class
	P_XEYES

inherit
	XEYES_DATA
		redefine
			default_create
		end
	S_X11_XLIB
	S_X11_INTRINSIC
	S_X11_COREP
	S_X11_INTRINSICP
	S_X11_STRINGDEFS
	S_X11_XMU_CONVERTERS
	S_MATH
	S_X11_EXTENSIONS_SHAPE
	S_X11_SHELL
	S_STDLIB

feature {NONE} -- Initialization

	default_create
		do
			create actions.make (<<1>>)
			create options.make (<<5>>)
			create wm_delete_window.make (<<1>>)
		end

feature {ANY} -- attributes

	actions: CE_ARRAY [SD_XTACTIONSREC]

	options: CE_ARRAY [SD_XRMOPTIONDESCREC]

	wm_delete_window: CE_ARRAY [NATURAL_32]

feature {ANY} -- routines

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_argc: CE_ARRAY [INTEGER_32]
			l_app_context: CE_ARRAY [CE_POINTER [ANY]]
			l_toplevel: CE_POINTER [SD_WIDGETREC]
			l_arg: CE_ARRAY [SD_ARG]
			l_i: NATURAL_32
			l_tmp___1: CE_POINTER [SD_SCREEN]
			l_tmp___4: CE_POINTER [SD_SCREEN]
			l_tmp___7: NATURAL_32
		do
			create l_argc.make (<<1>>)
			create l_app_context.make (<<1>>)
			create l_toplevel.make
			create l_arg.make (<<2>>)
			create l_tmp___1.make
			create l_tmp___4.make

			l_argc.item := a_argc
			XtSetLanguageProc (create {CE_POINTER [ANY]}.make_shared (default_pointer), create {CE_ROUTINE}.make_shared (default_pointer), create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
			l_toplevel := XtAppInitialize (l_app_context, ce_string ("XEyes"), options, ((create {SD_XRMOPTIONDESCREC}.make).structure_size.to_natural_32 * (5).to_natural_32) // (create {SD_XRMOPTIONDESCREC}.make).structure_size.to_natural_32, l_argc, a_argv, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), l_arg, {NATURAL_32} 0)
			if l_argc.item /= 1 then
				usage
			end
			wm_delete_window.item := XInternAtom ((XtDisplay (l_toplevel)), ce_string ("WM_DELETE_WINDOW"), 0)
			XtAppAddActions (l_app_context.item, actions, ((create {SD_XTACTIONSREC}.make).structure_size.to_natural_32 * (1).to_natural_32) // (create {SD_XTACTIONSREC}.make).structure_size.to_natural_32)
			XtOverrideTranslations (l_toplevel, (XtParseTranslationTable (ce_string ("<Message>WM_PROTOCOLS: quit()"))))
			l_i := {NATURAL_32} 0
			l_arg[l_i.to_integer_32].name := (XtShellStrings + 18)
			l_tmp___1 := XtScreen (l_toplevel)
			l_arg[l_i.to_integer_32].value := (XCreateBitmapFromData ((XtDisplay (l_toplevel)), l_tmp___1.item.root, create {CE_POINTER [INTEGER_8]}.make_cast (eyes_inst.eyes_bits), {NATURAL_32} 48, {NATURAL_32} 32)).to_integer_32
			l_i := l_i + 1
			l_arg[l_i.to_integer_32].name := (XtShellStrings + 62)
			l_tmp___4 := XtScreen (l_toplevel)
			l_arg[l_i.to_integer_32].value := (XCreateBitmapFromData ((XtDisplay (l_toplevel)), l_tmp___4.item.root, create {CE_POINTER [INTEGER_8]}.make_cast (eyesmask_inst.eyesmask_bits), {NATURAL_32} 48, {NATURAL_32} 32)).to_integer_32
			l_i := l_i + 1
			XtSetValues (l_toplevel, l_arg, l_i)
			XtCreateManagedWidget (ce_string ("eyes"), eyes_inst.eyesWidgetClass, l_toplevel, create {CE_POINTER [SD_ARG]}.make_shared (default_pointer), {NATURAL_32} 0).do_nothing
			XtRealizeWidget (l_toplevel)
			l_tmp___7 := XtWindow (l_toplevel)
			XSetWMProtocols ((XtDisplay (l_toplevel)), l_tmp___7, wm_delete_window, 1).do_nothing
			XtAppMainLoop (l_app_context.item)
			Result := 0
		end

	quit (a_w: CE_POINTER [SD_WIDGETREC]; a_event: CE_POINTER [SD_XEVENT]; a_params: CE_POINTER [CE_POINTER [INTEGER_8]]; a_num_params: CE_POINTER [NATURAL_32])
		local
			l_tmp___0: CE_POINTER [ANY]
		do
			create l_tmp___0.make

			if a_event.item.type = 33 then
				if (a_event.item.xclient.data.l[0]).to_natural_32 /= wm_delete_window.item then
					XBell ((XtDisplay (a_w)), 0).do_nothing
				else
					l_tmp___0 := XtWidgetToApplicationContext (a_w)
					XtDestroyApplicationContext (l_tmp___0)
					exit (0)
				end
			else
				l_tmp___0 := XtWidgetToApplicationContext (a_w)
				XtDestroyApplicationContext (l_tmp___0)
				exit (0)
			end
		end

	quit_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent quit)
		end

	usage
		do
			Io.error.put_string ("usage: xeyes%N")
			Io.error.put_string ("       [-geometry [{width}][x{height}][{+-}{xoff}[{+-}{yoff}]]] [-display [{host}]:[{vs}]]%N")
			Io.error.put_string ("       [-fg {color}] [-bg {color}] [-bd {color}] [-bw {pixels}]")
			Io.error.put_string (" [-shape | +shape]")
			Io.error.put_string ("%N")
			Io.error.put_string ("       [-outline {color}] [-center {color}] [-backing {backing-store}]%N")
			exit (1)
		end

end
