class
	P_TTYIN

inherit
	LESS_DATA
	S_UNISTD
	S_STDLIB
	S_STRING
	S_TERMIOS
	S_SYS_IOCTL
	S_TERMCAP
	S_STDIO
	S_CTYPE
	S_LOCALE
	S_FCNTL
	S_LIBIO
	S_SYS_STAT
	S_SIGNAL
	S_TIME
	S_BITS_ERRNO
	S_REGEX

feature {ANY} -- routines

	close_getchr
		do
		end

	getchr: INTEGER_32
		local
			l_c: CE_ARRAY [INTEGER_8]
			l_result: INTEGER_32
			js: JUMP_STATE
		do
			create l_c.make (<<1>>)

			from
			until
				js.loop_done
			loop
				l_result := os_inst.iread (screen_inst.tty, l_c, {PLATFORM}.Integer_8_bytes.to_natural_32)
				if l_result = -2 then
					Result := (-2)
					js.return
				end
				if not js.return_called then
					if l_result < 0 then
						main_inst.quit (1)
					end
					if (l_c.item).to_integer_32 = 0 then
						l_c.item := (('%/224/').code).to_integer_8
					end
					if l_result = 1 then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (((l_c.item).to_integer_32).bit_and (255))
			end
		end

	open_getchr
		do
			screen_inst.tty := open ([ce_string ("/dev/tty"), 0])
			if screen_inst.tty < 0 then
				screen_inst.tty := 2
			end
		end

end
