deferred class
	S_UNISTD

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	close (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return close($a___fd);"
		end

	dup (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return dup($a___fd);"
		end

	fsync (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fsync($a___fd);"
		end

	getpid: INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return getpid();"
		end

	isatty (a___fd: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return isatty($a___fd);"
		end

	lseek (a___fd: INTEGER_32; a___offset: INTEGER_32; a___whence: INTEGER_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return lseek($a___fd, $a___offset, $a___whence);"
		end

	read (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___nbytes: NATURAL_32): INTEGER_32
		do
			Result := c_read (a___fd, a___buf.c_pointer, a___nbytes)
		end

	c_read (a___fd: INTEGER_32; a___buf: POINTER; a___nbytes: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return read($a___fd, $a___buf, $a___nbytes);"
		end

	sleep (a___seconds: NATURAL_32): NATURAL_32
		external
			"C inline use <less.h>"
		alias
			"return sleep($a___seconds);"
		end

	write (a___fd: INTEGER_32; a___buf: CE_POINTER [ANY]; a___n: NATURAL_32): INTEGER_32
		do
			Result := c_write (a___fd, a___buf.c_pointer, a___n)
		end

	c_write (a___fd: INTEGER_32; a___buf: POINTER; a___n: NATURAL_32): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return write($a___fd, $a___buf, $a___n);"
		end

end
