class
	PD_PARAM_TOKEN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create b.make
			create e.make
		end

feature {ANY} -- fields

	b: CE_POINTER [INTEGER_8] assign set_b

	e: CE_POINTER [INTEGER_8] assign set_e

feature {ANY} -- setters

	set_b (a_b: CE_POINTER [INTEGER_8])
		do
			b := a_b
			update_memory_field ("b")
		end

	set_e (a_e: CE_POINTER [INTEGER_8])
		do
			e := a_e
			update_memory_field ("e")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b := a_other.b
			e := a_other.e
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b.is_equal (a_other.b) and
				e.is_equal (a_other.e)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b"),
					create {CE_STRUCTURE_FIELD}.make ("e")
				>>)
			init_structure_info
		end

end
