class
	P_FTP_LS

inherit
	WGET_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_SYS_SELECT
	S_LIBINTL
	S_STRING
	S_STDIO
	S_STDLIB
	S_UNISTD
	S_ASSERT
	S_SYS_SOCKET
	S_NETINET_IN
	S_BITS_ERRNO
	S_LIBIO
	S_TIME
	S_SYS_STAT
	S_FNMATCH
	S_CTYPE
	S_ARPA_INET
	S_NETDB
	S_LOCALE
	S_PWD
	S_GETOPT
	S_SIGNAL
	S_WCHAR
	S_SYS_TIME
	S_SYS_MMAN
	S_UTIME
	S_FCNTL
	S_SYS_IOCTL
	S_LANGINFO
	S_STDIO_EXT
	S_TERMIOS
	S_WCTYPE

feature {NONE} -- Initialization

	default_create
		do
			create months.make (<<12>>)
			create months___0.make (<<12>>)
		end

feature {ANY} -- attributes

	months: CE_ARRAY [CE_POINTER [INTEGER_8]]

	months___0: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	clean_line (a_line: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_line: CE_POINTER [INTEGER_8]
			l_len: INTEGER_32
			js: JUMP_STATE
		do
			create l_line.make

			l_line := a_line
			l_len := (strlen (l_line)).to_integer_32
			if not l_len.to_boolean then
				Result := 0
				js.return
			end
			if not js.return_called then
				if (l_line[(l_len - 1)]).to_integer_32 = 10 then
					l_len := l_len - 1
					l_line[l_len] := (('%/0/').code).to_integer_8
				end
				if not l_len.to_boolean then
					Result := 0
					js.return
				end
			end
			if not js.return_called then
				if (l_line[(l_len - 1)]).to_integer_32 = 13 then
					l_len := l_len - 1
					l_line[l_len] := (('%/0/').code).to_integer_8
				end
				from
				until
					not ((l_line[0]).to_boolean)
				loop
					if (l_line[0]).to_integer_32 = 9 then
						l_line[0] := ((' ').code).to_integer_8
					end
					l_line := l_line + 1
				end
				Result := l_len
			end
		end

	eat_carets (a_str: CE_POINTER [INTEGER_8])
		local
			l_str: CE_POINTER [INTEGER_8]
			l_strd: CE_POINTER [INTEGER_8]
			l_hdgt: INTEGER_8
			l_uchr: NATURAL_8
			l_prop: NATURAL_8
			js: JUMP_STATE
		do
			create l_str.make
			create l_strd.make

			l_str := a_str
			from
			until
				js.loop_done
			loop
				if (l_str[0]).to_integer_32 /= 0 then
					if (l_str[0]).to_integer_32 = 94 then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_str := l_str + 1
				end
			end
			if (l_str[0]).to_integer_32 /= 0 then
				l_strd := l_str
				from
				until
					(l_str[0]).to_integer_32 = 0
				loop
					l_uchr := (l_str[0]).to_natural_8
					if l_uchr.to_integer_32 = 94 then
						l_str := l_str + 1
						l_uchr := (l_str[0]).to_natural_8
						l_prop := utils_inst.char_prop[l_uchr.to_integer_32]
						if ((l_prop.to_integer_32).bit_and (64)).to_boolean then
							if l_uchr.to_integer_32 <= 57 then
								l_hdgt := (l_uchr.to_integer_32 - 48).to_integer_8
							else
								l_hdgt := ((((l_uchr.to_integer_32 - 65)).bit_and (7)) + 10).to_integer_8
							end
							l_hdgt := ((l_hdgt.to_integer_32).bit_shift_left (4)).to_integer_8
							l_str := l_str + 1
							l_uchr := (l_str[0]).to_natural_8
							if l_uchr.to_integer_32 <= 57 then
								l_uchr := ((l_hdgt.to_integer_32 + l_uchr.to_integer_32) - 48).to_natural_8
							else
								l_uchr := ((l_hdgt.to_integer_32 + (((l_uchr.to_integer_32 - 65)).bit_and (15))) + 10).to_natural_8
							end
						elseif l_uchr.to_integer_32 = 95 then
							l_uchr := ((' ').code).to_natural_8
						elseif l_uchr.to_integer_32 = 47 then
							l_uchr := (('?').code).to_natural_8
						end
					end
					l_strd[0] := l_uchr.to_integer_8
					l_strd := l_strd + 1
					l_str := l_str + 1
				end
				l_strd[0] := (('%/0/').code).to_integer_8
			end
		end

	ftp_index (a_file: CE_POINTER [INTEGER_8]; a_u: CE_POINTER [PD_URL]; a_f: CE_POINTER [PD_FILEINFO]): NATURAL_32
		local
			l_f: CE_POINTER [PD_FILEINFO]
			l_fp: CE_POINTER [SD_IO_FILE]
			l_upwd: CE_POINTER [INTEGER_8]
			l_htcldir: CE_POINTER [INTEGER_8]
			l_htclfile: CE_POINTER [INTEGER_8]
			l_urlclfile: CE_POINTER [INTEGER_8]
			l_tmpu: CE_POINTER [INTEGER_8]
			l_tmpp: CE_POINTER [INTEGER_8]
			l_tstamp: CE_ARRAY [INTEGER_32]
			l_ptm: CE_POINTER [SD_TM]
			l_tmp___10: CE_POINTER [INTEGER_8]
			l_tmp___12: CE_POINTER [INTEGER_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_f.make
			create l_fp.make
			create l_upwd.make
			create l_htcldir.make
			create l_htclfile.make
			create l_urlclfile.make
			create l_tmpu.make
			create l_tmpp.make
			create l_tstamp.make (<<1>>)
			create l_ptm.make
			create l_tmp___10.make
			create l_tmp___12.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_f := a_f
					if retr_inst.output_stream.is_void then
						l_fp := fopen (a_file, ce_string ("wb"))
						if l_fp.is_void then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
							Result := ({PC_UERR_T}.FOPENERR)
							js.return
						end
					else
						l_fp := retr_inst.output_stream
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						if (not (a_u.item.user).is_void) then
							l_tmpu := url_inst.url_escape (a_u.item.user)
							if (not (a_u.item.passwd).is_void) then
								l_tmpp := (url_inst.url_escape (a_u.item.passwd))
							else
								l_tmpp := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							end
							if (not l_tmpp.is_void) then
								l_upwd := utils_inst.concat_strings ([l_tmpu, ce_string (":"), l_tmpp, ce_string ("@"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)])
							else
								l_upwd := utils_inst.concat_strings ([l_tmpu, ce_string ("@"), create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)])
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_tmpu))
							if (not l_tmpp.is_void) then
								free (create {CE_POINTER [ANY]}.make_cast (l_tmpp))
							end
						else
							l_upwd := xmalloc_inst.xstrdup (ce_string (""))
						end
						l_htcldir := convert_inst.html_quote_string (a_u.item.dir)
						fprintf ([l_fp, ce_string ("<!DOCTYPE HTML PUBLIC %"-//IETF//DTD HTML 2.0//EN%">%N")]).do_nothing
						fprintf ([l_fp, ce_string ("<html>%N<head>%N<title>")]).do_nothing
						fprintf ([l_fp, (gettext (ce_string ("Index of /%%s on %%s:%%d"))), l_htcldir, a_u.item.host, a_u.item.port]).do_nothing
						fprintf ([l_fp, ce_string ("</title>%N</head>%N<body>%N<h1>")]).do_nothing
						fprintf ([l_fp, (gettext (ce_string ("Index of /%%s on %%s:%%d"))), l_htcldir, a_u.item.host, a_u.item.port]).do_nothing
						fprintf ([l_fp, ce_string ("</h1>%N<hr>%N<pre>%N")]).do_nothing
				when 2 then -- loop condition:
						if l_f.is_void then
							l_pos := -1 + 9 -- skip loop
						end
				when 3 then -- loop body:
						fprintf ([l_fp, ce_string ("  ")]).do_nothing
						if l_f.item.tstamp /= -1 then
							l_tstamp.item := l_f.item.tstamp
							l_ptm := (localtime (l_tstamp))
							fprintf ([l_fp, ce_string ("%%d %%s %%02d "), l_ptm.item.tm_year + 1_900, months___0[l_ptm.item.tm_mon], l_ptm.item.tm_mday]).do_nothing
							if (l_ptm.item.tm_hour).to_boolean then
								fprintf ([l_fp, ce_string ("%%02d:%%02d  "), l_ptm.item.tm_hour, l_ptm.item.tm_min]).do_nothing
							else
								fprintf ([l_fp, ce_string ("       ")]).do_nothing
							end
						else
							fprintf ([l_fp, (gettext (ce_string ("time unknown       ")))]).do_nothing
						end
						inspect (l_f.item.type).to_integer_32 -- switch 1 head
						when 0 then l_pos := -1 + 4
						when 1 then l_pos := -1 + 5
						when 2 then l_pos := -1 + 6
						else l_pos := -1 + 7
						end
				when 4 then -- switch 1, case 0
						fprintf ([l_fp, (gettext (ce_string ("File        ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 5 then -- switch 1, case 1
						fprintf ([l_fp, (gettext (ce_string ("Directory   ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 6 then -- switch 1, case 2
						fprintf ([l_fp, (gettext (ce_string ("Link        ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 7 then -- switch 1, default:
						fprintf ([l_fp, (gettext (ce_string ("Not sure    ")))]).do_nothing
						l_pos := -1 + 8 -- switch 1; break
				when 8 then -- switch 1, done:
						l_htclfile := convert_inst.html_quote_string (l_f.item.name)
						l_urlclfile := url_inst.url_escape_unsafe_and_reserved (l_f.item.name)
						fprintf ([l_fp, ce_string ("<a href=%"ftp://%%s%%s:%%d"), l_upwd, a_u.item.host, a_u.item.port]).do_nothing
						if ((a_u.item.dir).item).to_integer_32 /= 47 then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("%%s"), l_htcldir]).do_nothing
						if ((a_u.item.dir).item).to_boolean then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("%%s"), l_urlclfile]).do_nothing
						if l_f.item.type = {NATURAL_32} 1 then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("%">%%s"), l_htclfile]).do_nothing
						if l_f.item.type = {NATURAL_32} 1 then
							IO_putc (('/').code, l_fp).do_nothing
						end
						fprintf ([l_fp, ce_string ("</a> ")]).do_nothing
						if l_f.item.type = {NATURAL_32} 0 then
							l_tmp___10 := utils_inst.number_to_static_string (l_f.item.size)
							fprintf ([l_fp, (gettext (ce_string (" (%%s bytes)"))), l_tmp___10]).do_nothing
						elseif l_f.item.type = {NATURAL_32} 2 then
							if (not (l_f.item.linkto).is_void) then
								l_tmp___12 := l_f.item.linkto
							else
								l_tmp___12 := ce_string ("(nil)")
							end
							fprintf ([l_fp, ce_string ("-> %%s"), l_tmp___12]).do_nothing
						end
						IO_putc (('%N').code, l_fp).do_nothing
						free (create {CE_POINTER [ANY]}.make_cast (l_htclfile))
						free (create {CE_POINTER [ANY]}.make_cast (l_urlclfile))
						l_f := l_f.item.next
						l_pos := -1 + 2 -- back to loop condition
				when 9 then -- loop done
						fprintf ([l_fp, ce_string ("</pre>%N</body>%N</html>%N")]).do_nothing
						free (create {CE_POINTER [ANY]}.make_cast (l_htcldir))
						free (create {CE_POINTER [ANY]}.make_cast (l_upwd))
						if retr_inst.output_stream.is_void then
							fclose (l_fp).do_nothing
						else
							fflush (l_fp).do_nothing
						end
						Result := ({PC_UERR_T}.FTPOK)
				when 10 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_parse_ls (a_file: CE_POINTER [INTEGER_8]; a_system_type: NATURAL_32): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_c: INTEGER_32
			l_tmp___3: CE_POINTER [PD_FILEINFO]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_tmp___3.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					inspect a_system_type.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 1 then l_pos := -1 + 3
					when 3 then l_pos := -1 + 4
					else l_pos := -1 + 5
					end
				when 1 then -- switch 1, case 0
					Result := (ftp_parse_unix_ls (a_file, 0))
					js.return
				when 2 then -- switch 1, case 2
					if not js.return_called then
						l_fp := fopen (a_file, ce_string ("rb"))
						if l_fp.is_void then
							log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
							Result := (create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
							js.return
						end
					end
					if not js.return_called then
						l_c := fgetc (l_fp)
						fclose (l_fp).do_nothing
						if l_c >= 48 then
							if l_c <= 57 then
								Result := (ftp_parse_winnt_ls (a_file))
								js.return
							else
								l_tmp___3 := ftp_parse_unix_ls (a_file, 1)
								Result := l_tmp___3
								js.return
							end
						else
							l_tmp___3 := ftp_parse_unix_ls (a_file, 1)
							Result := l_tmp___3
							js.return
						end
					end
				when 3 then -- switch 1, case 1
					if not js.return_called then
						Result := (ftp_parse_vms_ls (a_file))
						js.return
					end
				when 4 then -- switch 1, case 3
					if not js.return_called then
						Result := (ftp_parse_unix_ls (a_file, 1))
						js.return
					end
				when 5 then -- switch 1, default:
					if not js.return_called then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, (gettext (ce_string ("Unsupported listing type, trying Unix listing parser.%N")))])
						Result := (ftp_parse_unix_ls (a_file, 0))
					end
				when 6 then -- switch 1, done:
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_parse_unix_ls (a_file: CE_POINTER [INTEGER_8]; a_ignore_perms: INTEGER_32): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_next: INTEGER_32
			l_len: INTEGER_32
			l_i: INTEGER_32
			l_error___0: INTEGER_32
			l_ignore: INTEGER_32
			l_year: INTEGER_32
			l_month: INTEGER_32
			l_day: INTEGER_32
			l_hour: INTEGER_32
			l_min: INTEGER_32
			l_sec: INTEGER_32
			l_timestruct: CE_ARRAY [SD_TM]
			l_tnow: CE_POINTER [SD_TM]
			l_timenow: CE_ARRAY [INTEGER_32]
			l_line: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_ptok: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [PD_FILEINFO]
			l_l: CE_POINTER [PD_FILEINFO]
			l_cur: CE_ARRAY [PD_FILEINFO]
			l_size: INTEGER_64
			l_fnlen: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___31: CE_POINTER [INTEGER_8]
			l_tmp___35: CE_POINTER [PD_FILEINFO]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_timestruct.make (<<1>>)
			create l_tnow.make
			create l_timenow.make (<<1>>)
			create l_line.make
			create l_tok.make
			create l_ptok.make
			create l_dir.make
			create l_l.make
			create l_cur.make (<<1>>)
			create l_p___0.make
			create l_tmp___31.make
			create l_tmp___35.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := fopen (a_file, ce_string ("rb"))
					if l_fp.is_void then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
						Result := (create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 58 -- skip if block
					end
				when 1 then -- if:
						l_l := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						l_dir := l_l
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 57 -- skip loop
						end
				when 3 then -- loop body:
						l_line := utils_inst.read_whole_line (l_fp)
						if l_line.is_void then
							js.break
						end
						if not js.loop_jumped then
							l_len := clean_line (l_line)
							if not (strncasecmp (l_line, ce_string ("total"), (5).to_natural_32)).to_boolean then
								free (create {CE_POINTER [ANY]}.make_cast (l_line))
								js.continue
							end
						end
						if not js.loop_jumped then
							l_tok := strtok (l_line, ce_string (" "))
							if l_tok.is_void then
								free (create {CE_POINTER [ANY]}.make_cast (l_line))
								js.continue
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 56 -- skip if block
						end
				when 4 then -- if:
						l_cur.item.name := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_cur.item.linkto := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						inspect (l_tok[0]).to_integer_32 -- switch 1 head
						when 45 then l_pos := -1 + 5
						when 100 then l_pos := -1 + 6
						when 108 then l_pos := -1 + 7
						else l_pos := -1 + 8
						end
				when 5 then -- switch 1, case 45
						l_cur.item.type := {PC_FTYPE}.FT_PLAINFILE
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("PLAINFILE; ")])
							end
							js.break
						end
						l_pos := -1 + 9 -- switch 1; break
				when 6 then -- switch 1, case 100
						l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("DIRECTORY; ")])
							end
							js.break
						end
						l_pos := -1 + 9 -- switch 1; break
				when 7 then -- switch 1, case 108
						l_cur.item.type := {PC_FTYPE}.FT_SYMLINK
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("SYMLINK; ")])
							end
							js.break
						end
						l_pos := -1 + 9 -- switch 1; break
				when 8 then -- switch 1, default:
						l_cur.item.type := {PC_FTYPE}.FT_UNKNOWN
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("UNKNOWN; ")])
							end
							js.break
						end
						l_pos := -1 + 9 -- switch 1; break
				when 9 then -- switch 1, done:
						if not (a_ignore_perms.to_boolean) then
							l_pos := -1 + 16 -- skip if block
						end
				when 10 then -- if:
						inspect (l_cur.item.type).to_integer_32 -- switch 2 head
						when 0 then l_pos := -1 + 11
						when 1 then l_pos := -1 + 12
						else l_pos := -1 + 13
						end
				when 11 then -- switch 2, case 0
						l_cur.item.perms := 420
						l_pos := -1 + 14 -- switch 2; break
				when 12 then -- switch 2, case 1
						l_cur.item.perms := 493
						l_pos := -1 + 14 -- switch 2; break
				when 13 then -- switch 2, default:
						l_cur.item.perms := 420
				when 14 then -- switch 2, done:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("implicit perms %%0o; "), l_cur.item.perms])
							end
							js.break
						end
				when 15 then -- if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_cur.item.perms := symperms ((l_tok + 1))
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("perms %%0o; "), l_cur.item.perms])
							end
							js.break
						end
				when 17 then -- if done
						l_ignore := 0
						l_error___0 := l_ignore
						l_sec := 0
						l_min := l_sec
						l_hour := l_min
						l_year := l_hour
						l_day := 0
						l_month := l_day
						l_next := -1
						l_tok := l_line
				when 18 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 51 -- skip loop
						end
				when 19 then -- loop body:
						l_ptok := l_tok
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 50 -- skip if block
						end
				when 20 then -- if:
						l_next := l_next - 1
						if not (l_next < 0) then
							l_pos := -1 + 23 -- skip if block
						end
				when 21 then -- if:
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < 12))
						loop
							if not (strcmp (l_tok, months[l_i])).to_boolean then
								js.break
							end
							if not js.loop_jumped then
								l_i := l_i + 1
							end
						end
						if l_i /= 12 then
							if l_ptok.is_equal (l_line) then
								l_error___0 := 1
								js.break
							end
							if not js.loop_jumped then
								(errno_location).item := 0
								l_size := strtoll (l_ptok, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
								if l_size = (((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not then
									if (errno_location).item = 34 then
										l_cur.item.size := (0).to_integer_64
									else
										l_cur.item.size := l_size
									end
								else
									l_cur.item.size := l_size
								end
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("size: %%s; "), (utils_inst.number_to_static_string (l_cur.item.size))])
									end
									js.break
								end
								l_month := l_i
								l_next := 5
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("month: %%s; "), months[l_month]])
									end
									js.break
								end
							end
						end
				when 22 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 23 then -- else:
						if l_next /= 4 then
							l_pos := -1 + 26 -- skip if block
						end
				when 24 then -- if:
						if (l_tok[1]).to_boolean then
							l_day := (10 * ((l_tok[0]).to_integer_32 - 48) + (l_tok[1]).to_integer_32) - 48
						else
							l_day := (l_tok[0]).to_integer_32 - 48
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("day: %%d; "), l_day])
							end
							js.break
						end
				when 25 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 26 then -- else:
						if l_next /= 3 then
							l_pos := -1 + 29 -- skip if block
						end
				when 27 then -- if:
						l_year := 0
						l_sec := 0
						l_hour := l_sec
						l_min := l_hour
						if (c_ctype_inst.c2_isdigit ((l_tok[0]).to_integer_32)) then
							from
							until
								js.loop_done
							loop
								if not (c_ctype_inst.c2_isdigit ((l_tok[0]).to_integer_32)) then
									js.break
								end
								if not js.loop_jumped then
									l_year := ((l_tok[0]).to_integer_32 - 48) + 10 * l_year
									l_tok := l_tok + 1
								end
							end
							if (l_tok[0]).to_integer_32 = 58 then
								l_hour := l_year
								l_year := 0
								l_tok := l_tok + 1
								from
								until
									js.loop_done
								loop
									if not (c_ctype_inst.c2_isdigit ((l_tok[0]).to_integer_32)) then
										js.break
									end
									if not js.loop_jumped then
										l_min := ((l_tok[0]).to_integer_32 - 48) + 10 * l_min
										l_tok := l_tok + 1
									end
								end
								if (l_tok[0]).to_integer_32 = 58 then
									l_tok := l_tok + 1
									from
									until
										js.loop_done
									loop
										if not (c_ctype_inst.c2_isdigit ((l_tok[0]).to_integer_32)) then
											js.break
										end
										if not js.loop_jumped then
											l_sec := ((l_tok[0]).to_integer_32 - 48) + 10 * l_sec
											l_tok := l_tok + 1
										end
									end
								end
							end
						end
						if l_year.to_boolean then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("year: %%d (no tm); "), l_year])
								end
								js.break
							end
						else
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("time: %%02d:%%02d:%%02d (no yr); "), l_hour, l_min, l_sec])
								end
								js.break
							end
						end
				when 28 then -- if block done, skip else block:
						l_pos := -1 + 50
				when 29 then -- else:
						if l_next /= 2 then
							l_pos := -1 + 49 -- skip if block
						end
				when 30 then -- if:
						l_fnlen := (strlen (l_tok)).to_integer_32
						if l_fnlen < l_len - (l_tok.distance (l_line)) then
							l_tok[l_fnlen] := ((' ').code).to_integer_8
							if l_cur.item.type = {NATURAL_32} 2 then
								l_p___0 := strstr (l_tok, ce_string (" -> "))
								if l_p___0.is_void then
									l_error___0 := 1
									js.break
								end
								if not js.loop_jumped then
									l_cur.item.linkto := xmalloc_inst.xstrdup ((l_p___0 + 4))
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("link to: %%s%N"), l_cur.item.linkto])
										end
										js.break
									end
									l_p___0[0] := (('%/0/').code).to_integer_8
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 36 -- skip if block
						end
				when 31 then -- if:
						if not ((strcmp (l_tok, ce_string ("."))).to_boolean) then
							l_pos := -1 + 35 -- skip if block
						end
				when 32 then -- if:
						if (strcmp (l_tok, ce_string (".."))).to_boolean then
							l_pos := -1 + 34 -- skip if block
						end
				when 33 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("%NIgnoring `.%' and `..%'; ")])
							end
							js.break
						end
						l_ignore := 1
						js.break
				when 34 then -- if done | if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						l_pos := -1 + 33 -- goto _L
				when 36 then -- if done
						if js.loop_jumped then
							l_pos := -1 + 48 -- skip if block
						end
				when 37 then -- if:
						l_fnlen := (strlen (l_tok)).to_integer_32
						l_cur.item.name := create {CE_POINTER [INTEGER_8]}.make_cast ((xmalloc_inst.xmalloc ((l_fnlen + 1).to_natural_32)))
						memcpy (create {CE_POINTER [ANY]}.make_cast (l_cur.item.name), create {CE_POINTER [ANY]}.make_cast (l_tok), (l_fnlen + 1).to_natural_32).do_nothing
						if not (l_fnlen.to_boolean) then
							l_pos := -1 + 46 -- skip if block
						end
				when 38 then -- if:
						if l_cur.item.type /= {NATURAL_32} 1 then
							l_pos := -1 + 41 -- skip if block
						end
				when 39 then -- if:
						if (l_cur.item.name[(l_fnlen - 1)]).to_integer_32 = 47 then
							l_cur.item.name[(l_fnlen - 1)] := (('%/0/').code).to_integer_8
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("trailing `/%' on dir.%N")])
								end
								js.break
							end
						else
							l_pos := -1 + 41 -- goto _L___1
						end
				when 40 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 41 then -- else: | _L___1:
						if l_cur.item.type /= {NATURAL_32} 2 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if:
						if (l_cur.item.name[(l_fnlen - 1)]).to_integer_32 = 64 then
							l_cur.item.name[(l_fnlen - 1)] := (('%/0/').code).to_integer_8
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("trailing `@%' on link.%N")])
								end
								js.break
							end
						else
							l_pos := -1 + 44 -- goto _L___0
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else: | _L___0:
						if l_cur.item.type = {NATURAL_32} 0 then
							if ((l_cur.item.perms).bit_and (73)).to_boolean then
								if (l_cur.item.name[(l_fnlen - 1)]).to_integer_32 = 42 then
									l_cur.item.name[(l_fnlen - 1)] := (('%/0/').code).to_integer_8
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("trailing `*%' on exec.%N")])
										end
										js.break
									end
								end
							end
						end
				when 45 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						l_error___0 := 1
				when 47 then
						js.break
				when 48 then -- if done | if block done, skip else block:
						l_pos := -1 + 50
				when 49 then -- else:
						abort
				when 50 then -- if done | if done | if done | if done | if done
						l_pos := -1 + 18 -- back to loop condition
				when 51 then -- loop done
						if (l_cur.item.name).is_void then
							l_error___0 := 1
						elseif l_cur.item.type = {NATURAL_32} 2 then
							if (l_cur.item.linkto).is_void then
								l_error___0 := 1
							end
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								if (not (l_cur.item.name).is_void) then
									l_tmp___31 := l_cur.item.name
								else
									l_tmp___31 := ce_string ("")
								end
								log_inst.debug_logprintf ([ce_string ("%%s%N"), l_tmp___31])
							end
							js.break
						end
						if not (l_error___0.to_boolean) then
							l_pos := -1 + 54 -- skip if block
						end
				when 52 then -- if:
						l_pos := -1 + 55 -- goto _L___2
				when 53 then -- if block done, skip else block:
						l_pos := -1 + 56
				when 54 then -- else:
						if not (l_ignore.to_boolean) then
							l_pos := -1 + 56 -- skip if block
						end
				when 55 then -- if: | _L___2:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Skipping.%N")])
							end
							js.break
						end
						if (not (l_cur.item.name).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (l_cur.item.name))
						end
						if (not (l_cur.item.linkto).is_void) then
							free (create {CE_POINTER [ANY]}.make_cast (l_cur.item.linkto))
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_line))
						js.continue
				when 56 then -- if done | if done
						if not js.loop_jumped then
							if l_dir.is_void then
								l_dir := create {CE_POINTER [PD_FILEINFO]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
								l_l := l_dir
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_l), create {CE_POINTER [ANY]}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
								l_tmp___35 := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
								l_l.item.next := l_tmp___35
								l_l.item.prev := l_tmp___35
							else
								l_cur.item.prev := l_l
								l_l.item.next := create {CE_POINTER [PD_FILEINFO]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
								l_l := l_l.item.next
								memcpy (create {CE_POINTER [ANY]}.make_cast (l_l), create {CE_POINTER [ANY]}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
								l_l.item.next := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
							end
							l_timenow.item := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							l_tnow := localtime (l_timenow)
							l_timestruct.item.tm_sec := l_sec
							l_timestruct.item.tm_min := l_min
							l_timestruct.item.tm_hour := l_hour
							l_timestruct.item.tm_mday := l_day
							l_timestruct.item.tm_mon := l_month
							if l_year = 0 then
								if l_month > l_tnow.item.tm_mon then
									l_timestruct.item.tm_year := l_tnow.item.tm_year - 1
								else
									l_timestruct.item.tm_year := l_tnow.item.tm_year
								end
							else
								l_timestruct.item.tm_year := l_year
							end
							if l_timestruct.item.tm_year >= 1_900 then
								l_timestruct.item.tm_year := l_timestruct.item.tm_year - (1_900)
							end
							l_timestruct.item.tm_wday := 0
							l_timestruct.item.tm_yday := 0
							l_timestruct.item.tm_isdst := -1
							l_l.item.tstamp := mktime (l_timestruct)
							free (create {CE_POINTER [ANY]}.make_cast (l_line))
						end
						l_pos := -1 + 2 -- back to loop condition
				when 57 then -- loop done
						fclose (l_fp).do_nothing
						Result := l_dir
				when 58 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_parse_vms_ls (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_dt: INTEGER_32
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_len: INTEGER_32
			l_perms: INTEGER_32
			l_timenow: CE_ARRAY [INTEGER_32]
			l_timestruct: CE_POINTER [SD_TM]
			l_date_str: CE_ARRAY [INTEGER_8]
			l_line: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [PD_FILEINFO]
			l_l: CE_POINTER [PD_FILEINFO]
			l_cur: CE_ARRAY [PD_FILEINFO]
			l_p___0: CE_POINTER [INTEGER_8]
			l_tmp___36: CE_POINTER [PD_FILEINFO]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fp.make
			create l_timenow.make (<<1>>)
			create l_timestruct.make
			create l_date_str.make (<<32>>)
			create l_line.make
			create l_tok.make
			create l_dir.make
			create l_l.make
			create l_cur.make (<<1>>)
			create l_p___0.make
			create l_tmp___36.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fp := fopen (a_file, ce_string ("r"))
					if l_fp.is_void then
						log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
						Result := (create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
						js.return
					end
					if js.return_called then
						l_pos := -1 + 48 -- skip if block
					end
				when 1 then -- if:
						l_l := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						l_dir := l_l
						l_j := 0
				when 2 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 15 -- skip loop
						end
				when 3 then -- loop body:
						l_line := utils_inst.read_whole_line (l_fp)
						if not (l_line.is_void) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						js.break
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 14
				when 6 then -- else:
						l_i := clean_line (l_line)
						if not (l_i <= 0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						free (create {CE_POINTER [ANY]}.make_cast (l_line))
						js.continue
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 9 then -- else:
						if l_j /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if (l_line[(l_i - 1)]).to_integer_32 = 93 then
							l_j := 1
						else
							l_pos := -1 + 12 -- goto _L
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L:
						if (strncmp (l_line, ce_string ("Total of "), (9).to_natural_32)).to_boolean then
							js.break
						else
							free (create {CE_POINTER [ANY]}.make_cast (l_line))
							l_line := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
							js.break
						end
				when 13 then -- if done
						if not js.loop_jumped then
							free (create {CE_POINTER [ANY]}.make_cast (l_line))
						end
				when 14 then -- if done
						l_pos := -1 + 2 -- back to loop condition
				when 15 then -- loop done
						if not (not js.loop_done and then (not l_line.is_void)) then
							l_pos := -1 + 47 -- skip loop
						end
				when 16 then -- loop body:
						l_tok := strtok (l_line, ce_string (" "))
						if l_tok.is_void then
							l_tok := l_line
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("file name:   %'%%s%'%N"), l_tok])
							end
							js.break
						end
						l_p___0 := l_tok + (strlen (l_tok)).to_integer_32
						from
						until
							js.loop_done
						loop
							l_p___0 := l_p___0 - 1
							if (l_p___0.c_pointer.to_integer_32).to_natural_32 > (l_tok.c_pointer.to_integer_32).to_natural_32 then
								if not (c_ctype_inst.c2_isdigit ((l_p___0[0]).to_integer_32)) then
									js.break
								end
							else
								js.break
							end
						end
						if (l_p___0[0]).to_integer_32 = 59 then
							if (l_p___0[-1]).to_integer_32 /= 94 then
								l_p___0[0] := (('%/0/').code).to_integer_8
							end
						end
						eat_carets (l_tok)
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("file name-^: %'%%s%'%N"), l_tok])
							end
							js.break
						end
						l_len := (strlen (l_tok)).to_integer_32
						if (strncasecmp ((l_tok + (l_len - 4)), ce_string (".DIR"), (4).to_natural_32)).to_boolean then
							if (strncasecmp ((l_tok + (l_len - 6)), ce_string (".DIR;1"), (6).to_natural_32)).to_boolean then
								l_cur.item.type := {PC_FTYPE}.FT_PLAINFILE
								l_cur.item.perms := 420
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("File%N")])
									end
									js.break
								end
							else
								l_len := l_len - (6)
								l_tok[l_len] := (('%/0/').code).to_integer_8
								l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
								l_cur.item.perms := 493
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("Directory (v)%N")])
									end
									js.break
								end
							end
						else
							l_len := l_len - (4)
							l_tok[l_len] := (('%/0/').code).to_integer_8
							l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
							l_cur.item.perms := 493
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Directory (nv)%N")])
								end
								js.break
							end
						end
						l_cur.item.name := xmalloc_inst.xstrdup (l_tok)
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Name: %'%%s%'%N"), l_cur.item.name])
							end
							js.break
						end
						l_date_str[0] := (('%/0/').code).to_integer_8
						l_cur.item.linkto := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						l_cur.item.size := (0).to_integer_64
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Getting additional line.%N")])
								end
								js.break
							end
							free (create {CE_POINTER [ANY]}.make_cast (l_line))
							l_line := utils_inst.read_whole_line (l_fp)
							if l_line.is_void then
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
										log_inst.debug_logprintf ([ce_string ("EOF.  Leaving listing parser.%N")])
									end
									js.break
								end
								js.break
							end
							if not js.loop_jumped then
								if l_i <= 0 then
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("Blank line.  Leaving listing parser.%N")])
										end
										js.break
									end
									free (create {CE_POINTER [ANY]}.make_cast (l_line))
									js.break
								elseif (l_line[0]).to_integer_32 /= 32 then
									from
									until
										js.loop_done
									loop
										if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
											log_inst.debug_logprintf ([ce_string ("Non-blank in column 1.  Must be a new file name?%N")])
										end
										js.break
									end
									js.continue
								else
									l_tok := strtok (l_line, ce_string (" "))
									if l_tok.is_void then
										from
										until
											js.loop_done
										loop
											if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
												log_inst.debug_logprintf ([ce_string ("Null token.  Leaving listing parser.%N")])
											end
											js.break
										end
										free (create {CE_POINTER [ANY]}.make_cast (l_line))
										js.break
									end
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 46 -- skip if block
						end
				when 17 then -- if: | loop condition:
						if not (not js.loop_done and then (not l_tok.is_void)) then
							l_pos := -1 + 45 -- skip loop
						end
				when 18 then -- loop body:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Token: >%%s<: "), l_tok])
							end
							js.break
						end
						if not ((strlen (l_tok)) < {NATURAL_32} 12) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if not (strchr (l_tok, ('-').code)).is_void then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Date.%N")])
								end
								js.break
							end
							strcpy (l_date_str, l_tok).do_nothing
							strcat (l_date_str, ce_string (" ")).do_nothing
						else
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 21 then -- else: | _L___1:
						if not ((strlen (l_tok)) < {NATURAL_32} 12) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if not (strchr (l_tok, (':').code)).is_void then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Time. ")])
								end
								js.break
							end
							strncat (l_date_str, l_tok, (({PLATFORM}.Integer_8_bytes.to_natural_32 * (32).to_natural_32) - (strlen (l_date_str))) - {NATURAL_32} 1).do_nothing
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Date time: >%%s<%N"), l_date_str])
								end
								js.break
							end
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 24 then -- else: | _L___0:
						if (strchr (l_tok, ('[').code)).is_void then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Owner.%N")])
							end
							js.break
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 27 then -- else:
						if (strchr (l_tok, ('(').code)).is_void then
							l_pos := -1 + 43 -- skip if block
						end
				when 28 then -- if:
						l_perms := 0
						l_j := 0
						l_i := 0
				when 29 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 41 -- skip loop
						end
				when 30 then -- loop body:
						if not (l_i.to_natural_32 < (strlen (l_tok))) then
							js.break
						end
						if js.loop_jumped then
							l_pos := -1 + 40 -- skip if block
						end
				when 31 then -- if:
						inspect (l_tok[l_i]).to_integer_32 -- switch 1 head
						when 40 then l_pos := -1 + 32
						when 41 then l_pos := -1 + 33
						when 44 then l_pos := -1 + 34
						when 82 then l_pos := -1 + 35
						when 87 then l_pos := -1 + 36
						when 69 then l_pos := -1 + 37
						when 68 then l_pos := -1 + 38
						else l_pos := -1 + 39
						end
				when 32 then -- switch 1, case 40
						l_pos := -1 + 39 -- switch 1; break
				when 33 then -- switch 1, case 41
						l_pos := -1 + 39 -- switch 1; break
				when 34 then -- switch 1, case 44
						if l_j = 0 then
							l_perms := 0
							l_j := 1
						else
							l_perms := (l_perms).bit_shift_left ((3))
						end
						l_pos := -1 + 39 -- switch 1; break
				when 35 then -- switch 1, case 82
						l_perms := (l_perms).bit_or ((4))
						l_pos := -1 + 39 -- switch 1; break
				when 36 then -- switch 1, case 87
						l_perms := (l_perms).bit_or ((2))
						l_pos := -1 + 39 -- switch 1; break
				when 37 then -- switch 1, case 69
						l_perms := (l_perms).bit_or ((1))
						l_pos := -1 + 39 -- switch 1; break
				when 38 then -- switch 1, case 68
						l_perms := (l_perms).bit_or ((2))
						l_pos := -1 + 39 -- switch 1; break
				when 39 then -- switch 1, done:
						l_i := l_i + 1
				when 40 then -- if done
						l_pos := -1 + 29 -- back to loop condition
				when 41 then -- loop done
						l_cur.item.perms := l_perms
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Prot.  perms = %%0o.%N"), l_cur.item.perms])
							end
							js.break
						end
				when 42 then -- if block done, skip else block:
						l_pos := -1 + 44
				when 43 then -- else:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Ignored (size?).%N")])
							end
							js.break
						end
				when 44 then -- if done | if done | if done
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
						l_pos := -1 + 17 -- back to loop condition
				when 45 then -- loop done
						l_timenow.item := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
						l_timestruct := localtime (l_timenow)
						strptime (l_date_str, ce_string ("%%d-%%b-%%Y %%H:%%M:%%S"), l_timestruct).do_nothing
						l_timenow.item := mktime (l_timestruct)
						l_tok := getenv (ce_string ("WGET_TIMEZONE_DIFFERENTIAL"))
						if not l_tok.is_void then
							l_dt := atoi (l_tok)
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Time differential = %%d.%N"), l_dt])
								end
								js.break
							end
						else
							l_dt := 0
						end
						if l_dt >= 0 then
							l_timenow.item := l_timenow.item + l_dt.to_integer_32
						else
							l_timenow.item := l_timenow.item - (-l_dt).to_integer_32
						end
						l_cur.item.tstamp := l_timenow.item
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Timestamp: %%ld%N"), l_cur.item.tstamp])
							end
							js.break
						end
						if l_dir.is_void then
							l_dir := create {CE_POINTER [PD_FILEINFO]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_dir
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_l), create {CE_POINTER [ANY]}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_tmp___36 := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
							l_l.item.next := l_tmp___36
							l_l.item.prev := l_tmp___36
						else
							l_cur.item.prev := l_l
							l_l.item.next := create {CE_POINTER [PD_FILEINFO]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_l.item.next
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_l), create {CE_POINTER [ANY]}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_l.item.next := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_line))
						l_line := utils_inst.read_whole_line (l_fp)
						if not l_line.is_void then
							l_i := clean_line (l_line)
							if l_i <= 0 then
								free (create {CE_POINTER [ANY]}.make_cast (l_line))
								js.break
							end
						end
				when 46 then -- if done
						l_pos := -1 + 15 -- back to loop condition
				when 47 then -- loop done
						fclose (l_fp).do_nothing
						Result := l_dir
				when 48 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	ftp_parse_winnt_ls (a_file: CE_POINTER [INTEGER_8]): CE_POINTER [PD_FILEINFO]
		local
			l_fp: CE_POINTER [SD_IO_FILE]
			l_len: INTEGER_32
			l_year: INTEGER_32
			l_month: INTEGER_32
			l_day: INTEGER_32
			l_hour: INTEGER_32
			l_min: INTEGER_32
			l_timestruct: CE_ARRAY [SD_TM]
			l_line: CE_POINTER [INTEGER_8]
			l_tok: CE_POINTER [INTEGER_8]
			l_dir: CE_POINTER [PD_FILEINFO]
			l_l: CE_POINTER [PD_FILEINFO]
			l_cur: CE_ARRAY [PD_FILEINFO]
			l_size: INTEGER_64
			l_tmp___11: CE_POINTER [PD_FILEINFO]
			js: JUMP_STATE
		do
			create l_fp.make
			create l_timestruct.make (<<1>>)
			create l_line.make
			create l_tok.make
			create l_dir.make
			create l_l.make
			create l_cur.make (<<1>>)
			create l_tmp___11.make

			l_fp := fopen (a_file, ce_string ("rb"))
			if l_fp.is_void then
				log_inst.logprintf ([{PC_LOG_OPTIONS}.LOG_NOTQUIET, ce_string ("%%s: %%s%N"), a_file, (strerror ((errno_location).item))])
				Result := (create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_l := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
				l_dir := l_l
				from
				until
					js.loop_done
				loop
					l_line := utils_inst.read_whole_line (l_fp)
					if l_line.is_void then
						js.break
					end
					if not js.loop_jumped then
						l_len := clean_line (l_line)
						if l_len < 40 then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_tok := l_line + 39
						l_cur.item.name := xmalloc_inst.xstrdup (l_tok)
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Name: %'%%s%'%N"), l_cur.item.name])
							end
							js.break
						end
						l_tok := strtok (l_line, ce_string ("-"))
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_month := (atoi (l_tok)) - 1
						if l_month < 0 then
							l_month := 0
						end
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("-"))
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_day := atoi (l_tok)
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_year := atoi (l_tok)
						if l_year <= 70 then
							l_year := l_year + (100)
						end
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (":"))
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_hour := atoi (l_tok)
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string ("M"))
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						l_min := atoi (l_tok)
						l_tok := l_tok + (2)
						if l_hour = 12 then
							l_hour := 0
						end
						if (l_tok[0]).to_integer_32 = 80 then
							l_hour := l_hour + (12)
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("YYYY/MM/DD HH:MM - %%d/%%02d/%%02d %%02d:%%02d%N"), l_year + 1_900, l_month, l_day, l_hour, l_min])
							end
							js.break
						end
						l_timestruct.item.tm_sec := 0
						l_timestruct.item.tm_min := l_min
						l_timestruct.item.tm_hour := l_hour
						l_timestruct.item.tm_mday := l_day
						l_timestruct.item.tm_mon := l_month
						l_timestruct.item.tm_year := l_year
						l_timestruct.item.tm_wday := 0
						l_timestruct.item.tm_yday := 0
						l_timestruct.item.tm_isdst := -1
						l_cur.item.tstamp := mktime (l_timestruct)
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
								log_inst.debug_logprintf ([ce_string ("Timestamp: %%ld%N"), l_cur.item.tstamp])
							end
							js.break
						end
						l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						from
						until
							js.loop_done
						loop
							if not l_tok.is_void then
								if (l_tok[0]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_tok := strtok (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer), ce_string (" "))
							end
						end
						if l_tok.is_void then
							js.continue
						end
					end
					if not js.loop_jumped then
						if (l_tok[0]).to_integer_32 = 60 then
							l_cur.item.type := {PC_FTYPE}.FT_DIRECTORY
							l_cur.item.size := (0).to_integer_64
							l_cur.item.perms := 493
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("Directory%N")])
								end
								js.break
							end
						else
							l_cur.item.type := {PC_FTYPE}.FT_PLAINFILE;
							(errno_location).item := 0
							l_size := strtoll (l_tok, create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
							if l_size = (((-{INTEGER_64} 1).bit_shift_left (({PLATFORM}.Integer_64_bytes.to_natural_32 * {NATURAL_32} 8 - {NATURAL_32} 1).to_integer_32))).bit_not then
								if (errno_location).item = 34 then
									l_cur.item.size := (0).to_integer_64
								else
									l_cur.item.size := l_size
								end
							else
								l_cur.item.size := l_size
							end
							l_cur.item.perms := 420
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((options_inst.opt.item.debug2).to_integer, 0)).to_boolean then
									log_inst.debug_logprintf ([ce_string ("File, size %%s bytes%N"), (utils_inst.number_to_static_string (l_cur.item.size))])
								end
								js.break
							end
						end
						l_cur.item.linkto := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
						if l_dir.is_void then
							l_dir := create {CE_POINTER [PD_FILEINFO]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_dir
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_l), create {CE_POINTER [ANY]}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_tmp___11 := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
							l_l.item.next := l_tmp___11
							l_l.item.prev := l_tmp___11
						else
							l_cur.item.prev := l_l
							l_l.item.next := create {CE_POINTER [PD_FILEINFO]}.make_cast ((xmalloc_inst.xmalloc ((create {PD_FILEINFO}.make).structure_size.to_natural_32)))
							l_l := l_l.item.next
							memcpy (create {CE_POINTER [ANY]}.make_cast (l_l), create {CE_POINTER [ANY]}.make_cast (l_cur), (create {PD_FILEINFO}.make).structure_size.to_natural_32).do_nothing
							l_l.item.next := create {CE_POINTER [PD_FILEINFO]}.make_shared (default_pointer)
						end
						free (create {CE_POINTER [ANY]}.make_cast (l_line))
					end
				end
				fclose (l_fp).do_nothing
				Result := l_dir
			end
		end

	symperms (a_s: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_POINTER [INTEGER_8]
			l_perms: INTEGER_32
			l_i: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_s.make

			l_s := a_s
			l_perms := 0
			if (strlen (l_s)) < {NATURAL_32} 9 then
				Result := 0
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					not (l_i < 3)
				loop
					l_perms := (l_perms).bit_shift_left ((3))
					if (l_s[2]).to_integer_32 = 120 then
						l_tmp___0 := 1
					elseif (l_s[2]).to_integer_32 = 115 then
						l_tmp___0 := 1
					else
						l_tmp___0 := 0
					end
					l_perms := l_perms + ((((((l_s[0]).to_integer_32 = 114).to_integer).bit_shift_left (2)) + ((((l_s[1]).to_integer_32 = 119).to_integer).bit_shift_left (1))) + l_tmp___0)
					l_i := l_i + 1
					l_s := l_s + (3)
				end
				Result := l_perms
			end
		end

end
