class
	PD_BUGGY_SERVERS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [NATURAL_8] assign set_name

	bugs: INTEGER_32 assign set_bugs

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_bugs (a_bugs: INTEGER_32)
		do
			bugs := a_bugs
			update_memory_field ("bugs")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			bugs := a_other.bugs
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				bugs = a_other.bugs
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("bugs")
				>>)
			init_structure_info
		end

end
