class
	PD_DIRS

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create s.make
			create f.make
		end

feature {ANY} -- fields

	s: CE_POINTER [NATURAL_8] assign set_s

	f: CE_POINTER [NATURAL_8] assign set_f

feature {ANY} -- setters

	set_s (a_s: CE_POINTER [NATURAL_8])
		do
			s := a_s
			update_memory_field ("s")
		end

	set_f (a_f: CE_POINTER [NATURAL_8])
		do
			f := a_f
			update_memory_field ("f")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			s := a_other.s
			f := a_other.f
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				s.is_equal (a_other.s) and
				f.is_equal (a_other.f)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("s"),
					create {CE_STRUCTURE_FIELD}.make ("f")
				>>)
			init_structure_info
		end

end
