frozen class
	LINKS_INITIALIZER_SLICE31

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			default_inst.links_options[25].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[25].rd_cfg := default_inst.str_rd_address
			default_inst.links_options[25].wr_cfg := default_inst.str_wr_address
			default_inst.links_options[25].min := 0
			default_inst.links_options[25].max := 1_024
			default_inst.links_options[25].ptr := create {CE_POINTER [ANY]}.make_cast (default_inst.download_dir)
			default_inst.links_options[25].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("download_dir"))
			default_inst.links_options[25].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("download-dir"))
			default_inst.links_options[26].p := 1
			default_inst.links_options[26].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[26].rd_cfg := default_inst.lang_rd_address
			default_inst.links_options[26].wr_cfg := default_inst.lang_wr_address
			default_inst.links_options[26].min := 0
			default_inst.links_options[26].max := 0
			default_inst.links_options[26].ptr := create {CE_POINTER [ANY]}.make_cast (links_inst.current_language)
			default_inst.links_options[26].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language"))
			default_inst.links_options[26].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language"))
			default_inst.links_options[27].p := 1
			default_inst.links_options[27].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[27].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[27].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[27].min := 0
			default_inst.links_options[27].max := 1
			default_inst.links_options[27].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.http_bugs.item.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("http10"))))
			default_inst.links_options[27].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http_bugs.http10"))
			default_inst.links_options[27].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http-bugs.http10"))
			default_inst.links_options[28].p := 1
			default_inst.links_options[28].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[28].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[28].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[28].min := 0
			default_inst.links_options[28].max := 1
			default_inst.links_options[28].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.http_bugs.item.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("allow_blacklist"))))
			default_inst.links_options[28].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http_bugs.allow_blacklist"))
			default_inst.links_options[28].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http-bugs.allow-blacklist"))
			default_inst.links_options[29].p := 1
			default_inst.links_options[29].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[29].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[29].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[29].min := 0
			default_inst.links_options[29].max := 1
			default_inst.links_options[29].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.http_bugs.item.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("bug_302_redirect"))))
			default_inst.links_options[29].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http_bugs.bug_302_redirect"))
			default_inst.links_options[29].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http-bugs.bug-302-redirect"))
			default_inst.links_options[30].p := 1
			default_inst.links_options[30].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[30].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[30].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[30].min := 0
			default_inst.links_options[30].max := 1
			default_inst.links_options[30].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.http_bugs.item.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("bug_post_no_keepalive"))))
			default_inst.links_options[30].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http_bugs.bug_post_no_keepalive"))
			default_inst.links_options[30].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http-bugs.bug-post-no-keepalive"))
			default_inst.links_options[31].p := 1
			default_inst.links_options[31].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[31].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[31].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[31].min := 0
			default_inst.links_options[31].max := 1
			default_inst.links_options[31].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.http_bugs.item.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("no_accept_charset"))))
			default_inst.links_options[31].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http_bugs.no_accept_charset"))
			default_inst.links_options[31].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http-bugs.bug-no-accept-charset"))
			default_inst.links_options[32].p := 1
			default_inst.links_options[32].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[32].rd_cfg := default_inst.str_rd_address
			default_inst.links_options[32].wr_cfg := default_inst.str_wr_address
			default_inst.links_options[32].min := 0
			default_inst.links_options[32].max := 1_024
			default_inst.links_options[32].ptr := create {CE_POINTER [ANY]}.make_cast ((default_inst.ftp_options.item.anon_pass))
			default_inst.links_options[32].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.anonymous_password"))
			default_inst.links_options[32].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.anonymous-password"))
			default_inst.links_options[33].p := 1
			default_inst.links_options[33].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[33].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[33].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[33].min := 0
			default_inst.links_options[33].max := 1
			default_inst.links_options[33].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.ftp_options.item.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("passive_ftp"))))
			default_inst.links_options[33].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.use_passive"))
			default_inst.links_options[33].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.use-passive"))
			default_inst.links_options[34].p := 1
			default_inst.links_options[34].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[34].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[34].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[34].min := 0
			default_inst.links_options[34].max := 1
			default_inst.links_options[34].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.ftp_options.item.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("fast_ftp"))))
			default_inst.links_options[34].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.fast"))
			default_inst.links_options[34].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.fast"))
			default_inst.links_options[35].p := 1
			default_inst.links_options[35].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[35].rd_cfg := default_inst.num_rd_address
			default_inst.links_options[35].wr_cfg := default_inst.num_wr_address
			default_inst.links_options[35].min := 0
			default_inst.links_options[35].max := 1
			default_inst.links_options[35].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.ftp_options.item.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("set_tos"))))
			default_inst.links_options[35].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.set_iptos"))
			default_inst.links_options[35].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.set-iptos"))
			default_inst.links_options[36].p := 1
			default_inst.links_options[36].rd_cmd := default_inst.gen_cmd_address
			default_inst.links_options[36].rd_cfg := default_inst.cp_rd_address
			default_inst.links_options[36].wr_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[36].min := 0
			default_inst.links_options[36].max := 0
			default_inst.links_options[36].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("assume_cp"))))
			default_inst.links_options[36].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("assume_codepage"))
			default_inst.links_options[36].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("assume-codepage"))
			default_inst.links_options[37].p := 1
			default_inst.links_options[37].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[37].rd_cfg := default_inst.term_rd_address
			default_inst.links_options[37].wr_cfg := default_inst.term_wr_address
			default_inst.links_options[37].min := 0
			default_inst.links_options[37].max := 0
			default_inst.links_options[37].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[37].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal"))
			default_inst.links_options[37].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[38].p := 1
			default_inst.links_options[38].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[38].rd_cfg := default_inst.term2_rd_address
			default_inst.links_options[38].wr_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[38].min := 0
			default_inst.links_options[38].max := 0
			default_inst.links_options[38].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[38].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("terminal2"))
			default_inst.links_options[38].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[39].p := 1
			default_inst.links_options[39].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[39].rd_cfg := default_inst.type_rd_address
			default_inst.links_options[39].wr_cfg := default_inst.type_wr_address
			default_inst.links_options[39].min := 0
			default_inst.links_options[39].max := 0
			default_inst.links_options[39].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[39].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("association"))
			default_inst.links_options[39].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[40].p := 1
			default_inst.links_options[40].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[40].rd_cfg := default_inst.ext_rd_address
			default_inst.links_options[40].wr_cfg := default_inst.ext_wr_address
			default_inst.links_options[40].min := 0
			default_inst.links_options[40].max := 0
			default_inst.links_options[40].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[40].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("extension"))
			default_inst.links_options[40].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[41].p := 1
			default_inst.links_options[41].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[41].rd_cfg := default_inst.prog_rd_address
			default_inst.links_options[41].wr_cfg := default_inst.prog_wr_address
			default_inst.links_options[41].min := 0
			default_inst.links_options[41].max := 0
			default_inst.links_options[41].ptr := create {CE_POINTER [ANY]}.make_cast (types_inst.mailto_prog)
			default_inst.links_options[41].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto"))
			default_inst.links_options[41].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[42].p := 1
			default_inst.links_options[42].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[42].rd_cfg := default_inst.prog_rd_address
			default_inst.links_options[42].wr_cfg := default_inst.prog_wr_address
			default_inst.links_options[42].min := 0
			default_inst.links_options[42].max := 0
			default_inst.links_options[42].ptr := create {CE_POINTER [ANY]}.make_cast (types_inst.telnet_prog)
			default_inst.links_options[42].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("telnet"))
			default_inst.links_options[42].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[43].p := 1
			default_inst.links_options[43].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[43].rd_cfg := default_inst.prog_rd_address
			default_inst.links_options[43].wr_cfg := default_inst.prog_wr_address
			default_inst.links_options[43].min := 0
			default_inst.links_options[43].max := 0
			default_inst.links_options[43].ptr := create {CE_POINTER [ANY]}.make_cast (types_inst.tn3270_prog)
			default_inst.links_options[43].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tn3270"))
			default_inst.links_options[43].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[44].p := 1
			default_inst.links_options[44].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[44].rd_cfg := default_inst.prog_rd_address
			default_inst.links_options[44].wr_cfg := default_inst.prog_wr_address
			default_inst.links_options[44].min := 0
			default_inst.links_options[44].max := 0
			default_inst.links_options[44].ptr := create {CE_POINTER [ANY]}.make_cast (types_inst.mms_prog)
			default_inst.links_options[44].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mms"))
			default_inst.links_options[44].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[45].p := 1
			default_inst.links_options[45].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[45].rd_cfg := kbdbind_inst.bind_rd_address
			default_inst.links_options[45].wr_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[45].min := 0
			default_inst.links_options[45].max := 0
			default_inst.links_options[45].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[45].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bind"))
			default_inst.links_options[45].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[46].p := 1
			default_inst.links_options[46].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[46].rd_cfg := kbdbind_inst.unbind_rd_address
			default_inst.links_options[46].wr_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[46].min := 0
			default_inst.links_options[46].max := 0
			default_inst.links_options[46].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[46].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("unbind"))
			default_inst.links_options[46].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[47].p := 0
			default_inst.links_options[47].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[47].rd_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[47].wr_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.links_options[47].min := 0
			default_inst.links_options[47].max := 0
			default_inst.links_options[47].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.links_options[47].cfg_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.links_options[47].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.html_options[0].p := 1
			default_inst.html_options[0].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[0].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[0].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[0].min := 0
			default_inst.html_options[0].max := 1
			default_inst.html_options[0].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("hard_assume"))))
			default_inst.html_options[0].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_hard_assume"))
			default_inst.html_options[0].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-hard-assume"))
			default_inst.html_options[1].p := 1
			default_inst.html_options[1].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[1].rd_cfg := default_inst.cp_rd_address
			default_inst.html_options[1].wr_cfg := default_inst.cp_wr_address
			default_inst.html_options[1].min := 0
			default_inst.html_options[1].max := 0
			default_inst.html_options[1].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("assume_cp"))))
			default_inst.html_options[1].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_assume_codepage"))
			default_inst.html_options[1].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-assume-codepage"))
			default_inst.html_options[2].p := 1
			default_inst.html_options[2].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[2].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[2].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[2].min := 0
			default_inst.html_options[2].max := 1
			default_inst.html_options[2].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("tables"))))
			default_inst.html_options[2].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_tables"))
			default_inst.html_options[2].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-tables"))
			default_inst.html_options[3].p := 1
			default_inst.html_options[3].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[3].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[3].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[3].min := 0
			default_inst.html_options[3].max := 1
			default_inst.html_options[3].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("frames"))))
			default_inst.html_options[3].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_frames"))
			default_inst.html_options[3].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-frames"))
			default_inst.html_options[4].p := 1
			default_inst.html_options[4].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[4].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[4].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[4].min := 0
			default_inst.html_options[4].max := 1
			default_inst.html_options[4].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("images"))))
			default_inst.html_options[4].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_images"))
			default_inst.html_options[4].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-images"))
			default_inst.html_options[5].p := 1
			default_inst.html_options[5].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[5].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[5].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[5].min := 0
			default_inst.html_options[5].max := 1
			default_inst.html_options[5].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("num_links"))))
			default_inst.html_options[5].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_numbered_links"))
			default_inst.html_options[5].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-numbered-links"))
			default_inst.html_options[6].p := 1
			default_inst.html_options[6].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[6].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[6].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[6].min := 0
			default_inst.html_options[6].max := 1
			default_inst.html_options[6].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("table_order"))))
			default_inst.html_options[6].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_table_order"))
			default_inst.html_options[6].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-table-order"))
			default_inst.html_options[7].p := 1
			default_inst.html_options[7].rd_cmd := default_inst.gen_cmd_address
			default_inst.html_options[7].rd_cfg := default_inst.num_rd_address
			default_inst.html_options[7].wr_cfg := default_inst.num_wr_address
			default_inst.html_options[7].min := 0
			default_inst.html_options[7].max := 9
			default_inst.html_options[7].ptr := create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (default_inst.dds.item.c_pointer + (create {PD_DOCUMENT_SETUP}.make).offset_of ("margin"))))
			default_inst.html_options[7].cfg_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html_margin"))
			default_inst.html_options[7].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("html-margin"))
			default_inst.html_options[8].p := 0
			default_inst.html_options[8].rd_cmd := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.html_options[8].rd_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.html_options[8].wr_cfg := create {CE_ROUTINE}.make_shared (default_pointer)
			default_inst.html_options[8].min := 0
			default_inst.html_options[8].max := 0
			default_inst.html_options[8].ptr := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			default_inst.html_options[8].cfg_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			default_inst.html_options[8].cmd_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			dns_inst.dns_cache[0].next := create {CE_POINTER [ANY]}.make_cast (dns_inst.dns_cache)
			dns_inst.dns_cache[0].prev := create {CE_POINTER [ANY]}.make_cast (dns_inst.dns_cache)
			error_inst.dummy_ptr := error_inst.dummy_val
			error_inst.mem_amount := 0
			error_inst.last_mem_amount := -1
			error_inst.memory_list[0].next := create {CE_POINTER [ANY]}.make_cast (error_inst.memory_list)
			error_inst.memory_list[0].prev := create {CE_POINTER [ANY]}.make_cast (error_inst.memory_list)
			file_inst.last_uid := -1
			file_inst.last_gid := -1
			ftp_inst.ftp_head[0] := (('<').code).to_natural_8
			ftp_inst.ftp_head[1] := (('h').code).to_natural_8
			ftp_inst.ftp_head[2] := (('t').code).to_natural_8
			ftp_inst.ftp_head[3] := (('m').code).to_natural_8
			ftp_inst.ftp_head[4] := (('l').code).to_natural_8
			ftp_inst.ftp_head[5] := (('>').code).to_natural_8
			ftp_inst.ftp_head[6] := (('<').code).to_natural_8
			ftp_inst.ftp_head[7] := (('h').code).to_natural_8
			ftp_inst.ftp_head[8] := (('e').code).to_natural_8
			ftp_inst.ftp_head[9] := (('a').code).to_natural_8
			ftp_inst.ftp_head[10] := (('d').code).to_natural_8
			ftp_inst.ftp_head[11] := (('>').code).to_natural_8
			ftp_inst.ftp_head[12] := (('<').code).to_natural_8
			ftp_inst.ftp_head[13] := (('t').code).to_natural_8
			ftp_inst.ftp_head[14] := (('i').code).to_natural_8
			ftp_inst.ftp_head[15] := (('t').code).to_natural_8
			ftp_inst.ftp_head[16] := (('l').code).to_natural_8
			ftp_inst.ftp_head[17] := (('e').code).to_natural_8
			ftp_inst.ftp_head[18] := (('>').code).to_natural_8
			ftp_inst.ftp_head[19] := (('/').code).to_natural_8
			ftp_inst.ftp_head[20] := (('%/0/').code).to_natural_8
			ftp_inst.ftp_head2[0] := (('<').code).to_natural_8
			ftp_inst.ftp_head2[1] := (('/').code).to_natural_8
			ftp_inst.ftp_head2[2] := (('t').code).to_natural_8
			ftp_inst.ftp_head2[3] := (('i').code).to_natural_8
			ftp_inst.ftp_head2[4] := (('t').code).to_natural_8
			ftp_inst.ftp_head2[5] := (('l').code).to_natural_8
			ftp_inst.ftp_head2[6] := (('e').code).to_natural_8
			ftp_inst.ftp_head2[7] := (('>').code).to_natural_8
			ftp_inst.ftp_head2[8] := (('<').code).to_natural_8
			ftp_inst.ftp_head2[9] := (('/').code).to_natural_8
			ftp_inst.ftp_head2[10] := (('h').code).to_natural_8
			ftp_inst.ftp_head2[11] := (('e').code).to_natural_8
			ftp_inst.ftp_head2[12] := (('a').code).to_natural_8
			ftp_inst.ftp_head2[13] := (('d').code).to_natural_8
			ftp_inst.ftp_head2[14] := (('>').code).to_natural_8
			ftp_inst.ftp_head2[15] := (('<').code).to_natural_8
			ftp_inst.ftp_head2[16] := (('b').code).to_natural_8
			ftp_inst.ftp_head2[17] := (('o').code).to_natural_8
			ftp_inst.ftp_head2[18] := (('d').code).to_natural_8
			ftp_inst.ftp_head2[19] := (('y').code).to_natural_8
			ftp_inst.ftp_head2[20] := (('>').code).to_natural_8
			ftp_inst.ftp_head2[21] := (('<').code).to_natural_8
			ftp_inst.ftp_head2[22] := (('h').code).to_natural_8
			ftp_inst.ftp_head2[23] := (('2').code).to_natural_8
			ftp_inst.ftp_head2[24] := (('>').code).to_natural_8
			ftp_inst.ftp_head2[25] := (('D').code).to_natural_8
			ftp_inst.ftp_head2[26] := (('i').code).to_natural_8
			ftp_inst.ftp_head2[27] := (('r').code).to_natural_8
			ftp_inst.ftp_head2[28] := (('e').code).to_natural_8
			ftp_inst.ftp_head2[29] := (('c').code).to_natural_8
			ftp_inst.ftp_head2[30] := (('t').code).to_natural_8
			ftp_inst.ftp_head2[31] := (('o').code).to_natural_8
			ftp_inst.ftp_head2[32] := (('r').code).to_natural_8
			ftp_inst.ftp_head2[33] := (('y').code).to_natural_8
			ftp_inst.ftp_head2[34] := ((' ').code).to_natural_8
			ftp_inst.ftp_head2[35] := (('/').code).to_natural_8
			ftp_inst.ftp_head2[36] := (('%/0/').code).to_natural_8
			ftp_inst.ftp_head3[0] := (('<').code).to_natural_8
			ftp_inst.ftp_head3[1] := (('/').code).to_natural_8
			ftp_inst.ftp_head3[2] := (('h').code).to_natural_8
			ftp_inst.ftp_head3[3] := (('2').code).to_natural_8
			ftp_inst.ftp_head3[4] := (('>').code).to_natural_8
			ftp_inst.ftp_head3[5] := (('<').code).to_natural_8
			ftp_inst.ftp_head3[6] := (('p').code).to_natural_8
			ftp_inst.ftp_head3[7] := (('r').code).to_natural_8
			ftp_inst.ftp_head3[8] := (('e').code).to_natural_8
			ftp_inst.ftp_head3[9] := (('>').code).to_natural_8
			ftp_inst.ftp_head3[10] := (('%/0/').code).to_natural_8
			html_inst.html_stack[0].next := create {CE_POINTER [ANY]}.make_cast (html_inst.html_stack)
			html_inst.html_stack[0].prev := create {CE_POINTER [ANY]}.make_cast (html_inst.html_stack)
			html_inst.get_attr_val_nl := 0
			html_inst.roman_tbl[0].n := (1_000).to_natural_16
			html_inst.roman_tbl[0].s := ce_string ("m")
			html_inst.roman_tbl[1].n := (999).to_natural_16
			html_inst.roman_tbl[1].s := ce_string ("im")
			html_inst.roman_tbl[2].n := (990).to_natural_16
			html_inst.roman_tbl[2].s := ce_string ("xm")
			html_inst.roman_tbl[3].n := (900).to_natural_16
			html_inst.roman_tbl[3].s := ce_string ("cm")
			html_inst.roman_tbl[4].n := (500).to_natural_16
			html_inst.roman_tbl[4].s := ce_string ("d")
			html_inst.roman_tbl[5].n := (499).to_natural_16
			html_inst.roman_tbl[5].s := ce_string ("id")
			html_inst.roman_tbl[6].n := (490).to_natural_16
			html_inst.roman_tbl[6].s := ce_string ("xd")
			html_inst.roman_tbl[7].n := (400).to_natural_16
			html_inst.roman_tbl[7].s := ce_string ("cd")
			html_inst.roman_tbl[8].n := (100).to_natural_16
			html_inst.roman_tbl[8].s := ce_string ("c")
			html_inst.roman_tbl[9].n := (99).to_natural_16
			html_inst.roman_tbl[9].s := ce_string ("ic")
			html_inst.roman_tbl[10].n := (90).to_natural_16
			html_inst.roman_tbl[10].s := ce_string ("xc")
			html_inst.roman_tbl[11].n := (50).to_natural_16
			html_inst.roman_tbl[11].s := ce_string ("l")
			html_inst.roman_tbl[12].n := (49).to_natural_16
			html_inst.roman_tbl[12].s := ce_string ("il")
			html_inst.roman_tbl[13].n := (40).to_natural_16
			html_inst.roman_tbl[13].s := ce_string ("xl")
			html_inst.roman_tbl[14].n := (10).to_natural_16
			html_inst.roman_tbl[14].s := ce_string ("x")
			html_inst.roman_tbl[15].n := (9).to_natural_16
			html_inst.roman_tbl[15].s := ce_string ("ix")
			html_inst.roman_tbl[16].n := (5).to_natural_16
			html_inst.roman_tbl[16].s := ce_string ("v")
			html_inst.roman_tbl[17].n := (4).to_natural_16
			html_inst.roman_tbl[17].s := ce_string ("iv")
			html_inst.roman_tbl[18].n := (1).to_natural_16
			html_inst.roman_tbl[18].s := ce_string ("i")
			html_inst.roman_tbl[19].n := (0).to_natural_16
			html_inst.roman_tbl[19].s := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			html_inst.color_specs[0].name := ce_string ("aliceblue")
			html_inst.color_specs[0].rgb := 15_792_383
			html_inst.color_specs[1].name := ce_string ("antiquewhite")
			html_inst.color_specs[1].rgb := 16_444_375
			html_inst.color_specs[2].name := ce_string ("aqua")
			html_inst.color_specs[2].rgb := 65_535
			html_inst.color_specs[3].name := ce_string ("aquamarine")
			html_inst.color_specs[3].rgb := 8_388_564
			html_inst.color_specs[4].name := ce_string ("azure")
			html_inst.color_specs[4].rgb := 15_794_175
			html_inst.color_specs[5].name := ce_string ("beige")
			html_inst.color_specs[5].rgb := 16_119_260
			html_inst.color_specs[6].name := ce_string ("bisque")
			html_inst.color_specs[6].rgb := 16_770_244
			html_inst.color_specs[7].name := ce_string ("black")
			html_inst.color_specs[7].rgb := 0
			html_inst.color_specs[8].name := ce_string ("blanchedalmond")
			html_inst.color_specs[8].rgb := 16_772_045
			html_inst.color_specs[9].name := ce_string ("blue")
			html_inst.color_specs[9].rgb := 255
			html_inst.color_specs[10].name := ce_string ("blueviolet")
			html_inst.color_specs[10].rgb := 9_055_202
			html_inst.color_specs[11].name := ce_string ("brown")
			html_inst.color_specs[11].rgb := 10_824_234
			html_inst.color_specs[12].name := ce_string ("burlywood")
			html_inst.color_specs[12].rgb := 14_596_231
			html_inst.color_specs[13].name := ce_string ("cadetblue")
			html_inst.color_specs[13].rgb := 6_266_528
			html_inst.color_specs[14].name := ce_string ("chartreuse")
			html_inst.color_specs[14].rgb := 8_388_352
			html_inst.color_specs[15].name := ce_string ("chocolate")
			html_inst.color_specs[15].rgb := 13_789_470
			html_inst.color_specs[16].name := ce_string ("coral")
			html_inst.color_specs[16].rgb := 16_744_272
			html_inst.color_specs[17].name := ce_string ("cornflowerblue")
			html_inst.color_specs[17].rgb := 6_591_981
			html_inst.color_specs[18].name := ce_string ("cornsilk")
			html_inst.color_specs[18].rgb := 16_775_388
			html_inst.color_specs[19].name := ce_string ("crimson")
			html_inst.color_specs[19].rgb := 14_423_100
			html_inst.color_specs[20].name := ce_string ("cyan")
			html_inst.color_specs[20].rgb := 65_535
			html_inst.color_specs[21].name := ce_string ("darkblue")
			html_inst.color_specs[21].rgb := 139
			html_inst.color_specs[22].name := ce_string ("darkcyan")
			html_inst.color_specs[22].rgb := 35_723
			html_inst.color_specs[23].name := ce_string ("darkgoldenrod")
			html_inst.color_specs[23].rgb := 12_092_939
			html_inst.color_specs[24].name := ce_string ("darkgray")
			html_inst.color_specs[24].rgb := 11_119_017
			html_inst.color_specs[25].name := ce_string ("darkgreen")
			html_inst.color_specs[25].rgb := 25_600
			html_inst.color_specs[26].name := ce_string ("darkkhaki")
			html_inst.color_specs[26].rgb := 12_433_259
			html_inst.color_specs[27].name := ce_string ("darkmagenta")
			html_inst.color_specs[27].rgb := 9_109_643
			html_inst.color_specs[28].name := ce_string ("darkolivegreen")
			html_inst.color_specs[28].rgb := 5_597_999
			html_inst.color_specs[29].name := ce_string ("darkorange")
			html_inst.color_specs[29].rgb := 16_747_520
			html_inst.color_specs[30].name := ce_string ("darkorchid")
			html_inst.color_specs[30].rgb := 10_040_012
			html_inst.color_specs[31].name := ce_string ("darkred")
			html_inst.color_specs[31].rgb := 9_109_504
			html_inst.color_specs[32].name := ce_string ("darksalmon")
			html_inst.color_specs[32].rgb := 15_308_410
			html_inst.color_specs[33].name := ce_string ("darkseagreen")
			html_inst.color_specs[33].rgb := 9_419_919
			html_inst.color_specs[34].name := ce_string ("darkslateblue")
			html_inst.color_specs[34].rgb := 4_734_347
			html_inst.color_specs[35].name := ce_string ("darkslategray")
			html_inst.color_specs[35].rgb := 3_100_495
			html_inst.color_specs[36].name := ce_string ("darkturquoise")
			html_inst.color_specs[36].rgb := 52_945
			html_inst.color_specs[37].name := ce_string ("darkviolet")
			html_inst.color_specs[37].rgb := 9_699_539
			html_inst.color_specs[38].name := ce_string ("deeppink")
			html_inst.color_specs[38].rgb := 16_716_947
			html_inst.color_specs[39].name := ce_string ("deepskyblue")
			html_inst.color_specs[39].rgb := 49_151
			html_inst.color_specs[40].name := ce_string ("dimgray")
			html_inst.color_specs[40].rgb := 6_908_265
			html_inst.color_specs[41].name := ce_string ("dodgerblue")
			html_inst.color_specs[41].rgb := 2_003_199
			html_inst.color_specs[42].name := ce_string ("firebrick")
			html_inst.color_specs[42].rgb := 11_674_146
			html_inst.color_specs[43].name := ce_string ("floralwhite")
			html_inst.color_specs[43].rgb := 16_775_920
			html_inst.color_specs[44].name := ce_string ("forestgreen")
			html_inst.color_specs[44].rgb := 2_263_842
			html_inst.color_specs[45].name := ce_string ("fuchsia")
			html_inst.color_specs[45].rgb := 16_711_935
		end

end
