frozen class
	LINKS_INITIALIZER_SLICE78

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			language_inst.translation_swedish[161].code := 161
			language_inst.translation_swedish[161].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("nuvarande hastighet"))
			language_inst.translation_swedish[162].code := 162
			language_inst.translation_swedish[162].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Anv%/228/nd tid"))
			language_inst.translation_swedish[163].code := 163
			language_inst.translation_swedish[163].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("uppskattad tid"))
			language_inst.translation_swedish[164].code := 164
			language_inst.translation_swedish[164].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bakgrund"))
			language_inst.translation_swedish[165].code := 165
			language_inst.translation_swedish[165].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Avbryt"))
			language_inst.translation_swedish[166].code := 166
			language_inst.translation_swedish[166].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ja"))
			language_inst.translation_swedish[167].code := 167
			language_inst.translation_swedish[167].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nej"))
			language_inst.translation_swedish[168].code := 168
			language_inst.translation_swedish[168].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H%/228/mtningsfel"))
			language_inst.translation_swedish[169].code := 169
			language_inst.translation_swedish[169].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kunde inte skriva till fil"))
			language_inst.translation_swedish[170].code := 170
			language_inst.translation_swedish[170].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fel vid h%/228/mtning av"))
			language_inst.translation_swedish[171].code := 171
			language_inst.translation_swedish[171].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kunde inte skapa fil"))
			language_inst.translation_swedish[172].code := 172
			language_inst.translation_swedish[172].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[173].code := 173
			language_inst.translation_swedish[173].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ok%/228/nd typ"))
			language_inst.translation_swedish[174].code := 174
			language_inst.translation_swedish[174].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inneh%/229/llstyp %/228/r"))
			language_inst.translation_swedish[175].code := 175
			language_inst.translation_swedish[175].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du spara eller visa filen?"))
			language_inst.translation_swedish[176].code := 176
			language_inst.translation_swedish[176].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Spara"))
			language_inst.translation_swedish[177].code := 177
			language_inst.translation_swedish[177].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Visa"))
			language_inst.translation_swedish[178].code := 178
			language_inst.translation_swedish[178].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vad skall jag g%/246/ra?"))
			language_inst.translation_swedish[179].code := 179
			language_inst.translation_swedish[179].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du %/246/ppna filen med"))
			language_inst.translation_swedish[180].code := 180
			language_inst.translation_swedish[180].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("spara den, eller visa den?"))
			language_inst.translation_swedish[181].code := 181
			language_inst.translation_swedish[181].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/214/ppna"))
			language_inst.translation_swedish[182].code := 182
			language_inst.translation_swedish[182].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du f%/246/lja omdirigering och skicka formul%/228/rdata till URL"))
			language_inst.translation_swedish[183].code := 183
			language_inst.translation_swedish[183].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du skicka formul%/228/rdata till URL"))
			language_inst.translation_swedish[184].code := 184
			language_inst.translation_swedish[184].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du skicka formul%/228/rdata igen till URL"))
			language_inst.translation_swedish[185].code := 185
			language_inst.translation_swedish[185].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Varning"))
			language_inst.translation_swedish[186].code := 186
			language_inst.translation_swedish[186].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fel"))
			language_inst.translation_swedish[187].code := 187
			language_inst.translation_swedish[187].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V%/228/lkommen"))
			language_inst.translation_swedish[188].code := 188
			language_inst.translation_swedish[188].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V%/228/lkommen till links!"))
			language_inst.translation_swedish[189].code := 189
			language_inst.translation_swedish[189].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tryck ESC f%/246/r meny. V%/228/lj Hj%/228/lp->Bruksanvisning f%/246/r bruksanvisning"))
			language_inst.translation_swedish[190].code := 190
			language_inst.translation_swedish[190].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Etikett"))
			language_inst.translation_swedish[191].code := 191
			language_inst.translation_swedish[191].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inneh%/229/llstyp(er)"))
			language_inst.translation_swedish[192].code := 192
			language_inst.translation_swedish[192].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Program (%'%%%' ers%/228/tts med filnamn)"))
			language_inst.translation_swedish[193].code := 193
			language_inst.translation_swedish[193].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Blockera terminalen n%/228/r programmet k%/246/rs"))
			language_inst.translation_swedish[194].code := 194
			language_inst.translation_swedish[194].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K%/246/r i terminal"))
			language_inst.translation_swedish[195].code := 195
			language_inst.translation_swedish[195].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K%/246/r i X-f%/246/nster"))
			language_inst.translation_swedish[196].code := 196
			language_inst.translation_swedish[196].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fr%/229/ga innan %/246/ppnande"))
			language_inst.translation_swedish[197].code := 197
			language_inst.translation_swedish[197].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ta bort association"))
			language_inst.translation_swedish[198].code := 198
			language_inst.translation_swedish[198].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Association"))
			language_inst.translation_swedish[199].code := 199
			language_inst.translation_swedish[199].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/196/ndelse(r)"))
			language_inst.translation_swedish[200].code := 200
			language_inst.translation_swedish[200].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inneh%/229/llstyp"))
			language_inst.translation_swedish[201].code := 201
			language_inst.translation_swedish[201].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inga associationer"))
			language_inst.translation_swedish[202].code := 202
			language_inst.translation_swedish[202].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ta bort %/228/ndelse"))
			language_inst.translation_swedish[203].code := 203
			language_inst.translation_swedish[203].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/196/ndelse"))
			language_inst.translation_swedish[204].code := 204
			language_inst.translation_swedish[204].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inga %/228/ndelser"))
			language_inst.translation_swedish[205].code := 205
			language_inst.translation_swedish[205].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fel vid skickande av formul%/228/r"))
			language_inst.translation_swedish[206].code := 206
			language_inst.translation_swedish[206].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kunde inte h%/228/mta fil"))
			language_inst.translation_swedish[207].code := 207
			language_inst.translation_swedish[207].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ingen tidigare s%/246/kning"))
			language_inst.translation_swedish[208].code := 208
			language_inst.translation_swedish[208].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S%/246/kstr%/228/ng ej hittad"))
			language_inst.translation_swedish[209].code := 209
			language_inst.translation_swedish[209].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sparfel"))
			language_inst.translation_swedish[210].code := 210
			language_inst.translation_swedish[210].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fel vid skrivning till fil"))
			language_inst.translation_swedish[211].code := 211
			language_inst.translation_swedish[211].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Visa usemap"))
			language_inst.translation_swedish[212].code := 212
			language_inst.translation_swedish[212].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F%/246/lj l%/228/nk"))
			language_inst.translation_swedish[213].code := 213
			language_inst.translation_swedish[213].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/214/ppna i nytt f%/246/nster"))
			language_inst.translation_swedish[214].code := 214
			language_inst.translation_swedish[214].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H%/228/mta l%/228/nk"))
			language_inst.translation_swedish[215].code := 215
			language_inst.translation_swedish[215].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T%/246/m formul%/228/r"))
			language_inst.translation_swedish[216].code := 216
			language_inst.translation_swedish[216].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skicka formul%/228/r"))
			language_inst.translation_swedish[217].code := 217
			language_inst.translation_swedish[217].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skicka formul%/228/r och %/246/ppna i nytt f%/246/nster"))
			language_inst.translation_swedish[218].code := 218
			language_inst.translation_swedish[218].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skicka formul%/228/r och h%/228/mta"))
			language_inst.translation_swedish[219].code := 219
			language_inst.translation_swedish[219].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Visa bild"))
			language_inst.translation_swedish[220].code := 220
			language_inst.translation_swedish[220].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H%/228/mta bild"))
			language_inst.translation_swedish[221].code := 221
			language_inst.translation_swedish[221].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ingen l%/228/nk vald"))
			language_inst.translation_swedish[222].code := 222
			language_inst.translation_swedish[222].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bild"))
			language_inst.translation_swedish[223].code := 223
			language_inst.translation_swedish[223].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Usemap"))
			language_inst.translation_swedish[224].code := 224
			language_inst.translation_swedish[224].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skicka formul%/228/r till"))
			language_inst.translation_swedish[225].code := 225
			language_inst.translation_swedish[225].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skicka formul%/228/r till"))
			language_inst.translation_swedish[226].code := 226
			language_inst.translation_swedish[226].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Radioknapp"))
			language_inst.translation_swedish[227].code := 227
			language_inst.translation_swedish[227].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kryssruta"))
			language_inst.translation_swedish[228].code := 228
			language_inst.translation_swedish[228].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Valf%/228/lt"))
			language_inst.translation_swedish[229].code := 229
			language_inst.translation_swedish[229].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Textf%/228/lt"))
			language_inst.translation_swedish[230].code := 230
			language_inst.translation_swedish[230].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Textarea"))
			language_inst.translation_swedish[231].code := 231
			language_inst.translation_swedish[231].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fils%/228/ndning"))
			language_inst.translation_swedish[232].code := 232
			language_inst.translation_swedish[232].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L%/246/senordsf%/228/lt"))
			language_inst.translation_swedish[233].code := 233
			language_inst.translation_swedish[233].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Namn"))
			language_inst.translation_swedish[234].code := 234
			language_inst.translation_swedish[234].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V%/228/rde"))
			language_inst.translation_swedish[235].code := 235
			language_inst.translation_swedish[235].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tryck Enter f%/246/r att"))
			language_inst.translation_swedish[236].code := 236
			language_inst.translation_swedish[236].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("skicka till"))
			language_inst.translation_swedish[237].code := 237
			language_inst.translation_swedish[237].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("skicka till"))
			language_inst.translation_swedish[238].code := 238
			language_inst.translation_swedish[238].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Info"))
			language_inst.translation_swedish[239].code := 239
			language_inst.translation_swedish[239].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Huvudinfo"))
			language_inst.translation_swedish[240].code := 240
			language_inst.translation_swedish[240].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Du %/228/r ingenstans!"))
			language_inst.translation_swedish[241].code := 241
			language_inst.translation_swedish[241].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("URL"))
			language_inst.translation_swedish[242].code := 242
			language_inst.translation_swedish[242].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Storlek"))
			language_inst.translation_swedish[243].code := 243
			language_inst.translation_swedish[243].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ej komplett"))
			language_inst.translation_swedish[244].code := 244
			language_inst.translation_swedish[244].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("teckenupps%/228/ttning"))
			language_inst.translation_swedish[245].code := 245
			language_inst.translation_swedish[245].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("antagen"))
			language_inst.translation_swedish[246].code := 246
			language_inst.translation_swedish[246].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ignorerar serverinst%/228/llning"))
			language_inst.translation_swedish[247].code := 247
			language_inst.translation_swedish[247].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Server"))
			language_inst.translation_swedish[248].code := 248
			language_inst.translation_swedish[248].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Datum"))
			language_inst.translation_swedish[249].code := 249
			language_inst.translation_swedish[249].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Senast %/228/ndrad"))
			language_inst.translation_swedish[250].code := 250
			language_inst.translation_swedish[250].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Spr%/229/k"))
			language_inst.translation_swedish[251].code := 251
			language_inst.translation_swedish[251].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Xterm"))
			language_inst.translation_swedish[252].code := 252
			language_inst.translation_swedish[252].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[253].code := 253
			language_inst.translation_swedish[253].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Sk%/228/rm"))
			language_inst.translation_swedish[254].code := 254
			language_inst.translation_swedish[254].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F%/246/nster"))
			language_inst.translation_swedish[255].code := 255
			language_inst.translation_swedish[255].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Fullsk%/228/rm"))
			language_inst.translation_swedish[256].code := 256
			language_inst.translation_swedish[256].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("BeOS-terminal"))
			language_inst.translation_swedish[257].code := 257
			language_inst.translation_swedish[257].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Nytt f%/246/nster"))
			language_inst.translation_swedish[258].code := 258
			language_inst.translation_swedish[258].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G%/229/ till l%/228/nk"))
			language_inst.translation_swedish[259].code := 259
			language_inst.translation_swedish[259].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Skriv in l%/228/nknummer"))
			language_inst.translation_swedish[260].code := 260
			language_inst.translation_swedish[260].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/196/ndra storlek p%/229/ terminal"))
			language_inst.translation_swedish[261].code := 261
			language_inst.translation_swedish[261].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kolumner"))
			language_inst.translation_swedish[262].code := 262
			language_inst.translation_swedish[262].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Rader"))
			language_inst.translation_swedish[263].code := 263
			language_inst.translation_swedish[263].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bokm%/228/rken"))
			language_inst.translation_swedish[264].code := 264
			language_inst.translation_swedish[264].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L%/228/gg till bokm%/228/rke"))
			language_inst.translation_swedish[265].code := 265
			language_inst.translation_swedish[265].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G%/229/ till"))
			language_inst.translation_swedish[266].code := 266
			language_inst.translation_swedish[266].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Redigera"))
			language_inst.translation_swedish[267].code := 267
			language_inst.translation_swedish[267].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("St%/228/ng"))
			language_inst.translation_swedish[268].code := 268
			language_inst.translation_swedish[268].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bokm%/228/rkestitel"))
			language_inst.translation_swedish[269].code := 269
			language_inst.translation_swedish[269].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Redigera bokm%/228/rke"))
			language_inst.translation_swedish[270].code := 270
			language_inst.translation_swedish[270].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ta bort bokm%/228/rke"))
			language_inst.translation_swedish[271].code := 271
			language_inst.translation_swedish[271].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bokm%/228/rkeshanterare"))
			language_inst.translation_swedish[272].code := 272
			language_inst.translation_swedish[272].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("URL"))
			language_inst.translation_swedish[273].code := 273
			language_inst.translation_swedish[273].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Namn"))
			language_inst.translation_swedish[274].code := 274
			language_inst.translation_swedish[274].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Avsluta links"))
			language_inst.translation_swedish[275].code := 275
			language_inst.translation_swedish[275].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du verkligen avsluta links?"))
			language_inst.translation_swedish[276].code := 276
			language_inst.translation_swedish[276].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Vill du verkligen avsluta links och avbryta alla p%/229/g%/229/ende h%/228/mtningar?"))
			language_inst.translation_swedish[277].code := 277
			language_inst.translation_swedish[277].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("HTTP-alternativ"))
			language_inst.translation_swedish[278].code := 278
			language_inst.translation_swedish[278].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("FTP-alternativ"))
			language_inst.translation_swedish[279].code := 279
			language_inst.translation_swedish[279].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kringg%/229/ HTTP-buggar"))
			language_inst.translation_swedish[280].code := 280
			language_inst.translation_swedish[280].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Anv%/228/nd HTTP/1.0"))
			language_inst.translation_swedish[281].code := 281
			language_inst.translation_swedish[281].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Till%/229/t svartlistning av felaktiga servrar"))
			language_inst.translation_swedish[282].code := 282
			language_inst.translation_swedish[282].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Trasig omdirigering 302 (bryter mot RFC, men %/228/r kompatibel med Netscape)"))
			language_inst.translation_swedish[283].code := 283
			language_inst.translation_swedish[283].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H%/229/ll inte uppkopplingen uppe efter POST-f%/246/rfr%/229/gan (en del trasiga PHP-databaser beh%/246/ver det)"))
			language_inst.translation_swedish[284].code := 284
			language_inst.translation_swedish[284].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[285].code := 285
			language_inst.translation_swedish[285].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L%/246/senord f%/246/r anonym inloggning"))
			language_inst.translation_swedish[286].code := 286
			language_inst.translation_swedish[286].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[287].code := 287
			language_inst.translation_swedish[287].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[288].code := 288
			language_inst.translation_swedish[288].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[289].code := 289
			language_inst.translation_swedish[289].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bruksanvisning"))
			language_inst.translation_swedish[290].code := 290
			language_inst.translation_swedish[290].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Epostprogram (%% ers%/228/tts med adress)"))
			language_inst.translation_swedish[291].code := 291
			language_inst.translation_swedish[291].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Telnetprogram (%% ers%/228/tts med %"v%/228/rd%" eller %"v%/228/rd port%")"))
			language_inst.translation_swedish[292].code := 292
			language_inst.translation_swedish[292].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tn3270-program (%% ers%/228/tts med %"v%/228/rd%" eller %"v%/228/rd port%")"))
			language_inst.translation_swedish[293].code := 293
			language_inst.translation_swedish[293].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[294].code := 294
			language_inst.translation_swedish[294].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Epost- och telnetprogram"))
			language_inst.translation_swedish[295].code := 295
			language_inst.translation_swedish[295].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inget program"))
			language_inst.translation_swedish[296].code := 296
			language_inst.translation_swedish[296].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Inget program angett f%/246/r"))
			language_inst.translation_swedish[297].code := 297
			language_inst.translation_swedish[297].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("epost"))
			language_inst.translation_swedish[298].code := 298
			language_inst.translation_swedish[298].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("telnet"))
			language_inst.translation_swedish[299].code := 299
			language_inst.translation_swedish[299].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tn3270"))
			language_inst.translation_swedish[300].code := 300
			language_inst.translation_swedish[300].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[301].code := 301
			language_inst.translation_swedish[301].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Felaktig mailto-URL"))
			language_inst.translation_swedish[302].code := 302
			language_inst.translation_swedish[302].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Felaktig telnet-URL"))
			language_inst.translation_swedish[303].code := 303
			language_inst.translation_swedish[303].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Felaktig tn3270-URL"))
			language_inst.translation_swedish[304].code := 304
			language_inst.translation_swedish[304].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[305].code := 305
			language_inst.translation_swedish[305].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Anv%/228/ndar-ID"))
			language_inst.translation_swedish[306].code := 306
			language_inst.translation_swedish[306].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L%/246/senord"))
			language_inst.translation_swedish[307].code := 307
			language_inst.translation_swedish[307].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ange anv%/228/ndarnamn f%/246/r "))
			language_inst.translation_swedish[308].code := 308
			language_inst.translation_swedish[308].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" p%/229/ "))
			language_inst.translation_swedish[309].code := 309
			language_inst.translation_swedish[309].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("SSL-fel"))
			language_inst.translation_swedish[310].code := 310
			language_inst.translation_swedish[310].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Denna version av Links inneh%/229/ller inte st%/246/d f%/246/r SSL/TLS"))
			language_inst.translation_swedish[311].code := 311
			language_inst.translation_swedish[311].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[312].code := 312
			language_inst.translation_swedish[312].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_swedish[313].code := 313
			language_inst.translation_swedish[313].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_swedish[314].code := 314
			language_inst.translation_swedish[314].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_swedish[315].code := 315
			language_inst.translation_swedish[315].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_swedish[316].code := 316
			language_inst.translation_swedish[316].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_swedish[317].code := 317
			language_inst.translation_swedish[317].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_swedish[318].code := 318
			language_inst.translation_swedish[318].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_swedish[319].code := 319
			language_inst.translation_swedish[319].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_swedish[320].code := 320
			language_inst.translation_swedish[320].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_swedish[321].code := 321
			language_inst.translation_swedish[321].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_swedish[322].code := 322
			language_inst.translation_swedish[322].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_swedish[323].code := 323
			language_inst.translation_swedish[323].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_swedish[324].code := 324
			language_inst.translation_swedish[324].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_swedish[325].code := 325
			language_inst.translation_swedish[325].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_swedish[326].code := 326
			language_inst.translation_swedish[326].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_swedish[327].code := 327
			language_inst.translation_swedish[327].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_swedish[328].code := 328
			language_inst.translation_swedish[328].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_swedish[329].code := 329
			language_inst.translation_swedish[329].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("X"))
			language_inst.translation_swedish[330].code := 330
			language_inst.translation_swedish[330].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_swedish[331].code := 331
			language_inst.translation_swedish[331].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_swedish[332].code := 332
			language_inst.translation_swedish[332].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_swedish[333].code := 333
			language_inst.translation_swedish[333].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("P"))
			language_inst.translation_swedish[334].code := 334
			language_inst.translation_swedish[334].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_swedish[335].code := 335
			language_inst.translation_swedish[335].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_swedish[336].code := 336
			language_inst.translation_swedish[336].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[337].code := 337
			language_inst.translation_swedish[337].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_swedish[338].code := 338
			language_inst.translation_swedish[338].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("O"))
			language_inst.translation_swedish[339].code := 339
			language_inst.translation_swedish[339].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_swedish[340].code := 340
			language_inst.translation_swedish[340].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_swedish[341].code := 341
			language_inst.translation_swedish[341].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("K"))
			language_inst.translation_swedish[342].code := 342
			language_inst.translation_swedish[342].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_swedish[343].code := 343
			language_inst.translation_swedish[343].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_swedish[344].code := 344
			language_inst.translation_swedish[344].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_swedish[345].code := 345
			language_inst.translation_swedish[345].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("M"))
			language_inst.translation_swedish[346].code := 346
			language_inst.translation_swedish[346].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_swedish[347].code := 347
			language_inst.translation_swedish[347].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_swedish[348].code := 348
			language_inst.translation_swedish[348].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_swedish[349].code := 349
			language_inst.translation_swedish[349].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("T"))
			language_inst.translation_swedish[350].code := 350
			language_inst.translation_swedish[350].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_swedish[351].code := 351
			language_inst.translation_swedish[351].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("C"))
			language_inst.translation_swedish[352].code := 352
			language_inst.translation_swedish[352].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("A"))
			language_inst.translation_swedish[353].code := 353
			language_inst.translation_swedish[353].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E"))
			language_inst.translation_swedish[354].code := 354
			language_inst.translation_swedish[354].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_swedish[355].code := 355
			language_inst.translation_swedish[355].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_swedish[356].code := 356
			language_inst.translation_swedish[356].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("V"))
			language_inst.translation_swedish[357].code := 357
			language_inst.translation_swedish[357].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("L"))
			language_inst.translation_swedish[358].code := 358
			language_inst.translation_swedish[358].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_swedish[359].code := 359
			language_inst.translation_swedish[359].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_swedish[360].code := 360
			language_inst.translation_swedish[360].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("H"))
			language_inst.translation_swedish[361].code := 361
			language_inst.translation_swedish[361].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("U"))
			language_inst.translation_swedish[362].code := 362
			language_inst.translation_swedish[362].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_swedish[363].code := 363
			language_inst.translation_swedish[363].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_swedish[364].code := 364
			language_inst.translation_swedish[364].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_swedish[365].code := 365
			language_inst.translation_swedish[365].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("R"))
			language_inst.translation_swedish[366].code := 366
			language_inst.translation_swedish[366].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_swedish[367].code := 367
			language_inst.translation_swedish[367].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_swedish[368].code := 368
			language_inst.translation_swedish[368].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("D"))
			language_inst.translation_swedish[369].code := 369
			language_inst.translation_swedish[369].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("I"))
			language_inst.translation_swedish[370].code := 370
			language_inst.translation_swedish[370].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("G"))
			language_inst.translation_swedish[371].code := 371
			language_inst.translation_swedish[371].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("X"))
			language_inst.translation_swedish[372].code := 372
			language_inst.translation_swedish[372].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_swedish[373].code := 373
			language_inst.translation_swedish[373].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("S"))
			language_inst.translation_swedish[374].code := 374
			language_inst.translation_swedish[374].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("W"))
			language_inst.translation_swedish[375].code := 375
			language_inst.translation_swedish[375].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("F"))
			language_inst.translation_swedish[376].code := 376
			language_inst.translation_swedish[376].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("B"))
			language_inst.translation_swedish[377].code := 377
			language_inst.translation_swedish[377].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("N"))
			language_inst.translation_swedish[378].code := 0
			language_inst.translation_swedish[378].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_turkish[0].code := 0
			language_inst.translation_turkish[0].name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			language_inst.translation_turkish[1].code := 1
			language_inst.translation_turkish[1].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("8859-9"))
			language_inst.translation_turkish[2].code := 2
			language_inst.translation_turkish[2].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Turkish"))
			language_inst.translation_turkish[3].code := 3
			language_inst.translation_turkish[3].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tr"))
			language_inst.translation_turkish[4].code := 4
			language_inst.translation_turkish[4].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hatal%/253/ say%/253/"))
			language_inst.translation_turkish[5].code := 5
			language_inst.translation_turkish[5].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Say%/253/ girilmesi bekleniyordu"))
			language_inst.translation_turkish[6].code := 6
			language_inst.translation_turkish[6].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%/221/ptal"))
			language_inst.translation_turkish[7].code := 7
			language_inst.translation_turkish[7].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Number out of range"))
			language_inst.translation_turkish[8].code := 8
			language_inst.translation_turkish[8].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hatal%/253/ s%/246/z dizimi"))
			language_inst.translation_turkish[9].code := 9
			language_inst.translation_turkish[9].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bo%/254/ s%/246/z dizimine izin verilmiyor"))
			language_inst.translation_turkish[10].code := 10
			language_inst.translation_turkish[10].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Yap%/253/land%/253/rma Hatas%/253/"))
			language_inst.translation_turkish[11].code := 11
			language_inst.translation_turkish[11].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Yap%/253/land%/253/rma dosyas%/253/na yaz%/253/lam%/253/yor"))
			language_inst.translation_turkish[12].code := 12
			language_inst.translation_turkish[12].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Hakk%/253/nda"))
			language_inst.translation_turkish[13].code := 13
			language_inst.translation_turkish[13].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ba%/240/lant%/253/lar 1.00%N%NLynx t%/252/r%/252/nde metin tabanl%/253/ taray%/253/c%/253/"))
			language_inst.translation_turkish[14].code := 14
			language_inst.translation_turkish[14].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tamam"))
			language_inst.translation_turkish[15].code := 15
			language_inst.translation_turkish[15].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Tu%/254/lar"))
			language_inst.translation_turkish[16].code := 16
			language_inst.translation_turkish[16].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ESC    men%/252/y%/252/ g%/246/ster%N^C, q    %/231/%/253/k%N^P, ^N   yukar%/253/ kayd%/253/r, a%/254/a%/240/%/253/ kayd%/253/r%N[, ]     sa%/240/a kayd%/253/r, sola kayd%/253/r%Nyukar%/253/, a%/254/a%/240/%/253/ ba%/240/lant%/253/y%/253/ se%/231/%N->       ba%/240/lant%/253/y%/253/ izle%N<-       geri git%Ng        adrese git%NG        %/254/imdiki adresten yola %/231/%/253/karak yeni bir adrese git%N/        ara%N?        geriye do%/240/ru ara%Nn        tekrar ara%NN        geriye do%/240/ru tekrar ara%N=        belge bilgisi%N\        kayna%/240/%/253/n%/253/ g%/246/ster%Nd        indir"))
			language_inst.translation_turkish[17].code := 17
			language_inst.translation_turkish[17].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kopyalamak"))
			language_inst.translation_turkish[18].code := 18
			language_inst.translation_turkish[18].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ba%/240/lant%/253/lar 1.00%N%N(C) 1999 - 2008 Mikulas Patocka%N%N Bu %/246/zg%/252/r bir yaz%/253/l%/253/md%/253/r; GNU Genel Kamu Lisans%/253/ alt%/253/nda da%/240/%/253/t%/253/labilir ve/veya geli%/254/tirilebilir."))
			language_inst.translation_turkish[19].code := 19
			language_inst.translation_turkish[19].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Kaynaklar"))
			language_inst.translation_turkish[20].code := 20
			language_inst.translation_turkish[20].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("handles"))
			language_inst.translation_turkish[21].code := 21
			language_inst.translation_turkish[21].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("zamanlay%/253/c%/253/lar"))
			language_inst.translation_turkish[22].code := 22
			language_inst.translation_turkish[22].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Ba%/240/lant%/253/lar"))
			language_inst.translation_turkish[23].code := 23
			language_inst.translation_turkish[23].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ba%/240/lant%/253/lar"))
			language_inst.translation_turkish[24].code := 24
			language_inst.translation_turkish[24].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ba%/240/lan%/253/yor"))
			language_inst.translation_turkish[25].code := 25
			language_inst.translation_turkish[25].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("aktar%/253/l%/253/yor"))
			language_inst.translation_turkish[26].code := 26
			language_inst.translation_turkish[26].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepalive"))
			language_inst.translation_turkish[27].code := 27
			language_inst.translation_turkish[27].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Memory cache"))
			language_inst.translation_turkish[28].code := 28
			language_inst.translation_turkish[28].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("byte lar"))
			language_inst.translation_turkish[29].code := 29
			language_inst.translation_turkish[29].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dosyalar"))
			language_inst.translation_turkish[30].code := 30
			language_inst.translation_turkish[30].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("kilitlenmi%/254/"))
			language_inst.translation_turkish[31].code := 31
			language_inst.translation_turkish[31].name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("y%/252/kleniyor"))
		end

end
