frozen class
	LINKS_INITIALIZER_SLICE85

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			session_inst.depth := 0
			session_inst.stop_recursion := 0
			smb_inst.smb_client := 0
			terminal_inst.terminals[0].next := create {CE_POINTER [ANY]}.make_cast (terminal_inst.terminals)
			terminal_inst.terminals[0].prev := create {CE_POINTER [ANY]}.make_cast (terminal_inst.terminals)
			terminal_inst.term_specs[0].next := create {CE_POINTER [ANY]}.make_cast (terminal_inst.term_specs)
			terminal_inst.term_specs[0].prev := create {CE_POINTER [ANY]}.make_cast (terminal_inst.term_specs)
			terminal_inst.dumb_term[0].next := create {CE_POINTER [PD_TERM_SPEC]}.make_shared (default_pointer)
			terminal_inst.dumb_term[0].prev := create {CE_POINTER [PD_TERM_SPEC]}.make_shared (default_pointer)
			terminal_inst.dumb_term[0].term[0] := (('%/0/').code).to_natural_8
			terminal_inst.dumb_term[0].mode := 0
			terminal_inst.dumb_term[0].m11_hack := 1
			terminal_inst.dumb_term[0].restrict_852 := 0
			terminal_inst.dumb_term[0].block_cursor := 0
			terminal_inst.dumb_term[0].col := 0
			terminal_inst.dumb_term[0].charset := 0
			terminal_inst.frame_dumb[0] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[1] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[2] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[3] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[4] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[5] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[6] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[7] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[8] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[9] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[10] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[11] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[12] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[13] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[14] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[15] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[16] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[17] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[18] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[19] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[20] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[21] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[22] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[23] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[24] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[25] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[26] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[27] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[28] := (('|').code).to_natural_8
			terminal_inst.frame_dumb[29] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[30] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[31] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[32] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[33] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[34] := (('-').code).to_natural_8
			terminal_inst.frame_dumb[35] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[36] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[37] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[38] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[39] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[40] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[41] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[42] := (('+').code).to_natural_8
			terminal_inst.frame_dumb[43] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[44] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[45] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[46] := ((' ').code).to_natural_8
			terminal_inst.frame_dumb[47] := ((' ').code).to_natural_8
			terminal_inst.frame_vt100[0] := (('a').code).to_natural_8
			terminal_inst.frame_vt100[1] := (('a').code).to_natural_8
			terminal_inst.frame_vt100[2] := (('a').code).to_natural_8
			terminal_inst.frame_vt100[3] := (('x').code).to_natural_8
			terminal_inst.frame_vt100[4] := (('u').code).to_natural_8
			terminal_inst.frame_vt100[5] := (('u').code).to_natural_8
			terminal_inst.frame_vt100[6] := (('u').code).to_natural_8
			terminal_inst.frame_vt100[7] := (('k').code).to_natural_8
			terminal_inst.frame_vt100[8] := (('k').code).to_natural_8
			terminal_inst.frame_vt100[9] := (('u').code).to_natural_8
			terminal_inst.frame_vt100[10] := (('x').code).to_natural_8
			terminal_inst.frame_vt100[11] := (('k').code).to_natural_8
			terminal_inst.frame_vt100[12] := (('j').code).to_natural_8
			terminal_inst.frame_vt100[13] := (('j').code).to_natural_8
			terminal_inst.frame_vt100[14] := (('j').code).to_natural_8
			terminal_inst.frame_vt100[15] := (('k').code).to_natural_8
			terminal_inst.frame_vt100[16] := (('m').code).to_natural_8
			terminal_inst.frame_vt100[17] := (('v').code).to_natural_8
			terminal_inst.frame_vt100[18] := (('w').code).to_natural_8
			terminal_inst.frame_vt100[19] := (('t').code).to_natural_8
			terminal_inst.frame_vt100[20] := (('q').code).to_natural_8
			terminal_inst.frame_vt100[21] := (('n').code).to_natural_8
			terminal_inst.frame_vt100[22] := (('t').code).to_natural_8
			terminal_inst.frame_vt100[23] := (('t').code).to_natural_8
			terminal_inst.frame_vt100[24] := (('m').code).to_natural_8
			terminal_inst.frame_vt100[25] := (('l').code).to_natural_8
			terminal_inst.frame_vt100[26] := (('v').code).to_natural_8
			terminal_inst.frame_vt100[27] := (('w').code).to_natural_8
			terminal_inst.frame_vt100[28] := (('t').code).to_natural_8
			terminal_inst.frame_vt100[29] := (('q').code).to_natural_8
			terminal_inst.frame_vt100[30] := (('n').code).to_natural_8
			terminal_inst.frame_vt100[31] := (('v').code).to_natural_8
			terminal_inst.frame_vt100[32] := (('v').code).to_natural_8
			terminal_inst.frame_vt100[33] := (('w').code).to_natural_8
			terminal_inst.frame_vt100[34] := (('w').code).to_natural_8
			terminal_inst.frame_vt100[35] := (('m').code).to_natural_8
			terminal_inst.frame_vt100[36] := (('m').code).to_natural_8
			terminal_inst.frame_vt100[37] := (('l').code).to_natural_8
			terminal_inst.frame_vt100[38] := (('l').code).to_natural_8
			terminal_inst.frame_vt100[39] := (('n').code).to_natural_8
			terminal_inst.frame_vt100[40] := (('n').code).to_natural_8
			terminal_inst.frame_vt100[41] := (('j').code).to_natural_8
			terminal_inst.frame_vt100[42] := (('l').code).to_natural_8
			terminal_inst.frame_vt100[43] := (('a').code).to_natural_8
			terminal_inst.frame_vt100[44] := ((' ').code).to_natural_8
			terminal_inst.frame_vt100[45] := ((' ').code).to_natural_8
			terminal_inst.frame_vt100[46] := ((' ').code).to_natural_8
			terminal_inst.frame_vt100[47] := ((' ').code).to_natural_8
			terminal_inst.frame_koi[0] := (144).to_natural_8
			terminal_inst.frame_koi[1] := (145).to_natural_8
			terminal_inst.frame_koi[2] := (146).to_natural_8
			terminal_inst.frame_koi[3] := (129).to_natural_8
			terminal_inst.frame_koi[4] := (135).to_natural_8
			terminal_inst.frame_koi[5] := (178).to_natural_8
			terminal_inst.frame_koi[6] := (180).to_natural_8
			terminal_inst.frame_koi[7] := (167).to_natural_8
			terminal_inst.frame_koi[8] := (166).to_natural_8
			terminal_inst.frame_koi[9] := (181).to_natural_8
			terminal_inst.frame_koi[10] := (161).to_natural_8
			terminal_inst.frame_koi[11] := (168).to_natural_8
			terminal_inst.frame_koi[12] := (174).to_natural_8
			terminal_inst.frame_koi[13] := (173).to_natural_8
			terminal_inst.frame_koi[14] := (172).to_natural_8
			terminal_inst.frame_koi[15] := (131).to_natural_8
			terminal_inst.frame_koi[16] := (132).to_natural_8
			terminal_inst.frame_koi[17] := (137).to_natural_8
			terminal_inst.frame_koi[18] := (136).to_natural_8
			terminal_inst.frame_koi[19] := (134).to_natural_8
			terminal_inst.frame_koi[20] := (128).to_natural_8
			terminal_inst.frame_koi[21] := (138).to_natural_8
			terminal_inst.frame_koi[22] := (175).to_natural_8
			terminal_inst.frame_koi[23] := (176).to_natural_8
			terminal_inst.frame_koi[24] := (171).to_natural_8
			terminal_inst.frame_koi[25] := (165).to_natural_8
			terminal_inst.frame_koi[26] := (187).to_natural_8
			terminal_inst.frame_koi[27] := (184).to_natural_8
			terminal_inst.frame_koi[28] := (177).to_natural_8
			terminal_inst.frame_koi[29] := (160).to_natural_8
			terminal_inst.frame_koi[30] := (190).to_natural_8
			terminal_inst.frame_koi[31] := (185).to_natural_8
			terminal_inst.frame_koi[32] := (186).to_natural_8
			terminal_inst.frame_koi[33] := (182).to_natural_8
			terminal_inst.frame_koi[34] := (183).to_natural_8
			terminal_inst.frame_koi[35] := (170).to_natural_8
			terminal_inst.frame_koi[36] := (169).to_natural_8
			terminal_inst.frame_koi[37] := (162).to_natural_8
			terminal_inst.frame_koi[38] := (164).to_natural_8
			terminal_inst.frame_koi[39] := (189).to_natural_8
			terminal_inst.frame_koi[40] := (188).to_natural_8
			terminal_inst.frame_koi[41] := (133).to_natural_8
			terminal_inst.frame_koi[42] := (130).to_natural_8
			terminal_inst.frame_koi[43] := (141).to_natural_8
			terminal_inst.frame_koi[44] := (140).to_natural_8
			terminal_inst.frame_koi[45] := (142).to_natural_8
			terminal_inst.frame_koi[46] := (143).to_natural_8
			terminal_inst.frame_koi[47] := (139).to_natural_8
			terminal_inst.frame_freebsd[0] := (130).to_natural_8
			terminal_inst.frame_freebsd[1] := (138).to_natural_8
			terminal_inst.frame_freebsd[2] := (128).to_natural_8
			terminal_inst.frame_freebsd[3] := (153).to_natural_8
			terminal_inst.frame_freebsd[4] := (150).to_natural_8
			terminal_inst.frame_freebsd[5] := (150).to_natural_8
			terminal_inst.frame_freebsd[6] := (150).to_natural_8
			terminal_inst.frame_freebsd[7] := (140).to_natural_8
			terminal_inst.frame_freebsd[8] := (140).to_natural_8
			terminal_inst.frame_freebsd[9] := (150).to_natural_8
			terminal_inst.frame_freebsd[10] := (153).to_natural_8
			terminal_inst.frame_freebsd[11] := (140).to_natural_8
			terminal_inst.frame_freebsd[12] := (139).to_natural_8
			terminal_inst.frame_freebsd[13] := (139).to_natural_8
			terminal_inst.frame_freebsd[14] := (139).to_natural_8
			terminal_inst.frame_freebsd[15] := (140).to_natural_8
			terminal_inst.frame_freebsd[16] := (142).to_natural_8
			terminal_inst.frame_freebsd[17] := (151).to_natural_8
			terminal_inst.frame_freebsd[18] := (152).to_natural_8
			terminal_inst.frame_freebsd[19] := (149).to_natural_8
			terminal_inst.frame_freebsd[20] := (146).to_natural_8
			terminal_inst.frame_freebsd[21] := (143).to_natural_8
			terminal_inst.frame_freebsd[22] := (149).to_natural_8
			terminal_inst.frame_freebsd[23] := (149).to_natural_8
			terminal_inst.frame_freebsd[24] := (142).to_natural_8
			terminal_inst.frame_freebsd[25] := (141).to_natural_8
			terminal_inst.frame_freebsd[26] := (151).to_natural_8
			terminal_inst.frame_freebsd[27] := (152).to_natural_8
			terminal_inst.frame_freebsd[28] := (149).to_natural_8
			terminal_inst.frame_freebsd[29] := (146).to_natural_8
			terminal_inst.frame_freebsd[30] := (143).to_natural_8
			terminal_inst.frame_freebsd[31] := (151).to_natural_8
			terminal_inst.frame_freebsd[32] := (151).to_natural_8
			terminal_inst.frame_freebsd[33] := (152).to_natural_8
			terminal_inst.frame_freebsd[34] := (152).to_natural_8
			terminal_inst.frame_freebsd[35] := (142).to_natural_8
			terminal_inst.frame_freebsd[36] := (142).to_natural_8
			terminal_inst.frame_freebsd[37] := (141).to_natural_8
			terminal_inst.frame_freebsd[38] := (141).to_natural_8
			terminal_inst.frame_freebsd[39] := (143).to_natural_8
			terminal_inst.frame_freebsd[40] := (143).to_natural_8
			terminal_inst.frame_freebsd[41] := (139).to_natural_8
			terminal_inst.frame_freebsd[42] := (141).to_natural_8
			terminal_inst.frame_freebsd[43] := (128).to_natural_8
			terminal_inst.frame_freebsd[44] := (128).to_natural_8
			terminal_inst.frame_freebsd[45] := (128).to_natural_8
			terminal_inst.frame_freebsd[46] := (128).to_natural_8
			terminal_inst.frame_freebsd[47] := (128).to_natural_8
			terminal_inst.frame_restrict[0] := (0).to_natural_8
			terminal_inst.frame_restrict[1] := (0).to_natural_8
			terminal_inst.frame_restrict[2] := (0).to_natural_8
			terminal_inst.frame_restrict[3] := (0).to_natural_8
			terminal_inst.frame_restrict[4] := (0).to_natural_8
			terminal_inst.frame_restrict[5] := (179).to_natural_8
			terminal_inst.frame_restrict[6] := (186).to_natural_8
			terminal_inst.frame_restrict[7] := (186).to_natural_8
			terminal_inst.frame_restrict[8] := (205).to_natural_8
			terminal_inst.frame_restrict[9] := (0).to_natural_8
			terminal_inst.frame_restrict[10] := (0).to_natural_8
			terminal_inst.frame_restrict[11] := (0).to_natural_8
			terminal_inst.frame_restrict[12] := (0).to_natural_8
			terminal_inst.frame_restrict[13] := (186).to_natural_8
			terminal_inst.frame_restrict[14] := (205).to_natural_8
			terminal_inst.frame_restrict[15] := (0).to_natural_8
			terminal_inst.frame_restrict[16] := (0).to_natural_8
			terminal_inst.frame_restrict[17] := (0).to_natural_8
			terminal_inst.frame_restrict[18] := (0).to_natural_8
			terminal_inst.frame_restrict[19] := (0).to_natural_8
			terminal_inst.frame_restrict[20] := (0).to_natural_8
			terminal_inst.frame_restrict[21] := (0).to_natural_8
			terminal_inst.frame_restrict[22] := (179).to_natural_8
			terminal_inst.frame_restrict[23] := (186).to_natural_8
			terminal_inst.frame_restrict[24] := (0).to_natural_8
			terminal_inst.frame_restrict[25] := (0).to_natural_8
			terminal_inst.frame_restrict[26] := (0).to_natural_8
			terminal_inst.frame_restrict[27] := (0).to_natural_8
			terminal_inst.frame_restrict[28] := (0).to_natural_8
			terminal_inst.frame_restrict[29] := (0).to_natural_8
			terminal_inst.frame_restrict[30] := (0).to_natural_8
			terminal_inst.frame_restrict[31] := (205).to_natural_8
			terminal_inst.frame_restrict[32] := (196).to_natural_8
			terminal_inst.frame_restrict[33] := (205).to_natural_8
			terminal_inst.frame_restrict[34] := (196).to_natural_8
			terminal_inst.frame_restrict[35] := (186).to_natural_8
			terminal_inst.frame_restrict[36] := (205).to_natural_8
			terminal_inst.frame_restrict[37] := (205).to_natural_8
			terminal_inst.frame_restrict[38] := (186).to_natural_8
			terminal_inst.frame_restrict[39] := (186).to_natural_8
			terminal_inst.frame_restrict[40] := (179).to_natural_8
			terminal_inst.frame_restrict[41] := (0).to_natural_8
			terminal_inst.frame_restrict[42] := (0).to_natural_8
			terminal_inst.frame_restrict[43] := (0).to_natural_8
			terminal_inst.frame_restrict[44] := (0).to_natural_8
			terminal_inst.frame_restrict[45] := (0).to_natural_8
			terminal_inst.frame_restrict[46] := (0).to_natural_8
			terminal_inst.frame_restrict[47] := (0).to_natural_8
			terminal_inst.p1[0] := 218
			terminal_inst.p1[1] := 191
			terminal_inst.p1[2] := 192
			terminal_inst.p1[3] := 217
			terminal_inst.p1[4] := 179
			terminal_inst.p1[5] := 196
			terminal_inst.p2[0] := 201
			terminal_inst.p2[1] := 187
			terminal_inst.p2[2] := 200
			terminal_inst.p2[3] := 188
			terminal_inst.p2[4] := 186
			terminal_inst.p2[5] := 205
			types_inst.mailto_prog[0].next := create {CE_POINTER [ANY]}.make_cast (types_inst.mailto_prog)
			types_inst.mailto_prog[0].prev := create {CE_POINTER [ANY]}.make_cast (types_inst.mailto_prog)
			types_inst.telnet_prog[0].next := create {CE_POINTER [ANY]}.make_cast (types_inst.telnet_prog)
			types_inst.telnet_prog[0].prev := create {CE_POINTER [ANY]}.make_cast (types_inst.telnet_prog)
			types_inst.tn3270_prog[0].next := create {CE_POINTER [ANY]}.make_cast (types_inst.tn3270_prog)
			types_inst.tn3270_prog[0].prev := create {CE_POINTER [ANY]}.make_cast (types_inst.tn3270_prog)
			types_inst.mms_prog[0].next := create {CE_POINTER [ANY]}.make_cast (types_inst.mms_prog)
			types_inst.mms_prog[0].prev := create {CE_POINTER [ANY]}.make_cast (types_inst.mms_prog)
			types_inst.assoc[0].next := create {CE_POINTER [ANY]}.make_cast (types_inst.assoc)
			types_inst.assoc[0].prev := create {CE_POINTER [ANY]}.make_cast (types_inst.assoc)
			types_inst.assoc_cnt := (0).to_natural_32
			types_inst.extensions[0].next := create {CE_POINTER [ANY]}.make_cast (types_inst.extensions)
			types_inst.extensions[0].prev := create {CE_POINTER [ANY]}.make_cast (types_inst.extensions)
			types_inst.ct_msg[0] := links_inst.dummyarray + 190
			types_inst.ct_msg[1] := links_inst.dummyarray + 191
			types_inst.ct_msg[2] := links_inst.dummyarray + 192
			types_inst.ct_msg[3] := links_inst.dummyarray + 193
			types_inst.ct_msg[4] := links_inst.dummyarray + 194
			types_inst.ct_msg[5] := links_inst.dummyarray + 195
			types_inst.ct_msg[6] := links_inst.dummyarray + 196
			types_inst.mi_no_assoc[0].text := links_inst.dummyarray + 201
			types_inst.mi_no_assoc[0].rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			types_inst.mi_no_assoc[0].hotkey := bfu_inst.m_bar
			types_inst.mi_no_assoc[0].func := create {CE_ROUTINE}.make_shared (default_pointer)
			types_inst.mi_no_assoc[0].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			types_inst.mi_no_assoc[0].in_m := 0
			types_inst.mi_no_assoc[0].free_i := 0
			types_inst.mi_no_assoc[1].text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			types_inst.mi_no_assoc[1].rtext := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			types_inst.mi_no_assoc[1].hotkey := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			types_inst.mi_no_assoc[1].func := create {CE_ROUTINE}.make_shared (default_pointer)
			types_inst.mi_no_assoc[1].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			types_inst.mi_no_assoc[1].in_m := 0
			types_inst.mi_no_assoc[1].free_i := 0
			types_inst.ext_msg[0] := links_inst.dummyarray + 199
			types_inst.ext_msg[1] := links_inst.dummyarray + 200
			types_inst.mi_no_ext[0].text := links_inst.dummyarray + 204
			types_inst.mi_no_ext[0].rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			types_inst.mi_no_ext[0].hotkey := bfu_inst.m_bar
			types_inst.mi_no_ext[0].func := create {CE_ROUTINE}.make_shared (default_pointer)
			types_inst.mi_no_ext[0].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			types_inst.mi_no_ext[0].in_m := 0
			types_inst.mi_no_ext[0].free_i := 0
			types_inst.mi_no_ext[1].text := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			types_inst.mi_no_ext[1].rtext := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			types_inst.mi_no_ext[1].hotkey := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			types_inst.mi_no_ext[1].func := create {CE_ROUTINE}.make_shared (default_pointer)
			types_inst.mi_no_ext[1].data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			types_inst.mi_no_ext[1].in_m := 0
			types_inst.mi_no_ext[1].free_i := 0
			url_inst.protocols[0].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file"))
			url_inst.protocols[0].port := 0
			url_inst.protocols[0].func := file_inst.file_func_address
			url_inst.protocols[0].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[0].free_syntax := 1
			url_inst.protocols[0].need_slashes := 1
			url_inst.protocols[0].need_slash_after_host := 0
			url_inst.protocols[0].allow_post := 0
			url_inst.protocols[1].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("https"))
			url_inst.protocols[1].port := 443
			url_inst.protocols[1].func := https_inst.https_func_address
			url_inst.protocols[1].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[1].free_syntax := 0
			url_inst.protocols[1].need_slashes := 1
			url_inst.protocols[1].need_slash_after_host := 1
			url_inst.protocols[1].allow_post := 1
			url_inst.protocols[2].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http"))
			url_inst.protocols[2].port := 80
			url_inst.protocols[2].func := http_inst.http_func_address
			url_inst.protocols[2].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[2].free_syntax := 0
			url_inst.protocols[2].need_slashes := 1
			url_inst.protocols[2].need_slash_after_host := 1
			url_inst.protocols[2].allow_post := 1
			url_inst.protocols[3].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("proxy"))
			url_inst.protocols[3].port := 3_128
			url_inst.protocols[3].func := http_inst.proxy_func_address
			url_inst.protocols[3].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[3].free_syntax := 0
			url_inst.protocols[3].need_slashes := 1
			url_inst.protocols[3].need_slash_after_host := 1
			url_inst.protocols[3].allow_post := 1
			url_inst.protocols[4].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp"))
			url_inst.protocols[4].port := 21
			url_inst.protocols[4].func := ftp_inst.ftp_func_address
			url_inst.protocols[4].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[4].free_syntax := 0
			url_inst.protocols[4].need_slashes := 1
			url_inst.protocols[4].need_slash_after_host := 1
			url_inst.protocols[4].allow_post := 0
			url_inst.protocols[5].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("finger"))
			url_inst.protocols[5].port := 79
			url_inst.protocols[5].func := finger_inst.finger_func_address
			url_inst.protocols[5].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[5].free_syntax := 0
			url_inst.protocols[5].need_slashes := 1
			url_inst.protocols[5].need_slash_after_host := 1
			url_inst.protocols[5].allow_post := 0
			url_inst.protocols[6].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("smb"))
			url_inst.protocols[6].port := 139
			url_inst.protocols[6].func := smb_inst.smb_func_address
			url_inst.protocols[6].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[6].free_syntax := 0
			url_inst.protocols[6].need_slashes := 1
			url_inst.protocols[6].need_slash_after_host := 1
			url_inst.protocols[6].allow_post := 0
			url_inst.protocols[7].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mailto"))
			url_inst.protocols[7].port := 0
			url_inst.protocols[7].func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[7].nc_func := mailto_inst.mailto_func_address
			url_inst.protocols[7].free_syntax := 0
			url_inst.protocols[7].need_slashes := 0
			url_inst.protocols[7].need_slash_after_host := 0
			url_inst.protocols[7].allow_post := 0
			url_inst.protocols[8].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("telnet"))
			url_inst.protocols[8].port := 0
			url_inst.protocols[8].func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[8].nc_func := mailto_inst.telnet_func_address
			url_inst.protocols[8].free_syntax := 0
			url_inst.protocols[8].need_slashes := 0
			url_inst.protocols[8].need_slash_after_host := 0
			url_inst.protocols[8].allow_post := 0
			url_inst.protocols[9].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tn3270"))
			url_inst.protocols[9].port := 0
			url_inst.protocols[9].func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[9].nc_func := mailto_inst.tn3270_func_address
			url_inst.protocols[9].free_syntax := 0
			url_inst.protocols[9].need_slashes := 0
			url_inst.protocols[9].need_slash_after_host := 0
			url_inst.protocols[9].allow_post := 0
			url_inst.protocols[10].prot := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mms"))
			url_inst.protocols[10].port := 0
			url_inst.protocols[10].func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[10].nc_func := mailto_inst.mms_func_address
			url_inst.protocols[10].free_syntax := 1
			url_inst.protocols[10].need_slashes := 0
			url_inst.protocols[10].need_slash_after_host := 1
			url_inst.protocols[10].allow_post := 0
			url_inst.protocols[11].prot := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			url_inst.protocols[11].port := 0
			url_inst.protocols[11].func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[11].nc_func := create {CE_ROUTINE}.make_shared (default_pointer)
			url_inst.protocols[11].free_syntax := 0
			url_inst.protocols[11].need_slashes := 0
			url_inst.protocols[11].need_slash_after_host := 0
			url_inst.protocols[11].allow_post := 0;
			(view_inst.fr_trans[0])[0] := (179).to_natural_8;
			(view_inst.fr_trans[0])[1] := (195).to_natural_8;
			(view_inst.fr_trans[0])[2] := (180).to_natural_8;
			(view_inst.fr_trans[0])[3] := (197).to_natural_8;
			(view_inst.fr_trans[1])[0] := (196).to_natural_8;
			(view_inst.fr_trans[1])[1] := (194).to_natural_8;
			(view_inst.fr_trans[1])[2] := (193).to_natural_8;
			(view_inst.fr_trans[1])[3] := (197).to_natural_8
			across "%NLinks:%N%/0/" as c loop view_inst.head[c.target_index - 1] := c.item.code.to_integer_8 end
			view_inst.init___0 := (0).to_integer_8
		end

end
