class
	P_MENU

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create assoc_menu.make (<<4>>)
			create cache_texts.make (<<2>>)
			create doc_str.make (<<4>>)
			create ext_menu.make (<<4>>)
			create file_history.make (<<1>>)
			create file_menu11.make (<<4>>)
			create file_menu12.make (<<2>>)
			create file_menu21.make (<<4>>)
			create file_menu22.make (<<6>>)
			create file_menu3.make (<<3>>)
			create ftp_texts.make (<<5>>)
			create goto_url_history.make (<<1>>)
			create help_menu.make (<<5>>)
			create html_texts.make (<<8>>)
			create http_labels.make (<<5>>)
			create main_menu.make (<<7>>)
			create marg_str.make (<<2>>)
			create max_c_str.make (<<3>>)
			create max_cth_str.make (<<3>>)
			create max_t_str.make (<<3>>)
			create mc_str.make (<<8>>)
			create net_msg.make (<<11>>)
			create no_downloads_menu.make (<<2>>)
			create no_hist_menu.make (<<2>>)
			create prg_msg.make (<<5>>)
			create resize_texts.make (<<2>>)
			create search_history.make (<<1>>)
			create setup_menu.make (<<11>>)
			create setup_menu_anon.make (<<4>>)
			create td_labels.make (<<10>>)
			create time_str.make (<<5>>)
			create unrtime_str.make (<<5>>)
			create view_menu.make (<<13>>)
			create view_menu_anon.make (<<11>>)
			create x_str.make (<<4>>)
			create y_str.make (<<4>>)
		end

feature {ANY} -- attributes

	assoc_menu: CE_ARRAY [PD_MENU_ITEM]

	cache_texts: CE_ARRAY [CE_POINTER [NATURAL_8]]

	doc_str: CE_ARRAY [NATURAL_8]

	ext_menu: CE_ARRAY [PD_MENU_ITEM]

	file_history: CE_ARRAY [PD_HISTORY]

	file_menu11: CE_ARRAY [PD_MENU_ITEM]

	file_menu12: CE_ARRAY [PD_MENU_ITEM]

	file_menu21: CE_ARRAY [PD_MENU_ITEM]

	file_menu22: CE_ARRAY [PD_MENU_ITEM]

	file_menu3: CE_ARRAY [PD_MENU_ITEM]

	ftp_texts: CE_ARRAY [CE_POINTER [NATURAL_8]]

	goto_url_history: CE_ARRAY [PD_HISTORY]

	help_menu: CE_ARRAY [PD_MENU_ITEM]

	html_texts: CE_ARRAY [CE_POINTER [NATURAL_8]]

	http_labels: CE_ARRAY [CE_POINTER [NATURAL_8]]

	main_menu: CE_ARRAY [PD_MENU_ITEM]

	marg_str: CE_ARRAY [NATURAL_8]

	max_c_str: CE_ARRAY [NATURAL_8]

	max_cth_str: CE_ARRAY [NATURAL_8]

	max_t_str: CE_ARRAY [NATURAL_8]

	mc_str: CE_ARRAY [NATURAL_8]

	net_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

	no_downloads_menu: CE_ARRAY [PD_MENU_ITEM]

	no_hist_menu: CE_ARRAY [PD_MENU_ITEM]

	prg_msg: CE_ARRAY [CE_POINTER [NATURAL_8]]

	resize_texts: CE_ARRAY [CE_POINTER [NATURAL_8]]

	search_history: CE_ARRAY [PD_HISTORY]

	setup_menu: CE_ARRAY [PD_MENU_ITEM]

	setup_menu_anon: CE_ARRAY [PD_MENU_ITEM]

	td_labels: CE_ARRAY [CE_POINTER [NATURAL_8]]

	time_str: CE_ARRAY [NATURAL_8]

	unrtime_str: CE_ARRAY [NATURAL_8]

	view_menu: CE_ARRAY [PD_MENU_ITEM]

	view_menu_anon: CE_ARRAY [PD_MENU_ITEM]

	x_str: CE_ARRAY [NATURAL_8]

	y_str: CE_ARRAY [NATURAL_8]

feature {ANY} -- routines

	activate_bfu_technology (a_ses: CE_POINTER [PD_SESSION]; a_item: INTEGER_32)
		local
			l_term: CE_POINTER [PD_TERMINAL]
		do
			create l_term.make

			l_term := a_ses.item.term
			bfu_inst.do_mainmenu (l_term, main_menu, create {CE_POINTER [ANY]}.make_cast (a_ses), a_item)
		end

	assumed_codepage (a_term: CE_POINTER [PD_TERMINAL]; a_pcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_cp: INTEGER_32
		do
			l_cp := (a_pcp.c_pointer.to_integer_32).to_integer_32
			a_ses.item.ds.assume_cp := l_cp
			terminal_inst.redraw_terminal_cls (a_term)
		end

	cache_inf (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_a1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a2: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a3: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a4: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a5: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a6: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a7: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a8: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a9: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a10: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a11: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a12: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a13: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a14: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a15: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_a16: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_r: CE_POINTER [PD_REFRESH]
		do
			create l_a1.make (<<1>>)
			create l_a2.make (<<1>>)
			create l_a3.make (<<1>>)
			create l_a4.make (<<1>>)
			create l_a5.make (<<1>>)
			create l_a6.make (<<1>>)
			create l_a7.make (<<1>>)
			create l_a8.make (<<1>>)
			create l_a9.make (<<1>>)
			create l_a10.make (<<1>>)
			create l_a11.make (<<1>>)
			create l_a12.make (<<1>>)
			create l_a13.make (<<1>>)
			create l_a14.make (<<1>>)
			create l_a15.make (<<1>>)
			create l_a16.make (<<1>>)
			create l_l.make (<<1>>)
			create l_r.make

			l_l.item := 0
			l_r := create {CE_POINTER [PD_REFRESH]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 120, (create {PD_REFRESH}.make).structure_size.to_natural_32)))
			l_r.item.term := a_term
			l_r.item.win := create {CE_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			l_r.item.ses := a_ses
			l_r.item.fn := cache_inf_address
			l_r.item.data := a_d
			l_r.item.timer := -1
			l_l.item := 0
			l_l.item := 0
			l_a1.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 128)
			links_inst.add_to_str (l_a1, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
			links_inst.add_num_to_str (l_a1, l_l, (select_inst.select_info (2)))
			links_inst.add_to_str (l_a1, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a2.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 129)
			links_inst.add_to_str (l_a2, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a2, l_l, (select_inst.select_info (5)))
			links_inst.add_to_str (l_a2, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a3.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 130)
			links_inst.add_to_str (l_a3, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".%N")))
			l_l.item := 0
			l_a4.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 132)
			links_inst.add_to_str (l_a4, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
			links_inst.add_num_to_str (l_a4, l_l, (sched_inst.connect_info (2)))
			links_inst.add_to_str (l_a4, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a5.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 133)
			links_inst.add_to_str (l_a5, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a5, l_l, (sched_inst.connect_info (7)))
			links_inst.add_to_str (l_a5, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a6.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 134)
			links_inst.add_to_str (l_a6, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a6, l_l, (sched_inst.connect_info (6)))
			links_inst.add_to_str (l_a6, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a7.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 135)
			links_inst.add_to_str (l_a7, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a7, l_l, (sched_inst.connect_info (8)))
			links_inst.add_to_str (l_a7, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a8.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 136)
			links_inst.add_to_str (l_a8, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".%N")))
			l_l.item := 0
			l_a9.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 138)
			links_inst.add_to_str (l_a9, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
			links_inst.add_num_to_str (l_a9, l_l, (cache_inst.cache_info (1)))
			links_inst.add_to_str (l_a9, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a10.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 139)
			links_inst.add_to_str (l_a10, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a10, l_l, (cache_inst.cache_info (2)))
			links_inst.add_to_str (l_a10, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a11.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 140)
			links_inst.add_to_str (l_a11, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a11, l_l, (cache_inst.cache_info (3)))
			links_inst.add_to_str (l_a11, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a12.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 141)
			links_inst.add_to_str (l_a12, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a12, l_l, (cache_inst.cache_info (4)))
			links_inst.add_to_str (l_a12, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a13.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 142)
			links_inst.add_to_str (l_a13, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".%N")))
			l_l.item := 0
			l_a14.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 144)
			links_inst.add_to_str (l_a14, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (": ")))
			links_inst.add_num_to_str (l_a14, l_l, (html_r_inst.formatted_info (2)))
			links_inst.add_to_str (l_a14, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a15.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 145)
			links_inst.add_to_str (l_a15, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (", ")))
			links_inst.add_num_to_str (l_a15, l_l, (html_r_inst.formatted_info (3)))
			links_inst.add_to_str (l_a15, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
			l_l.item := 0
			l_a16.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 146)
			links_inst.add_to_str (l_a16, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".")))
			bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_a1.item), l_a2.item, l_a3.item, l_a4.item, l_a5.item, l_a6.item, l_a7.item, l_a8.item, l_a9.item, l_a10.item, l_a11.item, l_a12.item, l_a13.item, l_a14.item, l_a15.item, l_a16.item, create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 19, 128, links_inst.dummyarray + 19, l_a1.item, links_inst.dummyarray + 20, l_a2.item, links_inst.dummyarray + 21, l_a3.item, links_inst.dummyarray + 22, l_a4.item, links_inst.dummyarray + 23, l_a5.item, links_inst.dummyarray + 24, l_a6.item, links_inst.dummyarray + 25, l_a7.item, links_inst.dummyarray + 26, l_a8.item, links_inst.dummyarray + 27, l_a9.item, links_inst.dummyarray + 28, l_a10.item, links_inst.dummyarray + 29, l_a11.item, links_inst.dummyarray + 30, l_a12.item, links_inst.dummyarray + 31, l_a13.item, links_inst.dummyarray + 32, l_a14.item, links_inst.dummyarray + 33, l_a15.item, links_inst.dummyarray + 30, l_a16.item, create {CE_POINTER [ANY]}.make_shared (default_pointer), l_r, 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
			l_r.item.win := create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next);
			((create {CE_POINTER [PD_DIALOG_DATA]}.make_cast ((l_r.item.win).item.data)).item.dlg).item.abort := refresh_abort_address
			l_r.item.timer := select_inst.install_timer ((100).to_integer_32, (refresh_address), create {CE_POINTER [ANY]}.make_cast (l_r))
		end

	cache_inf_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cache_inf)
		end

	cache_opt (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_yyy: CE_POINTER [ANY])
		local
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_d.make

			links_inst.snprint (mc_str, 8, default_inst.memory_cache_size.item // 1_024).do_nothing
			links_inst.snprint (doc_str, 4, (default_inst.max_format_cache_entries.item).to_integer_32).do_nothing
			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 846, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 70
			l_d.item.fn := bfu_inst.group_fn_address
			l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (cache_texts)
			l_d.item.refresh := cache_refresh_address
			l_d.item.items[0].type := 2
			l_d.item.items[0].dlen := 8
			l_d.item.items[0].data := mc_str
			l_d.item.items[0].fn := bfu_inst.check_number_address
			l_d.item.items[0].gid := 0
			l_d.item.items[0].gnum := 2_147_483_647
			l_d.item.items[1].type := 2
			l_d.item.items[1].dlen := 4
			l_d.item.items[1].data := doc_str
			l_d.item.items[1].fn := bfu_inst.check_number_address
			l_d.item.items[1].gid := 0
			l_d.item.items[1].gnum := 256
			l_d.item.items[2].type := 4
			l_d.item.items[2].gid := 1
			l_d.item.items[2].fn := bfu_inst.ok_dialog_address
			l_d.item.items[2].text := links_inst.dummyarray + 14
			l_d.item.items[3].type := 4
			l_d.item.items[3].gid := 2
			l_d.item.items[3].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[3].text := links_inst.dummyarray + 6
			l_d.item.items[4].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

	cache_opt_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cache_opt)
		end

	cache_refresh (a_xxx: CE_POINTER [ANY])
		do
			default_inst.memory_cache_size.item := ((atoi (create {CE_POINTER [INTEGER_8]}.make_cast (mc_str))) * 1_024).to_integer_32
			default_inst.max_format_cache_entries.item := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (doc_str))
			html_r_inst.count_format_cache
			main_inst.shrink_memory (0)
		end

	cache_refresh_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent cache_refresh)
		end

	charset_list (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_i: INTEGER_32
			l_sel: INTEGER_32
			l_n: CE_POINTER [NATURAL_8]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			js: JUMP_STATE
		do
			create l_n.make
			create l_mi.make (<<1>>)

			l_mi.item := bfu_inst.new_menu (1)
			if (l_mi.item).is_void then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					js.loop_done
				loop
					l_n := charsets_inst.get_cp_name (l_i)
					if l_n.is_void then
						js.break
					end
					if not js.loop_jumped then
						if (charsets_inst.is_cp_special (l_i)).to_boolean then
							js.continue
						end
					end
					if not js.loop_jumped then
						bfu_inst.add_to_menu (l_mi, (charsets_inst.get_cp_name (l_i)), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), (display_codepage_address), create {CE_POINTER [ANY]}.make_shared (default_pointer + l_i), 0)
					end
					if js.loop_increment then
						l_i := l_i + 1
					end
				end
				l_sel := ((a_ses.item.term).item.spec).item.charset
				if l_sel < 0 then
					l_sel := 0
				end
				bfu_inst.do_menu_selected (a_term, l_mi.item, create {CE_POINTER [ANY]}.make_cast (a_ses), l_sel)
			end
		end

	charset_list_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent charset_list)
		end

	charset_sel_list (a_term: CE_POINTER [PD_TERMINAL]; a_ses: CE_POINTER [PD_SESSION]; a_ptr: CE_POINTER [INTEGER_32])
		local
			l_i: INTEGER_32
			l_sel: INTEGER_32
			l_n: CE_POINTER [NATURAL_8]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			js: JUMP_STATE
		do
			create l_n.make
			create l_mi.make (<<1>>)

			l_mi.item := bfu_inst.new_menu (1)
			if (l_mi.item).is_void then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					js.loop_done
				loop
					l_n := charsets_inst.get_cp_name (l_i)
					if l_n.is_void then
						js.break
					end
					if not js.loop_jumped then
						bfu_inst.add_to_menu (l_mi, (charsets_inst.get_cp_name (l_i)), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), (set_val_address), create {CE_POINTER [ANY]}.make_shared (default_pointer + l_i), 0)
						l_i := l_i + 1
					end
				end
				l_sel := a_ptr.item
				if l_sel < 0 then
					l_sel := 0
				end
				bfu_inst.do_menu_selected (a_term, l_mi.item, create {CE_POINTER [ANY]}.make_cast (a_ptr), l_sel)
			end
		end

	dialog_goto_url (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [INTEGER_8])
		do
			bfu_inst.input_field (a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 80, links_inst.dummyarray + 115, links_inst.dummyarray + 14, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_cast (a_ses), goto_url_history, 4_096, create {CE_POINTER [NATURAL_8]}.make_cast (a_url), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (session_inst.goto_url_address), create {CE_ROUTINE}.make_shared (default_pointer))
		end

	dialog_save_url (a_ses: CE_POINTER [PD_SESSION])
		do
			bfu_inst.input_field (a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 116, links_inst.dummyarray + 115, links_inst.dummyarray + 14, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_cast (a_ses), goto_url_history, 4_096, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (view_inst.save_url_address), create {CE_ROUTINE}.make_shared (default_pointer))
		end

	display_codepage (a_term: CE_POINTER [PD_TERMINAL]; a_pcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_cp: INTEGER_32
			l_t: CE_POINTER [PD_TERM_SPEC]
		do
			create l_t.make

			l_cp := (a_pcp.c_pointer.to_integer_32).to_integer_32
			l_t := (terminal_inst.new_term_spec (a_term.item.term))
			if (not l_t.is_void) then
				l_t.item.charset := l_cp
			end
			terminal_inst.cls_redraw_all_terminals
		end

	display_codepage_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent display_codepage)
		end

	dlg_assume_cp (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		do
			charset_sel_list ((a_dlg.item.win).item.term, create {CE_POINTER [PD_SESSION]}.make_cast ((a_dlg.item.dlg).item.udata2), create {CE_POINTER [INTEGER_32]}.make_cast (a_di.item.cdata))
			Result := 0
		end

	dlg_assume_cp_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dlg_assume_cp)
		end

	dlg_ftp_options (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_a: INTEGER_32
			l_ftp_options___0: CE_POINTER [PD_FTP_OPTIONS]
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_ftp_options___0.make
			create l_d.make

			l_ftp_options___0 := create {CE_POINTER [PD_FTP_OPTIONS]}.make_cast (a_di.item.cdata)
			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 537, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 278
			l_d.item.fn := ftpopt_fn_address
			l_d.item.items[0].type := 2
			l_d.item.items[0].dlen := 1_024
			l_d.item.items[0].data := l_ftp_options___0.item.anon_pass
			l_d.item.items[1].type := 1
			l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[1].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ftp_options___0.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("passive_ftp"))))
			l_d.item.items[1].gid := 0
			l_d.item.items[2].type := 1
			l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[2].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ftp_options___0.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("fast_ftp"))))
			l_d.item.items[3].type := 1
			l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[3].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ftp_options___0.c_pointer + (create {PD_FTP_OPTIONS}.make).offset_of ("set_tos"))))
			l_a := 4
			l_d.item.items[l_a].type := 4
			l_d.item.items[l_a].gid := 1
			l_d.item.items[l_a].fn := bfu_inst.ok_dialog_address
			l_d.item.items[l_a].text := links_inst.dummyarray + 14
			l_a := l_a + 1
			l_d.item.items[l_a].type := 4
			l_d.item.items[l_a].gid := 2
			l_d.item.items[l_a].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[l_a].text := links_inst.dummyarray + 6
			l_a := l_a + 1
			l_d.item.items[l_a].type := 0
			bfu_inst.do_dialog ((a_dlg.item.win).item.term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
			Result := 0
		end

	dlg_ftp_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dlg_ftp_options)
		end

	dlg_http_options (a_dlg: CE_POINTER [PD_DIALOG_DATA]; a_di: CE_POINTER [PD_DIALOG_ITEM_DATA]): INTEGER_32
		local
			l_bugs: CE_POINTER [PD_HTTP_BUGS]
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_bugs.make
			create l_d.make

			l_bugs := create {CE_POINTER [PD_HTTP_BUGS]}.make_cast (a_di.item.cdata)
			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 454, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 8 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 8 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 279
			l_d.item.fn := bfu_inst.checkbox_list_fn_address
			l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (http_labels)
			l_d.item.items[0].type := 1
			l_d.item.items[0].gid := 0
			l_d.item.items[0].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[0].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("http10"))))
			l_d.item.items[1].type := 1
			l_d.item.items[1].gid := 0
			l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[1].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("allow_blacklist"))))
			l_d.item.items[2].type := 1
			l_d.item.items[2].gid := 0
			l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[2].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("bug_302_redirect"))))
			l_d.item.items[3].type := 1
			l_d.item.items[3].gid := 0
			l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[3].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("bug_post_no_keepalive"))))
			l_d.item.items[4].type := 1
			l_d.item.items[4].gid := 0
			l_d.item.items[4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[4].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_bugs.c_pointer + (create {PD_HTTP_BUGS}.make).offset_of ("no_accept_charset"))))
			l_d.item.items[5].type := 4
			l_d.item.items[5].gid := 1
			l_d.item.items[5].fn := bfu_inst.ok_dialog_address
			l_d.item.items[5].text := links_inst.dummyarray + 14
			l_d.item.items[6].type := 4
			l_d.item.items[6].gid := 2
			l_d.item.items[6].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[6].text := links_inst.dummyarray + 6
			l_d.item.items[7].type := 0
			bfu_inst.do_dialog ((a_dlg.item.win).item.term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
			Result := 0
		end

	dlg_http_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dlg_http_options)
		end

	dlg_resize_terminal (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_x: INTEGER_32
			l_tmp: INTEGER_32
			l_y: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			create l_d.make

			if a_term.item.x > 999 then
				l_tmp := 999
			else
				l_tmp := a_term.item.x
			end
			l_x := l_tmp
			if a_term.item.y > 999 then
				l_tmp___0 := 999
			else
				l_tmp___0 := a_term.item.y
			end
			l_y := l_tmp___0
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (x_str), ce_string ("%%d"), l_x]).do_nothing
			sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (y_str), ce_string ("%%d"), l_y]).do_nothing
			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_009, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 5 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 260
			l_d.item.fn := bfu_inst.group_fn_address
			l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (resize_texts)
			l_d.item.refresh := (do_resize_terminal_address)
			l_d.item.refresh_data := create {CE_POINTER [ANY]}.make_cast (a_term)
			l_d.item.items[0].type := 2
			l_d.item.items[0].dlen := 4
			l_d.item.items[0].data := x_str
			l_d.item.items[0].fn := bfu_inst.check_number_address
			l_d.item.items[0].gid := 1
			l_d.item.items[0].gnum := 999
			l_d.item.items[1].type := 2
			l_d.item.items[1].dlen := 4
			l_d.item.items[1].data := y_str
			l_d.item.items[1].fn := bfu_inst.check_number_address
			l_d.item.items[1].gid := 1
			l_d.item.items[1].gnum := 999
			l_d.item.items[2].type := 4
			l_d.item.items[2].gid := 1
			l_d.item.items[2].fn := bfu_inst.ok_dialog_address
			l_d.item.items[2].text := links_inst.dummyarray + 14
			l_d.item.items[3].type := 4
			l_d.item.items[3].gid := 2
			l_d.item.items[3].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[3].text := links_inst.dummyarray + 6
			l_d.item.items[4].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

	dlg_resize_terminal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dlg_resize_terminal)
		end

	do_file_menu (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_x: INTEGER_32
			l_o: INTEGER_32
			l_file_menu: CE_POINTER [PD_MENU_ITEM]
			l_e: CE_POINTER [PD_MENU_ITEM]
			l_f: CE_POINTER [PD_MENU_ITEM]
		do
			create l_file_menu.make
			create l_e.make
			create l_f.make

			l_file_menu := create {CE_POINTER [PD_MENU_ITEM]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_085, ((((((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (2).to_natural_32)) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32)) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (6).to_natural_32)) + ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32)) + {NATURAL_32} 3 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32)))
			l_e := l_file_menu
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_e), create {CE_POINTER [ANY]}.make_cast (file_menu11), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32)).do_nothing
			l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			if not default_inst.anonymous.to_boolean then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_e), create {CE_POINTER [ANY]}.make_cast (file_menu12), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (2).to_natural_32)).do_nothing
				l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (2).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			end
			l_o := view_inst.can_open_in_new (a_term)
			if l_o.to_boolean then
				l_e.item.text := links_inst.dummyarray + 257
				if (l_o - 1).to_boolean then
					l_e.item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (">"))
				else
					l_e.item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
				end
				l_e.item.hotkey := links_inst.dummyarray + 377
				l_e.item.func := (view_inst.open_in_new_window_address)
				l_e.item.data := create {CE_POINTER [ANY]}.make_cast ((view_inst.send_open_new_xterm_address))
				l_e.item.in_m := l_o - 1
				l_e.item.free_i := 0
				l_e := l_e + 1
			end
			if not default_inst.anonymous.to_boolean then
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_e), create {CE_POINTER [ANY]}.make_cast (file_menu21), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32)).do_nothing
				l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (4).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_e), create {CE_POINTER [ANY]}.make_cast (file_menu22), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (6).to_natural_32)).do_nothing
			l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (6).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			l_x := 1
			if not default_inst.anonymous.to_boolean then
				if (os_dep_inst.can_open_os_shell (a_term.item.environment)).to_boolean then
					l_e.item.text := links_inst.dummyarray + 90
					l_e.item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
					l_e.item.hotkey := links_inst.dummyarray + 327
					l_e.item.func := menu_shell_address
					l_e.item.data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
					l_e.item.in_m := 0
					l_e.item.free_i := 0
					l_e := l_e + 1
					l_x := 0
				end
			end
			if (os_dep_inst.can_resize_window (a_term.item.environment)).to_boolean then
				l_e.item.text := links_inst.dummyarray + 260
				l_e.item.rtext := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
				l_e.item.hotkey := links_inst.dummyarray + 328
				l_e.item.func := (dlg_resize_terminal_address)
				l_e.item.data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
				l_e.item.in_m := 0
				l_e.item.free_i := 0
				l_e := l_e + 1
				l_x := 0
			end
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_e), create {CE_POINTER [ANY]}.make_cast ((file_menu3 + l_x)), ((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32) - l_x.to_natural_32 * (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_e := l_e + (((create {PD_MENU_ITEM}.make).structure_size.to_natural_32 * (3).to_natural_32) // (create {PD_MENU_ITEM}.make).structure_size.to_natural_32).to_integer_32
			l_f := l_file_menu
			from
			until
				not ((l_f.c_pointer.to_integer_32).to_natural_32 < (l_e.c_pointer.to_integer_32).to_natural_32)
			loop
				l_f.item.free_i := 1
				l_f := l_f + 1
			end
			bfu_inst.do_menu (a_term, l_file_menu, create {CE_POINTER [ANY]}.make_cast (a_ses))
		end

	do_file_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_file_menu)
		end

	do_resize_terminal (a_term: CE_POINTER [PD_TERMINAL])
		local
			l_str: CE_ARRAY [NATURAL_8]
		do
			create l_str.make (<<8>>)

			strcpy (create {CE_POINTER [INTEGER_8]}.make_cast (l_str), create {CE_POINTER [INTEGER_8]}.make_cast (x_str)).do_nothing
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_str), ce_string (",")).do_nothing
			strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_str), create {CE_POINTER [INTEGER_8]}.make_cast (y_str)).do_nothing
			terminal_inst.do_terminal_function (a_term, (2).to_natural_8, l_str)
		end

	do_resize_terminal_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_resize_terminal)
		end

	do_setup_menu (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			if not default_inst.anonymous.to_boolean then
				bfu_inst.do_menu (a_term, setup_menu, create {CE_POINTER [ANY]}.make_cast (a_ses))
			else
				bfu_inst.do_menu (a_term, setup_menu_anon, create {CE_POINTER [ANY]}.make_cast (a_ses))
			end
		end

	do_setup_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_setup_menu)
		end

	do_view_menu (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			if not default_inst.anonymous.to_boolean then
				bfu_inst.do_menu (a_term, view_menu, create {CE_POINTER [ANY]}.make_cast (a_ses))
			else
				bfu_inst.do_menu (a_term, view_menu_anon, create {CE_POINTER [ANY]}.make_cast (a_ses))
			end
		end

	do_view_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent do_view_menu)
		end

	dont_exit_prog (a_ses: CE_POINTER [PD_SESSION])
		do
			a_ses.item.exit_query := 0
		end

	dont_exit_prog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent dont_exit_prog)
		end

	downloads_menu (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DOWNLOAD]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_n: INTEGER_32
			l_u: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_d.make
			create l_mi.make (<<1>>)
			create l_u.make

			l_mi.item := create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer)
			l_n := 0
			l_d := create {CE_POINTER [PD_DOWNLOAD]}.make_cast (session_inst.downloads.item.prev)
			from
			until
				not (not js.loop_done and then (not l_d.is_equal (session_inst.downloads)))
			loop
				if (l_mi.item).is_void then
					l_mi.item := bfu_inst.new_menu (3)
					if (l_mi.item).is_void then
						js.return
					end
				end
				if not js.return_called then
					l_u := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 304, l_d.item.url)
					if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), 1)).is_void) then
						(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_u), 1))[0] := (0).to_integer_8
					end
					bfu_inst.add_to_menu (l_mi, l_u, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), (session_inst.display_download_address), create {CE_POINTER [ANY]}.make_cast (l_d), 0)
					l_n := l_n + 1
					l_d := l_d.item.prev
				end
			end
			if not js.return_called then
				if not l_n.to_boolean then
					bfu_inst.do_menu (a_term, no_downloads_menu, create {CE_POINTER [ANY]}.make_cast (a_ses))
				else
					bfu_inst.do_menu (a_term, l_mi.item, create {CE_POINTER [ANY]}.make_cast (a_ses))
				end
			end
		end

	downloads_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent downloads_menu)
		end

	end_refresh (a_r: CE_POINTER [PD_REFRESH])
		do
			if a_r.item.timer /= -1 then
				select_inst.kill_timer (a_r.item.timer)
			end
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 107, create {CE_POINTER [ANY]}.make_cast (a_r))
		end

	end_refresh_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent end_refresh)
		end

	exit_prog (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			js: JUMP_STATE
		do
			if a_ses.is_void then
				select_inst.register_bottom_half ((terminal_inst.destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_term)).do_nothing
				js.return
			end
			if not js.return_called and then (not (a_ses.item.exit_query).to_boolean) then
				if a_d.is_void then
					query_exit (a_ses)
					js.return
				elseif (a_term.item.next).is_equal (a_term.item.prev) then
					if (session_inst.are_there_downloads).to_boolean then
						query_exit (a_ses)
						js.return
					end
				end
			end
			if not js.return_called then
				really_exit_prog (a_ses)
			end
		end

	exit_prog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent exit_prog)
		end

	flush_caches (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_e: CE_POINTER [ANY])
		do
			main_inst.shrink_memory (1)
		end

	flush_caches_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent flush_caches)
		end

	free_history_lists
		local
			l_a__: CE_POINTER [PD_XLIST_HEAD]
			l_a_____0: CE_POINTER [PD_XLIST_HEAD]
			l_a_____1: CE_POINTER [PD_XLIST_HEAD]
		do
			create l_a__.make
			create l_a_____0.make
			create l_a_____1.make

			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (goto_url_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (goto_url_history.item.items.next)
			from
			until
				l_a__.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (goto_url_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.next
			end
			l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (goto_url_history.item.items.prev)
			from
			until
				l_a__.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (goto_url_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				l_a__ := l_a__.item.prev
			end
			from
			until
				(goto_url_history.item.items.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (goto_url_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				l_a__ := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (goto_url_history.item.items.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a__.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a__.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a__.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a__))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_284, create {CE_POINTER [ANY]}.make_cast (l_a__))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (goto_url_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (file_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
			l_a_____0 := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (file_history.item.items.next)
			from
			until
				l_a_____0.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (file_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				l_a_____0 := l_a_____0.item.next
			end
			l_a_____0 := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (file_history.item.items.prev)
			from
			until
				l_a_____0.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (file_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				l_a_____0 := l_a_____0.item.prev
			end
			from
			until
				(file_history.item.items.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (file_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				l_a_____0 := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (file_history.item.items.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____0.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____0.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____0))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_285, create {CE_POINTER [ANY]}.make_cast (l_a_____0))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (file_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (search_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
			l_a_____1 := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (search_history.item.items.next)
			from
			until
				l_a_____1.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (search_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
				l_a_____1 := l_a_____1.item.next
			end
			l_a_____1 := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (search_history.item.items.prev)
			from
			until
				l_a_____1.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (search_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
				l_a_____1 := l_a_____1.item.prev
			end
			from
			until
				(search_history.item.items.next).is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (search_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))
			loop
				l_a_____1 := create {CE_POINTER [PD_XLIST_HEAD]}.make_cast (search_history.item.items.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1));
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.next)).item.prev := create {CE_POINTER [ANY]}.make_cast (l_a_____1.item.prev);
				(create {CE_POINTER [PD_LIST_HEAD]}.make_cast (l_a_____1.item.prev)).item.next := create {CE_POINTER [ANY]}.make_cast (l_a_____1.item.next)
				error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast (l_a_____1))
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_286, create {CE_POINTER [ANY]}.make_cast (l_a_____1))
			end
			error_inst.do_not_optimize_here (create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_LIST_HEAD]}.make_shared (search_history.item.c_pointer + (create {PD_HISTORY}.make).offset_of ("items")))))
		end

	ftpopt_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create l_term.make
			create l_max.make (<<1>>)
			create l_min.make (<<1>>)
			create l_rw.make (<<1>>)
			create l_y.make (<<1>>)

			l_term := (a_dlg.item.win).item.term
			l_max.item := 0
			l_min.item := 0
			l_y.item := 0
			bfu_inst.max_text_width (l_term, ftp_texts[0], l_max)
			bfu_inst.min_text_width (l_term, ftp_texts[0], l_min)
			bfu_inst.checkboxes_width (l_term, ftp_texts + 1, l_max, bfu_inst.max_text_width_address)
			bfu_inst.checkboxes_width (l_term, ftp_texts + 1, l_min, bfu_inst.min_text_width_address)
			bfu_inst.max_buttons_width (l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, l_max)
			bfu_inst.min_buttons_width (l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, l_min)
			l_w := (l_term.item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > l_term.item.x - 12 then
				l_w := l_term.item.x - 12
			end
			if l_w < 5 then
				l_w := 5
			end
			l_rw.item := 0
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, ftp_texts[0], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_checkboxes (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 1, a_dlg.item.n - 3, 0, l_y, l_w, l_rw, ftp_texts + 1)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, 0, l_y, l_w, l_rw, 1)
			l_w := l_rw.item
			a_dlg.item.xw := l_rw.item + 12
			a_dlg.item.yw := l_y.item + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y.item := a_dlg.item.y + 2
			bfu_inst.dlg_format_text (l_term, l_term, ftp_texts[0], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_checkboxes (l_term, l_term, a_dlg.item.items + 1, a_dlg.item.n - 3, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), ftp_texts + 1)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, (a_dlg.item.items + a_dlg.item.n) - 2, 2, a_dlg.item.x + 6, l_y, l_w, l_rw, 1)
		end

	ftpopt_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ftpopt_fn)
		end

	go_backwards (a_term: CE_POINTER [PD_TERMINAL]; a_psteps: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_steps: INTEGER_32
			l_loc: CE_POINTER [PD_LOCATION]
			js: JUMP_STATE
		do
			create l_loc.make

			l_steps := (a_psteps.c_pointer.to_integer_32).to_integer_32
			session_inst.abort_loading (a_ses)
			from
			until
				not (not js.loop_done and then (l_steps > 1))
			loop
				l_loc := create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)
				if l_loc.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
					js.return
				end
				if not js.return_called then
					l_loc := l_loc.item.next
					if l_loc.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history"))) then
						js.return
					end
				end
				if not js.return_called then
					session_inst.destroy_location (l_loc)
					l_steps := l_steps - 1
				end
			end
			if not js.return_called and then (l_steps.to_boolean) then
				session_inst.go_back (a_ses)
			end
		end

	go_backwards_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent go_backwards)
		end

	history_menu (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_l: CE_POINTER [PD_LOCATION]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			l_n: INTEGER_32
			l_url: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_l.make
			create l_mi.make (<<1>>)
			create l_url.make

			l_mi.item := create {CE_POINTER [PD_MENU_ITEM]}.make_shared (default_pointer)
			l_n := 0
			l_l := create {CE_POINTER [PD_LOCATION]}.make_cast (a_ses.item.history.next)
			from
			until
				not (not js.loop_done and then (not l_l.is_equal (create {CE_POINTER [PD_LIST_HEAD]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("history")))))
			loop
				if l_n.to_boolean then
					if (l_mi.item).is_void then
						l_mi.item := bfu_inst.new_menu (3)
						if (l_mi.item).is_void then
							js.return
						end
					end
					if not js.return_called then
						l_url := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 281, l_l.item.vs.url)
						if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), 1)).is_void) then
							(strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), 1))[0] := (0).to_integer_8
						end
						bfu_inst.add_to_menu (l_mi, l_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), (go_backwards_address), create {CE_POINTER [ANY]}.make_shared (default_pointer + l_n), 0)
					end
				end
				if not js.return_called then
					l_n := l_n + 1
					l_l := l_l.item.next
				end
			end
			if not js.return_called then
				if l_n <= 1 then
					bfu_inst.do_menu (a_term, no_hist_menu, create {CE_POINTER [ANY]}.make_cast (a_ses))
				else
					bfu_inst.do_menu (a_term, l_mi.item, create {CE_POINTER [ANY]}.make_cast (a_ses))
				end
			end
		end

	history_menu_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent history_menu)
		end

	html_refresh (a_ses: CE_POINTER [PD_SESSION])
		do
			a_ses.item.ds.margin := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (marg_str))
			html_r_inst.html_interpret (a_ses)
			view_inst.draw_formatted (a_ses)
			session_inst.load_frames (a_ses, a_ses.item.screen)
			session_inst.process_file_requests (a_ses)
			session_inst.print_screen_status (a_ses)
		end

	html_refresh_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent html_refresh)
		end

	list_cache (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_a: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_l: CE_ARRAY [INTEGER_32]
			l_r: CE_POINTER [PD_REFRESH]
			l_ce: CE_POINTER [PD_CACHE_ENTRY]
			l_cache___0: CE_POINTER [PD_CACHE_ENTRY]
		do
			create l_a.make (<<1>>)
			create l_l.make (<<1>>)
			create l_r.make
			create l_ce.make
			create l_cache___0.make

			l_l.item := 0
			l_a.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 162)
			l_r := create {CE_POINTER [PD_REFRESH]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 163, (create {PD_REFRESH}.make).structure_size.to_natural_32)))
			l_r.item.term := a_term
			l_r.item.win := create {CE_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			l_r.item.ses := a_ses
			l_r.item.fn := list_cache_address
			l_r.item.data := a_d
			l_r.item.timer := -1
			l_cache___0 := create {CE_POINTER [PD_CACHE_ENTRY]}.make_shared (default_pointer + (cache_inst.cache_info (9)))
			links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (":")))
			l_ce := l_cache___0.item.next
			from
			until
				l_ce.is_equal (l_cache___0)
			loop
				links_inst.add_to_str (l_a, l_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("%N")))
				links_inst.add_to_str (l_a, l_l, l_ce.item.url)
				l_ce := l_ce.item.next
			end
			bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_a.item), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 34, 128, links_inst.dummyarray + 35, l_a.item, create {CE_POINTER [ANY]}.make_shared (default_pointer), l_r, 1, links_inst.dummyarray + 14, end_refresh_address, 3])
			l_r.item.win := create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next)
			l_r.item.timer := select_inst.install_timer ((100).to_integer_32, (refresh_address), create {CE_POINTER [ANY]}.make_cast (l_r))
		end

	list_cache_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent list_cache)
		end

	memory_cld (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY])
		do
			error_inst.last_mem_amount := error_inst.mem_amount
		end

	memory_info (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_message: CE_ARRAY [INTEGER_8]
			l_p: CE_POINTER [INTEGER_8]
			l_r: CE_POINTER [PD_REFRESH]
			l_tmp___2: CE_POINTER [NATURAL_8]
		do
			create l_message.make (<<2_000>>)
			create l_p.make
			create l_r.make
			create l_tmp___2.make

			l_r := create {CE_POINTER [PD_REFRESH]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 199, (create {PD_REFRESH}.make).structure_size.to_natural_32)))
			l_r.item.term := a_term
			l_r.item.win := create {CE_POINTER [PD_WINDOW]}.make_shared (default_pointer)
			l_r.item.ses := a_ses
			l_r.item.fn := memory_info_address
			l_r.item.data := a_d
			l_r.item.timer := -1
			l_p := l_message
			sprintf ([l_p, ce_string ("%%ld %%s"), error_inst.mem_amount, (language_inst.get_text_translation (links_inst.dummyarray + 36, a_term))]).do_nothing
			l_p := l_p + (strlen (l_p)).to_integer_32
			if error_inst.last_mem_amount /= -1 then
				l_tmp___2 := language_inst.get_text_translation (links_inst.dummyarray + 38, a_term)
				sprintf ([l_p, ce_string (", %%s %%ld, %%s %%ld"), (language_inst.get_text_translation (links_inst.dummyarray + 37, a_term)), error_inst.last_mem_amount, l_tmp___2, error_inst.mem_amount - error_inst.last_mem_amount]).do_nothing
				l_p := l_p + (strlen (l_p)).to_integer_32
			end
			sprintf ([l_p, ce_string (".")]).do_nothing
			l_p := l_p + (strlen (l_p)).to_integer_32
			l_p := create {CE_POINTER [INTEGER_8]}.make_cast ((links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 229, create {CE_POINTER [NATURAL_8]}.make_cast (l_message))))
			bfu_inst.msg_box ([a_term, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_p), create {CE_POINTER [ANY]}.make_shared (default_pointer)])), links_inst.dummyarray + 43, 1, l_p, l_r, 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
			l_r.item.win := create {CE_POINTER [PD_WINDOW]}.make_cast (a_term.item.windows.next);
			((create {CE_POINTER [PD_DIALOG_DATA]}.make_cast ((l_r.item.win).item.data)).item.dlg).item.abort := refresh_abort_address
			l_r.item.timer := select_inst.install_timer ((100).to_integer_32, (refresh_address), create {CE_POINTER [ANY]}.make_cast (l_r))
		end

	memory_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent memory_info)
		end

	menu_about (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 12, 1, links_inst.dummyarray + 13, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
		end

	menu_about_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_about)
		end

	menu_copying (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 17, 1, links_inst.dummyarray + 18, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
		end

	menu_copying_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_copying)
		end

	menu_doc_info (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			view_inst.state_msg (a_ses)
		end

	menu_doc_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_doc_info)
		end

	menu_for_frame (a_term: CE_POINTER [PD_TERMINAL]; a_f: CE_ROUTINE; a_ses: CE_POINTER [PD_SESSION])
		do
			view_inst.do_for_frame (a_ses, a_f, 0)
		end

	menu_for_frame_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_for_frame)
		end

	menu_go_back (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			session_inst.go_back (a_ses)
		end

	menu_go_back_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_go_back)
		end

	menu_goto_url (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			dialog_goto_url (a_ses, ce_string (""))
		end

	menu_goto_url_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_goto_url)
		end

	menu_head_info (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			view_inst.head_msg (a_ses)
		end

	menu_head_info_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_head_info)
		end

	menu_html_options (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_d.make

			links_inst.snprint (marg_str, 2, (a_ses.item.ds.margin).to_integer_32).do_nothing
			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 918, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 11 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 11 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 78
			l_d.item.fn := bfu_inst.group_fn_address
			l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (html_texts)
			l_d.item.udata2 := create {CE_POINTER [ANY]}.make_cast (a_ses)
			l_d.item.refresh := (html_refresh_address)
			l_d.item.refresh_data := create {CE_POINTER [ANY]}.make_cast (a_ses)
			l_d.item.items[0].type := 1
			l_d.item.items[0].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("tables"))))
			l_d.item.items[0].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[1].type := 1
			l_d.item.items[1].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("frames"))))
			l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[2].type := 1
			l_d.item.items[2].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("images"))))
			l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[3].type := 1
			l_d.item.items[3].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("table_order"))))
			l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[4].type := 1
			l_d.item.items[4].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("num_links"))))
			l_d.item.items[4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[5].type := 2
			l_d.item.items[5].dlen := 2
			l_d.item.items[5].data := marg_str
			l_d.item.items[5].fn := bfu_inst.check_number_address
			l_d.item.items[5].gid := 0
			l_d.item.items[5].gnum := 9
			l_d.item.items[6].type := 4
			l_d.item.items[6].gid := 0
			l_d.item.items[6].fn := dlg_assume_cp_address
			l_d.item.items[6].text := links_inst.dummyarray + 79
			l_d.item.items[6].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("assume_cp"))))
			l_d.item.items[6].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[7].type := 1
			l_d.item.items[7].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds") + (create {PD_DOCUMENT_SETUP}.make).offset_of ("hard_assume"))))
			l_d.item.items[7].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[8].type := 4
			l_d.item.items[8].gid := 1
			l_d.item.items[8].fn := bfu_inst.ok_dialog_address
			l_d.item.items[8].text := links_inst.dummyarray + 14
			l_d.item.items[9].type := 4
			l_d.item.items[9].gid := 2
			l_d.item.items[9].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[9].text := links_inst.dummyarray + 6
			l_d.item.items[10].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

	menu_html_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_html_options)
		end

	menu_keys (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			bfu_inst.msg_box ([a_term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 15, 0, links_inst.dummyarray + 16, create {CE_POINTER [ANY]}.make_shared (default_pointer), 1, links_inst.dummyarray + 14, create {CE_POINTER [ANY]}.make_shared (default_pointer), 3])
		end

	menu_keys_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_keys)
		end

	menu_kill_background_connections (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_yyy: CE_POINTER [ANY])
		do
			sched_inst.abort_background_connections
		end

	menu_kill_background_connections_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_kill_background_connections)
		end

	menu_language_list (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_i: INTEGER_32
			l_sel: INTEGER_32
			l_n: CE_POINTER [NATURAL_8]
			l_mi: CE_ARRAY [CE_POINTER [PD_MENU_ITEM]]
			js: JUMP_STATE
		do
			create l_n.make
			create l_mi.make (<<1>>)

			l_mi.item := bfu_inst.new_menu (1)
			if (l_mi.item).is_void then
				js.return
			end
			if not js.return_called then
				l_i := 0
				from
				until
					js.loop_done
				loop
					if not (l_i < (language_inst.n_languages)) then
						js.break
					end
					if not js.loop_jumped then
						l_n := language_inst.language_name (l_i)
						bfu_inst.add_to_menu (l_mi, l_n, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), (menu_set_language_address), create {CE_POINTER [ANY]}.make_shared (default_pointer + l_i), 0)
						l_i := l_i + 1
					end
				end
				l_sel := links_inst.current_language.item
				bfu_inst.do_menu_selected (a_term, l_mi.item, create {CE_POINTER [ANY]}.make_cast (a_ses), l_sel)
			end
		end

	menu_language_list_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_language_list)
		end

	menu_manual (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			session_inst.goto_url (a_ses, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http://links.sourceforge.net/docs/manual-0.90-en/")))
		end

	menu_manual_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_manual)
		end

	menu_reload (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			session_inst.reload (a_ses, -1)
		end

	menu_reload_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_reload)
		end

	menu_save_html_options (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			memcpy (create {CE_POINTER [ANY]}.make_cast (default_inst.dds), create {CE_POINTER [ANY]}.make_cast ((create {CE_POINTER [PD_DOCUMENT_SETUP]}.make_shared (a_ses.c_pointer + (create {PD_SESSION}.make).offset_of ("ds")))), (create {PD_DOCUMENT_SETUP}.make).structure_size.to_natural_32).do_nothing
			default_inst.write_html_config (a_term)
		end

	menu_save_html_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_save_html_options)
		end

	menu_save_url_as (a_term: CE_POINTER [PD_TERMINAL]; a_d: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			dialog_save_url (a_ses)
		end

	menu_save_url_as_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_save_url_as)
		end

	menu_set_language (a_term: CE_POINTER [PD_TERMINAL]; a_pcp: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			language_inst.set_language ((a_pcp.c_pointer.to_integer_32).to_integer_32)
			terminal_inst.cls_redraw_all_terminals
		end

	menu_set_language_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_set_language)
		end

	menu_shell (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_yyy: CE_POINTER [ANY])
		local
			l_sh: CE_POINTER [NATURAL_8]
		do
			create l_sh.make

			l_sh := create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (ce_string ("SHELL"))))
			if l_sh.is_void then
				l_sh := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/bin/sh"))
			end
			terminal_inst.exec_on_terminal (a_term, l_sh, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 1)
		end

	menu_shell_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_shell)
		end

	menu_toggle (a_term: CE_POINTER [PD_TERMINAL]; a_ddd: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		do
			view_inst.toggle (a_ses, a_ses.item.screen, 0)
		end

	menu_toggle_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent menu_toggle)
		end

	net_options (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_yyy: CE_POINTER [ANY])
		local
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_d.make

			links_inst.snprint (max_c_str, 3, (default_inst.max_connections.item).to_integer_32).do_nothing
			links_inst.snprint (max_cth_str, 3, (default_inst.max_connections_to_host.item).to_integer_32).do_nothing
			links_inst.snprint (max_t_str, 3, (default_inst.max_tries.item).to_integer_32).do_nothing
			links_inst.snprint (time_str, 5, (default_inst.receive_timeout.item).to_integer_32).do_nothing
			links_inst.snprint (unrtime_str, 5, (default_inst.unrestartable_receive_timeout.item).to_integer_32).do_nothing
			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 657, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 14 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 14 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 67
			l_d.item.fn := netopt_fn_address
			l_d.item.refresh := refresh_net_address
			l_d.item.items[0].type := 2
			l_d.item.items[0].dlen := 1_024
			l_d.item.items[0].data := default_inst.http_proxy
			l_d.item.items[1].type := 2
			l_d.item.items[1].dlen := 1_024
			l_d.item.items[1].data := default_inst.ftp_proxy
			l_d.item.items[2].type := 2
			l_d.item.items[2].data := max_c_str
			l_d.item.items[2].dlen := 3
			l_d.item.items[2].fn := bfu_inst.check_number_address
			l_d.item.items[2].gid := 1
			l_d.item.items[2].gnum := 99
			l_d.item.items[3].type := 2
			l_d.item.items[3].data := max_cth_str
			l_d.item.items[3].dlen := 3
			l_d.item.items[3].fn := bfu_inst.check_number_address
			l_d.item.items[3].gid := 1
			l_d.item.items[3].gnum := 99
			l_d.item.items[4].type := 2
			l_d.item.items[4].data := max_t_str
			l_d.item.items[4].dlen := 3
			l_d.item.items[4].fn := bfu_inst.check_number_address
			l_d.item.items[4].gid := 0
			l_d.item.items[4].gnum := 16
			l_d.item.items[5].type := 2
			l_d.item.items[5].data := time_str
			l_d.item.items[5].dlen := 5
			l_d.item.items[5].fn := bfu_inst.check_number_address
			l_d.item.items[5].gid := 1
			l_d.item.items[5].gnum := 1_800
			l_d.item.items[6].type := 2
			l_d.item.items[6].data := unrtime_str
			l_d.item.items[6].dlen := 5
			l_d.item.items[6].fn := bfu_inst.check_number_address
			l_d.item.items[6].gid := 1
			l_d.item.items[6].gnum := 1_800
			l_d.item.items[7].type := 1
			l_d.item.items[7].data := create {CE_POINTER [NATURAL_8]}.make_cast (default_inst.async_lookup)
			l_d.item.items[7].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[8].type := 1
			l_d.item.items[8].data := create {CE_POINTER [NATURAL_8]}.make_cast (default_inst.download_utime)
			l_d.item.items[8].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
			l_d.item.items[9].type := 4
			l_d.item.items[9].gid := 0
			l_d.item.items[9].fn := dlg_http_options_address
			l_d.item.items[9].text := links_inst.dummyarray + 277
			l_d.item.items[9].data := create {CE_POINTER [NATURAL_8]}.make_cast (default_inst.http_bugs)
			l_d.item.items[9].dlen := ((create {PD_HTTP_BUGS}.make).structure_size.to_natural_32).to_integer_32
			l_d.item.items[10].type := 4
			l_d.item.items[10].gid := 0
			l_d.item.items[10].fn := dlg_ftp_options_address
			l_d.item.items[10].text := links_inst.dummyarray + 278
			l_d.item.items[10].data := create {CE_POINTER [NATURAL_8]}.make_cast (default_inst.ftp_options)
			l_d.item.items[10].dlen := ((create {PD_FTP_OPTIONS}.make).structure_size.to_natural_32).to_integer_32
			l_d.item.items[11].type := 4
			l_d.item.items[11].gid := 1
			l_d.item.items[11].fn := bfu_inst.ok_dialog_address
			l_d.item.items[11].text := links_inst.dummyarray + 14
			l_d.item.items[12].type := 4
			l_d.item.items[12].gid := 2
			l_d.item.items[12].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[12].text := links_inst.dummyarray + 6
			l_d.item.items[13].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

	net_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent net_options)
		end

	net_programs (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_yyy: CE_POINTER [ANY])
		local
			l_d: CE_POINTER [PD_DIALOG]
		do
			create l_d.make

			l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 791, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
			memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 7 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
			l_d.item.title := links_inst.dummyarray + 294
			l_d.item.fn := netprog_fn_address
			l_d.item.items[0].type := 2
			l_d.item.items[0].dlen := 1_024
			l_d.item.items[0].data := types_inst.get_prog (types_inst.mailto_prog)
			l_d.item.items[1].type := 2
			l_d.item.items[1].dlen := 1_024
			l_d.item.items[1].data := types_inst.get_prog (types_inst.telnet_prog)
			l_d.item.items[2].type := 2
			l_d.item.items[2].dlen := 1_024
			l_d.item.items[2].data := types_inst.get_prog (types_inst.tn3270_prog)
			l_d.item.items[3].type := 2
			l_d.item.items[3].dlen := 1_024
			l_d.item.items[3].data := types_inst.get_prog (types_inst.mms_prog)
			l_d.item.items[4].type := 4
			l_d.item.items[4].gid := 1
			l_d.item.items[4].fn := bfu_inst.ok_dialog_address
			l_d.item.items[4].text := links_inst.dummyarray + 14
			l_d.item.items[5].type := 4
			l_d.item.items[5].gid := 2
			l_d.item.items[5].fn := bfu_inst.cancel_dialog_address
			l_d.item.items[5].text := links_inst.dummyarray + 6
			l_d.item.items[6].type := 0
			bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
		end

	net_programs_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent net_programs)
		end

	netopt_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create l_term.make
			create l_max.make (<<1>>)
			create l_min.make (<<1>>)
			create l_rw.make (<<1>>)
			create l_y.make (<<1>>)

			l_term := (a_dlg.item.win).item.term
			l_max.item := 0
			l_min.item := 0
			l_y.item := -1
			bfu_inst.max_text_width (l_term, net_msg[0], l_max)
			bfu_inst.min_text_width (l_term, net_msg[0], l_min)
			bfu_inst.max_text_width (l_term, net_msg[1], l_max)
			bfu_inst.min_text_width (l_term, net_msg[1], l_min)
			bfu_inst.max_group_width (l_term, net_msg + 2, a_dlg.item.items + 2, 9, l_max)
			bfu_inst.min_group_width (l_term, net_msg + 2, a_dlg.item.items + 2, 9, l_min)
			bfu_inst.max_buttons_width (l_term, a_dlg.item.items + 11, 2, l_max)
			bfu_inst.min_buttons_width (l_term, a_dlg.item.items + 11, 2, l_min)
			l_w := (((a_dlg.item.win).item.term).item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > ((a_dlg.item.win).item.term).item.x - 12 then
				l_w := ((a_dlg.item.win).item.term).item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, net_msg[0], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, net_msg[1], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + (2)
			bfu_inst.dlg_format_group (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, net_msg + 2, a_dlg.item.items + 2, 9, 0, l_y, l_w, l_rw)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 11, 2, 0, l_y, l_w, l_rw, 1)
			l_w := l_rw.item
			a_dlg.item.xw := l_w + 12
			a_dlg.item.yw := l_y.item + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y.item := a_dlg.item.y + 2
			bfu_inst.dlg_format_text (l_term, l_term, net_msg[0], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 0, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_text (l_term, l_term, net_msg[1], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 1, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_group (l_term, l_term, net_msg + 2, a_dlg.item.items + 2, 9, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items + 11, 2, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	netopt_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent netopt_fn)
		end

	netprog_fn (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		local
			l_term: CE_POINTER [PD_TERMINAL]
			l_max: CE_ARRAY [INTEGER_32]
			l_min: CE_ARRAY [INTEGER_32]
			l_w: INTEGER_32
			l_rw: CE_ARRAY [INTEGER_32]
			l_y: CE_ARRAY [INTEGER_32]
		do
			create l_term.make
			create l_max.make (<<1>>)
			create l_min.make (<<1>>)
			create l_rw.make (<<1>>)
			create l_y.make (<<1>>)

			l_term := (a_dlg.item.win).item.term
			l_max.item := 0
			l_min.item := 0
			l_y.item := -1
			bfu_inst.max_text_width (l_term, prg_msg[0], l_max)
			bfu_inst.min_text_width (l_term, prg_msg[0], l_min)
			bfu_inst.max_text_width (l_term, prg_msg[1], l_max)
			bfu_inst.min_text_width (l_term, prg_msg[1], l_min)
			bfu_inst.max_text_width (l_term, prg_msg[2], l_max)
			bfu_inst.min_text_width (l_term, prg_msg[2], l_min)
			bfu_inst.max_text_width (l_term, prg_msg[3], l_max)
			bfu_inst.min_text_width (l_term, prg_msg[3], l_min)
			bfu_inst.max_buttons_width (l_term, a_dlg.item.items + 4, 2, l_max)
			bfu_inst.min_buttons_width (l_term, a_dlg.item.items + 4, 2, l_min)
			l_w := (((a_dlg.item.win).item.term).item.x * 9) // 10 - 12
			if l_w > l_max.item then
				l_w := l_max.item
			end
			if l_w < l_min.item then
				l_w := l_min.item
			end
			if l_w > ((a_dlg.item.win).item.term).item.x - 12 then
				l_w := ((a_dlg.item.win).item.term).item.x - 12
			end
			if l_w < 1 then
				l_w := 1
			end
			l_rw.item := 0
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg[0], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg[1], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg[2], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + (2)
			bfu_inst.dlg_format_text (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, prg_msg[3], 0, l_y, l_w, l_rw, 14_336, 0)
			l_y.item := l_y.item + (2)
			bfu_inst.dlg_format_buttons (create {CE_POINTER [PD_TERMINAL]}.make_shared (default_pointer), l_term, a_dlg.item.items + 4, 2, 0, l_y, l_w, l_rw, 1)
			l_w := l_rw.item
			a_dlg.item.xw := l_w + 12
			a_dlg.item.yw := l_y.item + 4
			bfu_inst.center_dlg (a_dlg)
			bfu_inst.draw_dlg (a_dlg)
			l_y.item := a_dlg.item.y + 2
			bfu_inst.dlg_format_text (l_term, l_term, prg_msg[0], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 0, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_text (l_term, l_term, prg_msg[1], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 1, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_text (l_term, l_term, prg_msg[2], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 2, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_text (l_term, l_term, prg_msg[3], a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 14_336, 0)
			bfu_inst.dlg_format_field (l_term, l_term, a_dlg.item.items + 3, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 0)
			l_y.item := l_y.item + 1
			bfu_inst.dlg_format_buttons (l_term, l_term, a_dlg.item.items + 4, 2, a_dlg.item.x + 6, l_y, l_w, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), 1)
		end

	netprog_fn_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent netprog_fn)
		end

	query_exit (a_ses: CE_POINTER [PD_SESSION])
		local
			l_tmp___0: CE_POINTER [NATURAL_8]
		do
			create l_tmp___0.make

			a_ses.item.exit_query := 1
			if ((a_ses.item.term).item.next).is_equal ((a_ses.item.term).item.prev) then
				if (session_inst.are_there_downloads).to_boolean then
					l_tmp___0 := links_inst.dummyarray + 276
				else
					l_tmp___0 := links_inst.dummyarray + 275
				end
			else
				l_tmp___0 := links_inst.dummyarray + 275
			end
			bfu_inst.msg_box ([a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 274, 1, l_tmp___0, a_ses, 2, links_inst.dummyarray + 166, (really_exit_prog_address), 1, links_inst.dummyarray + 167, dont_exit_prog_address, 2])
		end

	query_file (a_ses: CE_POINTER [PD_SESSION]; a_url: CE_POINTER [NATURAL_8]; a_std: CE_ROUTINE; a_cancel: CE_ROUTINE)
		local
			l_file: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_def: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_dfl: CE_ARRAY [INTEGER_32]
			l_l: CE_ARRAY [INTEGER_32]
		do
			create l_file.make (<<1>>)
			create l_def.make (<<1>>)
			create l_dfl.make (<<1>>)
			create l_l.make (<<1>>)

			l_dfl.item := 0
			url_inst.get_filename_from_url (a_url, l_file, l_l)
			l_def.item := links_inst.init_str_x (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_262)
			links_inst.add_to_str (l_def, l_dfl, default_inst.download_dir)
			if (l_def.item.item).to_boolean then
				if not (os_dep_inst.dir_sep ((l_def.item[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_def.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_8)).to_boolean then
					links_inst.add_chr_to_str (l_def, l_dfl, (('/').code).to_natural_8)
				end
			end
			links_inst.add_bytes_to_str (l_def, l_dfl, l_file.item, l_l.item)
			bfu_inst.input_field (a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 117, links_inst.dummyarray + 118, links_inst.dummyarray + 14, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_cast (a_ses), file_history, 4_096, l_def.item, 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), a_std, a_cancel)
			error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 1_267, create {CE_POINTER [ANY]}.make_cast (l_def.item))
		end

	really_exit_prog (a_ses: CE_POINTER [PD_SESSION])
		do
			select_inst.register_bottom_half ((terminal_inst.destroy_terminal_address), create {CE_POINTER [ANY]}.make_cast (a_ses.item.term)).do_nothing
		end

	really_exit_prog_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent really_exit_prog)
		end

	refresh (a_r: CE_POINTER [PD_REFRESH])
		local
			l_rr: CE_ARRAY [PD_REFRESH]
		do
			create l_rr.make (<<1>>)

			a_r.item.timer := -1
			memcpy (create {CE_POINTER [ANY]}.make_cast (l_rr), create {CE_POINTER [ANY]}.make_cast (a_r), (create {PD_REFRESH}.make).structure_size.to_natural_32).do_nothing
			terminal_inst.delete_window (a_r.item.win);
			(l_rr.item.fn).call ([l_rr.item.term, l_rr.item.data, l_rr.item.ses])
		end

	refresh_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent refresh)
		end

	refresh_abort (a_dlg: CE_POINTER [PD_DIALOG_DATA])
		do
			end_refresh (create {CE_POINTER [PD_REFRESH]}.make_cast ((a_dlg.item.dlg).item.udata2))
		end

	refresh_abort_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent refresh_abort)
		end

	refresh_net (a_xxx: CE_POINTER [ANY])
		do
			default_inst.max_connections.item := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (max_c_str))
			default_inst.max_connections_to_host.item := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (max_cth_str))
			default_inst.max_tries.item := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (max_t_str))
			default_inst.receive_timeout.item := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (time_str))
			default_inst.unrestartable_receive_timeout.item := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (unrtime_str))
			select_inst.register_bottom_half (sched_inst.check_queue_address, create {CE_POINTER [ANY]}.make_shared (default_pointer)).do_nothing
		end

	refresh_net_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent refresh_net)
		end

	search_back_dlg (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			bfu_inst.input_field (a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 93, links_inst.dummyarray + 119, links_inst.dummyarray + 14, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_cast (a_ses), search_history, 4_096, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (view_inst.search_for_back_address), create {CE_ROUTINE}.make_shared (default_pointer))
		end

	search_back_dlg_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent search_back_dlg)
		end

	search_dlg (a_ses: CE_POINTER [PD_SESSION]; a_f: CE_POINTER [PD_F_DATA_C]; a_a: INTEGER_32)
		do
			bfu_inst.input_field (a_ses.item.term, create {CE_POINTER [PD_MEMORY_LIST]}.make_shared (default_pointer), links_inst.dummyarray + 92, links_inst.dummyarray + 119, links_inst.dummyarray + 14, links_inst.dummyarray + 6, create {CE_POINTER [ANY]}.make_cast (a_ses), search_history, 4_096, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("")), 0, 0, create {CE_ROUTINE}.make_shared (default_pointer), (view_inst.search_for_address), create {CE_ROUTINE}.make_shared (default_pointer))
		end

	search_dlg_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent search_dlg)
		end

	set_val (a_term: CE_POINTER [PD_TERMINAL]; a_ip___0: CE_POINTER [ANY]; a_d: CE_POINTER [INTEGER_32])
		do
			a_d.item := (a_ip___0.c_pointer.to_integer_32).to_integer_32
		end

	set_val_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent set_val)
		end

	terminal_options (a_term: CE_POINTER [PD_TERMINAL]; a_xxx: CE_POINTER [ANY]; a_ses: CE_POINTER [PD_SESSION])
		local
			l_d: CE_POINTER [PD_DIALOG]
			l_ts: CE_POINTER [PD_TERM_SPEC]
			js: JUMP_STATE
		do
			create l_d.make
			create l_ts.make

			l_ts := (terminal_inst.new_term_spec (a_term.item.term))
			if l_ts.is_void then
				js.return
			end
			if not js.return_called then
				l_d := create {CE_POINTER [PD_DIALOG]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu.c")), 389, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 12 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32)))
				memset (create {CE_POINTER [ANY]}.make_cast (l_d), 0, (create {PD_DIALOG}.make).structure_size.to_natural_32 + {NATURAL_32} 12 * (create {PD_DIALOG_ITEM}.make).structure_size.to_natural_32).do_nothing
				l_d.item.title := links_inst.dummyarray + 56
				l_d.item.fn := bfu_inst.checkbox_list_fn_address
				l_d.item.udata := create {CE_POINTER [ANY]}.make_cast (td_labels)
				l_d.item.refresh := terminal_options_ok_address
				l_d.item.items[0].type := 1
				l_d.item.items[0].gid := 1
				l_d.item.items[0].gnum := 0
				l_d.item.items[0].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[0].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				l_d.item.items[1].type := 1
				l_d.item.items[1].gid := 1
				l_d.item.items[1].gnum := 1
				l_d.item.items[1].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[1].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				l_d.item.items[2].type := 1
				l_d.item.items[2].gid := 1
				l_d.item.items[2].gnum := 2
				l_d.item.items[2].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[2].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				l_d.item.items[3].type := 1
				l_d.item.items[3].gid := 1
				l_d.item.items[3].gnum := 3
				l_d.item.items[3].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[3].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				l_d.item.items[4].type := 1
				l_d.item.items[4].gid := 1
				l_d.item.items[4].gnum := 4
				l_d.item.items[4].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[4].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("mode"))))
				l_d.item.items[5].type := 1
				l_d.item.items[5].gid := 0
				l_d.item.items[5].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[5].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("m11_hack"))))
				l_d.item.items[6].type := 1
				l_d.item.items[6].gid := 0
				l_d.item.items[6].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[6].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("restrict_852"))))
				l_d.item.items[7].type := 1
				l_d.item.items[7].gid := 0
				l_d.item.items[7].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[7].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("block_cursor"))))
				l_d.item.items[8].type := 1
				l_d.item.items[8].gid := 0
				l_d.item.items[8].dlen := ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32
				l_d.item.items[8].data := create {CE_POINTER [NATURAL_8]}.make_cast ((create {CE_POINTER [INTEGER_32]}.make_shared (l_ts.c_pointer + (create {PD_TERM_SPEC}.make).offset_of ("col"))))
				l_d.item.items[9].type := 4
				l_d.item.items[9].gid := 1
				l_d.item.items[9].fn := bfu_inst.ok_dialog_address
				l_d.item.items[9].text := links_inst.dummyarray + 14
				l_d.item.items[10].type := 4
				l_d.item.items[10].gid := 2
				l_d.item.items[10].fn := bfu_inst.cancel_dialog_address
				l_d.item.items[10].text := links_inst.dummyarray + 6
				l_d.item.items[11].type := 0
				bfu_inst.do_dialog (a_term, l_d, (bfu_inst.getml ([create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_shared (default_pointer)])))
			end
		end

	terminal_options_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent terminal_options)
		end

	terminal_options_ok (a_p: CE_POINTER [ANY])
		do
			terminal_inst.cls_redraw_all_terminals
		end

	terminal_options_ok_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent terminal_options_ok)
		end

end
