class
	P_URL

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create protocols.make (<<12>>)
		end

feature {ANY} -- attributes

	protocols: CE_ARRAY [PD_PROTOCOLS]

feature {ANY} -- routines

	add_conv_str (a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32]; a_b: CE_POINTER [NATURAL_8]; a_ll: INTEGER_32; a_encode_special: INTEGER_32)
		local
			l_b: CE_POINTER [NATURAL_8]
			l_ll: INTEGER_32
			l_h: CE_ARRAY [NATURAL_8]
			l_h___0: NATURAL_8
			l_i: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_b.make
			create l_h.make (<<4>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_b := a_b
					l_ll := a_ll
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_ll.to_boolean)) then
						l_pos := -1 + 35 -- skip loop
					end
				when 2 then -- loop body:
						if (l_b.item).to_integer_32 < 32 then
							js.continue
						end
						if js.loop_jumped then
							l_pos := -1 + 34 -- skip if block
						end
				when 3 then -- if:
						if (l_b.item).to_integer_32 /= 37 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L___10
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 6 then -- else:
						if (l_b.item).to_integer_32 /= 35 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if: | _L___10:
						if a_encode_special = 1 then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_h), ce_string ("%%%%%%02X"), ((l_b.item).to_natural_32).bit_and ({NATURAL_32} 255)]).do_nothing
							links_inst.add_to_str (a_s, a_l, l_h)
						else
							l_pos := -1 + 9 -- goto _L___9
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 9 then -- else: | _L___9:
						if (l_b.item).to_integer_32 /= 37 then
							l_pos := -1 + 30 -- skip if block
						end
				when 10 then -- if:
						if not (a_encode_special <= -1) then
							l_pos := -1 + 28 -- skip if block
						end
				when 11 then -- if:
						if not (l_ll > 2) then
							l_pos := -1 + 26 -- skip if block
						end
				when 12 then -- if:
						if not ((l_b[1]).to_integer_32 >= 48) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if (l_b[1]).to_integer_32 <= 57 then
							l_pos := -1 + 20 -- goto _L___4
						else
							l_pos := -1 + 15 -- goto _L___6
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___6:
						if not ((l_b[1]).to_integer_32 >= 65) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if (l_b[1]).to_integer_32 <= 70 then
							l_pos := -1 + 20 -- goto _L___4
						else
							l_pos := -1 + 18 -- goto _L___5
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 18 then -- else: | _L___5:
						if not ((l_b[1]).to_integer_32 >= 97) then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if not ((l_b[1]).to_integer_32 <= 102) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___4:
						l_h___0 := (0).to_natural_8
						l_i := 1
						from
						until
							not (l_i < 3)
						loop
							if (l_b[l_i]).to_integer_32 >= 48 then
								if (l_b[l_i]).to_integer_32 <= 57 then
									l_h___0 := ((l_h___0.to_integer_32 * 16 + (l_b[l_i]).to_integer_32) - 48).to_natural_8
								end
							end
							if (l_b[l_i]).to_integer_32 >= 65 then
								if (l_b[l_i]).to_integer_32 <= 70 then
									l_h___0 := (((l_h___0.to_integer_32 * 16 + (l_b[l_i]).to_integer_32) - 65) + 10).to_natural_8
								end
							end
							if (l_b[l_i]).to_integer_32 >= 97 then
								if (l_b[l_i]).to_integer_32 <= 102 then
									l_h___0 := (((l_h___0.to_integer_32 * 16 + (l_b[l_i]).to_integer_32) - 97) + 10).to_natural_8
								end
							end
							l_i := l_i + 1
						end
						if l_h___0.to_integer_32 >= 32 then
							links_inst.add_chr_to_str (a_s, a_l, l_h___0)
						end
						l_ll := l_ll - (2)
						l_b := l_b + (2)
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 25 then -- if done | if done | if done | if block done, skip else block:
						l_pos := -1 + 27
				when 26 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 27 then -- if done | if block done, skip else block:
						l_pos := -1 + 29
				when 28 then -- else:
						l_pos := -1 + 30 -- goto _L___8
				when 29 then -- if done | if block done, skip else block:
						l_pos := -1 + 34
				when 30 then -- else: | _L___8:
						if (l_b.item).to_integer_32 = 34 then
							l_pos := -1 + 33 -- skip if block
						end
				when 31 then -- if:
						if (l_b.item).to_integer_32 /= 39 then
							if (l_b.item).to_integer_32 /= 38 then
								if (l_b.item).to_integer_32 /= 60 then
									if (l_b.item).to_integer_32 /= 62 then
										links_inst.add_chr_to_str (a_s, a_l, l_b.item)
									else
										l_pos := -1 + 33 -- goto _L___2
									end
								else
									l_pos := -1 + 33 -- goto _L___2
								end
							else
								l_pos := -1 + 33 -- goto _L___2
							end
						else
							l_pos := -1 + 33 -- goto _L___2
						end
				when 32 then -- if block done, skip else block:
						l_pos := -1 + 34
				when 33 then -- else: | _L___2:
						if a_encode_special = -2 then
							links_inst.add_chr_to_str (a_s, a_l, l_b.item)
						else
							links_inst.add_to_str (a_s, a_l, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("&#")))
							links_inst.add_num_to_str (a_s, a_l, ((l_b.item).to_integer_32).to_integer_32)
							links_inst.add_chr_to_str (a_s, a_l, ((';').code).to_natural_8)
						end
				when 34 then -- if done | if done | if done | if done
						if js.loop_increment then
							l_ll := l_ll - 1
							l_b := l_b + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 35 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	check_protocol (a_p: CE_POINTER [NATURAL_8]; a_l: INTEGER_32): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_done and then (not (protocols[l_i].prot).is_void))
			loop
				if not (links_inst.casecmp (protocols[l_i].prot, a_p, a_l.to_natural_32)).to_boolean then
					if (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (protocols[l_i].prot))).to_integer_32 = a_l then
						Result := l_i
						js.return
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	extract_position (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_url: CE_POINTER [NATURAL_8]
			l_u: CE_POINTER [NATURAL_8]
			l_uu: CE_POINTER [NATURAL_8]
			l_r: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_url.make
			create l_u.make
			create l_uu.make
			create l_r.make

			l_url := a_url
			l_u := get_url_data (l_url)
			if (not l_u.is_void) then
				l_url := l_u
			end
			l_u := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), 1)))
			if l_u.is_void then
				l_u := l_url + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_url))).to_integer_32
			end
			l_uu := create {CE_POINTER [NATURAL_8]}.make_cast ((memchr (create {CE_POINTER [ANY]}.make_cast (l_url), ('#').code, (l_u.distance (l_url)).to_natural_32)))
			if l_uu.is_void then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_r := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 442, (l_u.distance (l_uu)).to_natural_32)))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_r), create {CE_POINTER [ANY]}.make_cast ((l_uu + 1)), ((l_u.distance (l_uu)) - 1).to_natural_32).do_nothing
				l_r[((l_u.distance (l_uu)) - 1)] := (0).to_natural_8
				memmove (create {CE_POINTER [ANY]}.make_cast (l_uu), create {CE_POINTER [ANY]}.make_cast (l_u), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_u))) + {NATURAL_32} 1).do_nothing
				Result := l_r
			end
		end

	get_external_protocol_function (a_url: CE_POINTER [NATURAL_8]): CE_ROUTINE
		local
			l_p: CE_POINTER [NATURAL_8]
			l_f: CE_ARRAY [CE_ROUTINE]
			l_post: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_p.make
			create l_f.make (<<1>>)
			create l_post.make (<<1>>)

			l_f.item := create {CE_ROUTINE}.make_shared (default_pointer)
			l_post.item := 0
			l_p := get_protocol_name (a_url)
			if l_p.is_void then
				Result := (create {CE_ROUTINE}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				get_prot_info (l_p, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_ROUTINE]}.make_shared (default_pointer), l_f, l_post).do_nothing
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 212, create {CE_POINTER [ANY]}.make_cast (l_p))
				if not (l_post.item).to_boolean then
					if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_url), 1)).is_void) then
						Result := (create {CE_ROUTINE}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (l_f.item)
			end
		end

	get_filename_from_url (a_url: CE_POINTER [NATURAL_8]; a_s: CE_POINTER [CE_POINTER [NATURAL_8]]; a_l: CE_POINTER [INTEGER_32])
		local
			l_url: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_tmp___0: INTEGER_32
			l_uu: CE_POINTER [NATURAL_8]
			l_tmp___2: INTEGER_32
			js: JUMP_STATE
		do
			create l_url.make
			create l_uu.make

			l_url := a_url
			if (links_inst.casecmp (l_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
				l_tmp___0 := 0
			else
				l_tmp___0 := 1
			end
			l_lo := l_tmp___0
			l_uu := get_url_data (l_url)
			if (not l_uu.is_void) then
				l_url := l_uu
			end
			a_s.item := l_url
			from
			until
				js.loop_done
			loop
				if (l_url.item).to_boolean then
					if (links_inst.end_of_dir (l_url.item)).to_boolean then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					if l_lo.to_boolean then
						l_tmp___2 := (os_dep_inst.dir_sep ((l_url.item).to_integer_8))
					else
						l_tmp___2 := ((l_url.item).to_integer_32 = 47).to_integer
					end
					if l_tmp___2.to_boolean then
						a_s.item := l_url + 1
					end
					l_url := l_url + 1
				end
			end
			a_l.item := l_url.distance ((a_s.item))
		end

	get_host_and_pass (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_u: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_z: CE_POINTER [NATURAL_8]
			l_k: CE_POINTER [NATURAL_8]
			l_hl: CE_ARRAY [INTEGER_32]
			l_pl: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_u.make (<<1>>)
			create l_h.make (<<1>>)
			create l_p.make (<<1>>)
			create l_z.make
			create l_k.make
			create l_hl.make (<<1>>)
			create l_pl.make (<<1>>)

			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_u, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, l_p, l_pl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (not (l_u.item).is_void) then
					l_z := l_u.item
				else
					l_z := l_h.item
				end
				if (not (l_p.item).is_void) then
					l_k := l_p.item + l_pl.item
				else
					l_k := l_h.item + l_hl.item
				end
				Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 139, l_z, l_k.distance (l_z)))
			end
		end

	get_host_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_h.make (<<1>>)
			create l_hl.make (<<1>>)

			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 146, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))))
				js.return
			end
			if not js.return_called then
				Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 147, l_h.item, l_hl.item))
			end
		end

	get_pass (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_h.make (<<1>>)
			create l_hl.make (<<1>>)

			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 163, l_h.item, l_hl.item))
			end
		end

	get_port (a_url: CE_POINTER [NATURAL_8]): INTEGER_32
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_n: INTEGER_32
			l_nn: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_h.make (<<1>>)
			create l_hl.make (<<1>>)
			create l_nn.make (<<1>>)

			l_n := -1
			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (-1)
				js.return
			end
			if not js.return_called and then (not (l_h.item).is_void) then
				l_n := strtol (create {CE_POINTER [INTEGER_8]}.make_cast (l_h.item), create {CE_POINTER [CE_POINTER [INTEGER_8]]}.make_shared (default_pointer), 10)
				if l_n.to_boolean then
					if l_n < 2_147_483_647 then
						Result := l_n.to_integer_32
						js.return
					end
				end
			end
			if not js.return_called then
				l_h.item := get_protocol_name (a_url)
				if (not (l_h.item).is_void) then
					get_prot_info (l_h.item, l_nn, create {CE_POINTER [CE_ROUTINE]}.make_shared (default_pointer), create {CE_POINTER [CE_ROUTINE]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer)).do_nothing
					error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 187, create {CE_POINTER [ANY]}.make_cast (l_h.item))
					l_n := (l_nn.item).to_integer_32
				end
				Result := l_n.to_integer_32
			end
		end

	get_port_str (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			l_tmp___1: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_h.make (<<1>>)
			create l_hl.make (<<1>>)
			create l_tmp___1.make

			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				if (l_hl.item).to_boolean then
					l_tmp___1 := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 171, l_h.item, l_hl.item))
				else
					l_tmp___1 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				end
				Result := l_tmp___1
			end
		end

	get_prot_info (a_prot: CE_POINTER [NATURAL_8]; a_port: CE_POINTER [INTEGER_32]; a_func: CE_POINTER [CE_ROUTINE]; a_nc_func: CE_POINTER [CE_ROUTINE]; a_allow_post: CE_POINTER [INTEGER_32]): INTEGER_32
		local
			l_i: INTEGER_32
			js: JUMP_STATE
		do
			l_i := 0
			from
			until
				not (not js.loop_done and then (not (protocols[l_i].prot).is_void))
			loop
				if not (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (protocols[l_i].prot), create {CE_POINTER [INTEGER_8]}.make_cast (a_prot))).to_boolean then
					if (not a_port.is_void) then
						a_port.item := protocols[l_i].port
					end
					if (not a_func.is_void) then
						a_func.item := protocols[l_i].func
					end
					if (not a_nc_func.is_void) then
						a_nc_func.item := protocols[l_i].nc_func
					end
					if (not a_allow_post.is_void) then
						a_allow_post.item := protocols[l_i].allow_post
					end
					Result := 0
					js.return
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := (-1)
			end
		end

	get_protocol_handle (a_url: CE_POINTER [NATURAL_8]): CE_ROUTINE
		local
			l_p: CE_POINTER [NATURAL_8]
			l_f: CE_ARRAY [CE_ROUTINE]
			l_post: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_p.make
			create l_f.make (<<1>>)
			create l_post.make (<<1>>)

			l_f.item := create {CE_ROUTINE}.make_shared (default_pointer)
			l_post.item := 0
			l_p := get_protocol_name (a_url)
			if l_p.is_void then
				Result := (create {CE_ROUTINE}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				get_prot_info (l_p, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_f, create {CE_POINTER [CE_ROUTINE]}.make_shared (default_pointer), l_post).do_nothing
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 200, create {CE_POINTER [ANY]}.make_cast (l_p))
				if not (l_post.item).to_boolean then
					if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_url), 1)).is_void) then
						Result := (create {CE_ROUTINE}.make_shared (default_pointer))
						js.return
					end
				end
			end
			if not js.return_called then
				Result := (l_f.item)
			end
		end

	get_protocol_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_l: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_l.make (<<1>>)

			if (parse_url (a_url, l_l, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 129, a_url, l_l.item))
			end
		end

	get_url_data (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_d: CE_ARRAY [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
		do
			create l_d.make (<<1>>)

			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_d, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (l_d.item)
			end
		end

	get_user_name (a_url: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_h: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_hl: CE_ARRAY [INTEGER_32]
			js: JUMP_STATE
		do
			create l_h.make (<<1>>)
			create l_hl.make (<<1>>)

			if (parse_url (a_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_h, l_hl, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				Result := (links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 155, l_h.item, l_hl.item))
			end
		end

	insert_wd (a_up___0: CE_POINTER [CE_POINTER [NATURAL_8]]; a_cwd: CE_POINTER [NATURAL_8])
		local
			l_url: CE_POINTER [NATURAL_8]
			l_tmp___1: NATURAL_32
			js: JUMP_STATE
		do
			create l_url.make

			l_url := a_up___0.item
			if l_url.is_void then
				js.return
			elseif a_cwd.is_void then
				js.return
			elseif not (a_cwd.item).to_boolean then
				js.return
			end
			if not js.return_called then
				if (links_inst.casecmp (l_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				if (os_dep_inst.dir_sep ((l_url[7]).to_integer_8)).to_boolean then
					js.return
				end
			end
			if not js.return_called then
				l_tmp___1 := strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_up___0.item))
				l_url := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 272, (l_tmp___1 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_cwd)))) + {NATURAL_32} 2)))
				memcpy (create {CE_POINTER [ANY]}.make_cast (l_url), create {CE_POINTER [ANY]}.make_cast (a_up___0.item), (7).to_natural_32).do_nothing
				strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_url + 7)), create {CE_POINTER [INTEGER_8]}.make_cast (a_cwd)).do_nothing
				if not (os_dep_inst.dir_sep ((a_cwd[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_cwd))) - {NATURAL_32} 1).to_integer_32]).to_integer_8)).to_boolean then
					strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ce_string ("/")).do_nothing
				end
				strcat (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), create {CE_POINTER [INTEGER_8]}.make_cast ((a_up___0.item + 7))).do_nothing
				error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 277, create {CE_POINTER [ANY]}.make_cast (a_up___0.item))
				a_up___0.item := l_url
			end
		end

	join_urls (a_base: CE_POINTER [NATURAL_8]; a_rel: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_p: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_n: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pp: CE_POINTER [NATURAL_8]
			l_l: CE_ARRAY [INTEGER_32]
			l_lo: INTEGER_32
			l_tmp___0: INTEGER_32
			l_rj: CE_ARRAY [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_n___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___13: INTEGER_32
			l_tmp___17: INTEGER_32
			l_tmp___19: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make (<<1>>)
			create l_n.make (<<1>>)
			create l_pp.make
			create l_l.make (<<1>>)
			create l_rj.make (<<3>>)
			create l_d.make
			create l_s.make
			create l_n___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (links_inst.casecmp (a_base, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
						l_tmp___0 := 0
					else
						l_tmp___0 := 1
					end
					l_lo := l_tmp___0
					if (a_rel[0]).to_integer_32 /= 35 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if (a_rel[0]).to_boolean then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						l_n.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 287, a_base)
						l_p.item := l_n.item
						from
						until
							js.loop_done
						loop
							if (l_p.item.item).to_boolean then
								if (l_p.item.item).to_integer_32 /= 1 then
									if (l_p.item.item).to_integer_32 = 35 then
										js.break
									end
								else
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_p.item := l_p.item + 1
							end
						end
						l_p.item.item := (0).to_natural_8
						links_inst.add_to_strn (l_n, a_rel)
						translate_directories (l_n.item)
						Result := (l_n.item)
						js.return
				when 5 then -- if done
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 6 then -- if:
							if (a_rel[0]).to_integer_32 /= 63 then
								l_pos := -1 + 9 -- skip if block
							end
				when 7 then -- if:
							l_pos := -1 + 10 -- goto _L___0
				when 8 then -- if block done, skip else block:
							l_pos := -1 + 12
				when 9 then -- else:
							if (a_rel[0]).to_integer_32 /= 38 then
								l_pos := -1 + 12 -- skip if block
							end
				when 10 then -- if: | _L___0:
							l_d := (get_url_data (a_base))
							if l_d.is_void then
								l_pos := -1 + 16 -- goto bad_base
							end
				when 11 then
							l_rj[0] := a_rel[0]
							l_rj[1] := (1).to_natural_8
							l_rj[2] := (0).to_natural_8
							l_d := l_d + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_d), create {CE_POINTER [INTEGER_8]}.make_cast (l_rj))).to_integer_32
							l_n.item := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 302, a_base, l_d.distance (a_base))
							links_inst.add_to_strn (l_n, a_rel)
							translate_directories (l_n.item)
							Result := (l_n.item)
							js.return
				when 12 then -- if done | if done
							if not (not js.return_called and then ((a_rel[0]).to_integer_32 = 47)) then
								l_pos := -1 + 19 -- skip if block
							end
				when 13 then -- if:
								if (a_rel[1]).to_integer_32 /= 47 then
									l_pos := -1 + 19 -- skip if block
								end
				when 14 then -- if:
								l_s := create {CE_POINTER [NATURAL_8]}.make_cast ((strstr (create {CE_POINTER [INTEGER_8]}.make_cast (a_base), ce_string ("//"))))
								if (not l_s.is_void) then
									l_pos := -1 + 18 -- skip if block
								end
				when 15 then -- if:
								l_s := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_base), (':').code)))
								if (not l_s.is_void) then
									l_pos := -1 + 17 -- skip if block
								end
				when 16 then -- if: | bad_base:
								from
								until
									False
								loop
									links_inst.errfile := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c"))
									links_inst.errline := 312
									error_inst.int_error ([create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("bad base url: %%s")), a_base])
								end
								Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								js.return
				when 17 then -- if done
								if not js.return_called then
									l_s := l_s + 1
								end
				when 18 then -- if done
								if not js.return_called then
									l_n___0.item := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 317, a_base, l_s.distance (a_base))
									links_inst.add_to_strn (l_n___0, a_rel)
									if not (parse_url (l_n___0.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
										translate_directories (l_n___0.item)
										Result := (l_n___0.item)
										js.return
									end
								end
								if not js.return_called then
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 323, create {CE_POINTER [ANY]}.make_cast (l_n___0.item))
								end
				when 19 then -- if done | if done
								if js.return_called then
									l_pos := -1 + 22 -- skip if block
								end
				when 20 then -- if:
									if not (links_inst.casecmp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("proxy://")), a_rel, (8).to_natural_32)).to_boolean then
										l_pos := -1 + 24 -- goto prx
									end
				when 21 then
									if not (parse_url (a_rel, l_l, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
										l_n.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 327, a_rel)
										translate_directories (l_n.item)
										Result := (l_n.item)
										js.return
									end
				when 22 then -- if done
								if not js.return_called then
									l_n.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 331, a_rel)
									from
									until
										js.loop_done
									loop
										if (l_n.item[0]).to_boolean then
											if not ((l_n.item[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_n.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 <= 32) then
												js.break
											end
										else
											js.break
										end
										if not js.loop_jumped then
											l_n.item[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_n.item))) - {NATURAL_32} 1).to_integer_32] := (0).to_natural_8
										end
									end
									links_inst.add_to_strn (l_n, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
									if not (parse_url (l_n.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
										translate_directories (l_n.item)
										Result := (l_n.item)
										js.return
									end
								end
								if js.return_called then
									l_pos := -1 + 26 -- skip if block
								end
				when 23 then -- if:
									error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 338, create {CE_POINTER [ANY]}.make_cast (l_n.item))
				when 24 then -- prx:
									if (parse_url (a_base, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_p, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
										l_pos := -1 + 16 -- goto bad_base
									elseif (l_p.item).is_void then
										l_pos := -1 + 16 -- goto bad_base
									end
				when 25 then
									if l_lo.to_boolean then
										l_tmp___13 := (os_dep_inst.dir_sep ((l_p.item.item).to_integer_8))
									else
										l_tmp___13 := ((l_p.item.item).to_integer_32 = 47).to_integer
									end
									if not l_tmp___13.to_boolean then
										l_p.item := l_p.item - 1
									end
									if (links_inst.end_of_dir (a_rel[0])).to_boolean then
										from
										until
											not (not js.loop_done and then ((l_p.item.item).to_boolean))
										loop
											if (links_inst.end_of_dir (l_p.item.item)).to_boolean then
												js.break
											end
											if not js.loop_jumped then
												l_p.item := l_p.item + 1
											end
										end
									else
										if l_lo.to_boolean then
											l_tmp___19 := (os_dep_inst.dir_sep ((a_rel[0]).to_integer_8))
										else
											l_tmp___19 := ((a_rel[0]).to_integer_32 = 47).to_integer
										end
										if not l_tmp___19.to_boolean then
											l_pp := l_p.item
											from
											until
												not (not js.loop_done and then ((l_pp.item).to_boolean))
											loop
												if (links_inst.end_of_dir (l_pp.item)).to_boolean then
													js.break
												end
												if not js.loop_jumped then
													if l_lo.to_boolean then
														l_tmp___17 := (os_dep_inst.dir_sep ((l_pp.item).to_integer_8))
													else
														l_tmp___17 := ((l_pp.item).to_integer_32 = 47).to_integer
													end
													if l_tmp___17.to_boolean then
														l_p.item := l_pp + 1
													end
													l_pp := l_pp + 1
												end
											end
										end
									end
									l_n.item := create {CE_POINTER [NATURAL_8]}.make_cast ((error_inst.debug_mem_alloc (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 350, (((l_p.item).distance (a_base)).to_natural_32 + (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_rel)))) + {NATURAL_32} 1)))
									memcpy (create {CE_POINTER [ANY]}.make_cast (l_n.item), create {CE_POINTER [ANY]}.make_cast (a_base), ((l_p.item).distance (a_base)).to_natural_32).do_nothing
									strcpy (create {CE_POINTER [INTEGER_8]}.make_cast ((l_n.item + ((l_p.item).distance (a_base)))), create {CE_POINTER [INTEGER_8]}.make_cast (a_rel)).do_nothing
									translate_directories (l_n.item)
									Result := (l_n.item)
				when 26 then
								l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
					end

	parse_url (a_url: CE_POINTER [NATURAL_8]; a_prlen: CE_POINTER [INTEGER_32]; a_user: CE_POINTER [CE_POINTER [NATURAL_8]]; a_uslen: CE_POINTER [INTEGER_32]; a_pass: CE_POINTER [CE_POINTER [NATURAL_8]]; a_palen: CE_POINTER [INTEGER_32]; a_host: CE_POINTER [CE_POINTER [NATURAL_8]]; a_holen: CE_POINTER [INTEGER_32]; a_port: CE_POINTER [CE_POINTER [NATURAL_8]]; a_polen: CE_POINTER [INTEGER_32]; a_data: CE_POINTER [CE_POINTER [NATURAL_8]]; a_dalen: CE_POINTER [INTEGER_32]; a_post: CE_POINTER [CE_POINTER [NATURAL_8]]): INTEGER_32
		local
			l_p: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			l_p_c: CE_ARRAY [NATURAL_8]
			l_a: INTEGER_32
			l_pp: CE_POINTER [NATURAL_8]
			l_tmp___3: NATURAL_32
			l_pp___0: CE_POINTER [NATURAL_8]
			l_cc: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_p.make
			create l_q.make
			create l_p_c.make (<<2>>)
			create l_pp.make
			create l_pp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (not a_prlen.is_void) then
						a_prlen.item := 0
					end
					if (not a_user.is_void) then
						a_user.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (not a_uslen.is_void) then
						a_uslen.item := 0
					end
					if (not a_pass.is_void) then
						a_pass.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (not a_palen.is_void) then
						a_palen.item := 0
					end
					if (not a_host.is_void) then
						a_host.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (not a_holen.is_void) then
						a_holen.item := 0
					end
					if (not a_port.is_void) then
						a_port.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (not a_polen.is_void) then
						a_polen.item := 0
					end
					if (not a_data.is_void) then
						a_data.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if (not a_dalen.is_void) then
						a_dalen.item := 0
					end
					if (not a_post.is_void) then
						a_post.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					end
					if a_url.is_void then
						Result := (-1)
						js.return
					else
						l_p := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (a_url), (':').code)))
						if l_p.is_void then
							Result := (-1)
							js.return
						end
					end
					if not js.return_called then
						if (not a_prlen.is_void) then
							a_prlen.item := l_p.distance (a_url)
						end
						l_a := check_protocol (a_url, l_p.distance (a_url))
						if l_a = -1 then
							Result := (-1)
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						if (l_p[1]).to_integer_32 = 47 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if (l_p[2]).to_integer_32 = 47 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						if (protocols[l_a].need_slashes).to_boolean then
							Result := (-1)
							js.return
						end
						if not js.return_called then
							l_p := l_p - (2)
						end
				when 6 then -- if done | if done
						if not js.return_called and then ((protocols[l_a].free_syntax).to_boolean) then
							if (not a_data.is_void) then
								a_data.item := l_p + 3
							end
							if (not a_dalen.is_void) then
								a_dalen.item := (strlen (create {CE_POINTER [INTEGER_8]}.make_cast ((l_p + 3)))).to_integer_32
							end
							Result := 0
							js.return
						end
						if not js.return_called then
							l_p := l_p + (3)
							l_q := l_p + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), ce_string ("@/?"))).to_integer_32
							if not (l_q.item).to_boolean then
								if (protocols[l_a].need_slash_after_host).to_boolean then
									Result := (-1)
									js.return
								end
							end
						end
						if js.return_called then
							l_pos := -1 + 17 -- skip if block
						end
				when 7 then -- if:
							if (l_q.item).to_integer_32 /= 64 then
								l_pos := -1 + 16 -- skip if block
							end
				when 8 then -- if:
							from
							until
								js.loop_done
							loop
								l_tmp___3 := strcspn (create {CE_POINTER [INTEGER_8]}.make_cast ((l_q + 1)), ce_string ("@"))
								if not (l_tmp___3 < (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast ((l_q + 1)), ce_string ("/?")))) then
									js.break
								end
								if not js.loop_jumped then
									l_q := (l_q + 1) + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast ((l_q + 1)), ce_string ("@"))).to_integer_32
								end
							end
							l_pp := create {CE_POINTER [NATURAL_8]}.make_cast ((strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), (':').code)))
							if (not l_pp.is_void) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							l_pos := -1 + 12 -- goto _L___0
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 11 then -- else:
							if not ((l_pp.c_pointer.to_integer_32).to_natural_32 > (l_q.c_pointer.to_integer_32).to_natural_32) then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if: | _L___0:
							if (not a_user.is_void) then
								a_user.item := l_p
							end
							if (not a_uslen.is_void) then
								a_uslen.item := l_q.distance (l_p)
							end
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 15
				when 14 then -- else:
							if (not a_user.is_void) then
								a_user.item := l_p
							end
							if (not a_uslen.is_void) then
								a_uslen.item := l_pp.distance (l_p)
							end
							if (not a_pass.is_void) then
								a_pass.item := l_pp + 1
							end
							if (not a_palen.is_void) then
								a_palen.item := (l_q.distance (l_pp)) - 1
							end
				when 15 then -- if done
							l_p := l_q + 1
				when 16 then -- if done
							l_q := l_p + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), ce_string (":/?"))).to_integer_32
							if not (l_q.item).to_boolean then
								if (protocols[l_a].need_slash_after_host).to_boolean then
									Result := (-1)
									js.return
								end
							end
				when 17 then -- if done
						if not js.return_called then
							if (not a_host.is_void) then
								a_host.item := l_p
							end
							if (not a_holen.is_void) then
								a_holen.item := l_q.distance (l_p)
							end
							if (l_q.item).to_integer_32 = 58 then
								l_pp___0 := l_q + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_q), ce_string ("/"))).to_integer_32
								if (l_pp___0.item).to_integer_32 /= 47 then
									if (protocols[l_a].need_slash_after_host).to_boolean then
										Result := (-1)
										js.return
									end
								end
								if not js.return_called then
									if (not a_port.is_void) then
										a_port.item := l_q + 1
									end
									if (not a_polen.is_void) then
										a_polen.item := (l_pp___0.distance (l_q)) - 1
									end
									l_cc := 0
									from
									until
										not (not js.loop_done and then (l_cc < (l_pp___0.distance (l_q)) - 1))
									loop
										if (l_q[(l_cc + 1)]).to_integer_32 < 48 then
											Result := (-1)
											js.return
										elseif (l_q[(l_cc + 1)]).to_integer_32 > 57 then
											Result := (-1)
											js.return
										end
										if not js.return_called then
											l_cc := l_cc + 1
										end
									end
								end
								if not js.return_called then
									l_q := l_pp___0
								end
							end
						end
						if not js.return_called then
							if (l_q.item).to_boolean then
								if (l_q.item).to_integer_32 /= 63 then
									l_q := l_q + 1
								end
							end
							l_p := l_q
							l_p_c[0] := (1).to_natural_8
							l_p_c[1] := (0).to_natural_8
							l_q := l_p + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_p), create {CE_POINTER [INTEGER_8]}.make_cast (l_p_c))).to_integer_32
							if (not a_data.is_void) then
								a_data.item := l_p
							end
							if (not a_dalen.is_void) then
								a_dalen.item := l_q.distance (l_p)
							end
							if (not a_post.is_void) then
								if (l_q.item).to_boolean then
									a_post.item := l_q + 1
								else
									a_post.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								end
							end
							Result := 0
						end
				when 18 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	translate_directories (a_url: CE_POINTER [NATURAL_8])
		local
			l_dd: CE_POINTER [NATURAL_8]
			l_s: CE_POINTER [NATURAL_8]
			l_d: CE_POINTER [NATURAL_8]
			l_lo: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___9: INTEGER_32
			l_tmp___11: INTEGER_32
			l_tmp___12: CE_POINTER [NATURAL_8]
			l_tmp___14: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___17: CE_POINTER [NATURAL_8]
			l_tmp___18: NATURAL_8
			l_tmp___19: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_dd.make
			create l_s.make
			create l_d.make
			create l_tmp___12.make
			create l_tmp___17.make
			create l_tmp___19.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dd := (get_url_data (a_url))
					if (links_inst.casecmp (a_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file://")), (7).to_natural_32)).to_boolean then
						l_tmp___1 := 0
					else
						l_tmp___1 := 1
					end
					l_lo := l_tmp___1
					if l_dd.is_void then
						js.return
					elseif l_dd.is_equal (a_url) then
						js.return
					end
					if js.return_called then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_lo.to_boolean then
							l_tmp___3 := (os_dep_inst.dir_sep ((l_dd.item).to_integer_8))
						else
							l_tmp___3 := ((l_dd.item).to_integer_32 = 47).to_integer
						end
						if not l_tmp___3.to_boolean then
							l_dd := l_dd - 1
						end
						l_s := l_dd
						l_d := l_dd
				when 2 then -- r:
						if (links_inst.end_of_dir (l_s[0])).to_boolean then
							memmove (create {CE_POINTER [ANY]}.make_cast (l_d), create {CE_POINTER [ANY]}.make_cast (l_s), (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_s))) + {NATURAL_32} 1).do_nothing
							js.return
						end
				when 3 then -- if done
					if js.return_called then
						l_pos := -1 + 21 -- skip if block
					end
				when 4 then -- if:
						if l_lo.to_boolean then
							l_tmp___7 := (os_dep_inst.dir_sep ((l_s[0]).to_integer_8))
						else
							l_tmp___7 := ((l_s[0]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___7.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 5 then -- if:
						if (l_s[1]).to_integer_32 /= 46 then
							l_pos := -1 + 9 -- skip if block
						end
				when 6 then -- if:
						if l_lo.to_boolean then
							l_tmp___9 := (os_dep_inst.dir_sep ((l_s[2]).to_integer_8))
						else
							l_tmp___9 := ((l_s[2]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___9.to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if l_s.is_equal (l_dd) then
							if not (l_s[3]).to_boolean then
								l_pos := -1 + 20 -- goto p
							end
						end
				when 8 then
						l_s := l_s + (2)
						l_pos := -1 + 2 -- goto r
				when 9 then -- if done | if done
						if l_lo.to_boolean then
							l_tmp___14 := (os_dep_inst.dir_sep ((l_s[0]).to_integer_8))
						else
							l_tmp___14 := ((l_s[0]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___14.to_boolean) then
							l_pos := -1 + 20 -- skip if block
						end
				when 10 then -- if:
						if (l_s[1]).to_integer_32 /= 46 then
							l_pos := -1 + 20 -- skip if block
						end
				when 11 then -- if:
						if (l_s[2]).to_integer_32 /= 46 then
							l_pos := -1 + 20 -- skip if block
						end
				when 12 then -- if:
						if l_lo.to_boolean then
							l_tmp___16 := (os_dep_inst.dir_sep ((l_s[3]).to_integer_8))
						else
							l_tmp___16 := ((l_s[3]).to_integer_32 = 47).to_integer
						end
						if not (l_tmp___16.to_boolean) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						l_pos := -1 + 16 -- goto _L
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 15 then -- else:
						if (l_s[3]).to_boolean then
							l_pos := -1 + 20 -- skip if block
						end
				when 16 then -- if: | _L:
						if not ((l_d.c_pointer.to_integer_32).to_natural_32 > (l_dd.c_pointer.to_integer_32).to_natural_32) then
							l_pos := -1 + 19 -- skip loop
						end
				when 17 then -- loop body:
						l_d := l_d - 1
						if l_lo.to_boolean then
							l_tmp___11 := (os_dep_inst.dir_sep ((l_d.item).to_integer_8))
						else
							l_tmp___11 := ((l_d.item).to_integer_32 = 47).to_integer
						end
						if l_tmp___11.to_boolean then
							l_pos := -1 + 19 -- goto b
						end
				when 18 then
						l_pos := -1 + 16 -- back to loop condition
				when 19 then -- b:
						if not (l_s[3]).to_boolean then
							l_tmp___12 := l_d
							l_d := l_d + 1
							l_tmp___12.item := l_s.item
						end
						l_s := l_s + (3)
						l_pos := -1 + 2 -- goto r
				when 20 then -- if done | if done | if done | if done | p:
						l_tmp___17 := l_d
						l_d := l_d + 1
						l_tmp___19 := l_s
						l_s := l_s + 1
						l_tmp___18 := l_tmp___19.item
						l_tmp___17.item := l_tmp___18
						if l_tmp___18.to_boolean then
							l_pos := -1 + 2 -- goto r
						end
				when 21 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	translate_url (a_url: CE_POINTER [NATURAL_8]; a_cwd: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_url: CE_POINTER [NATURAL_8]
			l_ch: CE_POINTER [NATURAL_8]
			l_nu: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_da: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_prefix: CE_POINTER [NATURAL_8]
			l_sl: INTEGER_32
			l_f: CE_POINTER [NATURAL_8]
			l_e: CE_POINTER [NATURAL_8]
			l_i: INTEGER_32
			l_tld: CE_ARRAY [CE_POINTER [NATURAL_8]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_url.make
			create l_ch.make
			create l_nu.make (<<1>>)
			create l_da.make (<<1>>)
			create l_prefix.make
			create l_f.make
			create l_e.make
			create l_tld.make (<<21>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_url := a_url
					from
					until
						(l_url.item).to_integer_32 /= 32
					loop
						l_url := l_url + 1
					end
					if not (links_inst.casecmp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("proxy://")), l_url, (8).to_natural_32)).to_boolean then
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						if not (parse_url (l_url, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), l_da, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
							l_nu.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 366, l_url)
							insert_wd (l_nu, a_cwd)
							translate_directories (l_nu.item)
							Result := (l_nu.item)
							js.return
						end
					end
					if not js.return_called then
						if (not (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), 1)).is_void) then
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							js.return
						end
					end
					if not js.return_called then
						if (not (strstr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ce_string ("://"))).is_void) then
							l_nu.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 373, l_url)
							links_inst.add_to_strn (l_nu, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							if not (parse_url (l_nu.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
								insert_wd (l_nu, a_cwd)
								translate_directories (l_nu.item)
								Result := (l_nu.item)
								js.return
							end
							if not js.return_called then
								error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 380, create {CE_POINTER [ANY]}.make_cast (l_nu.item))
							end
						end
					end
					if js.return_called then
						l_pos := -1 + 20 -- skip if block
					end
				when 1 then -- if:
						l_ch := l_url + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ce_string (".:/@"))).to_integer_32
						l_prefix := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file://"))
						l_sl := 0
						if (l_ch.item).to_integer_32 = 58 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 20
				when 4 then -- else:
						if (l_url[(strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ce_string ("/@"))).to_integer_32]).to_integer_32 /= 64 then
							l_pos := -1 + 20 -- skip if block
						end
				when 5 then -- if: | _L:
						if (l_url.item).to_integer_32 = 46 then
							l_pos := -1 + 18 -- skip if block
						end
				when 6 then -- if:
						if (l_ch.item).to_integer_32 /= 46 then
							l_pos := -1 + 18 -- skip if block
						end
				when 7 then -- if:
						l_e := l_ch + 1
						from
						until
							js.loop_done
						loop
							l_f := l_e + (strcspn (create {CE_POINTER [INTEGER_8]}.make_cast (l_e), ce_string (".:/"))).to_integer_32
							if (l_f.item).to_integer_32 /= 46 then
								js.break
							end
							if not js.loop_jumped then
								l_e := l_f + 1
							end
						end
						l_i := 0
				when 8 then -- loop condition:
						if not (l_i < l_f.distance (l_e)) then
							l_pos := -1 + 11 -- skip loop
						end
				when 9 then -- loop body:
						if (l_e[l_i]).to_integer_32 >= 48 then
							if (l_e[l_i]).to_integer_32 <= 57 then
								l_pos := -1 + 12 -- goto http
							end
						end
				when 10 then
						l_i := l_i + 1
						l_pos := -1 + 8 -- back to loop condition
				when 11 then -- loop done
						if l_f.distance (l_e) /= 2 then
							l_pos := -1 + 14 -- skip if block
						end
				when 12 then -- if: | http:
						l_prefix := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("http://"))
						l_sl := 1
				when 13 then -- if block done, skip else block:
						l_pos := -1 + 18
				when 14 then -- else:
						l_tld[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("com"))
						l_tld[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("edu"))
						l_tld[2] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("net"))
						l_tld[3] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("org"))
						l_tld[4] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gov"))
						l_tld[5] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mil"))
						l_tld[6] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("int"))
						l_tld[7] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("arpa"))
						l_tld[8] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("aero"))
						l_tld[9] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("biz"))
						l_tld[10] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("coop"))
						l_tld[11] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("info"))
						l_tld[12] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("museum"))
						l_tld[13] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("name"))
						l_tld[14] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("pro"))
						l_tld[15] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cat"))
						l_tld[16] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("jobs"))
						l_tld[17] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mobi"))
						l_tld[18] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("travel"))
						l_tld[19] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tel"))
						l_tld[20] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						l_i := 0
				when 15 then -- loop condition:
						if (l_tld[l_i]).is_void then
							l_pos := -1 + 18 -- skip loop
						end
				when 16 then -- loop body:
						if (l_f.distance (l_e)).to_natural_32 = (strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_tld[l_i]))) then
							if not (links_inst.casecmp (l_tld[l_i], l_e, (l_f.distance (l_e)).to_natural_32)).to_boolean then
								l_pos := -1 + 12 -- goto http
							end
						end
				when 17 then
						l_i := l_i + 1
						l_pos := -1 + 15 -- back to loop condition
				when 18 then -- loop done | if done | if done | if done
						if (l_ch.item).to_integer_32 = 64 then
							l_prefix := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp://"))
							l_sl := 1
						elseif (l_ch.item).to_integer_32 = 58 then
							l_prefix := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp://"))
							l_sl := 1
						elseif not (links_inst.cmpbeg (l_url, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp.")))).to_boolean then
							l_prefix := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ftp://"))
							l_sl := 1
						end
						l_pos := -1 + 19 -- goto set_prefix
				when 19 then -- set_prefix:
						l_nu.item := links_inst.debug_stracpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 402, l_prefix)
						links_inst.add_to_strn (l_nu, l_url)
						if l_sl.to_boolean then
							if (strchr (create {CE_POINTER [INTEGER_8]}.make_cast (l_url), ('/').code)).is_void then
								links_inst.add_to_strn (l_nu, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							end
						end
						if (parse_url (l_nu.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 405, create {CE_POINTER [ANY]}.make_cast (l_nu.item))
							l_nu.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						else
							insert_wd (l_nu, a_cwd)
							translate_directories (l_nu.item)
						end
						Result := (l_nu.item)
						js.return
				when 20 then -- if done | if done
						if not js.return_called then
							l_nu.item := links_inst.debug_memacpy (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 418, l_url, (l_ch.distance (l_url)) + 1)
							links_inst.add_to_strn (l_nu, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("//")))
							links_inst.add_to_strn (l_nu, l_ch + 1)
							if not (parse_url (l_nu.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
								insert_wd (l_nu, a_cwd)
								translate_directories (l_nu.item)
								Result := (l_nu.item)
								js.return
							end
						end
						if not js.return_called then
							links_inst.add_to_strn (l_nu, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("/")))
							if not (parse_url (l_nu.item, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer), create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer))).to_boolean then
								insert_wd (l_nu, a_cwd)
								translate_directories (l_nu.item)
								Result := (l_nu.item)
								js.return
							end
						end
						if not js.return_called then
							error_inst.debug_mem_free (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("url.c")), 432, create {CE_POINTER [ANY]}.make_cast (l_nu.item))
							Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
				when 21 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
