deferred class
	S_SIGNAL

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	kill (a___pid: INTEGER_32; a___sig: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return kill($a___pid, $a___sig);"
		end

	raise (a___sig: INTEGER_32): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return raise($a___sig);"
		end

	sigaction (a___sig: INTEGER_32; a___act: CE_POINTER [SD_SIGACTION]; a___oact: CE_POINTER [SD_SIGACTION]): INTEGER_32
		do
			Result := c_sigaction (a___sig, a___act.c_pointer, a___oact.c_pointer)
		end

	c_sigaction (a___sig: INTEGER_32; a___act: POINTER; a___oact: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sigaction($a___sig, $a___act, $a___oact);"
		end

	sigfillset (a___set: CE_POINTER [SD_SIGSET_T]): INTEGER_32
		do
			Result := c_sigfillset (a___set.c_pointer)
		end

	c_sigfillset (a___set: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return sigfillset($a___set);"
		end

	signal (a___sig: INTEGER_32; a___handler: CE_ROUTINE): CE_ROUTINE
		do
			create Result.make_shared (c_signal (a___sig, a___handler.c_pointer))
		end

	c_signal (a___sig: INTEGER_32; a___handler: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return signal($a___sig, $a___handler);"
		end

end
