class
	PD_ATTR_ENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ae_u.make
		end

feature {ANY} -- fields

	ae_attr: INTEGER_16 assign set_ae_attr

	ae_u: PD_AE_U assign set_ae_u

feature {ANY} -- setters

	set_ae_attr (a_ae_attr: INTEGER_16)
		do
			ae_attr := a_ae_attr
			update_memory_field ("ae_attr")
		end

	set_ae_u (a_ae_u: PD_AE_U)
		do
			ae_u := a_ae_u
			update_memory_field ("ae_u")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ae_attr := a_other.ae_attr
			ae_u := a_other.ae_u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ae_attr = a_other.ae_attr and
				ae_u.is_equal (a_other.ae_u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ae_attr"),
					create {CE_STRUCTURE_FIELD}.make ("ae_u")
				>>)
			init_structure_info
		end

end
