class
	PD_BUFFBLOCK

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create b_next.make
			create b_str.make (<<1>>)
		end

feature {ANY} -- fields

	b_next: CE_POINTER [PD_BUFFBLOCK] assign set_b_next

	b_str: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_b_next (a_b_next: CE_POINTER [PD_BUFFBLOCK])
		do
			b_next := a_b_next
			update_memory_field ("b_next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			b_next := a_other.b_next
			b_str := a_other.b_str.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				b_next.is_equal (a_other.b_next) and
				b_str.is_equal (a_other.b_str)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("b_next"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("b_str", <<1>>)
				>>)
			init_structure_info
		end

end
