class
	PD_CTERM

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	fg_color: NATURAL_16 assign set_fg_color

	bg_color: NATURAL_16 assign set_bg_color

feature {ANY} -- setters

	set_fg_color (a_fg_color: NATURAL_16)
		do
			fg_color := a_fg_color
			update_memory_field ("fg_color")
		end

	set_bg_color (a_bg_color: NATURAL_16)
		do
			bg_color := a_bg_color
			update_memory_field ("bg_color")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fg_color := a_other.fg_color
			bg_color := a_other.bg_color
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fg_color = a_other.fg_color and
				bg_color = a_other.bg_color
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fg_color"),
					create {CE_STRUCTURE_FIELD}.make ("bg_color")
				>>)
			init_structure_info
		end

end
