class
	PD_ESLIST_ELEM

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create next.make
		end

feature {ANY} -- fields

	saved_emsg_silent: INTEGER_32 assign set_saved_emsg_silent

	next: CE_POINTER [PD_ESLIST_ELEM] assign set_next

feature {ANY} -- setters

	set_saved_emsg_silent (a_saved_emsg_silent: INTEGER_32)
		do
			saved_emsg_silent := a_saved_emsg_silent
			update_memory_field ("saved_emsg_silent")
		end

	set_next (a_next: CE_POINTER [PD_ESLIST_ELEM])
		do
			next := a_next
			update_memory_field ("next")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			saved_emsg_silent := a_other.saved_emsg_silent
			next := a_other.next
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				saved_emsg_silent = a_other.saved_emsg_silent and
				next.is_equal (a_other.next)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("saved_emsg_silent"),
					create {CE_STRUCTURE_FIELD}.make ("next")
				>>)
			init_structure_info
		end

end
