class
	PD_FMTPATTERN

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create pattern.make
		end

feature {ANY} -- fields

	convchar: NATURAL_8 assign set_convchar

	pattern: CE_POINTER [INTEGER_8] assign set_pattern

feature {ANY} -- setters

	set_convchar (a_convchar: NATURAL_8)
		do
			convchar := a_convchar
			update_memory_field ("convchar")
		end

	set_pattern (a_pattern: CE_POINTER [INTEGER_8])
		do
			pattern := a_pattern
			update_memory_field ("pattern")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			convchar := a_other.convchar
			pattern := a_other.pattern
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				convchar = a_other.convchar and
				pattern.is_equal (a_other.pattern)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("convchar"),
					create {CE_STRUCTURE_FIELD}.make ("pattern")
				>>)
			init_structure_info
		end

end
