class
	PD_FOLDINFO

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	fi_level: INTEGER_32 assign set_fi_level

	fi_lnum: INTEGER_32 assign set_fi_lnum

	fi_low_level: INTEGER_32 assign set_fi_low_level

feature {ANY} -- setters

	set_fi_level (a_fi_level: INTEGER_32)
		do
			fi_level := a_fi_level
			update_memory_field ("fi_level")
		end

	set_fi_lnum (a_fi_lnum: INTEGER_32)
		do
			fi_lnum := a_fi_lnum
			update_memory_field ("fi_lnum")
		end

	set_fi_low_level (a_fi_low_level: INTEGER_32)
		do
			fi_low_level := a_fi_low_level
			update_memory_field ("fi_low_level")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			fi_level := a_other.fi_level
			fi_lnum := a_other.fi_lnum
			fi_low_level := a_other.fi_low_level
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fi_level = a_other.fi_level and
				fi_lnum = a_other.fi_lnum and
				fi_low_level = a_other.fi_low_level
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("fi_level"),
					create {CE_STRUCTURE_FIELD}.make ("fi_lnum"),
					create {CE_STRUCTURE_FIELD}.make ("fi_low_level")
				>>)
			init_structure_info
		end

end
