class
	PD_HL_GROUP

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sg_name.make
			create sg_name_u.make
			create sg_start.make
			create sg_stop.make
			create sg_font.make
			create sg_font_name.make
			create sg_gui_fg_name.make
			create sg_gui_bg_name.make
			create sg_gui_sp_name.make
		end

feature {ANY} -- fields

	sg_name: CE_POINTER [NATURAL_8] assign set_sg_name

	sg_name_u: CE_POINTER [NATURAL_8] assign set_sg_name_u

	sg_term: INTEGER_32 assign set_sg_term

	sg_start: CE_POINTER [NATURAL_8] assign set_sg_start

	sg_stop: CE_POINTER [NATURAL_8] assign set_sg_stop

	sg_term_attr: INTEGER_32 assign set_sg_term_attr

	sg_cterm: INTEGER_32 assign set_sg_cterm

	sg_cterm_bold: INTEGER_32 assign set_sg_cterm_bold

	sg_cterm_fg: INTEGER_32 assign set_sg_cterm_fg

	sg_cterm_bg: INTEGER_32 assign set_sg_cterm_bg

	sg_cterm_attr: INTEGER_32 assign set_sg_cterm_attr

	sg_gui_fg: INTEGER_32 assign set_sg_gui_fg

	sg_gui_bg: INTEGER_32 assign set_sg_gui_bg

	sg_gui_sp: INTEGER_32 assign set_sg_gui_sp

	sg_font: CE_POINTER [ANY] assign set_sg_font

	sg_font_name: CE_POINTER [NATURAL_8] assign set_sg_font_name

	sg_gui_attr: INTEGER_32 assign set_sg_gui_attr

	sg_gui: INTEGER_32 assign set_sg_gui

	sg_gui_fg_name: CE_POINTER [NATURAL_8] assign set_sg_gui_fg_name

	sg_gui_bg_name: CE_POINTER [NATURAL_8] assign set_sg_gui_bg_name

	sg_gui_sp_name: CE_POINTER [NATURAL_8] assign set_sg_gui_sp_name

	sg_link: INTEGER_32 assign set_sg_link

	sg_set: INTEGER_32 assign set_sg_set

	sg_scriptID: INTEGER_32 assign set_sg_scriptID

feature {ANY} -- setters

	set_sg_name (a_sg_name: CE_POINTER [NATURAL_8])
		do
			sg_name := a_sg_name
			update_memory_field ("sg_name")
		end

	set_sg_name_u (a_sg_name_u: CE_POINTER [NATURAL_8])
		do
			sg_name_u := a_sg_name_u
			update_memory_field ("sg_name_u")
		end

	set_sg_term (a_sg_term: INTEGER_32)
		do
			sg_term := a_sg_term
			update_memory_field ("sg_term")
		end

	set_sg_start (a_sg_start: CE_POINTER [NATURAL_8])
		do
			sg_start := a_sg_start
			update_memory_field ("sg_start")
		end

	set_sg_stop (a_sg_stop: CE_POINTER [NATURAL_8])
		do
			sg_stop := a_sg_stop
			update_memory_field ("sg_stop")
		end

	set_sg_term_attr (a_sg_term_attr: INTEGER_32)
		do
			sg_term_attr := a_sg_term_attr
			update_memory_field ("sg_term_attr")
		end

	set_sg_cterm (a_sg_cterm: INTEGER_32)
		do
			sg_cterm := a_sg_cterm
			update_memory_field ("sg_cterm")
		end

	set_sg_cterm_bold (a_sg_cterm_bold: INTEGER_32)
		do
			sg_cterm_bold := a_sg_cterm_bold
			update_memory_field ("sg_cterm_bold")
		end

	set_sg_cterm_fg (a_sg_cterm_fg: INTEGER_32)
		do
			sg_cterm_fg := a_sg_cterm_fg
			update_memory_field ("sg_cterm_fg")
		end

	set_sg_cterm_bg (a_sg_cterm_bg: INTEGER_32)
		do
			sg_cterm_bg := a_sg_cterm_bg
			update_memory_field ("sg_cterm_bg")
		end

	set_sg_cterm_attr (a_sg_cterm_attr: INTEGER_32)
		do
			sg_cterm_attr := a_sg_cterm_attr
			update_memory_field ("sg_cterm_attr")
		end

	set_sg_gui_fg (a_sg_gui_fg: INTEGER_32)
		do
			sg_gui_fg := a_sg_gui_fg
			update_memory_field ("sg_gui_fg")
		end

	set_sg_gui_bg (a_sg_gui_bg: INTEGER_32)
		do
			sg_gui_bg := a_sg_gui_bg
			update_memory_field ("sg_gui_bg")
		end

	set_sg_gui_sp (a_sg_gui_sp: INTEGER_32)
		do
			sg_gui_sp := a_sg_gui_sp
			update_memory_field ("sg_gui_sp")
		end

	set_sg_font (a_sg_font: CE_POINTER [ANY])
		do
			sg_font := a_sg_font
			update_memory_field ("sg_font")
		end

	set_sg_font_name (a_sg_font_name: CE_POINTER [NATURAL_8])
		do
			sg_font_name := a_sg_font_name
			update_memory_field ("sg_font_name")
		end

	set_sg_gui_attr (a_sg_gui_attr: INTEGER_32)
		do
			sg_gui_attr := a_sg_gui_attr
			update_memory_field ("sg_gui_attr")
		end

	set_sg_gui (a_sg_gui: INTEGER_32)
		do
			sg_gui := a_sg_gui
			update_memory_field ("sg_gui")
		end

	set_sg_gui_fg_name (a_sg_gui_fg_name: CE_POINTER [NATURAL_8])
		do
			sg_gui_fg_name := a_sg_gui_fg_name
			update_memory_field ("sg_gui_fg_name")
		end

	set_sg_gui_bg_name (a_sg_gui_bg_name: CE_POINTER [NATURAL_8])
		do
			sg_gui_bg_name := a_sg_gui_bg_name
			update_memory_field ("sg_gui_bg_name")
		end

	set_sg_gui_sp_name (a_sg_gui_sp_name: CE_POINTER [NATURAL_8])
		do
			sg_gui_sp_name := a_sg_gui_sp_name
			update_memory_field ("sg_gui_sp_name")
		end

	set_sg_link (a_sg_link: INTEGER_32)
		do
			sg_link := a_sg_link
			update_memory_field ("sg_link")
		end

	set_sg_set (a_sg_set: INTEGER_32)
		do
			sg_set := a_sg_set
			update_memory_field ("sg_set")
		end

	set_sg_scriptID (a_sg_scriptID: INTEGER_32)
		do
			sg_scriptID := a_sg_scriptID
			update_memory_field ("sg_scriptID")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sg_name := a_other.sg_name
			sg_name_u := a_other.sg_name_u
			sg_term := a_other.sg_term
			sg_start := a_other.sg_start
			sg_stop := a_other.sg_stop
			sg_term_attr := a_other.sg_term_attr
			sg_cterm := a_other.sg_cterm
			sg_cterm_bold := a_other.sg_cterm_bold
			sg_cterm_fg := a_other.sg_cterm_fg
			sg_cterm_bg := a_other.sg_cterm_bg
			sg_cterm_attr := a_other.sg_cterm_attr
			sg_gui_fg := a_other.sg_gui_fg
			sg_gui_bg := a_other.sg_gui_bg
			sg_gui_sp := a_other.sg_gui_sp
			sg_font := a_other.sg_font
			sg_font_name := a_other.sg_font_name
			sg_gui_attr := a_other.sg_gui_attr
			sg_gui := a_other.sg_gui
			sg_gui_fg_name := a_other.sg_gui_fg_name
			sg_gui_bg_name := a_other.sg_gui_bg_name
			sg_gui_sp_name := a_other.sg_gui_sp_name
			sg_link := a_other.sg_link
			sg_set := a_other.sg_set
			sg_scriptID := a_other.sg_scriptID
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sg_name.is_equal (a_other.sg_name) and
				sg_name_u.is_equal (a_other.sg_name_u) and
				sg_term = a_other.sg_term and
				sg_start.is_equal (a_other.sg_start) and
				sg_stop.is_equal (a_other.sg_stop) and
				sg_term_attr = a_other.sg_term_attr and
				sg_cterm = a_other.sg_cterm and
				sg_cterm_bold = a_other.sg_cterm_bold and
				sg_cterm_fg = a_other.sg_cterm_fg and
				sg_cterm_bg = a_other.sg_cterm_bg and
				sg_cterm_attr = a_other.sg_cterm_attr and
				sg_gui_fg = a_other.sg_gui_fg and
				sg_gui_bg = a_other.sg_gui_bg and
				sg_gui_sp = a_other.sg_gui_sp and
				sg_font.is_equal (a_other.sg_font) and
				sg_font_name.is_equal (a_other.sg_font_name) and
				sg_gui_attr = a_other.sg_gui_attr and
				sg_gui = a_other.sg_gui and
				sg_gui_fg_name.is_equal (a_other.sg_gui_fg_name) and
				sg_gui_bg_name.is_equal (a_other.sg_gui_bg_name) and
				sg_gui_sp_name.is_equal (a_other.sg_gui_sp_name) and
				sg_link = a_other.sg_link and
				sg_set = a_other.sg_set and
				sg_scriptID = a_other.sg_scriptID
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sg_name"),
					create {CE_STRUCTURE_FIELD}.make ("sg_name_u"),
					create {CE_STRUCTURE_FIELD}.make ("sg_term"),
					create {CE_STRUCTURE_FIELD}.make ("sg_start"),
					create {CE_STRUCTURE_FIELD}.make ("sg_stop"),
					create {CE_STRUCTURE_FIELD}.make ("sg_term_attr"),
					create {CE_STRUCTURE_FIELD}.make ("sg_cterm"),
					create {CE_STRUCTURE_FIELD}.make ("sg_cterm_bold"),
					create {CE_STRUCTURE_FIELD}.make ("sg_cterm_fg"),
					create {CE_STRUCTURE_FIELD}.make ("sg_cterm_bg"),
					create {CE_STRUCTURE_FIELD}.make ("sg_cterm_attr"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_fg"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_bg"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_sp"),
					create {CE_STRUCTURE_FIELD}.make ("sg_font"),
					create {CE_STRUCTURE_FIELD}.make ("sg_font_name"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_attr"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_fg_name"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_bg_name"),
					create {CE_STRUCTURE_FIELD}.make ("sg_gui_sp_name"),
					create {CE_STRUCTURE_FIELD}.make ("sg_link"),
					create {CE_STRUCTURE_FIELD}.make ("sg_set"),
					create {CE_STRUCTURE_FIELD}.make ("sg_scriptID")
				>>)
			init_structure_info
		end

end
