class
	PD_KEY_NAME_ENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
		end

feature {ANY} -- fields

	key: INTEGER_32 assign set_key

	name: CE_POINTER [NATURAL_8] assign set_name

feature {ANY} -- setters

	set_key (a_key: INTEGER_32)
		do
			key := a_key
			update_memory_field ("key")
		end

	set_name (a_name: CE_POINTER [NATURAL_8])
		do
			name := a_name
			update_memory_field ("name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			key := a_other.key
			name := a_other.name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				key = a_other.key and
				name.is_equal (a_other.name)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("key"),
					create {CE_STRUCTURE_FIELD}.make ("name")
				>>)
			init_structure_info
		end

end
