class
	PD_PRT_MEDIASIZE_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
		end

feature {ANY} -- fields

	name: CE_POINTER [INTEGER_8] assign set_name

	width: REAL_32 assign set_width

	height: REAL_32 assign set_height

feature {ANY} -- setters

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_width (a_width: REAL_32)
		do
			width := a_width
			update_memory_field ("width")
		end

	set_height (a_height: REAL_32)
		do
			height := a_height
			update_memory_field ("height")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name
			width := a_other.width
			height := a_other.height
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				width = a_other.width and
				height = a_other.height
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("width"),
					create {CE_STRUCTURE_FIELD}.make ("height")
				>>)
			init_structure_info
		end

end
