class
	PD_SIGNALINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make
		end

feature {ANY} -- fields

	sig: INTEGER_32 assign set_sig

	name: CE_POINTER [INTEGER_8] assign set_name

	deadly: INTEGER_8 assign set_deadly

feature {ANY} -- setters

	set_sig (a_sig: INTEGER_32)
		do
			sig := a_sig
			update_memory_field ("sig")
		end

	set_name (a_name: CE_POINTER [INTEGER_8])
		do
			name := a_name
			update_memory_field ("name")
		end

	set_deadly (a_deadly: INTEGER_8)
		do
			deadly := a_deadly
			update_memory_field ("deadly")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sig := a_other.sig
			name := a_other.name
			deadly := a_other.deadly
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sig = a_other.sig and
				name.is_equal (a_other.name) and
				deadly = a_other.deadly
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("sig"),
					create {CE_STRUCTURE_FIELD}.make ("name"),
					create {CE_STRUCTURE_FIELD}.make ("deadly")
				>>)
			init_structure_info
		end

end
