class
	PD_SYL_ITEM_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sy_chars.make (<<30>>)
		end

feature {ANY} -- fields

	sy_chars: CE_ARRAY [NATURAL_8]

	sy_len: INTEGER_32 assign set_sy_len

feature {ANY} -- setters

	set_sy_len (a_sy_len: INTEGER_32)
		do
			sy_len := a_sy_len
			update_memory_field ("sy_len")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			sy_chars := a_other.sy_chars.twin
			sy_len := a_other.sy_len
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				sy_chars.is_equal (a_other.sy_chars) and
				sy_len = a_other.sy_len
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("sy_chars", <<30>>),
					create {CE_STRUCTURE_FIELD}.make ("sy_len")
				>>)
			init_structure_info
		end

end
