class
	PD_WORDCOUNT_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create wc_word.make (<<1>>)
		end

feature {ANY} -- fields

	wc_count: NATURAL_16 assign set_wc_count

	wc_word: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_wc_count (a_wc_count: NATURAL_16)
		do
			wc_count := a_wc_count
			update_memory_field ("wc_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			wc_count := a_other.wc_count
			wc_word := a_other.wc_word.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				wc_count = a_other.wc_count and
				wc_word.is_equal (a_other.wc_word)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("wc_count"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("wc_word", <<1>>)
				>>)
			init_structure_info
		end

end
