frozen class
	VIM_INITIALIZER_SLICE14

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			eval_inst.functions[6].f_name := ce_string ("argv")
			eval_inst.functions[6].f_min_argc := (0).to_integer_8
			eval_inst.functions[6].f_max_argc := (1).to_integer_8
			eval_inst.functions[6].f_func := eval_inst.f_argv_address
			eval_inst.functions[7].f_name := ce_string ("asin")
			eval_inst.functions[7].f_min_argc := (1).to_integer_8
			eval_inst.functions[7].f_max_argc := (1).to_integer_8
			eval_inst.functions[7].f_func := eval_inst.f_asin_address
			eval_inst.functions[8].f_name := ce_string ("atan")
			eval_inst.functions[8].f_min_argc := (1).to_integer_8
			eval_inst.functions[8].f_max_argc := (1).to_integer_8
			eval_inst.functions[8].f_func := eval_inst.f_atan_address
			eval_inst.functions[9].f_name := ce_string ("atan2")
			eval_inst.functions[9].f_min_argc := (2).to_integer_8
			eval_inst.functions[9].f_max_argc := (2).to_integer_8
			eval_inst.functions[9].f_func := eval_inst.f_atan2_address
			eval_inst.functions[10].f_name := ce_string ("browse")
			eval_inst.functions[10].f_min_argc := (4).to_integer_8
			eval_inst.functions[10].f_max_argc := (4).to_integer_8
			eval_inst.functions[10].f_func := eval_inst.f_browse_address
			eval_inst.functions[11].f_name := ce_string ("browsedir")
			eval_inst.functions[11].f_min_argc := (2).to_integer_8
			eval_inst.functions[11].f_max_argc := (2).to_integer_8
			eval_inst.functions[11].f_func := eval_inst.f_browsedir_address
			eval_inst.functions[12].f_name := ce_string ("bufexists")
			eval_inst.functions[12].f_min_argc := (1).to_integer_8
			eval_inst.functions[12].f_max_argc := (1).to_integer_8
			eval_inst.functions[12].f_func := eval_inst.f_bufexists_address
			eval_inst.functions[13].f_name := ce_string ("buffer_exists")
			eval_inst.functions[13].f_min_argc := (1).to_integer_8
			eval_inst.functions[13].f_max_argc := (1).to_integer_8
			eval_inst.functions[13].f_func := eval_inst.f_bufexists_address
			eval_inst.functions[14].f_name := ce_string ("buffer_name")
			eval_inst.functions[14].f_min_argc := (1).to_integer_8
			eval_inst.functions[14].f_max_argc := (1).to_integer_8
			eval_inst.functions[14].f_func := eval_inst.f_bufname_address
			eval_inst.functions[15].f_name := ce_string ("buffer_number")
			eval_inst.functions[15].f_min_argc := (1).to_integer_8
			eval_inst.functions[15].f_max_argc := (1).to_integer_8
			eval_inst.functions[15].f_func := eval_inst.f_bufnr_address
			eval_inst.functions[16].f_name := ce_string ("buflisted")
			eval_inst.functions[16].f_min_argc := (1).to_integer_8
			eval_inst.functions[16].f_max_argc := (1).to_integer_8
			eval_inst.functions[16].f_func := eval_inst.f_buflisted_address
			eval_inst.functions[17].f_name := ce_string ("bufloaded")
			eval_inst.functions[17].f_min_argc := (1).to_integer_8
			eval_inst.functions[17].f_max_argc := (1).to_integer_8
			eval_inst.functions[17].f_func := eval_inst.f_bufloaded_address
			eval_inst.functions[18].f_name := ce_string ("bufname")
			eval_inst.functions[18].f_min_argc := (1).to_integer_8
			eval_inst.functions[18].f_max_argc := (1).to_integer_8
			eval_inst.functions[18].f_func := eval_inst.f_bufname_address
			eval_inst.functions[19].f_name := ce_string ("bufnr")
			eval_inst.functions[19].f_min_argc := (1).to_integer_8
			eval_inst.functions[19].f_max_argc := (2).to_integer_8
			eval_inst.functions[19].f_func := eval_inst.f_bufnr_address
			eval_inst.functions[20].f_name := ce_string ("bufwinnr")
			eval_inst.functions[20].f_min_argc := (1).to_integer_8
			eval_inst.functions[20].f_max_argc := (1).to_integer_8
			eval_inst.functions[20].f_func := eval_inst.f_bufwinnr_address
			eval_inst.functions[21].f_name := ce_string ("byte2line")
			eval_inst.functions[21].f_min_argc := (1).to_integer_8
			eval_inst.functions[21].f_max_argc := (1).to_integer_8
			eval_inst.functions[21].f_func := eval_inst.f_byte2line_address
			eval_inst.functions[22].f_name := ce_string ("byteidx")
			eval_inst.functions[22].f_min_argc := (2).to_integer_8
			eval_inst.functions[22].f_max_argc := (2).to_integer_8
			eval_inst.functions[22].f_func := eval_inst.f_byteidx_address
			eval_inst.functions[23].f_name := ce_string ("call")
			eval_inst.functions[23].f_min_argc := (2).to_integer_8
			eval_inst.functions[23].f_max_argc := (3).to_integer_8
			eval_inst.functions[23].f_func := eval_inst.f_call_address
			eval_inst.functions[24].f_name := ce_string ("ceil")
			eval_inst.functions[24].f_min_argc := (1).to_integer_8
			eval_inst.functions[24].f_max_argc := (1).to_integer_8
			eval_inst.functions[24].f_func := eval_inst.f_ceil_address
			eval_inst.functions[25].f_name := ce_string ("changenr")
			eval_inst.functions[25].f_min_argc := (0).to_integer_8
			eval_inst.functions[25].f_max_argc := (0).to_integer_8
			eval_inst.functions[25].f_func := eval_inst.f_changenr_address
			eval_inst.functions[26].f_name := ce_string ("char2nr")
			eval_inst.functions[26].f_min_argc := (1).to_integer_8
			eval_inst.functions[26].f_max_argc := (1).to_integer_8
			eval_inst.functions[26].f_func := eval_inst.f_char2nr_address
			eval_inst.functions[27].f_name := ce_string ("cindent")
			eval_inst.functions[27].f_min_argc := (1).to_integer_8
			eval_inst.functions[27].f_max_argc := (1).to_integer_8
			eval_inst.functions[27].f_func := eval_inst.f_cindent_address
			eval_inst.functions[28].f_name := ce_string ("clearmatches")
			eval_inst.functions[28].f_min_argc := (0).to_integer_8
			eval_inst.functions[28].f_max_argc := (0).to_integer_8
			eval_inst.functions[28].f_func := eval_inst.f_clearmatches_address
			eval_inst.functions[29].f_name := ce_string ("col")
			eval_inst.functions[29].f_min_argc := (1).to_integer_8
			eval_inst.functions[29].f_max_argc := (1).to_integer_8
			eval_inst.functions[29].f_func := eval_inst.f_col_address
			eval_inst.functions[30].f_name := ce_string ("complete")
			eval_inst.functions[30].f_min_argc := (2).to_integer_8
			eval_inst.functions[30].f_max_argc := (2).to_integer_8
			eval_inst.functions[30].f_func := eval_inst.f_complete_address
			eval_inst.functions[31].f_name := ce_string ("complete_add")
			eval_inst.functions[31].f_min_argc := (1).to_integer_8
			eval_inst.functions[31].f_max_argc := (1).to_integer_8
			eval_inst.functions[31].f_func := eval_inst.f_complete_add_address
			eval_inst.functions[32].f_name := ce_string ("complete_check")
			eval_inst.functions[32].f_min_argc := (0).to_integer_8
			eval_inst.functions[32].f_max_argc := (0).to_integer_8
			eval_inst.functions[32].f_func := eval_inst.f_complete_check_address
			eval_inst.functions[33].f_name := ce_string ("confirm")
			eval_inst.functions[33].f_min_argc := (1).to_integer_8
			eval_inst.functions[33].f_max_argc := (4).to_integer_8
			eval_inst.functions[33].f_func := eval_inst.f_confirm_address
			eval_inst.functions[34].f_name := ce_string ("copy")
			eval_inst.functions[34].f_min_argc := (1).to_integer_8
			eval_inst.functions[34].f_max_argc := (1).to_integer_8
			eval_inst.functions[34].f_func := eval_inst.f_copy_address
			eval_inst.functions[35].f_name := ce_string ("cos")
			eval_inst.functions[35].f_min_argc := (1).to_integer_8
			eval_inst.functions[35].f_max_argc := (1).to_integer_8
			eval_inst.functions[35].f_func := eval_inst.f_cos_address
			eval_inst.functions[36].f_name := ce_string ("cosh")
			eval_inst.functions[36].f_min_argc := (1).to_integer_8
			eval_inst.functions[36].f_max_argc := (1).to_integer_8
			eval_inst.functions[36].f_func := eval_inst.f_cosh_address
			eval_inst.functions[37].f_name := ce_string ("count")
			eval_inst.functions[37].f_min_argc := (2).to_integer_8
			eval_inst.functions[37].f_max_argc := (4).to_integer_8
			eval_inst.functions[37].f_func := eval_inst.f_count_address
			eval_inst.functions[38].f_name := ce_string ("cscope_connection")
			eval_inst.functions[38].f_min_argc := (0).to_integer_8
			eval_inst.functions[38].f_max_argc := (3).to_integer_8
			eval_inst.functions[38].f_func := eval_inst.f_cscope_connection_address
			eval_inst.functions[39].f_name := ce_string ("cursor")
			eval_inst.functions[39].f_min_argc := (1).to_integer_8
			eval_inst.functions[39].f_max_argc := (3).to_integer_8
			eval_inst.functions[39].f_func := eval_inst.f_cursor_address
			eval_inst.functions[40].f_name := ce_string ("deepcopy")
			eval_inst.functions[40].f_min_argc := (1).to_integer_8
			eval_inst.functions[40].f_max_argc := (2).to_integer_8
			eval_inst.functions[40].f_func := eval_inst.f_deepcopy_address
			eval_inst.functions[41].f_name := ce_string ("delete")
			eval_inst.functions[41].f_min_argc := (1).to_integer_8
			eval_inst.functions[41].f_max_argc := (1).to_integer_8
			eval_inst.functions[41].f_func := eval_inst.f_delete_address
			eval_inst.functions[42].f_name := ce_string ("did_filetype")
			eval_inst.functions[42].f_min_argc := (0).to_integer_8
			eval_inst.functions[42].f_max_argc := (0).to_integer_8
			eval_inst.functions[42].f_func := eval_inst.f_did_filetype_address
			eval_inst.functions[43].f_name := ce_string ("diff_filler")
			eval_inst.functions[43].f_min_argc := (1).to_integer_8
			eval_inst.functions[43].f_max_argc := (1).to_integer_8
			eval_inst.functions[43].f_func := eval_inst.f_diff_filler_address
			eval_inst.functions[44].f_name := ce_string ("diff_hlID")
			eval_inst.functions[44].f_min_argc := (2).to_integer_8
			eval_inst.functions[44].f_max_argc := (2).to_integer_8
			eval_inst.functions[44].f_func := eval_inst.f_diff_hlID_address
			eval_inst.functions[45].f_name := ce_string ("empty")
			eval_inst.functions[45].f_min_argc := (1).to_integer_8
			eval_inst.functions[45].f_max_argc := (1).to_integer_8
			eval_inst.functions[45].f_func := eval_inst.f_empty_address
			eval_inst.functions[46].f_name := ce_string ("escape")
			eval_inst.functions[46].f_min_argc := (2).to_integer_8
			eval_inst.functions[46].f_max_argc := (2).to_integer_8
			eval_inst.functions[46].f_func := eval_inst.f_escape_address
			eval_inst.functions[47].f_name := ce_string ("eval")
			eval_inst.functions[47].f_min_argc := (1).to_integer_8
			eval_inst.functions[47].f_max_argc := (1).to_integer_8
			eval_inst.functions[47].f_func := eval_inst.f_eval_address
			eval_inst.functions[48].f_name := ce_string ("eventhandler")
			eval_inst.functions[48].f_min_argc := (0).to_integer_8
			eval_inst.functions[48].f_max_argc := (0).to_integer_8
			eval_inst.functions[48].f_func := eval_inst.f_eventhandler_address
			eval_inst.functions[49].f_name := ce_string ("executable")
			eval_inst.functions[49].f_min_argc := (1).to_integer_8
			eval_inst.functions[49].f_max_argc := (1).to_integer_8
			eval_inst.functions[49].f_func := eval_inst.f_executable_address
			eval_inst.functions[50].f_name := ce_string ("exists")
			eval_inst.functions[50].f_min_argc := (1).to_integer_8
			eval_inst.functions[50].f_max_argc := (1).to_integer_8
			eval_inst.functions[50].f_func := eval_inst.f_exists_address
			eval_inst.functions[51].f_name := ce_string ("exp")
			eval_inst.functions[51].f_min_argc := (1).to_integer_8
			eval_inst.functions[51].f_max_argc := (1).to_integer_8
			eval_inst.functions[51].f_func := eval_inst.f_exp_address
			eval_inst.functions[52].f_name := ce_string ("expand")
			eval_inst.functions[52].f_min_argc := (1).to_integer_8
			eval_inst.functions[52].f_max_argc := (2).to_integer_8
			eval_inst.functions[52].f_func := eval_inst.f_expand_address
			eval_inst.functions[53].f_name := ce_string ("extend")
			eval_inst.functions[53].f_min_argc := (2).to_integer_8
			eval_inst.functions[53].f_max_argc := (3).to_integer_8
			eval_inst.functions[53].f_func := eval_inst.f_extend_address
			eval_inst.functions[54].f_name := ce_string ("feedkeys")
			eval_inst.functions[54].f_min_argc := (1).to_integer_8
			eval_inst.functions[54].f_max_argc := (2).to_integer_8
			eval_inst.functions[54].f_func := eval_inst.f_feedkeys_address
			eval_inst.functions[55].f_name := ce_string ("file_readable")
			eval_inst.functions[55].f_min_argc := (1).to_integer_8
			eval_inst.functions[55].f_max_argc := (1).to_integer_8
			eval_inst.functions[55].f_func := eval_inst.f_filereadable_address
			eval_inst.functions[56].f_name := ce_string ("filereadable")
			eval_inst.functions[56].f_min_argc := (1).to_integer_8
			eval_inst.functions[56].f_max_argc := (1).to_integer_8
			eval_inst.functions[56].f_func := eval_inst.f_filereadable_address
			eval_inst.functions[57].f_name := ce_string ("filewritable")
			eval_inst.functions[57].f_min_argc := (1).to_integer_8
			eval_inst.functions[57].f_max_argc := (1).to_integer_8
			eval_inst.functions[57].f_func := eval_inst.f_filewritable_address
			eval_inst.functions[58].f_name := ce_string ("filter")
			eval_inst.functions[58].f_min_argc := (2).to_integer_8
			eval_inst.functions[58].f_max_argc := (2).to_integer_8
			eval_inst.functions[58].f_func := eval_inst.f_filter_address
			eval_inst.functions[59].f_name := ce_string ("finddir")
			eval_inst.functions[59].f_min_argc := (1).to_integer_8
			eval_inst.functions[59].f_max_argc := (3).to_integer_8
			eval_inst.functions[59].f_func := eval_inst.f_finddir_address
			eval_inst.functions[60].f_name := ce_string ("findfile")
			eval_inst.functions[60].f_min_argc := (1).to_integer_8
			eval_inst.functions[60].f_max_argc := (3).to_integer_8
			eval_inst.functions[60].f_func := eval_inst.f_findfile_address
			eval_inst.functions[61].f_name := ce_string ("float2nr")
			eval_inst.functions[61].f_min_argc := (1).to_integer_8
			eval_inst.functions[61].f_max_argc := (1).to_integer_8
			eval_inst.functions[61].f_func := eval_inst.f_float2nr_address
			eval_inst.functions[62].f_name := ce_string ("floor")
			eval_inst.functions[62].f_min_argc := (1).to_integer_8
			eval_inst.functions[62].f_max_argc := (1).to_integer_8
			eval_inst.functions[62].f_func := eval_inst.f_floor_address
			eval_inst.functions[63].f_name := ce_string ("fmod")
			eval_inst.functions[63].f_min_argc := (2).to_integer_8
			eval_inst.functions[63].f_max_argc := (2).to_integer_8
			eval_inst.functions[63].f_func := eval_inst.f_fmod_address
			eval_inst.functions[64].f_name := ce_string ("fnameescape")
			eval_inst.functions[64].f_min_argc := (1).to_integer_8
			eval_inst.functions[64].f_max_argc := (1).to_integer_8
			eval_inst.functions[64].f_func := eval_inst.f_fnameescape_address
			eval_inst.functions[65].f_name := ce_string ("fnamemodify")
			eval_inst.functions[65].f_min_argc := (2).to_integer_8
			eval_inst.functions[65].f_max_argc := (2).to_integer_8
			eval_inst.functions[65].f_func := eval_inst.f_fnamemodify_address
			eval_inst.functions[66].f_name := ce_string ("foldclosed")
			eval_inst.functions[66].f_min_argc := (1).to_integer_8
			eval_inst.functions[66].f_max_argc := (1).to_integer_8
			eval_inst.functions[66].f_func := eval_inst.f_foldclosed_address
			eval_inst.functions[67].f_name := ce_string ("foldclosedend")
			eval_inst.functions[67].f_min_argc := (1).to_integer_8
			eval_inst.functions[67].f_max_argc := (1).to_integer_8
			eval_inst.functions[67].f_func := eval_inst.f_foldclosedend_address
			eval_inst.functions[68].f_name := ce_string ("foldlevel")
			eval_inst.functions[68].f_min_argc := (1).to_integer_8
			eval_inst.functions[68].f_max_argc := (1).to_integer_8
			eval_inst.functions[68].f_func := eval_inst.f_foldlevel_address
			eval_inst.functions[69].f_name := ce_string ("foldtext")
			eval_inst.functions[69].f_min_argc := (0).to_integer_8
			eval_inst.functions[69].f_max_argc := (0).to_integer_8
			eval_inst.functions[69].f_func := eval_inst.f_foldtext_address
			eval_inst.functions[70].f_name := ce_string ("foldtextresult")
			eval_inst.functions[70].f_min_argc := (1).to_integer_8
			eval_inst.functions[70].f_max_argc := (1).to_integer_8
			eval_inst.functions[70].f_func := eval_inst.f_foldtextresult_address
			eval_inst.functions[71].f_name := ce_string ("foreground")
			eval_inst.functions[71].f_min_argc := (0).to_integer_8
			eval_inst.functions[71].f_max_argc := (0).to_integer_8
			eval_inst.functions[71].f_func := eval_inst.f_foreground_address
			eval_inst.functions[72].f_name := ce_string ("function")
			eval_inst.functions[72].f_min_argc := (1).to_integer_8
			eval_inst.functions[72].f_max_argc := (1).to_integer_8
			eval_inst.functions[72].f_func := eval_inst.f_function_address
			eval_inst.functions[73].f_name := ce_string ("garbagecollect")
			eval_inst.functions[73].f_min_argc := (0).to_integer_8
			eval_inst.functions[73].f_max_argc := (1).to_integer_8
			eval_inst.functions[73].f_func := eval_inst.f_garbagecollect_address
			eval_inst.functions[74].f_name := ce_string ("get")
			eval_inst.functions[74].f_min_argc := (2).to_integer_8
			eval_inst.functions[74].f_max_argc := (3).to_integer_8
			eval_inst.functions[74].f_func := eval_inst.f_get_address
			eval_inst.functions[75].f_name := ce_string ("getbufline")
			eval_inst.functions[75].f_min_argc := (2).to_integer_8
			eval_inst.functions[75].f_max_argc := (3).to_integer_8
			eval_inst.functions[75].f_func := eval_inst.f_getbufline_address
			eval_inst.functions[76].f_name := ce_string ("getbufvar")
			eval_inst.functions[76].f_min_argc := (2).to_integer_8
			eval_inst.functions[76].f_max_argc := (2).to_integer_8
			eval_inst.functions[76].f_func := eval_inst.f_getbufvar_address
			eval_inst.functions[77].f_name := ce_string ("getchar")
			eval_inst.functions[77].f_min_argc := (0).to_integer_8
			eval_inst.functions[77].f_max_argc := (1).to_integer_8
			eval_inst.functions[77].f_func := eval_inst.f_getchar_address
			eval_inst.functions[78].f_name := ce_string ("getcharmod")
			eval_inst.functions[78].f_min_argc := (0).to_integer_8
			eval_inst.functions[78].f_max_argc := (0).to_integer_8
			eval_inst.functions[78].f_func := eval_inst.f_getcharmod_address
			eval_inst.functions[79].f_name := ce_string ("getcmdline")
			eval_inst.functions[79].f_min_argc := (0).to_integer_8
			eval_inst.functions[79].f_max_argc := (0).to_integer_8
			eval_inst.functions[79].f_func := eval_inst.f_getcmdline_address
			eval_inst.functions[80].f_name := ce_string ("getcmdpos")
			eval_inst.functions[80].f_min_argc := (0).to_integer_8
			eval_inst.functions[80].f_max_argc := (0).to_integer_8
			eval_inst.functions[80].f_func := eval_inst.f_getcmdpos_address
			eval_inst.functions[81].f_name := ce_string ("getcmdtype")
			eval_inst.functions[81].f_min_argc := (0).to_integer_8
			eval_inst.functions[81].f_max_argc := (0).to_integer_8
			eval_inst.functions[81].f_func := eval_inst.f_getcmdtype_address
			eval_inst.functions[82].f_name := ce_string ("getcwd")
			eval_inst.functions[82].f_min_argc := (0).to_integer_8
			eval_inst.functions[82].f_max_argc := (0).to_integer_8
			eval_inst.functions[82].f_func := eval_inst.f_getcwd_address
			eval_inst.functions[83].f_name := ce_string ("getfontname")
			eval_inst.functions[83].f_min_argc := (0).to_integer_8
			eval_inst.functions[83].f_max_argc := (1).to_integer_8
			eval_inst.functions[83].f_func := eval_inst.f_getfontname_address
			eval_inst.functions[84].f_name := ce_string ("getfperm")
			eval_inst.functions[84].f_min_argc := (1).to_integer_8
			eval_inst.functions[84].f_max_argc := (1).to_integer_8
			eval_inst.functions[84].f_func := eval_inst.f_getfperm_address
			eval_inst.functions[85].f_name := ce_string ("getfsize")
			eval_inst.functions[85].f_min_argc := (1).to_integer_8
			eval_inst.functions[85].f_max_argc := (1).to_integer_8
			eval_inst.functions[85].f_func := eval_inst.f_getfsize_address
			eval_inst.functions[86].f_name := ce_string ("getftime")
			eval_inst.functions[86].f_min_argc := (1).to_integer_8
			eval_inst.functions[86].f_max_argc := (1).to_integer_8
			eval_inst.functions[86].f_func := eval_inst.f_getftime_address
			eval_inst.functions[87].f_name := ce_string ("getftype")
			eval_inst.functions[87].f_min_argc := (1).to_integer_8
			eval_inst.functions[87].f_max_argc := (1).to_integer_8
			eval_inst.functions[87].f_func := eval_inst.f_getftype_address
			eval_inst.functions[88].f_name := ce_string ("getline")
			eval_inst.functions[88].f_min_argc := (1).to_integer_8
			eval_inst.functions[88].f_max_argc := (2).to_integer_8
			eval_inst.functions[88].f_func := eval_inst.f_getline_address
			eval_inst.functions[89].f_name := ce_string ("getloclist")
			eval_inst.functions[89].f_min_argc := (1).to_integer_8
			eval_inst.functions[89].f_max_argc := (1).to_integer_8
			eval_inst.functions[89].f_func := eval_inst.f_getqflist_address
			eval_inst.functions[90].f_name := ce_string ("getmatches")
			eval_inst.functions[90].f_min_argc := (0).to_integer_8
			eval_inst.functions[90].f_max_argc := (0).to_integer_8
			eval_inst.functions[90].f_func := eval_inst.f_getmatches_address
			eval_inst.functions[91].f_name := ce_string ("getpid")
			eval_inst.functions[91].f_min_argc := (0).to_integer_8
			eval_inst.functions[91].f_max_argc := (0).to_integer_8
			eval_inst.functions[91].f_func := eval_inst.f_getpid_address
			eval_inst.functions[92].f_name := ce_string ("getpos")
			eval_inst.functions[92].f_min_argc := (1).to_integer_8
			eval_inst.functions[92].f_max_argc := (1).to_integer_8
			eval_inst.functions[92].f_func := eval_inst.f_getpos_address
			eval_inst.functions[93].f_name := ce_string ("getqflist")
			eval_inst.functions[93].f_min_argc := (0).to_integer_8
			eval_inst.functions[93].f_max_argc := (0).to_integer_8
			eval_inst.functions[93].f_func := eval_inst.f_getqflist_address
			eval_inst.functions[94].f_name := ce_string ("getreg")
			eval_inst.functions[94].f_min_argc := (0).to_integer_8
			eval_inst.functions[94].f_max_argc := (2).to_integer_8
			eval_inst.functions[94].f_func := eval_inst.f_getreg_address
			eval_inst.functions[95].f_name := ce_string ("getregtype")
			eval_inst.functions[95].f_min_argc := (0).to_integer_8
			eval_inst.functions[95].f_max_argc := (1).to_integer_8
			eval_inst.functions[95].f_func := eval_inst.f_getregtype_address
			eval_inst.functions[96].f_name := ce_string ("gettabvar")
			eval_inst.functions[96].f_min_argc := (2).to_integer_8
			eval_inst.functions[96].f_max_argc := (2).to_integer_8
			eval_inst.functions[96].f_func := eval_inst.f_gettabvar_address
			eval_inst.functions[97].f_name := ce_string ("gettabwinvar")
			eval_inst.functions[97].f_min_argc := (3).to_integer_8
			eval_inst.functions[97].f_max_argc := (3).to_integer_8
			eval_inst.functions[97].f_func := eval_inst.f_gettabwinvar_address
			eval_inst.functions[98].f_name := ce_string ("getwinposx")
			eval_inst.functions[98].f_min_argc := (0).to_integer_8
			eval_inst.functions[98].f_max_argc := (0).to_integer_8
			eval_inst.functions[98].f_func := eval_inst.f_getwinposx_address
			eval_inst.functions[99].f_name := ce_string ("getwinposy")
			eval_inst.functions[99].f_min_argc := (0).to_integer_8
			eval_inst.functions[99].f_max_argc := (0).to_integer_8
			eval_inst.functions[99].f_func := eval_inst.f_getwinposy_address
			eval_inst.functions[100].f_name := ce_string ("getwinvar")
			eval_inst.functions[100].f_min_argc := (2).to_integer_8
			eval_inst.functions[100].f_max_argc := (2).to_integer_8
			eval_inst.functions[100].f_func := eval_inst.f_getwinvar_address
			eval_inst.functions[101].f_name := ce_string ("glob")
			eval_inst.functions[101].f_min_argc := (1).to_integer_8
			eval_inst.functions[101].f_max_argc := (2).to_integer_8
			eval_inst.functions[101].f_func := eval_inst.f_glob_address
			eval_inst.functions[102].f_name := ce_string ("globpath")
			eval_inst.functions[102].f_min_argc := (2).to_integer_8
			eval_inst.functions[102].f_max_argc := (3).to_integer_8
			eval_inst.functions[102].f_func := eval_inst.f_globpath_address
			eval_inst.functions[103].f_name := ce_string ("has")
			eval_inst.functions[103].f_min_argc := (1).to_integer_8
			eval_inst.functions[103].f_max_argc := (1).to_integer_8
			eval_inst.functions[103].f_func := eval_inst.f_has_address
			eval_inst.functions[104].f_name := ce_string ("has_key")
			eval_inst.functions[104].f_min_argc := (2).to_integer_8
			eval_inst.functions[104].f_max_argc := (2).to_integer_8
			eval_inst.functions[104].f_func := eval_inst.f_has_key_address
			eval_inst.functions[105].f_name := ce_string ("haslocaldir")
			eval_inst.functions[105].f_min_argc := (0).to_integer_8
			eval_inst.functions[105].f_max_argc := (0).to_integer_8
			eval_inst.functions[105].f_func := eval_inst.f_haslocaldir_address
			eval_inst.functions[106].f_name := ce_string ("hasmapto")
			eval_inst.functions[106].f_min_argc := (1).to_integer_8
			eval_inst.functions[106].f_max_argc := (3).to_integer_8
			eval_inst.functions[106].f_func := eval_inst.f_hasmapto_address
			eval_inst.functions[107].f_name := ce_string ("highlightID")
			eval_inst.functions[107].f_min_argc := (1).to_integer_8
			eval_inst.functions[107].f_max_argc := (1).to_integer_8
			eval_inst.functions[107].f_func := eval_inst.f_hlID_address
			eval_inst.functions[108].f_name := ce_string ("highlight_exists")
			eval_inst.functions[108].f_min_argc := (1).to_integer_8
			eval_inst.functions[108].f_max_argc := (1).to_integer_8
			eval_inst.functions[108].f_func := eval_inst.f_hlexists_address
			eval_inst.functions[109].f_name := ce_string ("histadd")
			eval_inst.functions[109].f_min_argc := (2).to_integer_8
			eval_inst.functions[109].f_max_argc := (2).to_integer_8
			eval_inst.functions[109].f_func := eval_inst.f_histadd_address
			eval_inst.functions[110].f_name := ce_string ("histdel")
			eval_inst.functions[110].f_min_argc := (1).to_integer_8
			eval_inst.functions[110].f_max_argc := (2).to_integer_8
			eval_inst.functions[110].f_func := eval_inst.f_histdel_address
			eval_inst.functions[111].f_name := ce_string ("histget")
			eval_inst.functions[111].f_min_argc := (1).to_integer_8
			eval_inst.functions[111].f_max_argc := (2).to_integer_8
			eval_inst.functions[111].f_func := eval_inst.f_histget_address
			eval_inst.functions[112].f_name := ce_string ("histnr")
			eval_inst.functions[112].f_min_argc := (1).to_integer_8
			eval_inst.functions[112].f_max_argc := (1).to_integer_8
			eval_inst.functions[112].f_func := eval_inst.f_histnr_address
			eval_inst.functions[113].f_name := ce_string ("hlID")
			eval_inst.functions[113].f_min_argc := (1).to_integer_8
			eval_inst.functions[113].f_max_argc := (1).to_integer_8
			eval_inst.functions[113].f_func := eval_inst.f_hlID_address
			eval_inst.functions[114].f_name := ce_string ("hlexists")
			eval_inst.functions[114].f_min_argc := (1).to_integer_8
			eval_inst.functions[114].f_max_argc := (1).to_integer_8
			eval_inst.functions[114].f_func := eval_inst.f_hlexists_address
			eval_inst.functions[115].f_name := ce_string ("hostname")
			eval_inst.functions[115].f_min_argc := (0).to_integer_8
			eval_inst.functions[115].f_max_argc := (0).to_integer_8
			eval_inst.functions[115].f_func := eval_inst.f_hostname_address
			eval_inst.functions[116].f_name := ce_string ("iconv")
			eval_inst.functions[116].f_min_argc := (3).to_integer_8
			eval_inst.functions[116].f_max_argc := (3).to_integer_8
			eval_inst.functions[116].f_func := eval_inst.f_iconv_address
			eval_inst.functions[117].f_name := ce_string ("indent")
			eval_inst.functions[117].f_min_argc := (1).to_integer_8
			eval_inst.functions[117].f_max_argc := (1).to_integer_8
			eval_inst.functions[117].f_func := eval_inst.f_indent_address
			eval_inst.functions[118].f_name := ce_string ("index")
			eval_inst.functions[118].f_min_argc := (2).to_integer_8
			eval_inst.functions[118].f_max_argc := (4).to_integer_8
			eval_inst.functions[118].f_func := eval_inst.f_index_address
			eval_inst.functions[119].f_name := ce_string ("input")
			eval_inst.functions[119].f_min_argc := (1).to_integer_8
			eval_inst.functions[119].f_max_argc := (3).to_integer_8
			eval_inst.functions[119].f_func := eval_inst.f_input_address
			eval_inst.functions[120].f_name := ce_string ("inputdialog")
			eval_inst.functions[120].f_min_argc := (1).to_integer_8
			eval_inst.functions[120].f_max_argc := (3).to_integer_8
			eval_inst.functions[120].f_func := eval_inst.f_inputdialog_address
			eval_inst.functions[121].f_name := ce_string ("inputlist")
			eval_inst.functions[121].f_min_argc := (1).to_integer_8
			eval_inst.functions[121].f_max_argc := (1).to_integer_8
			eval_inst.functions[121].f_func := eval_inst.f_inputlist_address
			eval_inst.functions[122].f_name := ce_string ("inputrestore")
			eval_inst.functions[122].f_min_argc := (0).to_integer_8
			eval_inst.functions[122].f_max_argc := (0).to_integer_8
			eval_inst.functions[122].f_func := eval_inst.f_inputrestore_address
			eval_inst.functions[123].f_name := ce_string ("inputsave")
			eval_inst.functions[123].f_min_argc := (0).to_integer_8
			eval_inst.functions[123].f_max_argc := (0).to_integer_8
			eval_inst.functions[123].f_func := eval_inst.f_inputsave_address
			eval_inst.functions[124].f_name := ce_string ("inputsecret")
			eval_inst.functions[124].f_min_argc := (1).to_integer_8
			eval_inst.functions[124].f_max_argc := (2).to_integer_8
			eval_inst.functions[124].f_func := eval_inst.f_inputsecret_address
			eval_inst.functions[125].f_name := ce_string ("insert")
			eval_inst.functions[125].f_min_argc := (2).to_integer_8
			eval_inst.functions[125].f_max_argc := (3).to_integer_8
			eval_inst.functions[125].f_func := eval_inst.f_insert_address
			eval_inst.functions[126].f_name := ce_string ("isdirectory")
			eval_inst.functions[126].f_min_argc := (1).to_integer_8
			eval_inst.functions[126].f_max_argc := (1).to_integer_8
			eval_inst.functions[126].f_func := eval_inst.f_isdirectory_address
			eval_inst.functions[127].f_name := ce_string ("islocked")
			eval_inst.functions[127].f_min_argc := (1).to_integer_8
			eval_inst.functions[127].f_max_argc := (1).to_integer_8
			eval_inst.functions[127].f_func := eval_inst.f_islocked_address
			eval_inst.functions[128].f_name := ce_string ("items")
			eval_inst.functions[128].f_min_argc := (1).to_integer_8
			eval_inst.functions[128].f_max_argc := (1).to_integer_8
			eval_inst.functions[128].f_func := eval_inst.f_items_address
			eval_inst.functions[129].f_name := ce_string ("join")
			eval_inst.functions[129].f_min_argc := (1).to_integer_8
			eval_inst.functions[129].f_max_argc := (2).to_integer_8
			eval_inst.functions[129].f_func := eval_inst.f_join_address
			eval_inst.functions[130].f_name := ce_string ("keys")
			eval_inst.functions[130].f_min_argc := (1).to_integer_8
			eval_inst.functions[130].f_max_argc := (1).to_integer_8
			eval_inst.functions[130].f_func := eval_inst.f_keys_address
		end

end
