class
	SD_FD_SET

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create fds_bits.make (<<1_024 // (8 * ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)>>)
		end

feature {ANY} -- fields

	fds_bits: CE_ARRAY [INTEGER_32]

feature {ANY}

	copy (a_other: like Current)
		do
			fds_bits := a_other.fds_bits.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				fds_bits.is_equal (a_other.fds_bits)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("fds_bits", <<1_024 // (8 * ({PLATFORM}.Integer_32_bytes.to_natural_32).to_integer_32)>>)
				>>)
			init_structure_info
		end

end
