class
	SD_GDKCURSOR

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	type: INTEGER_32 assign set_type

	ref_count: NATURAL_32 assign set_ref_count

feature {ANY} -- setters

	set_type (a_type: INTEGER_32)
		do
			type := a_type
			update_memory_field ("type")
		end

	set_ref_count (a_ref_count: NATURAL_32)
		do
			ref_count := a_ref_count
			update_memory_field ("ref_count")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			type := a_other.type
			ref_count := a_other.ref_count
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				type = a_other.type and
				ref_count = a_other.ref_count
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("type"),
					create {CE_STRUCTURE_FIELD}.make ("ref_count")
				>>)
			init_structure_info
		end

end
