class
	SD_GDKDEVICEAXIS

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	use: NATURAL_32 assign set_use

	min: REAL_64 assign set_min

	max: REAL_64 assign set_max

feature {ANY} -- setters

	set_use (a_use: NATURAL_32)
		do
			use := a_use
			update_memory_field ("use")
		end

	set_min (a_min: REAL_64)
		do
			min := a_min
			update_memory_field ("min")
		end

	set_max (a_max: REAL_64)
		do
			max := a_max
			update_memory_field ("max")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			use := a_other.use
			min := a_other.min
			max := a_other.max
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				use = a_other.use and
				min = a_other.min and
				max = a_other.max
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("use"),
					create {CE_STRUCTURE_FIELD}.make ("min"),
					create {CE_STRUCTURE_FIELD}.make ("max")
				>>)
			init_structure_info
		end

end
