class
	SD_GTKIMAGESTOCKDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create stock_id.make
		end

feature {ANY} -- fields

	stock_id: CE_POINTER [INTEGER_8] assign set_stock_id

feature {ANY} -- setters

	set_stock_id (a_stock_id: CE_POINTER [INTEGER_8])
		do
			stock_id := a_stock_id
			update_memory_field ("stock_id")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			stock_id := a_other.stock_id
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				stock_id.is_equal (a_other.stock_id)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("stock_id")
				>>)
			init_structure_info
		end

end
