class
	SD_GVALUE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create data.make (<<2>>)
		end

feature {ANY} -- fields

	g_type: NATURAL_32 assign set_g_type

	data: CE_ARRAY [SD_DATA]

feature {ANY} -- setters

	set_g_type (a_g_type: NATURAL_32)
		do
			g_type := a_g_type
			update_memory_field ("g_type")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			g_type := a_other.g_type
			data := a_other.data.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				g_type = a_other.g_type and
				data.is_equal (a_other.data)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("g_type"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("data", <<2>>)
				>>)
			init_structure_info
		end

end
