deferred class
	S_GDK_GDK

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	gdk_atom_intern (a_atom_name: CE_POINTER [INTEGER_8]; a_only_if_exists: INTEGER_32): CE_POINTER [ANY]
		do
			create Result.make_shared (c_gdk_atom_intern (a_atom_name.c_pointer, a_only_if_exists))
		end

	c_gdk_atom_intern (a_atom_name: POINTER; a_only_if_exists: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_atom_intern($a_atom_name, $a_only_if_exists);"
		end

	gdk_bitmap_create_from_data (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_data: CE_POINTER [INTEGER_8]; a_width: INTEGER_32; a_height: INTEGER_32): CE_POINTER [SD_GDKDRAWABLE]
		do
			create Result.make_shared (c_gdk_bitmap_create_from_data (a_drawable.c_pointer, a_data.c_pointer, a_width, a_height))
		end

	c_gdk_bitmap_create_from_data (a_drawable: POINTER; a_data: POINTER; a_width: INTEGER_32; a_height: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_bitmap_create_from_data($a_drawable, $a_data, $a_width, $a_height);"
		end

	gdk_color_parse (a_spec: CE_POINTER [INTEGER_8]; a_color: CE_POINTER [SD_GDKCOLOR]): INTEGER_32
		do
			Result := c_gdk_color_parse (a_spec.c_pointer, a_color.c_pointer)
		end

	c_gdk_color_parse (a_spec: POINTER; a_color: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_color_parse($a_spec, $a_color);"
		end

	gdk_colormap_alloc_color (a_colormap: CE_POINTER [SD_GDKCOLORMAP]; a_color: CE_POINTER [SD_GDKCOLOR]; a_writeable: INTEGER_32; a_best_match: INTEGER_32): INTEGER_32
		do
			Result := c_gdk_colormap_alloc_color (a_colormap.c_pointer, a_color.c_pointer, a_writeable, a_best_match)
		end

	c_gdk_colormap_alloc_color (a_colormap: POINTER; a_color: POINTER; a_writeable: INTEGER_32; a_best_match: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_colormap_alloc_color($a_colormap, $a_color, $a_writeable, $a_best_match);"
		end

	gdk_colormap_query_color (a_colormap: CE_POINTER [SD_GDKCOLORMAP]; a_pixel: NATURAL_32; a_result: CE_POINTER [SD_GDKCOLOR])
		do
			c_gdk_colormap_query_color (a_colormap.c_pointer, a_pixel, a_result.c_pointer)
		end

	c_gdk_colormap_query_color (a_colormap: POINTER; a_pixel: NATURAL_32; a_result: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_colormap_query_color($a_colormap, $a_pixel, $a_result);"
		end

	gdk_cursor_new_for_display (a_display: CE_POINTER [SD_GDKDISPLAY]; a_cursor_type: INTEGER_32): CE_POINTER [SD_GDKCURSOR]
		do
			create Result.make_shared (c_gdk_cursor_new_for_display (a_display.c_pointer, a_cursor_type))
		end

	c_gdk_cursor_new_for_display (a_display: POINTER; a_cursor_type: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_cursor_new_for_display($a_display, $a_cursor_type);"
		end

	gdk_cursor_new_from_pixmap (a_source: CE_POINTER [SD_GDKDRAWABLE]; a_mask: CE_POINTER [SD_GDKDRAWABLE]; a_fg: CE_POINTER [SD_GDKCOLOR]; a_bg: CE_POINTER [SD_GDKCOLOR]; a_x: INTEGER_32; a_y: INTEGER_32): CE_POINTER [SD_GDKCURSOR]
		do
			create Result.make_shared (c_gdk_cursor_new_from_pixmap (a_source.c_pointer, a_mask.c_pointer, a_fg.c_pointer, a_bg.c_pointer, a_x, a_y))
		end

	c_gdk_cursor_new_from_pixmap (a_source: POINTER; a_mask: POINTER; a_fg: POINTER; a_bg: POINTER; a_x: INTEGER_32; a_y: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_cursor_new_from_pixmap($a_source, $a_mask, $a_fg, $a_bg, $a_x, $a_y);"
		end

	gdk_cursor_unref (a_cursor: CE_POINTER [SD_GDKCURSOR])
		do
			c_gdk_cursor_unref (a_cursor.c_pointer)
		end

	c_gdk_cursor_unref (a_cursor: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_cursor_unref($a_cursor);"
		end

	gdk_display_beep (a_display: CE_POINTER [SD_GDKDISPLAY])
		do
			c_gdk_display_beep (a_display.c_pointer)
		end

	c_gdk_display_beep (a_display: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_display_beep($a_display);"
		end

	gdk_display_get_default: CE_POINTER [SD_GDKDISPLAY]
		do
			create Result.make_shared (c_gdk_display_get_default)
		end

	c_gdk_display_get_default: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_display_get_default();"
		end

	gdk_display_sync (a_display: CE_POINTER [SD_GDKDISPLAY])
		do
			c_gdk_display_sync (a_display.c_pointer)
		end

	c_gdk_display_sync (a_display: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_display_sync($a_display);"
		end

	gdk_draw_drawable (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_gc: CE_POINTER [SD_GDKGC]; a_src: CE_POINTER [SD_GDKDRAWABLE]; a_xsrc: INTEGER_32; a_ysrc: INTEGER_32; a_xdest: INTEGER_32; a_ydest: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		do
			c_gdk_draw_drawable (a_drawable.c_pointer, a_gc.c_pointer, a_src.c_pointer, a_xsrc, a_ysrc, a_xdest, a_ydest, a_width, a_height)
		end

	c_gdk_draw_drawable (a_drawable: POINTER; a_gc: POINTER; a_src: POINTER; a_xsrc: INTEGER_32; a_ysrc: INTEGER_32; a_xdest: INTEGER_32; a_ydest: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_draw_drawable($a_drawable, $a_gc, $a_src, $a_xsrc, $a_ysrc, $a_xdest, $a_ydest, $a_width, $a_height);"
		end

	gdk_draw_glyphs (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_gc: CE_POINTER [SD_GDKGC]; a_font: CE_POINTER [ANY]; a_x: INTEGER_32; a_y: INTEGER_32; a_glyphs: CE_POINTER [SD_PANGOGLYPHSTRING])
		do
			c_gdk_draw_glyphs (a_drawable.c_pointer, a_gc.c_pointer, a_font.c_pointer, a_x, a_y, a_glyphs.c_pointer)
		end

	c_gdk_draw_glyphs (a_drawable: POINTER; a_gc: POINTER; a_font: POINTER; a_x: INTEGER_32; a_y: INTEGER_32; a_glyphs: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_draw_glyphs($a_drawable, $a_gc, $a_font, $a_x, $a_y, $a_glyphs);"
		end

	gdk_draw_line (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_gc: CE_POINTER [SD_GDKGC]; a_x1_: INTEGER_32; a_y1_: INTEGER_32; a_x2_: INTEGER_32; a_y2_: INTEGER_32)
		do
			c_gdk_draw_line (a_drawable.c_pointer, a_gc.c_pointer, a_x1_, a_y1_, a_x2_, a_y2_)
		end

	c_gdk_draw_line (a_drawable: POINTER; a_gc: POINTER; a_x1_: INTEGER_32; a_y1_: INTEGER_32; a_x2_: INTEGER_32; a_y2_: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_draw_line($a_drawable, $a_gc, $a_x1_, $a_y1_, $a_x2_, $a_y2_);"
		end

	gdk_draw_point (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_gc: CE_POINTER [SD_GDKGC]; a_x: INTEGER_32; a_y: INTEGER_32)
		do
			c_gdk_draw_point (a_drawable.c_pointer, a_gc.c_pointer, a_x, a_y)
		end

	c_gdk_draw_point (a_drawable: POINTER; a_gc: POINTER; a_x: INTEGER_32; a_y: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_draw_point($a_drawable, $a_gc, $a_x, $a_y);"
		end

	gdk_draw_rectangle (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_gc: CE_POINTER [SD_GDKGC]; a_filled: INTEGER_32; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		do
			c_gdk_draw_rectangle (a_drawable.c_pointer, a_gc.c_pointer, a_filled, a_x, a_y, a_width, a_height)
		end

	c_gdk_draw_rectangle (a_drawable: POINTER; a_gc: POINTER; a_filled: INTEGER_32; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_draw_rectangle($a_drawable, $a_gc, $a_filled, $a_x, $a_y, $a_width, $a_height);"
		end

	gdk_drawable_get_size (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_width: CE_POINTER [INTEGER_32]; a_height: CE_POINTER [INTEGER_32])
		do
			c_gdk_drawable_get_size (a_drawable.c_pointer, a_width.c_pointer, a_height.c_pointer)
		end

	c_gdk_drawable_get_size (a_drawable: POINTER; a_width: POINTER; a_height: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_drawable_get_size($a_drawable, $a_width, $a_height);"
		end

	gdk_event_free (a_event: CE_POINTER [SD_GDKEVENT])
		do
			c_gdk_event_free (a_event.c_pointer)
		end

	c_gdk_event_free (a_event: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_event_free($a_event);"
		end

	gdk_event_get_graphics_expose (a_window: CE_POINTER [SD_GDKDRAWABLE]): CE_POINTER [SD_GDKEVENT]
		do
			create Result.make_shared (c_gdk_event_get_graphics_expose (a_window.c_pointer))
		end

	c_gdk_event_get_graphics_expose (a_window: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_event_get_graphics_expose($a_window);"
		end

	gdk_event_new (a_type: INTEGER_32): CE_POINTER [SD_GDKEVENT]
		do
			create Result.make_shared (c_gdk_event_new (a_type))
		end

	c_gdk_event_new (a_type: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_event_new($a_type);"
		end

	gdk_gc_new (a_drawable: CE_POINTER [SD_GDKDRAWABLE]): CE_POINTER [SD_GDKGC]
		do
			create Result.make_shared (c_gdk_gc_new (a_drawable.c_pointer))
		end

	c_gdk_gc_new (a_drawable: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_gc_new($a_drawable);"
		end

	gdk_gc_new_with_values (a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_values: CE_POINTER [SD_GDKGCVALUES]; a_values_mask: NATURAL_32): CE_POINTER [SD_GDKGC]
		do
			create Result.make_shared (c_gdk_gc_new_with_values (a_drawable.c_pointer, a_values.c_pointer, a_values_mask))
		end

	c_gdk_gc_new_with_values (a_drawable: POINTER; a_values: POINTER; a_values_mask: NATURAL_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_gc_new_with_values($a_drawable, $a_values, $a_values_mask);"
		end

	gdk_gc_set_background (a_gc: CE_POINTER [SD_GDKGC]; a_color: CE_POINTER [SD_GDKCOLOR])
		do
			c_gdk_gc_set_background (a_gc.c_pointer, a_color.c_pointer)
		end

	c_gdk_gc_set_background (a_gc: POINTER; a_color: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_gc_set_background($a_gc, $a_color);"
		end

	gdk_gc_set_clip_origin (a_gc: CE_POINTER [SD_GDKGC]; a_x: INTEGER_32; a_y: INTEGER_32)
		do
			c_gdk_gc_set_clip_origin (a_gc.c_pointer, a_x, a_y)
		end

	c_gdk_gc_set_clip_origin (a_gc: POINTER; a_x: INTEGER_32; a_y: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_gc_set_clip_origin($a_gc, $a_x, $a_y);"
		end

	gdk_gc_set_clip_rectangle (a_gc: CE_POINTER [SD_GDKGC]; a_rectangle: CE_POINTER [SD_GDKRECTANGLE])
		do
			c_gdk_gc_set_clip_rectangle (a_gc.c_pointer, a_rectangle.c_pointer)
		end

	c_gdk_gc_set_clip_rectangle (a_gc: POINTER; a_rectangle: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_gc_set_clip_rectangle($a_gc, $a_rectangle);"
		end

	gdk_gc_set_exposures (a_gc: CE_POINTER [SD_GDKGC]; a_exposures: INTEGER_32)
		do
			c_gdk_gc_set_exposures (a_gc.c_pointer, a_exposures)
		end

	c_gdk_gc_set_exposures (a_gc: POINTER; a_exposures: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_gc_set_exposures($a_gc, $a_exposures);"
		end

	gdk_gc_set_foreground (a_gc: CE_POINTER [SD_GDKGC]; a_color: CE_POINTER [SD_GDKCOLOR])
		do
			c_gdk_gc_set_foreground (a_gc.c_pointer, a_color.c_pointer)
		end

	c_gdk_gc_set_foreground (a_gc: POINTER; a_color: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_gc_set_foreground($a_gc, $a_color);"
		end

	gdk_input_add (a_source: INTEGER_32; a_condition: NATURAL_32; a_function: CE_ROUTINE; a_data: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_gdk_input_add (a_source, a_condition, a_function.c_pointer, a_data.c_pointer)
		end

	c_gdk_input_add (a_source: INTEGER_32; a_condition: NATURAL_32; a_function: POINTER; a_data: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_input_add($a_source, $a_condition, $a_function, $a_data);"
		end

	gdk_input_remove (a_tag: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_input_remove($a_tag);"
		end

	gdk_keyval_from_name (a_keyval_name: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_gdk_keyval_from_name (a_keyval_name.c_pointer)
		end

	c_gdk_keyval_from_name (a_keyval_name: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_keyval_from_name($a_keyval_name);"
		end

	gdk_keyval_to_unicode (a_keyval: NATURAL_32): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_keyval_to_unicode($a_keyval);"
		end

	gdk_pixbuf_render_to_drawable_alpha (a_pixbuf: CE_POINTER [ANY]; a_drawable: CE_POINTER [SD_GDKDRAWABLE]; a_src_x: INTEGER_32; a_src_y: INTEGER_32; a_dest_x: INTEGER_32; a_dest_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32; a_alpha_mode: NATURAL_32; a_alpha_threshold: INTEGER_32; a_dither: NATURAL_32; a_x_dither: INTEGER_32; a_y_dither: INTEGER_32)
		do
			c_gdk_pixbuf_render_to_drawable_alpha (a_pixbuf.c_pointer, a_drawable.c_pointer, a_src_x, a_src_y, a_dest_x, a_dest_y, a_width, a_height, a_alpha_mode, a_alpha_threshold, a_dither, a_x_dither, a_y_dither)
		end

	c_gdk_pixbuf_render_to_drawable_alpha (a_pixbuf: POINTER; a_drawable: POINTER; a_src_x: INTEGER_32; a_src_y: INTEGER_32; a_dest_x: INTEGER_32; a_dest_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32; a_alpha_mode: NATURAL_32; a_alpha_threshold: INTEGER_32; a_dither: NATURAL_32; a_x_dither: INTEGER_32; a_y_dither: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_pixbuf_render_to_drawable_alpha($a_pixbuf, $a_drawable, $a_src_x, $a_src_y, $a_dest_x, $a_dest_y, $a_width, $a_height, $a_alpha_mode, $a_alpha_threshold, $a_dither, $a_x_dither, $a_y_dither);"
		end

	gdk_region_empty (a_region: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_gdk_region_empty (a_region.c_pointer)
		end

	c_gdk_region_empty (a_region: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_region_empty($a_region);"
		end

	gdk_region_get_clipbox (a_region: CE_POINTER [ANY]; a_rectangle: CE_POINTER [SD_GDKRECTANGLE])
		do
			c_gdk_region_get_clipbox (a_region.c_pointer, a_rectangle.c_pointer)
		end

	c_gdk_region_get_clipbox (a_region: POINTER; a_rectangle: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_region_get_clipbox($a_region, $a_rectangle);"
		end

	gdk_screen_get_default: CE_POINTER [SD_GDKSCREEN]
		do
			create Result.make_shared (c_gdk_screen_get_default)
		end

	c_gdk_screen_get_default: POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_screen_get_default();"
		end

	gdk_screen_get_height (a_screen: CE_POINTER [SD_GDKSCREEN]): INTEGER_32
		do
			Result := c_gdk_screen_get_height (a_screen.c_pointer)
		end

	c_gdk_screen_get_height (a_screen: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_screen_get_height($a_screen);"
		end

	gdk_screen_get_width (a_screen: CE_POINTER [SD_GDKSCREEN]): INTEGER_32
		do
			Result := c_gdk_screen_get_width (a_screen.c_pointer)
		end

	c_gdk_screen_get_width (a_screen: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_screen_get_width($a_screen);"
		end

	gdk_window_add_filter (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_function: CE_ROUTINE; a_data: CE_POINTER [ANY])
		do
			c_gdk_window_add_filter (a_window.c_pointer, a_function.c_pointer, a_data.c_pointer)
		end

	c_gdk_window_add_filter (a_window: POINTER; a_function: POINTER; a_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_add_filter($a_window, $a_function, $a_data);"
		end

	gdk_window_at_pointer (a_win_x: CE_POINTER [INTEGER_32]; a_win_y: CE_POINTER [INTEGER_32]): CE_POINTER [SD_GDKDRAWABLE]
		do
			create Result.make_shared (c_gdk_window_at_pointer (a_win_x.c_pointer, a_win_y.c_pointer))
		end

	c_gdk_window_at_pointer (a_win_x: POINTER; a_win_y: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_window_at_pointer($a_win_x, $a_win_y);"
		end

	gdk_window_clear (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_gdk_window_clear (a_window.c_pointer)
		end

	c_gdk_window_clear (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_clear($a_window);"
		end

	gdk_window_clear_area (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		do
			c_gdk_window_clear_area (a_window.c_pointer, a_x, a_y, a_width, a_height)
		end

	c_gdk_window_clear_area (a_window: POINTER; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_clear_area($a_window, $a_x, $a_y, $a_width, $a_height);"
		end

	gdk_window_destroy (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_gdk_window_destroy (a_window.c_pointer)
		end

	c_gdk_window_destroy (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_destroy($a_window);"
		end

	gdk_window_get_origin (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_x: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_gdk_window_get_origin (a_window.c_pointer, a_x.c_pointer, a_y.c_pointer)
		end

	c_gdk_window_get_origin (a_window: POINTER; a_x: POINTER; a_y: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_window_get_origin($a_window, $a_x, $a_y);"
		end

	gdk_window_get_pointer (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_x: CE_POINTER [INTEGER_32]; a_y: CE_POINTER [INTEGER_32]; a_mask: CE_POINTER [NATURAL_32]): CE_POINTER [SD_GDKDRAWABLE]
		do
			create Result.make_shared (c_gdk_window_get_pointer (a_window.c_pointer, a_x.c_pointer, a_y.c_pointer, a_mask.c_pointer))
		end

	c_gdk_window_get_pointer (a_window: POINTER; a_x: POINTER; a_y: POINTER; a_mask: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_window_get_pointer($a_window, $a_x, $a_y, $a_mask);"
		end

	gdk_window_get_state (a_window: CE_POINTER [SD_GDKDRAWABLE]): NATURAL_32
		do
			Result := c_gdk_window_get_state (a_window.c_pointer)
		end

	c_gdk_window_get_state (a_window: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_window_get_state($a_window);"
		end

	gdk_window_get_user_data (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_data: CE_POINTER [CE_POINTER [ANY]])
		do
			c_gdk_window_get_user_data (a_window.c_pointer, a_data.c_pointer)
		end

	c_gdk_window_get_user_data (a_window: POINTER; a_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_get_user_data($a_window, $a_data);"
		end

	gdk_window_hide (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_gdk_window_hide (a_window.c_pointer)
		end

	c_gdk_window_hide (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_hide($a_window);"
		end

	gdk_window_move_resize (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		do
			c_gdk_window_move_resize (a_window.c_pointer, a_x, a_y, a_width, a_height)
		end

	c_gdk_window_move_resize (a_window: POINTER; a_x: INTEGER_32; a_y: INTEGER_32; a_width: INTEGER_32; a_height: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_move_resize($a_window, $a_x, $a_y, $a_width, $a_height);"
		end

	gdk_window_new (a_parent: CE_POINTER [SD_GDKDRAWABLE]; a_attributes: CE_POINTER [SD_GDKWINDOWATTR]; a_attributes_mask: INTEGER_32): CE_POINTER [SD_GDKDRAWABLE]
		do
			create Result.make_shared (c_gdk_window_new (a_parent.c_pointer, a_attributes.c_pointer, a_attributes_mask))
		end

	c_gdk_window_new (a_parent: POINTER; a_attributes: POINTER; a_attributes_mask: INTEGER_32): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_window_new($a_parent, $a_attributes, $a_attributes_mask);"
		end

	gdk_window_process_updates (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_update_children: INTEGER_32)
		do
			c_gdk_window_process_updates (a_window.c_pointer, a_update_children)
		end

	c_gdk_window_process_updates (a_window: POINTER; a_update_children: INTEGER_32)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_process_updates($a_window, $a_update_children);"
		end

	gdk_window_set_background (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_color: CE_POINTER [SD_GDKCOLOR])
		do
			c_gdk_window_set_background (a_window.c_pointer, a_color.c_pointer)
		end

	c_gdk_window_set_background (a_window: POINTER; a_color: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_set_background($a_window, $a_color);"
		end

	gdk_window_set_cursor (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_cursor: CE_POINTER [SD_GDKCURSOR])
		do
			c_gdk_window_set_cursor (a_window.c_pointer, a_cursor.c_pointer)
		end

	c_gdk_window_set_cursor (a_window: POINTER; a_cursor: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_set_cursor($a_window, $a_cursor);"
		end

	gdk_window_set_static_gravities (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_use_static: INTEGER_32): INTEGER_32
		do
			Result := c_gdk_window_set_static_gravities (a_window.c_pointer, a_use_static)
		end

	c_gdk_window_set_static_gravities (a_window: POINTER; a_use_static: INTEGER_32): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_window_set_static_gravities($a_window, $a_use_static);"
		end

	gdk_window_set_user_data (a_window: CE_POINTER [SD_GDKDRAWABLE]; a_user_data: CE_POINTER [ANY])
		do
			c_gdk_window_set_user_data (a_window.c_pointer, a_user_data.c_pointer)
		end

	c_gdk_window_set_user_data (a_window: POINTER; a_user_data: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_set_user_data($a_window, $a_user_data);"
		end

	gdk_window_show (a_window: CE_POINTER [SD_GDKDRAWABLE])
		do
			c_gdk_window_show (a_window.c_pointer)
		end

	c_gdk_window_show (a_window: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"gdk_window_show($a_window);"
		end

	gdk_x11_atom_to_xatom_for_display (a_display: CE_POINTER [SD_GDKDISPLAY]; a_atom: CE_POINTER [ANY]): NATURAL_32
		do
			Result := c_gdk_x11_atom_to_xatom_for_display (a_display.c_pointer, a_atom.c_pointer)
		end

	c_gdk_x11_atom_to_xatom_for_display (a_display: POINTER; a_atom: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_x11_atom_to_xatom_for_display($a_display, $a_atom);"
		end

	gdk_x11_drawable_get_xdisplay (a_drawable: CE_POINTER [SD_GDKDRAWABLE]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_gdk_x11_drawable_get_xdisplay (a_drawable.c_pointer))
		end

	c_gdk_x11_drawable_get_xdisplay (a_drawable: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_x11_drawable_get_xdisplay($a_drawable);"
		end

	gdk_x11_drawable_get_xid (a_drawable: CE_POINTER [SD_GDKDRAWABLE]): NATURAL_32
		do
			Result := c_gdk_x11_drawable_get_xid (a_drawable.c_pointer)
		end

	c_gdk_x11_drawable_get_xid (a_drawable: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return gdk_x11_drawable_get_xid($a_drawable);"
		end

	gdk_x11_window_get_drawable_impl (a_window: CE_POINTER [SD_GDKDRAWABLE]): CE_POINTER [SD_GDKDRAWABLE]
		do
			create Result.make_shared (c_gdk_x11_window_get_drawable_impl (a_window.c_pointer))
		end

	c_gdk_x11_window_get_drawable_impl (a_window: POINTER): POINTER
		external
			"C inline use <vim.h>"
		alias
			"return gdk_x11_window_get_drawable_impl($a_window);"
		end

end
