deferred class
	S_X11_ICE_ICELIB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	IceAddConnectionWatch (a_arg1: CE_ROUTINE; a_arg2: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_IceAddConnectionWatch (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_IceAddConnectionWatch (a_arg1: POINTER; a_arg2: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return IceAddConnectionWatch($a_arg1, $a_arg2);"
		end

	IceConnectionNumber (a_arg1: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_IceConnectionNumber (a_arg1.c_pointer)
		end

	c_IceConnectionNumber (a_arg1: POINTER): INTEGER_32
		external
			"C inline use <vim.h>"
		alias
			"return IceConnectionNumber($a_arg1);"
		end

	IceProcessMessages (a_arg1: CE_POINTER [ANY]; a_arg2: CE_POINTER [SD_ICEREPLYWAITINFO]; a_arg3: CE_POINTER [INTEGER_32]): NATURAL_32
		do
			Result := c_IceProcessMessages (a_arg1.c_pointer, a_arg2.c_pointer, a_arg3.c_pointer)
		end

	c_IceProcessMessages (a_arg1: POINTER; a_arg2: POINTER; a_arg3: POINTER): NATURAL_32
		external
			"C inline use <vim.h>"
		alias
			"return IceProcessMessages($a_arg1, $a_arg2, $a_arg3);"
		end

	IceRemoveConnectionWatch (a_arg1: CE_ROUTINE; a_arg2: CE_POINTER [ANY])
		do
			c_IceRemoveConnectionWatch (a_arg1.c_pointer, a_arg2.c_pointer)
		end

	c_IceRemoveConnectionWatch (a_arg1: POINTER; a_arg2: POINTER)
		external
			"C inline use <vim.h>"
		alias
			"IceRemoveConnectionWatch($a_arg1, $a_arg2);"
		end

end
