class
	PD_SSHPROTO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create path.make
		end

feature {ANY} -- fields

	path: CE_POINTER [INTEGER_8] assign set_path

feature {ANY} -- setters

	set_path (a_path: CE_POINTER [INTEGER_8])
		do
			path := a_path
			update_memory_field ("path")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			path := a_other.path
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				path.is_equal (a_other.path)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("path")
				>>)
			init_structure_info
		end

end
