class
	P_CURL_MEMRCHR

inherit
	LIBCURL_DATA
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {ANY} -- routines

	Curl_memrchr (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		local
			l_p: CE_POINTER [NATURAL_8]
			l_q: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_p.make
			create l_q.make

			l_p := create {CE_POINTER [NATURAL_8]}.make_cast (a_s)
			l_q := create {CE_POINTER [NATURAL_8]}.make_cast (a_s)
			l_p := l_p + (a_n - {NATURAL_32} 1).to_integer_32
			from
			until
				not (not js.loop_done and then ((l_p.c_pointer.to_integer_32).to_natural_32 >= (l_q.c_pointer.to_integer_32).to_natural_32))
			loop
				if (l_p.item).to_integer_32 = (a_c.to_natural_8).to_integer_32 then
					Result := (create {CE_POINTER [ANY]}.make_cast (l_p))
					js.return
				end
				if not js.return_called then
					l_p := l_p - 1
				end
			end
			if not js.return_called then
				Result := (create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

end
