frozen class
	LIBGMP_INITIALIZER_SLICE4

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			mp_bases_inst.gmpn_bases[11].chars_per_limb := 9
			mp_bases_inst.gmpn_bases[11].chars_per_bit_exactly := 0.2890648263178878
			mp_bases_inst.gmpn_bases[11].big_base := {NATURAL_32} 2_357_947_691
			mp_bases_inst.gmpn_bases[11].big_base_inverted := {NATURAL_32} 3_528_252_932
			mp_bases_inst.gmpn_bases[12].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[12].chars_per_bit_exactly := 0.2789429456511298
			mp_bases_inst.gmpn_bases[12].big_base := (429_981_696).to_natural_32
			mp_bases_inst.gmpn_bases[12].big_base_inverted := (1_067_686_581).to_natural_32
			mp_bases_inst.gmpn_bases[13].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[13].chars_per_bit_exactly := 0.2702381544273197
			mp_bases_inst.gmpn_bases[13].big_base := (815_730_721).to_natural_32
			mp_bases_inst.gmpn_bases[13].big_base_inverted := (1_358_474_335).to_natural_32
			mp_bases_inst.gmpn_bases[14].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[14].chars_per_bit_exactly := 0.2626495350371936
			mp_bases_inst.gmpn_bases[14].big_base := (1_475_789_056).to_natural_32
			mp_bases_inst.gmpn_bases[14].big_base_inverted := (1_954_822_942).to_natural_32
			mp_bases_inst.gmpn_bases[15].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[15].chars_per_bit_exactly := 0.2559580248098155
			mp_bases_inst.gmpn_bases[15].big_base := {NATURAL_32} 2_562_890_625
			mp_bases_inst.gmpn_bases[15].big_base_inverted := {NATURAL_32} 2_902_664_898
			mp_bases_inst.gmpn_bases[16].chars_per_limb := 8
			mp_bases_inst.gmpn_bases[16].chars_per_bit_exactly := 0.2500000000000000
			mp_bases_inst.gmpn_bases[16].big_base := (4).to_natural_32
			mp_bases_inst.gmpn_bases[16].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[17].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[17].chars_per_bit_exactly := 0.2446505421182260
			mp_bases_inst.gmpn_bases[17].big_base := (410_338_673).to_natural_32
			mp_bases_inst.gmpn_bases[17].big_base_inverted := (1_324_398_269).to_natural_32
			mp_bases_inst.gmpn_bases[18].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[18].chars_per_bit_exactly := 0.2398124665681315
			mp_bases_inst.gmpn_bases[18].big_base := (612_220_032).to_natural_32
			mp_bases_inst.gmpn_bases[18].big_base_inverted := {NATURAL_32} 3_237_759_137
			mp_bases_inst.gmpn_bases[19].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[19].chars_per_bit_exactly := 0.2354089133666382
			mp_bases_inst.gmpn_bases[19].big_base := (893_871_739).to_natural_32
			mp_bases_inst.gmpn_bases[19].big_base_inverted := (864_258_370).to_natural_32
			mp_bases_inst.gmpn_bases[20].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[20].chars_per_bit_exactly := 0.2313782131597592
			mp_bases_inst.gmpn_bases[20].big_base := (1_280_000_000).to_natural_32
			mp_bases_inst.gmpn_bases[20].big_base_inverted := {NATURAL_32} 2_910_792_107
			mp_bases_inst.gmpn_bases[21].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[21].chars_per_bit_exactly := 0.2276702486969530
			mp_bases_inst.gmpn_bases[21].big_base := (1_801_088_541).to_natural_32
			mp_bases_inst.gmpn_bases[21].big_base_inverted := (826_031_381).to_natural_32
			mp_bases_inst.gmpn_bases[22].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[22].chars_per_bit_exactly := 0.2242438242175754
			mp_bases_inst.gmpn_bases[22].big_base := {NATURAL_32} 2_494_357_888
			mp_bases_inst.gmpn_bases[22].big_base_inverted := {NATURAL_32} 3_100_420_576
			mp_bases_inst.gmpn_bases[23].chars_per_limb := 7
			mp_bases_inst.gmpn_bases[23].chars_per_bit_exactly := 0.2210647294575037
			mp_bases_inst.gmpn_bases[23].big_base := {NATURAL_32} 3_404_825_447
			mp_bases_inst.gmpn_bases[23].big_base_inverted := (1_122_856_425).to_natural_32
			mp_bases_inst.gmpn_bases[24].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[24].chars_per_bit_exactly := 0.2181042919855316
			mp_bases_inst.gmpn_bases[24].big_base := (191_102_976).to_natural_32
			mp_bases_inst.gmpn_bases[24].big_base_inverted := (1_738_018_315).to_natural_32
			mp_bases_inst.gmpn_bases[25].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[25].chars_per_bit_exactly := 0.2153382790366965
			mp_bases_inst.gmpn_bases[25].big_base := (244_140_625).to_natural_32
			mp_bases_inst.gmpn_bases[25].big_base_inverted := (427_399_186).to_natural_32
			mp_bases_inst.gmpn_bases[26].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[26].chars_per_bit_exactly := 0.2127460535533632
			mp_bases_inst.gmpn_bases[26].big_base := (308_915_776).to_natural_32
			mp_bases_inst.gmpn_bases[26].big_base_inverted := {NATURAL_32} 3_169_342_358
			mp_bases_inst.gmpn_bases[27].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[27].chars_per_bit_exactly := 0.2103099178571525
			mp_bases_inst.gmpn_bases[27].big_base := (387_420_489).to_natural_32
			mp_bases_inst.gmpn_bases[27].big_base_inverted := (1_656_816_553).to_natural_32
			mp_bases_inst.gmpn_bases[28].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[28].chars_per_bit_exactly := 0.2080145976765095
			mp_bases_inst.gmpn_bases[28].big_base := (481_890_304).to_natural_32
			mp_bases_inst.gmpn_bases[28].big_base_inverted := (490_028_355).to_natural_32
			mp_bases_inst.gmpn_bases[29].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[29].chars_per_bit_exactly := 0.2058468324604344
			mp_bases_inst.gmpn_bases[29].big_base := (594_823_321).to_natural_32
			mp_bases_inst.gmpn_bases[29].big_base_inverted := {NATURAL_32} 3_458_067_690
			mp_bases_inst.gmpn_bases[30].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[30].chars_per_bit_exactly := 0.2037950470905062
			mp_bases_inst.gmpn_bases[30].big_base := (729_000_000).to_natural_32
			mp_bases_inst.gmpn_bases[30].big_base_inverted := (2_031_076_625).to_natural_32
			mp_bases_inst.gmpn_bases[31].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[31].chars_per_bit_exactly := 0.2018490865820999
			mp_bases_inst.gmpn_bases[31].big_base := (887_503_681).to_natural_32
			mp_bases_inst.gmpn_bases[31].big_base_inverted := (901_277_088).to_natural_32
			mp_bases_inst.gmpn_bases[32].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[32].chars_per_bit_exactly := 0.2000000000000000
			mp_bases_inst.gmpn_bases[32].big_base := (5).to_natural_32
			mp_bases_inst.gmpn_bases[32].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[33].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[33].chars_per_bit_exactly := 0.1982398631705605
			mp_bases_inst.gmpn_bases[33].big_base := (1_291_467_969).to_natural_32
			mp_bases_inst.gmpn_bases[33].big_base_inverted := {NATURAL_32} 2_846_806_451
			mp_bases_inst.gmpn_bases[34].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[34].chars_per_bit_exactly := 0.1965616322328226
			mp_bases_inst.gmpn_bases[34].big_base := (1_544_804_416).to_natural_32
			mp_bases_inst.gmpn_bases[34].big_base_inverted := (1_675_608_617).to_natural_32
			mp_bases_inst.gmpn_bases[35].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[35].chars_per_bit_exactly := 0.1949590218937863
			mp_bases_inst.gmpn_bases[35].big_base := (1_838_265_625).to_natural_32
			mp_bases_inst.gmpn_bases[35].big_base_inverted := (722_464_304).to_natural_32
			mp_bases_inst.gmpn_bases[36].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[36].chars_per_bit_exactly := 0.1934264036172708
			mp_bases_inst.gmpn_bases[36].big_base := {NATURAL_32} 2_176_782_336
			mp_bases_inst.gmpn_bases[36].big_base_inverted := {NATURAL_32} 4_179_349_942
			mp_bases_inst.gmpn_bases[37].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[37].chars_per_bit_exactly := 0.1919587200065601
			mp_bases_inst.gmpn_bases[37].big_base := {NATURAL_32} 2_565_726_409
			mp_bases_inst.gmpn_bases[37].big_base_inverted := {NATURAL_32} 2_894_709_673
			mp_bases_inst.gmpn_bases[38].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[38].chars_per_bit_exactly := 0.1905514124267734
			mp_bases_inst.gmpn_bases[38].big_base := {NATURAL_32} 3_010_936_384
			mp_bases_inst.gmpn_bases[38].big_base_inverted := (1_831_613_182).to_natural_32
			mp_bases_inst.gmpn_bases[39].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[39].chars_per_bit_exactly := 0.1892003595168700
			mp_bases_inst.gmpn_bases[39].big_base := {NATURAL_32} 3_518_743_761
			mp_bases_inst.gmpn_bases[39].big_base_inverted := (947_455_945).to_natural_32
			mp_bases_inst.gmpn_bases[40].chars_per_limb := 6
			mp_bases_inst.gmpn_bases[40].chars_per_bit_exactly := 0.1879018247091076
			mp_bases_inst.gmpn_bases[40].big_base := {NATURAL_32} 4_096_000_000
			mp_bases_inst.gmpn_bases[40].big_base_inverted := (208_632_331).to_natural_32
			mp_bases_inst.gmpn_bases[41].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[41].chars_per_bit_exactly := 0.1866524112389434
			mp_bases_inst.gmpn_bases[41].big_base := (115_856_201).to_natural_32
			mp_bases_inst.gmpn_bases[41].big_base_inverted := (680_690_004).to_natural_32
			mp_bases_inst.gmpn_bases[42].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[42].chars_per_bit_exactly := 0.1854490234153689
			mp_bases_inst.gmpn_bases[42].big_base := (130_691_232).to_natural_32
			mp_bases_inst.gmpn_bases[42].big_base_inverted := (115_892_893).to_natural_32
			mp_bases_inst.gmpn_bases[43].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[43].chars_per_bit_exactly := 0.1842888331487062
			mp_bases_inst.gmpn_bases[43].big_base := (147_008_443).to_natural_32
			mp_bases_inst.gmpn_bases[43].big_base_inverted := {NATURAL_32} 3_547_585_696
			mp_bases_inst.gmpn_bases[44].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[44].chars_per_bit_exactly := 0.1831692509136336
			mp_bases_inst.gmpn_bases[44].big_base := (164_916_224).to_natural_32
			mp_bases_inst.gmpn_bases[44].big_base_inverted := {NATURAL_32} 2_695_985_301
			mp_bases_inst.gmpn_bases[45].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[45].chars_per_bit_exactly := 0.1820879004699383
			mp_bases_inst.gmpn_bases[45].big_base := (184_528_125).to_natural_32
			mp_bases_inst.gmpn_bases[45].big_base_inverted := (1_952_977_317).to_natural_32
			mp_bases_inst.gmpn_bases[46].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[46].chars_per_bit_exactly := 0.1810425967800402
			mp_bases_inst.gmpn_bases[46].big_base := (205_962_976).to_natural_32
			mp_bases_inst.gmpn_bases[46].big_base_inverted := (1_302_745_103).to_natural_32
			mp_bases_inst.gmpn_bases[47].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[47].chars_per_bit_exactly := 0.1800313266566926
			mp_bases_inst.gmpn_bases[47].big_base := (229_345_007).to_natural_32
			mp_bases_inst.gmpn_bases[47].big_base_inverted := (732_050_818).to_natural_32
			mp_bases_inst.gmpn_bases[48].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[48].chars_per_bit_exactly := 0.1790522317510413
			mp_bases_inst.gmpn_bases[48].big_base := (254_803_968).to_natural_32
			mp_bases_inst.gmpn_bases[48].big_base_inverted := (229_771_912).to_natural_32
			mp_bases_inst.gmpn_bases[49].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[49].chars_per_bit_exactly := 0.1781035935540111
			mp_bases_inst.gmpn_bases[49].big_base := (282_475_249).to_natural_32
			mp_bases_inst.gmpn_bases[49].big_base_inverted := {NATURAL_32} 3_868_024_036
			mp_bases_inst.gmpn_bases[50].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[50].chars_per_bit_exactly := 0.1771838201355579
			mp_bases_inst.gmpn_bases[50].big_base := (312_500_000).to_natural_32
			mp_bases_inst.gmpn_bases[50].big_base_inverted := {NATURAL_32} 3_083_730_333
			mp_bases_inst.gmpn_bases[51].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[51].chars_per_bit_exactly := 0.1762914343888821
			mp_bases_inst.gmpn_bases[51].big_base := (345_025_251).to_natural_32
			mp_bases_inst.gmpn_bases[51].big_base_inverted := {NATURAL_32} 2_388_146_483
			mp_bases_inst.gmpn_bases[52].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[52].chars_per_bit_exactly := 0.1754250635819545
			mp_bases_inst.gmpn_bases[52].big_base := (380_204_032).to_natural_32
			mp_bases_inst.gmpn_bases[52].big_base_inverted := (1_769_784_298).to_natural_32
			mp_bases_inst.gmpn_bases[53].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[53].chars_per_bit_exactly := 0.1745834300480449
			mp_bases_inst.gmpn_bases[53].big_base := (418_195_493).to_natural_32
			mp_bases_inst.gmpn_bases[53].big_base_inverted := (1_218_824_812).to_natural_32
			mp_bases_inst.gmpn_bases[54].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[54].chars_per_bit_exactly := 0.1737653428714400
			mp_bases_inst.gmpn_bases[54].big_base := (459_165_024).to_natural_32
			mp_bases_inst.gmpn_bases[54].big_base_inverted := (726_850_326).to_natural_32
			mp_bases_inst.gmpn_bases[55].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[55].chars_per_bit_exactly := 0.1729696904450771
			mp_bases_inst.gmpn_bases[55].big_base := (503_284_375).to_natural_32
			mp_bases_inst.gmpn_bases[55].big_base_inverted := (286_623_398).to_natural_32
			mp_bases_inst.gmpn_bases[56].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[56].chars_per_bit_exactly := 0.1721954337940981
			mp_bases_inst.gmpn_bases[56].big_base := (550_731_776).to_natural_32
			mp_bases_inst.gmpn_bases[56].big_base_inverted := {NATURAL_32} 4_078_775_094
			mp_bases_inst.gmpn_bases[57].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[57].chars_per_bit_exactly := 0.1714416005739134
			mp_bases_inst.gmpn_bases[57].big_base := (601_692_057).to_natural_32
			mp_bases_inst.gmpn_bases[57].big_base_inverted := {NATURAL_32} 3_369_561_369
			mp_bases_inst.gmpn_bases[58].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[58].chars_per_bit_exactly := 0.1707072796637201
			mp_bases_inst.gmpn_bases[58].big_base := (656_356_768).to_natural_32
			mp_bases_inst.gmpn_bases[58].big_base_inverted := {NATURAL_32} 2_731_220_660
			mp_bases_inst.gmpn_bases[59].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[59].chars_per_bit_exactly := 0.1699916162869140
			mp_bases_inst.gmpn_bases[59].big_base := (714_924_299).to_natural_32
			mp_bases_inst.gmpn_bases[59].big_base_inverted := {NATURAL_32} 2_155_626_179
			mp_bases_inst.gmpn_bases[60].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[60].chars_per_bit_exactly := 0.1692938075987814
			mp_bases_inst.gmpn_bases[60].big_base := (777_600_000).to_natural_32
			mp_bases_inst.gmpn_bases[60].big_base_inverted := (1_635_698_879).to_natural_32
			mp_bases_inst.gmpn_bases[61].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[61].chars_per_bit_exactly := 0.1686130986895011
			mp_bases_inst.gmpn_bases[61].big_base := (844_596_301).to_natural_32
			mp_bases_inst.gmpn_bases[61].big_base_inverted := (1_165_257_918).to_natural_32
			mp_bases_inst.gmpn_bases[62].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[62].chars_per_bit_exactly := 0.1679487789570419
			mp_bases_inst.gmpn_bases[62].big_base := (916_132_832).to_natural_32
			mp_bases_inst.gmpn_bases[62].big_base_inverted := (738_894_451).to_natural_32
			mp_bases_inst.gmpn_bases[63].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[63].chars_per_bit_exactly := 0.1673001788101741
			mp_bases_inst.gmpn_bases[63].big_base := (992_436_543).to_natural_32
			mp_bases_inst.gmpn_bases[63].big_base_inverted := (351_864_837).to_natural_32
			mp_bases_inst.gmpn_bases[64].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[64].chars_per_bit_exactly := 0.1666666666666667
			mp_bases_inst.gmpn_bases[64].big_base := (6).to_natural_32
			mp_bases_inst.gmpn_bases[64].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[65].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[65].chars_per_bit_exactly := 0.1660476462159378
			mp_bases_inst.gmpn_bases[65].big_base := (1_160_290_625).to_natural_32
			mp_bases_inst.gmpn_bases[65].big_base_inverted := {NATURAL_32} 3_654_223_913
			mp_bases_inst.gmpn_bases[66].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[66].chars_per_bit_exactly := 0.1654425539190583
			mp_bases_inst.gmpn_bases[66].big_base := (1_252_332_576).to_natural_32
			mp_bases_inst.gmpn_bases[66].big_base_inverted := {NATURAL_32} 3_069_986_881
			mp_bases_inst.gmpn_bases[67].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[67].chars_per_bit_exactly := 0.1648508567221604
			mp_bases_inst.gmpn_bases[67].big_base := (1_350_125_107).to_natural_32
			mp_bases_inst.gmpn_bases[67].big_base_inverted := {NATURAL_32} 2_536_527_051
			mp_bases_inst.gmpn_bases[68].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[68].chars_per_bit_exactly := 0.1642720499620502
			mp_bases_inst.gmpn_bases[68].big_base := (1_453_933_568).to_natural_32
			mp_bases_inst.gmpn_bases[68].big_base_inverted := (2_048_769_611).to_natural_32
			mp_bases_inst.gmpn_bases[69].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[69].chars_per_bit_exactly := 0.1637056554452156
			mp_bases_inst.gmpn_bases[69].big_base := (1_564_031_349).to_natural_32
			mp_bases_inst.gmpn_bases[69].big_base_inverted := (1_602_211_199).to_natural_32
			mp_bases_inst.gmpn_bases[70].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[70].chars_per_bit_exactly := 0.1631512196835108
			mp_bases_inst.gmpn_bases[70].big_base := (1_680_700_000).to_natural_32
			mp_bases_inst.gmpn_bases[70].big_base_inverted := (1_192_848_516).to_natural_32
			mp_bases_inst.gmpn_bases[71].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[71].chars_per_bit_exactly := 0.1626083122716341
			mp_bases_inst.gmpn_bases[71].big_base := (1_804_229_351).to_natural_32
			mp_bases_inst.gmpn_bases[71].big_base_inverted := (817_116_725).to_natural_32
			mp_bases_inst.gmpn_bases[72].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[72].chars_per_bit_exactly := 0.1620765243931223
			mp_bases_inst.gmpn_bases[72].big_base := (1_934_917_632).to_natural_32
			mp_bases_inst.gmpn_bases[72].big_base_inverted := (471_836_150).to_natural_32
			mp_bases_inst.gmpn_bases[73].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[73].chars_per_bit_exactly := 0.1615554674429964
			mp_bases_inst.gmpn_bases[73].big_base := (2_073_071_593).to_natural_32
			mp_bases_inst.gmpn_bases[73].big_base_inverted := (154_166_090).to_natural_32
			mp_bases_inst.gmpn_bases[74].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[74].chars_per_bit_exactly := 0.1610447717564444
			mp_bases_inst.gmpn_bases[74].big_base := {NATURAL_32} 2_219_006_624
			mp_bases_inst.gmpn_bases[74].big_base_inverted := {NATURAL_32} 4_018_096_700
			mp_bases_inst.gmpn_bases[75].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[75].chars_per_bit_exactly := 0.1605440854340214
			mp_bases_inst.gmpn_bases[75].big_base := {NATURAL_32} 2_373_046_875
			mp_bases_inst.gmpn_bases[75].big_base_inverted := {NATURAL_32} 3_478_475_474
			mp_bases_inst.gmpn_bases[76].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[76].chars_per_bit_exactly := 0.1600530732548213
			mp_bases_inst.gmpn_bases[76].big_base := {NATURAL_32} 2_535_525_376
			mp_bases_inst.gmpn_bases[76].big_base_inverted := {NATURAL_32} 2_980_347_022
			mp_bases_inst.gmpn_bases[77].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[77].chars_per_bit_exactly := 0.1595714156699382
			mp_bases_inst.gmpn_bases[77].big_base := {NATURAL_32} 2_706_784_157
			mp_bases_inst.gmpn_bases[77].big_base_inverted := {NATURAL_32} 2_520_036_414
			mp_bases_inst.gmpn_bases[78].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[78].chars_per_bit_exactly := 0.1590988078692941
			mp_bases_inst.gmpn_bases[78].big_base := {NATURAL_32} 2_887_174_368
			mp_bases_inst.gmpn_bases[78].big_base_inverted := (2_094_236_029).to_natural_32
			mp_bases_inst.gmpn_bases[79].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[79].chars_per_bit_exactly := 0.1586349589155960
			mp_bases_inst.gmpn_bases[79].big_base := {NATURAL_32} 3_077_056_399
			mp_bases_inst.gmpn_bases[79].big_base_inverted := (1_699_964_769).to_natural_32
			mp_bases_inst.gmpn_bases[80].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[80].chars_per_bit_exactly := 0.1581795909397823
			mp_bases_inst.gmpn_bases[80].big_base := {NATURAL_32} 3_276_800_000
			mp_bases_inst.gmpn_bases[80].big_base_inverted := (1_334_532_238).to_natural_32
			mp_bases_inst.gmpn_bases[81].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[81].chars_per_bit_exactly := 0.1577324383928644
			mp_bases_inst.gmpn_bases[81].big_base := {NATURAL_32} 3_486_784_401
			mp_bases_inst.gmpn_bases[81].big_base_inverted := (995_507_236).to_natural_32
			mp_bases_inst.gmpn_bases[82].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[82].chars_per_bit_exactly := 0.1572932473495469
			mp_bases_inst.gmpn_bases[82].big_base := {NATURAL_32} 3_707_398_432
			mp_bases_inst.gmpn_bases[82].big_base_inverted := (680_690_004).to_natural_32
			mp_bases_inst.gmpn_bases[83].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[83].chars_per_bit_exactly := 0.1568617748594410
			mp_bases_inst.gmpn_bases[83].big_base := {NATURAL_32} 3_939_040_643
			mp_bases_inst.gmpn_bases[83].big_base_inverted := (388_087_728).to_natural_32
			mp_bases_inst.gmpn_bases[84].chars_per_limb := 5
			mp_bases_inst.gmpn_bases[84].chars_per_bit_exactly := 0.1564377883420716
			mp_bases_inst.gmpn_bases[84].big_base := {NATURAL_32} 4_182_119_424
			mp_bases_inst.gmpn_bases[84].big_base_inverted := (115_892_893).to_natural_32
			mp_bases_inst.gmpn_bases[85].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[85].chars_per_bit_exactly := 0.1560210650222250
			mp_bases_inst.gmpn_bases[85].big_base := (52_200_625).to_natural_32
			mp_bases_inst.gmpn_bases[85].big_base_inverted := (1_226_621_308).to_natural_32
			mp_bases_inst.gmpn_bases[86].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[86].chars_per_bit_exactly := 0.1556113914024940
			mp_bases_inst.gmpn_bases[86].big_base := (54_700_816).to_natural_32
			mp_bases_inst.gmpn_bases[86].big_base_inverted := (974_247_995).to_natural_32
			mp_bases_inst.gmpn_bases[87].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[87].chars_per_bit_exactly := 0.1552085627701551
			mp_bases_inst.gmpn_bases[87].big_base := (57_289_761).to_natural_32
			mp_bases_inst.gmpn_bases[87].big_base_inverted := (736_130_253).to_natural_32
			mp_bases_inst.gmpn_bases[88].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[88].chars_per_bit_exactly := 0.1548123827357682
			mp_bases_inst.gmpn_bases[88].big_base := (59_969_536).to_natural_32
			mp_bases_inst.gmpn_bases[88].big_base_inverted := (511_312_615).to_natural_32
			mp_bases_inst.gmpn_bases[89].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[89].chars_per_bit_exactly := 0.1544226628011101
			mp_bases_inst.gmpn_bases[89].big_base := (62_742_241).to_natural_32
			mp_bases_inst.gmpn_bases[89].big_base_inverted := (298_913_501).to_natural_32
			mp_bases_inst.gmpn_bases[90].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[90].chars_per_bit_exactly := 0.1540392219542636
			mp_bases_inst.gmpn_bases[90].big_base := (65_610_000).to_natural_32
			mp_bases_inst.gmpn_bases[90].big_base_inverted := (98_118_760).to_natural_32
			mp_bases_inst.gmpn_bases[91].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[91].chars_per_bit_exactly := 0.1536618862898642
			mp_bases_inst.gmpn_bases[91].big_base := (68_574_961).to_natural_32
			mp_bases_inst.gmpn_bases[91].big_base_inverted := {NATURAL_32} 4_111_318_962
			mp_bases_inst.gmpn_bases[92].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[92].chars_per_bit_exactly := 0.1532904886526781
			mp_bases_inst.gmpn_bases[92].big_base := (71_639_296).to_natural_32
			mp_bases_inst.gmpn_bases[92].big_base_inverted := {NATURAL_32} 3_751_744_278
			mp_bases_inst.gmpn_bases[93].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[93].chars_per_bit_exactly := 0.1529248683028321
			mp_bases_inst.gmpn_bases[93].big_base := (74_805_201).to_natural_32
			mp_bases_inst.gmpn_bases[93].big_base_inverted := {NATURAL_32} 3_411_191_428
			mp_bases_inst.gmpn_bases[94].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[94].chars_per_bit_exactly := 0.1525648706011593
			mp_bases_inst.gmpn_bases[94].big_base := (78_074_896).to_natural_32
			mp_bases_inst.gmpn_bases[94].big_base_inverted := {NATURAL_32} 3_088_465_559
			mp_bases_inst.gmpn_bases[95].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[95].chars_per_bit_exactly := 0.1522103467132434
			mp_bases_inst.gmpn_bases[95].big_base := (81_450_625).to_natural_32
			mp_bases_inst.gmpn_bases[95].big_base_inverted := {NATURAL_32} 2_782_458_473
			mp_bases_inst.gmpn_bases[96].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[96].chars_per_bit_exactly := 0.1518611533308632
			mp_bases_inst.gmpn_bases[96].big_base := (84_934_656).to_natural_32
			mp_bases_inst.gmpn_bases[96].big_base_inverted := {NATURAL_32} 2_492_141_517
			mp_bases_inst.gmpn_bases[97].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[97].chars_per_bit_exactly := 0.1515171524096389
			mp_bases_inst.gmpn_bases[97].big_base := (88_529_281).to_natural_32
			mp_bases_inst.gmpn_bases[97].big_base_inverted := {NATURAL_32} 2_216_559_125
			mp_bases_inst.gmpn_bases[98].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[98].chars_per_bit_exactly := 0.1511782109217764
			mp_bases_inst.gmpn_bases[98].big_base := (92_236_816).to_natural_32
			mp_bases_inst.gmpn_bases[98].big_base_inverted := (1_954_822_942).to_natural_32
			mp_bases_inst.gmpn_bases[99].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[99].chars_per_bit_exactly := 0.1508442006228941
			mp_bases_inst.gmpn_bases[99].big_base := (96_059_601).to_natural_32
			mp_bases_inst.gmpn_bases[99].big_base_inverted := (1_706_106_478).to_natural_32
			mp_bases_inst.gmpn_bases[100].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[100].chars_per_bit_exactly := 0.1505149978319906
			mp_bases_inst.gmpn_bases[100].big_base := (100_000_000).to_natural_32
			mp_bases_inst.gmpn_bases[100].big_base_inverted := (1_469_640_227).to_natural_32
			mp_bases_inst.gmpn_bases[101].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[101].chars_per_bit_exactly := 0.1501904832236879
			mp_bases_inst.gmpn_bases[101].big_base := (104_060_401).to_natural_32
			mp_bases_inst.gmpn_bases[101].big_base_inverted := (1_244_707_227).to_natural_32
			mp_bases_inst.gmpn_bases[102].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[102].chars_per_bit_exactly := 0.1498705416319474
			mp_bases_inst.gmpn_bases[102].big_base := (108_243_216).to_natural_32
			mp_bases_inst.gmpn_bases[102].big_base_inverted := (1_030_638_996).to_natural_32
			mp_bases_inst.gmpn_bases[103].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[103].chars_per_bit_exactly := 0.1495550618645152
			mp_bases_inst.gmpn_bases[103].big_base := (112_550_881).to_natural_32
			mp_bases_inst.gmpn_bases[103].big_base_inverted := (826_811_824).to_natural_32
			mp_bases_inst.gmpn_bases[104].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[104].chars_per_bit_exactly := 0.1492439365274121
			mp_bases_inst.gmpn_bases[104].big_base := (116_985_856).to_natural_32
			mp_bases_inst.gmpn_bases[104].big_base_inverted := (632_643_374).to_natural_32
			mp_bases_inst.gmpn_bases[105].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[105].chars_per_bit_exactly := 0.1489370618588283
			mp_bases_inst.gmpn_bases[105].big_base := (121_550_625).to_natural_32
			mp_bases_inst.gmpn_bases[105].big_base_inverted := (447_589_579).to_natural_32
			mp_bases_inst.gmpn_bases[106].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[106].chars_per_bit_exactly := 0.1486343375718350
			mp_bases_inst.gmpn_bases[106].big_base := (126_247_696).to_natural_32
			mp_bases_inst.gmpn_bases[106].big_base_inverted := (271_141_794).to_natural_32
			mp_bases_inst.gmpn_bases[107].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[107].chars_per_bit_exactly := 0.1483356667053617
			mp_bases_inst.gmpn_bases[107].big_base := (131_079_601).to_natural_32
			mp_bases_inst.gmpn_bases[107].big_base_inverted := (102_824_182).to_natural_32
			mp_bases_inst.gmpn_bases[108].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[108].chars_per_bit_exactly := 0.1480409554829326
			mp_bases_inst.gmpn_bases[108].big_base := (136_048_896).to_natural_32
			mp_bases_inst.gmpn_bases[108].big_base_inverted := {NATURAL_32} 4_179_349_942
			mp_bases_inst.gmpn_bases[109].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[109].chars_per_bit_exactly := 0.1477501131786861
			mp_bases_inst.gmpn_bases[109].big_base := (141_158_161).to_natural_32
			mp_bases_inst.gmpn_bases[109].big_base_inverted := {NATURAL_32} 3_872_619_306
			mp_bases_inst.gmpn_bases[110].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[110].chars_per_bit_exactly := 0.1474630519902391
			mp_bases_inst.gmpn_bases[110].big_base := (146_410_000).to_natural_32
			mp_bases_inst.gmpn_bases[110].big_base_inverted := {NATURAL_32} 3_579_641_710
			mp_bases_inst.gmpn_bases[111].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[111].chars_per_bit_exactly := 0.1471796869179852
			mp_bases_inst.gmpn_bases[111].big_base := (151_807_041).to_natural_32
			mp_bases_inst.gmpn_bases[111].big_base_inverted := {NATURAL_32} 3_299_683_762
			mp_bases_inst.gmpn_bases[112].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[112].chars_per_bit_exactly := 0.1468999356504447
			mp_bases_inst.gmpn_bases[112].big_base := (157_351_936).to_natural_32
			mp_bases_inst.gmpn_bases[112].big_base_inverted := {NATURAL_32} 3_032_057_295
			mp_bases_inst.gmpn_bases[113].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[113].chars_per_bit_exactly := 0.1466237184553111
			mp_bases_inst.gmpn_bases[113].big_base := (163_047_361).to_natural_32
			mp_bases_inst.gmpn_bases[113].big_base_inverted := {NATURAL_32} 2_776_116_207
			mp_bases_inst.gmpn_bases[114].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[114].chars_per_bit_exactly := 0.1463509580758620
			mp_bases_inst.gmpn_bases[114].big_base := (168_896_016).to_natural_32
			mp_bases_inst.gmpn_bases[114].big_base_inverted := {NATURAL_32} 2_531_253_546
			mp_bases_inst.gmpn_bases[115].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[115].chars_per_bit_exactly := 0.1460815796324244
			mp_bases_inst.gmpn_bases[115].big_base := (174_900_625).to_natural_32
			mp_bases_inst.gmpn_bases[115].big_base_inverted := {NATURAL_32} 2_296_898_825
			mp_bases_inst.gmpn_bases[116].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[116].chars_per_bit_exactly := 0.1458155105286054
			mp_bases_inst.gmpn_bases[116].big_base := (181_063_936).to_natural_32
			mp_bases_inst.gmpn_bases[116].big_base_inverted := (2_072_515_539).to_natural_32
			mp_bases_inst.gmpn_bases[117].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[117].chars_per_bit_exactly := 0.1455526803620167
			mp_bases_inst.gmpn_bases[117].big_base := (187_388_721).to_natural_32
			mp_bases_inst.gmpn_bases[117].big_base_inverted := (1_857_598_869).to_natural_32
			mp_bases_inst.gmpn_bases[118].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[118].chars_per_bit_exactly := 0.1452930208392428
			mp_bases_inst.gmpn_bases[118].big_base := (193_877_776).to_natural_32
			mp_bases_inst.gmpn_bases[118].big_base_inverted := (1_651_673_563).to_natural_32
			mp_bases_inst.gmpn_bases[119].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[119].chars_per_bit_exactly := 0.1450364656948130
			mp_bases_inst.gmpn_bases[119].big_base := (200_533_921).to_natural_32
			mp_bases_inst.gmpn_bases[119].big_base_inverted := (1_454_291_975).to_natural_32
			mp_bases_inst.gmpn_bases[120].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[120].chars_per_bit_exactly := 0.1447829506139581
			mp_bases_inst.gmpn_bases[120].big_base := (207_360_000).to_natural_32
			mp_bases_inst.gmpn_bases[120].big_base_inverted := (1_265_032_243).to_natural_32
			mp_bases_inst.gmpn_bases[121].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[121].chars_per_bit_exactly := 0.1445324131589439
			mp_bases_inst.gmpn_bases[121].big_base := (214_358_881).to_natural_32
			mp_bases_inst.gmpn_bases[121].big_base_inverted := (1_083_496_611).to_natural_32
			mp_bases_inst.gmpn_bases[122].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[122].chars_per_bit_exactly := 0.1442847926987864
			mp_bases_inst.gmpn_bases[122].big_base := (221_533_456).to_natural_32
			mp_bases_inst.gmpn_bases[122].big_base_inverted := (909_309_861).to_natural_32
			mp_bases_inst.gmpn_bases[123].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[123].chars_per_bit_exactly := 0.1440400303421672
			mp_bases_inst.gmpn_bases[123].big_base := (228_886_641).to_natural_32
			mp_bases_inst.gmpn_bases[123].big_base_inverted := (742_117_872).to_natural_32
			mp_bases_inst.gmpn_bases[124].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[124].chars_per_bit_exactly := 0.1437980688733775
			mp_bases_inst.gmpn_bases[124].big_base := (236_421_376).to_natural_32
			mp_bases_inst.gmpn_bases[124].big_base_inverted := (581_586_271).to_natural_32
			mp_bases_inst.gmpn_bases[125].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[125].chars_per_bit_exactly := 0.1435588526911310
			mp_bases_inst.gmpn_bases[125].big_base := (244_140_625).to_natural_32
			mp_bases_inst.gmpn_bases[125].big_base_inverted := (427_399_186).to_natural_32
			mp_bases_inst.gmpn_bases[126].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[126].chars_per_bit_exactly := 0.1433223277500932
			mp_bases_inst.gmpn_bases[126].big_base := (252_047_376).to_natural_32
			mp_bases_inst.gmpn_bases[126].big_base_inverted := (279_258_085).to_natural_32
			mp_bases_inst.gmpn_bases[127].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[127].chars_per_bit_exactly := 0.1430884415049874
			mp_bases_inst.gmpn_bases[127].big_base := (260_144_641).to_natural_32
			mp_bases_inst.gmpn_bases[127].big_base_inverted := (136_880_695).to_natural_32
			mp_bases_inst.gmpn_bases[128].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[128].chars_per_bit_exactly := 0.1428571428571428
			mp_bases_inst.gmpn_bases[128].big_base := (7).to_natural_32
			mp_bases_inst.gmpn_bases[128].big_base_inverted := {NATURAL_32} 0
			mp_bases_inst.gmpn_bases[129].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[129].chars_per_bit_exactly := 0.1426283821033600
			mp_bases_inst.gmpn_bases[129].big_base := (276_922_881).to_natural_32
			mp_bases_inst.gmpn_bases[129].big_base_inverted := {NATURAL_32} 4_031_693_906
			mp_bases_inst.gmpn_bases[130].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[130].chars_per_bit_exactly := 0.1424021108869747
			mp_bases_inst.gmpn_bases[130].big_base := (285_610_000).to_natural_32
			mp_bases_inst.gmpn_bases[130].big_base_inverted := {NATURAL_32} 3_778_430_026
			mp_bases_inst.gmpn_bases[131].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[131].chars_per_bit_exactly := 0.1421782821510107
			mp_bases_inst.gmpn_bases[131].big_base := (294_499_921).to_natural_32
			mp_bases_inst.gmpn_bases[131].big_base_inverted := {NATURAL_32} 3_534_722_441
			mp_bases_inst.gmpn_bases[132].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[132].chars_per_bit_exactly := 0.1419568500933153
			mp_bases_inst.gmpn_bases[132].big_base := (303_595_776).to_natural_32
			mp_bases_inst.gmpn_bases[132].big_base_inverted := {NATURAL_32} 3_300_141_699
			mp_bases_inst.gmpn_bases[133].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[133].chars_per_bit_exactly := 0.1417377701235801
			mp_bases_inst.gmpn_bases[133].big_base := (312_900_721).to_natural_32
			mp_bases_inst.gmpn_bases[133].big_base_inverted := {NATURAL_32} 3_074_280_693
			mp_bases_inst.gmpn_bases[134].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[134].chars_per_bit_exactly := 0.1415209988221527
			mp_bases_inst.gmpn_bases[134].big_base := (322_417_936).to_natural_32
			mp_bases_inst.gmpn_bases[134].big_base_inverted := {NATURAL_32} 2_856_753_349
			mp_bases_inst.gmpn_bases[135].chars_per_limb := 4
			mp_bases_inst.gmpn_bases[135].chars_per_bit_exactly := 0.1413064939005528
			mp_bases_inst.gmpn_bases[135].big_base := (332_150_625).to_natural_32
			mp_bases_inst.gmpn_bases[135].big_base_inverted := {NATURAL_32} 2_647_193_385
		end

end
