class
	P_AND

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_and (a_res: CE_POINTER [PD_MPZ_STRUCT]; a_op1: CE_POINTER [PD_MPZ_STRUCT]; a_op2: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_op1: CE_POINTER [PD_MPZ_STRUCT]
			l_op2: CE_POINTER [PD_MPZ_STRUCT]
			l_op1_ptr: CE_POINTER [NATURAL_32]
			l_op2_ptr: CE_POINTER [NATURAL_32]
			l_op1_size: INTEGER_32
			l_op2_size: INTEGER_32
			l_res_ptr: CE_POINTER [NATURAL_32]
			l_res_size: INTEGER_32
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___up: CE_POINTER [NATURAL_32]
			l___vp: CE_POINTER [NATURAL_32]
			l___rp: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l___a: NATURAL_32
			l___b: NATURAL_32
			l_opx: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			l_res_alloc: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___10: CE_POINTER [ANY]
			l___mpz_srcptr_swap__tmp: CE_POINTER [PD_MPZ_STRUCT]
			l___mp_srcptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_opx___0: CE_POINTER [NATURAL_32]
			l_tmp___16: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_op1.make
			create l_op2.make
			create l_op1_ptr.make
			create l_op2_ptr.make
			create l_res_ptr.make
			create l___tmp_marker.make (<<1>>)
			create l___up.make
			create l___vp.make
			create l___rp.make
			create l_opx.make
			create l_tmp___5.make
			create l_tmp___10.make
			create l___mpz_srcptr_swap__tmp.make
			create l___mp_srcptr_swap__tmp.make
			create l_opx___0.make
			create l_tmp___16.make

			l_op1 := a_op1
			l_op2 := a_op2
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_op1_size := (l_op1.item.mp_size).to_integer_32
			l_op2_size := (l_op2.item.mp_size).to_integer_32
			l_op1_ptr := l_op1.item.mp_d
			l_op2_ptr := l_op2.item.mp_d
			l_res_ptr := a_res.item.mp_d
			if l_op1_size >= 0 then
				if l_op2_size >= 0 then
					if l_op1_size < l_op2_size then
						l_res_size := l_op1_size
					else
						l_res_size := l_op2_size
					end
					l_i := l_res_size - 1
					from
					until
						not (not js.loop_done and then (l_i >= 0))
					loop
						if ((l_op1_ptr[l_i]).bit_and (l_op2_ptr[l_i])) /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_i := l_i - 1
						end
					end
					l_res_size := l_i + 1
					if (builtin_expect (((a_res.item.mp_alloc).to_integer_32 < l_res_size).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
						l_res_ptr := a_res.item.mp_d
					end
					a_res.item.mp_size := l_res_size.to_integer_32
					if (builtin_expect ((l_res_size /= 0).to_integer, 1)).to_boolean then
						from
						until
							js.loop_done
						loop
							l___up := l_op1_ptr
							l___vp := l_op2_ptr
							l___rp := l_res_ptr
							l___n := l_res_size
							l___up := l___up + l___n
							l___vp := l___vp + l___n
							l___rp := l___rp + l___n
							l___n := -l___n
							from
							until
								js.loop_done
							loop
								l___a := l___up[l___n]
								l___b := l___vp[l___n]
								l___rp[l___n] := (l___a).bit_and (l___b)
								l___n := l___n + 1
								if not l___n.to_boolean then
									js.break
								end
							end
							js.break
						end
					end
					js.return
				end
			elseif l_op2_size < 0 then
				l_op1_size := -l_op1_size
				l_op2_size := -l_op2_size
				if l_op1_size > l_op2_size then
					l_tmp___1 := l_op1_size
				else
					l_tmp___1 := l_op2_size
				end
				l_res_alloc := 1 + l_tmp___1
				if (builtin_expect ((l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___5 := (l_aaf.new ((l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op1_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_opx := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
				gmp_inst.gmpn_sub_1 (l_opx, l_op1_ptr, l_op1_size, (1).to_natural_32).do_nothing
				l_op1_ptr := l_opx
				if (builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___10 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___10 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_opx := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___10)
				gmp_inst.gmpn_sub_1 (l_opx, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				l_op2_ptr := l_opx
				if (a_res.item.mp_alloc).to_integer_32 < l_res_alloc then
					realloc_inst.gmpz_realloc (a_res, l_res_alloc).do_nothing
					l_res_ptr := a_res.item.mp_d
				end
				if l_op1_size >= l_op2_size then
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_op1_size - l_op2_size)
							js.break
						end
						js.break
					end
					l_i := l_op2_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
						l_i := l_i - 1
					end
					l_res_size := l_op1_size
				else
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_res_ptr + l_op1_size, l_op2_ptr + l_op1_size, l_op2_size - l_op1_size)
							js.break
						end
						js.break
					end
					l_i := l_op1_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_or (l_op2_ptr[l_i]))
						l_i := l_i - 1
					end
					l_res_size := l_op2_size
				end
				l_cy := gmp_inst.gmpn_add_1 (l_res_ptr, l_res_ptr, l_res_size, (1).to_natural_32)
				if l_cy.to_boolean then
					l_res_ptr[l_res_size] := l_cy
					l_res_size := l_res_size + 1
				end
				a_res.item.mp_size := (-l_res_size).to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				js.return
			else
				from
				until
					js.loop_done
				loop
					l___mpz_srcptr_swap__tmp := l_op1
					l_op1 := l_op2
					l_op2 := l___mpz_srcptr_swap__tmp
					js.break
				end
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						l___mp_srcptr_swap__tmp := l_op1_ptr
						l_op1_ptr := l_op2_ptr
						l_op2_ptr := l___mp_srcptr_swap__tmp
						js.break
					end
					from
					until
						js.loop_done
					loop
						l___mp_size_t_swap__tmp := l_op1_size
						l_op1_size := l_op2_size
						l_op2_size := l___mp_size_t_swap__tmp
						js.break
					end
					js.break
				end
			end
			if not js.return_called then
				l_op2_size := -l_op2_size
				if (builtin_expect ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___16 := (l_aaf.new ((l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___16 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_op2_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_opx___0 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___16)
				gmp_inst.gmpn_sub_1 (l_opx___0, l_op2_ptr, l_op2_size, (1).to_natural_32).do_nothing
				l_op2_ptr := l_opx___0
				if l_op1_size > l_op2_size then
					l_res_size := l_op1_size
					if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
						realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
						l_res_ptr := a_res.item.mp_d
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_res_ptr + l_op2_size, l_op1_ptr + l_op2_size, l_res_size - l_op2_size)
							js.break
						end
						js.break
					end
					l_i := l_op2_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and ((l_op2_ptr[l_i]).bit_not))
						l_i := l_i - 1
					end
					a_res.item.mp_size := l_res_size.to_integer_32
				else
					l_i := l_op1_size - 1
					from
					until
						not (not js.loop_done and then (l_i >= 0))
					loop
						if ((l_op1_ptr[l_i]).bit_and ((l_op2_ptr[l_i]).bit_not)) /= {NATURAL_32} 0 then
							js.break
						end
						if not js.loop_jumped then
							l_i := l_i - 1
						end
					end
					l_res_size := l_i + 1
					if (a_res.item.mp_alloc).to_integer_32 < l_res_size then
						realloc_inst.gmpz_realloc (a_res, l_res_size).do_nothing
						l_res_ptr := a_res.item.mp_d
					end
					l_i := l_res_size - 1
					from
					until
						not (l_i >= 0)
					loop
						l_res_ptr[l_i] := ((l_op1_ptr[l_i]).bit_and ((l_op2_ptr[l_i]).bit_not))
						l_i := l_i - 1
					end
					a_res.item.mp_size := l_res_size.to_integer_32
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
