class
	P_AND_N

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_and_n (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32)
		local
			l___up: CE_POINTER [NATURAL_32]
			l___vp: CE_POINTER [NATURAL_32]
			l___rp: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l___a: NATURAL_32
			l___b: NATURAL_32
			js: JUMP_STATE
		do
			create l___up.make
			create l___vp.make
			create l___rp.make

			from
			until
				js.loop_done
			loop
				l___up := a_up
				l___vp := a_vp
				l___rp := a_rp
				l___n := a_n
				l___up := l___up + l___n
				l___vp := l___vp + l___n
				l___rp := l___rp + l___n
				l___n := -l___n
				from
				until
					js.loop_done
				loop
					l___a := l___up[l___n]
					l___b := l___vp[l___n]
					l___rp[l___n] := (l___a).bit_and (l___b)
					l___n := l___n + 1
					if not l___n.to_boolean then
						js.break
					end
				end
				js.break
			end
		end

end
