class
	P_BINVERT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_binvert (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_xp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_newrn: INTEGER_32
			l_sizes: CE_ARRAY [INTEGER_32]
			l_sizp: CE_POINTER [INTEGER_32]
			l_di: NATURAL_32
			l_tmp: CE_POINTER [INTEGER_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l___n___0: NATURAL_32
			l___inv: NATURAL_32
			l_m: INTEGER_32
			js: JUMP_STATE
		do
			create l_xp.make
			create l_sizes.make (<<({NATURAL_32} 8 * {PLATFORM}.Integer_32_bytes.to_natural_32 - {NATURAL_32} 9).to_integer_32>>)
			create l_sizp.make
			create l_tmp.make
			create l___dst.make
			create l_tmp___0.make

			l_sizp := l_sizes
			l_rn := a_n
			from
			until
				js.loop_done
			loop
				if 276 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_rn >= 276) then
						js.break
					end
				else
					js.break
				end
				if not js.loop_jumped then
					l_tmp := l_sizp
					l_sizp := l_sizp + 1
					l_tmp.item := l_rn
					l_rn := ((l_rn + 1)).bit_shift_right (1)
				end
			end
			l_xp := a_scratch
			from
			until
				js.loop_done
			loop
				if l_rn /= 0 then
					l___dst := l_xp
					l___n := l_rn
					from
					until
						js.loop_done
					loop
						l_tmp___0 := l___dst
						l___dst := l___dst + 1
						l_tmp___0.item := (0).to_natural_32
						l___n := l___n - 1
						if not l___n.to_boolean then
							js.break
						end
					end
				end
				js.break
			end
			l_xp[0] := (1).to_natural_32
			from
			until
				js.loop_done
			loop
				l___n___0 := a_up[0]
				l___inv := (gmp_impl_inst.gmp_binvert_limb_table[((l___n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n___0
				l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n___0
				l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
				js.break
			end
			if 132 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_rn >= 132 then
					dcpi1_bdiv_q_inst.gmpn_dcpi1_bdiv_q (a_rp, l_xp, l_rn, a_up, l_rn, (-l_di.to_integer_32).to_natural_32)
				else
					sbpi1_bdiv_q_inst.gmpn_sbpi1_bdiv_q (a_rp, l_xp, l_rn, a_up, l_rn, (-l_di.to_integer_32).to_natural_32)
				end
			else
				sbpi1_bdiv_q_inst.gmpn_sbpi1_bdiv_q (a_rp, l_xp, l_rn, a_up, l_rn, (-l_di.to_integer_32).to_natural_32)
			end
			from
			until
				not (l_rn < a_n)
			loop
				l_sizp := l_sizp - 1
				l_newrn := l_sizp.item
				l_m := mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (l_newrn)
				mulmod_bnm1_inst.gmpn_mulmod_bnm1 (l_xp, l_m, a_up, l_newrn, a_rp, l_rn, l_xp + l_m)
				gmp_inst.gmpn_sub_1 (l_xp + l_m, l_xp, l_rn - (l_m - l_newrn), (1).to_natural_32).do_nothing
				mullo_n_inst.gmpn_mullo_n (a_rp + l_rn, a_rp, (l_xp + l_rn), l_newrn - l_rn)
				gmp_inst.gmpn_neg (a_rp + l_rn, (a_rp + l_rn), l_newrn - l_rn).do_nothing
				l_rn := l_newrn
			end
		end

	gmpn_binvert_itch (a_n: INTEGER_32): INTEGER_32
		local
			l_itch_local: INTEGER_32
			l_itch_out: INTEGER_32
		do
			l_itch_local := (mulmod_bnm1_inst.gmpn_mulmod_bnm1_next_size (a_n))
			l_itch_out := (gmp_impl_inst.mpn_mulmod_bnm1_itch (l_itch_local, a_n, ((a_n + 1)).bit_shift_right (1)))
			Result := (l_itch_local + l_itch_out)
		end

end
