class
	P_COMPAT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_divexact_by3 (a_dst: CE_POINTER [NATURAL_32]; a_src: CE_POINTER [NATURAL_32]; a_size: INTEGER_32): NATURAL_32
		do
			Result := (({NATURAL_32} 3).bit_and ((gmp_impl_inst.gmpn_bdiv_dbm1c (a_dst, a_src, a_size, {NATURAL_32} 1_431_655_765, (0).to_natural_32))))
		end

	gmpn_divmod_1 (a_dst: CE_POINTER [NATURAL_32]; a_src: CE_POINTER [NATURAL_32]; a_size: INTEGER_32; a_divisor: NATURAL_32): NATURAL_32
		do
			Result := (gmp_inst.gmpn_divrem_1 (a_dst, (0).to_integer_32, a_src, a_size, a_divisor))
		end

	gmpz_legendre (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_b: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		do
			Result := (jacobi_inst.gmpz_jacobi (a_a, a_b))
		end

end
