class
	P_DCPI1_BDIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_dcpi1_bdiv_qr (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_qn: CE_ARRAY [INTEGER_32]
			l_rr: NATURAL_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___tmp_marker: CE_POINTER [PD_TMP_REENTRANT_T]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_qp.make
			create l_np.make
			create l_qn.make (<<1>>)
			create l_cy.make (<<1>>)
			create l_tp.make (<<1>>)
			create l___tmp_marker.make
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)

			l_qp := a_qp
			l_np := a_np
			l___tmp_marker := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			l_tp.item := create {CE_POINTER [NATURAL_32]}.make_cast ((l_aaf.new ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
			l_qn.item := a_nn - a_dn
			if l_qn.item > a_dn then
				from
				until
					js.loop_done
				loop
					l_qn.item := l_qn.item - a_dn
					if not (l_qn.item > a_dn) then
						js.break
					end
				end
				if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn.item >= 60 then
						l_cy.item := gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_qn.item, a_dinv, l_tp.item)
					else
						l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
					end
				else
					l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
				end
				l_rr := (0).to_natural_32
				if l_qn.item /= a_dn then
					if l_qn.item > a_dn - l_qn.item then
						mul_inst.gmpn_mul (l_tp.item, l_qp, l_qn.item, a_dp + l_qn.item, a_dn - l_qn.item).do_nothing
					else
						mul_inst.gmpn_mul (l_tp.item, a_dp + l_qn.item, a_dn - l_qn.item, l_qp, l_qn.item).do_nothing
					end
					from
					until
						js.loop_done
					loop
						asm325 (l___ptr_dummy, l_tp, l_qn, l_cy)
						js.break
					end
					l_rr := gmp_inst.gmpn_sub (l_np + l_qn.item, (l_np + l_qn.item), a_nn - l_qn.item, l_tp.item, a_dn)
					l_cy.item := (0).to_natural_32
				end
				l_np := l_np + (l_qn.item)
				l_qp := l_qp + (l_qn.item)
				l_qn.item := (a_nn - a_dn) - l_qn.item
				from
				until
					js.loop_done
				loop
					l_rr := l_rr + (gmp_inst.gmpn_sub_1 (l_np + a_dn, (l_np + a_dn), l_qn.item, l_cy.item))
					l_cy.item := gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, a_dn, a_dinv, l_tp.item)
					l_qp := l_qp + a_dn
					l_np := l_np + a_dn
					l_qn.item := l_qn.item - a_dn
					if not (l_qn.item > 0) then
						js.break
					end
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker)
					end
					js.break
				end
				Result := (l_rr + l_cy.item)
				js.return
			end
			if not js.return_called then
				if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_qn.item >= 60 then
						l_cy.item := gmpn_dcpi1_bdiv_qr_n (l_qp, l_np, a_dp, l_qn.item, a_dinv, l_tp.item)
					else
						l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
					end
				else
					l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_np, 2 * l_qn.item, a_dp, l_qn.item, a_dinv)
				end
				l_rr := (0).to_natural_32
				if l_qn.item /= a_dn then
					if l_qn.item > a_dn - l_qn.item then
						mul_inst.gmpn_mul (l_tp.item, l_qp, l_qn.item, a_dp + l_qn.item, a_dn - l_qn.item).do_nothing
					else
						mul_inst.gmpn_mul (l_tp.item, a_dp + l_qn.item, a_dn - l_qn.item, l_qp, l_qn.item).do_nothing
					end
					from
					until
						js.loop_done
					loop
						asm326 (l___ptr_dummy___0, l_tp, l_qn, l_cy)
						js.break
					end
					l_rr := gmp_inst.gmpn_sub (l_np + l_qn.item, (l_np + l_qn.item), a_nn - l_qn.item, l_tp.item, a_dn)
					l_cy.item := (0).to_natural_32
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not l___tmp_marker.is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker)
					end
					js.break
				end
				Result := (l_rr + l_cy.item)
			end
		end

	gmpn_dcpi1_bdiv_qr_n (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_dinv: NATURAL_32; a_tp: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_lo: CE_ARRAY [INTEGER_32]
			l_hi: CE_ARRAY [INTEGER_32]
			l_cy: CE_ARRAY [NATURAL_32]
			l_rh: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_tp.make (<<1>>)
			create l_lo.make (<<1>>)
			create l_hi.make (<<1>>)
			create l_cy.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)

			l_tp.item := a_tp
			l_lo.item := (a_n).bit_shift_right (1)
			l_hi.item := a_n - l_lo.item
			if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_lo.item >= 60 then
					l_cy.item := gmpn_dcpi1_bdiv_qr_n (a_qp, a_np, a_dp, l_lo.item, a_dinv, l_tp.item)
				else
					l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (a_qp, a_np, 2 * l_lo.item, a_dp, l_lo.item, a_dinv)
				end
			else
				l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (a_qp, a_np, 2 * l_lo.item, a_dp, l_lo.item, a_dinv)
			end
			mul_inst.gmpn_mul (l_tp.item, a_dp + l_lo.item, l_hi.item, a_qp, l_lo.item).do_nothing
			from
			until
				js.loop_done
			loop
				asm323 (l___ptr_dummy, l_tp, l_lo, l_cy)
				js.break
			end
			l_rh := gmp_inst.gmpn_sub (a_np + l_lo.item, (a_np + l_lo.item), a_n + l_hi.item, l_tp.item, a_n)
			if 60 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_hi.item >= 60 then
					l_cy.item := gmpn_dcpi1_bdiv_qr_n (a_qp + l_lo.item, a_np + l_lo.item, a_dp, l_hi.item, a_dinv, l_tp.item)
				else
					l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (a_qp + l_lo.item, a_np + l_lo.item, 2 * l_hi.item, a_dp, l_hi.item, a_dinv)
				end
			else
				l_cy.item := sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (a_qp + l_lo.item, a_np + l_lo.item, 2 * l_hi.item, a_dp, l_hi.item, a_dinv)
			end
			mul_inst.gmpn_mul (l_tp.item, (a_qp + l_lo.item), l_hi.item, a_dp + l_hi.item, l_lo.item).do_nothing
			from
			until
				js.loop_done
			loop
				asm324 (l___ptr_dummy___0, l_tp, l_hi, l_cy)
				js.break
			end
			l_rh := l_rh + (gmp_inst.gmpn_sub_n (a_np + a_n, (a_np + a_n), l_tp.item, a_n))
			Result := l_rh
		end

	gmpn_dcpi1_bdiv_qr_n_itch (a_n: INTEGER_32): INTEGER_32
		do
			Result := a_n
		end

end
