class
	P_EXPORT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_export (a_data: CE_POINTER [ANY]; a_countp: CE_POINTER [NATURAL_32]; a_order: INTEGER_32; a_size: NATURAL_32; a_endian: INTEGER_32; a_nail: NATURAL_32; a_z: CE_POINTER [PD_MPZ_STRUCT]): CE_POINTER [ANY]
		local
			l_data: CE_POINTER [ANY]
			l_countp: CE_POINTER [NATURAL_32]
			l_endian: INTEGER_32
			l_zsize: INTEGER_32
			l_zp: CE_POINTER [NATURAL_32]
			l_count: NATURAL_32
			l_dummy: CE_ARRAY [NATURAL_32]
			l_numb: NATURAL_32
			l_align: NATURAL_32
			l___cnt: INTEGER_32
			l___totbits: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___size: INTEGER_32
			l___src: CE_POINTER [NATURAL_32]
			l___i: INTEGER_32
			l___dst___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___src___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___size___0: INTEGER_32
			l___i___0: INTEGER_32
			l___dst___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___size___1: INTEGER_32
			l___src___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___i___1: INTEGER_32
			l_limb: NATURAL_32
			l_wbitsmask: NATURAL_32
			l_i: NATURAL_32
			l_numb___0: NATURAL_32
			l_j: INTEGER_32
			l_wbytes: INTEGER_32
			l_woffset: INTEGER_32
			l_dp: CE_POINTER [NATURAL_8]
			l_lbits: INTEGER_32
			l_wbits: INTEGER_32
			l_zend: CE_POINTER [NATURAL_32]
			l_tmp: NATURAL_32
			l_tmp___0: NATURAL_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_newlimb: NATURAL_32
			l_tmp___3: CE_POINTER [NATURAL_32]
			l_newlimb___0: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
		do
			create l_data.make
			create l_countp.make
			create l_zp.make
			create l_dummy.make (<<1>>)
			create l___dst.make
			create l___src.make
			create l___dst___0.make (<<1>>)
			create l___src___0.make (<<1>>)
			create l___dst___1.make (<<1>>)
			create l___src___1.make (<<1>>)
			create l_dp.make
			create l_zend.make
			create l_tmp___3.make
			create l_tmp___4.make

			l_data := a_data
			l_countp := a_countp
			l_endian := a_endian
			if l_countp.is_void then
				l_countp := l_dummy
			end
			l_zsize := (a_z.item.mp_size).to_integer_32
			if l_zsize = 0 then
				l_countp.item := (0).to_natural_32
				Result := l_data
				js.return
			end
			if not js.return_called then
				if l_zsize >= 0 then
					l_zsize := l_zsize
				else
					l_zsize := -l_zsize
				end
				l_zp := a_z.item.mp_d
				l_numb := ({NATURAL_32} 8 * a_size - a_nail).to_natural_32
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						l___cnt := builtin_clzl (l_zp[(l_zsize - 1)])
						js.break
					end
					l___totbits := (l_zsize * 32 - l___cnt.to_integer_32).to_natural_32
					l_count := (((l___totbits + l_numb) - {NATURAL_32} 1) // l_numb).to_natural_32
					js.break
				end
				l_countp.item := l_count
				if l_data.is_void then
					l_data := create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_count * a_size]))
				end
				if l_endian = 0 then
					l_endian := -1
				end
				l_align := ((create {CE_POINTER [INTEGER_8]}.make_cast (l_data)).distance ((create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))).to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32
				if a_nail = {NATURAL_32} 0 then
					if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
						if l_align = {NATURAL_32} 0 then
							if a_order = -1 then
								if l_endian = -1 then
									from
									until
										js.loop_done
									loop
										from
										until
											js.loop_done
										loop
											gmp_inst.gmpn_copyi (create {CE_POINTER [NATURAL_32]}.make_cast (l_data), l_zp, l_count.to_integer_32)
											js.break
										end
										js.break
									end
									Result := l_data
									js.return
								end
							end
							if not js.return_called and then (a_order = 1) then
								if l_endian = -1 then
									from
									until
										js.loop_done
									loop
										l___dst := create {CE_POINTER [NATURAL_32]}.make_cast (l_data)
										l___size := l_count.to_integer_32
										l___src := (l_zp + l___size) - 1
										l___i := (0).to_integer_32
										from
										until
											not (l___i < l___size)
										loop
											l___dst.item := l___src.item
											l___dst := l___dst + 1
											l___src := l___src - 1
											l___i := l___i + 1
										end
										js.break
									end
									Result := l_data
									js.return
								end
							end
							if not js.return_called and then (a_order = -1) then
								if l_endian = 1 then
									from
									until
										js.loop_done
									loop
										l___dst___0.item := create {CE_POINTER [NATURAL_32]}.make_cast (l_data)
										l___src___0.item := l_zp
										l___size___0 := l_count.to_integer_32
										l___i___0 := (0).to_integer_32
										from
										until
											not (not js.loop_done and then (l___i___0 < l___size___0))
										loop
											from
											until
												js.loop_done
											loop
												asm10 (l___dst___0, l___src___0)
												js.break
											end
											l___dst___0.item := l___dst___0.item + 1
											l___src___0.item := l___src___0.item + 1
											l___i___0 := l___i___0 + 1
										end
										js.break
									end
									Result := l_data
									js.return
								end
							end
							if not js.return_called and then (a_order = 1) then
								if l_endian = 1 then
									from
									until
										js.loop_done
									loop
										l___dst___1.item := create {CE_POINTER [NATURAL_32]}.make_cast (l_data)
										l___size___1 := l_count.to_integer_32
										l___src___1.item := (l_zp + l___size___1) - 1
										l___i___1 := (0).to_integer_32
										from
										until
											not (not js.loop_done and then (l___i___1 < l___size___1))
										loop
											from
											until
												js.loop_done
											loop
												asm11 (l___dst___1, l___src___1)
												js.break
											end
											l___dst___1.item := l___dst___1.item + 1
											l___src___1.item := l___src___1.item - 1
											l___i___1 := l___i___1 + 1
										end
										js.break
									end
									Result := l_data
									js.return
								end
							end
						end
					end
				end
			end
			if not js.return_called then
				l_numb___0 := a_size * {NATURAL_32} 8 - a_nail
				l_wbytes := (l_numb___0 // {NATURAL_32} 8).to_integer_32
				l_wbits := (l_numb___0 \\ {NATURAL_32} 8).to_integer_32
				l_wbitsmask := (({NATURAL_32} 1).bit_shift_left (l_wbits)) - {NATURAL_32} 1
				if l_endian >= 0 then
					l_tmp := a_size.to_natural_32
				else
					l_tmp := (-a_size.to_integer_32).to_natural_32
				end
				if a_order < 0 then
					l_tmp___0 := a_size.to_natural_32
				else
					l_tmp___0 := (-a_size.to_integer_32).to_natural_32
				end
				l_woffset := (l_tmp + l_tmp___0).to_integer_32
				if a_order >= 0 then
					l_tmp___1 := (l_count - {NATURAL_32} 1) * a_size
				else
					l_tmp___1 := (0).to_natural_32
				end
				if l_endian >= 0 then
					l_tmp___2 := a_size - {NATURAL_32} 1
				else
					l_tmp___2 := (0).to_natural_32
				end
				l_dp := (create {CE_POINTER [NATURAL_8]}.make_cast (l_data) + l_tmp___1.to_integer_32) + l_tmp___2.to_integer_32
				l_zend := l_zp + l_zsize
				l_lbits := 0
				l_limb := (0).to_natural_32
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_count))
				loop
					l_j := (0).to_integer_32
					from
					until
						not (not js.loop_done and then (l_j < l_wbytes))
					loop
						from
						until
							js.loop_done
						loop
							if l_lbits >= 8 then
								l_dp.item := l_limb.to_natural_8
								l_limb := (l_limb).bit_shift_right ((8))
								l_lbits := l_lbits - (8)
							else
								if l_zp.is_equal (l_zend) then
									l_newlimb := (0).to_natural_32
								else
									l_tmp___3 := l_zp
									l_zp := l_zp + 1
									l_newlimb := l_tmp___3.item
								end
								l_dp.item := ((l_limb).bit_or (((l_newlimb).bit_shift_left (l_lbits)))).to_natural_8
								l_limb := (l_newlimb).bit_shift_right ((8 - l_lbits))
								l_lbits := l_lbits + (24)
							end
							js.break
						end
						l_dp := l_dp - l_endian
						l_j := l_j + 1
					end
					if l_wbits /= 0 then
						from
						until
							js.loop_done
						loop
							if l_lbits >= l_wbits then
								l_dp.item := ((l_limb).bit_and (l_wbitsmask)).to_natural_8
								l_limb := (l_limb).bit_shift_right (l_wbits)
								l_lbits := l_lbits - l_wbits
							else
								if l_zp.is_equal (l_zend) then
									l_newlimb___0 := (0).to_natural_32
								else
									l_tmp___4 := l_zp
									l_zp := l_zp + 1
									l_newlimb___0 := l_tmp___4.item
								end
								l_dp.item := ((((l_limb).bit_or (((l_newlimb___0).bit_shift_left (l_lbits))))).bit_and (l_wbitsmask)).to_natural_8
								l_limb := (l_newlimb___0).bit_shift_right ((l_wbits - l_lbits))
								l_lbits := l_lbits + (32 - l_wbits)
							end
							js.break
						end
						l_dp := l_dp - l_endian
						l_j := l_j + 1
					end
					from
					until
						not (l_j.to_natural_32 < a_size.to_natural_32)
					loop
						l_dp.item := (('%/0/').code).to_natural_8
						l_dp := l_dp - l_endian
						l_j := l_j + 1
					end
					l_dp := l_dp + l_woffset
					l_i := l_i + 1
				end
				Result := l_data
			end
		end

end
