class
	P_ISET_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_init_set_ui (a_r: CE_POINTER [PD_MPF_STRUCT]; a_val: NATURAL_32)
		local
			l_prec: INTEGER_32
			l_size: INTEGER_32
		do
			l_prec := set_dfl_prec_inst.gmp_default_fp_limb_precision
			a_r.item.mp_prec := l_prec.to_integer_32
			a_r.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([((l_prec + 1) * 4).to_natural_32]))))
			a_r.item.mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			a_r.item.mp_size := l_size.to_integer_32
			a_r.item.mp_exp := l_size
		end

	gmpz_init_set_ui (a_dest: CE_POINTER [PD_MPZ_STRUCT]; a_val: NATURAL_32)
		local
			l_size: INTEGER_32
		do
			a_dest.item.mp_alloc := 1
			a_dest.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(4).to_natural_32]))))
			a_dest.item.mp_d[0] := (a_val).bit_and ({NATURAL_32} 4_294_967_295)
			l_size := (a_val /= {NATURAL_32} 0).to_integer
			a_dest.item.mp_size := l_size.to_integer_32
		end

end
