class
	P_LUCNUM2_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_lucnum2_ui (a_ln: CE_POINTER [PD_MPZ_STRUCT]; a_lnsub1: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32)
		local
			l_lp: CE_POINTER [NATURAL_32]
			l_l1p: CE_POINTER [NATURAL_32]
			l_f1p: CE_POINTER [NATURAL_32]
			l_size: INTEGER_32
			l_c: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_f: NATURAL_32
			l_f1: NATURAL_32
			l_tmp___2: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_lp.make
			create l_l1p.make
			create l_f1p.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make

			if a_n <= {NATURAL_32} 46 then
				l_f := fib_table_inst.gmp_fib_table[(a_n + {NATURAL_32} 1).to_integer_32]
				l_f1 := fib_table_inst.gmp_fib_table[(a_n.to_integer_32 - 1) + 1]
				a_ln.item.mp_d[0] := l_f + {NATURAL_32} 2 * l_f1
				a_ln.item.mp_size := 1
				if a_n = {NATURAL_32} 0 then
					a_lnsub1.item.mp_d[0] := (1).to_natural_32
				else
					a_lnsub1.item.mp_d[0] := {NATURAL_32} 2 * l_f - l_f1
				end
				if a_n = {NATURAL_32} 0 then
					a_lnsub1.item.mp_size := -1
				else
					a_lnsub1.item.mp_size := 1
				end
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_size := (((a_n // {NATURAL_32} 32) * {NATURAL_32} 23) // {NATURAL_32} 32).to_integer_32 + 4
				if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_f1p := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				if (builtin_expect ((l_size + 1 > (a_ln.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_ln, l_size + 1).do_nothing
				end
				if (builtin_expect ((l_size + 1 > (a_lnsub1.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_lnsub1, l_size + 1).do_nothing
				end
				l_lp := a_ln.item.mp_d
				l_l1p := a_lnsub1.item.mp_d
				l_size := fib2_ui_inst.gmpn_fib2_ui (l_l1p, l_f1p, a_n)
				l_c := gmp_inst.gmpn_lshift (l_lp, l_f1p, l_size, {NATURAL_32} 1)
				l_c := l_c + (gmp_inst.gmpn_add_n (l_lp, l_lp, l_l1p, l_size))
				l_lp[l_size] := l_c
				a_ln.item.mp_size := (l_size + (l_c /= {NATURAL_32} 0).to_integer).to_integer_32
				l_c := gmp_inst.gmpn_lshift (l_l1p, l_l1p, l_size, {NATURAL_32} 1)
				l_c := l_c - (gmp_inst.gmpn_sub_n (l_l1p, l_l1p, l_f1p, l_size))
				l_l1p[l_size] := l_c
				a_lnsub1.item.mp_size := (l_size + (l_c /= {NATURAL_32} 0).to_integer).to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
