class
	P_MOD

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_mod (a_rem: CE_POINTER [PD_MPZ_STRUCT]; a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_divisor: CE_POINTER [PD_MPZ_STRUCT]
			l_divisor_size: INTEGER_32
			l_temp_divisor: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_divisor.make
			create l_temp_divisor.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l___x.make
			create l_tmp___5.make

			l_divisor := a_divisor
			l_divisor_size := (l_divisor.item.mp_size).to_integer_32
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if a_rem.is_equal (l_divisor) then
				from
				until
					js.loop_done
				loop
					l___x := l_temp_divisor
					if l_divisor_size >= 0 then
						l___x.item.mp_alloc := l_divisor_size.to_integer_32
					else
						l___x.item.mp_alloc := (-l_divisor_size).to_integer_32
					end
					if l_divisor_size >= 0 then
						l_tmp___6 := l_divisor_size
					else
						l_tmp___6 := -l_divisor_size
					end
					if (builtin_expect ((l_tmp___6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						if l_divisor_size >= 0 then
							l_tmp___1 := l_divisor_size
						else
							l_tmp___1 := -l_divisor_size
						end
						l_tmp___5 := (l_aaf.new ((l_tmp___1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						if l_divisor_size >= 0 then
							l_tmp___3 := l_divisor_size
						else
							l_tmp___3 := -l_divisor_size
						end
						l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l___x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
					js.break
				end
				set_inst.gmpz_set (l_temp_divisor, l_divisor)
				l_divisor := create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_temp_divisor)
			end
			tdiv_r_inst.gmpz_tdiv_r (a_rem, a_dividend, l_divisor)
			if a_rem.item.mp_size /= 0 then
				if a_dividend.item.mp_size < 0 then
					if l_divisor.item.mp_size < 0 then
						aors_inst.gmpz_sub (a_rem, a_rem, l_divisor)
					else
						aors_inst.gmpz_add (a_rem, a_rem, l_divisor)
					end
				end
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
		end

end
