class
	P_REDC_2

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_addmul_2 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]): NATURAL_32
		do
			a_rp[a_n] := gmp_inst.gmpn_addmul_1 (a_rp, a_up, a_n, a_vp[0])
			Result := (gmp_inst.gmpn_addmul_1 (a_rp + 1, a_up, a_n, a_vp[1]))
		end

	gmpn_redc_2 (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_mip: CE_POINTER [NATURAL_32])
		local
			l_mip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_up: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_q: CE_ARRAY [NATURAL_32]
			l_j: INTEGER_32
			l_upn: NATURAL_32
			l_cy: NATURAL_32
			l__ph: CE_ARRAY [NATURAL_32]
			l__pl: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
		do
			create l_mip.make (<<1>>)
			create l_up.make (<<1>>)
			create l_q.make (<<2>>)
			create l__ph.make (<<1>>)
			create l__pl.make (<<1>>)

			l_mip.item := a_mip
			l_up.item := a_up
			if ((a_n).bit_and (1)) /= 0 then
				l_up.item[0] := gmp_inst.gmpn_addmul_1 (l_up.item, a_mp, a_n, (l_up.item[0] * l_mip.item[0]).bit_and ({NATURAL_32} 4_294_967_295))
				l_up.item := l_up.item + 1
			end
			l_j := a_n - 2
			from
			until
				not (not js.loop_done and then (l_j >= 0))
			loop
				from
				until
					js.loop_done
				loop
					asm339 (l__pl, l__ph, l_mip, l_up)
					l_q[1] := (l__ph.item + (l_mip.item[0] * l_up.item[1])) + (l_mip.item[1] * l_up.item[0])
					l_q[0] := l__pl.item
					js.break
				end
				l_upn := l_up.item[a_n]
				l_up.item[1] := gmpn_addmul_2 (l_up.item, a_mp, a_n, create {CE_POINTER [NATURAL_32]}.make_cast (l_q))
				l_up.item[0] := l_up.item[a_n]
				l_up.item[a_n] := l_upn
				l_up.item := l_up.item + (2)
				l_j := l_j - (2)
			end
			l_cy := gmp_inst.gmpn_add_n (a_rp, l_up.item, (l_up.item - a_n), a_n)
			if l_cy /= {NATURAL_32} 0 then
				gmp_inst.gmpn_sub_n (a_rp, a_rp, a_mp, a_n).do_nothing
			end
		end

end
