class
	P_SSCANF

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_sscanf (a_args: TUPLE [a_s: CE_POINTER [INTEGER_8]; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_s: CE_ARRAY [CE_POINTER [INTEGER_8]]
			l_ap: CE_VA_LIST
			l_ret: INTEGER_32
		do
			create l_s.make (<<1>>)
			create l_ap.make_shared (default_pointer)

			l_s.item := a_args.a_s
			l_ap := create {CE_VA_LIST}.make (a_args, 3)
			l_ret := doscan_inst.gmp_doscan (sscanffuns_inst.gmp_sscanf_funs, create {CE_POINTER [ANY]}.make_cast (l_s), a_args.a_fmt, l_ap.twin)
			Result := l_ret
		end

end
