class
	P_SUB_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_sub_ui (a_sum: CE_POINTER [PD_MPF_STRUCT]; a_u: CE_POINTER [PD_MPF_STRUCT]; a_v: NATURAL_32)
		local
			l_vv: CE_ARRAY [PD_MPF_STRUCT]
			l_vl: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
		do
			create l_vv.make (<<1>>)
			create l_vl.make (<<1>>)

			if a_v = {NATURAL_32} 0 then
				set_inst.gmpf_set (a_sum, a_u)
				js.return
			end
			if not js.return_called then
				l_vl.item := a_v
				l_vv.item.mp_size := 1
				l_vv.item.mp_d := l_vl
				l_vv.item.mp_exp := (1).to_integer_32
				sub_inst.gmpf_sub (a_sum, a_u, l_vv)
			end
		end

end
