class
	P_UI_DIV

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_ui_div (a_r: CE_POINTER [PD_MPF_STRUCT]; a_u: NATURAL_32; a_v: CE_POINTER [PD_MPF_STRUCT])
		local
			l_vp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_remp: CE_POINTER [NATURAL_32]
			l_new_vp: CE_POINTER [NATURAL_32]
			l_vsize: INTEGER_32
			l_rsize: INTEGER_32
			l_prospective_rsize: INTEGER_32
			l_zeros: INTEGER_32
			l_tsize: INTEGER_32
			l_high_zero: INTEGER_32
			l_sign_quotient: INTEGER_32
			l_prec: INTEGER_32
			l_rexp: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_size: INTEGER_32
			l_tmp___16: INTEGER_32
			l_tmp___20: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___22: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_vp.make
			create l_rp.make
			create l_tp.make
			create l_remp.make
			create l_new_vp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___20.make
			create l___dst.make
			create l_tmp___22.make

			l_vsize := (a_v.item.mp_size).to_integer_32
			l_sign_quotient := l_vsize
			if l_vsize >= 0 then
				l_vsize := l_vsize
			else
				l_vsize := -l_vsize
			end
			l_prec := (a_r.item.mp_prec).to_integer_32
			if (builtin_expect ((l_vsize = 0).to_integer, 0)).to_boolean then
				errno_inst.gmp_divide_by_zero
			end
			if (builtin_expect ((a_u = {NATURAL_32} 0).to_integer, 0)).to_boolean then
				a_r.item.mp_size := 0
				a_r.item.mp_exp := (0).to_integer_32
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_rexp := ((1 - a_v.item.mp_exp) + 1)
				l_rp := a_r.item.mp_d
				l_vp := a_v.item.mp_d
				l_prospective_rsize := (1 - l_vsize) + 1
				l_rsize := l_prec + 1
				l_zeros := l_rsize - l_prospective_rsize
				l_tsize := 1 + l_zeros
				if l_rp.is_equal (l_vp) then
					l_tmp___16 := l_vsize
				else
					l_tmp___16 := (0).to_integer_32
				end
				l_size := (l_vsize + l_tsize) + l_tmp___16
				if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___20 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___20 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_remp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___20)
				l_tp := l_remp + l_vsize
				l_new_vp := l_tp + l_tsize
				if l_rp.is_equal (l_vp) then
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_new_vp, l_vp, l_vsize)
							js.break
						end
						js.break
					end
					l_vp := l_new_vp
				end
				from
				until
					js.loop_done
				loop
					if l_tsize - 1 /= 0 then
						l___dst := l_tp
						l___n := l_tsize - 1
						from
						until
							js.loop_done
						loop
							l_tmp___22 := l___dst
							l___dst := l___dst + 1
							l_tmp___22.item := (0).to_natural_32
							l___n := l___n - 1
							if not l___n.to_boolean then
								js.break
							end
						end
					end
					js.break
				end
				l_tp[(l_tsize - 1)] := (a_u).bit_and ({NATURAL_32} 4_294_967_295)
				tdiv_qr_inst.gmpn_tdiv_qr (l_rp, l_remp, (0).to_integer_32, l_tp, l_tsize, l_vp, l_vsize)
				l_high_zero := (l_rp[(l_rsize - 1)] = {NATURAL_32} 0).to_integer
				l_rsize := l_rsize - l_high_zero
				l_rexp := l_rexp - l_high_zero
				if l_sign_quotient >= 0 then
					a_r.item.mp_size := l_rsize.to_integer_32
				else
					a_r.item.mp_size := (-l_rsize).to_integer_32
				end
				a_r.item.mp_exp := l_rexp
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
