class
	PD_GFSR4_STATE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ra.make (<<16_384>>)
		end

feature {ANY} -- fields

	nd: INTEGER_32 assign set_nd

	ra: CE_ARRAY [NATURAL_32]

feature {ANY} -- setters

	set_nd (a_nd: INTEGER_32)
		do
			nd := a_nd
			update_memory_field ("nd")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			nd := a_other.nd
			ra := a_other.ra.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				nd = a_other.nd and
				ra.is_equal (a_other.ra)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("nd"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ra", <<16_384>>)
				>>)
			init_structure_info
		end

end
