class
	PD_GSL_COMPLEX_FLOAT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create dat.make (<<2>>)
		end

feature {ANY} -- fields

	dat: CE_ARRAY [REAL_32]

feature {ANY}

	copy (a_other: like Current)
		do
			dat := a_other.dat.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				dat.is_equal (a_other.dat)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("dat", <<2>>)
				>>)
			init_structure_info
		end

end
