class
	PD_IEEE

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create byte.make (<<4>>)
		end

feature {ANY} -- fields

	byte: CE_ARRAY [NATURAL_8]

feature {ANY}

	copy (a_other: like Current)
		do
			byte := a_other.byte.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				byte.is_equal (a_other.byte)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("byte", <<4>>)
				>>)
			init_structure_info
		end

end
