class
	PD_TAUS113_STATE_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	z1: NATURAL_32 assign set_z1

	z2: NATURAL_32 assign set_z2

	z3: NATURAL_32 assign set_z3

	z4: NATURAL_32 assign set_z4

feature {ANY} -- setters

	set_z1 (a_z1: NATURAL_32)
		do
			z1 := a_z1
			update_memory_field ("z1")
		end

	set_z2 (a_z2: NATURAL_32)
		do
			z2 := a_z2
			update_memory_field ("z2")
		end

	set_z3 (a_z3: NATURAL_32)
		do
			z3 := a_z3
			update_memory_field ("z3")
		end

	set_z4 (a_z4: NATURAL_32)
		do
			z4 := a_z4
			update_memory_field ("z4")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			z1 := a_other.z1
			z2 := a_other.z2
			z3 := a_other.z3
			z4 := a_other.z4
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				z1 = a_other.z1 and
				z2 = a_other.z2 and
				z3 = a_other.z3 and
				z4 = a_other.z4
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("z1"),
					create {CE_STRUCTURE_FIELD}.make ("z2"),
					create {CE_STRUCTURE_FIELD}.make ("z3"),
					create {CE_STRUCTURE_FIELD}.make ("z4")
				>>)
			init_structure_info
		end

end
