frozen class
	LIBGSL_INITIALIZER_SLICE20

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {LIBGSL_INITIALIZER}

	initialize
		do
			coveyou_inst.ran_type___8[0].size := (create {PD_RAN_STATE_T}.make).structure_size.to_natural_32
			coveyou_inst.ran_type___8[0].set := coveyou_inst.ran_set___8_address
			coveyou_inst.ran_type___8[0].get := coveyou_inst.ran_get___8_address
			coveyou_inst.ran_type___8[0].get_double := coveyou_inst.ran_get_double___8_address
			coveyou_inst.gsl_rng_coveyou := coveyou_inst.ran_type___8
			cmrg_inst.m1___2 := (2_147_483_647).to_integer_32
			cmrg_inst.m2___2 := (2_145_483_479).to_integer_32
			cmrg_inst.a2___2 := (63_308).to_integer_32
			cmrg_inst.qa2 := (33_921).to_integer_32
			cmrg_inst.ra2 := (12_979).to_integer_32
			cmrg_inst.a32 := (-183_326).to_integer_32
			cmrg_inst.qa3 := (11_714).to_integer_32
			cmrg_inst.ra3 := (2_883).to_integer_32
			cmrg_inst.b1 := (86_098).to_integer_32
			cmrg_inst.qb1 := (24_919).to_integer_32
			cmrg_inst.rb1 := (7_417).to_integer_32
			cmrg_inst.b3___2 := (-539_608).to_integer_32
			cmrg_inst.qb3 := (3_976).to_integer_32
			cmrg_inst.rb3 := (2_071).to_integer_32
			cmrg_inst.cmrg_type[0].name := ce_string ("cmrg")
			cmrg_inst.cmrg_type[0].max := {NATURAL_32} 2_147_483_646
			cmrg_inst.cmrg_type[0].min := {NATURAL_32} 0
			cmrg_inst.cmrg_type[0].size := (create {PD_CMRG_STATE_T}.make).structure_size.to_natural_32
			cmrg_inst.cmrg_type[0].set := cmrg_inst.cmrg_set_address
			cmrg_inst.cmrg_type[0].get := cmrg_inst.cmrg_get_address
			cmrg_inst.cmrg_type[0].get_double := cmrg_inst.cmrg_get_double_address
			cmrg_inst.gsl_rng_cmrg := cmrg_inst.cmrg_type
			mt_inst.UPPER_MASK := {NATURAL_32} 2_147_483_648
			mt_inst.LOWER_MASK := {NATURAL_32} 2_147_483_647
			mt_inst.mt_type[0].name := ce_string ("mt19937")
			mt_inst.mt_type[0].max := {NATURAL_32} 4_294_967_295
			mt_inst.mt_type[0].min := {NATURAL_32} 0
			mt_inst.mt_type[0].size := (create {PD_MT_STATE_T}.make).structure_size.to_natural_32
			mt_inst.mt_type[0].set := mt_inst.mt_set_address
			mt_inst.mt_type[0].get := mt_inst.mt_get_address
			mt_inst.mt_type[0].get_double := mt_inst.mt_get_double_address
			mt_inst.mt_1999_type[0].name := ce_string ("mt19937_1999")
			mt_inst.mt_1999_type[0].max := {NATURAL_32} 4_294_967_295
			mt_inst.mt_1999_type[0].min := {NATURAL_32} 0
			mt_inst.mt_1999_type[0].size := (create {PD_MT_STATE_T}.make).structure_size.to_natural_32
			mt_inst.mt_1999_type[0].set := mt_inst.mt_1999_set_address
			mt_inst.mt_1999_type[0].get := mt_inst.mt_get_address
			mt_inst.mt_1999_type[0].get_double := mt_inst.mt_get_double_address
			mt_inst.mt_1998_type[0].name := ce_string ("mt19937_1998")
			mt_inst.mt_1998_type[0].max := {NATURAL_32} 4_294_967_295
			mt_inst.mt_1998_type[0].min := {NATURAL_32} 0
			mt_inst.mt_1998_type[0].size := (create {PD_MT_STATE_T}.make).structure_size.to_natural_32
			mt_inst.mt_1998_type[0].set := mt_inst.mt_1998_set_address
			mt_inst.mt_1998_type[0].get := mt_inst.mt_get_address
			mt_inst.mt_1998_type[0].get_double := mt_inst.mt_get_double_address
			mt_inst.gsl_rng_mt19937 := mt_inst.mt_type
			mt_inst.gsl_rng_mt19937_1999 := mt_inst.mt_1999_type
			mt_inst.gsl_rng_mt19937_1998 := mt_inst.mt_1998_type
			mt_inst.gsl_rng_default := mt_inst.mt_type
			mt_inst.gsl_rng_default_seed := {NATURAL_32} 0
			newton_inst.newton_type___0[0].name := ce_string ("newton")
			newton_inst.newton_type___0[0].size := (create {PD_NEWTON_STATE_T2}.make).structure_size.to_natural_32
			newton_inst.newton_type___0[0].set := newton_inst.newton_init_address
			newton_inst.newton_type___0[0].iterate := newton_inst.newton_iterate___0_address
			newton_inst.gsl_root_fdfsolver_newton := newton_inst.newton_type___0
			steffenson_inst.steffenson_type[0].name := ce_string ("steffenson")
			steffenson_inst.steffenson_type[0].size := (create {PD_STEFFENSON_STATE_T}.make).structure_size.to_natural_32
			steffenson_inst.steffenson_type[0].set := steffenson_inst.steffenson_init_address
			steffenson_inst.steffenson_type[0].iterate := steffenson_inst.steffenson_iterate_address
			steffenson_inst.gsl_root_fdfsolver_steffenson := steffenson_inst.steffenson_type
			bisection_inst.bisection_type[0].name := ce_string ("bisection")
			bisection_inst.bisection_type[0].size := (create {PD_BISECTION_STATE_T}.make).structure_size.to_natural_32
			bisection_inst.bisection_type[0].set := bisection_inst.bisection_init_address
			bisection_inst.bisection_type[0].iterate := bisection_inst.bisection_iterate_address
			bisection_inst.gsl_root_fsolver_bisection := bisection_inst.bisection_type
			brent_inst.brent_type___0[0].name := ce_string ("brent")
			brent_inst.brent_type___0[0].size := (create {PD_BRENT_STATE_T2}.make).structure_size.to_natural_32
			brent_inst.brent_type___0[0].set := brent_inst.brent_init___0_address
			brent_inst.brent_type___0[0].iterate := brent_inst.brent_iterate___0_address
			brent_inst.gsl_root_fsolver_brent := brent_inst.brent_type___0
			secant_inst.secant_type[0].name := ce_string ("secant")
			secant_inst.secant_type[0].size := (create {PD_SECANT_STATE_T}.make).structure_size.to_natural_32
			secant_inst.secant_type[0].set := secant_inst.secant_init_address
			secant_inst.secant_type[0].iterate := secant_inst.secant_iterate_address
			secant_inst.gsl_root_fdfsolver_secant := secant_inst.secant_type
			falsepos_inst.falsepos_type[0].name := ce_string ("falsepos")
			falsepos_inst.falsepos_type[0].size := (create {PD_FALSEPOS_STATE_T}.make).structure_size.to_natural_32
			falsepos_inst.falsepos_type[0].set := falsepos_inst.falsepos_init_address
			falsepos_inst.falsepos_type[0].iterate := falsepos_inst.falsepos_iterate_address
			falsepos_inst.gsl_root_fsolver_falsepos := falsepos_inst.falsepos_type
			bessel_temme_inst.g1_dat[0] := -1.14516408366268311786898152867
			bessel_temme_inst.g1_dat[1] := 0.00636085311347084238122955495
			bessel_temme_inst.g1_dat[2] := 0.00186245193007206848934643657
			bessel_temme_inst.g1_dat[3] := 0.000152833085873453507081227824
			bessel_temme_inst.g1_dat[4] := 0.000017017464011802038795324732
			bessel_temme_inst.g1_dat[5] := -6.4597502923347254354668326451e-07
			bessel_temme_inst.g1_dat[6] := -5.1819848432519380894104312968e-08
			bessel_temme_inst.g1_dat[7] := 4.5189092894858183051123180797e-10
			bessel_temme_inst.g1_dat[8] := 3.2433227371020873043666259180e-11
			bessel_temme_inst.g1_dat[9] := 6.8309434024947522875432400828e-13
			bessel_temme_inst.g1_dat[10] := 2.8353502755172101513119628130e-14
			bessel_temme_inst.g1_dat[11] := -7.9883905769323592875638087541e-16
			bessel_temme_inst.g1_dat[12] := -3.3726677300771949833341213457e-17
			bessel_temme_inst.g1_dat[13] := -3.6586334809210520744054437104e-20
			bessel_temme_inst.g1_cs[0].c := bessel_temme_inst.g1_dat
			bessel_temme_inst.g1_cs[0].order := 13
			bessel_temme_inst.g1_cs[0].a := (-1).to_double
			bessel_temme_inst.g1_cs[0].b := (1).to_double
			bessel_temme_inst.g1_cs[0].order_sp := 7
			bessel_temme_inst.g2_dat[0] := 1.882645524949671835019616975350
			bessel_temme_inst.g2_dat[1] := -0.077490658396167518329547945212
			bessel_temme_inst.g2_dat[2] := -0.018256714847324929419579340950
			bessel_temme_inst.g2_dat[3] := 0.0006338030209074895795923971731
			bessel_temme_inst.g2_dat[4] := 0.0000762290543508729021194461175
			bessel_temme_inst.g2_dat[5] := -9.5501647561720443519853993526e-07
			bessel_temme_inst.g2_dat[6] := -8.8927268107886351912431512955e-08
			bessel_temme_inst.g2_dat[7] := -1.9521334772319613740511880132e-09
			bessel_temme_inst.g2_dat[8] := -9.4003052735885162111769579771e-11
			bessel_temme_inst.g2_dat[9] := 4.6875133849532393179290879101e-12
			bessel_temme_inst.g2_dat[10] := 2.2658535746925759582447545145e-13
			bessel_temme_inst.g2_dat[11] := -1.1725509698488015111878735251e-15
			bessel_temme_inst.g2_dat[12] := -7.0441338200245222530843155877e-17
			bessel_temme_inst.g2_dat[13] := -2.4377878310107693650659740228e-18
			bessel_temme_inst.g2_dat[14] := -7.5225243218253901727164675011e-20
			bessel_temme_inst.g2_cs[0].c := bessel_temme_inst.g2_dat
			bessel_temme_inst.g2_cs[0].order := 14
			bessel_temme_inst.g2_cs[0].a := (-1).to_double
			bessel_temme_inst.g2_cs[0].b := (1).to_double
			bessel_temme_inst.g2_cs[0].order_sp := 8
			trig_inst.sinc_data[0] := 1.133648177811747875422
			trig_inst.sinc_data[1] := -0.532677564732557348781
			trig_inst.sinc_data[2] := -0.068293048346633177859
			trig_inst.sinc_data[3] := 0.033403684226353715020
			trig_inst.sinc_data[4] := 0.001485679893925747818
			trig_inst.sinc_data[5] := -0.000734421305768455295
			trig_inst.sinc_data[6] := -0.000016837282388837229
			trig_inst.sinc_data[7] := 0.000008359950146618018
			trig_inst.sinc_data[8] := 0.000000117382095601192
			trig_inst.sinc_data[9] := -0.000000058413665922724
			trig_inst.sinc_data[10] := -0.000000000554763755743
			trig_inst.sinc_data[11] := 0.000000000276434190426
			trig_inst.sinc_data[12] := 0.000000000001895374892
			trig_inst.sinc_data[13] := -0.000000000000945237101
			trig_inst.sinc_data[14] := -0.000000000000004900690
			trig_inst.sinc_data[15] := 0.000000000000002445383
			trig_inst.sinc_data[16] := 0.000000000000000009925
			trig_inst.sinc_cs[0].c := trig_inst.sinc_data
			trig_inst.sinc_cs[0].order := 16
			trig_inst.sinc_cs[0].a := (-1).to_double
			trig_inst.sinc_cs[0].b := (1).to_double
			trig_inst.sinc_cs[0].order_sp := 10
			trig_inst.sin_data[0] := -0.3295190160663511504173
			trig_inst.sin_data[1] := 0.0025374284671667991990
			trig_inst.sin_data[2] := 0.0006261928782647355874
			trig_inst.sin_data[3] := -4.6495547521854042157541e-06
			trig_inst.sin_data[4] := -5.6917531549379706526677e-07
			trig_inst.sin_data[5] := 3.7283335140973803627866e-09
			trig_inst.sin_data[6] := 3.0267376484747473727186e-10
			trig_inst.sin_data[7] := -1.7400875016436622322022e-12
			trig_inst.sin_data[8] := -1.0554678305790849834462e-13
			trig_inst.sin_data[9] := 5.3701981409132410797062e-16
			trig_inst.sin_data[10] := 2.5984137983099020336115e-17
			trig_inst.sin_data[11] := -1.1821555255364833468288e-19
			trig_inst.sin_cs[0].c := trig_inst.sin_data
			trig_inst.sin_cs[0].order := 11
			trig_inst.sin_cs[0].a := (-1).to_double
			trig_inst.sin_cs[0].b := (1).to_double
			trig_inst.sin_cs[0].order_sp := 11
			trig_inst.cos_data[0] := 0.165391825637921473505668118136
			trig_inst.cos_data[1] := -0.00084852883845000173671196530195
			trig_inst.cos_data[2] := -0.000210086507222940730213625768083
			trig_inst.cos_data[3] := 1.16582269619760204299639757584e-6
			trig_inst.cos_data[4] := 1.43319375856259870334412701165e-7
			trig_inst.cos_data[5] := -7.4770883429007141617951330184e-10
			trig_inst.cos_data[6] := -6.0969994944584252706997438007e-11
			trig_inst.cos_data[7] := 2.90748249201909353949854872638e-13
			trig_inst.cos_data[8] := 1.77126739876261435667156490461e-14
			trig_inst.cos_data[9] := -7.6896421502815579078577263149e-17
			trig_inst.cos_data[10] := -3.7363121133079412079201377318e-18
			trig_inst.cos_cs[0].c := trig_inst.cos_data
			trig_inst.cos_cs[0].order := 10
			trig_inst.cos_cs[0].a := (-1).to_double
			trig_inst.cos_cs[0].b := (1).to_double
			trig_inst.cos_cs[0].order_sp := 10
			atanint_inst.atanint_data[0] := 1.91040361296235937512
			atanint_inst.atanint_data[1] := -0.4176351437656746940e-01
			atanint_inst.atanint_data[2] := 0.275392550786367434e-02
			atanint_inst.atanint_data[3] := -0.25051809526248881e-03
			atanint_inst.atanint_data[4] := 0.2666981285121171e-04
			atanint_inst.atanint_data[5] := -0.311890514107001e-05
			atanint_inst.atanint_data[6] := 0.38833853132249e-06
			atanint_inst.atanint_data[7] := -0.5057274584964e-07
			atanint_inst.atanint_data[8] := 0.681225282949e-08
			atanint_inst.atanint_data[9] := -0.94212561654e-09
			atanint_inst.atanint_data[10] := 0.13307878816e-09
			atanint_inst.atanint_data[11] := -0.1912678075e-10
			atanint_inst.atanint_data[12] := 0.278912620e-11
			atanint_inst.atanint_data[13] := -0.41174820e-12
			atanint_inst.atanint_data[14] := 0.6142987e-13
			atanint_inst.atanint_data[15] := -0.924929e-14
			atanint_inst.atanint_data[16] := 0.140387e-14
			atanint_inst.atanint_data[17] := -0.21460e-15
			atanint_inst.atanint_data[18] := 0.3301e-16
			atanint_inst.atanint_data[19] := -0.511e-17
			atanint_inst.atanint_data[20] := 0.79e-18
			atanint_inst.atanint_cs[0].c := atanint_inst.atanint_data
			atanint_inst.atanint_cs[0].order := 20
			atanint_inst.atanint_cs[0].a := (-1).to_double
			atanint_inst.atanint_cs[0].b := (1).to_double
			atanint_inst.atanint_cs[0].order_sp := 10
			erfc_inst.P___0[0] := 2.97886562639399288862
			erfc_inst.P___0[1] := 7.409740605964741794425
			erfc_inst.P___0[2] := 6.1602098531096305440906
			erfc_inst.P___0[3] := 5.019049726784267463450058
			erfc_inst.P___0[4] := 1.275366644729965952479585264
			erfc_inst.P___0[5] := 0.5641895835477550741253201704
			erfc_inst.Q7[0] := 3.3690752069827527677
			erfc_inst.Q7[1] := 9.608965327192787870698
			erfc_inst.Q7[2] := 17.08144074746600431571095
			erfc_inst.Q7[3] := 12.0489519278551290360340491
			erfc_inst.Q7[4] := 9.396034016235054150430579648
			erfc_inst.Q7[5] := 2.260528520767326969591866945
			erfc_inst.Q7[6] := 1.0
			erfc_inst.erfc_xlt1_data[0] := 1.06073416421769980345174155056
			erfc_inst.erfc_xlt1_data[1] := -0.42582445804381043569204735291
			erfc_inst.erfc_xlt1_data[2] := 0.04955262679620434040357683080
			erfc_inst.erfc_xlt1_data[3] := 0.00449293488768382749558001242
			erfc_inst.erfc_xlt1_data[4] := -0.00129194104658496953494224761
			erfc_inst.erfc_xlt1_data[5] := -0.00001836389292149396270416979
			erfc_inst.erfc_xlt1_data[6] := 0.00002211114704099526291538556
			erfc_inst.erfc_xlt1_data[7] := -5.23337485234257134673693179020e-7
			erfc_inst.erfc_xlt1_data[8] := -2.78184788833537885382530989578e-7
			erfc_inst.erfc_xlt1_data[9] := 1.41158092748813114560316684249e-8
			erfc_inst.erfc_xlt1_data[10] := 2.72571296330561699984539141865e-9
			erfc_inst.erfc_xlt1_data[11] := -2.06343904872070629406401492476e-10
			erfc_inst.erfc_xlt1_data[12] := -2.14273991996785367924201401812e-11
			erfc_inst.erfc_xlt1_data[13] := 2.22990255539358204580285098119e-12
			erfc_inst.erfc_xlt1_data[14] := 1.36250074650698280575807934155e-13
			erfc_inst.erfc_xlt1_data[15] := -1.95144010922293091898995913038e-14
			erfc_inst.erfc_xlt1_data[16] := -6.85627169231704599442806370690e-16
			erfc_inst.erfc_xlt1_data[17] := 1.44506492869699938239521607493e-16
			erfc_inst.erfc_xlt1_data[18] := 2.45935306460536488037576200030e-18
			erfc_inst.erfc_xlt1_data[19] := -9.29599561220523396007359328540e-19
			erfc_inst.erfc_xlt1_cs[0].c := erfc_inst.erfc_xlt1_data
			erfc_inst.erfc_xlt1_cs[0].order := 19
			erfc_inst.erfc_xlt1_cs[0].a := (-1).to_double
			erfc_inst.erfc_xlt1_cs[0].b := (1).to_double
			erfc_inst.erfc_xlt1_cs[0].order_sp := 12
			erfc_inst.erfc_x15_data[0] := 0.44045832024338111077637466616
			erfc_inst.erfc_x15_data[1] := -0.143958836762168335790826895326
			erfc_inst.erfc_x15_data[2] := 0.044786499817939267247056666937
			erfc_inst.erfc_x15_data[3] := -0.013343124200271211203618353102
			erfc_inst.erfc_x15_data[4] := 0.003824682739750469767692372556
			erfc_inst.erfc_x15_data[5] := -0.001058699227195126547306482530
			erfc_inst.erfc_x15_data[6] := 0.000283859419210073742736310108
			erfc_inst.erfc_x15_data[7] := -0.000073906170662206760483959432
			erfc_inst.erfc_x15_data[8] := 0.000018725312521489179015872934
			erfc_inst.erfc_x15_data[9] := -4.62530981164919445131297264430e-6
			erfc_inst.erfc_x15_data[10] := 1.11558657244432857487884006422e-6
			erfc_inst.erfc_x15_data[11] := -2.63098662650834130067808832725e-7
			erfc_inst.erfc_x15_data[12] := 6.07462122724551777372119408710e-8
			erfc_inst.erfc_x15_data[13] := -1.37460865539865444777251011793e-8
			erfc_inst.erfc_x15_data[14] := 3.05157051905475145520096717210e-9
			erfc_inst.erfc_x15_data[15] := -6.65174789720310713757307724790e-10
			erfc_inst.erfc_x15_data[16] := 1.42483346273207784489792999706e-10
			erfc_inst.erfc_x15_data[17] := -3.00141127395323902092018744545e-11
			erfc_inst.erfc_x15_data[18] := 6.22171792645348091472914001250e-12
			erfc_inst.erfc_x15_data[19] := -1.26994639225668496876152836555e-12
			erfc_inst.erfc_x15_data[20] := 2.55385883033257575402681845385e-13
			erfc_inst.erfc_x15_data[21] := -5.06258237507038698392265499770e-14
			erfc_inst.erfc_x15_data[22] := 9.89705409478327321641264227110e-15
			erfc_inst.erfc_x15_data[23] := -1.90685978789192181051961024995e-15
			erfc_inst.erfc_x15_data[24] := 3.50826648032737849245113757340e-16
			erfc_inst.erfc_x15_cs[0].c := erfc_inst.erfc_x15_data
			erfc_inst.erfc_x15_cs[0].order := 24
			erfc_inst.erfc_x15_cs[0].a := (-1).to_double
			erfc_inst.erfc_x15_cs[0].b := (1).to_double
			erfc_inst.erfc_x15_cs[0].order_sp := 16
			erfc_inst.erfc_x510_data[0] := 1.11684990123545698684297865808
			erfc_inst.erfc_x510_data[1] := 0.003736240359381998520654927536
			erfc_inst.erfc_x510_data[2] := -0.000916623948045470238763619870
			erfc_inst.erfc_x510_data[3] := 0.000199094325044940833965078819
			erfc_inst.erfc_x510_data[4] := -0.000040276384918650072591781859
			erfc_inst.erfc_x510_data[5] := 7.76515264697061049477127605790e-6
			erfc_inst.erfc_x510_data[6] := -1.44464794206689070402099225301e-6
			erfc_inst.erfc_x510_data[7] := 2.61311930343463958393485241947e-7
			erfc_inst.erfc_x510_data[8] := -4.61833026634844152345304095560e-8
			erfc_inst.erfc_x510_data[9] := 8.00253111512943601598732144340e-9
			erfc_inst.erfc_x510_data[10] := -1.36291114862793031395712122089e-9
			erfc_inst.erfc_x510_data[11] := 2.28570483090160869607683087722e-10
			erfc_inst.erfc_x510_data[12] := -3.78022521563251805044056974560e-11
			erfc_inst.erfc_x510_data[13] := 6.17253683874528285729910462130e-12
			erfc_inst.erfc_x510_data[14] := -9.96019290955316888445830597430e-13
			erfc_inst.erfc_x510_data[15] := 1.58953143706980770269506726000e-13
			erfc_inst.erfc_x510_data[16] := -2.51045971047162509999527428316e-14
			erfc_inst.erfc_x510_data[17] := 3.92607828989125810013581287560e-15
			erfc_inst.erfc_x510_data[18] := -6.07970619384160374392535453420e-16
			erfc_inst.erfc_x510_data[19] := 9.12600607264794717315507477670e-17
			erfc_inst.erfc_x510_cs[0].c := erfc_inst.erfc_x510_data
			erfc_inst.erfc_x510_cs[0].order := 19
			erfc_inst.erfc_x510_cs[0].a := (-1).to_double
			erfc_inst.erfc_x510_cs[0].b := (1).to_double
			erfc_inst.erfc_x510_cs[0].order_sp := 12
			fermi_dirac_inst.fd_1_a_data[0] := 1.8949340668482264365
			fermi_dirac_inst.fd_1_a_data[1] := 0.7237719066890052793
			fermi_dirac_inst.fd_1_a_data[2] := 0.1250000000000000000
			fermi_dirac_inst.fd_1_a_data[3] := 0.0101065196435973942
			fermi_dirac_inst.fd_1_a_data[4] := 0.0
			fermi_dirac_inst.fd_1_a_data[5] := -0.0000600615242174119
			fermi_dirac_inst.fd_1_a_data[6] := 0.0
			fermi_dirac_inst.fd_1_a_data[7] := 6.816528764623e-7
			fermi_dirac_inst.fd_1_a_data[8] := 0.0
			fermi_dirac_inst.fd_1_a_data[9] := -9.5895779195e-9
			fermi_dirac_inst.fd_1_a_data[10] := 0.0
			fermi_dirac_inst.fd_1_a_data[11] := 1.515104135e-10
			fermi_dirac_inst.fd_1_a_data[12] := 0.0
			fermi_dirac_inst.fd_1_a_data[13] := -2.5785616e-12
			fermi_dirac_inst.fd_1_a_data[14] := 0.0
			fermi_dirac_inst.fd_1_a_data[15] := 4.62270e-14
			fermi_dirac_inst.fd_1_a_data[16] := 0.0
			fermi_dirac_inst.fd_1_a_data[17] := -8.612e-16
			fermi_dirac_inst.fd_1_a_data[18] := 0.0
			fermi_dirac_inst.fd_1_a_data[19] := 1.65e-17
			fermi_dirac_inst.fd_1_a_data[20] := 0.0
			fermi_dirac_inst.fd_1_a_data[21] := -3.e-19
			fermi_dirac_inst.fd_1_a_cs[0].c := fermi_dirac_inst.fd_1_a_data
			fermi_dirac_inst.fd_1_a_cs[0].order := 21
			fermi_dirac_inst.fd_1_a_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_1_a_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_1_a_cs[0].order_sp := 12
			fermi_dirac_inst.fd_1_b_data[0] := 10.409136795234611872
			fermi_dirac_inst.fd_1_b_data[1] := 3.899445098225161947
			fermi_dirac_inst.fd_1_b_data[2] := 0.513510935510521222
			fermi_dirac_inst.fd_1_b_data[3] := 0.010618736770218426
			fermi_dirac_inst.fd_1_b_data[4] := -0.001584468020659694
			fermi_dirac_inst.fd_1_b_data[5] := 0.000146139297161640
			fermi_dirac_inst.fd_1_b_data[6] := -1.408095734499e-6
			fermi_dirac_inst.fd_1_b_data[7] := -2.177993899484e-6
			fermi_dirac_inst.fd_1_b_data[8] := 3.91423660640e-7
			fermi_dirac_inst.fd_1_b_data[9] := -2.3860262660e-8
			fermi_dirac_inst.fd_1_b_data[10] := -4.138309573e-9
			fermi_dirac_inst.fd_1_b_data[11] := 1.283965236e-9
			fermi_dirac_inst.fd_1_b_data[12] := -1.39695990e-10
			fermi_dirac_inst.fd_1_b_data[13] := -4.907743e-12
			fermi_dirac_inst.fd_1_b_data[14] := 4.399878e-12
			fermi_dirac_inst.fd_1_b_data[15] := -7.17291e-13
			fermi_dirac_inst.fd_1_b_data[16] := 2.4320e-14
			fermi_dirac_inst.fd_1_b_data[17] := 1.4230e-14
			fermi_dirac_inst.fd_1_b_data[18] := -3.446e-15
			fermi_dirac_inst.fd_1_b_data[19] := 2.93e-16
			fermi_dirac_inst.fd_1_b_data[20] := 3.7e-17
			fermi_dirac_inst.fd_1_b_data[21] := -1.6e-17
			fermi_dirac_inst.fd_1_b_cs[0].c := fermi_dirac_inst.fd_1_b_data
			fermi_dirac_inst.fd_1_b_cs[0].order := 21
			fermi_dirac_inst.fd_1_b_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_1_b_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_1_b_cs[0].order_sp := 11
			fermi_dirac_inst.fd_1_c_data[0] := 56.78099449124299762
			fermi_dirac_inst.fd_1_c_data[1] := 21.00718468237668011
			fermi_dirac_inst.fd_1_c_data[2] := 2.24592457063193457
			fermi_dirac_inst.fd_1_c_data[3] := 0.00173793640425994
			fermi_dirac_inst.fd_1_c_data[4] := -0.00058716468739423
			fermi_dirac_inst.fd_1_c_data[5] := 0.00016306958492437
			fermi_dirac_inst.fd_1_c_data[6] := -0.00003817425583020
			fermi_dirac_inst.fd_1_c_data[7] := 7.64527252009e-6
			fermi_dirac_inst.fd_1_c_data[8] := -1.31348500162e-6
			fermi_dirac_inst.fd_1_c_data[9] := 1.9000646056e-7
			fermi_dirac_inst.fd_1_c_data[10] := -2.141328223e-8
			fermi_dirac_inst.fd_1_c_data[11] := 1.23906372e-9
			fermi_dirac_inst.fd_1_c_data[12] := 2.1848049e-10
			fermi_dirac_inst.fd_1_c_data[13] := -1.0134282e-10
			fermi_dirac_inst.fd_1_c_data[14] := 2.484728e-11
			fermi_dirac_inst.fd_1_c_data[15] := -4.73067e-12
			fermi_dirac_inst.fd_1_c_data[16] := 7.3555e-13
			fermi_dirac_inst.fd_1_c_data[17] := -8.740e-14
			fermi_dirac_inst.fd_1_c_data[18] := 4.85e-15
			fermi_dirac_inst.fd_1_c_data[19] := 1.23e-15
			fermi_dirac_inst.fd_1_c_data[20] := -5.6e-16
			fermi_dirac_inst.fd_1_c_data[21] := 1.4e-16
			fermi_dirac_inst.fd_1_c_data[22] := -3.e-17
			fermi_dirac_inst.fd_1_c_cs[0].c := fermi_dirac_inst.fd_1_c_data
			fermi_dirac_inst.fd_1_c_cs[0].order := 22
			fermi_dirac_inst.fd_1_c_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_1_c_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_1_c_cs[0].order_sp := 13
			fermi_dirac_inst.fd_1_d_data[0] := 1.0126626021151374442
			fermi_dirac_inst.fd_1_d_data[1] := -0.0063312525536433793
			fermi_dirac_inst.fd_1_d_data[2] := 0.0024837319237084326
			fermi_dirac_inst.fd_1_d_data[3] := -0.0008764333697726109
			fermi_dirac_inst.fd_1_d_data[4] := 0.0002913344438921266
			fermi_dirac_inst.fd_1_d_data[5] := -0.0000931877907705692
			fermi_dirac_inst.fd_1_d_data[6] := 0.0000290151342040275
			fermi_dirac_inst.fd_1_d_data[7] := -8.8548707259955e-6
			fermi_dirac_inst.fd_1_d_data[8] := 2.6603474114517e-6
			fermi_dirac_inst.fd_1_d_data[9] := -7.891415690452e-7
			fermi_dirac_inst.fd_1_d_data[10] := 2.315730237195e-7
			fermi_dirac_inst.fd_1_d_data[11] := -6.73179452963e-8
			fermi_dirac_inst.fd_1_d_data[12] := 1.94048035606e-8
			fermi_dirac_inst.fd_1_d_data[13] := -5.5507129189e-9
			fermi_dirac_inst.fd_1_d_data[14] := 1.5766090896e-9
			fermi_dirac_inst.fd_1_d_data[15] := -4.449310875e-10
			fermi_dirac_inst.fd_1_d_data[16] := 1.248292745e-10
			fermi_dirac_inst.fd_1_d_data[17] := -3.48392894e-11
			fermi_dirac_inst.fd_1_d_data[18] := 9.6791550e-12
			fermi_dirac_inst.fd_1_d_data[19] := -2.6786240e-12
			fermi_dirac_inst.fd_1_d_data[20] := 7.388852e-13
			fermi_dirac_inst.fd_1_d_data[21] := -2.032828e-13
			fermi_dirac_inst.fd_1_d_data[22] := 5.58115e-14
			fermi_dirac_inst.fd_1_d_data[23] := -1.52987e-14
			fermi_dirac_inst.fd_1_d_data[24] := 4.1886e-15
			fermi_dirac_inst.fd_1_d_data[25] := -1.1458e-15
			fermi_dirac_inst.fd_1_d_data[26] := 3.132e-16
			fermi_dirac_inst.fd_1_d_data[27] := -8.56e-17
			fermi_dirac_inst.fd_1_d_data[28] := 2.33e-17
			fermi_dirac_inst.fd_1_d_data[29] := -5.9e-18
			fermi_dirac_inst.fd_1_d_cs[0].c := fermi_dirac_inst.fd_1_d_data
			fermi_dirac_inst.fd_1_d_cs[0].order := 29
			fermi_dirac_inst.fd_1_d_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_1_d_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_1_d_cs[0].order_sp := 14
			fermi_dirac_inst.fd_1_e_data[0] := 1.0013707783890401683
			fermi_dirac_inst.fd_1_e_data[1] := 0.0009138522593601060
			fermi_dirac_inst.fd_1_e_data[2] := 0.0002284630648400133
			fermi_dirac_inst.fd_1_e_data[3] := -1.57e-17
			fermi_dirac_inst.fd_1_e_data[4] := -1.27e-17
			fermi_dirac_inst.fd_1_e_data[5] := -9.7e-18
			fermi_dirac_inst.fd_1_e_data[6] := -6.9e-18
			fermi_dirac_inst.fd_1_e_data[7] := -4.6e-18
			fermi_dirac_inst.fd_1_e_data[8] := -2.9e-18
			fermi_dirac_inst.fd_1_e_data[9] := -1.7e-18
			fermi_dirac_inst.fd_1_e_cs[0].c := fermi_dirac_inst.fd_1_e_data
			fermi_dirac_inst.fd_1_e_cs[0].order := 9
			fermi_dirac_inst.fd_1_e_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_1_e_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_1_e_cs[0].order_sp := 4
			fermi_dirac_inst.fd_2_a_data[0] := 2.1573661917148458336
			fermi_dirac_inst.fd_2_a_data[1] := 0.8849670334241132182
			fermi_dirac_inst.fd_2_a_data[2] := 0.1784163467613519713
			fermi_dirac_inst.fd_2_a_data[3] := 0.0208333333333333333
			fermi_dirac_inst.fd_2_a_data[4] := 0.0012708226459768508
			fermi_dirac_inst.fd_2_a_data[5] := 0.0
			fermi_dirac_inst.fd_2_a_data[6] := -5.0619314244895e-6
			fermi_dirac_inst.fd_2_a_data[7] := 0.0
			fermi_dirac_inst.fd_2_a_data[8] := 4.32026533989e-8
			fermi_dirac_inst.fd_2_a_data[9] := 0.0
			fermi_dirac_inst.fd_2_a_data[10] := -4.870544166e-10
			fermi_dirac_inst.fd_2_a_data[11] := 0.0
			fermi_dirac_inst.fd_2_a_data[12] := 6.4203740e-12
			fermi_dirac_inst.fd_2_a_data[13] := 0.0
			fermi_dirac_inst.fd_2_a_data[14] := -9.37424e-14
			fermi_dirac_inst.fd_2_a_data[15] := 0.0
			fermi_dirac_inst.fd_2_a_data[16] := 1.4715e-15
			fermi_dirac_inst.fd_2_a_data[17] := 0.0
			fermi_dirac_inst.fd_2_a_data[18] := -2.44e-17
			fermi_dirac_inst.fd_2_a_data[19] := 0.0
			fermi_dirac_inst.fd_2_a_data[20] := 4.e-19
			fermi_dirac_inst.fd_2_a_cs[0].c := fermi_dirac_inst.fd_2_a_data
			fermi_dirac_inst.fd_2_a_cs[0].order := 20
			fermi_dirac_inst.fd_2_a_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_2_a_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_2_a_cs[0].order_sp := 12
			fermi_dirac_inst.fd_2_b_data[0] := 16.508258811798623599
			fermi_dirac_inst.fd_2_b_data[1] := 7.421719394793067988
			fermi_dirac_inst.fd_2_b_data[2] := 1.458309885545603821
			fermi_dirac_inst.fd_2_b_data[3] := 0.128773850882795229
			fermi_dirac_inst.fd_2_b_data[4] := 0.001963612026198147
			fermi_dirac_inst.fd_2_b_data[5] := -0.000237458988738779
			fermi_dirac_inst.fd_2_b_data[6] := 0.000018539661382641
			fermi_dirac_inst.fd_2_b_data[7] := -1.92805649479e-7
			fermi_dirac_inst.fd_2_b_data[8] := -2.01950028452e-7
			fermi_dirac_inst.fd_2_b_data[9] := 3.2963497518e-8
			fermi_dirac_inst.fd_2_b_data[10] := -1.885817092e-9
			fermi_dirac_inst.fd_2_b_data[11] := -2.72632744e-10
			fermi_dirac_inst.fd_2_b_data[12] := 8.0554561e-11
			fermi_dirac_inst.fd_2_b_data[13] := -8.313223e-12
			fermi_dirac_inst.fd_2_b_data[14] := -2.24489e-13
			fermi_dirac_inst.fd_2_b_data[15] := 2.18778e-13
			fermi_dirac_inst.fd_2_b_data[16] := -3.4290e-14
			fermi_dirac_inst.fd_2_b_data[17] := 1.225e-15
			fermi_dirac_inst.fd_2_b_data[18] := 5.81e-16
			fermi_dirac_inst.fd_2_b_data[19] := -1.37e-16
			fermi_dirac_inst.fd_2_b_data[20] := 1.2e-17
			fermi_dirac_inst.fd_2_b_data[21] := 1.e-18
			fermi_dirac_inst.fd_2_b_cs[0].c := fermi_dirac_inst.fd_2_b_data
			fermi_dirac_inst.fd_2_b_cs[0].order := 21
			fermi_dirac_inst.fd_2_b_cs[0].a := (-1).to_double
			fermi_dirac_inst.fd_2_b_cs[0].b := (1).to_double
			fermi_dirac_inst.fd_2_b_cs[0].order_sp := 12
			fermi_dirac_inst.fd_2_c_data[0] := 168.87129776686440711
			fermi_dirac_inst.fd_2_c_data[1] := 81.80260488091659458
			fermi_dirac_inst.fd_2_c_data[2] := 15.75408505947931513
			fermi_dirac_inst.fd_2_c_data[3] := 1.12325586765966440
			fermi_dirac_inst.fd_2_c_data[4] := 0.00059057505725084
			fermi_dirac_inst.fd_2_c_data[5] := -0.00016469712946921
			fermi_dirac_inst.fd_2_c_data[6] := 0.00003885607810107
			fermi_dirac_inst.fd_2_c_data[7] := -7.89873660613e-6
			fermi_dirac_inst.fd_2_c_data[8] := 1.39786238616e-6
			fermi_dirac_inst.fd_2_c_data[9] := -2.1534528656e-7
			fermi_dirac_inst.fd_2_c_data[10] := 2.831510953e-8
			fermi_dirac_inst.fd_2_c_data[11] := -2.94978583e-9
			fermi_dirac_inst.fd_2_c_data[12] := 1.6755082e-10
			fermi_dirac_inst.fd_2_c_data[13] := 2.234229e-11
			fermi_dirac_inst.fd_2_c_data[14] := -1.035130e-11
			fermi_dirac_inst.fd_2_c_data[15] := 2.41117e-12
			fermi_dirac_inst.fd_2_c_data[16] := -4.3531e-13
		end

end
