class
	P_AIRY_DER

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create aif_cs___0.make (<<1>>)
			create aif_data.make (<<8>>)
			create aig_cs___0.make (<<1>>)
			create aig_data.make (<<9>>)
			create aip1_cs.make (<<1>>)
			create aip1_data.make (<<25>>)
			create aip2_cs.make (<<1>>)
			create aip2_data.make (<<15>>)
			create an20_cs.make (<<1>>)
			create an20_data.make (<<16>>)
			create an21_cs.make (<<1>>)
			create an21_data.make (<<24>>)
			create an22_cs.make (<<1>>)
			create an22_data.make (<<33>>)
			create aph0_cs.make (<<1>>)
			create aph0_data.make (<<15>>)
			create aph1_cs.make (<<1>>)
			create aph1_data.make (<<22>>)
			create aph2_cs.make (<<1>>)
			create aph2_data.make (<<32>>)
			create bif2_cs___0.make (<<1>>)
			create bif2_data.make (<<10>>)
			create bif_cs___0.make (<<1>>)
			create bif_data.make (<<8>>)
			create big2_cs___0.make (<<1>>)
			create big2_data.make (<<10>>)
			create big_cs___0.make (<<1>>)
			create big_data.make (<<9>>)
			create bip1_cs.make (<<1>>)
			create bip1_data.make (<<24>>)
			create bip2_cs___0.make (<<1>>)
			create bip2_data.make (<<29>>)
		end

feature {ANY} -- attributes

	aif_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aif_data: CE_ARRAY [REAL_64]

	aig_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aig_data: CE_ARRAY [REAL_64]

	aip1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aip1_data: CE_ARRAY [REAL_64]

	aip2_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aip2_data: CE_ARRAY [REAL_64]

	an20_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	an20_data: CE_ARRAY [REAL_64]

	an21_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	an21_data: CE_ARRAY [REAL_64]

	an22_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	an22_data: CE_ARRAY [REAL_64]

	aph0_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aph0_data: CE_ARRAY [REAL_64]

	aph1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aph1_data: CE_ARRAY [REAL_64]

	aph2_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	aph2_data: CE_ARRAY [REAL_64]

	bif2_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	bif2_data: CE_ARRAY [REAL_64]

	bif_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	bif_data: CE_ARRAY [REAL_64]

	big2_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	big2_data: CE_ARRAY [REAL_64]

	big_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	big_data: CE_ARRAY [REAL_64]

	bip1_cs: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	bip1_data: CE_ARRAY [REAL_64]

	bip2_cs___0: CE_ARRAY [PD_CHEB_SERIES_STRUCT]

	bip2_data: CE_ARRAY [REAL_64]

feature {ANY} -- routines

	airy_deriv_mod_phase (a_x: REAL_64; a_mode: NATURAL_32; a_ampl: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_phi: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_pi34: REAL_64
			l_result_a: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_p: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_a___5: REAL_64
			l_p: REAL_64
			l_sqx: REAL_64
			l_x32___0: REAL_64
			l_z: REAL_64
			l_z___0: REAL_64
			l_z___1: REAL_64
			l_tmp: REAL_64
			l_tmp___1: REAL_64
			js: JUMP_STATE
		do
			create l_result_a.make (<<1>>)
			create l_result_p.make (<<1>>)

			l_pi34 := 2.356194490192344928847
			if a_x <= -4.0 then
				l_z := 128.0 / ((a_x * a_x) * a_x) + 1.0
				cheb_eval_mode_inst.cheb_eval_mode_e (an20_cs, l_z, a_mode, l_result_a).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (aph0_cs, l_z, a_mode, l_result_p).do_nothing
			elseif a_x <= -2.0 then
				l_z___0 := (128.0 / ((a_x * a_x) * a_x) + 9.0) / 7.0
				cheb_eval_mode_inst.cheb_eval_mode_e (an21_cs, l_z___0, a_mode, l_result_a).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (aph1_cs, l_z___0, a_mode, l_result_p).do_nothing
			elseif a_x <= -1.0 then
				l_z___1 := (16.0 / ((a_x * a_x) * a_x) + 9.0) / 7.0
				cheb_eval_mode_inst.cheb_eval_mode_e (an22_cs, l_z___1, a_mode, l_result_a).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (aph2_cs, l_z___1, a_mode, l_result_p).do_nothing
			else
				a_ampl.item.val := 0.0
				a_ampl.item.err := 0.0
				a_phi.item.val := 0.0
				a_phi.item.err := 0.0
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("x is greater than 1.0"), ce_string ("airy_der.c"), 617, 1)
					Result := 1
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				l_a___5 := 0.3125 + l_result_a.item.val
				l_p := -0.625 + l_result_p.item.val
				l_sqx := sqrt (-a_x)
				l_x32___0 := a_x * l_sqx
				a_ampl.item.val := sqrt (l_a___5 * l_sqx)
				l_tmp := fabs (a_ampl.item.val)
				a_ampl.item.err := l_tmp * (2.2204460492503131e-16 + (fabs (l_result_a.item.err / l_result_a.item.val)))
				a_phi.item.val := l_pi34 - (a_x * l_sqx) * l_p
				l_tmp___1 := fabs (a_phi.item.val)
				a_phi.item.err := l_tmp___1 * (2.2204460492503131e-16 + (fabs (l_result_p.item.err / l_result_p.item.val)))
				Result := 0
			end
		end

	gsl_sf_airy_Ai_deriv (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_airy_Ai_deriv_e (a_x, a_mode, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Ai_deriv_e(x, mode, &result)"), ce_string ("airy_der.c"), 877, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Ai_deriv_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_a___5: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_p: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status_ap: INTEGER_32
			l_c___1: REAL_64
			l_tmp___1: REAL_64
			l_x3___1: REAL_64
			l_result_c1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_aps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_arg: REAL_64
			l_stat_a: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_a___5.make (<<1>>)
			create l_p.make (<<1>>)
			create l_result_c1.make (<<1>>)
			create l_result_c2.make (<<1>>)
			create l_result_aps.make (<<1>>)

			if a_x < -1.0 then
				l_status_ap := (airy_deriv_mod_phase (a_x, a_mode, l_a___5, l_p))
				l_c___1 := (cos (l_p.item.val))
				a_result.item.val := l_a___5.item.val * l_c___1
				l_tmp___1 := fabs (a_result.item.val * l_p.item.err)
				a_result.item.err := l_tmp___1 + (fabs (l_c___1 * l_a___5.item.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := l_status_ap
				js.return
			elseif a_x < 1.0 then
				l_x3___1 := (a_x * a_x) * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e (aif_cs___0, l_x3___1, a_mode, l_result_c1).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (aig_cs___0, l_x3___1, a_mode, l_result_c2).do_nothing
				a_result.item.val := ((a_x * a_x) * (0.125 + l_result_c1.item.val) - l_result_c2.item.val) - 0.25
				a_result.item.err := (fabs ((a_x * a_x) * l_result_c1.item.err)) + l_result_c2.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif (a_x * a_x) * a_x < ((9.0 / 4.0) * -7.0839641853226408e+02) * -7.0839641853226408e+02 then
				l_arg := ((-2.0 * a_x) * (sqrt (a_x))) / 3.0
				l_stat_a := (gsl_sf_airy_Ai_deriv_scaled_e (a_x, a_mode, l_result_aps))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_arg, 1.5 * (fabs (l_arg * 2.2204460492503131e-16)), l_result_aps.item.val, l_result_aps.item.err, a_result))
				if l_stat_e /= 0 then
					l_tmp___11 := l_stat_e
				else
					if l_stat_a /= 0 then
						l_tmp___10 := l_stat_a
					else
						l_tmp___10 := 0
					end
					l_tmp___11 := l_tmp___10
				end
				Result := l_tmp___11
				js.return
			else
				from
				until
					js.loop_done
				loop
					a_result.item.val := 0.0
					a_result.item.err := 2.2250738585072014e-308
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("underflow"), ce_string ("airy_der.c"), 734, 15)
						Result := 15
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_Ai_deriv_scaled (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_airy_Ai_deriv_scaled_e (a_x, a_mode, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Ai_deriv_scaled_e(x, mode, &result)"), ce_string ("airy_der.c"), 872, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Ai_deriv_scaled_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_a___5: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_p: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status_ap: INTEGER_32
			l_c___1: REAL_64
			l_tmp___1: REAL_64
			l_x3___1: REAL_64
			l_x2___1: REAL_64
			l_result_c0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s: REAL_64
			l_sqrtx: REAL_64
			l_z: REAL_64
			l_s___0: REAL_64
			l_result_c0___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sqrtx___0: REAL_64
			l_z___0: REAL_64
			l_s___1: REAL_64
			l_result_c0___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_a___5.make (<<1>>)
			create l_p.make (<<1>>)
			create l_result_c0.make (<<1>>)
			create l_result_c1.make (<<1>>)
			create l_result_c0___0.make (<<1>>)
			create l_result_c0___1.make (<<1>>)

			if a_x < -1.0 then
				l_status_ap := (airy_deriv_mod_phase (a_x, a_mode, l_a___5, l_p))
				l_c___1 := (cos (l_p.item.val))
				a_result.item.val := l_a___5.item.val * l_c___1
				l_tmp___1 := fabs (a_result.item.val * l_p.item.err)
				a_result.item.err := l_tmp___1 + (fabs (l_c___1 * l_a___5.item.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := l_status_ap
			elseif a_x <= 1.0 then
				l_x3___1 := (a_x * a_x) * a_x
				l_x2___1 := a_x * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e (aif_cs___0, l_x3___1, a_mode, l_result_c0).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (aig_cs___0, l_x3___1, a_mode, l_result_c1).do_nothing
				a_result.item.val := (l_x2___1 * (0.125 + l_result_c0.item.val) - l_result_c1.item.val) - 0.25
				a_result.item.err := (fabs (l_x2___1 * l_result_c0.item.val)) + l_result_c1.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if a_x > 6.0554544523933429e-06 * 6.0554544523933429e-06 then
					l_s := (exp (((2.0 * a_x) * (sqrt (a_x))) / 3.0))
					a_result.item.val := a_result.item.val * l_s
					a_result.item.err := a_result.item.err * l_s
				end
				Result := 0
			elseif a_x <= 4.0 then
				l_sqrtx := (sqrt (a_x))
				l_z := (16.0 / (a_x * l_sqrtx) - 9.0) / 7.0
				l_s___0 := (sqrt (l_sqrtx))
				cheb_eval_mode_inst.cheb_eval_mode_e (aip1_cs, l_z, a_mode, l_result_c0___0).do_nothing
				a_result.item.val := -(0.28125 + l_result_c0___0.item.val) * l_s___0
				a_result.item.err := l_result_c0___0.item.err * l_s___0
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			else
				l_sqrtx___0 := (sqrt (a_x))
				l_z___0 := 16.0 / (a_x * l_sqrtx___0) - 1.0
				l_s___1 := (sqrt (l_sqrtx___0))
				cheb_eval_mode_inst.cheb_eval_mode_e (aip2_cs, l_z___0, a_mode, l_result_c0___1).do_nothing
				a_result.item.val := -(0.28125 + l_result_c0___1.item.val) * l_s___1
				a_result.item.err := l_result_c0___1.item.err * l_s___1
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			end
		end

	gsl_sf_airy_Bi_deriv (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_airy_Bi_deriv_e (a_x, a_mode, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Bi_deriv_e(x, mode, &result)"), ce_string ("airy_der.c"), 887, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Bi_deriv_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_a___5: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_p: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status_ap: INTEGER_32
			l_s: REAL_64
			l_tmp___1: REAL_64
			l_x3___1: REAL_64
			l_x2___1: REAL_64
			l_result_c1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_z: REAL_64
			l_result_c1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c2___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_bps: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_arg: REAL_64
			l_stat_b: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			js: JUMP_STATE
		do
			create l_a___5.make (<<1>>)
			create l_p.make (<<1>>)
			create l_result_c1.make (<<1>>)
			create l_result_c2.make (<<1>>)
			create l_result_c1___0.make (<<1>>)
			create l_result_c2___0.make (<<1>>)
			create l_result_bps.make (<<1>>)

			if a_x < -1.0 then
				l_status_ap := (airy_deriv_mod_phase (a_x, a_mode, l_a___5, l_p))
				l_s := (sin (l_p.item.val))
				a_result.item.val := l_a___5.item.val * l_s
				l_tmp___1 := fabs (a_result.item.val * l_p.item.err)
				a_result.item.err := l_tmp___1 + (fabs (l_s * l_a___5.item.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := l_status_ap
				js.return
			elseif a_x < 1.0 then
				l_x3___1 := (a_x * a_x) * a_x
				l_x2___1 := a_x * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e (bif_cs___0, l_x3___1, a_mode, l_result_c1).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (big_cs___0, l_x3___1, a_mode, l_result_c2).do_nothing
				a_result.item.val := (l_x2___1 * (l_result_c1.item.val + 0.25) + l_result_c2.item.val) + 0.5
				a_result.item.err := l_x2___1 * l_result_c1.item.err + l_result_c2.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < 2.0 then
				l_z := (((2.0 * a_x) * a_x) * a_x - 9.0) / 7.0
				cheb_eval_mode_inst.cheb_eval_mode_e (bif2_cs___0, l_z, a_mode, l_result_c1___0).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (big2_cs___0, l_z, a_mode, l_result_c2___0).do_nothing
				a_result.item.val := ((a_x * a_x) * (l_result_c1___0.item.val + 0.25) + l_result_c2___0.item.val) + 0.5
				a_result.item.err := (a_x * a_x) * l_result_c1___0.item.err + l_result_c2___0.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
				js.return
			elseif a_x < 5.6438030941222897e+102 * 5.6438030941222897e+102 then
				l_arg := 2.0 * ((a_x * (sqrt (a_x))) / 3.0)
				l_stat_b := (gsl_sf_airy_Bi_deriv_scaled_e (a_x, a_mode, l_result_bps))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_arg, 1.5 * (fabs (l_arg * 2.2204460492503131e-16)), l_result_bps.item.val, l_result_bps.item.err, a_result))
				if l_stat_e /= 0 then
					l_tmp___11 := l_stat_e
				else
					if l_stat_b /= 0 then
						l_tmp___10 := l_stat_b
					else
						l_tmp___10 := 0
					end
					l_tmp___11 := l_tmp___10
				end
				Result := l_tmp___11
				js.return
			else
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_inff).to_double
					a_result.item.err := (builtin_inff).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("overflow"), ce_string ("airy_der.c"), 862, 16)
						Result := 16
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_airy_Bi_deriv_scaled (a_x: REAL_64; a_mode: NATURAL_32): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_airy_Bi_deriv_scaled_e (a_x, a_mode, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_airy_Bi_deriv_scaled_e(x, mode, &result)"), ce_string ("airy_der.c"), 882, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_airy_Bi_deriv_scaled_e (a_x: REAL_64; a_mode: NATURAL_32; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_atr: REAL_64
			l_btr: REAL_64
			l_a___5: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_p: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status_ap: INTEGER_32
			l_s: REAL_64
			l_tmp___1: REAL_64
			l_x3___1: REAL_64
			l_x2___1: REAL_64
			l_result_c1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_s___0: REAL_64
			l_z: REAL_64
			l_s___1: REAL_64
			l_result_c0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_result_c1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sqrtx: REAL_64
			l_z___0: REAL_64
			l_s___2: REAL_64
			l_result_c0___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_sqrtx___0: REAL_64
			l_z___1: REAL_64
			l_s___3: REAL_64
			l_result_c0___1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
		do
			create l_a___5.make (<<1>>)
			create l_p.make (<<1>>)
			create l_result_c1.make (<<1>>)
			create l_result_c2.make (<<1>>)
			create l_result_c0.make (<<1>>)
			create l_result_c1___0.make (<<1>>)
			create l_result_c0___0.make (<<1>>)
			create l_result_c0___1.make (<<1>>)

			l_atr := 8.7506905708484345
			l_btr := -2.0938363213560543
			if a_x < -1.0 then
				l_status_ap := (airy_deriv_mod_phase (a_x, a_mode, l_a___5, l_p))
				l_s := (sin (l_p.item.val))
				a_result.item.val := l_a___5.item.val * l_s
				l_tmp___1 := fabs (a_result.item.val * l_p.item.err)
				a_result.item.err := l_tmp___1 + (fabs (l_s * l_a___5.item.err))
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := l_status_ap
			elseif a_x < 1.0 then
				l_x3___1 := (a_x * a_x) * a_x
				l_x2___1 := a_x * a_x
				cheb_eval_mode_inst.cheb_eval_mode_e (bif_cs___0, l_x3___1, a_mode, l_result_c1).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (big_cs___0, l_x3___1, a_mode, l_result_c2).do_nothing
				a_result.item.val := (l_x2___1 * (l_result_c1.item.val + 0.25) + l_result_c2.item.val) + 0.5
				a_result.item.err := l_x2___1 * l_result_c1.item.err + l_result_c2.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				if a_x > 6.0554544523933429e-06 * 6.0554544523933429e-06 then
					l_s___0 := (exp (((-2.0 * a_x) * (sqrt (a_x))) / 3.0))
					a_result.item.val := a_result.item.val * l_s___0
					a_result.item.err := a_result.item.err * l_s___0
				end
				Result := 0
			elseif a_x < 2.0 then
				l_z := (((2.0 * a_x) * a_x) * a_x - 9.0) / 7.0
				l_s___1 := (exp (((-2.0 * a_x) * (sqrt (a_x))) / 3.0))
				cheb_eval_mode_inst.cheb_eval_mode_e (bif2_cs___0, l_z, a_mode, l_result_c0).do_nothing
				cheb_eval_mode_inst.cheb_eval_mode_e (big2_cs___0, l_z, a_mode, l_result_c1___0).do_nothing
				a_result.item.val := l_s___1 * (((a_x * a_x) * (0.25 + l_result_c0.item.val) + 0.5) + l_result_c1___0.item.val)
				a_result.item.err := l_s___1 * ((a_x * a_x) * l_result_c0.item.err + l_result_c1___0.item.err)
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			elseif a_x < 4.0 then
				l_sqrtx := (sqrt (a_x))
				l_z___0 := l_atr / (a_x * l_sqrtx) + l_btr
				l_s___2 := (sqrt (l_sqrtx))
				cheb_eval_mode_inst.cheb_eval_mode_e (bip1_cs, l_z___0, a_mode, l_result_c0___0).do_nothing
				a_result.item.val := l_s___2 * (0.625 + l_result_c0___0.item.val)
				a_result.item.err := l_s___2 * l_result_c0___0.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			else
				l_sqrtx___0 := (sqrt (a_x))
				l_z___1 := 16.0 / (a_x * l_sqrtx___0) - 1.0
				l_s___3 := (sqrt (l_sqrtx___0))
				cheb_eval_mode_inst.cheb_eval_mode_e (bip2_cs___0, l_z___1, a_mode, l_result_c0___1).do_nothing
				a_result.item.val := l_s___3 * (0.625 + l_result_c0___1.item.val)
				a_result.item.err := l_s___3 * l_result_c0___1.item.err
				a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (a_result.item.val)))
				Result := 0
			end
		end

end
