class
	P_DIFF

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_diff_backward (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_h: REAL_64
			l_a___5: CE_ARRAY [REAL_64]
			l_d: CE_ARRAY [REAL_64]
			l_a2___3: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_a___5.make (<<3>>)
			create l_d.make (<<3>>)

			l_h := 1.4901161193847656e-08
			l_i := 0
			from
			until
				not (l_i < 3)
			loop
				l_a___5[l_i] := a_x + (l_i.to_double - 2.0) * l_h
				l_d[l_i] := (a_f.item.function).real_64_item ([l_a___5[l_i], a_f.item.params])
				l_i := l_i + 1
			end
			l_k := 1
			from
			until
				not (not js.loop_done and then (l_k < 4))
			loop
				l_i := 0
				from
				until
					not (l_i < 3 - l_k)
				loop
					l_d[l_i] := (l_d[l_i + 1] - l_d[l_i]) / (l_a___5[l_i + l_k] - l_a___5[l_i])
					l_i := l_i + 1
				end
				l_k := l_k + 1
			end
			l_a2___3 := fabs ((l_d[0] + l_d[1]) + l_d[2])
			if l_a2___3 < 100.0 * 1.4901161193847656e-08 then
				l_a2___3 := 100.0 * 1.4901161193847656e-08
			end
			l_h := sqrt (1.4901161193847656e-08 / (2.0 * l_a2___3))
			if l_h > 100.0 * 1.4901161193847656e-08 then
				l_h := 100.0 * 1.4901161193847656e-08
			end
			l_tmp := (a_f.item.function).real_64_item ([a_x, a_f.item.params])
			a_result.item := (l_tmp - ((a_f.item.function).real_64_item ([a_x - l_h, a_f.item.params]))) / l_h
			a_abserr.item := fabs ((10.0 * l_a2___3) * l_h)
			Result := 0
		end

	gsl_diff_central (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_h: REAL_64
			l_a___5: CE_ARRAY [REAL_64]
			l_d: CE_ARRAY [REAL_64]
			l_a3___0: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_a___5.make (<<4>>)
			create l_d.make (<<4>>)

			l_h := 1.4901161193847656e-08
			l_i := 0
			from
			until
				not (l_i < 4)
			loop
				l_a___5[l_i] := a_x + (l_i.to_double - 2.0) * l_h
				l_d[l_i] := (a_f.item.function).real_64_item ([l_a___5[l_i], a_f.item.params])
				l_i := l_i + 1
			end
			l_k := 1
			from
			until
				not (not js.loop_done and then (l_k < 5))
			loop
				l_i := 0
				from
				until
					not (l_i < 4 - l_k)
				loop
					l_d[l_i] := (l_d[l_i + 1] - l_d[l_i]) / (l_a___5[l_i + l_k] - l_a___5[l_i])
					l_i := l_i + 1
				end
				l_k := l_k + 1
			end
			l_a3___0 := fabs (((l_d[0] + l_d[1]) + l_d[2]) + l_d[3])
			if l_a3___0 < 100.0 * 1.4901161193847656e-08 then
				l_a3___0 := 100.0 * 1.4901161193847656e-08
			end
			l_h := pow (1.4901161193847656e-08 / (2.0 * l_a3___0), 1.0 / 3.0)
			if l_h > 100.0 * 1.4901161193847656e-08 then
				l_h := 100.0 * 1.4901161193847656e-08
			end
			l_tmp := (a_f.item.function).real_64_item ([a_x + l_h, a_f.item.params])
			a_result.item := (l_tmp - ((a_f.item.function).real_64_item ([a_x - l_h, a_f.item.params]))) / (2.0 * l_h)
			a_abserr.item := fabs (((100.0 * l_a3___0) * l_h) * l_h)
			Result := 0
		end

	gsl_diff_forward (a_f: CE_POINTER [PD_GSL_FUNCTION_STRUCT]; a_x: REAL_64; a_result: CE_POINTER [REAL_64]; a_abserr: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_i: INTEGER_32
			l_k: INTEGER_32
			l_h: REAL_64
			l_a___5: CE_ARRAY [REAL_64]
			l_d: CE_ARRAY [REAL_64]
			l_a2___3: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			create l_a___5.make (<<3>>)
			create l_d.make (<<3>>)

			l_h := 1.4901161193847656e-08
			l_i := 0
			from
			until
				not (l_i < 3)
			loop
				l_a___5[l_i] := a_x + l_i.to_double * l_h
				l_d[l_i] := (a_f.item.function).real_64_item ([l_a___5[l_i], a_f.item.params])
				l_i := l_i + 1
			end
			l_k := 1
			from
			until
				not (not js.loop_done and then (l_k < 4))
			loop
				l_i := 0
				from
				until
					not (l_i < 3 - l_k)
				loop
					l_d[l_i] := (l_d[l_i + 1] - l_d[l_i]) / (l_a___5[l_i + l_k] - l_a___5[l_i])
					l_i := l_i + 1
				end
				l_k := l_k + 1
			end
			l_a2___3 := fabs ((l_d[0] + l_d[1]) + l_d[2])
			if l_a2___3 < 100.0 * 1.4901161193847656e-08 then
				l_a2___3 := 100.0 * 1.4901161193847656e-08
			end
			l_h := sqrt (1.4901161193847656e-08 / (2.0 * l_a2___3))
			if l_h > 100.0 * 1.4901161193847656e-08 then
				l_h := 100.0 * 1.4901161193847656e-08
			end
			l_tmp := (a_f.item.function).real_64_item ([a_x + l_h, a_f.item.params])
			a_result.item := (l_tmp - ((a_f.item.function).real_64_item ([a_x, a_f.item.params]))) / l_h
			a_abserr.item := fabs ((10.0 * l_a2___3) * l_h)
			Result := 0
		end

	gsl_multimin_diff (a_f: CE_POINTER [PD_GSL_MULTIMIN_FUNCTION_STRUCT]; a_x: CE_POINTER [PD_GSL_VECTOR]; a_g: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_i: NATURAL_32
			l_n: NATURAL_32
			l_h: REAL_64
			l_x1___0: CE_POINTER [PD_GSL_VECTOR]
			l_fl: REAL_64
			l_fh: REAL_64
			l_xi: REAL_64
			l_dx: REAL_64
		do
			create l_x1___0.make

			l_n := a_f.item.n
			l_h := 1.4901161193847656e-08
			l_x1___0 := (init_source_inst.gsl_vector_alloc (l_n))
			copy_source_inst.gsl_vector_memcpy (l_x1___0, a_x).do_nothing
			l_i := (0).to_natural_32
			from
			until
				not (l_i < l_n)
			loop
				l_xi := (gsl_gsl_vector_double_inst.gsl_vector_get (a_x, l_i))
				l_dx := (fabs (l_xi)) * l_h
				if l_dx = 0.0 then
					l_dx := l_h
				end
				gsl_gsl_vector_double_inst.gsl_vector_set (l_x1___0, l_i, l_xi + l_dx)
				l_fh := (a_f.item.f).real_64_item ([l_x1___0, a_f.item.params])
				gsl_gsl_vector_double_inst.gsl_vector_set (l_x1___0, l_i, l_xi - l_dx)
				l_fl := (a_f.item.f).real_64_item ([l_x1___0, a_f.item.params])
				gsl_gsl_vector_double_inst.gsl_vector_set (l_x1___0, l_i, l_xi)
				gsl_gsl_vector_double_inst.gsl_vector_set (a_g, l_i, (l_fh - l_fl) / (2.0 * l_dx))
				l_i := l_i + 1
			end
			init_source_inst.gsl_vector_free (l_x1___0)
			Result := 0
		end

end
