class
	P_DSDOT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_dsdot (a_N: INTEGER_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32; a_Y: CE_POINTER [REAL_32]; a_incY: INTEGER_32): REAL_64
		local
			l_r___3: REAL_64
			l_i: INTEGER_32
			l_ix: INTEGER_32
			l_tmp: INTEGER_32
			l_iy: INTEGER_32
			l_tmp___0: INTEGER_32
		do
			l_r___3 := 0.0
			if a_incX > 0 then
				l_tmp := 0
			else
				l_tmp := (a_N - 1) * -a_incX
			end
			l_ix := l_tmp
			if a_incY > 0 then
				l_tmp___0 := 0
			else
				l_tmp___0 := (a_N - 1) * -a_incY
			end
			l_iy := l_tmp___0
			l_i := 0
			from
			until
				not (l_i < a_N)
			loop
				l_r___3 := l_r___3 + (a_X[l_ix] * a_Y[l_iy]).to_double
				l_ix := l_ix + a_incX
				l_iy := l_iy + a_incY
				l_i := l_i + 1
			end
			Result := l_r___3
		end

end
