class
	P_FIND2D

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	find2d (a_nx: NATURAL_32; a_xrange: CE_POINTER [REAL_64]; a_ny: NATURAL_32; a_yrange: CE_POINTER [REAL_64]; a_x: REAL_64; a_y: REAL_64; a_i: CE_POINTER [NATURAL_32]; a_j: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			l_status := (find_inst.find___4 (a_nx, a_xrange, a_x, a_i))
			if l_status.to_boolean then
				Result := l_status
				js.return
			end
			if not js.return_called then
				l_status := find_inst.find___4 (a_ny, a_yrange, a_y, a_j)
				if l_status.to_boolean then
					Result := l_status
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

end
