class
	P_FLAT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_flat_P (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_P___2: REAL_64
		do
			if a_x < a_a___5 then
				l_P___2 := (0).to_double
			elseif a_x > a_b___0 then
				l_P___2 := (1).to_double
			else
				l_P___2 := (a_x - a_a___5) / (a_b___0 - a_a___5)
			end
			Result := l_P___2
		end

	gsl_cdf_flat_Q (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_Q___1: REAL_64
		do
			if a_x < a_a___5 then
				l_Q___1 := (1).to_double
			elseif a_x > a_b___0 then
				l_Q___1 := (0).to_double
			else
				l_Q___1 := (a_b___0 - a_x) / (a_b___0 - a_a___5)
			end
			Result := l_Q___1
		end

	gsl_ran_flat (a_r___3: CE_POINTER [PD_GSL_RNG]; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		local
			l_u: REAL_64
		do
			l_u := (gsl_gsl_rng_inst.gsl_rng_uniform (a_r___3))
			Result := (a_a___5 * ((1).to_double - l_u) + a_b___0 * l_u)
		end

	gsl_ran_flat_pdf (a_x: REAL_64; a_a___5: REAL_64; a_b___0: REAL_64): REAL_64
		do
			if a_x < a_b___0 then
				if a_x >= a_a___5 then
					Result := ((1).to_double / (a_b___0 - a_a___5))
				else
					Result := (0).to_double
				end
			else
				Result := (0).to_double
			end
		end

end
