class
	P_PROP_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_char_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_char_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_char_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_char_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_float_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_float_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_float_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_float_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_long_double_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] >= real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_long_double_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] < real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_long_double_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] /= real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_complex_long_double_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 2))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) * {NATURAL_32} 2 + l_k).to_integer_32] <= real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_float_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_float_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_float_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_float_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_int_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_int_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_int_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_int_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_double_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] >= real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_double_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] < real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_double_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] /= real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_double_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32] <= real_96_from_real_64 (0.0) then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_long_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_short_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_short_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_short_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_short_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_double <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uchar_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uchar_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uchar_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uchar_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uint_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uint_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uint_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_uint_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ulong_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ulong_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ulong_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ulong_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ushort_isneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 >= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ushort_isnonneg (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 < 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ushort_isnull (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 /= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_matrix_ushort_ispos (a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_size1))
			loop
				l_j := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_j < l_size2))
				loop
					l_k := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_k < {NATURAL_32} 1))
					loop
						if (a_m___4.item.data[((l_i * l_tda + l_j) + l_k).to_integer_32]).to_real_64 <= 0.0 then
							Result := 0
							js.return
						end
						if not js.return_called then
							l_k := l_k + 1
						end
					end
					if not js.return_called then
						l_j := l_j + 1
					end
				end
				if not js.return_called then
					l_i := l_i + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_char_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_char_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_char_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_char_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_float_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if (a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]).to_double >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_float_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if (a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]).to_double < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_float_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if (a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]).to_double /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_float_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if (a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32]).to_double <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_long_double_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] >= real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_long_double_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] < real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_long_double_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] /= real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_complex_long_double_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 2))
				loop
					if a_v.item.data[(({NATURAL_32} 2 * l_stride) * l_j + l_k).to_integer_32] <= real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_float_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_float_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_float_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_float_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_int_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_int_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_int_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_int_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_isneg (a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_isnull (a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ispos (a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_double_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] >= real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_double_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] < real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_double_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] /= real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_double_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if a_v.item.data[(l_stride * l_j + l_k).to_integer_32] <= real_96_from_real_64 (0.0) then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_long_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_short_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_short_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_short_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_short_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_double <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uchar_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uchar_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uchar_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uchar_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uint_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uint_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uint_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_uint_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ulong_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ulong_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ulong_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ulong_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ushort_isneg (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 >= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ushort_isnonneg (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 < 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ushort_isnull (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 /= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

	gsl_vector_ushort_ispos (a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_n: NATURAL_32
			l_stride: NATURAL_32
			l_j: NATURAL_32
			l_k: NATURAL_32
			js: JUMP_STATE
		do
			l_n := a_v.item.size
			l_stride := a_v.item.stride
			l_j := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_j < l_n))
			loop
				l_k := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_k < {NATURAL_32} 1))
				loop
					if (a_v.item.data[(l_stride * l_j + l_k).to_integer_32]).to_real_64 <= 0.0 then
						Result := 0
						js.return
					end
					if not js.return_called then
						l_k := l_k + 1
					end
				end
				if not js.return_called then
					l_j := l_j + 1
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

end
