class
	P_WATERMAN14

inherit
	LIBGSL_DATA
		redefine
			default_create
		end
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {NONE} -- Initialization

	default_create
		do
			create gsl_rng_waterman14.make
			create ran_type___5.make (<<1>>)
		end

feature {ANY} -- attributes

	gsl_rng_waterman14: CE_POINTER [PD_GSL_RNG_TYPE] assign set_gsl_rng_waterman14

	set_gsl_rng_waterman14 (a_gsl_rng_waterman14: CE_POINTER [PD_GSL_RNG_TYPE])
		do
			gsl_rng_waterman14 := a_gsl_rng_waterman14
		end

	ran_type___5: CE_ARRAY [PD_GSL_RNG_TYPE]

feature {ANY} -- routines

	ran_get___5 (a_vstate: CE_POINTER [ANY]): NATURAL_32
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			l_state.item.x := ({NATURAL_32} 1_566_083_941 * l_state.item.x).bit_and ({NATURAL_32} 4_294_967_295)
			Result := (l_state.item.x)
		end

	ran_get___5_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get___5)
		end

	ran_get_double___5 (a_vstate: CE_POINTER [ANY]): REAL_64
		local
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_state := create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			Result := ((ran_get___5 (create {CE_POINTER [ANY]}.make_cast (l_state))).to_real_64 / 4294967296.0)
		end

	ran_get_double___5_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_get_double___5)
		end

	ran_set___5 (a_vstate: CE_POINTER [ANY]; a_s: NATURAL_32)
		local
			l_s: NATURAL_32
			l_state: CE_POINTER [PD_RAN_STATE_T]
		do
			create l_state.make

			l_s := a_s
			l_state := create {CE_POINTER [PD_RAN_STATE_T]}.make_cast (a_vstate)
			if l_s = {NATURAL_32} 0 then
				l_s := {NATURAL_32} 1
			end
			l_state.item.x := (l_s).bit_and ({NATURAL_32} 4_294_967_295)
		end

	ran_set___5_address: CE_ROUTINE
		once ("OBJECT")
			create Result.make_agent (agent ran_set___5)
		end

end
