deferred class
	S_STDIO

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	fclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fclose (a___stream.c_pointer)
		end

	c_fclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fclose($a___stream);"
		end

	fgetc (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fgetc (a___stream.c_pointer)
		end

	c_fgetc (a___stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fgetc($a___stream);"
		end

	fgets (a___s: CE_POINTER [INTEGER_8]; a___n: INTEGER_32; a___stream: CE_POINTER [SD_IO_FILE]): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_fgets (a___s.c_pointer, a___n, a___stream.c_pointer))
		end

	c_fgets (a___s: POINTER; a___n: INTEGER_32; a___stream: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return fgets($a___s, $a___n, $a___stream);"
		end

	fileno (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_fileno (a___stream.c_pointer)
		end

	c_fileno (a___stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return fileno($a___stream);"
		end

	fopen (a___filename: CE_POINTER [INTEGER_8]; a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_fopen (a___filename.c_pointer, a___modes.c_pointer))
		end

	c_fopen (a___filename: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return fopen($a___filename, $a___modes);"
		end

	pclose (a___stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_pclose (a___stream.c_pointer)
		end

	c_pclose (a___stream: POINTER): INTEGER_32
		external
			"C inline use <less.h>"
		alias
			"return pclose($a___stream);"
		end

	popen (a___command: CE_POINTER [INTEGER_8]; a___modes: CE_POINTER [INTEGER_8]): CE_POINTER [SD_IO_FILE]
		do
			create Result.make_shared (c_popen (a___command.c_pointer, a___modes.c_pointer))
		end

	c_popen (a___command: POINTER; a___modes: POINTER): POINTER
		external
			"C inline use <less.h>"
		alias
			"return popen($a___command, $a___modes);"
		end

	sprintf (a_args: TUPLE [a___s: CE_POINTER [INTEGER_8]; a___format: CE_POINTER [INTEGER_8]]): INTEGER_32
		do
			Result := (create {CE_ROUTINE}.make_shared (c_sprintf)).integer_32_item (a_args)
		end

	c_sprintf: POINTER
		external
			"C inline use <less.h>"
		alias
			"return &sprintf;"
		end

end
