class
	SD_ITIMERVAL

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create it_interval.make
			create it_value.make
		end

feature {ANY} -- fields

	it_interval: SD_TIMEVAL assign set_it_interval

	it_value: SD_TIMEVAL assign set_it_value

feature {ANY} -- setters

	set_it_interval (a_it_interval: SD_TIMEVAL)
		do
			it_interval := a_it_interval
			update_memory_field ("it_interval")
		end

	set_it_value (a_it_value: SD_TIMEVAL)
		do
			it_value := a_it_value
			update_memory_field ("it_value")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			it_interval := a_other.it_interval.twin
			it_value := a_other.it_value.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				it_interval.is_equal (a_other.it_interval) and
				it_value.is_equal (a_other.it_value)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("it_interval"),
					create {CE_STRUCTURE_FIELD}.make ("it_value")
				>>)
			init_structure_info
		end

end
