deferred class
	S_GETOPT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- attributes

	optarg: CE_POINTER [INTEGER_8] assign set_optarg
		do
			create Result.make_shared (c_optarg)
		end

	c_optarg: POINTER
		external
			"C inline use <wget.h>"
		alias
			"return optarg;"
		end

	set_optarg (a_optarg: CE_POINTER [INTEGER_8])
		do
			c_set_optarg (a_optarg.c_pointer)
		end

	c_set_optarg (a_optarg: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"optarg = (char *)$a_optarg;"
		end

	optind: INTEGER_32 assign set_optind
		external
			"C inline use <wget.h>"
		alias
			"return optind;"
		end

	set_optind (a_optind: INTEGER_32)
		external
			"C inline use <wget.h>"
		alias
			"optind = $a_optind;"
		end

feature {ANY} -- routines

	getopt_long (a____argc: INTEGER_32; a____argv: CE_POINTER [CE_POINTER [INTEGER_8]]; a___shortopts: CE_POINTER [INTEGER_8]; a___longopts: CE_POINTER [SD_OPTION]; a___longind: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_getopt_long (a____argc, a____argv.c_pointer, a___shortopts.c_pointer, a___longopts.c_pointer, a___longind.c_pointer)
		end

	c_getopt_long (a____argc: INTEGER_32; a____argv: POINTER; a___shortopts: POINTER; a___longopts: POINTER; a___longind: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getopt_long($a____argc, $a____argv, $a___shortopts, $a___longopts, $a___longind);"
		end

end
