deferred class
	S_NETDB

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	freeaddrinfo (a___ai: CE_POINTER [SD_ADDRINFO])
		do
			c_freeaddrinfo (a___ai.c_pointer)
		end

	c_freeaddrinfo (a___ai: POINTER)
		external
			"C inline use <wget.h>"
		alias
			"freeaddrinfo($a___ai);"
		end

	gai_strerror (a___ecode: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create Result.make_shared (c_gai_strerror (a___ecode))
		end

	c_gai_strerror (a___ecode: INTEGER_32): POINTER
		external
			"C inline use <wget.h>"
		alias
			"return gai_strerror($a___ecode);"
		end

	getaddrinfo (a___name: CE_POINTER [INTEGER_8]; a___service: CE_POINTER [INTEGER_8]; a___req: CE_POINTER [SD_ADDRINFO]; a___pai: CE_POINTER [CE_POINTER [SD_ADDRINFO]]): INTEGER_32
		do
			Result := c_getaddrinfo (a___name.c_pointer, a___service.c_pointer, a___req.c_pointer, a___pai.c_pointer)
		end

	c_getaddrinfo (a___name: POINTER; a___service: POINTER; a___req: POINTER; a___pai: POINTER): INTEGER_32
		external
			"C inline use <wget.h>"
		alias
			"return getaddrinfo($a___name, $a___service, $a___req, $a___pai);"
		end

end
