class
	PD_DEFAULT_KB

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	act: INTEGER_32 assign set_act

	x: INTEGER_32 assign set_x

	y: INTEGER_32 assign set_y

feature {ANY} -- setters

	set_act (a_act: INTEGER_32)
		do
			act := a_act
			update_memory_field ("act")
		end

	set_x (a_x: INTEGER_32)
		do
			x := a_x
			update_memory_field ("x")
		end

	set_y (a_y: INTEGER_32)
		do
			y := a_y
			update_memory_field ("y")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			act := a_other.act
			x := a_other.x
			y := a_other.y
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				act = a_other.act and
				x = a_other.x and
				y = a_other.y
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("act"),
					create {CE_STRUCTURE_FIELD}.make ("x"),
					create {CE_STRUCTURE_FIELD}.make ("y")
				>>)
			init_structure_info
		end

end
