class
	PD_TRANSLATION_DESC

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create t.make
		end

feature {ANY} -- fields

	t: CE_POINTER [PD_TRANSLATION] assign set_t

feature {ANY} -- setters

	set_t (a_t: CE_POINTER [PD_TRANSLATION])
		do
			t := a_t
			update_memory_field ("t")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			t := a_other.t
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				t.is_equal (a_other.t)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("t")
				>>)
			init_structure_info
		end

end
