class
	PD_UNICODE_UPCASE

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	lo: INTEGER_32 assign set_lo

	up: INTEGER_32 assign set_up

feature {ANY} -- setters

	set_lo (a_lo: INTEGER_32)
		do
			lo := a_lo
			update_memory_field ("lo")
		end

	set_up (a_up: INTEGER_32)
		do
			up := a_up
			update_memory_field ("up")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			lo := a_other.lo
			up := a_other.up
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				lo = a_other.lo and
				up = a_other.up
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("lo"),
					create {CE_STRUCTURE_FIELD}.make ("up")
				>>)
			init_structure_info
		end

end
