frozen class
	LINKS_INITIALIZER_SLICE1

inherit
	LINKS_DATA
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {LINKS_INITIALIZER}

	initialize
		do
			af_unix_inst.s_unix_acc := create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
			af_unix_inst.s_unix := create {CE_POINTER [SD_SOCKADDR]}.make_shared (default_pointer)
			af_unix_inst.s_unix_fd := -1
			bfu_inst.m_bar[0] := (0).to_natural_8
			bookmark_inst.bookmarks[0].next := create {CE_POINTER [ANY]}.make_cast (bookmark_inst.bookmarks)
			bookmark_inst.bookmarks[0].prev := create {CE_POINTER [ANY]}.make_cast (bookmark_inst.bookmarks)
			bookmark_inst.next_bookmark_id := 0
			bookmark_inst.bookmark_add_msg[0] := links_inst.dummyarray + 268
			bookmark_inst.bookmark_add_msg[1] := links_inst.dummyarray + 241
			bookmark_inst.bookmark_dialog_msg[0] := links_inst.dummyarray + 263
			bookmark_inst.bm_add_msg[0] := links_inst.dummyarray + 273
			bookmark_inst.bm_add_msg[1] := links_inst.dummyarray + 241
			cache_inst.cache[0].next := create {CE_POINTER [ANY]}.make_cast (cache_inst.cache)
			cache_inst.cache[0].prev := create {CE_POINTER [ANY]}.make_cast (cache_inst.cache)
			cache_inst.cache_count := 0
			cache_inst.page_size := 4_096
			codepage_inst.table_7bit[0].c := (0).to_natural_8
			codepage_inst.table_7bit[0].u := 0
			codepage_inst.aliases_7bit[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("us-ascii"))
			codepage_inst.aliases_7bit[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ascii"))
			codepage_inst.aliases_7bit[2] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("7bit"))
			codepage_inst.aliases_7bit[3] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("7-bit"))
			codepage_inst.aliases_7bit[4] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iso-ir-6"))
			codepage_inst.aliases_7bit[5] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ANSI_X3.4"))
			codepage_inst.aliases_7bit[6] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("646"))
			codepage_inst.aliases_7bit[7] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			codepage_inst.table_8859_1[0].c := (160).to_natural_8
			codepage_inst.table_8859_1[0].u := 160
			codepage_inst.table_8859_1[1].c := (161).to_natural_8
			codepage_inst.table_8859_1[1].u := 161
			codepage_inst.table_8859_1[2].c := (162).to_natural_8
			codepage_inst.table_8859_1[2].u := 162
			codepage_inst.table_8859_1[3].c := (163).to_natural_8
			codepage_inst.table_8859_1[3].u := 163
			codepage_inst.table_8859_1[4].c := (164).to_natural_8
			codepage_inst.table_8859_1[4].u := 164
			codepage_inst.table_8859_1[5].c := (165).to_natural_8
			codepage_inst.table_8859_1[5].u := 165
			codepage_inst.table_8859_1[6].c := (166).to_natural_8
			codepage_inst.table_8859_1[6].u := 166
			codepage_inst.table_8859_1[7].c := (167).to_natural_8
			codepage_inst.table_8859_1[7].u := 167
			codepage_inst.table_8859_1[8].c := (168).to_natural_8
			codepage_inst.table_8859_1[8].u := 168
			codepage_inst.table_8859_1[9].c := (169).to_natural_8
			codepage_inst.table_8859_1[9].u := 169
			codepage_inst.table_8859_1[10].c := (170).to_natural_8
			codepage_inst.table_8859_1[10].u := 170
			codepage_inst.table_8859_1[11].c := (171).to_natural_8
			codepage_inst.table_8859_1[11].u := 171
			codepage_inst.table_8859_1[12].c := (172).to_natural_8
			codepage_inst.table_8859_1[12].u := 172
			codepage_inst.table_8859_1[13].c := (173).to_natural_8
			codepage_inst.table_8859_1[13].u := 173
			codepage_inst.table_8859_1[14].c := (174).to_natural_8
			codepage_inst.table_8859_1[14].u := 174
			codepage_inst.table_8859_1[15].c := (175).to_natural_8
			codepage_inst.table_8859_1[15].u := 175
			codepage_inst.table_8859_1[16].c := (176).to_natural_8
			codepage_inst.table_8859_1[16].u := 176
			codepage_inst.table_8859_1[17].c := (177).to_natural_8
			codepage_inst.table_8859_1[17].u := 177
			codepage_inst.table_8859_1[18].c := (178).to_natural_8
			codepage_inst.table_8859_1[18].u := 178
			codepage_inst.table_8859_1[19].c := (179).to_natural_8
			codepage_inst.table_8859_1[19].u := 179
			codepage_inst.table_8859_1[20].c := (180).to_natural_8
			codepage_inst.table_8859_1[20].u := 180
			codepage_inst.table_8859_1[21].c := (181).to_natural_8
			codepage_inst.table_8859_1[21].u := 181
			codepage_inst.table_8859_1[22].c := (182).to_natural_8
			codepage_inst.table_8859_1[22].u := 182
			codepage_inst.table_8859_1[23].c := (183).to_natural_8
			codepage_inst.table_8859_1[23].u := 183
			codepage_inst.table_8859_1[24].c := (184).to_natural_8
			codepage_inst.table_8859_1[24].u := 184
			codepage_inst.table_8859_1[25].c := (185).to_natural_8
			codepage_inst.table_8859_1[25].u := 185
			codepage_inst.table_8859_1[26].c := (186).to_natural_8
			codepage_inst.table_8859_1[26].u := 186
			codepage_inst.table_8859_1[27].c := (187).to_natural_8
			codepage_inst.table_8859_1[27].u := 187
			codepage_inst.table_8859_1[28].c := (188).to_natural_8
			codepage_inst.table_8859_1[28].u := 188
			codepage_inst.table_8859_1[29].c := (189).to_natural_8
			codepage_inst.table_8859_1[29].u := 189
			codepage_inst.table_8859_1[30].c := (190).to_natural_8
			codepage_inst.table_8859_1[30].u := 190
			codepage_inst.table_8859_1[31].c := (191).to_natural_8
			codepage_inst.table_8859_1[31].u := 191
			codepage_inst.table_8859_1[32].c := (192).to_natural_8
			codepage_inst.table_8859_1[32].u := 192
			codepage_inst.table_8859_1[33].c := (193).to_natural_8
			codepage_inst.table_8859_1[33].u := 193
			codepage_inst.table_8859_1[34].c := (194).to_natural_8
			codepage_inst.table_8859_1[34].u := 194
			codepage_inst.table_8859_1[35].c := (195).to_natural_8
			codepage_inst.table_8859_1[35].u := 195
			codepage_inst.table_8859_1[36].c := (196).to_natural_8
			codepage_inst.table_8859_1[36].u := 196
			codepage_inst.table_8859_1[37].c := (197).to_natural_8
			codepage_inst.table_8859_1[37].u := 197
			codepage_inst.table_8859_1[38].c := (198).to_natural_8
			codepage_inst.table_8859_1[38].u := 198
			codepage_inst.table_8859_1[39].c := (199).to_natural_8
			codepage_inst.table_8859_1[39].u := 199
			codepage_inst.table_8859_1[40].c := (200).to_natural_8
			codepage_inst.table_8859_1[40].u := 200
			codepage_inst.table_8859_1[41].c := (201).to_natural_8
			codepage_inst.table_8859_1[41].u := 201
			codepage_inst.table_8859_1[42].c := (202).to_natural_8
			codepage_inst.table_8859_1[42].u := 202
			codepage_inst.table_8859_1[43].c := (203).to_natural_8
			codepage_inst.table_8859_1[43].u := 203
			codepage_inst.table_8859_1[44].c := (204).to_natural_8
			codepage_inst.table_8859_1[44].u := 204
			codepage_inst.table_8859_1[45].c := (205).to_natural_8
			codepage_inst.table_8859_1[45].u := 205
			codepage_inst.table_8859_1[46].c := (206).to_natural_8
			codepage_inst.table_8859_1[46].u := 206
			codepage_inst.table_8859_1[47].c := (207).to_natural_8
			codepage_inst.table_8859_1[47].u := 207
			codepage_inst.table_8859_1[48].c := (208).to_natural_8
			codepage_inst.table_8859_1[48].u := 208
			codepage_inst.table_8859_1[49].c := (209).to_natural_8
			codepage_inst.table_8859_1[49].u := 209
			codepage_inst.table_8859_1[50].c := (210).to_natural_8
			codepage_inst.table_8859_1[50].u := 210
			codepage_inst.table_8859_1[51].c := (211).to_natural_8
			codepage_inst.table_8859_1[51].u := 211
			codepage_inst.table_8859_1[52].c := (212).to_natural_8
			codepage_inst.table_8859_1[52].u := 212
			codepage_inst.table_8859_1[53].c := (213).to_natural_8
			codepage_inst.table_8859_1[53].u := 213
			codepage_inst.table_8859_1[54].c := (214).to_natural_8
			codepage_inst.table_8859_1[54].u := 214
			codepage_inst.table_8859_1[55].c := (215).to_natural_8
			codepage_inst.table_8859_1[55].u := 215
			codepage_inst.table_8859_1[56].c := (216).to_natural_8
			codepage_inst.table_8859_1[56].u := 216
			codepage_inst.table_8859_1[57].c := (217).to_natural_8
			codepage_inst.table_8859_1[57].u := 217
			codepage_inst.table_8859_1[58].c := (218).to_natural_8
			codepage_inst.table_8859_1[58].u := 218
			codepage_inst.table_8859_1[59].c := (219).to_natural_8
			codepage_inst.table_8859_1[59].u := 219
			codepage_inst.table_8859_1[60].c := (220).to_natural_8
			codepage_inst.table_8859_1[60].u := 220
			codepage_inst.table_8859_1[61].c := (221).to_natural_8
			codepage_inst.table_8859_1[61].u := 221
			codepage_inst.table_8859_1[62].c := (222).to_natural_8
			codepage_inst.table_8859_1[62].u := 222
			codepage_inst.table_8859_1[63].c := (223).to_natural_8
			codepage_inst.table_8859_1[63].u := 223
			codepage_inst.table_8859_1[64].c := (224).to_natural_8
			codepage_inst.table_8859_1[64].u := 224
			codepage_inst.table_8859_1[65].c := (225).to_natural_8
			codepage_inst.table_8859_1[65].u := 225
			codepage_inst.table_8859_1[66].c := (226).to_natural_8
			codepage_inst.table_8859_1[66].u := 226
			codepage_inst.table_8859_1[67].c := (227).to_natural_8
			codepage_inst.table_8859_1[67].u := 227
			codepage_inst.table_8859_1[68].c := (228).to_natural_8
			codepage_inst.table_8859_1[68].u := 228
			codepage_inst.table_8859_1[69].c := (229).to_natural_8
			codepage_inst.table_8859_1[69].u := 229
			codepage_inst.table_8859_1[70].c := (230).to_natural_8
			codepage_inst.table_8859_1[70].u := 230
			codepage_inst.table_8859_1[71].c := (231).to_natural_8
			codepage_inst.table_8859_1[71].u := 231
			codepage_inst.table_8859_1[72].c := (232).to_natural_8
			codepage_inst.table_8859_1[72].u := 232
			codepage_inst.table_8859_1[73].c := (233).to_natural_8
			codepage_inst.table_8859_1[73].u := 233
			codepage_inst.table_8859_1[74].c := (234).to_natural_8
			codepage_inst.table_8859_1[74].u := 234
			codepage_inst.table_8859_1[75].c := (235).to_natural_8
			codepage_inst.table_8859_1[75].u := 235
			codepage_inst.table_8859_1[76].c := (236).to_natural_8
			codepage_inst.table_8859_1[76].u := 236
			codepage_inst.table_8859_1[77].c := (237).to_natural_8
			codepage_inst.table_8859_1[77].u := 237
			codepage_inst.table_8859_1[78].c := (238).to_natural_8
			codepage_inst.table_8859_1[78].u := 238
			codepage_inst.table_8859_1[79].c := (239).to_natural_8
			codepage_inst.table_8859_1[79].u := 239
			codepage_inst.table_8859_1[80].c := (240).to_natural_8
			codepage_inst.table_8859_1[80].u := 240
			codepage_inst.table_8859_1[81].c := (241).to_natural_8
			codepage_inst.table_8859_1[81].u := 241
			codepage_inst.table_8859_1[82].c := (242).to_natural_8
			codepage_inst.table_8859_1[82].u := 242
			codepage_inst.table_8859_1[83].c := (243).to_natural_8
			codepage_inst.table_8859_1[83].u := 243
			codepage_inst.table_8859_1[84].c := (244).to_natural_8
			codepage_inst.table_8859_1[84].u := 244
			codepage_inst.table_8859_1[85].c := (245).to_natural_8
			codepage_inst.table_8859_1[85].u := 245
			codepage_inst.table_8859_1[86].c := (246).to_natural_8
			codepage_inst.table_8859_1[86].u := 246
			codepage_inst.table_8859_1[87].c := (247).to_natural_8
			codepage_inst.table_8859_1[87].u := 247
			codepage_inst.table_8859_1[88].c := (248).to_natural_8
			codepage_inst.table_8859_1[88].u := 248
			codepage_inst.table_8859_1[89].c := (249).to_natural_8
			codepage_inst.table_8859_1[89].u := 249
			codepage_inst.table_8859_1[90].c := (250).to_natural_8
			codepage_inst.table_8859_1[90].u := 250
			codepage_inst.table_8859_1[91].c := (251).to_natural_8
			codepage_inst.table_8859_1[91].u := 251
			codepage_inst.table_8859_1[92].c := (252).to_natural_8
			codepage_inst.table_8859_1[92].u := 252
			codepage_inst.table_8859_1[93].c := (253).to_natural_8
			codepage_inst.table_8859_1[93].u := 253
			codepage_inst.table_8859_1[94].c := (254).to_natural_8
			codepage_inst.table_8859_1[94].u := 254
			codepage_inst.table_8859_1[95].c := (255).to_natural_8
			codepage_inst.table_8859_1[95].u := 255
			codepage_inst.table_8859_1[96].c := (0).to_natural_8
			codepage_inst.table_8859_1[96].u := 0
			codepage_inst.aliases_8859_1[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ISO-8859-1"))
			codepage_inst.aliases_8859_1[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("8859-1"))
			codepage_inst.aliases_8859_1[2] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iso-ir-100"))
			codepage_inst.aliases_8859_1[3] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin1"))
			codepage_inst.aliases_8859_1[4] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("l1"))
			codepage_inst.aliases_8859_1[5] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("819"))
			codepage_inst.aliases_8859_1[6] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			codepage_inst.table_8859_2[0].c := (160).to_natural_8
			codepage_inst.table_8859_2[0].u := 160
			codepage_inst.table_8859_2[1].c := (161).to_natural_8
			codepage_inst.table_8859_2[1].u := 260
			codepage_inst.table_8859_2[2].c := (162).to_natural_8
			codepage_inst.table_8859_2[2].u := 728
			codepage_inst.table_8859_2[3].c := (163).to_natural_8
			codepage_inst.table_8859_2[3].u := 321
			codepage_inst.table_8859_2[4].c := (164).to_natural_8
			codepage_inst.table_8859_2[4].u := 164
			codepage_inst.table_8859_2[5].c := (165).to_natural_8
			codepage_inst.table_8859_2[5].u := 317
			codepage_inst.table_8859_2[6].c := (166).to_natural_8
			codepage_inst.table_8859_2[6].u := 346
			codepage_inst.table_8859_2[7].c := (167).to_natural_8
			codepage_inst.table_8859_2[7].u := 167
			codepage_inst.table_8859_2[8].c := (168).to_natural_8
			codepage_inst.table_8859_2[8].u := 168
			codepage_inst.table_8859_2[9].c := (169).to_natural_8
			codepage_inst.table_8859_2[9].u := 352
			codepage_inst.table_8859_2[10].c := (170).to_natural_8
			codepage_inst.table_8859_2[10].u := 350
			codepage_inst.table_8859_2[11].c := (171).to_natural_8
			codepage_inst.table_8859_2[11].u := 356
			codepage_inst.table_8859_2[12].c := (172).to_natural_8
			codepage_inst.table_8859_2[12].u := 377
			codepage_inst.table_8859_2[13].c := (173).to_natural_8
			codepage_inst.table_8859_2[13].u := 173
			codepage_inst.table_8859_2[14].c := (174).to_natural_8
			codepage_inst.table_8859_2[14].u := 381
			codepage_inst.table_8859_2[15].c := (175).to_natural_8
			codepage_inst.table_8859_2[15].u := 379
			codepage_inst.table_8859_2[16].c := (176).to_natural_8
			codepage_inst.table_8859_2[16].u := 176
			codepage_inst.table_8859_2[17].c := (177).to_natural_8
			codepage_inst.table_8859_2[17].u := 261
			codepage_inst.table_8859_2[18].c := (178).to_natural_8
			codepage_inst.table_8859_2[18].u := 731
			codepage_inst.table_8859_2[19].c := (179).to_natural_8
			codepage_inst.table_8859_2[19].u := 322
			codepage_inst.table_8859_2[20].c := (180).to_natural_8
			codepage_inst.table_8859_2[20].u := 180
			codepage_inst.table_8859_2[21].c := (181).to_natural_8
			codepage_inst.table_8859_2[21].u := 318
			codepage_inst.table_8859_2[22].c := (182).to_natural_8
			codepage_inst.table_8859_2[22].u := 347
			codepage_inst.table_8859_2[23].c := (183).to_natural_8
			codepage_inst.table_8859_2[23].u := 711
			codepage_inst.table_8859_2[24].c := (184).to_natural_8
			codepage_inst.table_8859_2[24].u := 184
			codepage_inst.table_8859_2[25].c := (185).to_natural_8
			codepage_inst.table_8859_2[25].u := 353
			codepage_inst.table_8859_2[26].c := (186).to_natural_8
			codepage_inst.table_8859_2[26].u := 351
			codepage_inst.table_8859_2[27].c := (187).to_natural_8
			codepage_inst.table_8859_2[27].u := 357
			codepage_inst.table_8859_2[28].c := (188).to_natural_8
			codepage_inst.table_8859_2[28].u := 378
			codepage_inst.table_8859_2[29].c := (189).to_natural_8
			codepage_inst.table_8859_2[29].u := 733
			codepage_inst.table_8859_2[30].c := (190).to_natural_8
			codepage_inst.table_8859_2[30].u := 382
			codepage_inst.table_8859_2[31].c := (191).to_natural_8
			codepage_inst.table_8859_2[31].u := 380
			codepage_inst.table_8859_2[32].c := (192).to_natural_8
			codepage_inst.table_8859_2[32].u := 340
			codepage_inst.table_8859_2[33].c := (193).to_natural_8
			codepage_inst.table_8859_2[33].u := 193
			codepage_inst.table_8859_2[34].c := (194).to_natural_8
			codepage_inst.table_8859_2[34].u := 194
			codepage_inst.table_8859_2[35].c := (195).to_natural_8
			codepage_inst.table_8859_2[35].u := 258
			codepage_inst.table_8859_2[36].c := (196).to_natural_8
			codepage_inst.table_8859_2[36].u := 196
			codepage_inst.table_8859_2[37].c := (197).to_natural_8
			codepage_inst.table_8859_2[37].u := 313
			codepage_inst.table_8859_2[38].c := (198).to_natural_8
			codepage_inst.table_8859_2[38].u := 262
			codepage_inst.table_8859_2[39].c := (199).to_natural_8
			codepage_inst.table_8859_2[39].u := 199
			codepage_inst.table_8859_2[40].c := (200).to_natural_8
			codepage_inst.table_8859_2[40].u := 268
			codepage_inst.table_8859_2[41].c := (201).to_natural_8
			codepage_inst.table_8859_2[41].u := 201
			codepage_inst.table_8859_2[42].c := (202).to_natural_8
			codepage_inst.table_8859_2[42].u := 280
			codepage_inst.table_8859_2[43].c := (203).to_natural_8
			codepage_inst.table_8859_2[43].u := 203
			codepage_inst.table_8859_2[44].c := (204).to_natural_8
			codepage_inst.table_8859_2[44].u := 282
			codepage_inst.table_8859_2[45].c := (205).to_natural_8
			codepage_inst.table_8859_2[45].u := 205
			codepage_inst.table_8859_2[46].c := (206).to_natural_8
			codepage_inst.table_8859_2[46].u := 206
			codepage_inst.table_8859_2[47].c := (207).to_natural_8
			codepage_inst.table_8859_2[47].u := 270
			codepage_inst.table_8859_2[48].c := (208).to_natural_8
			codepage_inst.table_8859_2[48].u := 272
			codepage_inst.table_8859_2[49].c := (209).to_natural_8
			codepage_inst.table_8859_2[49].u := 323
			codepage_inst.table_8859_2[50].c := (210).to_natural_8
			codepage_inst.table_8859_2[50].u := 327
			codepage_inst.table_8859_2[51].c := (211).to_natural_8
			codepage_inst.table_8859_2[51].u := 211
			codepage_inst.table_8859_2[52].c := (212).to_natural_8
			codepage_inst.table_8859_2[52].u := 212
			codepage_inst.table_8859_2[53].c := (213).to_natural_8
			codepage_inst.table_8859_2[53].u := 336
			codepage_inst.table_8859_2[54].c := (214).to_natural_8
			codepage_inst.table_8859_2[54].u := 214
			codepage_inst.table_8859_2[55].c := (215).to_natural_8
			codepage_inst.table_8859_2[55].u := 215
			codepage_inst.table_8859_2[56].c := (216).to_natural_8
			codepage_inst.table_8859_2[56].u := 344
			codepage_inst.table_8859_2[57].c := (217).to_natural_8
			codepage_inst.table_8859_2[57].u := 366
			codepage_inst.table_8859_2[58].c := (218).to_natural_8
			codepage_inst.table_8859_2[58].u := 218
			codepage_inst.table_8859_2[59].c := (219).to_natural_8
			codepage_inst.table_8859_2[59].u := 368
			codepage_inst.table_8859_2[60].c := (220).to_natural_8
			codepage_inst.table_8859_2[60].u := 220
			codepage_inst.table_8859_2[61].c := (221).to_natural_8
			codepage_inst.table_8859_2[61].u := 221
			codepage_inst.table_8859_2[62].c := (222).to_natural_8
			codepage_inst.table_8859_2[62].u := 354
			codepage_inst.table_8859_2[63].c := (223).to_natural_8
			codepage_inst.table_8859_2[63].u := 223
			codepage_inst.table_8859_2[64].c := (224).to_natural_8
			codepage_inst.table_8859_2[64].u := 341
			codepage_inst.table_8859_2[65].c := (225).to_natural_8
			codepage_inst.table_8859_2[65].u := 225
			codepage_inst.table_8859_2[66].c := (226).to_natural_8
			codepage_inst.table_8859_2[66].u := 226
			codepage_inst.table_8859_2[67].c := (227).to_natural_8
			codepage_inst.table_8859_2[67].u := 259
			codepage_inst.table_8859_2[68].c := (228).to_natural_8
			codepage_inst.table_8859_2[68].u := 228
			codepage_inst.table_8859_2[69].c := (229).to_natural_8
			codepage_inst.table_8859_2[69].u := 314
			codepage_inst.table_8859_2[70].c := (230).to_natural_8
			codepage_inst.table_8859_2[70].u := 263
			codepage_inst.table_8859_2[71].c := (231).to_natural_8
			codepage_inst.table_8859_2[71].u := 231
			codepage_inst.table_8859_2[72].c := (232).to_natural_8
			codepage_inst.table_8859_2[72].u := 269
			codepage_inst.table_8859_2[73].c := (233).to_natural_8
			codepage_inst.table_8859_2[73].u := 233
			codepage_inst.table_8859_2[74].c := (234).to_natural_8
			codepage_inst.table_8859_2[74].u := 281
			codepage_inst.table_8859_2[75].c := (235).to_natural_8
			codepage_inst.table_8859_2[75].u := 235
			codepage_inst.table_8859_2[76].c := (236).to_natural_8
			codepage_inst.table_8859_2[76].u := 283
			codepage_inst.table_8859_2[77].c := (237).to_natural_8
			codepage_inst.table_8859_2[77].u := 237
			codepage_inst.table_8859_2[78].c := (238).to_natural_8
			codepage_inst.table_8859_2[78].u := 238
			codepage_inst.table_8859_2[79].c := (239).to_natural_8
			codepage_inst.table_8859_2[79].u := 271
			codepage_inst.table_8859_2[80].c := (240).to_natural_8
			codepage_inst.table_8859_2[80].u := 273
			codepage_inst.table_8859_2[81].c := (241).to_natural_8
			codepage_inst.table_8859_2[81].u := 324
			codepage_inst.table_8859_2[82].c := (242).to_natural_8
			codepage_inst.table_8859_2[82].u := 328
			codepage_inst.table_8859_2[83].c := (243).to_natural_8
			codepage_inst.table_8859_2[83].u := 243
			codepage_inst.table_8859_2[84].c := (244).to_natural_8
			codepage_inst.table_8859_2[84].u := 244
			codepage_inst.table_8859_2[85].c := (245).to_natural_8
			codepage_inst.table_8859_2[85].u := 337
			codepage_inst.table_8859_2[86].c := (246).to_natural_8
			codepage_inst.table_8859_2[86].u := 246
			codepage_inst.table_8859_2[87].c := (247).to_natural_8
			codepage_inst.table_8859_2[87].u := 247
			codepage_inst.table_8859_2[88].c := (248).to_natural_8
			codepage_inst.table_8859_2[88].u := 345
			codepage_inst.table_8859_2[89].c := (249).to_natural_8
			codepage_inst.table_8859_2[89].u := 367
			codepage_inst.table_8859_2[90].c := (250).to_natural_8
			codepage_inst.table_8859_2[90].u := 250
			codepage_inst.table_8859_2[91].c := (251).to_natural_8
			codepage_inst.table_8859_2[91].u := 369
			codepage_inst.table_8859_2[92].c := (252).to_natural_8
			codepage_inst.table_8859_2[92].u := 252
			codepage_inst.table_8859_2[93].c := (253).to_natural_8
			codepage_inst.table_8859_2[93].u := 253
			codepage_inst.table_8859_2[94].c := (254).to_natural_8
			codepage_inst.table_8859_2[94].u := 355
			codepage_inst.table_8859_2[95].c := (255).to_natural_8
			codepage_inst.table_8859_2[95].u := 729
			codepage_inst.table_8859_2[96].c := (0).to_natural_8
			codepage_inst.table_8859_2[96].u := 0
			codepage_inst.aliases_8859_2[0] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ISO-8859-2"))
			codepage_inst.aliases_8859_2[1] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("8859-2"))
			codepage_inst.aliases_8859_2[2] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iso-ir-101"))
			codepage_inst.aliases_8859_2[3] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("latin2"))
			codepage_inst.aliases_8859_2[4] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("l2"))
			codepage_inst.aliases_8859_2[5] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			codepage_inst.table_8859_4[0].c := (128).to_natural_8
			codepage_inst.table_8859_4[0].u := 128
			codepage_inst.table_8859_4[1].c := (129).to_natural_8
			codepage_inst.table_8859_4[1].u := 129
			codepage_inst.table_8859_4[2].c := (130).to_natural_8
			codepage_inst.table_8859_4[2].u := 130
			codepage_inst.table_8859_4[3].c := (131).to_natural_8
			codepage_inst.table_8859_4[3].u := 131
			codepage_inst.table_8859_4[4].c := (132).to_natural_8
			codepage_inst.table_8859_4[4].u := 132
			codepage_inst.table_8859_4[5].c := (133).to_natural_8
			codepage_inst.table_8859_4[5].u := 133
			codepage_inst.table_8859_4[6].c := (134).to_natural_8
			codepage_inst.table_8859_4[6].u := 134
			codepage_inst.table_8859_4[7].c := (135).to_natural_8
			codepage_inst.table_8859_4[7].u := 135
			codepage_inst.table_8859_4[8].c := (136).to_natural_8
			codepage_inst.table_8859_4[8].u := 136
			codepage_inst.table_8859_4[9].c := (137).to_natural_8
			codepage_inst.table_8859_4[9].u := 137
			codepage_inst.table_8859_4[10].c := (138).to_natural_8
			codepage_inst.table_8859_4[10].u := 138
			codepage_inst.table_8859_4[11].c := (139).to_natural_8
			codepage_inst.table_8859_4[11].u := 139
			codepage_inst.table_8859_4[12].c := (140).to_natural_8
			codepage_inst.table_8859_4[12].u := 140
			codepage_inst.table_8859_4[13].c := (141).to_natural_8
			codepage_inst.table_8859_4[13].u := 141
			codepage_inst.table_8859_4[14].c := (142).to_natural_8
			codepage_inst.table_8859_4[14].u := 142
			codepage_inst.table_8859_4[15].c := (143).to_natural_8
			codepage_inst.table_8859_4[15].u := 143
			codepage_inst.table_8859_4[16].c := (144).to_natural_8
			codepage_inst.table_8859_4[16].u := 144
			codepage_inst.table_8859_4[17].c := (145).to_natural_8
			codepage_inst.table_8859_4[17].u := 145
			codepage_inst.table_8859_4[18].c := (146).to_natural_8
			codepage_inst.table_8859_4[18].u := 146
			codepage_inst.table_8859_4[19].c := (147).to_natural_8
			codepage_inst.table_8859_4[19].u := 147
			codepage_inst.table_8859_4[20].c := (148).to_natural_8
			codepage_inst.table_8859_4[20].u := 148
			codepage_inst.table_8859_4[21].c := (149).to_natural_8
			codepage_inst.table_8859_4[21].u := 149
			codepage_inst.table_8859_4[22].c := (150).to_natural_8
			codepage_inst.table_8859_4[22].u := 150
			codepage_inst.table_8859_4[23].c := (151).to_natural_8
			codepage_inst.table_8859_4[23].u := 151
			codepage_inst.table_8859_4[24].c := (152).to_natural_8
			codepage_inst.table_8859_4[24].u := 152
			codepage_inst.table_8859_4[25].c := (153).to_natural_8
			codepage_inst.table_8859_4[25].u := 153
			codepage_inst.table_8859_4[26].c := (154).to_natural_8
			codepage_inst.table_8859_4[26].u := 154
			codepage_inst.table_8859_4[27].c := (155).to_natural_8
			codepage_inst.table_8859_4[27].u := 155
			codepage_inst.table_8859_4[28].c := (156).to_natural_8
			codepage_inst.table_8859_4[28].u := 156
			codepage_inst.table_8859_4[29].c := (157).to_natural_8
			codepage_inst.table_8859_4[29].u := 157
			codepage_inst.table_8859_4[30].c := (158).to_natural_8
			codepage_inst.table_8859_4[30].u := 158
			codepage_inst.table_8859_4[31].c := (159).to_natural_8
			codepage_inst.table_8859_4[31].u := 159
			codepage_inst.table_8859_4[32].c := (160).to_natural_8
			codepage_inst.table_8859_4[32].u := 160
			codepage_inst.table_8859_4[33].c := (161).to_natural_8
			codepage_inst.table_8859_4[33].u := 260
			codepage_inst.table_8859_4[34].c := (162).to_natural_8
			codepage_inst.table_8859_4[34].u := 312
			codepage_inst.table_8859_4[35].c := (163).to_natural_8
			codepage_inst.table_8859_4[35].u := 342
			codepage_inst.table_8859_4[36].c := (164).to_natural_8
		end

end
