class
	P_CODEPAGE

inherit
	LINKS_DATA
		redefine
			default_create
		end
	S_SYS_SELECT
	S_STDLIB
	S_UNISTD
	S_STRING
	S_BITS_ERRNO
	S_SYS_SOCKET
	S_STDIO
	S_FCNTL
	S_NETINET_IN
	S_SYS_STAT
	S_SYS_UTSNAME
	S_NETDB
	S_SIGNAL
	S_PWD
	S_GRP
	S_TIME
	S_DIRENT
	S_TERMIOS
	S_SYS_IOCTL
	S_SYS_TIME
	S_SYS_WAIT
	S_UTIME

feature {NONE} -- Initialization

	default_create
		do
			create aliases_7bit.make (<<8>>)
			create aliases_8859_1.make (<<7>>)
			create aliases_8859_13.make (<<6>>)
			create aliases_8859_15.make (<<7>>)
			create aliases_8859_16.make (<<5>>)
			create aliases_8859_2.make (<<6>>)
			create aliases_8859_4.make (<<6>>)
			create aliases_8859_5.make (<<3>>)
			create aliases_8859_7.make (<<5>>)
			create aliases_8859_9.make (<<3>>)
			create aliases_cp1125.make (<<4>>)
			create aliases_cp1250.make (<<3>>)
			create aliases_cp1251.make (<<3>>)
			create aliases_cp1257.make (<<3>>)
			create aliases_cp437.make (<<3>>)
			create aliases_cp737.make (<<3>>)
			create aliases_cp850.make (<<3>>)
			create aliases_cp852.make (<<3>>)
			create aliases_cp866.make (<<3>>)
			create aliases_kamen.make (<<5>>)
			create aliases_koi8_r.make (<<2>>)
			create aliases_koi8_u.make (<<2>>)
			create aliases_mac_lat2.make (<<5>>)
			create aliases_macroman.make (<<4>>)
			create aliases_tcvn5712.make (<<5>>)
			create aliases_utf_8.make (<<3>>)
			create aliases_viscii.make (<<6>>)
			create codepages.make (<<28>>)
			create table_7bit.make (<<1>>)
			create table_8859_1.make (<<97>>)
			create table_8859_13.make (<<129>>)
			create table_8859_15.make (<<97>>)
			create table_8859_16.make (<<97>>)
			create table_8859_2.make (<<97>>)
			create table_8859_4.make (<<129>>)
			create table_8859_5.make (<<129>>)
			create table_8859_7.make (<<123>>)
			create table_8859_9.make (<<129>>)
			create table_cp1125.make (<<129>>)
			create table_cp1250.make (<<126>>)
			create table_cp1251.make (<<128>>)
			create table_cp1257.make (<<129>>)
			create table_cp437.make (<<129>>)
			create table_cp737.make (<<129>>)
			create table_cp850.make (<<129>>)
			create table_cp852.make (<<129>>)
			create table_cp866.make (<<129>>)
			create table_kamen.make (<<129>>)
			create table_koi8_r.make (<<129>>)
			create table_koi8_u.make (<<129>>)
			create table_mac_lat2.make (<<129>>)
			create table_macroman.make (<<129>>)
			create table_tcvn5712.make (<<131>>)
			create table_utf_8.make (<<1>>)
			create table_viscii.make (<<131>>)
		end

feature {ANY} -- attributes

	aliases_7bit: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_1: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_13: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_15: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_16: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_2: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_4: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_5: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_7: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_8859_9: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp1125: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp1250: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp1251: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp1257: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp437: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp737: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp850: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp852: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_cp866: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_kamen: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_koi8_r: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_koi8_u: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_mac_lat2: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_macroman: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_tcvn5712: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_utf_8: CE_ARRAY [CE_POINTER [NATURAL_8]]

	aliases_viscii: CE_ARRAY [CE_POINTER [NATURAL_8]]

	codepages: CE_ARRAY [PD_CODEPAGE_DESC]

	table_7bit: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_1: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_13: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_15: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_16: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_2: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_4: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_5: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_7: CE_ARRAY [PD_TABLE_ENTRY]

	table_8859_9: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp1125: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp1250: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp1251: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp1257: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp437: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp737: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp850: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp852: CE_ARRAY [PD_TABLE_ENTRY]

	table_cp866: CE_ARRAY [PD_TABLE_ENTRY]

	table_kamen: CE_ARRAY [PD_TABLE_ENTRY]

	table_koi8_r: CE_ARRAY [PD_TABLE_ENTRY]

	table_koi8_u: CE_ARRAY [PD_TABLE_ENTRY]

	table_mac_lat2: CE_ARRAY [PD_TABLE_ENTRY]

	table_macroman: CE_ARRAY [PD_TABLE_ENTRY]

	table_tcvn5712: CE_ARRAY [PD_TABLE_ENTRY]

	table_utf_8: CE_ARRAY [PD_TABLE_ENTRY]

	table_viscii: CE_ARRAY [PD_TABLE_ENTRY]

end
