class
	SD_TIMEZONE

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	tz_minuteswest: INTEGER_32 assign set_tz_minuteswest

	tz_dsttime: INTEGER_32 assign set_tz_dsttime

feature {ANY} -- setters

	set_tz_minuteswest (a_tz_minuteswest: INTEGER_32)
		do
			tz_minuteswest := a_tz_minuteswest
			update_memory_field ("tz_minuteswest")
		end

	set_tz_dsttime (a_tz_dsttime: INTEGER_32)
		do
			tz_dsttime := a_tz_dsttime
			update_memory_field ("tz_dsttime")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			tz_minuteswest := a_other.tz_minuteswest
			tz_dsttime := a_other.tz_dsttime
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				tz_minuteswest = a_other.tz_minuteswest and
				tz_dsttime = a_other.tz_dsttime
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("tz_minuteswest"),
					create {CE_STRUCTURE_FIELD}.make ("tz_dsttime")
				>>)
			init_structure_info
		end

end
