deferred class
	S_DIRENT

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	closedir (a___dirp: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_closedir (a___dirp.c_pointer)
		end

	c_closedir (a___dirp: POINTER): INTEGER_32
		external
			"C inline use <links.h>"
		alias
			"return closedir($a___dirp);"
		end

	opendir (a___name: CE_POINTER [INTEGER_8]): CE_POINTER [ANY]
		do
			create Result.make_shared (c_opendir (a___name.c_pointer))
		end

	c_opendir (a___name: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return opendir($a___name);"
		end

	readdir (a___dirp: CE_POINTER [ANY]): CE_POINTER [SD_DIRENT]
		do
			create Result.make_shared (c_readdir (a___dirp.c_pointer))
		end

	c_readdir (a___dirp: POINTER): POINTER
		external
			"C inline use <links.h>"
		alias
			"return readdir($a___dirp);"
		end

end
