class
	PD_ARGENTRY

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create ae_fname.make
		end

feature {ANY} -- fields

	ae_fname: CE_POINTER [NATURAL_8] assign set_ae_fname

	ae_fnum: INTEGER_32 assign set_ae_fnum

feature {ANY} -- setters

	set_ae_fname (a_ae_fname: CE_POINTER [NATURAL_8])
		do
			ae_fname := a_ae_fname
			update_memory_field ("ae_fname")
		end

	set_ae_fnum (a_ae_fnum: INTEGER_32)
		do
			ae_fnum := a_ae_fnum
			update_memory_field ("ae_fnum")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			ae_fname := a_other.ae_fname
			ae_fnum := a_other.ae_fnum
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ae_fname.is_equal (a_other.ae_fname) and
				ae_fnum = a_other.ae_fnum
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("ae_fname"),
					create {CE_STRUCTURE_FIELD}.make ("ae_fnum")
				>>)
			init_structure_info
		end

end
