class
	PD_BLOCK8

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			make_memory -- union; back with memory for correct semantics
		end

feature {ANY} -- fields

	ul: CE_ARRAY [NATURAL_32]

	uc: CE_ARRAY [NATURAL_8]

feature {ANY}

	copy (a_other: like Current)
		do
			ul := a_other.ul.twin
			uc := a_other.uc.twin
			create_memory_copy -- union; back with memory for correct semantics
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				ul.is_equal (a_other.ul) and
				uc.is_equal (a_other.uc)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_union (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("ul", <<2>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("uc", <<8>>)
				>>)
			init_structure_info
		end

end
