class
	PD_FIXVAR

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create var.make
			create room.make (<<20>>)
		end

feature {ANY} -- fields

	var: PD_DICTITEM_S assign set_var

	room: CE_ARRAY [NATURAL_8]

feature {ANY} -- setters

	set_var (a_var: PD_DICTITEM_S)
		do
			var := a_var
			update_memory_field ("var")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			var := a_other.var.twin
			room := a_other.room.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				var.is_equal (a_other.var) and
				room.is_equal (a_other.room)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("var"),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("room", <<20>>)
				>>)
			init_structure_info
		end

end
