class
	PD_MODMASKTABLE

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	mod_mask: INTEGER_16 assign set_mod_mask

	mod_flag: INTEGER_16 assign set_mod_flag

	name: NATURAL_8 assign set_name

feature {ANY} -- setters

	set_mod_mask (a_mod_mask: INTEGER_16)
		do
			mod_mask := a_mod_mask
			update_memory_field ("mod_mask")
		end

	set_mod_flag (a_mod_flag: INTEGER_16)
		do
			mod_flag := a_mod_flag
			update_memory_field ("mod_flag")
		end

	set_name (a_name: NATURAL_8)
		do
			name := a_name
			update_memory_field ("name")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			mod_mask := a_other.mod_mask
			mod_flag := a_other.mod_flag
			name := a_other.name
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				mod_mask = a_other.mod_mask and
				mod_flag = a_other.mod_flag and
				name = a_other.name
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("mod_mask"),
					create {CE_STRUCTURE_FIELD}.make ("mod_flag"),
					create {CE_STRUCTURE_FIELD}.make ("name")
				>>)
			init_structure_info
		end

end
