class
	PD_SAVE_SE_T

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create se_u.make
		end

feature {ANY} -- fields

	se_u: PD_SE_U assign set_se_u

feature {ANY} -- setters

	set_se_u (a_se_u: PD_SE_U)
		do
			se_u := a_se_u
			update_memory_field ("se_u")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			se_u := a_other.se_u.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				se_u.is_equal (a_other.se_u)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("se_u")
				>>)
			init_structure_info
		end

end
