class
	PD_SPELLTAB_S

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create st_isw.make (<<256>>)
			create st_isu.make (<<256>>)
			create st_fold.make (<<256>>)
			create st_upper.make (<<256>>)
		end

feature {ANY} -- fields

	st_isw: CE_ARRAY [NATURAL_8]

	st_isu: CE_ARRAY [NATURAL_8]

	st_fold: CE_ARRAY [NATURAL_8]

	st_upper: CE_ARRAY [NATURAL_8]

feature {ANY}

	copy (a_other: like Current)
		do
			st_isw := a_other.st_isw.twin
			st_isu := a_other.st_isu.twin
			st_fold := a_other.st_fold.twin
			st_upper := a_other.st_upper.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				st_isw.is_equal (a_other.st_isw) and
				st_isu.is_equal (a_other.st_isu) and
				st_fold.is_equal (a_other.st_fold) and
				st_upper.is_equal (a_other.st_upper)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_isw", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_isu", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_fold", <<256>>),
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("st_upper", <<256>>)
				>>)
			init_structure_info
		end

end
