frozen class
	VIM_INITIALIZER_SLICE1

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			buffer_inst.msg_loclist := ce_string ("[Location List]")
			buffer_inst.msg_qflist := ce_string ("[Quickfix List]")
			buffer_inst.top_file_num := 1
			buffer_inst.no_position[0].lnum := (1).to_integer_32
			buffer_inst.no_position[0].col := 0
			buffer_inst.no_position[0].coladd := 0
			buffer_inst.lasttitle[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			buffer_inst.lasticon[0] := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			buffer_inst.entered := 0
			blowfish_inst.ipa[0] := {NATURAL_32} 608_135_816
			blowfish_inst.ipa[1] := {NATURAL_32} 2_242_054_355
			blowfish_inst.ipa[2] := {NATURAL_32} 320_440_878
			blowfish_inst.ipa[3] := {NATURAL_32} 57_701_188
			blowfish_inst.ipa[4] := {NATURAL_32} 2_752_067_618
			blowfish_inst.ipa[5] := {NATURAL_32} 698_298_832
			blowfish_inst.ipa[6] := {NATURAL_32} 137_296_536
			blowfish_inst.ipa[7] := {NATURAL_32} 3_964_562_569
			blowfish_inst.ipa[8] := {NATURAL_32} 1_160_258_022
			blowfish_inst.ipa[9] := {NATURAL_32} 953_160_567
			blowfish_inst.ipa[10] := {NATURAL_32} 3_193_202_383
			blowfish_inst.ipa[11] := {NATURAL_32} 887_688_300
			blowfish_inst.ipa[12] := {NATURAL_32} 3_232_508_343
			blowfish_inst.ipa[13] := {NATURAL_32} 3_380_367_581
			blowfish_inst.ipa[14] := {NATURAL_32} 1_065_670_069
			blowfish_inst.ipa[15] := {NATURAL_32} 3_041_331_479
			blowfish_inst.ipa[16] := {NATURAL_32} 2_450_970_073
			blowfish_inst.ipa[17] := {NATURAL_32} 2_306_472_731;
			(blowfish_inst.sbi[0])[0] := {NATURAL_32} 3_509_652_390;
			(blowfish_inst.sbi[0])[1] := {NATURAL_32} 2_564_797_868;
			(blowfish_inst.sbi[0])[2] := {NATURAL_32} 805_139_163;
			(blowfish_inst.sbi[0])[3] := {NATURAL_32} 3_491_422_135;
			(blowfish_inst.sbi[0])[4] := {NATURAL_32} 3_101_798_381;
			(blowfish_inst.sbi[0])[5] := {NATURAL_32} 1_780_907_670;
			(blowfish_inst.sbi[0])[6] := {NATURAL_32} 3_128_725_573;
			(blowfish_inst.sbi[0])[7] := {NATURAL_32} 4_046_225_305;
			(blowfish_inst.sbi[0])[8] := {NATURAL_32} 614_570_311;
			(blowfish_inst.sbi[0])[9] := {NATURAL_32} 3_012_652_279;
			(blowfish_inst.sbi[0])[10] := {NATURAL_32} 134_345_442;
			(blowfish_inst.sbi[0])[11] := {NATURAL_32} 2_240_740_374;
			(blowfish_inst.sbi[0])[12] := {NATURAL_32} 1_667_834_072;
			(blowfish_inst.sbi[0])[13] := {NATURAL_32} 1_901_547_113;
			(blowfish_inst.sbi[0])[14] := {NATURAL_32} 2_757_295_779;
			(blowfish_inst.sbi[0])[15] := {NATURAL_32} 4_103_290_238;
			(blowfish_inst.sbi[0])[16] := {NATURAL_32} 227_898_511;
			(blowfish_inst.sbi[0])[17] := {NATURAL_32} 1_921_955_416;
			(blowfish_inst.sbi[0])[18] := {NATURAL_32} 1_904_987_480;
			(blowfish_inst.sbi[0])[19] := {NATURAL_32} 2_182_433_518;
			(blowfish_inst.sbi[0])[20] := {NATURAL_32} 2_069_144_605;
			(blowfish_inst.sbi[0])[21] := {NATURAL_32} 3_260_701_109;
			(blowfish_inst.sbi[0])[22] := {NATURAL_32} 2_620_446_009;
			(blowfish_inst.sbi[0])[23] := {NATURAL_32} 720_527_379;
			(blowfish_inst.sbi[0])[24] := {NATURAL_32} 3_318_853_667;
			(blowfish_inst.sbi[0])[25] := {NATURAL_32} 677_414_384;
			(blowfish_inst.sbi[0])[26] := {NATURAL_32} 3_393_288_472;
			(blowfish_inst.sbi[0])[27] := {NATURAL_32} 3_101_374_703;
			(blowfish_inst.sbi[0])[28] := {NATURAL_32} 2_390_351_024;
			(blowfish_inst.sbi[0])[29] := {NATURAL_32} 1_614_419_982;
			(blowfish_inst.sbi[0])[30] := {NATURAL_32} 1_822_297_739;
			(blowfish_inst.sbi[0])[31] := {NATURAL_32} 2_954_791_486;
			(blowfish_inst.sbi[0])[32] := {NATURAL_32} 3_608_508_353;
			(blowfish_inst.sbi[0])[33] := {NATURAL_32} 3_174_124_327;
			(blowfish_inst.sbi[0])[34] := {NATURAL_32} 2_024_746_970;
			(blowfish_inst.sbi[0])[35] := {NATURAL_32} 1_432_378_464;
			(blowfish_inst.sbi[0])[36] := {NATURAL_32} 3_864_339_955;
			(blowfish_inst.sbi[0])[37] := {NATURAL_32} 2_857_741_204;
			(blowfish_inst.sbi[0])[38] := {NATURAL_32} 1_464_375_394;
			(blowfish_inst.sbi[0])[39] := {NATURAL_32} 1_676_153_920;
			(blowfish_inst.sbi[0])[40] := {NATURAL_32} 1_439_316_330;
			(blowfish_inst.sbi[0])[41] := {NATURAL_32} 715_854_006;
			(blowfish_inst.sbi[0])[42] := {NATURAL_32} 3_033_291_828;
			(blowfish_inst.sbi[0])[43] := {NATURAL_32} 289_532_110;
			(blowfish_inst.sbi[0])[44] := {NATURAL_32} 2_706_671_279;
			(blowfish_inst.sbi[0])[45] := {NATURAL_32} 2_087_905_683;
			(blowfish_inst.sbi[0])[46] := {NATURAL_32} 3_018_724_369;
			(blowfish_inst.sbi[0])[47] := {NATURAL_32} 1_668_267_050;
			(blowfish_inst.sbi[0])[48] := {NATURAL_32} 732_546_397;
			(blowfish_inst.sbi[0])[49] := {NATURAL_32} 1_947_742_710;
			(blowfish_inst.sbi[0])[50] := {NATURAL_32} 3_462_151_702;
			(blowfish_inst.sbi[0])[51] := {NATURAL_32} 2_609_353_502;
			(blowfish_inst.sbi[0])[52] := {NATURAL_32} 2_950_085_171;
			(blowfish_inst.sbi[0])[53] := {NATURAL_32} 1_814_351_708;
			(blowfish_inst.sbi[0])[54] := {NATURAL_32} 2_050_118_529;
			(blowfish_inst.sbi[0])[55] := {NATURAL_32} 680_887_927;
			(blowfish_inst.sbi[0])[56] := {NATURAL_32} 999_245_976;
			(blowfish_inst.sbi[0])[57] := {NATURAL_32} 1_800_124_847;
			(blowfish_inst.sbi[0])[58] := {NATURAL_32} 3_300_911_131;
			(blowfish_inst.sbi[0])[59] := {NATURAL_32} 1_713_906_067;
			(blowfish_inst.sbi[0])[60] := {NATURAL_32} 1_641_548_236;
			(blowfish_inst.sbi[0])[61] := {NATURAL_32} 4_213_287_313;
			(blowfish_inst.sbi[0])[62] := {NATURAL_32} 1_216_130_144;
			(blowfish_inst.sbi[0])[63] := {NATURAL_32} 1_575_780_402;
			(blowfish_inst.sbi[0])[64] := {NATURAL_32} 4_018_429_277;
			(blowfish_inst.sbi[0])[65] := {NATURAL_32} 3_917_837_745;
			(blowfish_inst.sbi[0])[66] := {NATURAL_32} 3_693_486_850;
			(blowfish_inst.sbi[0])[67] := {NATURAL_32} 3_949_271_944;
			(blowfish_inst.sbi[0])[68] := {NATURAL_32} 596_196_993;
			(blowfish_inst.sbi[0])[69] := {NATURAL_32} 3_549_867_205;
			(blowfish_inst.sbi[0])[70] := {NATURAL_32} 258_830_323;
			(blowfish_inst.sbi[0])[71] := {NATURAL_32} 2_213_823_033;
			(blowfish_inst.sbi[0])[72] := {NATURAL_32} 772_490_370;
			(blowfish_inst.sbi[0])[73] := {NATURAL_32} 2_760_122_372;
			(blowfish_inst.sbi[0])[74] := {NATURAL_32} 1_774_776_394;
			(blowfish_inst.sbi[0])[75] := {NATURAL_32} 2_652_871_518;
			(blowfish_inst.sbi[0])[76] := {NATURAL_32} 566_650_946;
			(blowfish_inst.sbi[0])[77] := {NATURAL_32} 4_142_492_826;
			(blowfish_inst.sbi[0])[78] := {NATURAL_32} 1_728_879_713;
			(blowfish_inst.sbi[0])[79] := {NATURAL_32} 2_882_767_088;
			(blowfish_inst.sbi[0])[80] := {NATURAL_32} 1_783_734_482;
			(blowfish_inst.sbi[0])[81] := {NATURAL_32} 3_629_395_816;
			(blowfish_inst.sbi[0])[82] := {NATURAL_32} 2_517_608_232;
			(blowfish_inst.sbi[0])[83] := {NATURAL_32} 2_874_225_571;
			(blowfish_inst.sbi[0])[84] := {NATURAL_32} 1_861_159_788;
			(blowfish_inst.sbi[0])[85] := {NATURAL_32} 326_777_828;
			(blowfish_inst.sbi[0])[86] := {NATURAL_32} 3_124_490_320;
			(blowfish_inst.sbi[0])[87] := {NATURAL_32} 2_130_389_656;
			(blowfish_inst.sbi[0])[88] := {NATURAL_32} 2_716_951_837;
			(blowfish_inst.sbi[0])[89] := {NATURAL_32} 967_770_486;
			(blowfish_inst.sbi[0])[90] := {NATURAL_32} 1_724_537_150;
			(blowfish_inst.sbi[0])[91] := {NATURAL_32} 2_185_432_712;
			(blowfish_inst.sbi[0])[92] := {NATURAL_32} 2_364_442_137;
			(blowfish_inst.sbi[0])[93] := {NATURAL_32} 1_164_943_284;
			(blowfish_inst.sbi[0])[94] := {NATURAL_32} 2_105_845_187;
			(blowfish_inst.sbi[0])[95] := {NATURAL_32} 998_989_502;
			(blowfish_inst.sbi[0])[96] := {NATURAL_32} 3_765_401_048;
			(blowfish_inst.sbi[0])[97] := {NATURAL_32} 2_244_026_483;
			(blowfish_inst.sbi[0])[98] := {NATURAL_32} 1_075_463_327;
			(blowfish_inst.sbi[0])[99] := {NATURAL_32} 1_455_516_326;
			(blowfish_inst.sbi[0])[100] := {NATURAL_32} 1_322_494_562;
			(blowfish_inst.sbi[0])[101] := {NATURAL_32} 910_128_902;
			(blowfish_inst.sbi[0])[102] := {NATURAL_32} 469_688_178;
			(blowfish_inst.sbi[0])[103] := {NATURAL_32} 1_117_454_909;
			(blowfish_inst.sbi[0])[104] := {NATURAL_32} 936_433_444;
			(blowfish_inst.sbi[0])[105] := {NATURAL_32} 3_490_320_968;
			(blowfish_inst.sbi[0])[106] := {NATURAL_32} 3_675_253_459;
			(blowfish_inst.sbi[0])[107] := {NATURAL_32} 1_240_580_251;
			(blowfish_inst.sbi[0])[108] := {NATURAL_32} 122_909_385;
			(blowfish_inst.sbi[0])[109] := {NATURAL_32} 2_157_517_691;
			(blowfish_inst.sbi[0])[110] := {NATURAL_32} 634_681_816;
			(blowfish_inst.sbi[0])[111] := {NATURAL_32} 4_142_456_567;
			(blowfish_inst.sbi[0])[112] := {NATURAL_32} 3_825_094_682;
			(blowfish_inst.sbi[0])[113] := {NATURAL_32} 3_061_402_683;
			(blowfish_inst.sbi[0])[114] := {NATURAL_32} 2_540_495_037;
			(blowfish_inst.sbi[0])[115] := {NATURAL_32} 79_693_498;
			(blowfish_inst.sbi[0])[116] := {NATURAL_32} 3_249_098_678;
			(blowfish_inst.sbi[0])[117] := {NATURAL_32} 1_084_186_820;
			(blowfish_inst.sbi[0])[118] := {NATURAL_32} 1_583_128_258;
			(blowfish_inst.sbi[0])[119] := {NATURAL_32} 426_386_531;
			(blowfish_inst.sbi[0])[120] := {NATURAL_32} 1_761_308_591;
			(blowfish_inst.sbi[0])[121] := {NATURAL_32} 1_047_286_709;
			(blowfish_inst.sbi[0])[122] := {NATURAL_32} 322_548_459;
			(blowfish_inst.sbi[0])[123] := {NATURAL_32} 995_290_223;
			(blowfish_inst.sbi[0])[124] := {NATURAL_32} 1_845_252_383;
			(blowfish_inst.sbi[0])[125] := {NATURAL_32} 2_603_652_396;
			(blowfish_inst.sbi[0])[126] := {NATURAL_32} 3_431_023_940;
			(blowfish_inst.sbi[0])[127] := {NATURAL_32} 2_942_221_577;
			(blowfish_inst.sbi[0])[128] := {NATURAL_32} 3_202_600_964;
			(blowfish_inst.sbi[0])[129] := {NATURAL_32} 3_727_903_485;
			(blowfish_inst.sbi[0])[130] := {NATURAL_32} 1_712_269_319;
			(blowfish_inst.sbi[0])[131] := {NATURAL_32} 422_464_435;
			(blowfish_inst.sbi[0])[132] := {NATURAL_32} 3_234_572_375;
			(blowfish_inst.sbi[0])[133] := {NATURAL_32} 1_170_764_815;
			(blowfish_inst.sbi[0])[134] := {NATURAL_32} 3_523_960_633;
			(blowfish_inst.sbi[0])[135] := {NATURAL_32} 3_117_677_531;
			(blowfish_inst.sbi[0])[136] := {NATURAL_32} 1_434_042_557;
			(blowfish_inst.sbi[0])[137] := {NATURAL_32} 442_511_882;
			(blowfish_inst.sbi[0])[138] := {NATURAL_32} 3_600_875_718;
			(blowfish_inst.sbi[0])[139] := {NATURAL_32} 1_076_654_713;
			(blowfish_inst.sbi[0])[140] := {NATURAL_32} 1_738_483_198;
			(blowfish_inst.sbi[0])[141] := {NATURAL_32} 4_213_154_764;
			(blowfish_inst.sbi[0])[142] := {NATURAL_32} 2_393_238_008;
			(blowfish_inst.sbi[0])[143] := {NATURAL_32} 3_677_496_056;
			(blowfish_inst.sbi[0])[144] := {NATURAL_32} 1_014_306_527;
			(blowfish_inst.sbi[0])[145] := {NATURAL_32} 4_251_020_053;
			(blowfish_inst.sbi[0])[146] := {NATURAL_32} 793_779_912;
			(blowfish_inst.sbi[0])[147] := {NATURAL_32} 2_902_807_211;
			(blowfish_inst.sbi[0])[148] := {NATURAL_32} 842_905_082;
			(blowfish_inst.sbi[0])[149] := {NATURAL_32} 4_246_964_064;
			(blowfish_inst.sbi[0])[150] := {NATURAL_32} 1_395_751_752;
			(blowfish_inst.sbi[0])[151] := {NATURAL_32} 1_040_244_610;
			(blowfish_inst.sbi[0])[152] := {NATURAL_32} 2_656_851_899;
			(blowfish_inst.sbi[0])[153] := {NATURAL_32} 3_396_308_128;
			(blowfish_inst.sbi[0])[154] := {NATURAL_32} 445_077_038;
			(blowfish_inst.sbi[0])[155] := {NATURAL_32} 3_742_853_595;
			(blowfish_inst.sbi[0])[156] := {NATURAL_32} 3_577_915_638;
			(blowfish_inst.sbi[0])[157] := {NATURAL_32} 679_411_651;
			(blowfish_inst.sbi[0])[158] := {NATURAL_32} 2_892_444_358;
			(blowfish_inst.sbi[0])[159] := {NATURAL_32} 2_354_009_459;
			(blowfish_inst.sbi[0])[160] := {NATURAL_32} 1_767_581_616;
			(blowfish_inst.sbi[0])[161] := {NATURAL_32} 3_150_600_392;
			(blowfish_inst.sbi[0])[162] := {NATURAL_32} 3_791_627_101;
			(blowfish_inst.sbi[0])[163] := {NATURAL_32} 3_102_740_896;
			(blowfish_inst.sbi[0])[164] := {NATURAL_32} 284_835_224;
			(blowfish_inst.sbi[0])[165] := {NATURAL_32} 4_246_832_056;
			(blowfish_inst.sbi[0])[166] := {NATURAL_32} 1_258_075_500;
			(blowfish_inst.sbi[0])[167] := {NATURAL_32} 768_725_851;
			(blowfish_inst.sbi[0])[168] := {NATURAL_32} 2_589_189_241;
			(blowfish_inst.sbi[0])[169] := {NATURAL_32} 3_069_724_005;
			(blowfish_inst.sbi[0])[170] := {NATURAL_32} 3_532_540_348;
			(blowfish_inst.sbi[0])[171] := {NATURAL_32} 1_274_779_536;
			(blowfish_inst.sbi[0])[172] := {NATURAL_32} 3_789_419_226;
			(blowfish_inst.sbi[0])[173] := {NATURAL_32} 2_764_799_539;
			(blowfish_inst.sbi[0])[174] := {NATURAL_32} 1_660_621_633;
			(blowfish_inst.sbi[0])[175] := {NATURAL_32} 3_471_099_624;
			(blowfish_inst.sbi[0])[176] := {NATURAL_32} 4_011_903_706;
			(blowfish_inst.sbi[0])[177] := {NATURAL_32} 913_787_905;
			(blowfish_inst.sbi[0])[178] := {NATURAL_32} 3_497_959_166;
			(blowfish_inst.sbi[0])[179] := {NATURAL_32} 737_222_580;
			(blowfish_inst.sbi[0])[180] := {NATURAL_32} 2_514_213_453;
			(blowfish_inst.sbi[0])[181] := {NATURAL_32} 2_928_710_040;
			(blowfish_inst.sbi[0])[182] := {NATURAL_32} 3_937_242_737;
			(blowfish_inst.sbi[0])[183] := {NATURAL_32} 1_804_850_592;
			(blowfish_inst.sbi[0])[184] := {NATURAL_32} 3_499_020_752;
			(blowfish_inst.sbi[0])[185] := {NATURAL_32} 2_949_064_160;
			(blowfish_inst.sbi[0])[186] := {NATURAL_32} 2_386_320_175;
			(blowfish_inst.sbi[0])[187] := {NATURAL_32} 2_390_070_455;
			(blowfish_inst.sbi[0])[188] := {NATURAL_32} 2_415_321_851;
			(blowfish_inst.sbi[0])[189] := {NATURAL_32} 4_061_277_028;
			(blowfish_inst.sbi[0])[190] := {NATURAL_32} 2_290_661_394;
			(blowfish_inst.sbi[0])[191] := {NATURAL_32} 2_416_832_540;
			(blowfish_inst.sbi[0])[192] := {NATURAL_32} 1_336_762_016;
			(blowfish_inst.sbi[0])[193] := {NATURAL_32} 1_754_252_060;
			(blowfish_inst.sbi[0])[194] := {NATURAL_32} 3_520_065_937;
			(blowfish_inst.sbi[0])[195] := {NATURAL_32} 3_014_181_293;
			(blowfish_inst.sbi[0])[196] := {NATURAL_32} 791_618_072;
			(blowfish_inst.sbi[0])[197] := {NATURAL_32} 3_188_594_551;
			(blowfish_inst.sbi[0])[198] := {NATURAL_32} 3_933_548_030;
			(blowfish_inst.sbi[0])[199] := {NATURAL_32} 2_332_172_193;
			(blowfish_inst.sbi[0])[200] := {NATURAL_32} 3_852_520_463;
			(blowfish_inst.sbi[0])[201] := {NATURAL_32} 3_043_980_520;
			(blowfish_inst.sbi[0])[202] := {NATURAL_32} 413_987_798;
			(blowfish_inst.sbi[0])[203] := {NATURAL_32} 3_465_142_937;
			(blowfish_inst.sbi[0])[204] := {NATURAL_32} 3_030_929_376;
			(blowfish_inst.sbi[0])[205] := {NATURAL_32} 4_245_938_359;
			(blowfish_inst.sbi[0])[206] := {NATURAL_32} 2_093_235_073;
			(blowfish_inst.sbi[0])[207] := {NATURAL_32} 3_534_596_313;
			(blowfish_inst.sbi[0])[208] := {NATURAL_32} 375_366_246;
			(blowfish_inst.sbi[0])[209] := {NATURAL_32} 2_157_278_981;
			(blowfish_inst.sbi[0])[210] := {NATURAL_32} 2_479_649_556;
			(blowfish_inst.sbi[0])[211] := {NATURAL_32} 555_357_303;
			(blowfish_inst.sbi[0])[212] := {NATURAL_32} 3_870_105_701;
			(blowfish_inst.sbi[0])[213] := {NATURAL_32} 2_008_414_854;
			(blowfish_inst.sbi[0])[214] := {NATURAL_32} 3_344_188_149;
			(blowfish_inst.sbi[0])[215] := {NATURAL_32} 4_221_384_143;
			(blowfish_inst.sbi[0])[216] := {NATURAL_32} 3_956_125_452;
			(blowfish_inst.sbi[0])[217] := {NATURAL_32} 2_067_696_032;
			(blowfish_inst.sbi[0])[218] := {NATURAL_32} 3_594_591_187;
			(blowfish_inst.sbi[0])[219] := {NATURAL_32} 2_921_233_993;
			(blowfish_inst.sbi[0])[220] := {NATURAL_32} 2_428_461;
			(blowfish_inst.sbi[0])[221] := {NATURAL_32} 544_322_398;
			(blowfish_inst.sbi[0])[222] := {NATURAL_32} 577_241_275;
			(blowfish_inst.sbi[0])[223] := {NATURAL_32} 1_471_733_935;
			(blowfish_inst.sbi[0])[224] := {NATURAL_32} 610_547_355;
			(blowfish_inst.sbi[0])[225] := {NATURAL_32} 4_027_169_054;
			(blowfish_inst.sbi[0])[226] := {NATURAL_32} 1_432_588_573;
			(blowfish_inst.sbi[0])[227] := {NATURAL_32} 1_507_829_418;
			(blowfish_inst.sbi[0])[228] := {NATURAL_32} 2_025_931_657;
			(blowfish_inst.sbi[0])[229] := {NATURAL_32} 3_646_575_487;
			(blowfish_inst.sbi[0])[230] := {NATURAL_32} 545_086_370;
			(blowfish_inst.sbi[0])[231] := {NATURAL_32} 48_609_733;
			(blowfish_inst.sbi[0])[232] := {NATURAL_32} 2_200_306_550;
			(blowfish_inst.sbi[0])[233] := {NATURAL_32} 1_653_985_193;
			(blowfish_inst.sbi[0])[234] := {NATURAL_32} 298_326_376;
			(blowfish_inst.sbi[0])[235] := {NATURAL_32} 1_316_178_497;
			(blowfish_inst.sbi[0])[236] := {NATURAL_32} 3_007_786_442;
			(blowfish_inst.sbi[0])[237] := {NATURAL_32} 2_064_951_626;
			(blowfish_inst.sbi[0])[238] := {NATURAL_32} 458_293_330;
			(blowfish_inst.sbi[0])[239] := {NATURAL_32} 2_589_141_269;
			(blowfish_inst.sbi[0])[240] := {NATURAL_32} 3_591_329_599;
			(blowfish_inst.sbi[0])[241] := {NATURAL_32} 3_164_325_604;
			(blowfish_inst.sbi[0])[242] := {NATURAL_32} 727_753_846;
			(blowfish_inst.sbi[0])[243] := {NATURAL_32} 2_179_363_840;
			(blowfish_inst.sbi[0])[244] := {NATURAL_32} 146_436_021;
			(blowfish_inst.sbi[0])[245] := {NATURAL_32} 1_461_446_943;
			(blowfish_inst.sbi[0])[246] := {NATURAL_32} 4_069_977_195;
			(blowfish_inst.sbi[0])[247] := {NATURAL_32} 705_550_613;
			(blowfish_inst.sbi[0])[248] := {NATURAL_32} 3_059_967_265;
			(blowfish_inst.sbi[0])[249] := {NATURAL_32} 3_887_724_982;
			(blowfish_inst.sbi[0])[250] := {NATURAL_32} 4_281_599_278;
			(blowfish_inst.sbi[0])[251] := {NATURAL_32} 3_313_849_956;
			(blowfish_inst.sbi[0])[252] := {NATURAL_32} 1_404_054_877;
			(blowfish_inst.sbi[0])[253] := {NATURAL_32} 2_845_806_497;
			(blowfish_inst.sbi[0])[254] := {NATURAL_32} 146_425_753;
			(blowfish_inst.sbi[0])[255] := {NATURAL_32} 1_854_211_946;
			(blowfish_inst.sbi[1])[0] := {NATURAL_32} 1_266_315_497;
			(blowfish_inst.sbi[1])[1] := {NATURAL_32} 3_048_417_604;
			(blowfish_inst.sbi[1])[2] := {NATURAL_32} 3_681_880_366;
			(blowfish_inst.sbi[1])[3] := {NATURAL_32} 3_289_982_499;
			(blowfish_inst.sbi[1])[4] := {NATURAL_32} 2_909_710_000;
			(blowfish_inst.sbi[1])[5] := {NATURAL_32} 1_235_738_493;
			(blowfish_inst.sbi[1])[6] := {NATURAL_32} 2_632_868_024;
			(blowfish_inst.sbi[1])[7] := {NATURAL_32} 2_414_719_590;
			(blowfish_inst.sbi[1])[8] := {NATURAL_32} 3_970_600_049;
			(blowfish_inst.sbi[1])[9] := {NATURAL_32} 1_771_706_367;
			(blowfish_inst.sbi[1])[10] := {NATURAL_32} 1_449_415_276;
			(blowfish_inst.sbi[1])[11] := {NATURAL_32} 3_266_420_449;
			(blowfish_inst.sbi[1])[12] := {NATURAL_32} 422_970_021;
			(blowfish_inst.sbi[1])[13] := {NATURAL_32} 1_963_543_593;
			(blowfish_inst.sbi[1])[14] := {NATURAL_32} 2_690_192_192;
			(blowfish_inst.sbi[1])[15] := {NATURAL_32} 3_826_793_022;
			(blowfish_inst.sbi[1])[16] := {NATURAL_32} 1_062_508_698;
			(blowfish_inst.sbi[1])[17] := {NATURAL_32} 1_531_092_325;
			(blowfish_inst.sbi[1])[18] := {NATURAL_32} 1_804_592_342;
			(blowfish_inst.sbi[1])[19] := {NATURAL_32} 2_583_117_782;
			(blowfish_inst.sbi[1])[20] := {NATURAL_32} 2_714_934_279;
			(blowfish_inst.sbi[1])[21] := {NATURAL_32} 4_024_971_509;
			(blowfish_inst.sbi[1])[22] := {NATURAL_32} 1_294_809_318;
			(blowfish_inst.sbi[1])[23] := {NATURAL_32} 4_028_980_673;
			(blowfish_inst.sbi[1])[24] := {NATURAL_32} 1_289_560_198;
			(blowfish_inst.sbi[1])[25] := {NATURAL_32} 2_221_992_742;
			(blowfish_inst.sbi[1])[26] := {NATURAL_32} 1_669_523_910;
			(blowfish_inst.sbi[1])[27] := {NATURAL_32} 35_572_830;
			(blowfish_inst.sbi[1])[28] := {NATURAL_32} 157_838_143;
			(blowfish_inst.sbi[1])[29] := {NATURAL_32} 1_052_438_473;
			(blowfish_inst.sbi[1])[30] := {NATURAL_32} 1_016_535_060;
			(blowfish_inst.sbi[1])[31] := {NATURAL_32} 1_802_137_761;
			(blowfish_inst.sbi[1])[32] := {NATURAL_32} 1_753_167_236;
			(blowfish_inst.sbi[1])[33] := {NATURAL_32} 1_386_275_462;
			(blowfish_inst.sbi[1])[34] := {NATURAL_32} 3_080_475_397;
			(blowfish_inst.sbi[1])[35] := {NATURAL_32} 2_857_371_447;
			(blowfish_inst.sbi[1])[36] := {NATURAL_32} 1_040_679_964;
			(blowfish_inst.sbi[1])[37] := {NATURAL_32} 2_145_300_060;
			(blowfish_inst.sbi[1])[38] := {NATURAL_32} 2_390_574_316;
			(blowfish_inst.sbi[1])[39] := {NATURAL_32} 1_461_121_720;
			(blowfish_inst.sbi[1])[40] := {NATURAL_32} 2_956_646_967;
			(blowfish_inst.sbi[1])[41] := {NATURAL_32} 4_031_777_805;
			(blowfish_inst.sbi[1])[42] := {NATURAL_32} 4_028_374_788;
			(blowfish_inst.sbi[1])[43] := {NATURAL_32} 33_600_511;
			(blowfish_inst.sbi[1])[44] := {NATURAL_32} 2_920_084_762;
			(blowfish_inst.sbi[1])[45] := {NATURAL_32} 1_018_524_850;
			(blowfish_inst.sbi[1])[46] := {NATURAL_32} 629_373_528;
			(blowfish_inst.sbi[1])[47] := {NATURAL_32} 3_691_585_981;
			(blowfish_inst.sbi[1])[48] := {NATURAL_32} 3_515_945_977;
			(blowfish_inst.sbi[1])[49] := {NATURAL_32} 2_091_462_646;
			(blowfish_inst.sbi[1])[50] := {NATURAL_32} 2_486_323_059;
			(blowfish_inst.sbi[1])[51] := {NATURAL_32} 586_499_841;
			(blowfish_inst.sbi[1])[52] := {NATURAL_32} 988_145_025;
			(blowfish_inst.sbi[1])[53] := {NATURAL_32} 935_516_892;
			(blowfish_inst.sbi[1])[54] := {NATURAL_32} 3_367_335_476;
			(blowfish_inst.sbi[1])[55] := {NATURAL_32} 2_599_673_255;
			(blowfish_inst.sbi[1])[56] := {NATURAL_32} 2_839_830_854;
			(blowfish_inst.sbi[1])[57] := {NATURAL_32} 265_290_510;
			(blowfish_inst.sbi[1])[58] := {NATURAL_32} 3_972_581_182;
			(blowfish_inst.sbi[1])[59] := {NATURAL_32} 2_759_138_881;
			(blowfish_inst.sbi[1])[60] := {NATURAL_32} 3_795_373_465;
			(blowfish_inst.sbi[1])[61] := {NATURAL_32} 1_005_194_799;
			(blowfish_inst.sbi[1])[62] := {NATURAL_32} 847_297_441;
			(blowfish_inst.sbi[1])[63] := {NATURAL_32} 406_762_289;
			(blowfish_inst.sbi[1])[64] := {NATURAL_32} 1_314_163_512;
			(blowfish_inst.sbi[1])[65] := {NATURAL_32} 1_332_590_856;
			(blowfish_inst.sbi[1])[66] := {NATURAL_32} 1_866_599_683;
			(blowfish_inst.sbi[1])[67] := {NATURAL_32} 4_127_851_711;
			(blowfish_inst.sbi[1])[68] := {NATURAL_32} 750_260_880;
			(blowfish_inst.sbi[1])[69] := {NATURAL_32} 613_907_577;
			(blowfish_inst.sbi[1])[70] := {NATURAL_32} 1_450_815_602;
			(blowfish_inst.sbi[1])[71] := {NATURAL_32} 3_165_620_655;
			(blowfish_inst.sbi[1])[72] := {NATURAL_32} 3_734_664_991;
			(blowfish_inst.sbi[1])[73] := {NATURAL_32} 3_650_291_728;
			(blowfish_inst.sbi[1])[74] := {NATURAL_32} 3_012_275_730;
			(blowfish_inst.sbi[1])[75] := {NATURAL_32} 3_704_569_646;
			(blowfish_inst.sbi[1])[76] := {NATURAL_32} 1_427_272_223;
			(blowfish_inst.sbi[1])[77] := {NATURAL_32} 778_793_252;
			(blowfish_inst.sbi[1])[78] := {NATURAL_32} 1_343_938_022;
			(blowfish_inst.sbi[1])[79] := {NATURAL_32} 2_676_280_711;
			(blowfish_inst.sbi[1])[80] := {NATURAL_32} 2_052_605_720;
			(blowfish_inst.sbi[1])[81] := {NATURAL_32} 1_946_737_175;
			(blowfish_inst.sbi[1])[82] := {NATURAL_32} 3_164_576_444;
			(blowfish_inst.sbi[1])[83] := {NATURAL_32} 3_914_038_668;
			(blowfish_inst.sbi[1])[84] := {NATURAL_32} 3_967_478_842;
			(blowfish_inst.sbi[1])[85] := {NATURAL_32} 3_682_934_266;
			(blowfish_inst.sbi[1])[86] := {NATURAL_32} 1_661_551_462;
			(blowfish_inst.sbi[1])[87] := {NATURAL_32} 3_294_938_066;
			(blowfish_inst.sbi[1])[88] := {NATURAL_32} 4_011_595_847;
			(blowfish_inst.sbi[1])[89] := {NATURAL_32} 840_292_616;
			(blowfish_inst.sbi[1])[90] := {NATURAL_32} 3_712_170_807;
			(blowfish_inst.sbi[1])[91] := {NATURAL_32} 616_741_398;
			(blowfish_inst.sbi[1])[92] := {NATURAL_32} 312_560_963;
			(blowfish_inst.sbi[1])[93] := {NATURAL_32} 711_312_465;
			(blowfish_inst.sbi[1])[94] := {NATURAL_32} 1_351_876_610;
			(blowfish_inst.sbi[1])[95] := {NATURAL_32} 322_626_781;
			(blowfish_inst.sbi[1])[96] := {NATURAL_32} 1_910_503_582;
			(blowfish_inst.sbi[1])[97] := {NATURAL_32} 271_666_773;
			(blowfish_inst.sbi[1])[98] := {NATURAL_32} 2_175_563_734;
			(blowfish_inst.sbi[1])[99] := {NATURAL_32} 1_594_956_187;
			(blowfish_inst.sbi[1])[100] := {NATURAL_32} 70_604_529;
			(blowfish_inst.sbi[1])[101] := {NATURAL_32} 3_617_834_859;
			(blowfish_inst.sbi[1])[102] := {NATURAL_32} 1_007_753_275;
			(blowfish_inst.sbi[1])[103] := {NATURAL_32} 1_495_573_769;
			(blowfish_inst.sbi[1])[104] := {NATURAL_32} 4_069_517_037;
			(blowfish_inst.sbi[1])[105] := {NATURAL_32} 2_549_218_298;
			(blowfish_inst.sbi[1])[106] := {NATURAL_32} 2_663_038_764;
			(blowfish_inst.sbi[1])[107] := {NATURAL_32} 504_708_206;
			(blowfish_inst.sbi[1])[108] := {NATURAL_32} 2_263_041_392;
			(blowfish_inst.sbi[1])[109] := {NATURAL_32} 3_941_167_025;
			(blowfish_inst.sbi[1])[110] := {NATURAL_32} 2_249_088_522;
			(blowfish_inst.sbi[1])[111] := {NATURAL_32} 1_514_023_603;
			(blowfish_inst.sbi[1])[112] := {NATURAL_32} 1_998_579_484;
			(blowfish_inst.sbi[1])[113] := {NATURAL_32} 1_312_622_330;
			(blowfish_inst.sbi[1])[114] := {NATURAL_32} 694_541_497;
			(blowfish_inst.sbi[1])[115] := {NATURAL_32} 2_582_060_303;
			(blowfish_inst.sbi[1])[116] := {NATURAL_32} 2_151_582_166;
			(blowfish_inst.sbi[1])[117] := {NATURAL_32} 1_382_467_621;
			(blowfish_inst.sbi[1])[118] := {NATURAL_32} 776_784_248;
			(blowfish_inst.sbi[1])[119] := {NATURAL_32} 2_618_340_202;
			(blowfish_inst.sbi[1])[120] := {NATURAL_32} 3_323_268_794;
			(blowfish_inst.sbi[1])[121] := {NATURAL_32} 2_497_899_128;
			(blowfish_inst.sbi[1])[122] := {NATURAL_32} 2_784_771_155;
			(blowfish_inst.sbi[1])[123] := {NATURAL_32} 503_983_604;
			(blowfish_inst.sbi[1])[124] := {NATURAL_32} 4_076_293_799;
			(blowfish_inst.sbi[1])[125] := {NATURAL_32} 907_881_277;
			(blowfish_inst.sbi[1])[126] := {NATURAL_32} 423_175_695;
			(blowfish_inst.sbi[1])[127] := {NATURAL_32} 432_175_456;
			(blowfish_inst.sbi[1])[128] := {NATURAL_32} 1_378_068_232;
			(blowfish_inst.sbi[1])[129] := {NATURAL_32} 4_145_222_326;
			(blowfish_inst.sbi[1])[130] := {NATURAL_32} 3_954_048_622;
			(blowfish_inst.sbi[1])[131] := {NATURAL_32} 3_938_656_102;
			(blowfish_inst.sbi[1])[132] := {NATURAL_32} 3_820_766_613;
			(blowfish_inst.sbi[1])[133] := {NATURAL_32} 2_793_130_115;
			(blowfish_inst.sbi[1])[134] := {NATURAL_32} 2_977_904_593;
			(blowfish_inst.sbi[1])[135] := {NATURAL_32} 26_017_576;
			(blowfish_inst.sbi[1])[136] := {NATURAL_32} 3_274_890_735;
			(blowfish_inst.sbi[1])[137] := {NATURAL_32} 3_194_772_133;
			(blowfish_inst.sbi[1])[138] := {NATURAL_32} 1_700_274_565;
			(blowfish_inst.sbi[1])[139] := {NATURAL_32} 1_756_076_034;
			(blowfish_inst.sbi[1])[140] := {NATURAL_32} 4_006_520_079;
			(blowfish_inst.sbi[1])[141] := {NATURAL_32} 3_677_328_699;
			(blowfish_inst.sbi[1])[142] := {NATURAL_32} 720_338_349;
			(blowfish_inst.sbi[1])[143] := {NATURAL_32} 1_533_947_780;
			(blowfish_inst.sbi[1])[144] := {NATURAL_32} 354_530_856;
			(blowfish_inst.sbi[1])[145] := {NATURAL_32} 688_349_552;
			(blowfish_inst.sbi[1])[146] := {NATURAL_32} 3_973_924_725;
			(blowfish_inst.sbi[1])[147] := {NATURAL_32} 1_637_815_568;
			(blowfish_inst.sbi[1])[148] := {NATURAL_32} 332_179_504;
			(blowfish_inst.sbi[1])[149] := {NATURAL_32} 3_949_051_286;
			(blowfish_inst.sbi[1])[150] := {NATURAL_32} 53_804_574;
			(blowfish_inst.sbi[1])[151] := {NATURAL_32} 2_852_348_879;
			(blowfish_inst.sbi[1])[152] := {NATURAL_32} 3_044_236_432;
			(blowfish_inst.sbi[1])[153] := {NATURAL_32} 1_282_449_977;
			(blowfish_inst.sbi[1])[154] := {NATURAL_32} 3_583_942_155;
			(blowfish_inst.sbi[1])[155] := {NATURAL_32} 3_416_972_820;
			(blowfish_inst.sbi[1])[156] := {NATURAL_32} 4_006_381_244;
			(blowfish_inst.sbi[1])[157] := {NATURAL_32} 1_617_046_695;
			(blowfish_inst.sbi[1])[158] := {NATURAL_32} 2_628_476_075;
			(blowfish_inst.sbi[1])[159] := {NATURAL_32} 3_002_303_598;
			(blowfish_inst.sbi[1])[160] := {NATURAL_32} 1_686_838_959;
			(blowfish_inst.sbi[1])[161] := {NATURAL_32} 431_878_346;
			(blowfish_inst.sbi[1])[162] := {NATURAL_32} 2_686_675_385;
			(blowfish_inst.sbi[1])[163] := {NATURAL_32} 1_700_445_008;
			(blowfish_inst.sbi[1])[164] := {NATURAL_32} 1_080_580_658;
			(blowfish_inst.sbi[1])[165] := {NATURAL_32} 1_009_431_731;
			(blowfish_inst.sbi[1])[166] := {NATURAL_32} 832_498_133;
			(blowfish_inst.sbi[1])[167] := {NATURAL_32} 3_223_435_511;
			(blowfish_inst.sbi[1])[168] := {NATURAL_32} 2_605_976_345;
			(blowfish_inst.sbi[1])[169] := {NATURAL_32} 2_271_191_193;
			(blowfish_inst.sbi[1])[170] := {NATURAL_32} 2_516_031_870;
			(blowfish_inst.sbi[1])[171] := {NATURAL_32} 1_648_197_032;
			(blowfish_inst.sbi[1])[172] := {NATURAL_32} 4_164_389_018;
			(blowfish_inst.sbi[1])[173] := {NATURAL_32} 2_548_247_927;
			(blowfish_inst.sbi[1])[174] := {NATURAL_32} 300_782_431;
			(blowfish_inst.sbi[1])[175] := {NATURAL_32} 375_919_233;
			(blowfish_inst.sbi[1])[176] := {NATURAL_32} 238_389_289;
			(blowfish_inst.sbi[1])[177] := {NATURAL_32} 3_353_747_414;
			(blowfish_inst.sbi[1])[178] := {NATURAL_32} 2_531_188_641;
			(blowfish_inst.sbi[1])[179] := {NATURAL_32} 2_019_080_857;
			(blowfish_inst.sbi[1])[180] := {NATURAL_32} 1_475_708_069;
			(blowfish_inst.sbi[1])[181] := {NATURAL_32} 455_242_339;
			(blowfish_inst.sbi[1])[182] := {NATURAL_32} 2_609_103_871;
			(blowfish_inst.sbi[1])[183] := {NATURAL_32} 448_939_670;
			(blowfish_inst.sbi[1])[184] := {NATURAL_32} 3_451_063_019;
			(blowfish_inst.sbi[1])[185] := {NATURAL_32} 1_395_535_956;
			(blowfish_inst.sbi[1])[186] := {NATURAL_32} 2_413_381_860;
			(blowfish_inst.sbi[1])[187] := {NATURAL_32} 1_841_049_896;
			(blowfish_inst.sbi[1])[188] := {NATURAL_32} 1_491_858_159;
			(blowfish_inst.sbi[1])[189] := {NATURAL_32} 885_456_874;
			(blowfish_inst.sbi[1])[190] := {NATURAL_32} 4_264_095_073;
			(blowfish_inst.sbi[1])[191] := {NATURAL_32} 4_001_119_347;
			(blowfish_inst.sbi[1])[192] := {NATURAL_32} 1_565_136_089;
			(blowfish_inst.sbi[1])[193] := {NATURAL_32} 3_898_914_787;
			(blowfish_inst.sbi[1])[194] := {NATURAL_32} 1_108_368_660;
			(blowfish_inst.sbi[1])[195] := {NATURAL_32} 540_939_232;
			(blowfish_inst.sbi[1])[196] := {NATURAL_32} 1_173_283_510;
			(blowfish_inst.sbi[1])[197] := {NATURAL_32} 2_745_871_338;
			(blowfish_inst.sbi[1])[198] := {NATURAL_32} 3_681_308_437;
			(blowfish_inst.sbi[1])[199] := {NATURAL_32} 4_207_628_240;
			(blowfish_inst.sbi[1])[200] := {NATURAL_32} 3_343_053_890;
			(blowfish_inst.sbi[1])[201] := {NATURAL_32} 4_016_749_493;
			(blowfish_inst.sbi[1])[202] := {NATURAL_32} 1_699_691_293;
			(blowfish_inst.sbi[1])[203] := {NATURAL_32} 1_103_962_373;
			(blowfish_inst.sbi[1])[204] := {NATURAL_32} 3_625_875_870;
			(blowfish_inst.sbi[1])[205] := {NATURAL_32} 2_256_883_143;
			(blowfish_inst.sbi[1])[206] := {NATURAL_32} 3_830_138_730;
			(blowfish_inst.sbi[1])[207] := {NATURAL_32} 1_031_889_488;
			(blowfish_inst.sbi[1])[208] := {NATURAL_32} 3_479_347_698;
			(blowfish_inst.sbi[1])[209] := {NATURAL_32} 1_535_977_030;
			(blowfish_inst.sbi[1])[210] := {NATURAL_32} 4_236_805_024;
			(blowfish_inst.sbi[1])[211] := {NATURAL_32} 3_251_091_107;
			(blowfish_inst.sbi[1])[212] := {NATURAL_32} 2_132_092_099;
			(blowfish_inst.sbi[1])[213] := {NATURAL_32} 1_774_941_330;
			(blowfish_inst.sbi[1])[214] := {NATURAL_32} 1_199_868_427;
			(blowfish_inst.sbi[1])[215] := {NATURAL_32} 1_452_454_533;
			(blowfish_inst.sbi[1])[216] := {NATURAL_32} 157_007_616
		end

end
