frozen class
	VIM_INITIALIZER_SLICE15

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			eval_inst.functions[131].f_name := ce_string ("last_buffer_nr")
			eval_inst.functions[131].f_min_argc := (0).to_integer_8
			eval_inst.functions[131].f_max_argc := (0).to_integer_8
			eval_inst.functions[131].f_func := eval_inst.f_last_buffer_nr_address
			eval_inst.functions[132].f_name := ce_string ("len")
			eval_inst.functions[132].f_min_argc := (1).to_integer_8
			eval_inst.functions[132].f_max_argc := (1).to_integer_8
			eval_inst.functions[132].f_func := eval_inst.f_len_address
			eval_inst.functions[133].f_name := ce_string ("libcall")
			eval_inst.functions[133].f_min_argc := (3).to_integer_8
			eval_inst.functions[133].f_max_argc := (3).to_integer_8
			eval_inst.functions[133].f_func := eval_inst.f_libcall_address
			eval_inst.functions[134].f_name := ce_string ("libcallnr")
			eval_inst.functions[134].f_min_argc := (3).to_integer_8
			eval_inst.functions[134].f_max_argc := (3).to_integer_8
			eval_inst.functions[134].f_func := eval_inst.f_libcallnr_address
			eval_inst.functions[135].f_name := ce_string ("line")
			eval_inst.functions[135].f_min_argc := (1).to_integer_8
			eval_inst.functions[135].f_max_argc := (1).to_integer_8
			eval_inst.functions[135].f_func := eval_inst.f_line_address
			eval_inst.functions[136].f_name := ce_string ("line2byte")
			eval_inst.functions[136].f_min_argc := (1).to_integer_8
			eval_inst.functions[136].f_max_argc := (1).to_integer_8
			eval_inst.functions[136].f_func := eval_inst.f_line2byte_address
			eval_inst.functions[137].f_name := ce_string ("lispindent")
			eval_inst.functions[137].f_min_argc := (1).to_integer_8
			eval_inst.functions[137].f_max_argc := (1).to_integer_8
			eval_inst.functions[137].f_func := eval_inst.f_lispindent_address
			eval_inst.functions[138].f_name := ce_string ("localtime")
			eval_inst.functions[138].f_min_argc := (0).to_integer_8
			eval_inst.functions[138].f_max_argc := (0).to_integer_8
			eval_inst.functions[138].f_func := eval_inst.f_localtime_address
			eval_inst.functions[139].f_name := ce_string ("log")
			eval_inst.functions[139].f_min_argc := (1).to_integer_8
			eval_inst.functions[139].f_max_argc := (1).to_integer_8
			eval_inst.functions[139].f_func := eval_inst.f_log_address
			eval_inst.functions[140].f_name := ce_string ("log10")
			eval_inst.functions[140].f_min_argc := (1).to_integer_8
			eval_inst.functions[140].f_max_argc := (1).to_integer_8
			eval_inst.functions[140].f_func := eval_inst.f_log10_address
			eval_inst.functions[141].f_name := ce_string ("map")
			eval_inst.functions[141].f_min_argc := (2).to_integer_8
			eval_inst.functions[141].f_max_argc := (2).to_integer_8
			eval_inst.functions[141].f_func := eval_inst.f_map_address
			eval_inst.functions[142].f_name := ce_string ("maparg")
			eval_inst.functions[142].f_min_argc := (1).to_integer_8
			eval_inst.functions[142].f_max_argc := (3).to_integer_8
			eval_inst.functions[142].f_func := eval_inst.f_maparg_address
			eval_inst.functions[143].f_name := ce_string ("mapcheck")
			eval_inst.functions[143].f_min_argc := (1).to_integer_8
			eval_inst.functions[143].f_max_argc := (3).to_integer_8
			eval_inst.functions[143].f_func := eval_inst.f_mapcheck_address
			eval_inst.functions[144].f_name := ce_string ("match")
			eval_inst.functions[144].f_min_argc := (2).to_integer_8
			eval_inst.functions[144].f_max_argc := (4).to_integer_8
			eval_inst.functions[144].f_func := eval_inst.f_match_address
			eval_inst.functions[145].f_name := ce_string ("matchadd")
			eval_inst.functions[145].f_min_argc := (2).to_integer_8
			eval_inst.functions[145].f_max_argc := (4).to_integer_8
			eval_inst.functions[145].f_func := eval_inst.f_matchadd_address
			eval_inst.functions[146].f_name := ce_string ("matcharg")
			eval_inst.functions[146].f_min_argc := (1).to_integer_8
			eval_inst.functions[146].f_max_argc := (1).to_integer_8
			eval_inst.functions[146].f_func := eval_inst.f_matcharg_address
			eval_inst.functions[147].f_name := ce_string ("matchdelete")
			eval_inst.functions[147].f_min_argc := (1).to_integer_8
			eval_inst.functions[147].f_max_argc := (1).to_integer_8
			eval_inst.functions[147].f_func := eval_inst.f_matchdelete_address
			eval_inst.functions[148].f_name := ce_string ("matchend")
			eval_inst.functions[148].f_min_argc := (2).to_integer_8
			eval_inst.functions[148].f_max_argc := (4).to_integer_8
			eval_inst.functions[148].f_func := eval_inst.f_matchend_address
			eval_inst.functions[149].f_name := ce_string ("matchlist")
			eval_inst.functions[149].f_min_argc := (2).to_integer_8
			eval_inst.functions[149].f_max_argc := (4).to_integer_8
			eval_inst.functions[149].f_func := eval_inst.f_matchlist_address
			eval_inst.functions[150].f_name := ce_string ("matchstr")
			eval_inst.functions[150].f_min_argc := (2).to_integer_8
			eval_inst.functions[150].f_max_argc := (4).to_integer_8
			eval_inst.functions[150].f_func := eval_inst.f_matchstr_address
			eval_inst.functions[151].f_name := ce_string ("max")
			eval_inst.functions[151].f_min_argc := (1).to_integer_8
			eval_inst.functions[151].f_max_argc := (1).to_integer_8
			eval_inst.functions[151].f_func := eval_inst.f_max_address
			eval_inst.functions[152].f_name := ce_string ("min")
			eval_inst.functions[152].f_min_argc := (1).to_integer_8
			eval_inst.functions[152].f_max_argc := (1).to_integer_8
			eval_inst.functions[152].f_func := eval_inst.f_min_address
			eval_inst.functions[153].f_name := ce_string ("mkdir")
			eval_inst.functions[153].f_min_argc := (1).to_integer_8
			eval_inst.functions[153].f_max_argc := (3).to_integer_8
			eval_inst.functions[153].f_func := eval_inst.f_mkdir_address
			eval_inst.functions[154].f_name := ce_string ("mode")
			eval_inst.functions[154].f_min_argc := (0).to_integer_8
			eval_inst.functions[154].f_max_argc := (1).to_integer_8
			eval_inst.functions[154].f_func := eval_inst.f_mode_address
			eval_inst.functions[155].f_name := ce_string ("nextnonblank")
			eval_inst.functions[155].f_min_argc := (1).to_integer_8
			eval_inst.functions[155].f_max_argc := (1).to_integer_8
			eval_inst.functions[155].f_func := eval_inst.f_nextnonblank_address
			eval_inst.functions[156].f_name := ce_string ("nr2char")
			eval_inst.functions[156].f_min_argc := (1).to_integer_8
			eval_inst.functions[156].f_max_argc := (1).to_integer_8
			eval_inst.functions[156].f_func := eval_inst.f_nr2char_address
			eval_inst.functions[157].f_name := ce_string ("pathshorten")
			eval_inst.functions[157].f_min_argc := (1).to_integer_8
			eval_inst.functions[157].f_max_argc := (1).to_integer_8
			eval_inst.functions[157].f_func := eval_inst.f_pathshorten_address
			eval_inst.functions[158].f_name := ce_string ("pow")
			eval_inst.functions[158].f_min_argc := (2).to_integer_8
			eval_inst.functions[158].f_max_argc := (2).to_integer_8
			eval_inst.functions[158].f_func := eval_inst.f_pow_address
			eval_inst.functions[159].f_name := ce_string ("prevnonblank")
			eval_inst.functions[159].f_min_argc := (1).to_integer_8
			eval_inst.functions[159].f_max_argc := (1).to_integer_8
			eval_inst.functions[159].f_func := eval_inst.f_prevnonblank_address
			eval_inst.functions[160].f_name := ce_string ("printf")
			eval_inst.functions[160].f_min_argc := (2).to_integer_8
			eval_inst.functions[160].f_max_argc := (19).to_integer_8
			eval_inst.functions[160].f_func := eval_inst.f_printf_address
			eval_inst.functions[161].f_name := ce_string ("pumvisible")
			eval_inst.functions[161].f_min_argc := (0).to_integer_8
			eval_inst.functions[161].f_max_argc := (0).to_integer_8
			eval_inst.functions[161].f_func := eval_inst.f_pumvisible_address
			eval_inst.functions[162].f_name := ce_string ("range")
			eval_inst.functions[162].f_min_argc := (1).to_integer_8
			eval_inst.functions[162].f_max_argc := (3).to_integer_8
			eval_inst.functions[162].f_func := eval_inst.f_range_address
			eval_inst.functions[163].f_name := ce_string ("readfile")
			eval_inst.functions[163].f_min_argc := (1).to_integer_8
			eval_inst.functions[163].f_max_argc := (3).to_integer_8
			eval_inst.functions[163].f_func := eval_inst.f_readfile_address
			eval_inst.functions[164].f_name := ce_string ("reltime")
			eval_inst.functions[164].f_min_argc := (0).to_integer_8
			eval_inst.functions[164].f_max_argc := (2).to_integer_8
			eval_inst.functions[164].f_func := eval_inst.f_reltime_address
			eval_inst.functions[165].f_name := ce_string ("reltimestr")
			eval_inst.functions[165].f_min_argc := (1).to_integer_8
			eval_inst.functions[165].f_max_argc := (1).to_integer_8
			eval_inst.functions[165].f_func := eval_inst.f_reltimestr_address
			eval_inst.functions[166].f_name := ce_string ("remote_expr")
			eval_inst.functions[166].f_min_argc := (2).to_integer_8
			eval_inst.functions[166].f_max_argc := (3).to_integer_8
			eval_inst.functions[166].f_func := eval_inst.f_remote_expr_address
			eval_inst.functions[167].f_name := ce_string ("remote_foreground")
			eval_inst.functions[167].f_min_argc := (1).to_integer_8
			eval_inst.functions[167].f_max_argc := (1).to_integer_8
			eval_inst.functions[167].f_func := eval_inst.f_remote_foreground_address
			eval_inst.functions[168].f_name := ce_string ("remote_peek")
			eval_inst.functions[168].f_min_argc := (1).to_integer_8
			eval_inst.functions[168].f_max_argc := (2).to_integer_8
			eval_inst.functions[168].f_func := eval_inst.f_remote_peek_address
			eval_inst.functions[169].f_name := ce_string ("remote_read")
			eval_inst.functions[169].f_min_argc := (1).to_integer_8
			eval_inst.functions[169].f_max_argc := (1).to_integer_8
			eval_inst.functions[169].f_func := eval_inst.f_remote_read_address
			eval_inst.functions[170].f_name := ce_string ("remote_send")
			eval_inst.functions[170].f_min_argc := (2).to_integer_8
			eval_inst.functions[170].f_max_argc := (3).to_integer_8
			eval_inst.functions[170].f_func := eval_inst.f_remote_send_address
			eval_inst.functions[171].f_name := ce_string ("remove")
			eval_inst.functions[171].f_min_argc := (2).to_integer_8
			eval_inst.functions[171].f_max_argc := (3).to_integer_8
			eval_inst.functions[171].f_func := eval_inst.f_remove_address
			eval_inst.functions[172].f_name := ce_string ("rename")
			eval_inst.functions[172].f_min_argc := (2).to_integer_8
			eval_inst.functions[172].f_max_argc := (2).to_integer_8
			eval_inst.functions[172].f_func := eval_inst.f_rename_address
			eval_inst.functions[173].f_name := ce_string ("repeat")
			eval_inst.functions[173].f_min_argc := (2).to_integer_8
			eval_inst.functions[173].f_max_argc := (2).to_integer_8
			eval_inst.functions[173].f_func := eval_inst.f_repeat_address
			eval_inst.functions[174].f_name := ce_string ("resolve")
			eval_inst.functions[174].f_min_argc := (1).to_integer_8
			eval_inst.functions[174].f_max_argc := (1).to_integer_8
			eval_inst.functions[174].f_func := eval_inst.f_resolve_address
			eval_inst.functions[175].f_name := ce_string ("reverse")
			eval_inst.functions[175].f_min_argc := (1).to_integer_8
			eval_inst.functions[175].f_max_argc := (1).to_integer_8
			eval_inst.functions[175].f_func := eval_inst.f_reverse_address
			eval_inst.functions[176].f_name := ce_string ("round")
			eval_inst.functions[176].f_min_argc := (1).to_integer_8
			eval_inst.functions[176].f_max_argc := (1).to_integer_8
			eval_inst.functions[176].f_func := eval_inst.f_round_address
			eval_inst.functions[177].f_name := ce_string ("search")
			eval_inst.functions[177].f_min_argc := (1).to_integer_8
			eval_inst.functions[177].f_max_argc := (4).to_integer_8
			eval_inst.functions[177].f_func := eval_inst.f_search_address
			eval_inst.functions[178].f_name := ce_string ("searchdecl")
			eval_inst.functions[178].f_min_argc := (1).to_integer_8
			eval_inst.functions[178].f_max_argc := (3).to_integer_8
			eval_inst.functions[178].f_func := eval_inst.f_searchdecl_address
			eval_inst.functions[179].f_name := ce_string ("searchpair")
			eval_inst.functions[179].f_min_argc := (3).to_integer_8
			eval_inst.functions[179].f_max_argc := (7).to_integer_8
			eval_inst.functions[179].f_func := eval_inst.f_searchpair_address
			eval_inst.functions[180].f_name := ce_string ("searchpairpos")
			eval_inst.functions[180].f_min_argc := (3).to_integer_8
			eval_inst.functions[180].f_max_argc := (7).to_integer_8
			eval_inst.functions[180].f_func := eval_inst.f_searchpairpos_address
			eval_inst.functions[181].f_name := ce_string ("searchpos")
			eval_inst.functions[181].f_min_argc := (1).to_integer_8
			eval_inst.functions[181].f_max_argc := (4).to_integer_8
			eval_inst.functions[181].f_func := eval_inst.f_searchpos_address
			eval_inst.functions[182].f_name := ce_string ("server2client")
			eval_inst.functions[182].f_min_argc := (2).to_integer_8
			eval_inst.functions[182].f_max_argc := (2).to_integer_8
			eval_inst.functions[182].f_func := eval_inst.f_server2client_address
			eval_inst.functions[183].f_name := ce_string ("serverlist")
			eval_inst.functions[183].f_min_argc := (0).to_integer_8
			eval_inst.functions[183].f_max_argc := (0).to_integer_8
			eval_inst.functions[183].f_func := eval_inst.f_serverlist_address
			eval_inst.functions[184].f_name := ce_string ("setbufvar")
			eval_inst.functions[184].f_min_argc := (3).to_integer_8
			eval_inst.functions[184].f_max_argc := (3).to_integer_8
			eval_inst.functions[184].f_func := eval_inst.f_setbufvar_address
			eval_inst.functions[185].f_name := ce_string ("setcmdpos")
			eval_inst.functions[185].f_min_argc := (1).to_integer_8
			eval_inst.functions[185].f_max_argc := (1).to_integer_8
			eval_inst.functions[185].f_func := eval_inst.f_setcmdpos_address
			eval_inst.functions[186].f_name := ce_string ("setline")
			eval_inst.functions[186].f_min_argc := (2).to_integer_8
			eval_inst.functions[186].f_max_argc := (2).to_integer_8
			eval_inst.functions[186].f_func := eval_inst.f_setline_address
			eval_inst.functions[187].f_name := ce_string ("setloclist")
			eval_inst.functions[187].f_min_argc := (2).to_integer_8
			eval_inst.functions[187].f_max_argc := (3).to_integer_8
			eval_inst.functions[187].f_func := eval_inst.f_setloclist_address
			eval_inst.functions[188].f_name := ce_string ("setmatches")
			eval_inst.functions[188].f_min_argc := (1).to_integer_8
			eval_inst.functions[188].f_max_argc := (1).to_integer_8
			eval_inst.functions[188].f_func := eval_inst.f_setmatches_address
			eval_inst.functions[189].f_name := ce_string ("setpos")
			eval_inst.functions[189].f_min_argc := (2).to_integer_8
			eval_inst.functions[189].f_max_argc := (2).to_integer_8
			eval_inst.functions[189].f_func := eval_inst.f_setpos_address
			eval_inst.functions[190].f_name := ce_string ("setqflist")
			eval_inst.functions[190].f_min_argc := (1).to_integer_8
			eval_inst.functions[190].f_max_argc := (2).to_integer_8
			eval_inst.functions[190].f_func := eval_inst.f_setqflist_address
			eval_inst.functions[191].f_name := ce_string ("setreg")
			eval_inst.functions[191].f_min_argc := (2).to_integer_8
			eval_inst.functions[191].f_max_argc := (3).to_integer_8
			eval_inst.functions[191].f_func := eval_inst.f_setreg_address
			eval_inst.functions[192].f_name := ce_string ("settabvar")
			eval_inst.functions[192].f_min_argc := (3).to_integer_8
			eval_inst.functions[192].f_max_argc := (3).to_integer_8
			eval_inst.functions[192].f_func := eval_inst.f_settabvar_address
			eval_inst.functions[193].f_name := ce_string ("settabwinvar")
			eval_inst.functions[193].f_min_argc := (4).to_integer_8
			eval_inst.functions[193].f_max_argc := (4).to_integer_8
			eval_inst.functions[193].f_func := eval_inst.f_settabwinvar_address
			eval_inst.functions[194].f_name := ce_string ("setwinvar")
			eval_inst.functions[194].f_min_argc := (3).to_integer_8
			eval_inst.functions[194].f_max_argc := (3).to_integer_8
			eval_inst.functions[194].f_func := eval_inst.f_setwinvar_address
			eval_inst.functions[195].f_name := ce_string ("shellescape")
			eval_inst.functions[195].f_min_argc := (1).to_integer_8
			eval_inst.functions[195].f_max_argc := (2).to_integer_8
			eval_inst.functions[195].f_func := eval_inst.f_shellescape_address
			eval_inst.functions[196].f_name := ce_string ("simplify")
			eval_inst.functions[196].f_min_argc := (1).to_integer_8
			eval_inst.functions[196].f_max_argc := (1).to_integer_8
			eval_inst.functions[196].f_func := eval_inst.f_simplify_address
			eval_inst.functions[197].f_name := ce_string ("sin")
			eval_inst.functions[197].f_min_argc := (1).to_integer_8
			eval_inst.functions[197].f_max_argc := (1).to_integer_8
			eval_inst.functions[197].f_func := eval_inst.f_sin_address
			eval_inst.functions[198].f_name := ce_string ("sinh")
			eval_inst.functions[198].f_min_argc := (1).to_integer_8
			eval_inst.functions[198].f_max_argc := (1).to_integer_8
			eval_inst.functions[198].f_func := eval_inst.f_sinh_address
			eval_inst.functions[199].f_name := ce_string ("sort")
			eval_inst.functions[199].f_min_argc := (1).to_integer_8
			eval_inst.functions[199].f_max_argc := (2).to_integer_8
			eval_inst.functions[199].f_func := eval_inst.f_sort_address
			eval_inst.functions[200].f_name := ce_string ("soundfold")
			eval_inst.functions[200].f_min_argc := (1).to_integer_8
			eval_inst.functions[200].f_max_argc := (1).to_integer_8
			eval_inst.functions[200].f_func := eval_inst.f_soundfold_address
			eval_inst.functions[201].f_name := ce_string ("spellbadword")
			eval_inst.functions[201].f_min_argc := (0).to_integer_8
			eval_inst.functions[201].f_max_argc := (1).to_integer_8
			eval_inst.functions[201].f_func := eval_inst.f_spellbadword_address
			eval_inst.functions[202].f_name := ce_string ("spellsuggest")
			eval_inst.functions[202].f_min_argc := (1).to_integer_8
			eval_inst.functions[202].f_max_argc := (3).to_integer_8
			eval_inst.functions[202].f_func := eval_inst.f_spellsuggest_address
			eval_inst.functions[203].f_name := ce_string ("split")
			eval_inst.functions[203].f_min_argc := (1).to_integer_8
			eval_inst.functions[203].f_max_argc := (3).to_integer_8
			eval_inst.functions[203].f_func := eval_inst.f_split_address
			eval_inst.functions[204].f_name := ce_string ("sqrt")
			eval_inst.functions[204].f_min_argc := (1).to_integer_8
			eval_inst.functions[204].f_max_argc := (1).to_integer_8
			eval_inst.functions[204].f_func := eval_inst.f_sqrt_address
			eval_inst.functions[205].f_name := ce_string ("str2float")
			eval_inst.functions[205].f_min_argc := (1).to_integer_8
			eval_inst.functions[205].f_max_argc := (1).to_integer_8
			eval_inst.functions[205].f_func := eval_inst.f_str2float_address
			eval_inst.functions[206].f_name := ce_string ("str2nr")
			eval_inst.functions[206].f_min_argc := (1).to_integer_8
			eval_inst.functions[206].f_max_argc := (2).to_integer_8
			eval_inst.functions[206].f_func := eval_inst.f_str2nr_address
			eval_inst.functions[207].f_name := ce_string ("strchars")
			eval_inst.functions[207].f_min_argc := (1).to_integer_8
			eval_inst.functions[207].f_max_argc := (1).to_integer_8
			eval_inst.functions[207].f_func := eval_inst.f_strchars_address
			eval_inst.functions[208].f_name := ce_string ("strdisplaywidth")
			eval_inst.functions[208].f_min_argc := (1).to_integer_8
			eval_inst.functions[208].f_max_argc := (2).to_integer_8
			eval_inst.functions[208].f_func := eval_inst.f_strdisplaywidth_address
			eval_inst.functions[209].f_name := ce_string ("strftime")
			eval_inst.functions[209].f_min_argc := (1).to_integer_8
			eval_inst.functions[209].f_max_argc := (2).to_integer_8
			eval_inst.functions[209].f_func := eval_inst.f_strftime_address
			eval_inst.functions[210].f_name := ce_string ("stridx")
			eval_inst.functions[210].f_min_argc := (2).to_integer_8
			eval_inst.functions[210].f_max_argc := (3).to_integer_8
			eval_inst.functions[210].f_func := eval_inst.f_stridx_address
			eval_inst.functions[211].f_name := ce_string ("string")
			eval_inst.functions[211].f_min_argc := (1).to_integer_8
			eval_inst.functions[211].f_max_argc := (1).to_integer_8
			eval_inst.functions[211].f_func := eval_inst.f_string_address
			eval_inst.functions[212].f_name := ce_string ("strlen")
			eval_inst.functions[212].f_min_argc := (1).to_integer_8
			eval_inst.functions[212].f_max_argc := (1).to_integer_8
			eval_inst.functions[212].f_func := eval_inst.f_strlen_address
			eval_inst.functions[213].f_name := ce_string ("strpart")
			eval_inst.functions[213].f_min_argc := (2).to_integer_8
			eval_inst.functions[213].f_max_argc := (3).to_integer_8
			eval_inst.functions[213].f_func := eval_inst.f_strpart_address
			eval_inst.functions[214].f_name := ce_string ("strridx")
			eval_inst.functions[214].f_min_argc := (2).to_integer_8
			eval_inst.functions[214].f_max_argc := (3).to_integer_8
			eval_inst.functions[214].f_func := eval_inst.f_strridx_address
			eval_inst.functions[215].f_name := ce_string ("strtrans")
			eval_inst.functions[215].f_min_argc := (1).to_integer_8
			eval_inst.functions[215].f_max_argc := (1).to_integer_8
			eval_inst.functions[215].f_func := eval_inst.f_strtrans_address
			eval_inst.functions[216].f_name := ce_string ("strwidth")
			eval_inst.functions[216].f_min_argc := (1).to_integer_8
			eval_inst.functions[216].f_max_argc := (1).to_integer_8
			eval_inst.functions[216].f_func := eval_inst.f_strwidth_address
			eval_inst.functions[217].f_name := ce_string ("submatch")
			eval_inst.functions[217].f_min_argc := (1).to_integer_8
			eval_inst.functions[217].f_max_argc := (1).to_integer_8
			eval_inst.functions[217].f_func := eval_inst.f_submatch_address
			eval_inst.functions[218].f_name := ce_string ("substitute")
			eval_inst.functions[218].f_min_argc := (4).to_integer_8
			eval_inst.functions[218].f_max_argc := (4).to_integer_8
			eval_inst.functions[218].f_func := eval_inst.f_substitute_address
			eval_inst.functions[219].f_name := ce_string ("synID")
			eval_inst.functions[219].f_min_argc := (3).to_integer_8
			eval_inst.functions[219].f_max_argc := (3).to_integer_8
			eval_inst.functions[219].f_func := eval_inst.f_synID_address
			eval_inst.functions[220].f_name := ce_string ("synIDattr")
			eval_inst.functions[220].f_min_argc := (2).to_integer_8
			eval_inst.functions[220].f_max_argc := (3).to_integer_8
			eval_inst.functions[220].f_func := eval_inst.f_synIDattr_address
			eval_inst.functions[221].f_name := ce_string ("synIDtrans")
			eval_inst.functions[221].f_min_argc := (1).to_integer_8
			eval_inst.functions[221].f_max_argc := (1).to_integer_8
			eval_inst.functions[221].f_func := eval_inst.f_synIDtrans_address
			eval_inst.functions[222].f_name := ce_string ("synconcealed")
			eval_inst.functions[222].f_min_argc := (2).to_integer_8
			eval_inst.functions[222].f_max_argc := (2).to_integer_8
			eval_inst.functions[222].f_func := eval_inst.f_synconcealed_address
			eval_inst.functions[223].f_name := ce_string ("synstack")
			eval_inst.functions[223].f_min_argc := (2).to_integer_8
			eval_inst.functions[223].f_max_argc := (2).to_integer_8
			eval_inst.functions[223].f_func := eval_inst.f_synstack_address
			eval_inst.functions[224].f_name := ce_string ("system")
			eval_inst.functions[224].f_min_argc := (1).to_integer_8
			eval_inst.functions[224].f_max_argc := (2).to_integer_8
			eval_inst.functions[224].f_func := eval_inst.f_system_address
			eval_inst.functions[225].f_name := ce_string ("tabpagebuflist")
			eval_inst.functions[225].f_min_argc := (0).to_integer_8
			eval_inst.functions[225].f_max_argc := (1).to_integer_8
			eval_inst.functions[225].f_func := eval_inst.f_tabpagebuflist_address
			eval_inst.functions[226].f_name := ce_string ("tabpagenr")
			eval_inst.functions[226].f_min_argc := (0).to_integer_8
			eval_inst.functions[226].f_max_argc := (1).to_integer_8
			eval_inst.functions[226].f_func := eval_inst.f_tabpagenr_address
			eval_inst.functions[227].f_name := ce_string ("tabpagewinnr")
			eval_inst.functions[227].f_min_argc := (1).to_integer_8
			eval_inst.functions[227].f_max_argc := (2).to_integer_8
			eval_inst.functions[227].f_func := eval_inst.f_tabpagewinnr_address
			eval_inst.functions[228].f_name := ce_string ("tagfiles")
			eval_inst.functions[228].f_min_argc := (0).to_integer_8
			eval_inst.functions[228].f_max_argc := (0).to_integer_8
			eval_inst.functions[228].f_func := eval_inst.f_tagfiles_address
			eval_inst.functions[229].f_name := ce_string ("taglist")
			eval_inst.functions[229].f_min_argc := (1).to_integer_8
			eval_inst.functions[229].f_max_argc := (1).to_integer_8
			eval_inst.functions[229].f_func := eval_inst.f_taglist_address
			eval_inst.functions[230].f_name := ce_string ("tan")
			eval_inst.functions[230].f_min_argc := (1).to_integer_8
			eval_inst.functions[230].f_max_argc := (1).to_integer_8
			eval_inst.functions[230].f_func := eval_inst.f_tan_address
			eval_inst.functions[231].f_name := ce_string ("tanh")
			eval_inst.functions[231].f_min_argc := (1).to_integer_8
			eval_inst.functions[231].f_max_argc := (1).to_integer_8
			eval_inst.functions[231].f_func := eval_inst.f_tanh_address
			eval_inst.functions[232].f_name := ce_string ("tempname")
			eval_inst.functions[232].f_min_argc := (0).to_integer_8
			eval_inst.functions[232].f_max_argc := (0).to_integer_8
			eval_inst.functions[232].f_func := eval_inst.f_tempname_address
			eval_inst.functions[233].f_name := ce_string ("test")
			eval_inst.functions[233].f_min_argc := (1).to_integer_8
			eval_inst.functions[233].f_max_argc := (1).to_integer_8
			eval_inst.functions[233].f_func := eval_inst.f_test_address
			eval_inst.functions[234].f_name := ce_string ("tolower")
			eval_inst.functions[234].f_min_argc := (1).to_integer_8
			eval_inst.functions[234].f_max_argc := (1).to_integer_8
			eval_inst.functions[234].f_func := eval_inst.f_tolower_address
			eval_inst.functions[235].f_name := ce_string ("toupper")
			eval_inst.functions[235].f_min_argc := (1).to_integer_8
			eval_inst.functions[235].f_max_argc := (1).to_integer_8
			eval_inst.functions[235].f_func := eval_inst.f_toupper_address
			eval_inst.functions[236].f_name := ce_string ("tr")
			eval_inst.functions[236].f_min_argc := (3).to_integer_8
			eval_inst.functions[236].f_max_argc := (3).to_integer_8
			eval_inst.functions[236].f_func := eval_inst.f_tr_address
			eval_inst.functions[237].f_name := ce_string ("trunc")
			eval_inst.functions[237].f_min_argc := (1).to_integer_8
			eval_inst.functions[237].f_max_argc := (1).to_integer_8
			eval_inst.functions[237].f_func := eval_inst.f_trunc_address
			eval_inst.functions[238].f_name := ce_string ("type")
			eval_inst.functions[238].f_min_argc := (1).to_integer_8
			eval_inst.functions[238].f_max_argc := (1).to_integer_8
			eval_inst.functions[238].f_func := eval_inst.f_type_address
			eval_inst.functions[239].f_name := ce_string ("undofile")
			eval_inst.functions[239].f_min_argc := (1).to_integer_8
			eval_inst.functions[239].f_max_argc := (1).to_integer_8
			eval_inst.functions[239].f_func := eval_inst.f_undofile_address
			eval_inst.functions[240].f_name := ce_string ("undotree")
			eval_inst.functions[240].f_min_argc := (0).to_integer_8
			eval_inst.functions[240].f_max_argc := (0).to_integer_8
			eval_inst.functions[240].f_func := eval_inst.f_undotree_address
			eval_inst.functions[241].f_name := ce_string ("values")
			eval_inst.functions[241].f_min_argc := (1).to_integer_8
			eval_inst.functions[241].f_max_argc := (1).to_integer_8
			eval_inst.functions[241].f_func := eval_inst.f_values_address
			eval_inst.functions[242].f_name := ce_string ("virtcol")
			eval_inst.functions[242].f_min_argc := (1).to_integer_8
			eval_inst.functions[242].f_max_argc := (1).to_integer_8
			eval_inst.functions[242].f_func := eval_inst.f_virtcol_address
			eval_inst.functions[243].f_name := ce_string ("visualmode")
			eval_inst.functions[243].f_min_argc := (0).to_integer_8
			eval_inst.functions[243].f_max_argc := (1).to_integer_8
			eval_inst.functions[243].f_func := eval_inst.f_visualmode_address
			eval_inst.functions[244].f_name := ce_string ("winbufnr")
			eval_inst.functions[244].f_min_argc := (1).to_integer_8
			eval_inst.functions[244].f_max_argc := (1).to_integer_8
			eval_inst.functions[244].f_func := eval_inst.f_winbufnr_address
			eval_inst.functions[245].f_name := ce_string ("wincol")
			eval_inst.functions[245].f_min_argc := (0).to_integer_8
			eval_inst.functions[245].f_max_argc := (0).to_integer_8
			eval_inst.functions[245].f_func := eval_inst.f_wincol_address
			eval_inst.functions[246].f_name := ce_string ("winheight")
			eval_inst.functions[246].f_min_argc := (1).to_integer_8
			eval_inst.functions[246].f_max_argc := (1).to_integer_8
			eval_inst.functions[246].f_func := eval_inst.f_winheight_address
			eval_inst.functions[247].f_name := ce_string ("winline")
			eval_inst.functions[247].f_min_argc := (0).to_integer_8
			eval_inst.functions[247].f_max_argc := (0).to_integer_8
			eval_inst.functions[247].f_func := eval_inst.f_winline_address
			eval_inst.functions[248].f_name := ce_string ("winnr")
			eval_inst.functions[248].f_min_argc := (0).to_integer_8
			eval_inst.functions[248].f_max_argc := (1).to_integer_8
			eval_inst.functions[248].f_func := eval_inst.f_winnr_address
			eval_inst.functions[249].f_name := ce_string ("winrestcmd")
			eval_inst.functions[249].f_min_argc := (0).to_integer_8
			eval_inst.functions[249].f_max_argc := (0).to_integer_8
			eval_inst.functions[249].f_func := eval_inst.f_winrestcmd_address
			eval_inst.functions[250].f_name := ce_string ("winrestview")
			eval_inst.functions[250].f_min_argc := (1).to_integer_8
			eval_inst.functions[250].f_max_argc := (1).to_integer_8
			eval_inst.functions[250].f_func := eval_inst.f_winrestview_address
			eval_inst.functions[251].f_name := ce_string ("winsaveview")
			eval_inst.functions[251].f_min_argc := (0).to_integer_8
			eval_inst.functions[251].f_max_argc := (0).to_integer_8
			eval_inst.functions[251].f_func := eval_inst.f_winsaveview_address
			eval_inst.functions[252].f_name := ce_string ("winwidth")
			eval_inst.functions[252].f_min_argc := (1).to_integer_8
			eval_inst.functions[252].f_max_argc := (1).to_integer_8
			eval_inst.functions[252].f_func := eval_inst.f_winwidth_address
			eval_inst.functions[253].f_name := ce_string ("writefile")
			eval_inst.functions[253].f_min_argc := (2).to_integer_8
			eval_inst.functions[253].f_max_argc := (3).to_integer_8
			eval_inst.functions[253].f_func := eval_inst.f_writefile_address
			eval_inst.intidx := -1
			eval_inst.intidx___0 := -1
			eval_inst.prev_lnum := (0).to_integer_32
			eval_inst.changedtick := 0
			eval_inst.fnum := 0
			eval_inst.change_start[0] := 0
			eval_inst.change_end[0] := 0
			eval_inst.hlID := {PC_HLF_T}.HLF_8
		end

end
