frozen class
	VIM_INITIALIZER_SLICE17

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			ex_cmds_inst.cmdnames[99].cmd_func := mark_inst.ex_delmarks_address
			ex_cmds_inst.cmdnames[99].cmd_argt := (1_048_838).to_natural_32
			ex_cmds_inst.cmdnames[100].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("debug"))
			ex_cmds_inst.cmdnames[100].cmd_func := ex_cmds2_inst.ex_debug_address
			ex_cmds_inst.cmdnames[100].cmd_argt := (1_575_044).to_natural_32
			ex_cmds_inst.cmdnames[101].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("debuggreedy"))
			ex_cmds_inst.cmdnames[101].cmd_func := ex_cmds2_inst.ex_debuggreedy_address
			ex_cmds_inst.cmdnames[101].cmd_argt := (1_069_313).to_natural_32
			ex_cmds_inst.cmdnames[102].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("delcommand"))
			ex_cmds_inst.cmdnames[102].cmd_func := ex_docmd_inst.ex_delcommand_address
			ex_cmds_inst.cmdnames[102].cmd_argt := (1_048_980).to_natural_32
			ex_cmds_inst.cmdnames[103].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("delfunction"))
			ex_cmds_inst.cmdnames[103].cmd_func := eval_inst.ex_delfunction_address
			ex_cmds_inst.cmdnames[103].cmd_argt := (1_048_724).to_natural_32
			ex_cmds_inst.cmdnames[104].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("display"))
			ex_cmds_inst.cmdnames[104].cmd_func := ops_inst.ex_display_address
			ex_cmds_inst.cmdnames[104].cmd_argt := (1_575_172).to_natural_32
			ex_cmds_inst.cmdnames[105].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffupdate"))
			ex_cmds_inst.cmdnames[105].cmd_func := diff_inst.ex_diffupdate_address
			ex_cmds_inst.cmdnames[105].cmd_argt := (256).to_natural_32
			ex_cmds_inst.cmdnames[106].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffget"))
			ex_cmds_inst.cmdnames[106].cmd_func := diff_inst.ex_diffgetput_address
			ex_cmds_inst.cmdnames[106].cmd_argt := (2_097_413).to_natural_32
			ex_cmds_inst.cmdnames[107].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffoff"))
			ex_cmds_inst.cmdnames[107].cmd_func := diff_inst.ex_diffoff_address
			ex_cmds_inst.cmdnames[107].cmd_argt := (258).to_natural_32
			ex_cmds_inst.cmdnames[108].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffpatch"))
			ex_cmds_inst.cmdnames[108].cmd_func := diff_inst.ex_diffpatch_address
			ex_cmds_inst.cmdnames[108].cmd_argt := (2_097_436).to_natural_32
			ex_cmds_inst.cmdnames[109].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffput"))
			ex_cmds_inst.cmdnames[109].cmd_func := diff_inst.ex_diffgetput_address
			ex_cmds_inst.cmdnames[109].cmd_argt := (261).to_natural_32
			ex_cmds_inst.cmdnames[110].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffsplit"))
			ex_cmds_inst.cmdnames[110].cmd_func := diff_inst.ex_diffsplit_address
			ex_cmds_inst.cmdnames[110].cmd_argt := (284).to_natural_32
			ex_cmds_inst.cmdnames[111].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("diffthis"))
			ex_cmds_inst.cmdnames[111].cmd_func := diff_inst.ex_diffthis_address
			ex_cmds_inst.cmdnames[111].cmd_argt := (256).to_natural_32
			ex_cmds_inst.cmdnames[112].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("digraphs"))
			ex_cmds_inst.cmdnames[112].cmd_func := ex_docmd_inst.ex_digraphs_address
			ex_cmds_inst.cmdnames[112].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[113].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("djump"))
			ex_cmds_inst.cmdnames[113].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[113].cmd_argt := (103).to_natural_32
			ex_cmds_inst.cmdnames[114].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dlist"))
			ex_cmds_inst.cmdnames[114].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[114].cmd_argt := (1_048_679).to_natural_32
			ex_cmds_inst.cmdnames[115].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("doautocmd"))
			ex_cmds_inst.cmdnames[115].cmd_func := ex_docmd_inst.ex_doautocmd_address
			ex_cmds_inst.cmdnames[115].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[116].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("doautoall"))
			ex_cmds_inst.cmdnames[116].cmd_func := fileio_inst.ex_doautoall_address
			ex_cmds_inst.cmdnames[116].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[117].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("drop"))
			ex_cmds_inst.cmdnames[117].cmd_func := ex_cmds_inst.ex_drop_address
			ex_cmds_inst.cmdnames[117].cmd_argt := (295_308).to_natural_32
			ex_cmds_inst.cmdnames[118].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dsearch"))
			ex_cmds_inst.cmdnames[118].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[118].cmd_argt := (1_048_679).to_natural_32
			ex_cmds_inst.cmdnames[119].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("dsplit"))
			ex_cmds_inst.cmdnames[119].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[119].cmd_argt := (103).to_natural_32
			ex_cmds_inst.cmdnames[120].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("edit"))
			ex_cmds_inst.cmdnames[120].cmd_func := ex_docmd_inst.ex_edit_address
			ex_cmds_inst.cmdnames[120].cmd_argt := (295_198).to_natural_32
			ex_cmds_inst.cmdnames[121].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("earlier"))
			ex_cmds_inst.cmdnames[121].cmd_func := ex_docmd_inst.ex_later_address
			ex_cmds_inst.cmdnames[121].cmd_argt := (1_048_852).to_natural_32
			ex_cmds_inst.cmdnames[122].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("echo"))
			ex_cmds_inst.cmdnames[122].cmd_func := eval_inst.ex_echo_address
			ex_cmds_inst.cmdnames[122].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[123].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("echoerr"))
			ex_cmds_inst.cmdnames[123].cmd_func := eval_inst.ex_execute_address
			ex_cmds_inst.cmdnames[123].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[124].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("echohl"))
			ex_cmds_inst.cmdnames[124].cmd_func := eval_inst.ex_echohl_address
			ex_cmds_inst.cmdnames[124].cmd_argt := (1_573_124).to_natural_32
			ex_cmds_inst.cmdnames[125].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("echomsg"))
			ex_cmds_inst.cmdnames[125].cmd_func := eval_inst.ex_execute_address
			ex_cmds_inst.cmdnames[125].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[126].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("echon"))
			ex_cmds_inst.cmdnames[126].cmd_func := eval_inst.ex_echo_address
			ex_cmds_inst.cmdnames[126].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[127].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("else"))
			ex_cmds_inst.cmdnames[127].cmd_func := ex_eval_inst.ex_else_address
			ex_cmds_inst.cmdnames[127].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[128].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("elseif"))
			ex_cmds_inst.cmdnames[128].cmd_func := ex_eval_inst.ex_else_address
			ex_cmds_inst.cmdnames[128].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[129].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("emenu"))
			ex_cmds_inst.cmdnames[129].cmd_func := menu_inst.ex_emenu_address
			ex_cmds_inst.cmdnames[129].cmd_argt := (1_067_397).to_natural_32
			ex_cmds_inst.cmdnames[130].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("endif"))
			ex_cmds_inst.cmdnames[130].cmd_func := ex_eval_inst.ex_endif_address
			ex_cmds_inst.cmdnames[130].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[131].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("endfunction"))
			ex_cmds_inst.cmdnames[131].cmd_func := ex_eval_inst.ex_endfunction_address
			ex_cmds_inst.cmdnames[131].cmd_argt := (1_048_832).to_natural_32
			ex_cmds_inst.cmdnames[132].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("endfor"))
			ex_cmds_inst.cmdnames[132].cmd_func := ex_eval_inst.ex_endwhile_address
			ex_cmds_inst.cmdnames[132].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[133].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("endtry"))
			ex_cmds_inst.cmdnames[133].cmd_func := ex_eval_inst.ex_endtry_address
			ex_cmds_inst.cmdnames[133].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[134].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("endwhile"))
			ex_cmds_inst.cmdnames[134].cmd_func := ex_eval_inst.ex_endwhile_address
			ex_cmds_inst.cmdnames[134].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[135].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("enew"))
			ex_cmds_inst.cmdnames[135].cmd_func := ex_docmd_inst.ex_edit_address
			ex_cmds_inst.cmdnames[135].cmd_argt := (258).to_natural_32
			ex_cmds_inst.cmdnames[136].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ex"))
			ex_cmds_inst.cmdnames[136].cmd_func := ex_docmd_inst.ex_edit_address
			ex_cmds_inst.cmdnames[136].cmd_argt := (295_198).to_natural_32
			ex_cmds_inst.cmdnames[137].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("execute"))
			ex_cmds_inst.cmdnames[137].cmd_func := eval_inst.ex_execute_address
			ex_cmds_inst.cmdnames[137].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[138].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("exit"))
			ex_cmds_inst.cmdnames[138].cmd_func := ex_docmd_inst.ex_exit_address
			ex_cmds_inst.cmdnames[138].cmd_argt := (1_311_103).to_natural_32
			ex_cmds_inst.cmdnames[139].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("exusage"))
			ex_cmds_inst.cmdnames[139].cmd_func := ex_cmds_inst.ex_exusage_address
			ex_cmds_inst.cmdnames[139].cmd_argt := (256).to_natural_32
			ex_cmds_inst.cmdnames[140].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("file"))
			ex_cmds_inst.cmdnames[140].cmd_func := ex_cmds_inst.ex_file_address
			ex_cmds_inst.cmdnames[140].cmd_argt := (20_767).to_natural_32
			ex_cmds_inst.cmdnames[141].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("files"))
			ex_cmds_inst.cmdnames[141].cmd_func := buffer_inst.buflist_list_address
			ex_cmds_inst.cmdnames[141].cmd_argt := (1_048_834).to_natural_32
			ex_cmds_inst.cmdnames[142].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("filetype"))
			ex_cmds_inst.cmdnames[142].cmd_func := ex_docmd_inst.ex_filetype_address
			ex_cmds_inst.cmdnames[142].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[143].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("find"))
			ex_cmds_inst.cmdnames[143].cmd_func := ex_docmd_inst.ex_find_address
			ex_cmds_inst.cmdnames[143].cmd_argt := (311_583).to_natural_32
			ex_cmds_inst.cmdnames[144].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("finally"))
			ex_cmds_inst.cmdnames[144].cmd_func := ex_eval_inst.ex_finally_address
			ex_cmds_inst.cmdnames[144].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[145].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("finish"))
			ex_cmds_inst.cmdnames[145].cmd_func := ex_cmds2_inst.ex_finish_address
			ex_cmds_inst.cmdnames[145].cmd_argt := (1_573_120).to_natural_32
			ex_cmds_inst.cmdnames[146].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("first"))
			ex_cmds_inst.cmdnames[146].cmd_func := ex_cmds2_inst.ex_rewind_address
			ex_cmds_inst.cmdnames[146].cmd_argt := (295_174).to_natural_32
			ex_cmds_inst.cmdnames[147].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fixdel"))
			ex_cmds_inst.cmdnames[147].cmd_func := ex_cmds_inst.do_fixdel_address
			ex_cmds_inst.cmdnames[147].cmd_argt := (1_048_832).to_natural_32
			ex_cmds_inst.cmdnames[148].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("fold"))
			ex_cmds_inst.cmdnames[148].cmd_func := ex_docmd_inst.ex_fold_address
			ex_cmds_inst.cmdnames[148].cmd_argt := (1_573_185).to_natural_32
			ex_cmds_inst.cmdnames[149].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("foldclose"))
			ex_cmds_inst.cmdnames[149].cmd_func := ex_docmd_inst.ex_foldopen_address
			ex_cmds_inst.cmdnames[149].cmd_argt := (1_573_187).to_natural_32
			ex_cmds_inst.cmdnames[150].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("folddoopen"))
			ex_cmds_inst.cmdnames[150].cmd_func := ex_docmd_inst.ex_folddo_address
			ex_cmds_inst.cmdnames[150].cmd_argt := (2_213).to_natural_32
			ex_cmds_inst.cmdnames[151].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("folddoclosed"))
			ex_cmds_inst.cmdnames[151].cmd_func := ex_docmd_inst.ex_folddo_address
			ex_cmds_inst.cmdnames[151].cmd_argt := (2_213).to_natural_32
			ex_cmds_inst.cmdnames[152].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("foldopen"))
			ex_cmds_inst.cmdnames[152].cmd_func := ex_docmd_inst.ex_foldopen_address
			ex_cmds_inst.cmdnames[152].cmd_argt := (1_573_187).to_natural_32
			ex_cmds_inst.cmdnames[153].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("for"))
			ex_cmds_inst.cmdnames[153].cmd_func := ex_eval_inst.ex_while_address
			ex_cmds_inst.cmdnames[153].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[154].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("function"))
			ex_cmds_inst.cmdnames[154].cmd_func := eval_inst.ex_function_address
			ex_cmds_inst.cmdnames[154].cmd_argt := (1_048_582).to_natural_32
			ex_cmds_inst.cmdnames[155].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("global"))
			ex_cmds_inst.cmdnames[155].cmd_func := ex_cmds_inst.ex_global_address
			ex_cmds_inst.cmdnames[155].cmd_argt := (1_572_967).to_natural_32
			ex_cmds_inst.cmdnames[156].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("goto"))
			ex_cmds_inst.cmdnames[156].cmd_func := ex_docmd_inst.ex_goto_address
			ex_cmds_inst.cmdnames[156].cmd_argt := (1_590_529).to_natural_32
			ex_cmds_inst.cmdnames[157].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("grep"))
			ex_cmds_inst.cmdnames[157].cmd_func := quickfix_inst.ex_make_address
			ex_cmds_inst.cmdnames[157].cmd_argt := (18_831).to_natural_32
			ex_cmds_inst.cmdnames[158].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("grepadd"))
			ex_cmds_inst.cmdnames[158].cmd_func := quickfix_inst.ex_make_address
			ex_cmds_inst.cmdnames[158].cmd_argt := (18_831).to_natural_32
			ex_cmds_inst.cmdnames[159].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gui"))
			ex_cmds_inst.cmdnames[159].cmd_func := gui_inst.ex_gui_address
			ex_cmds_inst.cmdnames[159].cmd_argt := (1_343_758).to_natural_32
			ex_cmds_inst.cmdnames[160].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("gvim"))
			ex_cmds_inst.cmdnames[160].cmd_func := gui_inst.ex_gui_address
			ex_cmds_inst.cmdnames[160].cmd_argt := (1_343_758).to_natural_32
			ex_cmds_inst.cmdnames[161].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("help"))
			ex_cmds_inst.cmdnames[161].cmd_func := ex_cmds_inst.ex_help_address
			ex_cmds_inst.cmdnames[161].cmd_argt := (2_054).to_natural_32
			ex_cmds_inst.cmdnames[162].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("helpfind"))
			ex_cmds_inst.cmdnames[162].cmd_func := gui_gtk_inst.ex_helpfind_address
			ex_cmds_inst.cmdnames[162].cmd_argt := (2_052).to_natural_32
			ex_cmds_inst.cmdnames[163].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("helpgrep"))
			ex_cmds_inst.cmdnames[163].cmd_func := quickfix_inst.ex_helpgrep_address
			ex_cmds_inst.cmdnames[163].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[164].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("helptags"))
			ex_cmds_inst.cmdnames[164].cmd_func := ex_cmds_inst.ex_helptags_address
			ex_cmds_inst.cmdnames[164].cmd_argt := (1_048_972).to_natural_32
			ex_cmds_inst.cmdnames[165].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("hardcopy"))
			ex_cmds_inst.cmdnames[165].cmd_func := hardcopy_inst.ex_hardcopy_address
			ex_cmds_inst.cmdnames[165].cmd_argt := (1_319).to_natural_32
			ex_cmds_inst.cmdnames[166].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("highlight"))
			ex_cmds_inst.cmdnames[166].cmd_func := ex_docmd_inst.ex_highlight_address
			ex_cmds_inst.cmdnames[166].cmd_argt := (1_573_126).to_natural_32
			ex_cmds_inst.cmdnames[167].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("hide"))
			ex_cmds_inst.cmdnames[167].cmd_func := ex_docmd_inst.ex_hide_address
			ex_cmds_inst.cmdnames[167].cmd_argt := (2_054).to_natural_32
			ex_cmds_inst.cmdnames[168].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("history"))
			ex_cmds_inst.cmdnames[168].cmd_func := ex_getln_inst.ex_history_address
			ex_cmds_inst.cmdnames[168].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[169].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("insert"))
			ex_cmds_inst.cmdnames[169].cmd_func := ex_cmds_inst.ex_append_address
			ex_cmds_inst.cmdnames[169].cmd_argt := (3_145_987).to_natural_32
			ex_cmds_inst.cmdnames[170].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iabbrev"))
			ex_cmds_inst.cmdnames[170].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[170].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[171].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iabclear"))
			ex_cmds_inst.cmdnames[171].cmd_func := ex_docmd_inst.ex_abclear_address
			ex_cmds_inst.cmdnames[171].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[172].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("if"))
			ex_cmds_inst.cmdnames[172].cmd_func := ex_eval_inst.ex_if_address
			ex_cmds_inst.cmdnames[172].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[173].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ijump"))
			ex_cmds_inst.cmdnames[173].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[173].cmd_argt := (103).to_natural_32
			ex_cmds_inst.cmdnames[174].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ilist"))
			ex_cmds_inst.cmdnames[174].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[174].cmd_argt := (1_048_679).to_natural_32
			ex_cmds_inst.cmdnames[175].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("imap"))
			ex_cmds_inst.cmdnames[175].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[175].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[176].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("imapclear"))
			ex_cmds_inst.cmdnames[176].cmd_func := ex_docmd_inst.ex_mapclear_address
			ex_cmds_inst.cmdnames[176].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[177].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("imenu"))
			ex_cmds_inst.cmdnames[177].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[177].cmd_argt := (1_079_557).to_natural_32
			ex_cmds_inst.cmdnames[178].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("inoremap"))
			ex_cmds_inst.cmdnames[178].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[178].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[179].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("inoreabbrev"))
			ex_cmds_inst.cmdnames[179].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[179].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[180].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("inoremenu"))
			ex_cmds_inst.cmdnames[180].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[180].cmd_argt := (1_079_557).to_natural_32
			ex_cmds_inst.cmdnames[181].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("intro"))
			ex_cmds_inst.cmdnames[181].cmd_func := version_inst.ex_intro_address
			ex_cmds_inst.cmdnames[181].cmd_argt := (1_048_832).to_natural_32
			ex_cmds_inst.cmdnames[182].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("isearch"))
			ex_cmds_inst.cmdnames[182].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[182].cmd_argt := (1_048_679).to_natural_32
			ex_cmds_inst.cmdnames[183].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("isplit"))
			ex_cmds_inst.cmdnames[183].cmd_func := ex_docmd_inst.ex_findpat_address
			ex_cmds_inst.cmdnames[183].cmd_argt := (103).to_natural_32
			ex_cmds_inst.cmdnames[184].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iunmap"))
			ex_cmds_inst.cmdnames[184].cmd_func := ex_docmd_inst.ex_unmap_address
			ex_cmds_inst.cmdnames[184].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[185].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iunabbrev"))
			ex_cmds_inst.cmdnames[185].cmd_func := ex_docmd_inst.ex_abbreviate_address
			ex_cmds_inst.cmdnames[185].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[186].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("iunmenu"))
			ex_cmds_inst.cmdnames[186].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[186].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[187].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("join"))
			ex_cmds_inst.cmdnames[187].cmd_func := ex_docmd_inst.ex_join_address
			ex_cmds_inst.cmdnames[187].cmd_argt := (7_341_379).to_natural_32
			ex_cmds_inst.cmdnames[188].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("jumps"))
			ex_cmds_inst.cmdnames[188].cmd_func := mark_inst.ex_jumps_address
			ex_cmds_inst.cmdnames[188].cmd_argt := (1_048_832).to_natural_32
			ex_cmds_inst.cmdnames[189].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("k"))
			ex_cmds_inst.cmdnames[189].cmd_func := ex_docmd_inst.ex_mark_address
			ex_cmds_inst.cmdnames[189].cmd_argt := (1_573_141).to_natural_32
			ex_cmds_inst.cmdnames[190].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepmarks"))
			ex_cmds_inst.cmdnames[190].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[190].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[191].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepjumps"))
			ex_cmds_inst.cmdnames[191].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[191].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[192].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("keepalt"))
			ex_cmds_inst.cmdnames[192].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[192].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[193].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("list"))
			ex_cmds_inst.cmdnames[193].cmd_func := ex_docmd_inst.ex_print_address
			ex_cmds_inst.cmdnames[193].cmd_argt := (5_244_225).to_natural_32
			ex_cmds_inst.cmdnames[194].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lNext"))
			ex_cmds_inst.cmdnames[194].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[194].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[195].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lNfile"))
			ex_cmds_inst.cmdnames[195].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[195].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[196].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("last"))
			ex_cmds_inst.cmdnames[196].cmd_func := ex_cmds2_inst.ex_last_address
			ex_cmds_inst.cmdnames[196].cmd_argt := (295_174).to_natural_32
			ex_cmds_inst.cmdnames[197].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("language"))
			ex_cmds_inst.cmdnames[197].cmd_func := ex_cmds2_inst.ex_language_address
			ex_cmds_inst.cmdnames[197].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[198].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("laddexpr"))
			ex_cmds_inst.cmdnames[198].cmd_func := quickfix_inst.ex_cexpr_address
			ex_cmds_inst.cmdnames[198].cmd_argt := (2_452).to_natural_32
			ex_cmds_inst.cmdnames[199].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("laddbuffer"))
			ex_cmds_inst.cmdnames[199].cmd_func := quickfix_inst.ex_cbuffer_address
			ex_cmds_inst.cmdnames[199].cmd_argt := (16_661).to_natural_32
			ex_cmds_inst.cmdnames[200].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("laddfile"))
			ex_cmds_inst.cmdnames[200].cmd_func := quickfix_inst.ex_cfile_address
			ex_cmds_inst.cmdnames[200].cmd_argt := (284).to_natural_32
			ex_cmds_inst.cmdnames[201].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("later"))
			ex_cmds_inst.cmdnames[201].cmd_func := ex_docmd_inst.ex_later_address
			ex_cmds_inst.cmdnames[201].cmd_argt := (1_048_852).to_natural_32
			ex_cmds_inst.cmdnames[202].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lbuffer"))
			ex_cmds_inst.cmdnames[202].cmd_func := quickfix_inst.ex_cbuffer_address
			ex_cmds_inst.cmdnames[202].cmd_argt := (16_663).to_natural_32
			ex_cmds_inst.cmdnames[203].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lcd"))
			ex_cmds_inst.cmdnames[203].cmd_func := ex_docmd_inst.ex_cd_address
			ex_cmds_inst.cmdnames[203].cmd_argt := (1_048_862).to_natural_32
			ex_cmds_inst.cmdnames[204].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lchdir"))
			ex_cmds_inst.cmdnames[204].cmd_func := ex_docmd_inst.ex_cd_address
			ex_cmds_inst.cmdnames[204].cmd_argt := (1_048_862).to_natural_32
			ex_cmds_inst.cmdnames[205].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lclose"))
			ex_cmds_inst.cmdnames[205].cmd_func := quickfix_inst.ex_cclose_address
			ex_cmds_inst.cmdnames[205].cmd_argt := (17_665).to_natural_32
			ex_cmds_inst.cmdnames[206].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lcscope"))
			ex_cmds_inst.cmdnames[206].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[206].cmd_argt := (2_060).to_natural_32
			ex_cmds_inst.cmdnames[207].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("left"))
			ex_cmds_inst.cmdnames[207].cmd_func := ex_cmds_inst.ex_align_address
			ex_cmds_inst.cmdnames[207].cmd_argt := (3_146_053).to_natural_32
			ex_cmds_inst.cmdnames[208].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("leftabove"))
			ex_cmds_inst.cmdnames[208].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[208].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[209].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("let"))
			ex_cmds_inst.cmdnames[209].cmd_func := eval_inst.ex_let_address
			ex_cmds_inst.cmdnames[209].cmd_argt := (1_574_916).to_natural_32
			ex_cmds_inst.cmdnames[210].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lexpr"))
			ex_cmds_inst.cmdnames[210].cmd_func := quickfix_inst.ex_cexpr_address
			ex_cmds_inst.cmdnames[210].cmd_argt := (2_454).to_natural_32
			ex_cmds_inst.cmdnames[211].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lfile"))
			ex_cmds_inst.cmdnames[211].cmd_func := quickfix_inst.ex_cfile_address
			ex_cmds_inst.cmdnames[211].cmd_argt := (286).to_natural_32
			ex_cmds_inst.cmdnames[212].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lfirst"))
			ex_cmds_inst.cmdnames[212].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[212].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[213].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgetfile"))
			ex_cmds_inst.cmdnames[213].cmd_func := quickfix_inst.ex_cfile_address
			ex_cmds_inst.cmdnames[213].cmd_argt := (284).to_natural_32
			ex_cmds_inst.cmdnames[214].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgetbuffer"))
			ex_cmds_inst.cmdnames[214].cmd_func := quickfix_inst.ex_cbuffer_address
			ex_cmds_inst.cmdnames[214].cmd_argt := (16_661).to_natural_32
			ex_cmds_inst.cmdnames[215].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgetexpr"))
			ex_cmds_inst.cmdnames[215].cmd_func := quickfix_inst.ex_cexpr_address
			ex_cmds_inst.cmdnames[215].cmd_argt := (2_452).to_natural_32
			ex_cmds_inst.cmdnames[216].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgrep"))
			ex_cmds_inst.cmdnames[216].cmd_func := quickfix_inst.ex_make_address
			ex_cmds_inst.cmdnames[216].cmd_argt := (18_831).to_natural_32
			ex_cmds_inst.cmdnames[217].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lgrepadd"))
			ex_cmds_inst.cmdnames[217].cmd_func := quickfix_inst.ex_make_address
			ex_cmds_inst.cmdnames[217].cmd_argt := (18_831).to_natural_32
			ex_cmds_inst.cmdnames[218].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lhelpgrep"))
			ex_cmds_inst.cmdnames[218].cmd_func := quickfix_inst.ex_helpgrep_address
			ex_cmds_inst.cmdnames[218].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[219].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ll"))
			ex_cmds_inst.cmdnames[219].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[219].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[220].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("llast"))
			ex_cmds_inst.cmdnames[220].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[220].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[221].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("llist"))
			ex_cmds_inst.cmdnames[221].cmd_func := quickfix_inst.qf_list_address
			ex_cmds_inst.cmdnames[221].cmd_argt := (1_048_838).to_natural_32
			ex_cmds_inst.cmdnames[222].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lmap"))
			ex_cmds_inst.cmdnames[222].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[222].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[223].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lmapclear"))
			ex_cmds_inst.cmdnames[223].cmd_func := ex_docmd_inst.ex_mapclear_address
			ex_cmds_inst.cmdnames[223].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[224].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lmake"))
			ex_cmds_inst.cmdnames[224].cmd_func := quickfix_inst.ex_make_address
			ex_cmds_inst.cmdnames[224].cmd_argt := (2_318).to_natural_32
			ex_cmds_inst.cmdnames[225].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lnoremap"))
			ex_cmds_inst.cmdnames[225].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[225].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[226].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lnext"))
			ex_cmds_inst.cmdnames[226].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[226].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[227].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lnewer"))
			ex_cmds_inst.cmdnames[227].cmd_func := quickfix_inst.qf_age_address
			ex_cmds_inst.cmdnames[227].cmd_argt := (17_665).to_natural_32
			ex_cmds_inst.cmdnames[228].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lnfile"))
			ex_cmds_inst.cmdnames[228].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[228].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[229].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("loadview"))
			ex_cmds_inst.cmdnames[229].cmd_func := ex_docmd_inst.ex_loadview_address
			ex_cmds_inst.cmdnames[229].cmd_argt := (284).to_natural_32
			ex_cmds_inst.cmdnames[230].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("loadkeymap"))
			ex_cmds_inst.cmdnames[230].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[230].cmd_argt := (1_048_576).to_natural_32
			ex_cmds_inst.cmdnames[231].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lockmarks"))
			ex_cmds_inst.cmdnames[231].cmd_func := ex_docmd_inst.ex_wrongmodifier_address
			ex_cmds_inst.cmdnames[231].cmd_argt := (2_180).to_natural_32
			ex_cmds_inst.cmdnames[232].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lockvar"))
			ex_cmds_inst.cmdnames[232].cmd_func := eval_inst.ex_lockvar_address
			ex_cmds_inst.cmdnames[232].cmd_argt := (1_572_998).to_natural_32
			ex_cmds_inst.cmdnames[233].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lolder"))
			ex_cmds_inst.cmdnames[233].cmd_func := quickfix_inst.qf_age_address
			ex_cmds_inst.cmdnames[233].cmd_argt := (17_665).to_natural_32
			ex_cmds_inst.cmdnames[234].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lopen"))
			ex_cmds_inst.cmdnames[234].cmd_func := quickfix_inst.ex_copen_address
			ex_cmds_inst.cmdnames[234].cmd_argt := (17_665).to_natural_32
			ex_cmds_inst.cmdnames[235].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lprevious"))
			ex_cmds_inst.cmdnames[235].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[235].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[236].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lpfile"))
			ex_cmds_inst.cmdnames[236].cmd_func := quickfix_inst.ex_cnext_address
			ex_cmds_inst.cmdnames[236].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[237].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lrewind"))
			ex_cmds_inst.cmdnames[237].cmd_func := quickfix_inst.ex_cc_address
			ex_cmds_inst.cmdnames[237].cmd_argt := (17_667).to_natural_32
			ex_cmds_inst.cmdnames[238].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ltag"))
			ex_cmds_inst.cmdnames[238].cmd_func := ex_docmd_inst.ex_tag_address
			ex_cmds_inst.cmdnames[238].cmd_argt := (16_662).to_natural_32
			ex_cmds_inst.cmdnames[239].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lua"))
			ex_cmds_inst.cmdnames[239].cmd_func := ex_docmd_inst.ex_script_ni_address
			ex_cmds_inst.cmdnames[239].cmd_argt := (1_048_709).to_natural_32
			ex_cmds_inst.cmdnames[240].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("luado"))
			ex_cmds_inst.cmdnames[240].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[240].cmd_argt := (1_048_741).to_natural_32
			ex_cmds_inst.cmdnames[241].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("luafile"))
			ex_cmds_inst.cmdnames[241].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[241].cmd_argt := (1_048_733).to_natural_32
			ex_cmds_inst.cmdnames[242].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lunmap"))
			ex_cmds_inst.cmdnames[242].cmd_func := ex_docmd_inst.ex_unmap_address
			ex_cmds_inst.cmdnames[242].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[243].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lvimgrep"))
			ex_cmds_inst.cmdnames[243].cmd_func := quickfix_inst.ex_vimgrep_address
			ex_cmds_inst.cmdnames[243].cmd_argt := (18_831).to_natural_32
			ex_cmds_inst.cmdnames[244].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lvimgrepadd"))
			ex_cmds_inst.cmdnames[244].cmd_func := quickfix_inst.ex_vimgrep_address
			ex_cmds_inst.cmdnames[244].cmd_argt := (18_831).to_natural_32
			ex_cmds_inst.cmdnames[245].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lwindow"))
			ex_cmds_inst.cmdnames[245].cmd_func := quickfix_inst.ex_cwindow_address
			ex_cmds_inst.cmdnames[245].cmd_argt := (17_665).to_natural_32
			ex_cmds_inst.cmdnames[246].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ls"))
			ex_cmds_inst.cmdnames[246].cmd_func := buffer_inst.buflist_list_address
			ex_cmds_inst.cmdnames[246].cmd_argt := (1_048_834).to_natural_32
			ex_cmds_inst.cmdnames[247].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("move"))
			ex_cmds_inst.cmdnames[247].cmd_func := ex_docmd_inst.ex_copymove_address
			ex_cmds_inst.cmdnames[247].cmd_argt := (3_146_053).to_natural_32
			ex_cmds_inst.cmdnames[248].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mark"))
			ex_cmds_inst.cmdnames[248].cmd_func := ex_docmd_inst.ex_mark_address
			ex_cmds_inst.cmdnames[248].cmd_argt := (1_573_141).to_natural_32
			ex_cmds_inst.cmdnames[249].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("make"))
			ex_cmds_inst.cmdnames[249].cmd_func := quickfix_inst.ex_make_address
			ex_cmds_inst.cmdnames[249].cmd_argt := (2_318).to_natural_32
			ex_cmds_inst.cmdnames[250].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("map"))
			ex_cmds_inst.cmdnames[250].cmd_func := ex_docmd_inst.ex_map_address
			ex_cmds_inst.cmdnames[250].cmd_argt := (1_059_078).to_natural_32
			ex_cmds_inst.cmdnames[251].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mapclear"))
			ex_cmds_inst.cmdnames[251].cmd_func := ex_docmd_inst.ex_mapclear_address
			ex_cmds_inst.cmdnames[251].cmd_argt := (1_048_838).to_natural_32
			ex_cmds_inst.cmdnames[252].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("marks"))
			ex_cmds_inst.cmdnames[252].cmd_func := mark_inst.do_marks_address
			ex_cmds_inst.cmdnames[252].cmd_argt := (1_048_836).to_natural_32
			ex_cmds_inst.cmdnames[253].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("match"))
			ex_cmds_inst.cmdnames[253].cmd_func := ex_docmd_inst.ex_match_address
			ex_cmds_inst.cmdnames[253].cmd_argt := (1_064_965).to_natural_32
			ex_cmds_inst.cmdnames[254].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menu"))
			ex_cmds_inst.cmdnames[254].cmd_func := menu_inst.ex_menu_address
			ex_cmds_inst.cmdnames[254].cmd_argt := (1_079_559).to_natural_32
			ex_cmds_inst.cmdnames[255].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("menutranslate"))
			ex_cmds_inst.cmdnames[255].cmd_func := menu_inst.ex_menutranslate_address
			ex_cmds_inst.cmdnames[255].cmd_argt := (1_059_076).to_natural_32
			ex_cmds_inst.cmdnames[256].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("messages"))
			ex_cmds_inst.cmdnames[256].cmd_func := message_inst.ex_messages_address
			ex_cmds_inst.cmdnames[256].cmd_argt := (1_048_832).to_natural_32
			ex_cmds_inst.cmdnames[257].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mkexrc"))
			ex_cmds_inst.cmdnames[257].cmd_func := ex_docmd_inst.ex_mkrc_address
			ex_cmds_inst.cmdnames[257].cmd_argt := (1_048_862).to_natural_32
			ex_cmds_inst.cmdnames[258].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mksession"))
			ex_cmds_inst.cmdnames[258].cmd_func := ex_docmd_inst.ex_mkrc_address
			ex_cmds_inst.cmdnames[258].cmd_argt := (286).to_natural_32
			ex_cmds_inst.cmdnames[259].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mkspell"))
			ex_cmds_inst.cmdnames[259].cmd_func := spell_inst.ex_mkspell_address
			ex_cmds_inst.cmdnames[259].cmd_argt := (2_446).to_natural_32
			ex_cmds_inst.cmdnames[260].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mkvimrc"))
			ex_cmds_inst.cmdnames[260].cmd_func := ex_docmd_inst.ex_mkrc_address
			ex_cmds_inst.cmdnames[260].cmd_argt := (1_048_862).to_natural_32
			ex_cmds_inst.cmdnames[261].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mkview"))
			ex_cmds_inst.cmdnames[261].cmd_func := ex_docmd_inst.ex_mkrc_address
			ex_cmds_inst.cmdnames[261].cmd_argt := (286).to_natural_32
			ex_cmds_inst.cmdnames[262].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mode"))
			ex_cmds_inst.cmdnames[262].cmd_func := ex_docmd_inst.ex_mode_address
			ex_cmds_inst.cmdnames[262].cmd_argt := (1_048_852).to_natural_32
			ex_cmds_inst.cmdnames[263].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mzscheme"))
			ex_cmds_inst.cmdnames[263].cmd_func := ex_docmd_inst.ex_script_ni_address
			ex_cmds_inst.cmdnames[263].cmd_argt := (1_573_029).to_natural_32
			ex_cmds_inst.cmdnames[264].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("mzfile"))
			ex_cmds_inst.cmdnames[264].cmd_func := ex_docmd_inst.ex_ni_address
			ex_cmds_inst.cmdnames[264].cmd_argt := (1_048_733).to_natural_32
			ex_cmds_inst.cmdnames[265].cmd_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("next"))
			ex_cmds_inst.cmdnames[265].cmd_func := ex_cmds2_inst.ex_next_address
			ex_cmds_inst.cmdnames[265].cmd_argt := (311_567).to_natural_32
		end

end
