frozen class
	VIM_INITIALIZER_SLICE21

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			hardcopy_inst.j_charsets[5].has_charset := 2
			hardcopy_inst.j_charsets[6].charset := ce_string ("KANJITALK6")
			hardcopy_inst.j_charsets[6].cmap_charset := ce_string ("83pv")
			hardcopy_inst.j_charsets[6].has_charset := 64
			hardcopy_inst.j_charsets[7].charset := ce_string ("KANJITALK7")
			hardcopy_inst.j_charsets[7].cmap_charset := ce_string ("90pv")
			hardcopy_inst.j_charsets[7].has_charset := 128
			hardcopy_inst.sc_encodings[0].encoding := ce_string ("iso-2022")
			hardcopy_inst.sc_encodings[0].cmap_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.sc_encodings[0].needs_charset := 3
			hardcopy_inst.sc_encodings[1].encoding := ce_string ("gb18030")
			hardcopy_inst.sc_encodings[1].cmap_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.sc_encodings[1].needs_charset := 4
			hardcopy_inst.sc_encodings[2].encoding := ce_string ("euc-cn")
			hardcopy_inst.sc_encodings[2].cmap_encoding := ce_string ("EUC")
			hardcopy_inst.sc_encodings[2].needs_charset := 27
			hardcopy_inst.sc_encodings[3].encoding := ce_string ("gbk")
			hardcopy_inst.sc_encodings[3].cmap_encoding := ce_string ("EUC")
			hardcopy_inst.sc_encodings[3].needs_charset := 32
			hardcopy_inst.sc_encodings[4].encoding := ce_string ("ucs-2")
			hardcopy_inst.sc_encodings[4].cmap_encoding := ce_string ("UCS2")
			hardcopy_inst.sc_encodings[4].needs_charset := 64
			hardcopy_inst.sc_encodings[5].encoding := ce_string ("utf-8")
			hardcopy_inst.sc_encodings[5].cmap_encoding := ce_string ("UTF8")
			hardcopy_inst.sc_encodings[5].needs_charset := 64
			hardcopy_inst.sc_charsets[0].charset := ce_string ("GB_2312-80")
			hardcopy_inst.sc_charsets[0].cmap_charset := ce_string ("GB")
			hardcopy_inst.sc_charsets[0].has_charset := 1
			hardcopy_inst.sc_charsets[1].charset := ce_string ("GBT_12345-90")
			hardcopy_inst.sc_charsets[1].cmap_charset := ce_string ("GBT")
			hardcopy_inst.sc_charsets[1].has_charset := 2
			hardcopy_inst.sc_charsets[2].charset := ce_string ("MAC")
			hardcopy_inst.sc_charsets[2].cmap_charset := ce_string ("GBpc")
			hardcopy_inst.sc_charsets[2].has_charset := 8
			hardcopy_inst.sc_charsets[3].charset := ce_string ("GBT-90_MAC")
			hardcopy_inst.sc_charsets[3].cmap_charset := ce_string ("GBTpc")
			hardcopy_inst.sc_charsets[3].has_charset := 16
			hardcopy_inst.sc_charsets[4].charset := ce_string ("GBK")
			hardcopy_inst.sc_charsets[4].cmap_charset := ce_string ("GBK")
			hardcopy_inst.sc_charsets[4].has_charset := 32
			hardcopy_inst.sc_charsets[5].charset := ce_string ("GB18030")
			hardcopy_inst.sc_charsets[5].cmap_charset := ce_string ("GBK2K")
			hardcopy_inst.sc_charsets[5].has_charset := 4
			hardcopy_inst.sc_charsets[6].charset := ce_string ("ISO10646")
			hardcopy_inst.sc_charsets[6].cmap_charset := ce_string ("UniGB")
			hardcopy_inst.sc_charsets[6].has_charset := 64
			hardcopy_inst.tc_encodings[0].encoding := ce_string ("iso-2022")
			hardcopy_inst.tc_encodings[0].cmap_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.tc_encodings[0].needs_charset := 3
			hardcopy_inst.tc_encodings[1].encoding := ce_string ("euc-tw")
			hardcopy_inst.tc_encodings[1].cmap_encoding := ce_string ("EUC")
			hardcopy_inst.tc_encodings[1].needs_charset := 4
			hardcopy_inst.tc_encodings[2].encoding := ce_string ("big5")
			hardcopy_inst.tc_encodings[2].cmap_encoding := ce_string ("B5")
			hardcopy_inst.tc_encodings[2].needs_charset := 4_088
			hardcopy_inst.tc_encodings[3].encoding := ce_string ("cp950")
			hardcopy_inst.tc_encodings[3].cmap_encoding := ce_string ("B5")
			hardcopy_inst.tc_encodings[3].needs_charset := 8
			hardcopy_inst.tc_encodings[4].encoding := ce_string ("ucs-2")
			hardcopy_inst.tc_encodings[4].cmap_encoding := ce_string ("UCS2")
			hardcopy_inst.tc_encodings[4].needs_charset := 4_096
			hardcopy_inst.tc_encodings[5].encoding := ce_string ("utf-8")
			hardcopy_inst.tc_encodings[5].cmap_encoding := ce_string ("UTF8")
			hardcopy_inst.tc_encodings[5].needs_charset := 4_096
			hardcopy_inst.tc_encodings[6].encoding := ce_string ("utf-16")
			hardcopy_inst.tc_encodings[6].cmap_encoding := ce_string ("UTF16")
			hardcopy_inst.tc_encodings[6].needs_charset := 4_096
			hardcopy_inst.tc_encodings[7].encoding := ce_string ("utf-32")
			hardcopy_inst.tc_encodings[7].cmap_encoding := ce_string ("UTF32")
			hardcopy_inst.tc_encodings[7].needs_charset := 4_096
			hardcopy_inst.tc_charsets[0].charset := ce_string ("CNS_1992_1")
			hardcopy_inst.tc_charsets[0].cmap_charset := ce_string ("CNS1")
			hardcopy_inst.tc_charsets[0].has_charset := 1
			hardcopy_inst.tc_charsets[1].charset := ce_string ("CNS_1992_2")
			hardcopy_inst.tc_charsets[1].cmap_charset := ce_string ("CNS2")
			hardcopy_inst.tc_charsets[1].has_charset := 2
			hardcopy_inst.tc_charsets[2].charset := ce_string ("CNS_1993")
			hardcopy_inst.tc_charsets[2].cmap_charset := ce_string ("CNS")
			hardcopy_inst.tc_charsets[2].has_charset := 4
			hardcopy_inst.tc_charsets[3].charset := ce_string ("BIG5")
			hardcopy_inst.tc_charsets[3].cmap_charset := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.tc_charsets[3].has_charset := 8
			hardcopy_inst.tc_charsets[4].charset := ce_string ("CP950")
			hardcopy_inst.tc_charsets[4].cmap_charset := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.tc_charsets[4].has_charset := 8
			hardcopy_inst.tc_charsets[5].charset := ce_string ("ETEN")
			hardcopy_inst.tc_charsets[5].cmap_charset := ce_string ("ETen")
			hardcopy_inst.tc_charsets[5].has_charset := 16
			hardcopy_inst.tc_charsets[6].charset := ce_string ("HK_GCCS")
			hardcopy_inst.tc_charsets[6].cmap_charset := ce_string ("HKgccs")
			hardcopy_inst.tc_charsets[6].has_charset := 32
			hardcopy_inst.tc_charsets[7].charset := ce_string ("SCS")
			hardcopy_inst.tc_charsets[7].cmap_charset := ce_string ("HKscs")
			hardcopy_inst.tc_charsets[7].has_charset := 64
			hardcopy_inst.tc_charsets[8].charset := ce_string ("SCS_ETEN")
			hardcopy_inst.tc_charsets[8].cmap_charset := ce_string ("ETHK")
			hardcopy_inst.tc_charsets[8].has_charset := 128
			hardcopy_inst.tc_charsets[9].charset := ce_string ("MTHKL")
			hardcopy_inst.tc_charsets[9].cmap_charset := ce_string ("HKm471")
			hardcopy_inst.tc_charsets[9].has_charset := 256
			hardcopy_inst.tc_charsets[10].charset := ce_string ("MTHKS")
			hardcopy_inst.tc_charsets[10].cmap_charset := ce_string ("HKm314")
			hardcopy_inst.tc_charsets[10].has_charset := 512
			hardcopy_inst.tc_charsets[11].charset := ce_string ("DLHKL")
			hardcopy_inst.tc_charsets[11].cmap_charset := ce_string ("HKdla")
			hardcopy_inst.tc_charsets[11].has_charset := 1_024
			hardcopy_inst.tc_charsets[12].charset := ce_string ("DLHKS")
			hardcopy_inst.tc_charsets[12].cmap_charset := ce_string ("HKdlb")
			hardcopy_inst.tc_charsets[12].has_charset := 2_048
			hardcopy_inst.tc_charsets[13].charset := ce_string ("ISO10646")
			hardcopy_inst.tc_charsets[13].cmap_charset := ce_string ("UniCNS")
			hardcopy_inst.tc_charsets[13].has_charset := 4_096
			hardcopy_inst.k_encodings[0].encoding := ce_string ("iso-2022-kr")
			hardcopy_inst.k_encodings[0].cmap_encoding := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			hardcopy_inst.k_encodings[0].needs_charset := 1
			hardcopy_inst.k_encodings[1].encoding := ce_string ("euc-kr")
			hardcopy_inst.k_encodings[1].cmap_encoding := ce_string ("EUC")
			hardcopy_inst.k_encodings[1].needs_charset := 3
			hardcopy_inst.k_encodings[2].encoding := ce_string ("johab")
			hardcopy_inst.k_encodings[2].cmap_encoding := ce_string ("Johab")
			hardcopy_inst.k_encodings[2].needs_charset := 1
			hardcopy_inst.k_encodings[3].encoding := ce_string ("cp1361")
			hardcopy_inst.k_encodings[3].cmap_encoding := ce_string ("Johab")
			hardcopy_inst.k_encodings[3].needs_charset := 1
			hardcopy_inst.k_encodings[4].encoding := ce_string ("uhc")
			hardcopy_inst.k_encodings[4].cmap_encoding := ce_string ("UHC")
			hardcopy_inst.k_encodings[4].needs_charset := 4
			hardcopy_inst.k_encodings[5].encoding := ce_string ("cp949")
			hardcopy_inst.k_encodings[5].cmap_encoding := ce_string ("UHC")
			hardcopy_inst.k_encodings[5].needs_charset := 4
			hardcopy_inst.k_encodings[6].encoding := ce_string ("ucs-2")
			hardcopy_inst.k_encodings[6].cmap_encoding := ce_string ("UCS2")
			hardcopy_inst.k_encodings[6].needs_charset := 8
			hardcopy_inst.k_encodings[7].encoding := ce_string ("utf-8")
			hardcopy_inst.k_encodings[7].cmap_encoding := ce_string ("UTF8")
			hardcopy_inst.k_encodings[7].needs_charset := 8
			hardcopy_inst.k_charsets[0].charset := ce_string ("KS_X_1992")
			hardcopy_inst.k_charsets[0].cmap_charset := ce_string ("KSC")
			hardcopy_inst.k_charsets[0].has_charset := 1
			hardcopy_inst.k_charsets[1].charset := ce_string ("CP1361")
			hardcopy_inst.k_charsets[1].cmap_charset := ce_string ("KSC")
			hardcopy_inst.k_charsets[1].has_charset := 1
			hardcopy_inst.k_charsets[2].charset := ce_string ("MAC")
			hardcopy_inst.k_charsets[2].cmap_charset := ce_string ("KSCpc")
			hardcopy_inst.k_charsets[2].has_charset := 2
			hardcopy_inst.k_charsets[3].charset := ce_string ("MSWINDOWS")
			hardcopy_inst.k_charsets[3].cmap_charset := ce_string ("KSCms")
			hardcopy_inst.k_charsets[3].has_charset := 4
			hardcopy_inst.k_charsets[4].charset := ce_string ("CP949")
			hardcopy_inst.k_charsets[4].cmap_charset := ce_string ("KSCms")
			hardcopy_inst.k_charsets[4].has_charset := 4
			hardcopy_inst.k_charsets[5].charset := ce_string ("WANSUNG")
			hardcopy_inst.k_charsets[5].cmap_charset := ce_string ("KSCms")
			hardcopy_inst.k_charsets[5].has_charset := 4
			hardcopy_inst.k_charsets[6].charset := ce_string ("ISO10646")
			hardcopy_inst.k_charsets[6].cmap_charset := ce_string ("UniKS")
			hardcopy_inst.k_charsets[6].has_charset := 8
			hardcopy_inst.prt_ps_mbfonts[0].num_encodings := (((create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32 * (6).to_natural_32) // (create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[0].encodings := hardcopy_inst.j_encodings
			hardcopy_inst.prt_ps_mbfonts[0].num_charsets := (((create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32 * (8).to_natural_32) // (create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[0].charsets := hardcopy_inst.j_charsets
			hardcopy_inst.prt_ps_mbfonts[0].ascii_enc := ce_string ("jis_roman")
			hardcopy_inst.prt_ps_mbfonts[0].defcs := ce_string ("JIS_X_1983")
			hardcopy_inst.prt_ps_mbfonts[1].num_encodings := (((create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32 * (6).to_natural_32) // (create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[1].encodings := hardcopy_inst.sc_encodings
			hardcopy_inst.prt_ps_mbfonts[1].num_charsets := (((create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32 * (7).to_natural_32) // (create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[1].charsets := hardcopy_inst.sc_charsets
			hardcopy_inst.prt_ps_mbfonts[1].ascii_enc := ce_string ("gb_roman")
			hardcopy_inst.prt_ps_mbfonts[1].defcs := ce_string ("GB_2312-80")
			hardcopy_inst.prt_ps_mbfonts[2].num_encodings := (((create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32 * (8).to_natural_32) // (create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[2].encodings := hardcopy_inst.tc_encodings
			hardcopy_inst.prt_ps_mbfonts[2].num_charsets := (((create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32 * (14).to_natural_32) // (create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[2].charsets := hardcopy_inst.tc_charsets
			hardcopy_inst.prt_ps_mbfonts[2].ascii_enc := ce_string ("cns_roman")
			hardcopy_inst.prt_ps_mbfonts[2].defcs := ce_string ("BIG5")
			hardcopy_inst.prt_ps_mbfonts[3].num_encodings := (((create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32 * (8).to_natural_32) // (create {PD_PRT_PS_ENCODING_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[3].encodings := hardcopy_inst.k_encodings
			hardcopy_inst.prt_ps_mbfonts[3].num_charsets := (((create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32 * (7).to_natural_32) // (create {PD_PRT_PS_CHARSET_S}.make).structure_size.to_natural_32).to_integer_32
			hardcopy_inst.prt_ps_mbfonts[3].charsets := hardcopy_inst.k_charsets
			hardcopy_inst.prt_ps_mbfonts[3].ascii_enc := ce_string ("ks_roman")
			hardcopy_inst.prt_ps_mbfonts[3].defcs := ce_string ("KS_X_1992")
			hardcopy_inst.prt_resource_types[0] := ce_string ("procset")
			hardcopy_inst.prt_resource_types[1] := ce_string ("encoding")
			hardcopy_inst.prt_resource_types[2] := ce_string ("cmap")
			hardcopy_inst.prt_dsc_table[0].string := ce_string ("%%%%Title:")
			hardcopy_inst.prt_dsc_table[0].len := ((("%%%%Title:").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32
			hardcopy_inst.prt_dsc_table[0].type := 1
			hardcopy_inst.prt_dsc_table[1].string := ce_string ("%%%%Version:")
			hardcopy_inst.prt_dsc_table[1].len := ((("%%%%Version:").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32
			hardcopy_inst.prt_dsc_table[1].type := 2
			hardcopy_inst.prt_dsc_table[2].string := ce_string ("%%%%EndComments:")
			hardcopy_inst.prt_dsc_table[2].len := ((("%%%%EndComments:").count + 1).to_natural_32 - {NATURAL_32} 1).to_integer_32
			hardcopy_inst.prt_dsc_table[2].type := 3
			hardcopy_inst.prt_ps_file_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			hardcopy_inst.prt_pos_x_moveto := (0.0).truncated_to_real
			hardcopy_inst.prt_pos_y_moveto := (0.0).truncated_to_real
			hardcopy_inst.prt_hexchar[0] := (('0').code).to_natural_8
			hardcopy_inst.prt_hexchar[1] := (('1').code).to_natural_8
			hardcopy_inst.prt_hexchar[2] := (('2').code).to_natural_8
			hardcopy_inst.prt_hexchar[3] := (('3').code).to_natural_8
			hardcopy_inst.prt_hexchar[4] := (('4').code).to_natural_8
			hardcopy_inst.prt_hexchar[5] := (('5').code).to_natural_8
			hardcopy_inst.prt_hexchar[6] := (('6').code).to_natural_8
			hardcopy_inst.prt_hexchar[7] := (('7').code).to_natural_8
			hardcopy_inst.prt_hexchar[8] := (('8').code).to_natural_8
			hardcopy_inst.prt_hexchar[9] := (('9').code).to_natural_8
			hardcopy_inst.prt_hexchar[10] := (('a').code).to_natural_8
			hardcopy_inst.prt_hexchar[11] := (('b').code).to_natural_8
			hardcopy_inst.prt_hexchar[12] := (('c').code).to_natural_8
			hardcopy_inst.prt_hexchar[13] := (('d').code).to_natural_8
			hardcopy_inst.prt_hexchar[14] := (('e').code).to_natural_8
			hardcopy_inst.prt_hexchar[15] := (('f').code).to_natural_8
			hardcopy_inst.prt_hexchar[16] := (('%/0/').code).to_natural_8
			hardcopy_inst.prt_pos_x := (0).to_real
			hardcopy_inst.prt_pos_y := (0).to_real
			if_xcmdsrv_inst.pendingCommands := create {CE_POINTER [PD_PENDINGCOMMAND]}.make_shared (default_pointer)
			if_xcmdsrv_inst.serverReply[0].ga_len := 0
			if_xcmdsrv_inst.serverReply[0].ga_maxlen := 0
			if_xcmdsrv_inst.serverReply[0].ga_itemsize := 0
			if_xcmdsrv_inst.serverReply[0].ga_growsize := 0
			if_xcmdsrv_inst.serverReply[0].ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			if_xcmdsrv_inst.registryProperty := (0).to_natural_32
			if_xcmdsrv_inst.vimProperty := (0).to_natural_32
			if_xcmdsrv_inst.got_x_error := 0
			if_xcmdsrv_inst.empty_prop := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			if_xcmdsrv_inst.serial := 0
			globals_inst.Rows[0] := 24
			globals_inst.Columns[0] := 80
			globals_inst.ScreenLines := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.ScreenAttrs := create {CE_POINTER [NATURAL_16]}.make_shared (default_pointer)
			globals_inst.LineOffset := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			globals_inst.LineWraps := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.ScreenLinesUC := create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer)
			globals_inst.Screen_mco := 0
			globals_inst.ScreenLines2 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.TabPageIdxs := create {CE_POINTER [INTEGER_16]}.make_shared (default_pointer)
			globals_inst.screen_Rows := 0
			globals_inst.screen_Columns := 0
			globals_inst.mod_mask[0] := 0
			globals_inst.redraw_cmdline := 0
			globals_inst.clear_cmdline := 0
			globals_inst.mode_displayed := 0
			globals_inst.cmdline_star := 0
			globals_inst.exec_from_reg := 0
			globals_inst.screen_cleared := 0
			globals_inst.use_crypt_method := 0
			globals_inst.dollar_vcol := 0
			globals_inst.compl_length := 0
			globals_inst.compl_interrupted := 0
			globals_inst.compl_cont_status := 0
			globals_inst.msg_scrolled_ign := 0
			globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.keep_msg_attr := 0
			globals_inst.keep_msg_more := 0
			globals_inst.need_fileinfo := 0
			globals_inst.msg_scroll := 0
			globals_inst.msg_didout := 0
			globals_inst.msg_didany := 0
			globals_inst.msg_nowait := 0
			globals_inst.emsg_off := 0
			globals_inst.info_message := 0
			globals_inst.msg_hist_off := 0
			globals_inst.need_clr_eos := 0
			globals_inst.emsg_skip := 0
			globals_inst.emsg_severe := 0
			globals_inst.did_endif := 0
			globals_inst.ex_exitval := 0
			globals_inst.emsg_on_display := 0
			globals_inst.rc_did_emsg := 0
			globals_inst.no_wait_return := 0
			globals_inst.need_wait_return := 0
			globals_inst.did_wait_return := 0
			globals_inst.need_maketitle := 1
			globals_inst.quit_more := 0
			globals_inst.newline_on_exit := 0
			globals_inst.intr_char := 0
			globals_inst.x_no_connect := 0
			globals_inst.x_force_connect := 0
			globals_inst.ex_keep_indent := 0
			globals_inst.vgetc_busy := 0
			globals_inst.didset_vim := 0
			globals_inst.didset_vimruntime := 0
			globals_inst.lines_left := -1
			globals_inst.msg_no_more := 0
			globals_inst.sourcing_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.sourcing_lnum := (0).to_integer_32
			globals_inst.ex_nesting_level := 0
			globals_inst.debug_break_level := -1
			globals_inst.debug_did_msg := 0
			globals_inst.debug_tick := 0
			globals_inst.did_throw := 0
			globals_inst.need_rethrow := 0
			globals_inst.check_cstack := 0
			globals_inst.trylevel := 0
			globals_inst.force_abort := 0
			globals_inst.msg_list := create {CE_POINTER [CE_POINTER [PD_MSGLIST]]}.make_shared (default_pointer)
			globals_inst.suppress_errthrow := 0
			globals_inst.caught_stack := create {CE_POINTER [PD_VIM_EXCEPTION]}.make_shared (default_pointer)
			globals_inst.may_garbage_collect := 0
			globals_inst.want_garbage_collect := 0
			globals_inst.garbage_collect_at_exit := 0
			globals_inst.current_SID := 0
			globals_inst.scroll_region := 0
			globals_inst.t_colors := 0
			globals_inst.highlight_match := 0
			globals_inst.no_smartcase := 0
			globals_inst.need_check_timestamps := 0
			globals_inst.did_check_timestamps := 0
			globals_inst.no_check_timestamps := 0
			globals_inst.use_gvimrc := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.cterm_normal_fg_color := 0
			globals_inst.cterm_normal_fg_bold := 0
			globals_inst.cterm_normal_bg_color := 0
			globals_inst.autocmd_busy := 0
			globals_inst.autocmd_no_enter := 0
			globals_inst.autocmd_no_leave := 0
			globals_inst.did_filetype := 0
			globals_inst.keep_filetype := 0
			globals_inst.au_new_curbuf := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			globals_inst.mouse_past_bottom := 0
			globals_inst.mouse_past_eol := 0
			globals_inst.mouse_dragging := 0
			globals_inst.need_mouse_correct := 0
			globals_inst.gui_prev_topline := (0).to_integer_32
			globals_inst.gui_prev_topfill := 0
			globals_inst.drag_status_line := 0
			globals_inst.postponed_mouseshape := 0
			globals_inst.drag_sep_line := 0
			globals_inst.diff_context := 6
			globals_inst.diff_foldcolumn := 2
			globals_inst.diff_need_scrollbind := 0
			globals_inst.root_menu[0] := create {CE_POINTER [PD_VIMMENU]}.make_shared (default_pointer)
			globals_inst.sys_menu := 0
			globals_inst.updating_screen := 0
			globals_inst.force_menu_update := 0
			globals_inst.found_reverse_arg := 0
			globals_inst.font_argument := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			globals_inst.background_argument := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			globals_inst.foreground_argument := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			globals_inst.hold_gui_events := 0
			globals_inst.new_pixel_width := 0
			globals_inst.new_pixel_height := 0
			globals_inst.gui_win_x := -1
			globals_inst.gui_win_y := -1
			globals_inst.clip_unnamed := 0
			globals_inst.clip_autoselect := 0
			globals_inst.clip_autoselectml := 0
			globals_inst.clip_html := 0
			globals_inst.clip_exclude_prog := create {CE_POINTER [PD_REGPROG_T]}.make_shared (default_pointer)
			globals_inst.prevwin := create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer)
			globals_inst.aucmd_win_used := 0
			globals_inst.redraw_tabline := 0
			globals_inst.firstbuf := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			globals_inst.lastbuf := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			globals_inst.curbuf := create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer)
			globals_inst.mf_dont_release := 0
			globals_inst.arg_had_last := 0
			globals_inst.vim_tempdir := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.starting := 2
			globals_inst.exiting := 0
			globals_inst.really_exiting := 0
			globals_inst.full_screen := 0
			globals_inst.restricted := 0
			globals_inst.secure := 0
			globals_inst.textlock := 0
			globals_inst.curbuf_lock := 0
			globals_inst.allbuf_lock := 0
			globals_inst.sandbox := 0
			globals_inst.silent_mode := 0
			globals_inst.VIsual_active := 0
			globals_inst.VIsual_select := 0
			globals_inst.VIsual_mode := ('v').code
			globals_inst.redo_VIsual_busy := 0
			globals_inst.did_ai := 0
			globals_inst.ai_col := 0
			globals_inst.end_comment_pending := ('%/0/').code
			globals_inst.did_syncbind := 0
			globals_inst.did_si := 0
			globals_inst.can_si := 0
			globals_inst.can_si_back := 0
			globals_inst.saved_cursor[0].lnum := (0).to_integer_32
			globals_inst.saved_cursor[0].col := 0
			globals_inst.saved_cursor[0].coladd := 0
			globals_inst.orig_line_count := 0
			globals_inst.vr_lines_changed := 0
			globals_inst.lc_active := 0
			globals_inst.enc_dbcs := 0
			globals_inst.enc_unicode := 0
			globals_inst.enc_utf8 := 0
			globals_inst.enc_latin1like := 1
			globals_inst.has_mbyte := 0
			globals_inst.mb_ptr2len := mbyte_inst.latin_ptr2len_address
			globals_inst.mb_ptr2len_len := mbyte_inst.latin_ptr2len_len_address
			globals_inst.mb_char2len := mbyte_inst.latin_char2len_address
			globals_inst.mb_char2bytes := mbyte_inst.latin_char2bytes_address
			globals_inst.mb_ptr2cells := mbyte_inst.latin_ptr2cells_address
			globals_inst.mb_ptr2cells_len := mbyte_inst.latin_ptr2cells_len_address
			globals_inst.mb_char2cells := mbyte_inst.latin_char2cells_address
			globals_inst.mb_off2cells := mbyte_inst.latin_off2cells_address
			globals_inst.mb_ptr2char := mbyte_inst.latin_ptr2char_address
			globals_inst.mb_head_off := mbyte_inst.latin_head_off_address
			globals_inst.xic := create {CE_POINTER [SD_GTKIMCONTEXT]}.make_shared (default_pointer)
			globals_inst.preedit_start_col[0] := (2_147_483_647).to_integer_32
			globals_inst.preedit_end_col := (2_147_483_647).to_integer_32
			globals_inst.xim_changed_while_preediting := 0
			globals_inst.xim_fg_color := (-11_111).to_integer_32
			globals_inst.xim_bg_color := (-11_111).to_integer_32
			globals_inst.State := 1
			globals_inst.finish_op := 0
			globals_inst.opcount := 0
			globals_inst.exmode_active := 0
			globals_inst.ex_no_reprint := 0
			globals_inst.Recording := 0
			globals_inst.Exec_reg := 0
			globals_inst.no_mapping := 0
			globals_inst.no_zero_mapping := 0
			globals_inst.allow_keys := 0
			globals_inst.no_u_sync := 0
			globals_inst.restart_edit := 0
			globals_inst.ins_at_eol := 0
			globals_inst.edit_submode := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.edit_submode_pre := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.edit_submode_extra := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.ctrl_x_mode := 0
			globals_inst.no_abbr := 1
			globals_inst.dont_scroll := 0
			globals_inst.mapped_ctrl_c := 0
			globals_inst.ctrl_c_interrupts := 1
			globals_inst.msg_silent := 0
			globals_inst.emsg_silent := 0
			globals_inst.cmd_silent := 0
			globals_inst.swap_exists_action := 0
			globals_inst.swap_exists_did_quit := 0
			globals_inst.RedrawingDisabled := 0
			globals_inst.readonlymode := 0
			globals_inst.recoverymode := 0
			globals_inst.stuffbuff[0].bh_first.b_next := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			globals_inst.stuffbuff[0].bh_first.b_str[0] := (('%/0/').code).to_natural_8
			globals_inst.stuffbuff[0].bh_curr := create {CE_POINTER [PD_BUFFBLOCK]}.make_shared (default_pointer)
			globals_inst.stuffbuff[0].bh_index := 0
			globals_inst.stuffbuff[0].bh_space := 0
			globals_inst.typebuf.tb_buf := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.typebuf.tb_noremap := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.typebuf.tb_buflen := 0
			globals_inst.typebuf.tb_off := 0
			globals_inst.typebuf.tb_len := 0
			globals_inst.typebuf.tb_maplen := 0
			globals_inst.typebuf.tb_silent := 0
			globals_inst.typebuf.tb_no_abbr_cnt := 0
			globals_inst.typebuf.tb_change_cnt := 0
			globals_inst.ex_normal_busy := 0
			globals_inst.ex_normal_lock := 0
			globals_inst.ignore_script := 0
			globals_inst.maptick := 0
			globals_inst.must_redraw := 0
			globals_inst.skip_redraw := 0
			globals_inst.do_redraw := 0
			globals_inst.need_highlight_changed := 1
			globals_inst.use_viminfo := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.curscript := 0
			globals_inst.scriptout := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			globals_inst.read_cmd_fd := 0
			globals_inst.got_int := 0
			globals_inst.termcap_active := 0
			globals_inst.cur_tmode := 0
			globals_inst.bangredo := 0
			globals_inst.reg_do_extmatch := 0
			globals_inst.re_extmatch_in := create {CE_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
			globals_inst.re_extmatch_out := create {CE_POINTER [PD_REG_EXTMATCH_T]}.make_shared (default_pointer)
			globals_inst.did_outofmem_msg := 0
			globals_inst.did_swapwrite_msg := 0
			globals_inst.undo_off := 0
			globals_inst.global_busy := 0
			globals_inst.listcmd_busy := 0
			globals_inst.need_start_insertmode := 0
			globals_inst.last_cmdline := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.repeat_cmdline := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.new_last_cmdline := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.autocmd_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.autocmd_bufnr := 0
			globals_inst.autocmd_match := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.did_cursorhold := 0
			globals_inst.last_cursormoved.lnum := (0).to_integer_32
			globals_inst.last_cursormoved.col := 0
			globals_inst.last_cursormoved.coladd := 0
			globals_inst.write_no_eol_lnum := (0).to_integer_32
			globals_inst.postponed_split := 0
			globals_inst.postponed_split_flags := 0
			globals_inst.postponed_split_tab := 0
			globals_inst.g_do_tagpreview := 0
			globals_inst.replace_offset := 0
			globals_inst.escape_chars := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T\%"|"))
			globals_inst.keep_help_flag := 0
			globals_inst.empty_option := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			globals_inst.redir_off := 0
			globals_inst.redir_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
			globals_inst.redir_reg := 0
			globals_inst.redir_vname := 0
			globals_inst.save_p_ls := -1
			globals_inst.save_p_wmh := -1
		end

end
