frozen class
	VIM_INITIALIZER_SLICE47

inherit
	VIM_DATA
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {VIM_INITIALIZER}

	initialize
		do
			quickfix_inst.fmt_pat[8].pattern := ce_string ("\d\+")
			quickfix_inst.fmt_pat[9].convchar := (('s').code).to_natural_8
			quickfix_inst.fmt_pat[9].pattern := ce_string (".\+")
			quickfix_inst.e_no_more_items := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("E553: No more items"))
			quickfix_inst.start___0 := -1
			quickfix_inst.off := 0
			regexp_inst.reg_prev_sub := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			regexp_inst.REGEXP_INRANGE[0] := ((']').code).to_natural_8
			regexp_inst.REGEXP_INRANGE[1] := (('^').code).to_natural_8
			regexp_inst.REGEXP_INRANGE[2] := (('-').code).to_natural_8
			regexp_inst.REGEXP_INRANGE[3] := (('n').code).to_natural_8
			regexp_inst.REGEXP_INRANGE[4] := (('\').code).to_natural_8
			regexp_inst.REGEXP_INRANGE[5] := (('%/0/').code).to_natural_8
			regexp_inst.REGEXP_ABBR[0] := (('n').code).to_natural_8
			regexp_inst.REGEXP_ABBR[1] := (('r').code).to_natural_8
			regexp_inst.REGEXP_ABBR[2] := (('t').code).to_natural_8
			regexp_inst.REGEXP_ABBR[3] := (('e').code).to_natural_8
			regexp_inst.REGEXP_ABBR[4] := (('b').code).to_natural_8
			regexp_inst.REGEXP_ABBR[5] := (('d').code).to_natural_8
			regexp_inst.REGEXP_ABBR[6] := (('o').code).to_natural_8
			regexp_inst.REGEXP_ABBR[7] := (('x').code).to_natural_8
			regexp_inst.REGEXP_ABBR[8] := (('u').code).to_natural_8
			regexp_inst.REGEXP_ABBR[9] := (('U').code).to_natural_8
			regexp_inst.REGEXP_ABBR[10] := (('%/0/').code).to_natural_8
			regexp_inst.class_names[0] := ce_string ("alnum:]")
			regexp_inst.class_names[1] := ce_string ("alpha:]")
			regexp_inst.class_names[2] := ce_string ("blank:]")
			regexp_inst.class_names[3] := ce_string ("cntrl:]")
			regexp_inst.class_names[4] := ce_string ("digit:]")
			regexp_inst.class_names[5] := ce_string ("graph:]")
			regexp_inst.class_names[6] := ce_string ("lower:]")
			regexp_inst.class_names[7] := ce_string ("print:]")
			regexp_inst.class_names[8] := ce_string ("punct:]")
			regexp_inst.class_names[9] := ce_string ("space:]")
			regexp_inst.class_names[10] := ce_string ("upper:]")
			regexp_inst.class_names[11] := ce_string ("xdigit:]")
			regexp_inst.class_names[12] := ce_string ("tab:]")
			regexp_inst.class_names[13] := ce_string ("return:]")
			regexp_inst.class_names[14] := ce_string ("backspace:]")
			regexp_inst.class_names[15] := ce_string ("escape:]")
			regexp_inst.done___1 := 0
			regexp_inst.one_exactly := 0
			regexp_inst.META_flags[0] := (0).to_natural_8
			regexp_inst.META_flags[1] := (0).to_natural_8
			regexp_inst.META_flags[2] := (0).to_natural_8
			regexp_inst.META_flags[3] := (0).to_natural_8
			regexp_inst.META_flags[4] := (0).to_natural_8
			regexp_inst.META_flags[5] := (0).to_natural_8
			regexp_inst.META_flags[6] := (0).to_natural_8
			regexp_inst.META_flags[7] := (0).to_natural_8
			regexp_inst.META_flags[8] := (0).to_natural_8
			regexp_inst.META_flags[9] := (0).to_natural_8
			regexp_inst.META_flags[10] := (0).to_natural_8
			regexp_inst.META_flags[11] := (0).to_natural_8
			regexp_inst.META_flags[12] := (0).to_natural_8
			regexp_inst.META_flags[13] := (0).to_natural_8
			regexp_inst.META_flags[14] := (0).to_natural_8
			regexp_inst.META_flags[15] := (0).to_natural_8
			regexp_inst.META_flags[16] := (0).to_natural_8
			regexp_inst.META_flags[17] := (0).to_natural_8
			regexp_inst.META_flags[18] := (0).to_natural_8
			regexp_inst.META_flags[19] := (0).to_natural_8
			regexp_inst.META_flags[20] := (0).to_natural_8
			regexp_inst.META_flags[21] := (0).to_natural_8
			regexp_inst.META_flags[22] := (0).to_natural_8
			regexp_inst.META_flags[23] := (0).to_natural_8
			regexp_inst.META_flags[24] := (0).to_natural_8
			regexp_inst.META_flags[25] := (0).to_natural_8
			regexp_inst.META_flags[26] := (0).to_natural_8
			regexp_inst.META_flags[27] := (0).to_natural_8
			regexp_inst.META_flags[28] := (0).to_natural_8
			regexp_inst.META_flags[29] := (0).to_natural_8
			regexp_inst.META_flags[30] := (0).to_natural_8
			regexp_inst.META_flags[31] := (0).to_natural_8
			regexp_inst.META_flags[32] := (0).to_natural_8
			regexp_inst.META_flags[33] := (0).to_natural_8
			regexp_inst.META_flags[34] := (0).to_natural_8
			regexp_inst.META_flags[35] := (0).to_natural_8
			regexp_inst.META_flags[36] := (0).to_natural_8
			regexp_inst.META_flags[37] := (1).to_natural_8
			regexp_inst.META_flags[38] := (1).to_natural_8
			regexp_inst.META_flags[39] := (0).to_natural_8
			regexp_inst.META_flags[40] := (1).to_natural_8
			regexp_inst.META_flags[41] := (1).to_natural_8
			regexp_inst.META_flags[42] := (1).to_natural_8
			regexp_inst.META_flags[43] := (1).to_natural_8
			regexp_inst.META_flags[44] := (0).to_natural_8
			regexp_inst.META_flags[45] := (0).to_natural_8
			regexp_inst.META_flags[46] := (1).to_natural_8
			regexp_inst.META_flags[47] := (0).to_natural_8
			regexp_inst.META_flags[48] := (0).to_natural_8
			regexp_inst.META_flags[49] := (1).to_natural_8
			regexp_inst.META_flags[50] := (1).to_natural_8
			regexp_inst.META_flags[51] := (1).to_natural_8
			regexp_inst.META_flags[52] := (1).to_natural_8
			regexp_inst.META_flags[53] := (1).to_natural_8
			regexp_inst.META_flags[54] := (1).to_natural_8
			regexp_inst.META_flags[55] := (1).to_natural_8
			regexp_inst.META_flags[56] := (1).to_natural_8
			regexp_inst.META_flags[57] := (1).to_natural_8
			regexp_inst.META_flags[58] := (0).to_natural_8
			regexp_inst.META_flags[59] := (0).to_natural_8
			regexp_inst.META_flags[60] := (1).to_natural_8
			regexp_inst.META_flags[61] := (1).to_natural_8
			regexp_inst.META_flags[62] := (1).to_natural_8
			regexp_inst.META_flags[63] := (1).to_natural_8
			regexp_inst.META_flags[64] := (1).to_natural_8
			regexp_inst.META_flags[65] := (1).to_natural_8
			regexp_inst.META_flags[66] := (0).to_natural_8
			regexp_inst.META_flags[67] := (1).to_natural_8
			regexp_inst.META_flags[68] := (1).to_natural_8
			regexp_inst.META_flags[69] := (0).to_natural_8
			regexp_inst.META_flags[70] := (1).to_natural_8
			regexp_inst.META_flags[71] := (0).to_natural_8
			regexp_inst.META_flags[72] := (1).to_natural_8
			regexp_inst.META_flags[73] := (1).to_natural_8
			regexp_inst.META_flags[74] := (0).to_natural_8
			regexp_inst.META_flags[75] := (1).to_natural_8
			regexp_inst.META_flags[76] := (1).to_natural_8
			regexp_inst.META_flags[77] := (1).to_natural_8
			regexp_inst.META_flags[78] := (0).to_natural_8
			regexp_inst.META_flags[79] := (1).to_natural_8
			regexp_inst.META_flags[80] := (1).to_natural_8
			regexp_inst.META_flags[81] := (0).to_natural_8
			regexp_inst.META_flags[82] := (0).to_natural_8
			regexp_inst.META_flags[83] := (1).to_natural_8
			regexp_inst.META_flags[84] := (0).to_natural_8
			regexp_inst.META_flags[85] := (1).to_natural_8
			regexp_inst.META_flags[86] := (1).to_natural_8
			regexp_inst.META_flags[87] := (1).to_natural_8
			regexp_inst.META_flags[88] := (1).to_natural_8
			regexp_inst.META_flags[89] := (0).to_natural_8
			regexp_inst.META_flags[90] := (1).to_natural_8
			regexp_inst.META_flags[91] := (1).to_natural_8
			regexp_inst.META_flags[92] := (0).to_natural_8
			regexp_inst.META_flags[93] := (0).to_natural_8
			regexp_inst.META_flags[94] := (0).to_natural_8
			regexp_inst.META_flags[95] := (1).to_natural_8
			regexp_inst.META_flags[96] := (0).to_natural_8
			regexp_inst.META_flags[97] := (1).to_natural_8
			regexp_inst.META_flags[98] := (0).to_natural_8
			regexp_inst.META_flags[99] := (1).to_natural_8
			regexp_inst.META_flags[100] := (1).to_natural_8
			regexp_inst.META_flags[101] := (0).to_natural_8
			regexp_inst.META_flags[102] := (1).to_natural_8
			regexp_inst.META_flags[103] := (0).to_natural_8
			regexp_inst.META_flags[104] := (1).to_natural_8
			regexp_inst.META_flags[105] := (1).to_natural_8
			regexp_inst.META_flags[106] := (0).to_natural_8
			regexp_inst.META_flags[107] := (1).to_natural_8
			regexp_inst.META_flags[108] := (1).to_natural_8
			regexp_inst.META_flags[109] := (1).to_natural_8
			regexp_inst.META_flags[110] := (1).to_natural_8
			regexp_inst.META_flags[111] := (1).to_natural_8
			regexp_inst.META_flags[112] := (1).to_natural_8
			regexp_inst.META_flags[113] := (0).to_natural_8
			regexp_inst.META_flags[114] := (0).to_natural_8
			regexp_inst.META_flags[115] := (1).to_natural_8
			regexp_inst.META_flags[116] := (0).to_natural_8
			regexp_inst.META_flags[117] := (1).to_natural_8
			regexp_inst.META_flags[118] := (1).to_natural_8
			regexp_inst.META_flags[119] := (1).to_natural_8
			regexp_inst.META_flags[120] := (1).to_natural_8
			regexp_inst.META_flags[121] := (0).to_natural_8
			regexp_inst.META_flags[122] := (1).to_natural_8
			regexp_inst.META_flags[123] := (1).to_natural_8
			regexp_inst.META_flags[124] := (1).to_natural_8
			regexp_inst.META_flags[125] := (0).to_natural_8
			regexp_inst.META_flags[126] := (1).to_natural_8
			regexp_inst.classchars := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".iIkKfFpPsSdDxXoOwWhHaAlLuU"))
			regexp_inst.classcodes[0] := 20
			regexp_inst.classcodes[1] := 23
			regexp_inst.classcodes[2] := 24
			regexp_inst.classcodes[3] := 25
			regexp_inst.classcodes[4] := 26
			regexp_inst.classcodes[5] := 27
			regexp_inst.classcodes[6] := 28
			regexp_inst.classcodes[7] := 29
			regexp_inst.classcodes[8] := 30
			regexp_inst.classcodes[9] := 31
			regexp_inst.classcodes[10] := 32
			regexp_inst.classcodes[11] := 33
			regexp_inst.classcodes[12] := 34
			regexp_inst.classcodes[13] := 35
			regexp_inst.classcodes[14] := 36
			regexp_inst.classcodes[15] := 37
			regexp_inst.classcodes[16] := 38
			regexp_inst.classcodes[17] := 39
			regexp_inst.classcodes[18] := 40
			regexp_inst.classcodes[19] := 41
			regexp_inst.classcodes[20] := 42
			regexp_inst.classcodes[21] := 43
			regexp_inst.classcodes[22] := 44
			regexp_inst.classcodes[23] := 45
			regexp_inst.classcodes[24] := 46
			regexp_inst.classcodes[25] := 47
			regexp_inst.classcodes[26] := 48
			regexp_inst.after_slash := 0
			regexp_inst.need_clear_zsubexpr := 0
			regexp_inst.reg_tofree := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			regexp_inst.reg_startp := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			regexp_inst.reg_endp := create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)
			regexp_inst.reg_startpos := create {CE_POINTER [PD_LPOS_T]}.make_shared (default_pointer)
			regexp_inst.reg_endpos := create {CE_POINTER [PD_LPOS_T]}.make_shared (default_pointer)
			regexp_inst.regstack[0].ga_len := 0
			regexp_inst.regstack[0].ga_maxlen := 0
			regexp_inst.regstack[0].ga_itemsize := 0
			regexp_inst.regstack[0].ga_growsize := 0
			regexp_inst.regstack[0].ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			regexp_inst.backpos[0].ga_len := 0
			regexp_inst.backpos[0].ga_maxlen := 0
			regexp_inst.backpos[0].ga_itemsize := 0
			regexp_inst.backpos[0].ga_growsize := 0
			regexp_inst.backpos[0].ga_data := create {CE_POINTER [ANY]}.make_shared (default_pointer)
			regexp_inst.decomp_table[0].a := 1_506
			regexp_inst.decomp_table[0].b := 0
			regexp_inst.decomp_table[0].c := 0
			regexp_inst.decomp_table[1].a := 1_488
			regexp_inst.decomp_table[1].b := 0
			regexp_inst.decomp_table[1].c := 0
			regexp_inst.decomp_table[2].a := 1_491
			regexp_inst.decomp_table[2].b := 0
			regexp_inst.decomp_table[2].c := 0
			regexp_inst.decomp_table[3].a := 1_492
			regexp_inst.decomp_table[3].b := 0
			regexp_inst.decomp_table[3].c := 0
			regexp_inst.decomp_table[4].a := 1_499
			regexp_inst.decomp_table[4].b := 0
			regexp_inst.decomp_table[4].c := 0
			regexp_inst.decomp_table[5].a := 1_500
			regexp_inst.decomp_table[5].b := 0
			regexp_inst.decomp_table[5].c := 0
			regexp_inst.decomp_table[6].a := 1_501
			regexp_inst.decomp_table[6].b := 0
			regexp_inst.decomp_table[6].c := 0
			regexp_inst.decomp_table[7].a := 1_512
			regexp_inst.decomp_table[7].b := 0
			regexp_inst.decomp_table[7].c := 0
			regexp_inst.decomp_table[8].a := 1_514
			regexp_inst.decomp_table[8].b := 0
			regexp_inst.decomp_table[8].c := 0
			regexp_inst.decomp_table[9].a := ('+').code
			regexp_inst.decomp_table[9].b := 0
			regexp_inst.decomp_table[9].c := 0
			regexp_inst.decomp_table[10].a := 1_513
			regexp_inst.decomp_table[10].b := 1_473
			regexp_inst.decomp_table[10].c := 0
			regexp_inst.decomp_table[11].a := 1_513
			regexp_inst.decomp_table[11].b := 1_474
			regexp_inst.decomp_table[11].c := 0
			regexp_inst.decomp_table[12].a := 1_513
			regexp_inst.decomp_table[12].b := 1_473
			regexp_inst.decomp_table[12].c := 1_468
			regexp_inst.decomp_table[13].a := 1_513
			regexp_inst.decomp_table[13].b := 1_474
			regexp_inst.decomp_table[13].c := 1_468
			regexp_inst.decomp_table[14].a := 1_488
			regexp_inst.decomp_table[14].b := 1_463
			regexp_inst.decomp_table[14].c := 0
			regexp_inst.decomp_table[15].a := 1_488
			regexp_inst.decomp_table[15].b := 1_464
			regexp_inst.decomp_table[15].c := 0
			regexp_inst.decomp_table[16].a := 1_488
			regexp_inst.decomp_table[16].b := 1_460
			regexp_inst.decomp_table[16].c := 0
			regexp_inst.decomp_table[17].a := 1_489
			regexp_inst.decomp_table[17].b := 1_468
			regexp_inst.decomp_table[17].c := 0
			regexp_inst.decomp_table[18].a := 1_490
			regexp_inst.decomp_table[18].b := 1_468
			regexp_inst.decomp_table[18].c := 0
			regexp_inst.decomp_table[19].a := 1_491
			regexp_inst.decomp_table[19].b := 1_468
			regexp_inst.decomp_table[19].c := 0
			regexp_inst.decomp_table[20].a := 1_492
			regexp_inst.decomp_table[20].b := 1_468
			regexp_inst.decomp_table[20].c := 0
			regexp_inst.decomp_table[21].a := 1_493
			regexp_inst.decomp_table[21].b := 1_468
			regexp_inst.decomp_table[21].c := 0
			regexp_inst.decomp_table[22].a := 1_494
			regexp_inst.decomp_table[22].b := 1_468
			regexp_inst.decomp_table[22].c := 0
			regexp_inst.decomp_table[23].a := 64_311
			regexp_inst.decomp_table[23].b := 0
			regexp_inst.decomp_table[23].c := 0
			regexp_inst.decomp_table[24].a := 1_496
			regexp_inst.decomp_table[24].b := 1_468
			regexp_inst.decomp_table[24].c := 0
			regexp_inst.decomp_table[25].a := 1_497
			regexp_inst.decomp_table[25].b := 1_468
			regexp_inst.decomp_table[25].c := 0
			regexp_inst.decomp_table[26].a := 1_498
			regexp_inst.decomp_table[26].b := 1_468
			regexp_inst.decomp_table[26].c := 0
			regexp_inst.decomp_table[27].a := 1_499
			regexp_inst.decomp_table[27].b := 1_468
			regexp_inst.decomp_table[27].c := 0
			regexp_inst.decomp_table[28].a := 1_500
			regexp_inst.decomp_table[28].b := 1_468
			regexp_inst.decomp_table[28].c := 0
			regexp_inst.decomp_table[29].a := 64_317
			regexp_inst.decomp_table[29].b := 0
			regexp_inst.decomp_table[29].c := 0
			regexp_inst.decomp_table[30].a := 1_502
			regexp_inst.decomp_table[30].b := 1_468
			regexp_inst.decomp_table[30].c := 0
			regexp_inst.decomp_table[31].a := 64_319
			regexp_inst.decomp_table[31].b := 0
			regexp_inst.decomp_table[31].c := 0
			regexp_inst.decomp_table[32].a := 1_504
			regexp_inst.decomp_table[32].b := 1_468
			regexp_inst.decomp_table[32].c := 0
			regexp_inst.decomp_table[33].a := 1_505
			regexp_inst.decomp_table[33].b := 1_468
			regexp_inst.decomp_table[33].c := 0
			regexp_inst.decomp_table[34].a := 64_322
			regexp_inst.decomp_table[34].b := 0
			regexp_inst.decomp_table[34].c := 0
			regexp_inst.decomp_table[35].a := 1_507
			regexp_inst.decomp_table[35].b := 1_468
			regexp_inst.decomp_table[35].c := 0
			regexp_inst.decomp_table[36].a := 1_508
			regexp_inst.decomp_table[36].b := 1_468
			regexp_inst.decomp_table[36].c := 0
			regexp_inst.decomp_table[37].a := 64_325
			regexp_inst.decomp_table[37].b := 0
			regexp_inst.decomp_table[37].c := 0
			regexp_inst.decomp_table[38].a := 1_510
			regexp_inst.decomp_table[38].b := 1_468
			regexp_inst.decomp_table[38].c := 0
			regexp_inst.decomp_table[39].a := 1_511
			regexp_inst.decomp_table[39].b := 1_468
			regexp_inst.decomp_table[39].c := 0
			regexp_inst.decomp_table[40].a := 1_512
			regexp_inst.decomp_table[40].b := 1_468
			regexp_inst.decomp_table[40].c := 0
			regexp_inst.decomp_table[41].a := 1_513
			regexp_inst.decomp_table[41].b := 1_468
			regexp_inst.decomp_table[41].c := 0
			regexp_inst.decomp_table[42].a := 1_514
			regexp_inst.decomp_table[42].b := 1_468
			regexp_inst.decomp_table[42].c := 0
			regexp_inst.decomp_table[43].a := 1_493
			regexp_inst.decomp_table[43].b := 1_465
			regexp_inst.decomp_table[43].c := 0
			regexp_inst.decomp_table[44].a := 1_489
			regexp_inst.decomp_table[44].b := 1_471
			regexp_inst.decomp_table[44].c := 0
			regexp_inst.decomp_table[45].a := 1_499
			regexp_inst.decomp_table[45].b := 1_471
			regexp_inst.decomp_table[45].c := 0
			regexp_inst.decomp_table[46].a := 1_508
			regexp_inst.decomp_table[46].b := 1_471
			regexp_inst.decomp_table[46].c := 0
			regexp_inst.decomp_table[47].a := 1_488
			regexp_inst.decomp_table[47].b := 1_500
			regexp_inst.decomp_table[47].c := 0
			regexp_inst.can_f_submatch := 0
			regexp_inst.eval_result := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			screen_inst.screen_attr := 0
			screen_inst.screen_char_attr := 0
			screen_inst.did_intro := 0
			screen_inst.recursive___4 := 0
			screen_inst.at_end_str := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (""))
			screen_inst.checked_lnum := (0).to_integer_32
			screen_inst.checked_col := 0
			screen_inst.cap_col[0] := -1
			screen_inst.capcol_lnum := (0).to_integer_32
			screen_inst.first_match := 0
			screen_inst.busy___1 := 0
			screen_inst.entered___3 := 0
			screen_inst.entered___4 := 0
			screen_inst.done_outofmem_msg := 0
			search_inst.spats[0].pat := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			search_inst.spats[0].magic := 1
			search_inst.spats[0].no_scs := 0
			search_inst.spats[0].off.dir := ('/').code
			search_inst.spats[0].off.line := 0
			search_inst.spats[0].off.end2 := 0
			search_inst.spats[0].off.off := 0
			search_inst.spats[1].pat := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			search_inst.spats[1].magic := 1
			search_inst.spats[1].no_scs := 0
			search_inst.spats[1].off.dir := ('/').code
			search_inst.spats[1].off.line := 0
			search_inst.spats[1].off.end2 := 0
			search_inst.spats[1].off.off := 0
			search_inst.last_idx := 0
			search_inst.saved_last_idx := 0
			search_inst.saved_no_hlsearch := 0
			search_inst.mr_pattern := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			search_inst.save_level___0 := 0
			search_inst.lastc := ('%/0/').code
			search_inst.bytelen := 1
			search_inst.hlsearch_on := 0
			sha256_inst.sha256_padding[0] := (128).to_natural_8
			sha256_inst.sha256_padding[1] := (0).to_natural_8
			sha256_inst.sha256_padding[2] := (0).to_natural_8
			sha256_inst.sha256_padding[3] := (0).to_natural_8
			sha256_inst.sha256_padding[4] := (0).to_natural_8
			sha256_inst.sha256_padding[5] := (0).to_natural_8
			sha256_inst.sha256_padding[6] := (0).to_natural_8
			sha256_inst.sha256_padding[7] := (0).to_natural_8
			sha256_inst.sha256_padding[8] := (0).to_natural_8
			sha256_inst.sha256_padding[9] := (0).to_natural_8
			sha256_inst.sha256_padding[10] := (0).to_natural_8
			sha256_inst.sha256_padding[11] := (0).to_natural_8
			sha256_inst.sha256_padding[12] := (0).to_natural_8
			sha256_inst.sha256_padding[13] := (0).to_natural_8
			sha256_inst.sha256_padding[14] := (0).to_natural_8
			sha256_inst.sha256_padding[15] := (0).to_natural_8
			sha256_inst.sha256_padding[16] := (0).to_natural_8
			sha256_inst.sha256_padding[17] := (0).to_natural_8
			sha256_inst.sha256_padding[18] := (0).to_natural_8
			sha256_inst.sha256_padding[19] := (0).to_natural_8
			sha256_inst.sha256_padding[20] := (0).to_natural_8
			sha256_inst.sha256_padding[21] := (0).to_natural_8
			sha256_inst.sha256_padding[22] := (0).to_natural_8
			sha256_inst.sha256_padding[23] := (0).to_natural_8
			sha256_inst.sha256_padding[24] := (0).to_natural_8
			sha256_inst.sha256_padding[25] := (0).to_natural_8
			sha256_inst.sha256_padding[26] := (0).to_natural_8
			sha256_inst.sha256_padding[27] := (0).to_natural_8
			sha256_inst.sha256_padding[28] := (0).to_natural_8
			sha256_inst.sha256_padding[29] := (0).to_natural_8
			sha256_inst.sha256_padding[30] := (0).to_natural_8
			sha256_inst.sha256_padding[31] := (0).to_natural_8
			sha256_inst.sha256_padding[32] := (0).to_natural_8
			sha256_inst.sha256_padding[33] := (0).to_natural_8
			sha256_inst.sha256_padding[34] := (0).to_natural_8
			sha256_inst.sha256_padding[35] := (0).to_natural_8
			sha256_inst.sha256_padding[36] := (0).to_natural_8
			sha256_inst.sha256_padding[37] := (0).to_natural_8
			sha256_inst.sha256_padding[38] := (0).to_natural_8
			sha256_inst.sha256_padding[39] := (0).to_natural_8
			sha256_inst.sha256_padding[40] := (0).to_natural_8
			sha256_inst.sha256_padding[41] := (0).to_natural_8
			sha256_inst.sha256_padding[42] := (0).to_natural_8
			sha256_inst.sha256_padding[43] := (0).to_natural_8
			sha256_inst.sha256_padding[44] := (0).to_natural_8
			sha256_inst.sha256_padding[45] := (0).to_natural_8
			sha256_inst.sha256_padding[46] := (0).to_natural_8
			sha256_inst.sha256_padding[47] := (0).to_natural_8
			sha256_inst.sha256_padding[48] := (0).to_natural_8
			sha256_inst.sha256_padding[49] := (0).to_natural_8
			sha256_inst.sha256_padding[50] := (0).to_natural_8
			sha256_inst.sha256_padding[51] := (0).to_natural_8
			sha256_inst.sha256_padding[52] := (0).to_natural_8
			sha256_inst.sha256_padding[53] := (0).to_natural_8
			sha256_inst.sha256_padding[54] := (0).to_natural_8
			sha256_inst.sha256_padding[55] := (0).to_natural_8
			sha256_inst.sha256_padding[56] := (0).to_natural_8
			sha256_inst.sha256_padding[57] := (0).to_natural_8
			sha256_inst.sha256_padding[58] := (0).to_natural_8
			sha256_inst.sha256_padding[59] := (0).to_natural_8
			sha256_inst.sha256_padding[60] := (0).to_natural_8
			sha256_inst.sha256_padding[61] := (0).to_natural_8
			sha256_inst.sha256_padding[62] := (0).to_natural_8
			sha256_inst.sha256_padding[63] := (0).to_natural_8
			sha256_inst.sha_self_test_msg[0] := ce_string ("abc")
			sha256_inst.sha_self_test_msg[1] := ce_string ("abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq")
			sha256_inst.sha_self_test_msg[2] := create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)
			sha256_inst.sha_self_test_vector[0] := ce_string ("ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad")
			sha256_inst.sha_self_test_vector[1] := ce_string ("248d6a61d20638b8e5c026930c3e6039a33ce45964ff2167f6ecedd419db06c1")
			sha256_inst.sha_self_test_vector[2] := ce_string ("cdc76e5c9914fb9281a1c7e284d73e67f1809a48a497200e046d39ccc7112cd0")
			sha256_inst.failures := 0
			sha256_inst.sha256_self_tested := 0
			spell_inst.first_lang := create {CE_POINTER [PD_SLANG_S]}.make_shared (default_pointer)
			spell_inst.int_wordlist := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			spell_inst.e_format := ce_string ("E759: Format error in spell file")
			spell_inst.e_spell_trunc := ce_string ("E758: Truncated spell file")
			spell_inst.e_afftrailing := ce_string ("Trailing text in %%s line %%d: %%s")
			spell_inst.e_affname := ce_string ("Affix name too long in %%s line %%d: %%s")
			spell_inst.e_affform := ce_string ("E761: Format error in affix file FOL, LOW or UPP")
			spell_inst.e_affrange := ce_string ("E762: Character in FOL, LOW or UPP is out of range")
			spell_inst.msg_compressing := ce_string ("Compressing word tree...")
			spell_inst.repl_from := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			spell_inst.repl_to := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			spell_inst.recursive___5 := 0
			spell_inst.compress_start := 30_000
			spell_inst.compress_inc := 100
			spell_inst.compress_added := 500_000
			spell_inst.sps_flags := 1
			spell_inst.sps_limit := 9_999
			spell_inst.expr_busy := 0
			syntax_inst.include_none := 0
			syntax_inst.include_default := 0
			syntax_inst.include_link := 0
			syntax_inst.hl_name_table[0] := ce_string ("bold")
			syntax_inst.hl_name_table[1] := ce_string ("standout")
			syntax_inst.hl_name_table[2] := ce_string ("underline")
			syntax_inst.hl_name_table[3] := ce_string ("undercurl")
			syntax_inst.hl_name_table[4] := ce_string ("italic")
			syntax_inst.hl_name_table[5] := ce_string ("reverse")
			syntax_inst.hl_name_table[6] := ce_string ("inverse")
			syntax_inst.hl_name_table[7] := ce_string ("NONE")
			syntax_inst.hl_attr_table[0] := 2
			syntax_inst.hl_attr_table[1] := 32
			syntax_inst.hl_attr_table[2] := 8
		end

end
