class
	P_MAIN

inherit
	VIM_DATA
		redefine
			default_create
		end
	S_LIBIO
	S_STDIO
	S_CTYPE
	S_SYS_STAT
	S_STDLIB
	S_STRING
	S_LIBINTL
	S_WCTYPE
	S_UNISTD
	S_TIME
	S_FCNTL
	S_MATH
	S_SYS_TIME
	S_LOCALE
	S_BITS_ERRNO
	S_ICONV
	S_UTIME
	S_GLIB_OBJECT
	S_GTK_GTK
	S_SYS_SELECT
	S_X11_XLIB
	S_SIGNAL
	S_DIRENT
	S_PWD
	S_GLIB
	S_PANGO_PANGO
	S_GDK_GDK
	S_LANGINFO
	S_X11_XUTIL
	S_X11_INTRINSIC
	S_SYS_IOCTL
	S_SYS_RESOURCE
	S_SYS_WAIT
	S_SYS_UTSNAME
	S_TERMIOS
	S_DLFCN
	S_X11_ICE_ICELIB
	S_X11_SM_SMLIB
	S_X11_SHELL
	S_X11_STRINGDEFS
	S_SYS_SYSINFO
	S_TERMCAP
	S_TERM
	S_GDK_PIXBUF_GDK_PIXBUF
	S_SYS_SOCKET
	S_NETINET_IN
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create main_errors.make (<<6>>)
			create prev_timeval.make (<<1>>)
			create start.make (<<1>>)
			create use.make (<<4>>)
		end

feature {ANY} -- attributes

	main_errors: CE_ARRAY [CE_POINTER [INTEGER_8]]

	prev_timeval: CE_ARRAY [SD_TIMEVAL]

	start: CE_ARRAY [SD_TIMEVAL]

	use: CE_ARRAY [CE_POINTER [INTEGER_8]]

feature {ANY} -- routines

	build_drop_cmd (a_filec: INTEGER_32; a_filev: CE_POINTER [CE_POINTER [INTEGER_8]]; a_tabs: INTEGER_32; a_sendReply: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_filec: INTEGER_32
			l_filev: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_ga: CE_ARRAY [PD_GROWARRAY]
			l_i___0: INTEGER_32
			l_inicmd: CE_POINTER [NATURAL_8]
			l_p___0: CE_POINTER [NATURAL_8]
			l_cwd: CE_ARRAY [NATURAL_8]
			js: JUMP_STATE
		do
			create l_filev.make
			create l_ga.make (<<1>>)
			create l_inicmd.make
			create l_p___0.make
			create l_cwd.make (<<4_096>>)

			l_filec := a_filec
			l_filev := a_filev
			l_inicmd := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if l_filec > 0 then
				if ((l_filev[0])[0]).to_integer_32 = 43 then
					l_inicmd := create {CE_POINTER [NATURAL_8]}.make_cast (l_filev[0]) + 1
					l_filev := l_filev + 1
					l_filec := l_filec - 1
				end
			end
			if l_filec <= 0 then
				mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (l_filev[-1]))
			end
			if (os_unix_inst.mch_dirname (l_cwd, 4_096)) /= 1 then
				Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
				js.return
			end
			if not js.return_called then
				l_p___0 := misc2_inst.vim_strsave_escaped_ext (l_cwd, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<")), ('\').code, 1)
				if l_p___0.is_void then
					Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					js.return
				end
			end
			if not js.return_called then
				misc2_inst.ga_init2 (l_ga, 1, 100)
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<C-\><C-N>:cd ")))
				misc2_inst.ga_concat (l_ga, l_p___0)
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<CR>:if exists(%'*inputsave%')|call inputsave()|endif|")))
				if a_tabs.to_boolean then
					misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("tab ")))
				end
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("drop")))
				l_i___0 := 0
				from
				until
					not (not js.loop_done and then (l_i___0 < l_filec))
				loop
					l_p___0 := misc2_inst.vim_strsave_escaped (create {CE_POINTER [NATURAL_8]}.make_cast (l_filev[l_i___0]), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" %T%N*?[{`$\%%#%'%"|!<")))
					if l_p___0.is_void then
						misc2_inst.vim_free (l_ga.item.ga_data)
						Result := (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						js.return
					end
					if not js.return_called then
						misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (" ")))
						misc2_inst.ga_concat (l_ga, l_p___0)
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						l_i___0 := l_i___0 + 1
					end
				end
			end
			if not js.return_called then
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("|if exists(%'*inputrestore%')|call inputrestore()|endif<CR>")))
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<C-\><C-N>:cd -")))
				if a_sendReply.to_boolean then
					misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<CR>:call SetupRemoteReplies()")))
				end
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("<CR>:")))
				if not l_inicmd.is_void then
					misc2_inst.ga_concat (l_ga, l_inicmd)
					misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("|")))
				end
				misc2_inst.ga_concat (l_ga, create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("cal foreground()|if &im|star|en|redr|f<CR>")))
				misc2_inst.ga_append (l_ga, ('%/0/').code)
				Result := (create {CE_POINTER [NATURAL_8]}.make_cast (l_ga.item.ga_data))
			end
		end

	check_swap_exists_action
		do
			if globals_inst.swap_exists_action = 2 then
				getout (1)
			end
			buffer_inst.handle_swap_exists (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
		end

	check_tty (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_input_isatty: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_input_isatty := os_unix_inst.mch_input_isatty
					if not (globals_inst.exmode_active.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if not l_input_isatty.to_boolean then
							globals_inst.silent_mode := 1
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 3 then -- else:
						if not ((a_parmp.item.want_full_screen).to_boolean) then
							l_pos := -1 + 9 -- skip if block
						end
				when 4 then -- if:
						if (a_parmp.item.stdout_isatty).to_boolean then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if:
						l_pos := -1 + 8 -- goto _L
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 7 then -- else:
						if l_input_isatty.to_boolean then
							l_pos := -1 + 9 -- skip if block
						end
				when 8 then -- if: | _L:
						if not (gui_inst.gui.item.starting).to_boolean then
							if not (a_parmp.item.stdout_isatty).to_boolean then
								message_inst.mch_errmsg ((gettext (ce_string ("Vim: Warning: Output is not to a terminal%N"))))
							end
							if not l_input_isatty.to_boolean then
								message_inst.mch_errmsg ((gettext (ce_string ("Vim: Warning: Input is not from a terminal%N"))))
							end
							term_inst.out_flush
							if (globals_inst.scriptin[0]).is_void then
								ui_inst.ui_delay (2_000, 1)
							end
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("Warning delay"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
						end
				when 9 then -- if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	cmdsrv_main (a_argc: CE_POINTER [INTEGER_32]; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]; a_serverName_arg: CE_POINTER [NATURAL_8]; a_serverStr: CE_POINTER [CE_POINTER [NATURAL_8]])
		local
			l_res: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_i___0: INTEGER_32
			l_sname: CE_POINTER [NATURAL_8]
			l_ret: INTEGER_32
			l_didone: INTEGER_32
			l_exiterr: INTEGER_32
			l_newArgV: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_newArgC: INTEGER_32
			l_Argc: INTEGER_32
			l_argtype: INTEGER_32
			l_silent: INTEGER_32
			l_tabs: INTEGER_32
			l_srv: CE_ARRAY [NATURAL_32]
			l_tmp: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_p___0: CE_POINTER [INTEGER_8]
			l_numFiles: INTEGER_32
			l_j: INTEGER_32
			l_done___2: CE_POINTER [NATURAL_8]
			l_p___1: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_tmp___15: CE_POINTER [CE_POINTER [INTEGER_8]]
			js: JUMP_STATE
		do
			create l_res.make (<<1>>)
			create l_sname.make
			create l_newArgV.make
			create l_srv.make (<<1>>)
			create l_tmp.make
			create l_p___0.make
			create l_done___2.make
			create l_p___1.make (<<1>>)
			create l_tmp___15.make

			l_didone := 0
			l_exiterr := 0
			l_newArgV := a_argv + 1
			l_newArgC := 1
			l_Argc := a_argc.item
			l_silent := 0
			l_tabs := 0
			os_unix_inst.setup_term_clip
			l_sname := serverMakeName (a_serverName_arg, a_argv[0])
			if l_sname.is_void then
				js.return
			end
			if not js.return_called then
				l_i___0 := 1
				from
				until
					not (not js.loop_done and then (l_i___0 < l_Argc))
				loop
					l_res.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					if (strcmp (a_argv[l_i___0], ce_string ("--"))) = 0 then
						from
						until
							not (l_i___0 < a_argc.item)
						loop
							l_tmp := l_newArgV
							l_newArgV := l_newArgV + 1
							l_tmp.item := a_argv[l_i___0]
							l_newArgC := l_newArgC + 1
							l_i___0 := l_i___0 + 1
						end
						js.break
					end
					if not js.loop_jumped then
						if (strcasecmp (a_argv[l_i___0], ce_string ("--remote-send"))) = 0 then
							l_argtype := 3
						elseif (strncasecmp (a_argv[l_i___0], ce_string ("--remote"), (8).to_natural_32)) = 0 then
							l_p___0 := a_argv[l_i___0] + 8
							l_argtype := 1
							from
							until
								not (not js.loop_done and then ((l_p___0[0]).to_integer_32 /= 0))
							loop
								if (strncasecmp (l_p___0, ce_string ("-wait"), (5).to_natural_32)) = 0 then
									l_argtype := 2
									l_p___0 := l_p___0 + (5)
								elseif (strncasecmp (l_p___0, ce_string ("-silent"), (7).to_natural_32)) = 0 then
									l_silent := 1
									l_p___0 := l_p___0 + (7)
								elseif (strncasecmp (l_p___0, ce_string ("-tab"), (4).to_natural_32)) = 0 then
									l_tabs := 1
									l_p___0 := l_p___0 + (4)
								else
									l_argtype := 0
									js.break
								end
							end
						else
							l_argtype := 0
						end
						if l_argtype /= 0 then
							if l_i___0 = a_argc.item - 1 then
								mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (a_argv[l_i___0]))
							end
							if l_argtype = 3 then
								a_serverStr.item := create {CE_POINTER [NATURAL_8]}.make_cast (a_argv[(l_i___0 + 1)])
								l_i___0 := l_i___0 + 1
							else
								a_serverStr.item := build_drop_cmd ((a_argc.item - l_i___0) - 1, (a_argv + l_i___0) + 1, l_tabs, (l_argtype = 2).to_integer)
								if (a_serverStr.item).is_void then
									l_didone := 1
									l_exiterr := 1
									js.break
								end
								if not js.loop_jumped then
									l_Argc := l_i___0
								end
							end
							if not js.loop_jumped then
								if (globals_inst.xterm_dpy.item).is_void then
									message_inst.mch_errmsg ((gettext (ce_string ("No display"))))
									l_ret := -1
								else
									l_ret := if_xcmdsrv_inst.serverSendToVim (globals_inst.xterm_dpy.item, l_sname, a_serverStr.item, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), l_srv, 0, 0, l_silent)
								end
								if l_ret < 0 then
									if l_argtype = 3 then
										message_inst.mch_errmsg ((gettext (ce_string (": Send failed.%N"))))
										l_didone := 1
										l_exiterr := 1
									elseif not l_silent.to_boolean then
										message_inst.mch_errmsg ((gettext (ce_string (": Send failed. Trying to execute locally%N"))))
									end
									js.break
								end
							end
							if not js.loop_jumped and then (l_ret >= 0) then
								if l_argtype = 2 then
									l_numFiles := (a_argc.item - l_i___0) - 1
									l_done___2 := (misc2_inst.alloc (l_numFiles.to_natural_32))
									if l_numFiles > 0 then
										if ((a_argv[(l_i___0 + 1)])[0]).to_integer_32 = 43 then
											l_numFiles := l_numFiles - 1
										end
									end
									memset (create {CE_POINTER [ANY]}.make_cast (l_done___2), 0, l_numFiles.to_natural_32).do_nothing
									from
									until
										js.loop_done
									loop
										if (memchr (create {CE_POINTER [ANY]}.make_cast (l_done___2), 0, l_numFiles.to_natural_32)).is_void then
											js.break
										end
										if not js.loop_jumped then
											if (if_xcmdsrv_inst.serverReadReply (globals_inst.xterm_dpy.item, l_srv.item, l_p___1, 1)) < 0 then
												js.break
											end
										end
										if not js.loop_jumped then
											l_j := atoi (create {CE_POINTER [INTEGER_8]}.make_cast (l_p___1.item))
											if l_j >= 0 then
												if l_j < l_numFiles then
													l_done___2[l_j] := (1).to_natural_8
												end
											end
										end
									end
								end
							end
						elseif (strcasecmp (a_argv[l_i___0], ce_string ("--remote-expr"))) = 0 then
							if l_i___0 = a_argc.item - 1 then
								mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (a_argv[l_i___0]))
							end
							if (globals_inst.xterm_dpy.item).is_void then
								message_inst.mch_errmsg ((gettext (ce_string ("No display: Send expression failed.%N"))))
							elseif (if_xcmdsrv_inst.serverSendToVim (globals_inst.xterm_dpy.item, l_sname, create {CE_POINTER [NATURAL_8]}.make_cast (a_argv[(l_i___0 + 1)]), l_res, create {CE_POINTER [NATURAL_32]}.make_shared (default_pointer), 1, 1, 0)) < 0 then
								if not (l_res.item).is_void then
									if (l_res.item.item).to_integer_32 /= 0 then
										message_inst.mch_errmsg (create {CE_POINTER [INTEGER_8]}.make_cast (l_res.item))
										misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_res.item))
										l_res.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
									end
								end
								message_inst.mch_errmsg ((gettext (ce_string (": Send expression failed.%N"))))
							end
						elseif (strcasecmp (a_argv[l_i___0], ce_string ("--serverlist"))) = 0 then
							if not (globals_inst.xterm_dpy.item).is_void then
								l_res.item := if_xcmdsrv_inst.serverGetVimNames (globals_inst.xterm_dpy.item)
							end
							if globals_inst.called_emsg.to_boolean then
								message_inst.mch_errmsg (ce_string ("%N"))
							end
						elseif (strcasecmp (a_argv[l_i___0], ce_string ("--servername"))) = 0 then
							l_i___0 := l_i___0 + 1
							js.continue
						else
							l_tmp___15 := l_newArgV
							l_newArgV := l_newArgV + 1
							l_tmp___15.item := a_argv[l_i___0]
							l_newArgC := l_newArgC + 1
							js.continue
						end
					end
					if not js.loop_jumped then
						l_didone := 1
						if not (l_res.item).is_void then
							if (l_res.item.item).to_integer_32 /= 0 then
								message_inst.mch_msg (create {CE_POINTER [INTEGER_8]}.make_cast (l_res.item))
								if (l_res.item[((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (l_res.item))) - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 10 then
									message_inst.mch_msg (ce_string ("%N"))
								end
							end
						end
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_res.item))
					end
					if js.loop_increment then
						l_i___0 := l_i___0 + 1
					end
				end
				if l_didone.to_boolean then
					gui_inst.display_errors
					exit (l_exiterr)
				end
				a_argc.item := l_newArgC
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_sname))
			end
		end

	command_line_scan (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_argv_idx: CE_ARRAY [INTEGER_32]
			l_had_minmin: INTEGER_32
			l_want_argument: INTEGER_32
			l_c: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_n: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___21: INTEGER_32
			l_a: CE_POINTER [INTEGER_8]
			l_tmp___23: INTEGER_32
			l_tmp___24: INTEGER_32
			l_tmp___25: INTEGER_32
			l_tmp___33: CE_POINTER [INTEGER_8]
			l_r: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_argv.make
			create l_argv_idx.make (<<1>>)
			create l_p___0.make
			create l_a.make
			create l_tmp___33.make
			create l_r.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := a_parmp.item.argc
					l_argv := a_parmp.item.argv
					l_had_minmin := 0
					l_p___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					l_argc := l_argc - 1
					l_argv := l_argv + 1
					l_argv_idx.item := 1
				when 1 then -- loop condition:
					if not (l_argc > 0) then
						l_pos := -1 + 94 -- skip loop
					end
				when 2 then -- loop body:
						if ((l_argv[0])[0]).to_integer_32 /= 43 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if not l_had_minmin.to_boolean then
							if a_parmp.item.n_commands >= 10 then
								mainerr (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							l_argv_idx.item := -1
							if ((l_argv[0])[1]).to_integer_32 = 0 then
								l_tmp := a_parmp.item.n_commands
								a_parmp.item.n_commands := (a_parmp.item.n_commands) + 1
								a_parmp.item.commands[l_tmp] := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$"))
							else
								l_tmp___0 := a_parmp.item.n_commands
								a_parmp.item.n_commands := (a_parmp.item.n_commands) + 1
								a_parmp.item.commands[l_tmp___0] := create {CE_POINTER [NATURAL_8]}.make_cast ((l_argv[0] + 1))
							end
						else
							l_pos := -1 + 5 -- goto _L___1
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 93
				when 5 then -- else: | _L___1:
						if ((l_argv[0])[0]).to_integer_32 /= 45 then
							l_pos := -1 + 92 -- skip if block
						end
				when 6 then -- if:
						if l_had_minmin.to_boolean then
							l_pos := -1 + 90 -- skip if block
						end
				when 7 then -- if:
						l_want_argument := 0
						l_tmp___1 := l_argv_idx.item
						l_argv_idx.item := l_argv_idx.item + 1
						l_c := ((l_argv[0])[l_tmp___1]).to_integer_32
						inspect l_c -- switch 1 head
						when 0 then l_pos := -1 + 8
						when 45 then l_pos := -1 + 9
						when 65 then l_pos := -1 + 37
						when 98 then l_pos := -1 + 38
						when 67 then l_pos := -1 + 39
						when 101 then l_pos := -1 + 40
						when 69 then l_pos := -1 + 41
						when 102 then l_pos := -1 + 42
						when 103 then l_pos := -1 + 43
						when 70 then l_pos := -1 + 44
						when 104 then l_pos := -1 + 45
						when 72 then l_pos := -1 + 46
						when 108 then l_pos := -1 + 47
						when 77 then l_pos := -1 + 48
						when 109 then l_pos := -1 + 49
						when 121 then l_pos := -1 + 50
						when 78 then l_pos := -1 + 51
						when 110 then l_pos := -1 + 52
						when 112 then l_pos := -1 + 53
						when 111 then l_pos := -1 + 54
						when 79 then l_pos := -1 + 55
						when 113 then l_pos := -1 + 56
						when 82 then l_pos := -1 + 57
						when 114 then l_pos := -1 + 58
						when 76 then l_pos := -1 + 58
						when 115 then l_pos := -1 + 59
						when 116 then l_pos := -1 + 60
						when 68 then l_pos := -1 + 61
						when 100 then l_pos := -1 + 62
						when 86 then l_pos := -1 + 63
						when 118 then l_pos := -1 + 64
						when 119 then l_pos := -1 + 65
						when 120 then l_pos := -1 + 67
						when 88 then l_pos := -1 + 68
						when 90 then l_pos := -1 + 69
						when 99 then l_pos := -1 + 70
						when 83 then l_pos := -1 + 71
						when 105 then l_pos := -1 + 71
						when 84 then l_pos := -1 + 71
						when 117 then l_pos := -1 + 71
						when 85 then l_pos := -1 + 71
						when 87 then l_pos := -1 + 71
						else l_pos := -1 + 72
						end
				when 8 then -- switch 1, case 0
						if globals_inst.exmode_active.to_boolean then
							globals_inst.silent_mode := 1
						else
							if a_parmp.item.edit_type /= 0 then
								mainerr (1, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
							end
							a_parmp.item.edit_type := 2
							globals_inst.read_cmd_fd := 2
						end
						l_argv_idx.item := -1
						l_pos := -1 + 73 -- switch 1; break
				when 9 then -- switch 1, case 45
						if (strcasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("help"))) /= 0 then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						usage
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 12 then -- else:
						if (strcasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("version"))) /= 0 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						globals_inst.Columns.item := 80
						globals_inst.info_message := 1
						version_inst.list_version
						message_inst.msg_putchar (('%N').code)
						globals_inst.msg_didout := 0
						os_unix_inst.mch_exit (0)
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 15 then -- else:
						if ((strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("literal"), (7).to_natural_32)) = 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 16 then -- if:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("nofork"), (6).to_natural_32)) /= 0 then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						gui_inst.gui.item.dofork := 0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 19 then -- else:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("noplugin"), (8).to_natural_32)) /= 0 then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if:
						option_inst.p_lpl.item := 0
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 22 then -- else:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("cmd"), (3).to_natural_32)) /= 0 then
							l_pos := -1 + 25 -- skip if block
						end
				when 23 then -- if:
						l_want_argument := 1
						l_argv_idx.item := l_argv_idx.item + (3)
				when 24 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 25 then -- else:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("startuptime"), (11).to_natural_32)) /= 0 then
							l_pos := -1 + 28 -- skip if block
						end
				when 26 then -- if:
						l_want_argument := 1
						l_argv_idx.item := l_argv_idx.item + (11)
				when 27 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 28 then -- else:
						if ((strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("serverlist"), (10).to_natural_32)) = 0) then
							l_pos := -1 + 36 -- skip if block
						end
				when 29 then -- if:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("servername"), (10).to_natural_32)) /= 0 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if:
						l_pos := -1 + 33 -- goto _L
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 32 then -- else:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("serversend"), (10).to_natural_32)) /= 0 then
							l_pos := -1 + 35 -- skip if block
						end
				when 33 then -- if: | _L:
						if l_argc > 1 then
							l_argc := l_argc - 1
							l_argv := l_argv + 1
						end
				when 34 then -- if block done, skip else block:
						l_pos := -1 + 36
				when 35 then -- else:
						if (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("socketid"), (8).to_natural_32)) = 0 then
							if l_argc > 1 then
								l_argc := l_argc - 1
								l_argv := l_argv + 1
							end
						elseif (strncasecmp ((l_argv[0] + l_argv_idx.item), ce_string ("echo-wid"), (8).to_natural_32)) /= 0 then
							if ((l_argv[0])[l_argv_idx.item]).to_boolean then
								mainerr (0, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
							end
							l_had_minmin := 1
						end
				when 36 then -- if done | if done | if done | if done | if done | if done | if done | if done | if done
						if not l_want_argument.to_boolean then
							l_argv_idx.item := -1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 37 then -- switch 1, case 65
						message_inst.mch_errmsg ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_noarabic))))
						os_unix_inst.mch_exit (2)
						l_pos := -1 + 73 -- switch 1; break
				when 38 then -- switch 1, case 98
						option_inst.set_options_bin (globals_inst.curbuf.item.b_p_bin, 1, 0)
						globals_inst.curbuf.item.b_p_bin := 1
						l_pos := -1 + 73 -- switch 1; break
				when 39 then -- switch 1, case 67
						option_inst.change_compatible (1)
						l_pos := -1 + 73 -- switch 1; break
				when 40 then -- switch 1, case 101
						globals_inst.exmode_active := 1
						l_pos := -1 + 73 -- switch 1; break
				when 41 then -- switch 1, case 69
						globals_inst.exmode_active := 2
						l_pos := -1 + 73 -- switch 1; break
				when 42 then -- switch 1, case 102
						gui_inst.gui.item.dofork := 0
						l_pos := -1 + 73 -- switch 1; break
				when 43 then -- switch 1, case 103
						main_start_gui
						l_pos := -1 + 73 -- switch 1; break
				when 44 then -- switch 1, case 70
						message_inst.mch_errmsg ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nofarsi))))
						os_unix_inst.mch_exit (2)
						l_pos := -1 + 73 -- switch 1; break
				when 45 then -- switch 1, case 104
						usage
						l_pos := -1 + 73 -- switch 1; break
				when 46 then -- switch 1, case 72
						message_inst.mch_errmsg ((gettext (create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.e_nohebrew))))
						os_unix_inst.mch_exit (2)
						l_pos := -1 + 73 -- switch 1; break
				when 47 then -- switch 1, case 108
						option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("lisp")), 1, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
						option_inst.p_sm.item := 1
						l_pos := -1 + 73 -- switch 1; break
				when 48 then -- switch 1, case 77
						option_inst.reset_modifiable
				when 49 then -- switch 1, case 109
						option_inst.p_write.item := 0
						l_pos := -1 + 73 -- switch 1; break
				when 50 then -- switch 1, case 121
						gui_inst.gui.item.starting := 1
						a_parmp.item.evim_mode := 1
						l_pos := -1 + 73 -- switch 1; break
				when 51 then -- switch 1, case 78
						option_inst.change_compatible (0)
						l_pos := -1 + 73 -- switch 1; break
				when 52 then -- switch 1, case 110
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 = 98 then
							globals_inst.netbeansArg := l_argv[0]
							l_argv_idx.item := -1
						else
							a_parmp.item.no_swap_file := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 53 then -- switch 1, case 112
						a_parmp.item.window_count := get_number_arg (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]), l_argv_idx, 0)
						a_parmp.item.window_layout := 3
						l_pos := -1 + 73 -- switch 1; break
				when 54 then -- switch 1, case 111
						a_parmp.item.window_count := get_number_arg (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]), l_argv_idx, 0)
						a_parmp.item.window_layout := 1
						l_pos := -1 + 73 -- switch 1; break
				when 55 then -- switch 1, case 79
						a_parmp.item.window_count := get_number_arg (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]), l_argv_idx, 0)
						a_parmp.item.window_layout := 2
						l_pos := -1 + 73 -- switch 1; break
				when 56 then -- switch 1, case 113
						if a_parmp.item.edit_type /= 0 then
							mainerr (1, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
						end
						a_parmp.item.edit_type := 4
						if ((l_argv[0])[l_argv_idx.item]).to_boolean then
							a_parmp.item.use_ef := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]) + l_argv_idx.item
							l_argv_idx.item := -1
						elseif l_argc > 1 then
							l_want_argument := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 57 then -- switch 1, case 82
						globals_inst.readonlymode := 1
						globals_inst.curbuf.item.b_p_ro := 1
						option_inst.p_uc.item := 10_000
						l_pos := -1 + 73 -- switch 1; break
				when 58 then -- switch 1, case 114 | switch 1, case 76
						globals_inst.recoverymode := 1
						l_pos := -1 + 73 -- switch 1; break
				when 59 then -- switch 1, case 115
						if globals_inst.exmode_active.to_boolean then
							globals_inst.silent_mode := 1
						else
							l_want_argument := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 60 then -- switch 1, case 116
						if a_parmp.item.edit_type /= 0 then
							mainerr (1, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
						end
						a_parmp.item.edit_type := 3
						if ((l_argv[0])[l_argv_idx.item]).to_boolean then
							a_parmp.item.tagname := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]) + l_argv_idx.item
							l_argv_idx.item := -1
						else
							l_want_argument := 1
						end
						l_pos := -1 + 73 -- switch 1; break
				when 61 then -- switch 1, case 68
						a_parmp.item.use_debug_break_level := 9_999
						l_pos := -1 + 73 -- switch 1; break
				when 62 then -- switch 1, case 100
						a_parmp.item.diff_mode := 1
						l_pos := -1 + 73 -- switch 1; break
				when 63 then -- switch 1, case 86
						option_inst.p_verbose.item := (get_number_arg (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]), l_argv_idx, 10)).to_integer_32
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 /= 0 then
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("verbosefile")), 0, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]) + l_argv_idx.item, 0)
							l_argv_idx.item := (strlen (l_argv[0])).to_integer_32
						end
						l_pos := -1 + 73 -- switch 1; break
				when 64 then -- switch 1, case 118
						globals_inst.exmode_active := 0
						gui_inst.gui.item.starting := 0
						l_pos := -1 + 73 -- switch 1; break
				when 65 then -- switch 1, case 119
						if (charset_inst.vim_isdigit ((create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])[l_argv_idx.item]).to_integer_32)).to_boolean then
							l_n := (get_number_arg (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]), l_argv_idx, 10)).to_integer_32
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("window")), l_n, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
							l_pos := -1 + 73 -- switch 1; break
						end
				when 66 then
						l_want_argument := 1
						l_pos := -1 + 73 -- switch 1; break
				when 67 then -- switch 1, case 120
						a_parmp.item.ask_for_key := 1
						l_pos := -1 + 73 -- switch 1; break
				when 68 then -- switch 1, case 88
						globals_inst.x_no_connect := 1
						l_pos := -1 + 73 -- switch 1; break
				when 69 then -- switch 1, case 90
						globals_inst.restricted := 1
						l_pos := -1 + 73 -- switch 1; break
				when 70 then -- switch 1, case 99
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 /= 0 then
							if a_parmp.item.n_commands >= 10 then
								mainerr (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							l_tmp___21 := a_parmp.item.n_commands
							a_parmp.item.n_commands := (a_parmp.item.n_commands) + 1
							a_parmp.item.commands[l_tmp___21] := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]) + l_argv_idx.item
							l_argv_idx.item := -1
							l_pos := -1 + 73 -- switch 1; break
						end
				when 71 then -- switch 1, case 83 | switch 1, case 105 | switch 1, case 84 | switch 1, case 117 | switch 1, case 85 | switch 1, case 87
						l_want_argument := 1
						l_pos := -1 + 73 -- switch 1; break
				when 72 then -- switch 1, default:
						mainerr (0, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
				when 73 then -- switch 1, done:
						if not (l_want_argument.to_boolean) then
							l_pos := -1 + 89 -- skip if block
						end
				when 74 then -- if:
						if ((l_argv[0])[l_argv_idx.item]).to_integer_32 /= 0 then
							mainerr (3, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
						end
						l_argc := l_argc - 1
						if l_argc < 1 then
							if l_c /= 83 then
								mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
							end
						end
						l_argv := l_argv + 1
						l_argv_idx.item := -1
						inspect l_c -- switch 2 head
						when 99 then l_pos := -1 + 75
						when 83 then l_pos := -1 + 75
						when 45 then l_pos := -1 + 76
						when 113 then l_pos := -1 + 77
						when 105 then l_pos := -1 + 78
						when 115 then l_pos := -1 + 79
						when 116 then l_pos := -1 + 82
						when 84 then l_pos := -1 + 83
						when 117 then l_pos := -1 + 84
						when 85 then l_pos := -1 + 85
						when 119 then l_pos := -1 + 86
						when 87 then l_pos := -1 + 87
						else l_pos := -1 + 89
						end
				when 75 then -- switch 2, case 99 | switch 2, case 83
						if a_parmp.item.n_commands >= 10 then
							mainerr (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
						end
						if l_c = 83 then
							if l_argc < 1 then
								l_a := ce_string ("Session.vim")
							elseif ((l_argv[0])[0]).to_integer_32 = 45 then
								l_a := ce_string ("Session.vim")
								l_argc := l_argc + 1
								l_argv := l_argv - 1
							else
								l_a := l_argv[0]
							end
							l_p___0 := misc2_inst.alloc ((strlen (l_a)) + {NATURAL_32} 4)
							if l_p___0.is_void then
								os_unix_inst.mch_exit (2)
							end
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string ("so %%s"), l_a]).do_nothing
							a_parmp.item.cmds_tofree[a_parmp.item.n_commands] := (1).to_natural_8
							l_tmp___23 := a_parmp.item.n_commands
							a_parmp.item.n_commands := (a_parmp.item.n_commands) + 1
							a_parmp.item.commands[l_tmp___23] := l_p___0
						else
							l_tmp___24 := a_parmp.item.n_commands
							a_parmp.item.n_commands := (a_parmp.item.n_commands) + 1
							a_parmp.item.commands[l_tmp___24] := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						end
						l_pos := -1 + 89 -- switch 2; break
				when 76 then -- switch 2, case 45
						if ((l_argv[-1])[2]).to_integer_32 = 99 then
							if a_parmp.item.n_pre_commands >= 10 then
								mainerr (4, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
							end
							l_tmp___25 := a_parmp.item.n_pre_commands
							a_parmp.item.n_pre_commands := (a_parmp.item.n_pre_commands) + 1
							a_parmp.item.pre_commands[l_tmp___25] := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						end
						l_pos := -1 + 89 -- switch 2; break
				when 77 then -- switch 2, case 113
						a_parmp.item.use_ef := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						l_pos := -1 + 89 -- switch 2; break
				when 78 then -- switch 2, case 105
						globals_inst.use_viminfo := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						l_pos := -1 + 89 -- switch 2; break
				when 79 then -- switch 2, case 115
						if (globals_inst.scriptin[0]).is_void then
							l_pos := -1 + 81 -- skip if block
						end
				when 80 then -- if: | scripterror:
						message_inst.mch_errmsg ((gettext (ce_string ("Attempt to open script file again: %""))))
						message_inst.mch_errmsg (l_argv[-1])
						message_inst.mch_errmsg (ce_string (" "))
						message_inst.mch_errmsg (l_argv[0])
						message_inst.mch_errmsg (ce_string ("%"%N"))
						os_unix_inst.mch_exit (2)
				when 81 then -- if done
						globals_inst.scriptin[0] := fopen (l_argv[0], ce_string ("r"))
						if (globals_inst.scriptin[0]).is_void then
							message_inst.mch_errmsg ((gettext (ce_string ("Cannot open for reading: %""))))
							message_inst.mch_errmsg (l_argv[0])
							message_inst.mch_errmsg (ce_string ("%"%N"))
							os_unix_inst.mch_exit (2)
						end
						if (getchar_inst.save_typebuf) = 0 then
							os_unix_inst.mch_exit (2)
						end
						l_pos := -1 + 89 -- switch 2; break
				when 82 then -- switch 2, case 116
						a_parmp.item.tagname := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						l_pos := -1 + 89 -- switch 2; break
				when 83 then -- switch 2, case 84
						if (term_inst.term_is_gui (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))).to_boolean then
							gui_inst.gui.item.starting := 1
						else
							a_parmp.item.term := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						end
						l_pos := -1 + 89 -- switch 2; break
				when 84 then -- switch 2, case 117
						a_parmp.item.use_vimrc := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						l_pos := -1 + 89 -- switch 2; break
				when 85 then -- switch 2, case 85
						globals_inst.use_gvimrc := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])
						l_pos := -1 + 89 -- switch 2; break
				when 86 then -- switch 2, case 119
						if (charset_inst.vim_isdigit (((create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0])).item).to_integer_32)).to_boolean then
							l_argv_idx.item := 0
							l_n := (get_number_arg (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]), l_argv_idx, 10)).to_integer_32
							option_inst.set_option_value (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("window")), l_n, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
							l_argv_idx.item := -1
							l_pos := -1 + 89 -- switch 2; break
						end
				when 87 then -- switch 2, case 87
						if not globals_inst.scriptout.is_void then
							l_pos := -1 + 80 -- goto scripterror
						end
				when 88 then
						if l_c = 119 then
							l_tmp___33 := ce_string ("a")
						else
							l_tmp___33 := ce_string ("w")
						end
						globals_inst.scriptout := fopen (l_argv[0], l_tmp___33)
						if globals_inst.scriptout.is_void then
							message_inst.mch_errmsg ((gettext (ce_string ("Cannot open for script output: %""))))
							message_inst.mch_errmsg (l_argv[0])
							message_inst.mch_errmsg (ce_string ("%"%N"))
							os_unix_inst.mch_exit (2)
						end
						l_pos := -1 + 89 -- switch 2; break
				when 89 then -- switch 2, done: | if done | if block done, skip else block:
						l_pos := -1 + 91
				when 90 then -- else:
						l_pos := -1 + 92 -- goto _L___0
				when 91 then -- if done | if block done, skip else block:
						l_pos := -1 + 93
				when 92 then -- else: | _L___0:
						l_argv_idx.item := -1
						if a_parmp.item.edit_type /= 0 then
							if a_parmp.item.edit_type /= 1 then
								mainerr (1, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
							end
						end
						a_parmp.item.edit_type := 1
						if (misc2_inst.ga_grow (create {CE_POINTER [PD_GROWARRAY]}.make_shared (globals_inst.global_alist.item.c_pointer + (create {PD_ARGLIST}.make).offset_of ("al_ga")), 1)) = 0 then
							os_unix_inst.mch_exit (2)
						else
							l_p___0 := misc2_inst.vim_strsave (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[0]))
							if l_p___0.is_void then
								os_unix_inst.mch_exit (2)
							end
						end
						if (a_parmp.item.diff_mode).to_boolean then
							if (os_unix_inst.mch_isdir (l_p___0)).to_boolean then
								if globals_inst.global_alist.item.al_ga.ga_len > 0 then
									if not (os_unix_inst.mch_isdir ((buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.item.al_ga.ga_data) + 0)))).to_boolean then
										l_r := misc1_inst.concat_fnames (l_p___0, (misc1_inst.gettail ((buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.item.al_ga.ga_data) + 0)))), 1)
										if not l_r.is_void then
											misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
											l_p___0 := l_r
										end
									end
								end
							end
						end
						ex_docmd_inst.alist_add (globals_inst.global_alist, l_p___0, 2)
				when 93 then -- if done
						if l_argv_idx.item <= 0 then
							l_argc := l_argc - 1
							l_argv := l_argv + 1
							l_argv_idx.item := 1
						elseif ((l_argv[0])[l_argv_idx.item]).to_integer_32 = 0 then
							l_argc := l_argc - 1
							l_argv := l_argv + 1
							l_argv_idx.item := 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 94 then -- loop done
					if a_parmp.item.n_commands > 0 then
						l_p___0 := misc2_inst.alloc ((strlen (create {CE_POINTER [INTEGER_8]}.make_cast (a_parmp.item.commands[0]))) + {NATURAL_32} 3)
						if not l_p___0.is_void then
							sprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (l_p___0), ce_string (":%%s%R"), a_parmp.item.commands[0]]).do_nothing
							eval_inst.set_vim_var_string (47, l_p___0, -1)
							misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
						end
					end
				when 95 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	create_windows (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_dorewind: INTEGER_32
			l_done___2: INTEGER_32
			l_tmp___0: INTEGER_32
			js: JUMP_STATE
		do
			l_done___2 := 0
			if a_parmp.item.window_count = -1 then
				a_parmp.item.window_count := 1
			end
			if a_parmp.item.window_count = 0 then
				a_parmp.item.window_count := globals_inst.global_alist.item.al_ga.ga_len
			end
			if a_parmp.item.window_count > 1 then
				if a_parmp.item.window_layout = 0 then
					a_parmp.item.window_layout := 1
				end
				if a_parmp.item.window_layout = 3 then
					a_parmp.item.window_count := window_inst.make_tabpages (a_parmp.item.window_count)
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("making tab pages"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
				elseif (globals_inst.firstwin.item.w_next).is_void then
					a_parmp.item.window_count := window_inst.make_windows (a_parmp.item.window_count, (a_parmp.item.window_layout = 2).to_integer)
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("making windows"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
				else
					a_parmp.item.window_count := window_inst.win_count
				end
			else
				a_parmp.item.window_count := 1
			end
			if globals_inst.recoverymode.to_boolean then
				globals_inst.msg_scroll := 1
				memline_inst.ml_recover
				if (globals_inst.curbuf.item.b_ml.ml_mfp).is_void then
					getout (1)
				end
				buffer_inst.do_modelines (0)
			else
				globals_inst.autocmd_no_enter := globals_inst.autocmd_no_enter + 1
				globals_inst.autocmd_no_leave := globals_inst.autocmd_no_leave + 1
				l_dorewind := 1
				from
				until
					js.loop_done
				loop
					l_tmp___0 := l_done___2
					l_done___2 := l_done___2 + 1
					if not (l_tmp___0 < 1_000) then
						js.break
					end
					if not js.loop_jumped then
						if l_dorewind.to_boolean then
							if a_parmp.item.window_layout = 3 then
								window_inst.goto_tabpage (1)
							else
								globals_inst.curwin := globals_inst.firstwin
							end
						elseif a_parmp.item.window_layout = 3 then
							if (globals_inst.curtab.item.tp_next).is_void then
								js.break
							end
							if not js.loop_jumped then
								window_inst.goto_tabpage (0)
							end
						else
							if (globals_inst.curwin.item.w_next).is_void then
								js.break
							end
							if not js.loop_jumped then
								globals_inst.curwin := globals_inst.curwin.item.w_next
							end
						end
					end
					if not js.loop_jumped then
						l_dorewind := 0
						globals_inst.curbuf := globals_inst.curwin.item.w_buffer
						if (globals_inst.curbuf.item.b_ml.ml_mfp).is_void then
							if option_inst.p_fdls.item >= 0 then
								globals_inst.curwin.item.w_onebuf_opt.wo_fdl := option_inst.p_fdls.item
							end
							globals_inst.swap_exists_action := 1
							buffer_inst.set_buflisted (1)
							buffer_inst.open_buffer (0, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), 0).do_nothing
							if globals_inst.swap_exists_action = 2 then
								if globals_inst.got_int.to_boolean then
									globals_inst.did_emsg := 0
									getout (1)
								elseif (window_inst.only_one_window).to_boolean then
									globals_inst.did_emsg := 0
									getout (1)
								end
								buffer_inst.setfname (globals_inst.curbuf, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0).do_nothing
								globals_inst.curwin.item.w_arg_idx := -1
								globals_inst.swap_exists_action := 0
							else
								buffer_inst.handle_swap_exists (create {CE_POINTER [PD_FILE_BUFFER]}.make_shared (default_pointer))
							end
							l_dorewind := 1
						end
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							getchar_inst.vgetc.do_nothing
							js.break
						end
					end
				end
				if a_parmp.item.window_layout = 3 then
					window_inst.goto_tabpage (1)
				else
					globals_inst.curwin := globals_inst.firstwin
				end
				globals_inst.curbuf := globals_inst.curwin.item.w_buffer
				globals_inst.autocmd_no_enter := globals_inst.autocmd_no_enter - 1
				globals_inst.autocmd_no_leave := globals_inst.autocmd_no_leave - 1
			end
		end

	early_arg_scan (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_argc: INTEGER_32
			l_argv: CE_POINTER [CE_POINTER [INTEGER_8]]
			l_i___0: INTEGER_32
			l_id: CE_ARRAY [NATURAL_32]
			l_count___2: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_argv.make
			create l_id.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_argc := a_parmp.item.argc
					l_argv := a_parmp.item.argv
					l_i___0 := 1
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_i___0 < l_argc)) then
						l_pos := -1 + 13 -- skip loop
					end
				when 2 then -- loop body:
						if (strcmp (l_argv[l_i___0], ce_string ("--"))) /= 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						js.break
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 5 then -- else:
						if (strcasecmp (l_argv[l_i___0], ce_string ("-display"))) /= 0 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						l_pos := -1 + 9 -- goto _L
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 8 then -- else:
						if (strcasecmp (l_argv[l_i___0], ce_string ("--display"))) /= 0 then
							l_pos := -1 + 11 -- skip if block
						end
				when 9 then -- if: | _L:
						if l_i___0 = l_argc - 1 then
							mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[l_i___0]))
						end
						l_i___0 := l_i___0 + 1
						globals_inst.xterm_display := l_argv[l_i___0]
				when 10 then -- if block done, skip else block:
						l_pos := -1 + 12
				when 11 then -- else:
						if (strcasecmp (l_argv[l_i___0], ce_string ("--servername"))) = 0 then
							if l_i___0 = l_argc - 1 then
								mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[l_i___0]))
							end
							l_i___0 := l_i___0 + 1
							a_parmp.item.serverName_arg := create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[l_i___0])
						elseif (strcasecmp (l_argv[l_i___0], ce_string ("--serverlist"))) = 0 then
							a_parmp.item.serverArg := 1
						elseif (strncasecmp (l_argv[l_i___0], ce_string ("--remote"), (8).to_natural_32)) = 0 then
							a_parmp.item.serverArg := 1
							if not (strstr (l_argv[l_i___0], ce_string ("-wait"))).is_void then
								gui_inst.gui.item.dofork := 0
							end
						elseif (strcasecmp (l_argv[l_i___0], ce_string ("--socketid"))) = 0 then
							if l_i___0 = l_argc - 1 then
								mainerr_arg_missing (create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[l_i___0]))
							end
							if (strncasecmp (l_argv[(l_i___0 + 1)], ce_string ("0x"), (2).to_natural_32)) = 0 then
								l_count___2 := sscanf ([(l_argv[(l_i___0 + 1)] + 2), ce_string ("%%lx"), l_id])
							else
								l_count___2 := sscanf ([l_argv[(l_i___0 + 1)], ce_string ("%%lu"), l_id])
							end
							if l_count___2 /= 1 then
								mainerr (5, create {CE_POINTER [NATURAL_8]}.make_cast (l_argv[l_i___0]))
							else
								globals_inst.gtk_socket_id := (l_id.item).to_natural_32
							end
							l_i___0 := l_i___0 + 1
						elseif (strcasecmp (l_argv[l_i___0], ce_string ("--echo-wid"))) = 0 then
							globals_inst.echo_wid_arg := 1
						end
				when 12 then -- if done | if done
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 13 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	edit_buffers (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_arg_idx: INTEGER_32
			l_i___0: INTEGER_32
			l_advance: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tmp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_advance := 1
					globals_inst.autocmd_no_enter := globals_inst.autocmd_no_enter + 1
					globals_inst.autocmd_no_leave := globals_inst.autocmd_no_leave + 1
					if globals_inst.curwin.item.w_arg_idx = -1 then
						window_inst.win_close (globals_inst.curwin, 1)
						l_advance := 0
					end
					l_arg_idx := 1
					l_i___0 := 1
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_i___0 < a_parmp.item.window_count)) then
						l_pos := -1 + 10 -- skip loop
					end
				when 2 then -- loop body:
						if globals_inst.curwin.item.w_arg_idx = -1 then
							l_arg_idx := l_arg_idx + 1
							window_inst.win_close (globals_inst.curwin, 1)
							l_advance := 0
							js.continue
						end
						if not js.loop_jumped and then (l_advance.to_boolean) then
							if a_parmp.item.window_layout = 3 then
								if (globals_inst.curtab.item.tp_next).is_void then
									js.break
								end
								if not js.loop_jumped then
									window_inst.goto_tabpage (0)
								end
							else
								if (globals_inst.curwin.item.w_next).is_void then
									js.break
								end
								if not js.loop_jumped then
									window_inst.win_enter (globals_inst.curwin.item.w_next, 0)
								end
							end
						end
						if js.loop_jumped then
							l_pos := -1 + 9 -- skip if block
						end
				when 3 then -- if:
						l_advance := 1
						if not (globals_inst.curbuf.is_equal (globals_inst.firstwin.item.w_buffer)) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						l_pos := -1 + 7 -- goto _L
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 6 then -- else:
						if not ((globals_inst.curbuf.item.b_ffname).is_void) then
							l_pos := -1 + 8 -- skip if block
						end
				when 7 then -- if: | _L:
						globals_inst.curwin.item.w_arg_idx := l_arg_idx
						globals_inst.swap_exists_did_quit := 0
						if l_arg_idx < globals_inst.global_alist.item.al_ga.ga_len then
							l_tmp___0 := (buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.item.al_ga.ga_data) + l_arg_idx))
						else
							l_tmp___0 := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
						end
						ex_cmds_inst.do_ecmd (0, l_tmp___0, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), (0).to_integer_32, 1, globals_inst.curwin).do_nothing
						if globals_inst.swap_exists_did_quit.to_boolean then
							if globals_inst.got_int.to_boolean then
								globals_inst.did_emsg := 0
								getout (1)
							elseif (window_inst.only_one_window).to_boolean then
								globals_inst.did_emsg := 0
								getout (1)
							end
							window_inst.win_close (globals_inst.curwin, 1)
							l_advance := 0
						end
						if l_arg_idx = globals_inst.global_alist.item.al_ga.ga_len - 1 then
							globals_inst.arg_had_last := 1
						end
						l_arg_idx := l_arg_idx + 1
				when 8 then -- if done
						ui_inst.ui_breakcheck
						if globals_inst.got_int.to_boolean then
							getchar_inst.vgetc.do_nothing
							js.break
						end
				when 9 then -- if done
						if js.loop_increment then
							l_i___0 := l_i___0 + 1
						end
						l_pos := -1 + 1 -- back to loop condition
				when 10 then -- loop done
					if a_parmp.item.window_layout = 3 then
						window_inst.goto_tabpage (1)
					end
					globals_inst.autocmd_no_enter := globals_inst.autocmd_no_enter - 1
					window_inst.win_enter (globals_inst.firstwin, 0)
					globals_inst.autocmd_no_leave := globals_inst.autocmd_no_leave - 1
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("editing files in windows"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					if a_parmp.item.window_count > 1 then
						if a_parmp.item.window_layout /= 3 then
							window_inst.win_equal (globals_inst.curwin, 0, ('b').code)
						end
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	eval_client_expr_to_string (a_expr: CE_POINTER [NATURAL_8]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_save_dbl: INTEGER_32
			l_save_ro: INTEGER_32
		do
			create l_res.make

			l_save_dbl := globals_inst.debug_break_level
			l_save_ro := globals_inst.redir_off
			globals_inst.debug_break_level := -1
			globals_inst.redir_off := 0
			globals_inst.emsg_skip := globals_inst.emsg_skip + 1
			l_res := eval_inst.eval_to_string (a_expr, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer), 1)
			globals_inst.debug_break_level := l_save_dbl
			globals_inst.redir_off := l_save_ro
			globals_inst.emsg_skip := globals_inst.emsg_skip - 1
			screen_inst.setcursor
			term_inst.out_flush
			if (gui_inst.gui.item.in_use).to_boolean then
				gui_inst.gui_update_cursor (0, 0)
			end
			Result := l_res
		end

	exe_commands (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_i___0: INTEGER_32
		do
			globals_inst.msg_scroll := 1
			if (a_parmp.item.tagname).is_void then
				if globals_inst.curwin.item.w_cursor.lnum <= 1 then
					globals_inst.curwin.item.w_cursor.lnum := (0).to_integer_32
				end
			end
			globals_inst.sourcing_name := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("command line"))
			globals_inst.current_SID := -3
			l_i___0 := 0
			from
			until
				not (l_i___0 < a_parmp.item.n_commands)
			loop
				ex_docmd_inst.do_cmdline_cmd (a_parmp.item.commands[l_i___0]).do_nothing
				if (a_parmp.item.cmds_tofree[l_i___0]).to_boolean then
					misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_parmp.item.commands[l_i___0]))
				end
				l_i___0 := l_i___0 + 1
			end
			globals_inst.sourcing_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			globals_inst.current_SID := 0
			if globals_inst.curwin.item.w_cursor.lnum = 0 then
				globals_inst.curwin.item.w_cursor.lnum := (1).to_integer_32
			end
			if not globals_inst.exmode_active.to_boolean then
				globals_inst.msg_scroll := 0
			end
			if a_parmp.item.edit_type = 4 then
				quickfix_inst.qf_jump (create {CE_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer), 0, 0, 0)
			end
			if not globals_inst.time_fd.is_void then
				time_msg (ce_string ("executing command arguments"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
		end

	exe_pre_commands (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_cmds___0: CE_POINTER [CE_POINTER [NATURAL_8]]
			l_cnt: INTEGER_32
			l_i___0: INTEGER_32
		do
			create l_cmds___0.make

			l_cmds___0 := a_parmp.item.pre_commands
			l_cnt := a_parmp.item.n_pre_commands
			if l_cnt > 0 then
				globals_inst.curwin.item.w_cursor.lnum := (0).to_integer_32
				globals_inst.sourcing_name := create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("pre-vimrc command line"))))
				globals_inst.current_SID := -2
				l_i___0 := 0
				from
				until
					not (l_i___0 < l_cnt)
				loop
					ex_docmd_inst.do_cmdline_cmd (l_cmds___0[l_i___0]).do_nothing
					l_i___0 := l_i___0 + 1
				end
				globals_inst.sourcing_name := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
				globals_inst.current_SID := 0
				if not globals_inst.time_fd.is_void then
					time_msg (ce_string ("--cmd commands"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
				end
			end
		end

	exec_on_server (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not ((a_parmp.item.serverName_arg).is_void) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if ((a_parmp.item.serverName_arg).item).to_integer_32 = 0 then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if (a_parmp.item.serverArg).to_boolean then
							cmdsrv_main (create {CE_POINTER [INTEGER_32]}.make_shared (a_parmp.c_pointer + (create {PD_MPARM_T}.make).offset_of ("argc")), a_parmp.item.argv, a_parmp.item.serverName_arg, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (a_parmp.c_pointer + (create {PD_MPARM_T}.make).offset_of ("serverStr")))
							a_parmp.item.serverStrEnc := misc2_inst.vim_strsave (option_inst.p_enc.item)
						end
						a_parmp.item.servername := serverMakeName (a_parmp.item.serverName_arg, a_parmp.item.argv[0])
				when 5 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	file_owned (a_fname: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_s: CE_ARRAY [SD_STAT]
			l_uid: NATURAL_32
			l_tmp___2: INTEGER_32
		do
			create l_s.make (<<1>>)

			l_uid := (getuid)
			if (stat (a_fname, l_s)) /= 0 then
				l_tmp___2 := 0
			elseif l_s.item.st_uid /= l_uid then
				l_tmp___2 := 0
			elseif (lstat (a_fname, l_s)) /= 0 then
				l_tmp___2 := 0
			elseif l_s.item.st_uid /= l_uid then
				l_tmp___2 := 0
			else
				l_tmp___2 := 1
			end
			Result := l_tmp___2
		end

	get_number_arg (a_p___0: CE_POINTER [NATURAL_8]; a_idx: CE_POINTER [INTEGER_32]; a_def: INTEGER_32): INTEGER_32
		local
			l_def: INTEGER_32
			js: JUMP_STATE
		do
			l_def := a_def
			if (charset_inst.vim_isdigit ((a_p___0[a_idx.item]).to_integer_32)).to_boolean then
				l_def := atoi (create {CE_POINTER [INTEGER_8]}.make_cast ((a_p___0 + a_idx.item)))
				from
				until
					js.loop_done
				loop
					if not (charset_inst.vim_isdigit ((a_p___0[a_idx.item]).to_integer_32)).to_boolean then
						js.break
					end
					if not js.loop_jumped then
						a_idx.item := (a_idx.item) + 1
					end
				end
			end
			Result := l_def
		end

	getout (a_exitval: INTEGER_32)
		local
			l_exitval: INTEGER_32
			l_buf___6: CE_POINTER [PD_FILE_BUFFER]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			l_tp: CE_POINTER [PD_TABPAGE_S]
			l_next_tp: CE_POINTER [PD_TABPAGE_S]
			js: JUMP_STATE
		do
			create l_buf___6.make
			create l_wp___0.make
			create l_tp.make
			create l_next_tp.make

			l_exitval := a_exitval
			globals_inst.exiting := 1
			if globals_inst.exmode_active.to_boolean then
				l_exitval := l_exitval + globals_inst.ex_exitval
			end
			if not (gui_inst.gui.item.in_use).to_boolean then
				screen_inst.windgoto ((globals_inst.Rows.item).to_integer_32 - 1, 0)
			end
			hashtab_inst.hash_debug_results
			globals_inst.msg_didany := 0
			if (eval_inst.get_vim_var_nr (28)) <= 1 then
				l_tp := globals_inst.first_tabpage
				from
				until
					not (not js.loop_done and then (not l_tp.is_void))
				loop
					l_next_tp := l_tp.item.tp_next
					if l_tp.is_equal (globals_inst.curtab) then
						l_wp___0 := globals_inst.firstwin
					else
						l_wp___0 := l_tp.item.tp_firstwin
					end
					from
					until
						not (not js.loop_done and then (not l_wp___0.is_void))
					loop
						l_buf___6 := l_wp___0.item.w_buffer
						if l_buf___6.item.b_changedtick /= -1 then
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFWINLEAVE, l_buf___6.item.b_fname, l_buf___6.item.b_fname, 0, l_buf___6).do_nothing
							l_buf___6.item.b_changedtick := -1
							l_next_tp := globals_inst.first_tabpage
							js.break
						end
						if not js.loop_jumped then
							l_wp___0 := l_wp___0.item.w_next
						end
					end
					l_tp := l_next_tp
				end
				l_buf___6 := globals_inst.firstbuf
				from
				until
					not (not js.loop_done and then (not l_buf___6.is_void))
				loop
					if not (l_buf___6.item.b_ml.ml_mfp).is_void then
						fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFUNLOAD, l_buf___6.item.b_fname, l_buf___6.item.b_fname, 0, l_buf___6).do_nothing
						if not (buffer_inst.buf_valid (l_buf___6)).to_boolean then
							js.break
						end
					end
					if not js.loop_jumped then
						l_buf___6 := l_buf___6.item.b_next
					end
				end
				fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMLEAVEPRE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			end
			if (option_inst.p_viminfo.item.item).to_integer_32 /= 0 then
				ex_cmds_inst.write_viminfo (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0)
			end
			if (eval_inst.get_vim_var_nr (28)) <= 1 then
				fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMLEAVE, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
			end
			if globals_inst.did_emsg.to_boolean then
				globals_inst.no_wait_return := 0
				message_inst.wait_return (0)
			elseif (gui_inst.gui.item.in_use).to_boolean then
				if globals_inst.msg_didany.to_boolean then
					if option_inst.p_verbose.item > 0 then
						globals_inst.no_wait_return := 0
						message_inst.wait_return (0)
					end
				end
			end
			if not (gui_inst.gui.item.in_use).to_boolean then
				screen_inst.windgoto ((globals_inst.Rows.item).to_integer_32 - 1, 0)
			end
			netbeans_inst.netbeans_end
			if globals_inst.garbage_collect_at_exit.to_boolean then
				eval_inst.garbage_collect.do_nothing
			end
			os_unix_inst.mch_exit (l_exitval)
		end

	getout_preserve_modified (a_exitval: INTEGER_32)
		do
			signal (1, create {CE_ROUTINE}.make_shared (default_pointer + 1)).do_nothing
			memline_inst.ml_close_notmod
			memline_inst.ml_sync_all (0, 0)
			memline_inst.ml_close_all (0)
			getout (a_exitval)
		end

	init_locale
		local
			l_mustfree: CE_ARRAY [INTEGER_32]
			l_p___0: CE_POINTER [NATURAL_8]
		do
			create l_mustfree.make (<<1>>)
			create l_p___0.make

			setlocale (6, ce_string ("")).do_nothing
			gtk_disable_setlocale
			setlocale (1, ce_string ("C")).do_nothing
			l_mustfree.item := 0
			l_p___0 := misc1_inst.vim_getenv (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("VIMRUNTIME")), l_mustfree)
			if not l_p___0.is_void then
				if (l_p___0.item).to_integer_32 /= 0 then
					message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item), (4_096).to_natural_32, ce_string ("%%s/lang"), l_p___0]).do_nothing
					bindtextdomain (ce_string ("vim"), create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.NameBuff.item)).do_nothing
				end
			end
			if (l_mustfree.item).to_boolean then
				misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
			end
			textdomain (ce_string ("vim")).do_nothing
		end

	main (a_argc: INTEGER_32; a_argv: CE_POINTER [CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_fname: CE_POINTER [NATURAL_8]
			l_params: CE_ARRAY [PD_MPARM_T]
			l_i___0: INTEGER_32
			l_p___0: CE_POINTER [INTEGER_8]
			l_wp___0: CE_POINTER [PD_WINDOW_S]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_fname.make
			create l_params.make (<<1>>)
			create l_p___0.make
			create l_wp___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_fname := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
					os_unix_inst.mch_early_init
					memset (create {CE_POINTER [ANY]}.make_cast (l_params), 0, (create {PD_MPARM_T}.make).structure_size.to_natural_32).do_nothing
					l_params.item.argc := a_argc
					l_params.item.argv := a_argv
					l_params.item.want_full_screen := 1
					l_params.item.use_debug_break_level := -1
					l_params.item.window_count := -1
					l_i___0 := 1
					from
					until
						not (not js.loop_done and then (l_i___0 < a_argc))
					loop
						if (strcasecmp (a_argv[l_i___0], ce_string ("--startuptime"))) = 0 then
							if l_i___0 + 1 < a_argc then
								globals_inst.time_fd := fopen (a_argv[(l_i___0 + 1)], ce_string ("a"))
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("--- VIM STARTING ---"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
								js.break
							end
						end
						if not js.loop_jumped then
							l_i___0 := l_i___0 + 1
						end
					end
					globals_inst.starttime := time (create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
					mbyte_inst.mb_init.do_nothing
					eval_inst.eval_init
					normal_inst.init_normal_cmds
					globals_inst.IObuff := misc2_inst.alloc ({NATURAL_32} 1_025)
					if globals_inst.IObuff.is_void then
						os_unix_inst.mch_exit (0)
					else
						globals_inst.NameBuff.item := misc2_inst.alloc ({NATURAL_32} 4_096)
						if (globals_inst.NameBuff.item).is_void then
							os_unix_inst.mch_exit (0)
						end
					end
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("Allocated generic buffers"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					init_locale
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("locale set"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					gui_inst.gui.item.dofork := 1
					early_arg_scan (l_params)
					gui_inst.gui_prepare (create {CE_POINTER [INTEGER_32]}.make_shared (l_params.item.c_pointer + (create {PD_MPARM_T}.make).offset_of ("argc")), l_params.item.argv)
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("GUI prepared"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					ui_inst.clip_init (0)
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("clipboard setup"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					l_params.item.stdout_isatty := ((os_unix_inst.mch_check_win (l_params.item.argc, l_params.item.argv)) /= 0).to_integer
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("window checked"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					if (window_inst.win_alloc_first) = 0 then
						os_unix_inst.mch_exit (0)
					end
					ops_inst.init_yank
					ex_docmd_inst.alist_init (globals_inst.global_alist)
					misc1_inst.init_homedir
					option_inst.set_init_1
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("inits 1"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					ex_cmds2_inst.set_lang_var
					exec_on_server (l_params)
					parse_command_name (l_params)
					command_line_scan (l_params)
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("parsing arguments"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					if (gui_inst.gui.item.starting).to_boolean then
						if (gui_inst.gui_init_check) = 0 then
							gui_inst.gui.item.starting := 0
							if (l_params.item.evim_mode).to_boolean then
								os_unix_inst.mch_exit (1)
							end
						end
					end
					if globals_inst.global_alist.item.al_ga.ga_len > 0 then
						l_fname := buffer_inst.alist_name (create {CE_POINTER [PD_ARGENTRY]}.make_cast (globals_inst.global_alist.item.al_ga.ga_data) + 0)
					end
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("expanding arguments"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					if (l_params.item.diff_mode).to_boolean then
						if l_params.item.window_count = -1 then
							l_params.item.window_count := 0
						end
					end
					globals_inst.RedrawingDisabled := globals_inst.RedrawingDisabled + 1
					if globals_inst.recoverymode.to_boolean then
						if l_fname.is_void then
							l_params.item.want_full_screen := 0
						end
					end
					if (gui_inst.gui.item.starting).to_boolean then
						if not (isatty (2)).to_boolean then
							l_params.item.want_full_screen := 0
						end
					end
					os_unix_inst.mch_init
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("shell init"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					if not globals_inst.x_no_connect.to_boolean then
						l_p___0 := (getenv (ce_string ("SESSION_MANAGER")))
						if not l_p___0.is_void then
							if (l_p___0[0]).to_integer_32 /= 0 then
								os_unix_inst.xsmp_init
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("xsmp init"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
							end
						end
					end
					check_tty (l_params)
					if globals_inst.global_alist.item.al_ga.ga_len > 1 then
						if not globals_inst.silent_mode.to_boolean then
							printf ([(gettext (ce_string ("%%d files to edit%N"))), globals_inst.global_alist.item.al_ga.ga_len]).do_nothing
						end
					end
					if (l_params.item.want_full_screen).to_boolean then
						if not globals_inst.silent_mode.to_boolean then
							term_inst.termcapinit (l_params.item.term)
							screen_inst.screen_start
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("Termcap init"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
						end
					end
					ui_inst.ui_get_shellsize.do_nothing
					window_inst.win_init_size
					if (l_params.item.diff_mode).to_boolean then
						diff_inst.diff_win_options (globals_inst.firstwin, 0)
					end
					globals_inst.cmdline_row := (globals_inst.Rows.item - option_inst.p_ch.item).to_integer_32
					globals_inst.msg_row := globals_inst.cmdline_row
					screen_inst.screenalloc (0)
					option_inst.set_init_2
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("inits 2"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					globals_inst.msg_scroll := 1
					globals_inst.no_wait_return := 1
					getchar_inst.init_mappings
					syntax_inst.init_highlight (1, 0)
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("init highlight"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					globals_inst.debug_break_level := l_params.item.use_debug_break_level
					exe_pre_commands (l_params)
					source_startup_scripts (l_params)
					if (option_inst.p_lpl.item).to_boolean then
						ex_cmds2_inst.source_runtime (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("plugin/**/*.vim")), 1).do_nothing
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("loading plugins"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
					end
					if (l_params.item.diff_mode).to_boolean then
						if l_params.item.window_layout = 0 then
							if (diff_inst.diffopt_horizontal).to_boolean then
								l_params.item.window_layout := 1
							else
								l_params.item.window_layout := 2
							end
						end
					end
					if globals_inst.recoverymode.to_boolean then
						if l_fname.is_void then
							memline_inst.recover_names (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 1, 0, create {CE_POINTER [CE_POINTER [NATURAL_8]]}.make_shared (default_pointer)).do_nothing
							os_unix_inst.mch_exit (0)
						end
					end
					option_inst.set_init_3
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("inits 3"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
					if (l_params.item.no_swap_file).to_boolean then
						option_inst.p_uc.item := 0
					end
					if (gui_inst.gui.item.starting).to_boolean then
						if globals_inst.did_emsg.to_boolean then
							putchar (('%N').code).do_nothing
						elseif globals_inst.msg_didout.to_boolean then
							putchar (('%N').code).do_nothing
						end
						gui_inst.gui_start
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("starting GUI"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
						if not (gui_inst.gui.item.in_use).to_boolean then
							if (l_params.item.evim_mode).to_boolean then
								os_unix_inst.mch_exit (1)
							end
						end
					end
					if (option_inst.p_viminfo.item.item).to_integer_32 /= 0 then
						ex_cmds_inst.read_viminfo (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 9).do_nothing
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("reading viminfo"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
					end
					if l_params.item.edit_type = 4 then
						if not (l_params.item.use_ef).is_void then
							option_inst.set_string_option_direct (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("ef")), -1, l_params.item.use_ef, 1, -3)
						end
						message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("cfile %%s"), option_inst.p_ef.item]).do_nothing
						if (quickfix_inst.qf_init (create {CE_POINTER [PD_WINDOW_S]}.make_shared (default_pointer), option_inst.p_ef.item, option_inst.p_efm.item, 1, globals_inst.IObuff)) < 0 then
							term_inst.out_char ((('%N').code).to_natural_32)
							os_unix_inst.mch_exit (3)
						end
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("reading errorfile"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
					end
					globals_inst.starting := 1
					globals_inst.no_wait_return := 0
					if not globals_inst.exmode_active.to_boolean then
						globals_inst.msg_scroll := 0
					end
					if (gui_inst.gui.item.in_use).to_boolean then
						gui_inst.gui_wait_for_chars (50).do_nothing
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("GUI delay"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
					end
					if not (gui_inst.gui.item.in_use).to_boolean then
						os_unix_inst.setup_term_clip
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("setup clipboard"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
					end
					prepare_server (l_params)
					if l_params.item.edit_type = 2 then
						if not globals_inst.recoverymode.to_boolean then
							read_stdin
						end
					end
					if not (globals_inst.did_emsg.to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not (globals_inst.msg_didout.to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | _L:
						if ((term_inst.term_strings[33]).item).to_integer_32 /= 0 then
							globals_inst.newline_on_exit := 1
						end
				when 5 then -- if done
						term_inst.settmode (2)
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("setting raw mode"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
						if not (globals_inst.need_wait_return.to_boolean) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
							l_pos := -1 + 9 -- goto _L___0
				when 7 then -- if block done, skip else block:
							l_pos := -1 + 10
				when 8 then -- else:
							if not (globals_inst.msg_didany.to_boolean) then
								l_pos := -1 + 10 -- skip if block
							end
				when 9 then -- if: | _L___0:
							message_inst.wait_return (1)
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("waiting for return"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
				when 10 then -- if done
							term_inst.starttermcap
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("start termcap"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							term_inst.setmouse
							if globals_inst.scroll_region.to_boolean then
								term_inst.scroll_region_reset
							end
							term_inst.scroll_start
							if not (globals_inst.exmode_active.to_boolean) then
								l_pos := -1 + 13 -- skip if block
							end
				when 11 then -- if:
								if not (gui_inst.gui.item.in_use).to_boolean then
									globals_inst.must_redraw := 50
								else
									l_pos := -1 + 13 -- goto _L___1
								end
				when 12 then -- if block done, skip else block:
								l_pos := -1 + 14
				when 13 then -- else: | _L___1:
								screen_inst.screenclear
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("clearing screen"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
				when 14 then
							if (l_params.item.ask_for_key).to_boolean then
								blowfish_inst.blowfish_self_test.do_nothing
								misc2_inst.get_crypt_key (1, 1).do_nothing
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("getting crypt key"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
							end
							globals_inst.no_wait_return := 1
							create_windows (l_params)
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("opening buffers"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							eval_inst.set_vim_var_string (47, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), -1)
							if globals_inst.exmode_active.to_boolean then
								globals_inst.curwin.item.w_cursor.lnum := globals_inst.curbuf.item.b_ml.ml_line_count
							end
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_BUFENTER, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("BufEnter autocommands"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							mark_inst.setpcmark
							if l_params.item.edit_type = 4 then
								quickfix_inst.qf_jump (create {CE_POINTER [PD_QF_INFO_S]}.make_shared (default_pointer), 0, 0, 0)
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("jump to first error"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
							end
							edit_buffers (l_params)
							if (l_params.item.diff_mode).to_boolean then
								l_wp___0 := globals_inst.firstwin
								from
								until
									l_wp___0.is_void
								loop
									diff_inst.diff_win_options (l_wp___0, 1)
									l_wp___0 := l_wp___0.item.w_next
								end
							end
							fileio_inst.shorten_fnames (0)
							if not (l_params.item.tagname).is_void then
								globals_inst.swap_exists_did_quit := 0
								message_inst.vim_snprintf ([create {CE_POINTER [INTEGER_8]}.make_cast (globals_inst.IObuff), (1_025).to_natural_32, ce_string ("ta %%s"), l_params.item.tagname]).do_nothing
								ex_docmd_inst.do_cmdline_cmd (globals_inst.IObuff).do_nothing
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("jumping to tag"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
								if globals_inst.swap_exists_did_quit.to_boolean then
									getout (1)
								end
							end
							if l_params.item.n_commands > 0 then
								exe_commands (l_params)
							end
							globals_inst.RedrawingDisabled := 0
							screen_inst.redraw_all_later (40)
							globals_inst.no_wait_return := 0
							globals_inst.starting := 0
							term_inst.may_req_termresponse
							if (option_inst.p_im.item).to_boolean then
								globals_inst.need_start_insertmode := 1
							end
							fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_VIMENTER, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("VimEnter autocommands"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							if (globals_inst.curwin.item.w_onebuf_opt.wo_diff).to_boolean then
								if (globals_inst.curwin.item.w_onebuf_opt.wo_scb).to_boolean then
									move_inst.update_topline
									normal_inst.check_scrollbind ((0).to_integer_32, 0)
									if not globals_inst.time_fd.is_void then
										time_msg (ce_string ("diff scrollbinding"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
									end
								end
							end
							if not (globals_inst.first_tabpage.item.tp_next).is_void then
								term_inst.out_flush
								gui_inst.gui_init_which_components (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
								gui_inst.gui_update_scrollbars (1)
							end
							globals_inst.need_mouse_correct := 1
							if globals_inst.restart_edit /= 0 then
								getchar_inst.stuffcharReadbuff (-(253 + ((97).bit_shift_left (8))))
							end
							if not globals_inst.netbeansArg.is_void then
								if (strncmp (ce_string ("-nb"), globals_inst.netbeansArg, (3).to_natural_32)) = 0 then
									netbeans_inst.netbeans_open (globals_inst.netbeansArg + 3, 1)
								end
							end
							if not globals_inst.time_fd.is_void then
								time_msg (ce_string ("before starting main loop"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
							end
							main_loop (0, 0)
							Result := 0
				when 15 then
							l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
				end

	main_loop (a_cmdwin: INTEGER_32; a_noexmode: INTEGER_32)
		local
			l_oa: CE_ARRAY [PD_OPARG_S]
			l_previous_got_int: INTEGER_32
			l_tmp: INTEGER_32
			l_p___0: CE_POINTER [NATURAL_8]
			l_tmp___7: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_oa.make (<<1>>)
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_previous_got_int := 0
					if a_cmdwin.to_boolean then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						if a_noexmode.to_boolean then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						globals_inst.x_jump_env := create {CE_EXCEPTION}.make ($main_loop, l_pos, $l_tmp)
				when 3 then -- continue here on raising x_jump_env:
						if l_tmp.to_boolean then
							globals_inst.State := 1
							globals_inst.VIsual_active := 0
							globals_inst.got_int := 1
							globals_inst.need_wait_return := 0
							globals_inst.global_busy := 0
							globals_inst.exmode_active := 0
							globals_inst.skip_redraw := 0
							globals_inst.RedrawingDisabled := 0
							globals_inst.no_wait_return := 0
							globals_inst.emsg_skip := 0
							globals_inst.emsg_off := 0
							term_inst.setmouse
							term_inst.settmode (2)
							term_inst.starttermcap
							term_inst.scroll_start
							screen_inst.redraw_later_clear
						end
				when 4 then -- if done | if done
						ops_inst.clear_oparg (l_oa)
				when 5 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 38 -- skip loop
						end
				when 6 then -- loop body:
							if a_cmdwin.to_boolean then
								if globals_inst.cmdwin_result /= 0 then
									js.break
								end
							end
							if js.loop_jumped then
								l_pos := -1 + 37 -- skip if block
							end
				when 7 then -- if:
							if (getchar_inst.stuff_empty).to_boolean then
								globals_inst.did_check_timestamps := 0
								if globals_inst.need_check_timestamps.to_boolean then
									fileio_inst.check_timestamps (0).do_nothing
								end
								if globals_inst.need_wait_return.to_boolean then
									message_inst.wait_return (0)
								end
								if globals_inst.need_start_insertmode.to_boolean then
									if (misc1_inst.goto_im).to_boolean then
										if not globals_inst.VIsual_active.to_boolean then
											globals_inst.need_start_insertmode := 0
											getchar_inst.stuffReadbuff (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("i")))
											globals_inst.need_fileinfo := 0
										end
									end
								end
							end
							if not (globals_inst.got_int.to_boolean) then
								l_pos := -1 + 18 -- skip if block
							end
				when 8 then -- if:
							if not (a_noexmode.to_boolean) then
								l_pos := -1 + 11 -- skip if block
							end
				when 9 then -- if:
							if globals_inst.global_busy.to_boolean then
								if not globals_inst.exmode_active.to_boolean then
									if l_previous_got_int.to_boolean then
										globals_inst.exmode_active := 1
										globals_inst.State := 1
									else
										l_pos := -1 + 11 -- goto _L___2
									end
								else
									l_pos := -1 + 11 -- goto _L___2
								end
							else
								l_pos := -1 + 11 -- goto _L___2
							end
				when 10 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 11 then -- else: | _L___2:
							if globals_inst.global_busy.to_boolean then
								l_pos := -1 + 14 -- skip if block
							end
				when 12 then -- if:
							l_pos := -1 + 15 -- goto _L
				when 13 then -- if block done, skip else block:
							l_pos := -1 + 16
				when 14 then -- else:
							if globals_inst.exmode_active.to_boolean then
								l_pos := -1 + 16 -- skip if block
							end
				when 15 then -- if: | _L:
							if not globals_inst.quit_more.to_boolean then
								getchar_inst.vgetc.do_nothing
							end
							globals_inst.got_int := 0
				when 16 then -- if done | if done
							l_previous_got_int := 1
				when 17 then -- if block done, skip else block:
							l_pos := -1 + 19
				when 18 then -- else:
							l_previous_got_int := 0
				when 19 then -- if done
							if not globals_inst.exmode_active.to_boolean then
								globals_inst.msg_scroll := 0
							end
							globals_inst.quit_more := 0
							if not (globals_inst.skip_redraw.to_boolean) then
								l_pos := -1 + 22 -- skip if block
							end
				when 20 then -- if:
							globals_inst.skip_redraw := 0
				when 21 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 22 then -- else:
							if not (globals_inst.exmode_active.to_boolean) then
								l_pos := -1 + 25 -- skip if block
							end
				when 23 then -- if:
							globals_inst.skip_redraw := 0
				when 24 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 25 then -- else:
							if not (globals_inst.do_redraw.to_boolean) then
								l_pos := -1 + 28 -- skip if block
							end
				when 26 then -- if:
							l_pos := -1 + 29 -- goto _L___5
				when 27 then -- if block done, skip else block:
							l_pos := -1 + 36
				when 28 then -- else:
							if not ((getchar_inst.stuff_empty).to_boolean) then
								l_pos := -1 + 36 -- skip if block
							end
				when 29 then -- if: | _L___5:
							if globals_inst.finish_op.to_boolean then
								l_pos := -1 + 35 -- skip if block
							end
				when 30 then -- if:
							if not ((fileio_inst.has_cursormoved).to_boolean) then
								l_pos := -1 + 35 -- skip if block
							end
				when 31 then -- if:
							if globals_inst.last_cursormoved.lnum /= globals_inst.curwin.item.w_cursor.lnum then
								l_pos := -1 + 34 -- skip if block
							end
				when 32 then -- if:
							if globals_inst.last_cursormoved.col = globals_inst.curwin.item.w_cursor.col then
								if globals_inst.last_cursormoved.coladd /= globals_inst.curwin.item.w_cursor.coladd then
									l_pos := -1 + 34 -- goto _L___4
								end
							else
								l_pos := -1 + 34 -- goto _L___4
							end
				when 33 then -- if block done, skip else block:
							l_pos := -1 + 35
				when 34 then -- else: | _L___4:
							if (fileio_inst.has_cursormoved).to_boolean then
								fileio_inst.apply_autocmds ({PC_AUTO_EVENT}.EVENT_CURSORMOVED, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), 0, globals_inst.curbuf).do_nothing
							end
							globals_inst.last_cursormoved := (globals_inst.curwin.item.w_cursor).twin
				when 35 then -- if done | if done
							if globals_inst.diff_need_scrollbind.to_boolean then
								normal_inst.check_scrollbind ((0).to_integer_32, 0)
								globals_inst.diff_need_scrollbind := 0
							end
							fold_inst.foldAdjustVisual
							if (fold_inst.hasAnyFolding (globals_inst.curwin)).to_boolean then
								if not (getchar_inst.char_avail).to_boolean then
									fold_inst.foldCheckClose
									if ((option_inst.fdo_flags.item).bit_and ({NATURAL_32} 1)).to_boolean then
										fold_inst.foldOpenCursor
									end
								end
							end
							move_inst.update_topline
							move_inst.validate_cursor
							if globals_inst.VIsual_active.to_boolean then
								screen_inst.update_curbuf (20)
							elseif globals_inst.must_redraw.to_boolean then
								screen_inst.update_screen (0)
							elseif globals_inst.redraw_cmdline.to_boolean then
								screen_inst.showmode.do_nothing
							elseif globals_inst.clear_cmdline.to_boolean then
								screen_inst.showmode.do_nothing
							end
							screen_inst.redraw_statuslines
							if globals_inst.need_maketitle.to_boolean then
								buffer_inst.maketitle
							end
							if not globals_inst.keep_msg.is_void then
								l_p___0 := globals_inst.keep_msg
								globals_inst.keep_msg := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
								message_inst.msg_attr (l_p___0, globals_inst.keep_msg_attr).do_nothing
								misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0))
							end
							if globals_inst.need_fileinfo.to_boolean then
								buffer_inst.fileinfo (0, 1, 0)
								globals_inst.need_fileinfo := 0
							end
							globals_inst.emsg_on_display := 0
							globals_inst.did_emsg := 0
							globals_inst.msg_didany := 0
							message_inst.may_clear_sb_text
							screen_inst.showruler (0)
							screen_inst.setcursor
							term_inst.cursor_on
							globals_inst.do_redraw := 0
							if not globals_inst.time_fd.is_void then
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("first screen update"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
								if not globals_inst.time_fd.is_void then
									time_msg (ce_string ("--- VIM STARTED ---"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
								end
								fclose (globals_inst.time_fd).do_nothing
								globals_inst.time_fd := create {CE_POINTER [SD_IO_FILE]}.make_shared (default_pointer)
							end
				when 36 then -- if done | if done | if done
							if globals_inst.need_mouse_correct.to_boolean then
								gui_inst.gui_mouse_correct
							end
							move_inst.update_curswant
							if not a_cmdwin.to_boolean then
								if not a_noexmode.to_boolean then
									l_tmp___7 := 1
								else
									l_tmp___7 := 0
								end
							else
								l_tmp___7 := 0
							end
							globals_inst.may_garbage_collect := l_tmp___7
							if globals_inst.exmode_active.to_boolean then
								if a_noexmode.to_boolean then
									js.return
								end
								if not js.return_called then
									ex_docmd_inst.do_exmode ((globals_inst.exmode_active = 2).to_integer)
								end
							else
								normal_inst.normal_cmd (l_oa, 1)
							end
				when 37 then -- if done
							l_pos := -1 + 5 -- back to loop condition
				when 38 then -- loop done
						if not js.return_called then
						end
				when 39 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		rescue
			if attached {CE_EXCEPTION} (create {EXCEPTION_MANAGER}).last_exception as ex then
				if ex.routine = $main_loop then
					l_pos := ex.position + 1
					retry
				end
				ex.re_raise
			end
			end

	main_msg (a_s: CE_POINTER [INTEGER_8])
		do
			message_inst.mch_msg (ce_string ("   "))
			message_inst.mch_msg (a_s)
			message_inst.mch_msg (ce_string ("%N"))
		end

	main_start_gui
		do
			gui_inst.gui.item.starting := 1
		end

	mainerr (a_n: INTEGER_32; a_str___1: CE_POINTER [NATURAL_8])
		do
			os_unix_inst.reset_signals
			message_inst.mch_errmsg (version_inst.longVersion)
			message_inst.mch_errmsg (ce_string ("%N"))
			message_inst.mch_errmsg ((gettext (main_errors[a_n])))
			if not a_str___1.is_void then
				message_inst.mch_errmsg (ce_string (": %""))
				message_inst.mch_errmsg (create {CE_POINTER [INTEGER_8]}.make_cast (a_str___1))
				message_inst.mch_errmsg (ce_string ("%""))
			end
			message_inst.mch_errmsg ((gettext (ce_string ("%NMore info with: %"vim -h%"%N"))))
			os_unix_inst.mch_exit (1)
		end

	mainerr_arg_missing (a_str___1: CE_POINTER [NATURAL_8])
		do
			mainerr (2, a_str___1)
		end

	parse_command_name (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_initstr: CE_POINTER [NATURAL_8]
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: INTEGER_32
			l_tmp___3: INTEGER_32
		do
			create l_initstr.make

			l_initstr := misc1_inst.gettail (create {CE_POINTER [NATURAL_8]}.make_cast (a_parmp.item.argv[0]))
			eval_inst.set_vim_var_string (26, l_initstr, -1)
			if (l_initstr[0]).to_integer_32 < 65 then
				l_tmp := (l_initstr[0]).to_integer_32
			elseif (l_initstr[0]).to_integer_32 > 90 then
				l_tmp := (l_initstr[0]).to_integer_32
			else
				l_tmp := (l_initstr[0]).to_integer_32 + 32
			end
			if l_tmp = 114 then
				globals_inst.restricted := 1
				l_initstr := l_initstr + 1
			end
			if (l_initstr[0]).to_integer_32 < 65 then
				l_tmp___0 := (l_initstr[0]).to_integer_32
			elseif (l_initstr[0]).to_integer_32 > 90 then
				l_tmp___0 := (l_initstr[0]).to_integer_32
			else
				l_tmp___0 := (l_initstr[0]).to_integer_32 + 32
			end
			if l_tmp___0 = 101 then
				if (l_initstr[1]).to_integer_32 < 65 then
					l_tmp___1 := (l_initstr[1]).to_integer_32
				elseif (l_initstr[1]).to_integer_32 > 90 then
					l_tmp___1 := (l_initstr[1]).to_integer_32
				else
					l_tmp___1 := (l_initstr[1]).to_integer_32 + 32
				end
				if l_tmp___1 = 118 then
					gui_inst.gui.item.starting := 1
					a_parmp.item.evim_mode := 1
					l_initstr := l_initstr + 1
				else
					if (l_initstr[1]).to_integer_32 < 65 then
						l_tmp___2 := (l_initstr[1]).to_integer_32
					elseif (l_initstr[1]).to_integer_32 > 90 then
						l_tmp___2 := (l_initstr[1]).to_integer_32
					else
						l_tmp___2 := (l_initstr[1]).to_integer_32 + 32
					end
					if l_tmp___2 = 103 then
						gui_inst.gui.item.starting := 1
						a_parmp.item.evim_mode := 1
						l_initstr := l_initstr + 1
					end
				end
			end
			if (l_initstr[0]).to_integer_32 < 65 then
				l_tmp___3 := (l_initstr[0]).to_integer_32
			elseif (l_initstr[0]).to_integer_32 > 90 then
				l_tmp___3 := (l_initstr[0]).to_integer_32
			else
				l_tmp___3 := (l_initstr[0]).to_integer_32 + 32
			end
			if l_tmp___3 = 103 then
				main_start_gui
				l_initstr := l_initstr + 1
			end
			if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_initstr), ce_string ("view"), (4).to_natural_32)) = 0 then
				globals_inst.readonlymode := 1
				globals_inst.curbuf.item.b_p_ro := 1
				option_inst.p_uc.item := 10_000
				l_initstr := l_initstr + (4)
			elseif (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_initstr), ce_string ("vim"), (3).to_natural_32)) = 0 then
				l_initstr := l_initstr + (3)
			end
			if (strcasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_initstr), ce_string ("diff"))) = 0 then
				a_parmp.item.diff_mode := 1
			end
			if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast (l_initstr), ce_string ("ex"), (2).to_natural_32)) = 0 then
				if (strncasecmp (create {CE_POINTER [INTEGER_8]}.make_cast ((l_initstr + 2)), ce_string ("im"), (2).to_natural_32)) = 0 then
					globals_inst.exmode_active := 2
				else
					globals_inst.exmode_active := 1
				end
				option_inst.change_compatible (1)
			end
		end

	prepare_server (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_tmp___0: CE_POINTER [ANY]
			l_tmp___2: CE_POINTER [ANY]
			l_p___0: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_pos: INTEGER_32
		do
			create l_tmp___0.make
			create l_tmp___2.make
			create l_p___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (gui_inst.gui.item.in_use).to_boolean then
						l_tmp___2 := (gui_gtk_x11_inst.gui_mch_get_display)
					else
						l_tmp___2 := globals_inst.xterm_dpy.item
					end
					if l_tmp___2.is_void then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if (a_parmp.item.servername).is_void then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						if not ((gui_inst.gui.item.in_use).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						if (getuid) /= {NATURAL_32} 0 then
							l_pos := -1 + 6 -- goto _L
						else
							l_pos := -1 + 5 -- goto _L___0
						end
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else: | _L___0:
						if (a_parmp.item.serverName_arg).is_void then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L:
						if (gui_inst.gui.item.in_use).to_boolean then
							l_tmp___0 := (gui_gtk_x11_inst.gui_mch_get_display)
						else
							l_tmp___0 := globals_inst.xterm_dpy.item
						end
						if_xcmdsrv_inst.serverRegisterName (l_tmp___0, a_parmp.item.servername).do_nothing
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (a_parmp.item.servername))
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("register server name"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						globals_inst.serverDelayedStartName := a_parmp.item.servername
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						globals_inst.serverDelayedStartName := a_parmp.item.servername
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else:
						globals_inst.serverDelayedStartName := a_parmp.item.servername
				when 13 then
					if not (a_parmp.item.serverStr).is_void then
						server_to_input_buf ((serverConvert (a_parmp.item.serverStrEnc, a_parmp.item.serverStr, l_p___0)))
						misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_p___0.item))
					end
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	process_env (a_env: CE_POINTER [NATURAL_8]; a_is_viminit: INTEGER_32): INTEGER_32
		local
			l_initstr: CE_POINTER [NATURAL_8]
			l_save_sourcing_name: CE_POINTER [NATURAL_8]
			l_save_sourcing_lnum: INTEGER_32
			l_save_sid: INTEGER_32
			js: JUMP_STATE
		do
			create l_initstr.make
			create l_save_sourcing_name.make

			l_initstr := create {CE_POINTER [NATURAL_8]}.make_cast ((getenv (create {CE_POINTER [INTEGER_8]}.make_cast (a_env))))
			if not l_initstr.is_void then
				if (l_initstr.item).to_integer_32 /= 0 then
					if a_is_viminit.to_boolean then
						option_inst.vimrc_found (create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer))
					end
					l_save_sourcing_name := globals_inst.sourcing_name
					l_save_sourcing_lnum := globals_inst.sourcing_lnum
					globals_inst.sourcing_name := a_env
					globals_inst.sourcing_lnum := (0).to_integer_32
					l_save_sid := globals_inst.current_SID
					globals_inst.current_SID := -4
					ex_docmd_inst.do_cmdline_cmd (l_initstr).do_nothing
					globals_inst.sourcing_name := l_save_sourcing_name
					globals_inst.sourcing_lnum := l_save_sourcing_lnum
					globals_inst.current_SID := l_save_sid
					Result := 1
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	read_stdin
		local
			l_i___0: INTEGER_32
		do
			globals_inst.swap_exists_action := 1
			globals_inst.no_wait_return := 1
			l_i___0 := globals_inst.msg_didany
			buffer_inst.set_buflisted (1)
			buffer_inst.open_buffer (1, create {CE_POINTER [PD_EXARG]}.make_shared (default_pointer), 0).do_nothing
			globals_inst.no_wait_return := 0
			globals_inst.msg_didany := l_i___0
			if not globals_inst.time_fd.is_void then
				time_msg (ce_string ("reading stdin"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
			end
			check_swap_exists_action
			close (0).do_nothing
			globals_inst.ignored := dup (2)
		end

	serverConvert (a_client_enc: CE_POINTER [NATURAL_8]; a_data: CE_POINTER [NATURAL_8]; a_tofree: CE_POINTER [CE_POINTER [NATURAL_8]]): CE_POINTER [NATURAL_8]
		local
			l_res: CE_POINTER [NATURAL_8]
			l_vimconv: CE_ARRAY [PD_VIMCONV_T]
		do
			create l_res.make
			create l_vimconv.make (<<1>>)

			l_res := a_data
			a_tofree.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			if not a_client_enc.is_void then
				if not (option_inst.p_enc.item).is_void then
					l_vimconv.item.vc_type := 0
					if (mbyte_inst.convert_setup (l_vimconv, a_client_enc, option_inst.p_enc.item)) /= 0 then
						if l_vimconv.item.vc_type /= 0 then
							l_res := mbyte_inst.string_convert (l_vimconv, a_data, create {CE_POINTER [INTEGER_32]}.make_shared (default_pointer))
							if l_res.is_void then
								l_res := a_data
							else
								a_tofree.item := l_res
							end
						end
					end
					mbyte_inst.convert_setup (l_vimconv, create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer), create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)).do_nothing
				end
			end
			Result := l_res
		end

	serverMakeName (a_arg: CE_POINTER [NATURAL_8]; a_cmd: CE_POINTER [INTEGER_8]): CE_POINTER [NATURAL_8]
		local
			l_p___0: CE_POINTER [NATURAL_8]
			l_pos: INTEGER_32
		do
			create l_p___0.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if a_arg.is_void then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if (a_arg.item).to_integer_32 /= 0 then
							l_p___0 := misc2_inst.vim_strsave_up (a_arg)
						else
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_p___0 := misc2_inst.vim_strsave_up ((misc1_inst.gettail (create {CE_POINTER [NATURAL_8]}.make_cast (a_cmd))))
						if not l_p___0.is_void then
							if not (misc2_inst.vim_strchr (l_p___0, ('.').code)).is_void then
								(misc2_inst.vim_strchr (l_p___0, ('.').code)).item := (('%/0/').code).to_natural_8
							end
						end
				when 4 then
					Result := l_p___0
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	server_to_input_buf (a_str___1: CE_POINTER [NATURAL_8])
		local
			l_str___1: CE_POINTER [NATURAL_8]
			l_ptr: CE_ARRAY [CE_POINTER [NATURAL_8]]
			l_cpo_save: CE_POINTER [NATURAL_8]
		do
			create l_str___1.make
			create l_ptr.make (<<1>>)
			create l_cpo_save.make

			l_str___1 := a_str___1
			l_ptr.item := create {CE_POINTER [NATURAL_8]}.make_shared (default_pointer)
			l_cpo_save := option_inst.p_cpo.item
			option_inst.p_cpo.item := create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("Bk"))
			l_str___1 := term_inst.replace_termcodes (l_str___1, l_ptr, 0, 1, 0)
			option_inst.p_cpo.item := l_cpo_save
			if (l_ptr.item.item).to_integer_32 /= 0 then
				if globals_inst.typebuf.tb_maplen < globals_inst.typebuf.tb_len then
					getchar_inst.del_typebuf (globals_inst.typebuf.tb_len - globals_inst.typebuf.tb_maplen, globals_inst.typebuf.tb_maplen)
				end
				getchar_inst.ins_typebuf (l_str___1, -1, globals_inst.typebuf.tb_len, 1, 0).do_nothing
				globals_inst.typebuf_was_filled := 1
			end
			misc2_inst.vim_free (create {CE_POINTER [ANY]}.make_cast (l_ptr.item))
		end

	source_startup_scripts (a_parmp: CE_POINTER [PD_MPARM_T])
		local
			l_i___0: INTEGER_32
			l_tmp___6: INTEGER_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if (a_parmp.item.evim_mode).to_boolean then
						ex_cmds2_inst.do_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$VIMRUNTIME/evim.vim")), 0, 0).do_nothing
						if not globals_inst.time_fd.is_void then
							time_msg (ce_string ("source evim file"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
						end
					end
					if (a_parmp.item.use_vimrc).is_void then
						l_pos := -1 + 9 -- skip if block
					end
				when 1 then -- if:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_parmp.item.use_vimrc), ce_string ("NONE"))) /= 0 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 4 then -- else:
						if (strcmp (create {CE_POINTER [INTEGER_8]}.make_cast (a_parmp.item.use_vimrc), ce_string ("NORC"))) /= 0 then
							l_pos := -1 + 7 -- skip if block
						end
				when 5 then -- if: | _L:
						if globals_inst.use_gvimrc.is_void then
							globals_inst.use_gvimrc := a_parmp.item.use_vimrc
						end
						if (a_parmp.item.use_vimrc[2]).to_integer_32 = 78 then
							option_inst.p_lpl.item := 0
						end
				when 6 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 7 then -- else:
						if (ex_cmds2_inst.do_source (a_parmp.item.use_vimrc, 0, 0)) /= 1 then
							message_inst.emsg2 (create {CE_POINTER [NATURAL_8]}.make_cast ((gettext (ce_string ("E282: Cannot read from %"%%s%"")))), a_parmp.item.use_vimrc).do_nothing
						end
				when 8 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 10
				when 9 then -- else:
						if not globals_inst.silent_mode.to_boolean then
							ex_cmds2_inst.do_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$VIM/vimrc")), 0, 0).do_nothing
							if (process_env (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("VIMINIT")), 1)) /= 1 then
								if (ex_cmds2_inst.do_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.vimrc")), 1, 1)) = 0 then
									if (process_env (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("EXINIT")), 0)) = 0 then
										if (ex_cmds2_inst.do_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.exrc")), 0, 0)) = 0 then
											l_tmp___6 := 1
										else
											l_tmp___6 := 0
										end
									else
										l_tmp___6 := 0
									end
								else
									l_tmp___6 := 0
								end
							end
							if (option_inst.p_exrc.item).to_boolean then
								if not (file_owned (ce_string (".vimrc"))).to_boolean then
									globals_inst.secure := option_inst.p_secure.item
								end
								l_i___0 := 0
								if (misc1_inst.fullpathcmp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.vimrc")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".vimrc")), 0)) /= 1 then
									if (misc1_inst.fullpathcmp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$VIM/vimrc")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".vimrc")), 0)) /= 1 then
										l_i___0 := ex_cmds2_inst.do_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".vimrc")), 1, 1)
									end
								end
								if l_i___0 = 0 then
									if (file_owned (ce_string (".exrc"))).to_boolean then
										globals_inst.secure := 0
									else
										globals_inst.secure := option_inst.p_secure.item
									end
									if (misc1_inst.fullpathcmp (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string ("$HOME/.exrc")), create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".exrc")), 0)) /= 1 then
										ex_cmds2_inst.do_source (create {CE_POINTER [NATURAL_8]}.make_cast (ce_string (".exrc")), 0, 0).do_nothing
									end
								end
							end
							if globals_inst.secure = 2 then
								globals_inst.need_wait_return := 1
							end
							globals_inst.secure := 0
						end
				when 10 then
					if not globals_inst.time_fd.is_void then
						time_msg (ce_string ("sourcing vimrc file(s)"), create {CE_POINTER [ANY]}.make_shared (default_pointer))
					end
				when 11 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	time_diff (a_then: CE_POINTER [SD_TIMEVAL]; a_now: CE_POINTER [SD_TIMEVAL])
		local
			l_usec: INTEGER_32
			l_msec: INTEGER_32
			l_tmp: INTEGER_32
		do
			l_usec := a_now.item.tv_usec - a_then.item.tv_usec
			l_msec := (a_now.item.tv_sec - a_then.item.tv_sec) * 1_000 + l_usec // 1_000
			l_usec := l_usec \\ (1_000)
			if l_usec >= 0 then
				l_tmp := l_usec
			else
				l_tmp := l_usec + 1_000
			end
			fprintf ([globals_inst.time_fd, ce_string ("%%03ld.%%03ld"), l_msec, l_tmp]).do_nothing
		end

	time_msg (a_mesg: CE_POINTER [INTEGER_8]; a_tv_start: CE_POINTER [ANY])
		local
			l_now: CE_ARRAY [SD_TIMEVAL]
		do
			create l_now.make (<<1>>)

			if not globals_inst.time_fd.is_void then
				if not (strstr (a_mesg, ce_string ("STARTING"))).is_void then
					gettimeofday (start, create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
					prev_timeval.item := (start.item).twin
					fprintf ([globals_inst.time_fd, ce_string ("%N%Ntimes in msec%N")]).do_nothing
					fprintf ([globals_inst.time_fd, ce_string (" clock   self+sourced   self:  sourced script%N")]).do_nothing
					fprintf ([globals_inst.time_fd, ce_string (" clock   elapsed:              other lines%N%N")]).do_nothing
				end
				gettimeofday (l_now, create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing
				time_diff (start, l_now)
				if not a_tv_start.is_void then
					fprintf ([globals_inst.time_fd, ce_string ("  ")]).do_nothing
					time_diff (create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_start), l_now)
				end
				fprintf ([globals_inst.time_fd, ce_string ("  ")]).do_nothing
				time_diff (prev_timeval, l_now)
				prev_timeval.item := (l_now.item).twin
				fprintf ([globals_inst.time_fd, ce_string (": %%s%N"), a_mesg]).do_nothing
			end
		end

	time_pop (a_tp: CE_POINTER [ANY])
		do
			prev_timeval.item.tv_usec := prev_timeval.item.tv_usec - ((create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tp)).item.tv_usec)
			prev_timeval.item.tv_sec := prev_timeval.item.tv_sec - ((create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tp)).item.tv_sec)
			if prev_timeval.item.tv_usec < 0 then
				prev_timeval.item.tv_usec := prev_timeval.item.tv_usec + (1_000_000)
				prev_timeval.item.tv_sec := (prev_timeval.item.tv_sec) - 1
			end
		end

	time_push (a_tv_rel: CE_POINTER [ANY]; a_tv_start: CE_POINTER [ANY])
		do
			(create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item := (prev_timeval.item).twin
			gettimeofday (prev_timeval, create {CE_POINTER [SD_TIMEZONE]}.make_shared (default_pointer)).do_nothing;
			(create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec := prev_timeval.item.tv_usec - (create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec;
			(create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec := prev_timeval.item.tv_sec - (create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec
			if (create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec < 0 then
				(create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec := (create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_usec + (1_000_000);
				(create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec := ((create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_rel)).item.tv_sec) - 1
			end
			(create {CE_POINTER [SD_TIMEVAL]}.make_cast (a_tv_start)).item := (prev_timeval.item).twin
		end

	usage
		local
			l_i___0: INTEGER_32
			js: JUMP_STATE
		do
			os_unix_inst.reset_signals
			message_inst.mch_msg (version_inst.longVersion)
			message_inst.mch_msg ((gettext (ce_string ("%N%Nusage:"))))
			l_i___0 := 0
			from
			until
				js.loop_done
			loop
				message_inst.mch_msg ((gettext (ce_string (" vim [arguments] "))))
				message_inst.mch_msg ((gettext (use[l_i___0])))
				if l_i___0.to_natural_32 = ({PLATFORM}.Pointer_bytes.to_natural_32 * (4).to_natural_32) // {PLATFORM}.Pointer_bytes.to_natural_32 - {NATURAL_32} 1 then
					js.break
				end
				if not js.loop_jumped then
					message_inst.mch_msg ((gettext (ce_string ("%N   or:"))))
					l_i___0 := l_i___0 + 1
				end
			end
			message_inst.mch_msg ((gettext (ce_string ("%N%NArguments:%N"))))
			main_msg ((gettext (ce_string ("--%T%T%TOnly file names after this"))))
			main_msg ((gettext (ce_string ("-g%T%T%TRun using GUI (like %"gvim%")"))))
			main_msg ((gettext (ce_string ("-f  or  --nofork%TForeground: Don%'t fork when starting GUI"))))
			main_msg ((gettext (ce_string ("-v%T%T%TVi mode (like %"vi%")"))))
			main_msg ((gettext (ce_string ("-e%T%T%TEx mode (like %"ex%")"))))
			main_msg ((gettext (ce_string ("-s%T%T%TSilent (batch) mode (only for %"ex%")"))))
			main_msg ((gettext (ce_string ("-d%T%T%TDiff mode (like %"vimdiff%")"))))
			main_msg ((gettext (ce_string ("-y%T%T%TEasy mode (like %"evim%", modeless)"))))
			main_msg ((gettext (ce_string ("-R%T%T%TReadonly mode (like %"view%")"))))
			main_msg ((gettext (ce_string ("-Z%T%T%TRestricted mode (like %"rvim%")"))))
			main_msg ((gettext (ce_string ("-m%T%T%TModifications (writing files) not allowed"))))
			main_msg ((gettext (ce_string ("-M%T%T%TModifications in text not allowed"))))
			main_msg ((gettext (ce_string ("-b%T%T%TBinary mode"))))
			main_msg ((gettext (ce_string ("-l%T%T%TLisp mode"))))
			main_msg ((gettext (ce_string ("-C%T%T%TCompatible with Vi: %'compatible%'"))))
			main_msg ((gettext (ce_string ("-N%T%T%TNot fully Vi compatible: %'nocompatible%'"))))
			main_msg ((gettext (ce_string ("-V[N][fname]%T%TBe verbose [level N] [log messages to fname]"))))
			main_msg ((gettext (ce_string ("-D%T%T%TDebugging mode"))))
			main_msg ((gettext (ce_string ("-n%T%T%TNo swap file, use memory only"))))
			main_msg ((gettext (ce_string ("-r%T%T%TList swap files and exit"))))
			main_msg ((gettext (ce_string ("-r (with file name)%TRecover crashed session"))))
			main_msg ((gettext (ce_string ("-L%T%T%TSame as -r"))))
			main_msg ((gettext (ce_string ("-T <terminal>%TSet terminal type to <terminal>"))))
			main_msg ((gettext (ce_string ("-u <vimrc>%T%TUse <vimrc> instead of any .vimrc"))))
			main_msg ((gettext (ce_string ("-U <gvimrc>%T%TUse <gvimrc> instead of any .gvimrc"))))
			main_msg ((gettext (ce_string ("--noplugin%T%TDon%'t load plugin scripts"))))
			main_msg ((gettext (ce_string ("-p[N]%T%TOpen N tab pages (default: one for each file)"))))
			main_msg ((gettext (ce_string ("-o[N]%T%TOpen N windows (default: one for each file)"))))
			main_msg ((gettext (ce_string ("-O[N]%T%TLike -o but split vertically"))))
			main_msg ((gettext (ce_string ("+%T%T%TStart at end of file"))))
			main_msg ((gettext (ce_string ("+<lnum>%T%TStart at line <lnum>"))))
			main_msg ((gettext (ce_string ("--cmd <command>%TExecute <command> before loading any vimrc file"))))
			main_msg ((gettext (ce_string ("-c <command>%T%TExecute <command> after loading the first file"))))
			main_msg ((gettext (ce_string ("-S <session>%T%TSource file <session> after loading the first file"))))
			main_msg ((gettext (ce_string ("-s <scriptin>%TRead Normal mode commands from file <scriptin>"))))
			main_msg ((gettext (ce_string ("-w <scriptout>%TAppend all typed commands to file <scriptout>"))))
			main_msg ((gettext (ce_string ("-W <scriptout>%TWrite all typed commands to file <scriptout>"))))
			main_msg ((gettext (ce_string ("-x%T%T%TEdit encrypted files"))))
			main_msg ((gettext (ce_string ("-X%T%T%TDo not connect to X server"))))
			main_msg ((gettext (ce_string ("--remote <files>%TEdit <files> in a Vim server if possible"))))
			main_msg ((gettext (ce_string ("--remote-silent <files>  Same, don%'t complain if there is no server"))))
			main_msg ((gettext (ce_string ("--remote-wait <files>  As --remote but wait for files to have been edited"))))
			main_msg ((gettext (ce_string ("--remote-wait-silent <files>  Same, don%'t complain if there is no server"))))
			main_msg ((gettext (ce_string ("--remote-tab[-wait][-silent] <files>  As --remote but use tab page per file"))))
			main_msg ((gettext (ce_string ("--remote-send <keys>%TSend <keys> to a Vim server and exit"))))
			main_msg ((gettext (ce_string ("--remote-expr <expr>%TEvaluate <expr> in a Vim server and print result"))))
			main_msg ((gettext (ce_string ("--serverlist%T%TList available Vim server names and exit"))))
			main_msg ((gettext (ce_string ("--servername <name>%TSend to/become the Vim server <name>"))))
			main_msg ((gettext (ce_string ("--startuptime <file>%TWrite startup timing messages to <file>"))))
			main_msg ((gettext (ce_string ("-i <viminfo>%T%TUse <viminfo> instead of .viminfo"))))
			main_msg ((gettext (ce_string ("-h  or  --help%TPrint Help (this message) and exit"))))
			main_msg ((gettext (ce_string ("--version%T%TPrint version information and exit"))))
			message_inst.mch_msg ((gettext (ce_string ("%NArguments recognised by gvim (GTK+ version):%N"))))
			main_msg ((gettext (ce_string ("-font <font>%T%TUse <font> for normal text (also: -fn)"))))
			main_msg ((gettext (ce_string ("-geometry <geom>%TUse <geom> for initial geometry (also: -geom)"))))
			main_msg ((gettext (ce_string ("-reverse%T%TUse reverse video (also: -rv)"))))
			main_msg ((gettext (ce_string ("-display <display>%TRun vim on <display> (also: --display)"))))
			main_msg ((gettext (ce_string ("--role <role>%TSet a unique role to identify the main window"))))
			main_msg ((gettext (ce_string ("--socketid <xid>%TOpen Vim inside another GTK widget"))))
			os_unix_inst.mch_exit (0)
		end

end
