class
	SD_GTKIMAGEICONSETDATA

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create icon_set.make
		end

feature {ANY} -- fields

	icon_set: CE_POINTER [ANY] assign set_icon_set

feature {ANY} -- setters

	set_icon_set (a_icon_set: CE_POINTER [ANY])
		do
			icon_set := a_icon_set
			update_memory_field ("icon_set")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			icon_set := a_other.icon_set
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				icon_set.is_equal (a_other.icon_set)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("icon_set")
				>>)
			init_structure_info
		end

end
