class
	PD_NT

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create sub.make
		end

feature {ANY} -- fields

	main: NATURAL_32 assign set_main

	sub: PD_PL_WINNT_SUBSTATE assign set_sub

feature {ANY} -- setters

	set_main (a_main: NATURAL_32)
		do
			main := a_main
			update_memory_field ("main")
		end

	set_sub (a_sub: PD_PL_WINNT_SUBSTATE)
		do
			sub := a_sub
			update_memory_field ("sub")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			main := a_other.main
			sub := a_other.sub.twin
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				main = a_other.main and
				sub.is_equal (a_other.sub)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("main"),
					create {CE_STRUCTURE_FIELD}.make ("sub")
				>>)
			init_structure_info
		end

end
