class
	PD_TZINFO

inherit
	CE_CLASS
		redefine
			make,
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {NONE}

	make
		do
			create name.make (<<5>>)
		end

feature {ANY} -- fields

	name: CE_ARRAY [INTEGER_8]

	offset: INTEGER_32 assign set_offset

feature {ANY} -- setters

	set_offset (a_offset: INTEGER_32)
		do
			offset := a_offset
			update_memory_field ("offset")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			name := a_other.name.twin
			offset := a_other.offset
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				name.is_equal (a_other.name) and
				offset = a_other.offset
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make_arrayfield ("name", <<5>>),
					create {CE_STRUCTURE_FIELD}.make ("offset")
				>>)
			init_structure_info
		end

end
