class
	P_VERSION

inherit
	LIBCURL_DATA
		redefine
			default_create
		end
	S_STDIO
	S_STDLIB
	S_STRING
	S_CTYPE
	S_SYS_STAT
	S_TIME
	S_UNISTD
	S_FCNTL
	S_SYS_TIME
	S_ARPA_INET
	S_SIGNAL
	S_LIBGEN
	S_SYS_SOCKET
	S_BITS_ERRNO
	S_NETINET_IN
	S_IFADDRS
	S_PWD
	S_SYS_POLL
	S_NETDB

feature {NONE} -- Initialization

	default_create
		do
			create protocols___0.make (<<12>>)
			create version.make (<<200>>)
			create version_info.make (<<1>>)
		end

feature {ANY} -- attributes

	protocols___0: CE_ARRAY [CE_POINTER [INTEGER_8]]

	version: CE_ARRAY [INTEGER_8]

	version_info: CE_ARRAY [PD_CURL_VERSION_INFO_DATA]

feature {ANY} -- routines

	curl_version: CE_POINTER [INTEGER_8]
		local
			l_ptr: CE_POINTER [INTEGER_8]
			l_len: NATURAL_32
			l_left: NATURAL_32
		do
			create l_ptr.make

			l_ptr := version
			l_left := ({PLATFORM}.Integer_8_bytes.to_natural_32 * (200).to_natural_32)
			strcpy (l_ptr, ce_string ("libcurl/7.21.2")).do_nothing
			l_len := strlen (l_ptr)
			l_left := l_left - l_len
			l_ptr := l_ptr + l_len.to_integer_32
			if l_left > {NATURAL_32} 1 then
				l_len := (0).to_natural_32
				if l_len > {NATURAL_32} 0 then
					l_ptr[0] := ((' ').code).to_integer_8
					l_len := l_len + 1
					l_left := l_left - l_len
					l_ptr := l_ptr + l_len.to_integer_32
				end
			end
			Result := version
		end

	curl_version_info (a_stamp: NATURAL_32): CE_POINTER [PD_CURL_VERSION_INFO_DATA]
		do
			Result := version_info
		end

end
