deferred class
	S_TIME

inherit
	ANY
		undefine
			default_create
		end

feature {ANY} -- routines

	clock_gettime (a___clock_id: INTEGER_32; a___tp: CE_POINTER [SD_TIMESPEC]): INTEGER_32
		do
			Result := c_clock_gettime (a___clock_id, a___tp.c_pointer)
		end

	c_clock_gettime (a___clock_id: INTEGER_32; a___tp: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return clock_gettime($a___clock_id, $a___tp);"
		end

	gmtime_r (a___timer: CE_POINTER [INTEGER_32]; a___tp: CE_POINTER [SD_TM]): CE_POINTER [SD_TM]
		do
			create Result.make_shared (c_gmtime_r (a___timer.c_pointer, a___tp.c_pointer))
		end

	c_gmtime_r (a___timer: POINTER; a___tp: POINTER): POINTER
		external
			"C inline use <libcurl.h>"
		alias
			"return gmtime_r($a___timer, $a___tp);"
		end

	time (a___timer: CE_POINTER [INTEGER_32]): INTEGER_32
		do
			Result := c_time (a___timer.c_pointer)
		end

	c_time (a___timer: POINTER): INTEGER_32
		external
			"C inline use <libcurl.h>"
		alias
			"return time($a___timer);"
		end

end
