class
	PD_GMP_PI1_T

inherit
	CE_CLASS
		redefine
			copy,
			is_equal
		end

create
	make,
	make_shared

feature {ANY} -- fields

	inv32: NATURAL_32 assign set_inv32

feature {ANY} -- setters

	set_inv32 (a_inv32: NATURAL_32)
		do
			inv32 := a_inv32
			update_memory_field ("inv32")
		end

feature {ANY}

	copy (a_other: like Current)
		do
			inv32 := a_other.inv32
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result :=
				inv32 = a_other.inv32
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		once ("PROCESS")
			create Result.make_struct (<<
					create {CE_STRUCTURE_FIELD}.make ("inv32")
				>>)
			init_structure_info
		end

end
