frozen class
	LIBGMP_INITIALIZER_SLICE1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {LIBGMP_INITIALIZER}

	initialize
		do
			errno_inst.gmp_errno := 0
			memory_inst.gmp_allocate_func := memory_inst.gmp_default_allocate_address
			memory_inst.gmp_reallocate_func := memory_inst.gmp_default_reallocate_address
			memory_inst.gmp_free_func := memory_inst.gmp_default_free_address
			mp_bpl_inst.gmp_bits_per_limb := 32
			mp_bpl_inst.gmp_0 := 0
			mp_dv_tab_inst.gmp_digit_value_tab[0] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[1] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[2] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[3] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[4] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[5] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[6] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[7] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[8] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[9] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[10] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[11] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[12] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[13] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[14] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[15] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[16] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[17] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[18] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[19] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[20] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[21] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[22] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[23] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[24] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[25] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[26] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[27] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[28] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[29] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[30] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[31] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[32] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[33] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[34] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[35] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[36] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[37] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[38] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[39] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[40] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[41] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[42] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[43] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[44] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[45] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[46] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[47] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[48] := (0).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[49] := (1).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[50] := (2).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[51] := (3).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[52] := (4).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[53] := (5).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[54] := (6).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[55] := (7).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[56] := (8).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[57] := (9).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[58] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[59] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[60] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[61] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[62] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[63] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[64] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[65] := (10).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[66] := (11).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[67] := (12).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[68] := (13).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[69] := (14).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[70] := (15).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[71] := (16).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[72] := (17).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[73] := (18).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[74] := (19).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[75] := (20).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[76] := (21).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[77] := (22).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[78] := (23).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[79] := (24).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[80] := (25).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[81] := (26).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[82] := (27).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[83] := (28).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[84] := (29).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[85] := (30).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[86] := (31).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[87] := (32).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[88] := (33).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[89] := (34).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[90] := (35).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[91] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[92] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[93] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[94] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[95] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[96] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[97] := (10).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[98] := (11).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[99] := (12).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[100] := (13).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[101] := (14).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[102] := (15).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[103] := (16).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[104] := (17).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[105] := (18).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[106] := (19).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[107] := (20).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[108] := (21).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[109] := (22).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[110] := (23).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[111] := (24).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[112] := (25).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[113] := (26).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[114] := (27).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[115] := (28).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[116] := (29).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[117] := (30).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[118] := (31).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[119] := (32).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[120] := (33).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[121] := (34).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[122] := (35).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[123] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[124] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[125] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[126] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[127] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[128] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[129] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[130] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[131] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[132] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[133] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[134] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[135] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[136] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[137] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[138] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[139] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[140] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[141] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[142] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[143] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[144] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[145] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[146] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[147] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[148] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[149] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[150] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[151] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[152] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[153] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[154] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[155] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[156] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[157] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[158] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[159] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[160] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[161] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[162] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[163] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[164] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[165] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[166] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[167] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[168] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[169] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[170] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[171] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[172] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[173] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[174] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[175] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[176] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[177] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[178] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[179] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[180] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[181] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[182] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[183] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[184] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[185] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[186] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[187] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[188] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[189] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[190] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[191] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[192] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[193] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[194] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[195] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[196] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[197] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[198] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[199] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[200] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[201] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[202] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[203] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[204] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[205] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[206] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[207] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[208] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[209] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[210] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[211] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[212] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[213] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[214] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[215] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[216] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[217] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[218] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[219] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[220] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[221] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[222] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[223] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[224] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[225] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[226] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[227] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[228] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[229] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[230] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[231] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[232] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[233] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[234] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[235] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[236] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[237] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[238] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[239] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[240] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[241] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[242] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[243] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[244] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[245] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[246] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[247] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[248] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[249] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[250] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[251] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[252] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[253] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[254] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[255] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[256] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[257] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[258] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[259] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[260] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[261] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[262] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[263] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[264] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[265] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[266] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[267] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[268] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[269] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[270] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[271] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[272] := (0).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[273] := (1).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[274] := (2).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[275] := (3).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[276] := (4).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[277] := (5).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[278] := (6).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[279] := (7).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[280] := (8).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[281] := (9).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[282] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[283] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[284] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[285] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[286] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[287] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[288] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[289] := (10).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[290] := (11).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[291] := (12).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[292] := (13).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[293] := (14).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[294] := (15).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[295] := (16).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[296] := (17).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[297] := (18).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[298] := (19).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[299] := (20).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[300] := (21).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[301] := (22).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[302] := (23).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[303] := (24).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[304] := (25).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[305] := (26).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[306] := (27).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[307] := (28).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[308] := (29).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[309] := (30).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[310] := (31).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[311] := (32).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[312] := (33).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[313] := (34).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[314] := (35).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[315] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[316] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[317] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[318] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[319] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[320] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[321] := (36).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[322] := (37).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[323] := (38).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[324] := (39).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[325] := (40).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[326] := (41).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[327] := (42).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[328] := (43).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[329] := (44).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[330] := (45).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[331] := (46).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[332] := (47).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[333] := (48).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[334] := (49).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[335] := (50).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[336] := (51).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[337] := (52).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[338] := (53).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[339] := (54).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[340] := (55).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[341] := (56).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[342] := (57).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[343] := (58).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[344] := (59).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[345] := (60).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[346] := (61).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[347] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[348] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[349] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[350] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[351] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[352] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[353] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[354] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[355] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[356] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[357] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[358] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[359] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[360] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[361] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[362] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[363] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[364] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[365] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[366] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[367] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[368] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[369] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[370] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[371] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[372] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[373] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[374] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[375] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[376] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[377] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[378] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[379] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[380] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[381] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[382] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[383] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[384] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[385] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[386] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[387] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[388] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[389] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[390] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[391] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[392] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[393] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[394] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[395] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[396] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[397] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[398] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[399] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[400] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[401] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[402] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[403] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[404] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[405] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[406] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[407] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[408] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[409] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[410] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[411] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[412] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[413] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[414] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[415] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[416] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[417] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[418] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[419] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[420] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[421] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[422] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[423] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[424] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[425] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[426] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[427] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[428] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[429] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[430] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[431] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[432] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[433] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[434] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[435] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[436] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[437] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[438] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[439] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[440] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[441] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[442] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[443] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[444] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[445] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[446] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[447] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[448] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[449] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[450] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[451] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[452] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[453] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[454] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[455] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[456] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[457] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[458] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[459] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[460] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[461] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[462] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[463] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[464] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[465] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[466] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[467] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[468] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[469] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[470] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[471] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[472] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[473] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[474] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[475] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[476] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[477] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[478] := (255).to_natural_8
			mp_dv_tab_inst.gmp_digit_value_tab[479] := (255).to_natural_8
			randlc2s_inst.gmp_rand_lc_scheme[0].m2exp := {NATURAL_32} 32
			randlc2s_inst.gmp_rand_lc_scheme[0].astr := ce_string ("29CF535")
			randlc2s_inst.gmp_rand_lc_scheme[0].c := {NATURAL_32} 1
			randlc2s_inst.gmp_rand_lc_scheme[1].m2exp := {NATURAL_32} 33
			randlc2s_inst.gmp_rand_lc_scheme[1].astr := ce_string ("51F666D")
			randlc2s_inst.gmp_rand_lc_scheme[1].c := {NATURAL_32} 1
			randlc2s_inst.gmp_rand_lc_scheme[2].m2exp := {NATURAL_32} 34
			randlc2s_inst.gmp_rand_lc_scheme[2].astr := ce_string ("A3D73AD")
			randlc2s_inst.gmp_rand_lc_scheme[2].c := {NATURAL_32} 1
			randlc2s_inst.gmp_rand_lc_scheme[3].m2exp := {NATURAL_32} 35
			randlc2s_inst.gmp_rand_lc_scheme[3].astr := ce_string ("147E5B85")
			randlc2s_inst.gmp_rand_lc_scheme[3].c := {NATURAL_32} 1
			randlc2s_inst.gmp_rand_lc_scheme[4].m2exp := {NATURAL_32} 36
			randlc2s_inst.gmp_rand_lc_scheme[4].astr := ce_string ("28F725C5")
		end

end
