class
	P_BIN_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_bin_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT]; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_ni: CE_ARRAY [PD_MPZ_STRUCT]
			l_i: CE_ARRAY [NATURAL_32]
			l_nacc: CE_ARRAY [PD_MPZ_STRUCT]
			l_kacc: CE_ARRAY [NATURAL_32]
			l_negate: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___2: NATURAL_32
			l_k1: CE_ARRAY [NATURAL_32]
			l_k0: CE_ARRAY [NATURAL_32]
			js: JUMP_STATE
		do
			create l_ni.make (<<1>>)
			create l_i.make (<<1>>)
			create l_nacc.make (<<1>>)
			create l_kacc.make (<<1>>)
			create l_k1.make (<<1>>)
			create l_k0.make (<<1>>)

			l_k := a_k
			if a_n.item.mp_size < 0 then
				l_tmp___1 := -1
			else
				l_tmp___1 := (a_n.item.mp_size > 0).to_integer
			end
			if l_tmp___1 < 0 then
				init_inst.gmpz_init (l_ni)
				neg_inst.gmpz_neg (l_ni, a_n)
				aors_ui_inst.gmpz_sub_ui (l_ni, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), {NATURAL_32} 1)
				l_negate := ((l_k).bit_and ({NATURAL_32} 1)).to_integer_32
			else
				if (cmp_ui_inst.gmpz_cmp_ui (a_n, l_k)) < 0 then
					set_ui_inst.gmpz_set_ui (a_r, {NATURAL_32} 0)
					js.return
				end
				if not js.return_called then
					init_inst.gmpz_init (l_ni)
					aors_ui_inst.gmpz_sub_ui (l_ni, a_n, l_k)
					l_negate := (0).to_integer_32
				end
			end
			if not js.return_called then
				set_ui_inst.gmpz_set_ui (a_r, {NATURAL_32} 1)
				if (cmp_ui_inst.gmpz_cmp_ui (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), l_k)) < 0 then
					l_tmp___2 := l_k
					l_k := gmp_inst.gmpz_get_ui (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni))
					set_ui_inst.gmpz_set_ui (l_ni, l_tmp___2)
				end
				l_kacc.item := (1).to_natural_32
				iset_ui_inst.gmpz_init_set_ui (l_nacc, {NATURAL_32} 1)
				l_i.item := (1).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i.item <= l_k))
				loop
					aors_ui_inst.gmpz_add_ui (l_ni, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni), {NATURAL_32} 1)
					mul_inst.gmpz_mul (l_nacc, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ni))
					asm5 (l_k0, l_k1, l_kacc, l_i)
					l_k0.item := l_k0.item
					if l_k1.item /= {NATURAL_32} 0 then
						mul_inst.gmpz_mul (a_r, a_r, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc))
						set_ui_inst.gmpz_set_ui (l_nacc, {NATURAL_32} 1)
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_impl_inst.gmpn_divexact_1 (a_r.item.mp_d, a_r.item.mp_d, (a_r.item.mp_size).to_integer_32, l_kacc.item)
								js.break
							end
							a_r.item.mp_size := a_r.item.mp_size - (a_r.item.mp_d[(a_r.item.mp_size - 1)] = {NATURAL_32} 0).to_integer
							js.break
						end
						l_kacc.item := l_i.item
					else
						l_kacc.item := l_k0.item
					end
					l_i.item := l_i.item + 1
				end
				mul_inst.gmpz_mul (a_r, a_r, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_nacc))
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_impl_inst.gmpn_divexact_1 (a_r.item.mp_d, a_r.item.mp_d, (a_r.item.mp_size).to_integer_32, l_kacc.item)
						js.break
					end
					a_r.item.mp_size := a_r.item.mp_size - (a_r.item.mp_d[(a_r.item.mp_size - 1)] = {NATURAL_32} 0).to_integer
					js.break
				end
				a_r.item.mp_size := ((((a_r.item.mp_size).to_integer_32).bit_xor (-l_negate)) + l_negate).to_integer_32
				clear_inst.gmpz_clear (l_nacc)
				clear_inst.gmpz_clear (l_ni)
			end
		end

end
