class
	P_BIN_UIUI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_bin_uiui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_n: NATURAL_32; a_k: NATURAL_32)
		local
			l_k: NATURAL_32
			l_i: NATURAL_32
			l_j: CE_ARRAY [NATURAL_32]
			l_nacc: CE_ARRAY [NATURAL_32]
			l_kacc: NATURAL_32
			l_cnt: NATURAL_32
			l_rsize: INTEGER_32
			l_ralloc: INTEGER_32
			l_rp: CE_POINTER [NATURAL_32]
			l_n1: CE_ARRAY [NATURAL_32]
			l_n0: CE_ARRAY [NATURAL_32]
			l_new_ralloc: INTEGER_32
			l_new_ralloc___0: INTEGER_32
			js: JUMP_STATE
		do
			create l_j.make (<<1>>)
			create l_nacc.make (<<1>>)
			create l_rp.make
			create l_n1.make (<<1>>)
			create l_n0.make (<<1>>)

			l_k := a_k
			if a_n < l_k then
				a_r.item.mp_size := 0
				js.return
			end
			if not js.return_called then
				l_rp := a_r.item.mp_d
				if l_k < a_n - l_k then
					l_k := l_k
				else
					l_k := a_n - l_k
				end
				if l_k = {NATURAL_32} 0 then
					a_r.item.mp_size := 1
					l_rp[0] := (1).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				l_j.item := (a_n - l_k) + {NATURAL_32} 1
				l_rp[0] := l_j.item
				l_rsize := (1).to_integer_32
				l_ralloc := (a_r.item.mp_alloc).to_integer_32
				l_nacc.item := (1).to_natural_32
				l_kacc := (1).to_natural_32
				l_i := {NATURAL_32} 2
				from
				until
					not (not js.loop_done and then (l_i <= l_k))
				loop
					l_cnt := (((((l_nacc.item).bit_or (l_kacc))).bit_and ({NATURAL_32} 1))).bit_xor ({NATURAL_32} 1)
					l_nacc.item := (l_nacc.item).bit_shift_right (l_cnt.to_integer_32)
					l_kacc := (l_kacc).bit_shift_right (l_cnt.to_integer_32)
					l_j.item := l_j.item + 1
					asm6 (l_n0, l_n1, l_nacc, l_j)
					l_n0.item := l_n0.item
					if l_n1.item = {NATURAL_32} 0 then
						l_nacc.item := l_n0.item
						l_kacc := l_kacc * l_i
					else
						from
						until
							js.loop_done
						loop
							if l_rsize = l_ralloc then
								l_new_ralloc := l_ralloc + 32
								l_rp := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_rp), (l_ralloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32, (l_new_ralloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
								l_ralloc := l_new_ralloc
							end
							l_rp[l_rsize] := gmp_inst.gmpn_mul_1 (l_rp, l_rp, l_rsize, l_nacc.item)
							from
							until
								js.loop_done
							loop
								gmp_impl_inst.gmpn_divexact_1 (l_rp, l_rp, l_rsize + 1, l_kacc)
								js.break
							end
							l_rsize := l_rsize + (l_rp[l_rsize] /= {NATURAL_32} 0).to_integer
							js.break
						end
						l_nacc.item := l_j.item
						l_kacc := l_i
					end
					l_i := l_i + 1
				end
				from
				until
					js.loop_done
				loop
					if l_rsize = l_ralloc then
						l_new_ralloc___0 := l_ralloc + 1
						l_rp := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_rp), (l_ralloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32, (l_new_ralloc___0.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
						l_ralloc := l_new_ralloc___0
					end
					l_rp[l_rsize] := gmp_inst.gmpn_mul_1 (l_rp, l_rp, l_rsize, l_nacc.item)
					from
					until
						js.loop_done
					loop
						gmp_impl_inst.gmpn_divexact_1 (l_rp, l_rp, l_rsize + 1, l_kacc)
						js.break
					end
					l_rsize := l_rsize + (l_rp[l_rsize] /= {NATURAL_32} 0).to_integer
					js.break
				end
				a_r.item.mp_alloc := l_ralloc.to_integer_32
				a_r.item.mp_size := l_rsize.to_integer_32
				a_r.item.mp_d := l_rp
			end
		end

end
