class
	P_CDIV_Q

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cdiv_q (a_quot: CE_POINTER [PD_MPZ_STRUCT]; a_dividend: CE_POINTER [PD_MPZ_STRUCT]; a_divisor: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_dividend_size: INTEGER_32
			l_divisor_size: INTEGER_32
			l_rem: CE_ARRAY [PD_MPZ_STRUCT]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___1: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___6: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_rem.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l___x.make
			create l_tmp___5.make

			l_dividend_size := (a_dividend.item.mp_size).to_integer_32
			l_divisor_size := (a_divisor.item.mp_size).to_integer_32
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			from
			until
				js.loop_done
			loop
				l___x := l_rem
				if l_divisor_size >= 0 then
					l___x.item.mp_alloc := l_divisor_size.to_integer_32
				else
					l___x.item.mp_alloc := (-l_divisor_size).to_integer_32
				end
				if l_divisor_size >= 0 then
					l_tmp___6 := l_divisor_size
				else
					l_tmp___6 := -l_divisor_size
				end
				if (builtin_expect ((l_tmp___6.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					if l_divisor_size >= 0 then
						l_tmp___1 := l_divisor_size
					else
						l_tmp___1 := -l_divisor_size
					end
					l_tmp___5 := (l_aaf.new ((l_tmp___1.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					if l_divisor_size >= 0 then
						l_tmp___3 := l_divisor_size
					else
						l_tmp___3 := -l_divisor_size
					end
					l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_tmp___3.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l___x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
				js.break
			end
			tdiv_qr_inst.gmpz_tdiv_qr (a_quot, l_rem, a_dividend, a_divisor)
			if ((l_divisor_size).bit_xor (l_dividend_size)) >= 0 then
				if l_rem[0].mp_size /= 0 then
					aors_ui_inst.gmpz_add_ui (a_quot, a_quot, {NATURAL_32} 1)
				end
			end
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
		end

end
