class
	P_CMPABS_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_cmpabs_ui (a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v_digit: NATURAL_32): INTEGER_32
		local
			l_up: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_ul: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make

			l_up := a_u.item.mp_d
			l_un := (a_u.item.mp_size).to_integer_32
			if l_un = 0 then
				Result := (-(a_v_digit /= {NATURAL_32} 0).to_integer).to_integer
				js.return
			end
			if not js.return_called then
				if l_un >= 0 then
					l_un := l_un
				else
					l_un := -l_un
				end
				if l_un = 1 then
					l_ul := l_up[0]
					if l_ul > a_v_digit then
						Result := 1
						js.return
					end
					if not js.return_called and then (l_ul < a_v_digit) then
						Result := (-1)
						js.return
					end
					if not js.return_called then
						Result := 0
						js.return
					end
				end
			end
			if not js.return_called then
				Result := 1
			end
		end

end
