class
	P_DIVIS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_divisible_p (a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_an: INTEGER_32
			l_dp: CE_POINTER [NATURAL_32]
			l_dn: INTEGER_32
			l_alow: NATURAL_32
			l_dlow: NATURAL_32
			l_dmask: NATURAL_32
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_i: INTEGER_32
			l_di: NATURAL_32
			l_twos: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_dsecond: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___5: NATURAL_32
			l_tmp___9: CE_POINTER [ANY]
			l_tmp___14: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l___n: NATURAL_32
			l___inv: NATURAL_32
			l___n___0: NATURAL_32
			l___inv___0: NATURAL_32
			l_tmp___29: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_ap.make
			create l_dp.make
			create l_qp.make
			create l_rp.make
			create l_tp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___9.make
			create l_tmp___14.make
			create l_tmp___20.make
			create l_tmp___29.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_ap
					l_an := a_an
					l_dp := a_dp
					l_dn := a_dn
					if l_an < l_dn then
						Result := (l_an = 0).to_integer
						js.return
					end
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							l_alow := l_ap.item
							l_dlow := l_dp.item
							if l_dlow /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								if l_alow /= {NATURAL_32} 0 then
									Result := 0
									js.return
								end
								if not js.return_called then
									l_an := l_an - 1
									l_dn := l_dn - 1
									l_ap := l_ap + 1
									l_dp := l_dp + 1
								end
							end
						end
					end
					if not js.return_called then
						l_dmask := ((l_dlow).bit_and ((-l_dlow.to_integer_32).to_natural_32)) - {NATURAL_32} 1
						if ((l_alow).bit_and (l_dmask)) /= {NATURAL_32} 0 then
							Result := 0
							js.return
						end
					end
					if not js.return_called and then (l_dn = 1) then
						if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							if l_an >= 22 then
								Result := ((mod_1_inst.gmpn_mod_1 (l_ap, l_an, l_dlow)) = {NATURAL_32} 0).to_integer
								js.return
							end
						end
						if not js.return_called then
							from
							until
								js.loop_done
							loop
								l_twos := (builtin_ctzl (l_dlow)).to_natural_32
								js.break
							end
							l_dlow := (l_dlow).bit_shift_right (l_twos.to_integer_32)
							Result := ((gmp_impl_inst.gmpn_modexact_1_odd (l_ap, l_an, l_dlow)) = {NATURAL_32} 0).to_integer
							js.return
						end
					end
					if not js.return_called and then (l_dn = 2) then
						l_dsecond := l_dp[1]
						if l_dsecond <= l_dmask then
							from
							until
								js.loop_done
							loop
								l_twos := (builtin_ctzl (l_dlow)).to_natural_32
								js.break
							end
							l_dlow := (((l_dlow).bit_shift_right (l_twos.to_integer_32))).bit_or (((l_dsecond).bit_shift_left (({NATURAL_32} 32 - l_twos).to_integer_32)))
							if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_an >= 22 then
									l_tmp___5 := (mod_1_inst.gmpn_mod_1 (l_ap, l_an, l_dlow))
								else
									l_tmp___3 := gmp_impl_inst.gmpn_modexact_1_odd (l_ap, l_an, l_dlow)
									l_tmp___5 := l_tmp___3
								end
							else
								l_tmp___3 := gmp_impl_inst.gmpn_modexact_1_odd (l_ap, l_an, l_dlow)
								l_tmp___5 := l_tmp___3
							end
							Result := (l_tmp___5 = {NATURAL_32} 0).to_integer
							js.return
						end
					end
					if not js.return_called then
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if (builtin_expect (((l_an + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___9 := (l_aaf.new (((l_an + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___9 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_an + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_rp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9)
						if (builtin_expect ((((l_an - l_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___14 := (l_aaf.new ((((l_an - l_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						else
							l_tmp___14 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (((l_an - l_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
						end
						l_qp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___14)
						from
						until
							js.loop_done
						loop
							l_twos := (builtin_ctzl (l_dp[0])).to_natural_32
							js.break
						end
						if l_twos /= {NATURAL_32} 0 then
							if (builtin_expect ((l_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___20 := (l_aaf.new ((l_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___20 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___20)
							gmp_inst.gmpn_rshift (l_tp, l_dp, l_dn, l_twos).do_nothing
							l_dp := l_tp
							gmp_inst.gmpn_rshift (l_rp, l_ap, l_an, l_twos).do_nothing
						else
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_rp, l_ap, l_an)
									js.break
								end
								js.break
							end
						end
						if l_rp[(l_an - 1)] >= l_dp[(l_dn - 1)] then
							l_rp[l_an] := (0).to_natural_32
							l_an := l_an + 1
						elseif l_an = l_dn then
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								js.break
							end
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 18 -- skip if block
					end
				when 1 then -- if:
						if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 16 -- skip if block
						end
				when 2 then -- if:
						if not (l_dn >= 60) then
							l_pos := -1 + 14 -- skip if block
						end
				when 3 then -- if:
						if 60 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if not (l_an - l_dn >= 60) then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if 1_442 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if l_dn >= 1_442 then
							if (builtin_expect (((mu_bdiv_qr_inst.gmpn_mu_bdiv_qr_itch (l_an, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___29 := (l_aaf.new (((mu_bdiv_qr_inst.gmpn_mu_bdiv_qr_itch (l_an, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___29 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((mu_bdiv_qr_inst.gmpn_mu_bdiv_qr_itch (l_an, l_dn)).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___29)
							mu_bdiv_qr_inst.gmpn_mu_bdiv_qr (l_qp, l_rp, l_rp, l_an, l_dp, l_dn, l_tp).do_nothing
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						from
						until
							js.loop_done
						loop
							l___n___0 := l_dp[0]
							l___inv___0 := (gmp_impl_inst.gmp_binvert_limb_table[((l___n___0 // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l___inv___0 := {NATURAL_32} 2 * l___inv___0 - (l___inv___0 * l___inv___0) * l___n___0
							l_di := (l___inv___0).bit_and ({NATURAL_32} 4_294_967_295)
							js.break
						end
						dcpi1_bdiv_qr_inst.gmpn_dcpi1_bdiv_qr (l_qp, l_rp, l_an, l_dp, l_dn, (-l_di.to_integer_32).to_natural_32).do_nothing
						l_rp := l_rp + (l_an - l_dn)
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___1:
						from
						until
							js.loop_done
						loop
							l___n := l_dp[0]
							l___inv := (gmp_impl_inst.gmp_binvert_limb_table[((l___n // {NATURAL_32} 2).bit_and ({NATURAL_32} 127)).to_integer_32]).to_natural_32
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l___inv := {NATURAL_32} 2 * l___inv - (l___inv * l___inv) * l___n
							l_di := (l___inv).bit_and ({NATURAL_32} 4_294_967_295)
							js.break
						end
						sbpi1_bdiv_qr_inst.gmpn_sbpi1_bdiv_qr (l_qp, l_rp, l_an, l_dp, l_dn, (-l_di.to_integer_32).to_natural_32).do_nothing
						l_rp := l_rp + (l_an - l_dn)
				when 13 then -- if done | if block done, skip else block:
						l_pos := -1 + 15
				when 14 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 15 then -- if done | if block done, skip else block:
						l_pos := -1 + 17
				when 16 then -- else:
						l_pos := -1 + 12 -- goto _L___1
				when 17 then
						l_i := (0).to_integer_32
						from
						until
							js.loop_done
						loop
							if l_rp[l_i] /= {NATURAL_32} 0 then
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									js.break
								end
								Result := 0
								js.return
							end
							if not js.return_called then
								l_i := l_i + 1
								if not (l_i < l_dn) then
									js.break
								end
							end
						end
				when 18 then -- if done
					if not js.return_called then
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
						Result := 1
					end
				when 19 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_divisible_p (a_a: CE_POINTER [PD_MPZ_STRUCT]; a_d: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_dsize: INTEGER_32
			l_asize: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			js: JUMP_STATE
		do
			l_dsize := (a_d.item.mp_size).to_integer_32
			l_asize := (a_a.item.mp_size).to_integer_32
			if (builtin_expect ((l_dsize = 0).to_integer, 0)).to_boolean then
				Result := (l_asize = 0).to_integer
				js.return
			end
			if not js.return_called then
				if l_dsize >= 0 then
					l_tmp___0 := l_dsize
				else
					l_tmp___0 := -l_dsize
				end
				if l_asize >= 0 then
					l_tmp___1 := l_asize
				else
					l_tmp___1 := -l_asize
				end
				Result := (gmpn_divisible_p (a_a.item.mp_d, l_tmp___1, a_d.item.mp_d, l_tmp___0))
			end
		end

end
