class
	P_DIVREM

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_divrem (a_qp: CE_POINTER [NATURAL_32]; a_qxn: INTEGER_32; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32): NATURAL_32
		local
			l_ret: NATURAL_32
			l_q2p: CE_POINTER [NATURAL_32]
			l_qn: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_rp: CE_POINTER [NATURAL_32]
			l_q2p___0: CE_POINTER [NATURAL_32]
			l_qhl: NATURAL_32
			l_qn___0: INTEGER_32
			l___tmp_marker___0: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_n2p: CE_POINTER [NATURAL_32]
			l_tmp___9: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___11: CE_POINTER [NATURAL_32]
			l_tmp___15: CE_POINTER [ANY]
			l_tmp___20: CE_POINTER [ANY]
			l_tmp___25: CE_POINTER [ANY]
			l_tmp___30: CE_POINTER [ANY]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_q2p.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make
			create l_rp.make
			create l_q2p___0.make
			create l___tmp_marker___0.make (<<1>>)
			create l_n2p.make
			create l_tmp___9.make
			create l___dst.make
			create l_tmp___11.make
			create l_tmp___15.make
			create l_tmp___20.make
			create l_tmp___25.make
			create l_tmp___30.make

			if a_dn = 1 then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if (builtin_expect (((a_nn + a_qxn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___2 := (l_aaf.new (((a_nn + a_qxn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_nn + a_qxn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_q2p := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
				a_np[0] := gmp_inst.gmpn_divrem_1 (l_q2p, a_qxn, a_np, a_nn, a_dp[0])
				l_qn := (a_nn + a_qxn) - 1
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (a_qp, l_q2p, l_qn)
						js.break
					end
					js.break
				end
				l_ret := l_q2p[l_qn]
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				Result := l_ret
			elseif a_dn = 2 then
				Result := (gmp_inst.gmpn_divrem_2 (a_qp, a_qxn, a_np, a_nn, a_dp))
			else
				l___tmp_marker___0.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				if (builtin_expect ((a_qxn /= 0).to_integer, 0)).to_boolean then
					if (builtin_expect (((a_nn + a_qxn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___9 := (l_aaf.new (((a_nn + a_qxn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___9 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((a_nn + a_qxn).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_n2p := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9)
					from
					until
						js.loop_done
					loop
						if a_qxn /= 0 then
							l___dst := l_n2p
							l___n := a_qxn
							from
							until
								js.loop_done
							loop
								l_tmp___11 := l___dst
								l___dst := l___dst + 1
								l_tmp___11.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_n2p + a_qxn, a_np, a_nn)
							js.break
						end
						js.break
					end
					if (builtin_expect (((((a_nn - a_dn) + a_qxn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___15 := (l_aaf.new (((((a_nn - a_dn) + a_qxn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___15 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker___0, ((((a_nn - a_dn) + a_qxn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_q2p___0 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___15)
					if (builtin_expect ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___20 := (l_aaf.new ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___20 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker___0, (a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_rp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___20)
					tdiv_qr_inst.gmpn_tdiv_qr (l_q2p___0, l_rp, 0, l_n2p, a_nn + a_qxn, a_dp, a_dn)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_np, l_rp, a_dn)
							js.break
						end
						js.break
					end
					l_qn___0 := (a_nn - a_dn) + a_qxn
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_qp, l_q2p___0, l_qn___0)
							js.break
						end
						js.break
					end
					l_qhl := l_q2p___0[l_qn___0]
				else
					if (builtin_expect ((((a_nn - a_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___25 := (l_aaf.new ((((a_nn - a_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___25 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker___0, (((a_nn - a_dn) + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_q2p___0 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___25)
					if (builtin_expect ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___30 := (l_aaf.new ((a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___30 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker___0, (a_dn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_rp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___30)
					tdiv_qr_inst.gmpn_tdiv_qr (l_q2p___0, l_rp, 0, a_np, a_nn, a_dp, a_dn)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_np, l_rp, a_dn)
							js.break
						end
						js.break
					end
					l_qn___0 := a_nn - a_dn
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_qp, l_q2p___0, l_qn___0)
							js.break
						end
						js.break
					end
					l_qhl := l_q2p___0[l_qn___0]
				end
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker___0.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker___0.item)
					end
					js.break
				end
				Result := l_qhl
			end
		end

end
