class
	P_GCD

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcd (a_gp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_usize: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32): INTEGER_32
		local
			l_n: INTEGER_32
			l_talloc: INTEGER_32
			l_scratch: INTEGER_32
			l_matrix_scratch: INTEGER_32
			l_gn: CE_ARRAY [INTEGER_32]
			l_tp: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_hgcd_scratch: INTEGER_32
			l_update_scratch: INTEGER_32
			l_p: INTEGER_32
			l_scratch___0: INTEGER_32
			l_tmp: INTEGER_32
			l_tmp___3: CE_POINTER [ANY]
			l_M: CE_ARRAY [PD_HGCD_MATRIX]
			l_p___0: INTEGER_32
			l_matrix_scratch___0: INTEGER_32
			l_nn: INTEGER_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gn.make (<<1>>)
			create l_tp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___3.make
			create l_M.make (<<1>>)

			l_n := a_n
			l_talloc := l_n
			l_scratch := (a_usize - l_n) + 1
			if l_scratch > l_talloc then
				l_talloc := l_scratch
			end
			if 393 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if l_n >= 393 then
					l_p := (2 * l_n) // 3
					l_matrix_scratch := 4 * (((l_n - l_p) + 1) // 2 + 1)
					l_hgcd_scratch := hgcd_inst.gmpn_hgcd_itch (l_n - l_p)
					l_update_scratch := (l_p + l_n) - 1
					if l_hgcd_scratch > l_update_scratch then
						l_tmp := l_hgcd_scratch
					else
						l_tmp := l_update_scratch
					end
					l_scratch___0 := l_matrix_scratch + l_tmp
					if l_scratch___0 > l_talloc then
						l_talloc := l_scratch___0
					end
				end
			end
			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___3 := (l_aaf.new ((l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_talloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___3)
			if a_usize > l_n then
				tdiv_qr_inst.gmpn_tdiv_qr (l_tp, a_up, (0).to_integer_32, a_up, a_usize, a_vp, l_n)
				if (gmp_impl_inst.mpn_zero_p (a_up, l_n)).to_boolean then
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_gp, a_vp, l_n)
							js.break
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
							tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
						end
						js.break
					end
					Result := l_n
					js.return
				end
			end
			if not js.return_called then
				from
				until
					js.loop_done
				loop
					if 393 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						if not (l_n >= 393) then
							js.break
						end
					else
						js.break
					end
					if not js.loop_jumped then
						l_p___0 := (2 * l_n) // 3
						l_matrix_scratch___0 := 4 * (((l_n - l_p___0) + 1) // 2 + 1)
						hgcd_inst.gmpn_hgcd_matrix_init (l_M, l_n - l_p___0, l_tp)
						l_nn := hgcd_inst.gmpn_hgcd (a_up + l_p___0, a_vp + l_p___0, l_n - l_p___0, l_M, l_tp + l_matrix_scratch___0)
						if l_nn > 0 then
							l_n := hgcd_inst.gmpn_hgcd_matrix_adjust (l_M, l_p___0 + l_nn, a_up, a_vp, l_p___0, l_tp + l_matrix_scratch___0)
						else
							l_n := gcd_subdiv_step_inst.gmpn_gcd_subdiv_step (a_gp, l_gn, a_up, a_vp, l_n, l_tp)
							if l_n = 0 then
								from
								until
									js.loop_done
								loop
									if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
										tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
									end
									js.break
								end
								Result := (l_gn.item)
								js.return
							end
						end
					end
				end
			end
			if not js.return_called then
				l_gn.item := gcd_lehmer_inst.gmpn_gcd_lehmer_n (a_gp, a_up, a_vp, l_n, l_tp)
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				Result := (l_gn.item)
			end
		end

	gmpz_gcd (a_g: CE_POINTER [PD_MPZ_STRUCT]; a_u: CE_POINTER [PD_MPZ_STRUCT]; a_v: CE_POINTER [PD_MPZ_STRUCT])
		local
			l_g_zero_bits: NATURAL_32
			l_u_zero_bits: NATURAL_32
			l_v_zero_bits: NATURAL_32
			l_g_zero_limbs: INTEGER_32
			l_u_zero_limbs: INTEGER_32
			l_v_zero_limbs: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_up: CE_POINTER [NATURAL_32]
			l_usize: INTEGER_32
			l_tmp: INTEGER_32
			l_vp: CE_POINTER [NATURAL_32]
			l_vsize: INTEGER_32
			l_tmp___0: INTEGER_32
			l_gsize: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___5: CE_POINTER [ANY]
			l_tmp___11: CE_POINTER [ANY]
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_cy_limb: NATURAL_32
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_32]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___16: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_tp.make
			create l_up.make
			create l_vp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___5.make
			create l_tmp___11.make
			create l___dst.make
			create l_tmp___15.make
			create l___dst___0.make
			create l_tmp___16.make

			l_up := a_u.item.mp_d
			if a_u.item.mp_size >= 0 then
				l_tmp := a_u.item.mp_size
			else
				l_tmp := -a_u.item.mp_size
			end
			l_usize := l_tmp.to_integer_32
			l_vp := a_v.item.mp_d
			if a_v.item.mp_size >= 0 then
				l_tmp___0 := a_v.item.mp_size
			else
				l_tmp___0 := -a_v.item.mp_size
			end
			l_vsize := l_tmp___0.to_integer_32
			if l_usize = 0 then
				a_g.item.mp_size := l_vsize.to_integer_32
				if a_g.is_equal (a_v) then
					js.return
				end
				if not js.return_called then
					if (a_g.item.mp_alloc).to_integer_32 < l_vsize then
						realloc_inst.gmpz_realloc (a_g, l_vsize).do_nothing
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_g.item.mp_d, l_vp, l_vsize)
							js.break
						end
						js.break
					end
					js.return
				end
			end
			if not js.return_called and then (l_vsize = 0) then
				a_g.item.mp_size := l_usize.to_integer_32
				if a_g.is_equal (a_u) then
					js.return
				end
				if not js.return_called then
					if (a_g.item.mp_alloc).to_integer_32 < l_usize then
						realloc_inst.gmpz_realloc (a_g, l_usize).do_nothing
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_g.item.mp_d, l_up, l_usize)
							js.break
						end
						js.break
					end
					js.return
				end
			end
			if not js.return_called and then (l_usize = 1) then
				a_g.item.mp_size := 1
				a_g.item.mp_d[0] := gcd_1_inst.gmpn_gcd_1 (l_vp, l_vsize, l_up[0])
				js.return
			end
			if not js.return_called and then (l_vsize = 1) then
				a_g.item.mp_size := 1
				a_g.item.mp_d[0] := gcd_1_inst.gmpn_gcd_1 (l_up, l_usize, l_vp[0])
				js.return
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				from
				until
					l_up.item /= {NATURAL_32} 0
				loop
					l_up := l_up + 1
				end
				l_u_zero_limbs := (l_up.distance ((a_u.item.mp_d))).to_integer_32
				l_usize := l_usize - l_u_zero_limbs
				from
				until
					js.loop_done
				loop
					l_u_zero_bits := (builtin_ctzl (l_up.item)).to_natural_32
					js.break
				end
				l_tp := l_up
				if (builtin_expect ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___5 := (l_aaf.new ((l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___5 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_usize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_up := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___5)
				if l_u_zero_bits /= {NATURAL_32} 0 then
					gmp_inst.gmpn_rshift (l_up, l_tp, l_usize, l_u_zero_bits.to_natural_32).do_nothing
					l_usize := l_usize - (l_up[(l_usize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_up, l_tp, l_usize)
							js.break
						end
						js.break
					end
				end
				from
				until
					l_vp.item /= {NATURAL_32} 0
				loop
					l_vp := l_vp + 1
				end
				l_v_zero_limbs := (l_vp.distance ((a_v.item.mp_d))).to_integer_32
				l_vsize := l_vsize - l_v_zero_limbs
				from
				until
					js.loop_done
				loop
					l_v_zero_bits := (builtin_ctzl (l_vp.item)).to_natural_32
					js.break
				end
				l_tp := l_vp
				if (builtin_expect ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
					l_tmp___11 := (l_aaf.new ((l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				else
					l_tmp___11 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_vsize.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
				end
				l_vp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___11)
				if l_v_zero_bits /= {NATURAL_32} 0 then
					gmp_inst.gmpn_rshift (l_vp, l_tp, l_vsize, l_v_zero_bits.to_natural_32).do_nothing
					l_vsize := l_vsize - (l_vp[(l_vsize - 1)] = {NATURAL_32} 0).to_integer
				else
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_vp, l_tp, l_vsize)
							js.break
						end
						js.break
					end
				end
				if l_u_zero_limbs > l_v_zero_limbs then
					l_g_zero_limbs := l_v_zero_limbs
					l_g_zero_bits := l_v_zero_bits
				elseif l_u_zero_limbs < l_v_zero_limbs then
					l_g_zero_limbs := l_u_zero_limbs
					l_g_zero_bits := l_u_zero_bits
				else
					l_g_zero_limbs := l_u_zero_limbs
					if l_u_zero_bits < l_v_zero_bits then
						l_g_zero_bits := l_u_zero_bits
					else
						l_g_zero_bits := l_v_zero_bits
					end
				end
				if l_usize < l_vsize then
					l_tmp___13 := gmpn_gcd (l_vp, l_vp, l_vsize, l_up, l_usize)
					l_vsize := l_tmp___13
				elseif l_usize = l_vsize then
					if l_up[(l_usize - 1)] < l_vp[(l_vsize - 1)] then
						l_tmp___13 := gmpn_gcd (l_vp, l_vp, l_vsize, l_up, l_usize)
						l_vsize := l_tmp___13
					else
						l_tmp___14 := gmpn_gcd (l_vp, l_up, l_usize, l_vp, l_vsize)
						l_vsize := l_tmp___14
					end
				else
					l_tmp___14 := gmpn_gcd (l_vp, l_up, l_usize, l_vp, l_vsize)
					l_vsize := l_tmp___14
				end
				l_gsize := l_vsize + l_g_zero_limbs
				if l_g_zero_bits /= {NATURAL_32} 0 then
					l_gsize := l_gsize + ((l_vp[(l_vsize - 1)]).bit_shift_right (({NATURAL_32} 32 - l_g_zero_bits).to_integer_32) /= {NATURAL_32} 0).to_integer
					if (a_g.item.mp_alloc).to_integer_32 < l_gsize then
						realloc_inst.gmpz_realloc (a_g, l_gsize).do_nothing
					end
					from
					until
						js.loop_done
					loop
						if l_g_zero_limbs /= 0 then
							l___dst := a_g.item.mp_d
							l___n := l_g_zero_limbs
							from
							until
								js.loop_done
							loop
								l_tmp___15 := l___dst
								l___dst := l___dst + 1
								l_tmp___15.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
					l_tp := a_g.item.mp_d + l_g_zero_limbs
					l_cy_limb := gmp_inst.gmpn_lshift (l_tp, l_vp, l_vsize, l_g_zero_bits.to_natural_32)
					if l_cy_limb /= {NATURAL_32} 0 then
						l_tp[l_vsize] := l_cy_limb
					end
				else
					if (a_g.item.mp_alloc).to_integer_32 < l_gsize then
						realloc_inst.gmpz_realloc (a_g, l_gsize).do_nothing
					end
					from
					until
						js.loop_done
					loop
						if l_g_zero_limbs /= 0 then
							l___dst___0 := a_g.item.mp_d
							l___n___0 := l_g_zero_limbs
							from
							until
								js.loop_done
							loop
								l_tmp___16 := l___dst___0
								l___dst___0 := l___dst___0 + 1
								l_tmp___16.item := (0).to_natural_32
								l___n___0 := l___n___0 - 1
								if not l___n___0.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (a_g.item.mp_d + l_g_zero_limbs, l_vp, l_vsize)
							js.break
						end
						js.break
					end
				end
				a_g.item.mp_size := l_gsize.to_integer_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
			end
		end

end
