class
	P_GCD_SUBDIV_STEP

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_gcd_subdiv_step (a_gp: CE_POINTER [NATURAL_32]; a_gn: CE_POINTER [INTEGER_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_ap: CE_POINTER [NATURAL_32]
			l_bp: CE_POINTER [NATURAL_32]
			l_an: INTEGER_32
			l_bn: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp: INTEGER_32
			l_c: INTEGER_32
			l___gmp_i: INTEGER_32
			l___gmp_x: NATURAL_32
			l___gmp_y: NATURAL_32
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___1: CE_POINTER [NATURAL_32]
			l___mp_size_t_swap__tmp___0: INTEGER_32
			l_c___0: INTEGER_32
			l___gmp_i___0: INTEGER_32
			l___gmp_x___0: NATURAL_32
			l___gmp_y___0: NATURAL_32
			l___mp_ptr_swap__tmp___2: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_ap.make
			create l_bp.make
			create l___mp_ptr_swap__tmp.make
			create l___mp_ptr_swap__tmp___0.make
			create l___mp_ptr_swap__tmp___1.make
			create l___mp_ptr_swap__tmp___2.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := a_ap
					l_bp := a_bp
					l_bn := a_n
					l_an := l_bn
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_an > 0))
						loop
							if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_an := l_an - 1
							end
						end
						js.break
					end
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_bn > 0))
						loop
							if l_bp[(l_bn - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_bn := l_bn - 1
							end
						end
						js.break
					end
					if not ((builtin_expect ((l_an = 0).to_integer, 0)).to_boolean) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if: | return_b:
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_gp, l_bp, l_bn)
								js.break
							end
							js.break
						end
						a_gn.item := l_bn
						Result := (0).to_integer_32
						js.return
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 5
				when 3 then -- else:
						if not ((builtin_expect ((l_bn = 0).to_integer, 0)).to_boolean) then
							l_pos := -1 + 5 -- skip if block
						end
				when 4 then -- if: | return_a:
						from
						until
							js.loop_done
						loop
							from
							until
								js.loop_done
							loop
								gmp_inst.gmpn_copyi (a_gp, l_ap, l_an)
								js.break
							end
							js.break
						end
						a_gn.item := l_an
						Result := (0).to_integer_32
						js.return
				when 5 then -- if done | if done
						if js.return_called then
							l_pos := -1 + 10 -- skip if block
						end
				when 6 then -- if:
							if l_an < l_bn then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										l___mp_ptr_swap__tmp := l_ap
										l_ap := l_bp
										l_bp := l___mp_ptr_swap__tmp
										js.break
									end
									from
									until
										js.loop_done
									loop
										l___mp_size_t_swap__tmp := l_an
										l_an := l_bn
										l_bn := l___mp_size_t_swap__tmp
										js.break
									end
									js.break
								end
							elseif l_an = l_bn then
								from
								until
									js.loop_done
								loop
									l_c := 0
									l___gmp_i := l_an
									from
									until
										js.loop_done
									loop
										l___gmp_i := l___gmp_i - 1
										if not (l___gmp_i >= 0) then
											js.break
										end
										if not js.loop_jumped then
											l___gmp_x := l_ap[l___gmp_i]
											l___gmp_y := l_bp[l___gmp_i]
											if l___gmp_x /= l___gmp_y then
												if l___gmp_x > l___gmp_y then
													l_c := 1
												else
													l_c := -1
												end
												js.break
											end
										end
									end
									js.break
								end
								if (builtin_expect ((l_c = 0).to_integer, 0)).to_boolean then
									l_pos := -1 + 4 -- goto return_a
								elseif l_c < 0 then
									from
									until
										js.loop_done
									loop
										l___mp_ptr_swap__tmp___0 := l_ap
										l_ap := l_bp
										l_bp := l___mp_ptr_swap__tmp___0
										js.break
									end
								end
							end
				when 7 then
							gmp_inst.gmpn_sub (l_ap, l_ap, l_an, l_bp, l_bn).do_nothing
							from
							until
								js.loop_done
							loop
								from
								until
									not (not js.loop_done and then (l_an > 0))
								loop
									if l_ap[(l_an - 1)] /= {NATURAL_32} 0 then
										js.break
									end
									if not js.loop_jumped then
										l_an := l_an - 1
									end
								end
								js.break
							end
							if l_an < l_bn then
								from
								until
									js.loop_done
								loop
									from
									until
										js.loop_done
									loop
										l___mp_ptr_swap__tmp___1 := l_ap
										l_ap := l_bp
										l_bp := l___mp_ptr_swap__tmp___1
										js.break
									end
									from
									until
										js.loop_done
									loop
										l___mp_size_t_swap__tmp___0 := l_an
										l_an := l_bn
										l_bn := l___mp_size_t_swap__tmp___0
										js.break
									end
									js.break
								end
							elseif l_an = l_bn then
								from
								until
									js.loop_done
								loop
									l_c___0 := 0
									l___gmp_i___0 := l_an
									from
									until
										js.loop_done
									loop
										l___gmp_i___0 := l___gmp_i___0 - 1
										if not (l___gmp_i___0 >= 0) then
											js.break
										end
										if not js.loop_jumped then
											l___gmp_x___0 := l_ap[l___gmp_i___0]
											l___gmp_y___0 := l_bp[l___gmp_i___0]
											if l___gmp_x___0 /= l___gmp_y___0 then
												if l___gmp_x___0 > l___gmp_y___0 then
													l_c___0 := 1
												else
													l_c___0 := -1
												end
												js.break
											end
										end
									end
									js.break
								end
								if (builtin_expect ((l_c___0 = 0).to_integer, 0)).to_boolean then
									l_pos := -1 + 4 -- goto return_a
								elseif l_c___0 < 0 then
									from
									until
										js.loop_done
									loop
										l___mp_ptr_swap__tmp___2 := l_ap
										l_ap := l_bp
										l_bp := l___mp_ptr_swap__tmp___2
										js.break
									end
								end
							end
				when 8 then
							tdiv_qr_inst.gmpn_tdiv_qr (a_tp, l_ap, (0).to_integer_32, l_ap, l_an, l_bp, l_bn)
							if (gmp_impl_inst.mpn_zero_p (l_ap, l_bn)).to_boolean then
								l_pos := -1 + 1 -- goto return_b
							end
				when 9 then
							Result := l_bn
				when 10 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
