class
	P_GET_STR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_get_str (a_dbuf: CE_POINTER [INTEGER_8]; a_exp: CE_POINTER [INTEGER_32]; a_base: INTEGER_32; a_n_digits: NATURAL_32; a_u: CE_POINTER [PD_MPF_STRUCT]): CE_POINTER [INTEGER_8]
		local
			l_dbuf: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_n_digits: NATURAL_32
			l_ue: INTEGER_32
			l_n_limbs_needed: INTEGER_32
			l_max_digits: NATURAL_32
			l_up: CE_POINTER [NATURAL_32]
			l_pp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_un: INTEGER_32
			l_pn: INTEGER_32
			l_tn: INTEGER_32
			l_tstr: CE_POINTER [NATURAL_8]
			l_exp_in_base: INTEGER_32
			l_n_digits_computed: NATURAL_32
			l_i: INTEGER_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_alloc_size: NATURAL_32
			l_dp: CE_POINTER [INTEGER_8]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___3: CE_POINTER [ANY]
			l_n_more_limbs_needed: INTEGER_32
			l_ign: CE_ARRAY [INTEGER_32]
			l_off: INTEGER_32
			l_e: NATURAL_32
			l_tmp___8: CE_POINTER [ANY]
			l_tmp___13: CE_POINTER [ANY]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___15: CE_POINTER [NATURAL_32]
			l_n_less_limbs_needed: INTEGER_32
			l_ign___0: CE_ARRAY [INTEGER_32]
			l_off___0: INTEGER_32
			l_xn: INTEGER_32
			l_e___0: NATURAL_32
			l_dummyp: CE_POINTER [NATURAL_32]
			l_xp: CE_POINTER [NATURAL_32]
			l_tmp___19: CE_POINTER [ANY]
			l_tmp___24: CE_POINTER [ANY]
			l_tmp___29: CE_POINTER [ANY]
			l___dst___0: CE_POINTER [NATURAL_32]
			l___n___0: INTEGER_32
			l_tmp___31: CE_POINTER [NATURAL_32]
			l_tmp___35: CE_POINTER [ANY]
			l_i___0: NATURAL_32
			l_x___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_dbuf.make
			create l_up.make
			create l_pp.make
			create l_tp.make
			create l_tstr.make
			create l_num_to_text.make
			create l_dp.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___3.make
			create l_ign.make (<<1>>)
			create l_tmp___8.make
			create l_tmp___13.make
			create l___dst.make
			create l_tmp___15.make
			create l_ign___0.make (<<1>>)
			create l_dummyp.make
			create l_xp.make
			create l_tmp___19.make
			create l_tmp___24.make
			create l_tmp___29.make
			create l___dst___0.make
			create l_tmp___31.make
			create l_tmp___35.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_dbuf := a_dbuf
					l_base := a_base
					l_n_digits := a_n_digits
					l_alloc_size := (0).to_natural_32
					l_up := a_u.item.mp_d
					if a_u.item.mp_size >= 0 then
						l_un := (a_u.item.mp_size).to_integer_32
					else
						l_un := (-a_u.item.mp_size).to_integer_32
					end
					l_ue := a_u.item.mp_exp
					if l_base >= 0 then
						l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
						if l_base = 0 then
							l_base := 10
						elseif l_base > 36 then
							l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
							if l_base > 62 then
								Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
								js.return
							end
						end
					else
						l_base := -l_base
						l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
					end
					if js.return_called then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							l_max_digits := {NATURAL_32} 2 + ((((a_u.item.mp_prec).to_natural_32 - {NATURAL_32} 1) * {NATURAL_32} 32).to_real_64 * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32
							js.break
						end
						if l_n_digits = {NATURAL_32} 0 then
							l_n_digits := l_max_digits
						elseif l_n_digits > l_max_digits then
							l_n_digits := l_max_digits
						end
						if l_dbuf.is_void then
							l_alloc_size := l_n_digits + {NATURAL_32} 2
							l_dbuf := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_n_digits + {NATURAL_32} 2]))))
						end
						if l_un = 0 then
							a_exp.item := (0).to_integer_32
							l_dbuf[0] := (0).to_integer_8
							l_n_digits := (0).to_natural_32
							l_pos := -1 + 3 -- goto done
						end
				when 2 then
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if (builtin_expect (((l_n_digits + {NATURAL_32} 64) + {NATURAL_32} 3 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
							l_tmp___3 := (l_aaf.new ((l_n_digits + {NATURAL_32} 64) + {NATURAL_32} 3))
						else
							l_tmp___3 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_n_digits + {NATURAL_32} 64) + {NATURAL_32} 3))
						end
						l_tstr := create {CE_POINTER [NATURAL_8]}.make_cast (l_tmp___3)
						l_n_limbs_needed := 2 + (l_n_digits.to_real_64 / ((32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer
						if l_ue <= l_n_limbs_needed then
							l_n_more_limbs_needed := l_n_limbs_needed - l_ue
							l_e := ((l_n_more_limbs_needed.to_natural_32).to_real_64 * ((32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer_64.to_natural_32
							if l_un > l_n_limbs_needed then
								l_up := l_up + (l_un - l_n_limbs_needed)
								l_un := l_n_limbs_needed
							end
							if (builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___8 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___8 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_pp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___8)
							if (builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___13 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___13 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___13)
							l_pn := mpn_pow_1_highpart___0 (l_pp, l_ign, l_base.to_natural_32, l_e, l_n_limbs_needed, l_tp)
							if l_un > l_pn then
								mul_inst.gmpn_mul (l_tp, l_up, l_un, l_pp, l_pn).do_nothing
							else
								mul_inst.gmpn_mul (l_tp, l_pp, l_pn, l_up, l_un).do_nothing
							end
							l_tn := l_un + l_pn
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							l_off := (l_un - l_ue) - l_ign.item
							if l_off < 0 then
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyd (l_tp - l_off, l_tp, l_tn)
									js.break
								end
								from
								until
									js.loop_done
								loop
									if -l_off /= 0 then
										l___dst := l_tp
										l___n := -l_off
										from
										until
											js.loop_done
										loop
											l_tmp___15 := l___dst
											l___dst := l___dst + 1
											l_tmp___15.item := (0).to_natural_32
											l___n := l___n - 1
											if not l___n.to_boolean then
												js.break
											end
										end
									end
									js.break
								end
								l_tn := l_tn - l_off
								l_off := (0).to_integer_32
							end
							l_n_digits_computed := gmpn_get_str (l_tstr, l_base, l_tp + l_off, l_tn - l_off)
							l_exp_in_base := (l_n_digits_computed.to_natural_32 - l_e).to_integer_32
						else
							l_n_less_limbs_needed := l_ue - l_n_limbs_needed
							l_e___0 := ((l_n_less_limbs_needed.to_natural_32).to_real_64 * ((32).to_double * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly)).truncated_to_integer_64.to_natural_32
							if l_un > l_n_limbs_needed then
								l_up := l_up + (l_un - l_n_limbs_needed)
								l_un := l_n_limbs_needed
							end
							if (builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___19 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___19 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_pp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___19)
							if (builtin_expect (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___24 := (l_aaf.new (((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___24 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((2 * l_n_limbs_needed + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___24)
							l_pn := mpn_pow_1_highpart___0 (l_pp, l_ign___0, l_base.to_natural_32, l_e___0, l_n_limbs_needed, l_tp)
							l_xn := l_n_limbs_needed + (l_n_less_limbs_needed - l_ign___0.item)
							if (builtin_expect ((l_xn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___29 := (l_aaf.new ((l_xn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___29 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_xn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_xp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___29)
							l_off___0 := l_xn - l_un
							from
							until
								js.loop_done
							loop
								if l_off___0 /= 0 then
									l___dst___0 := l_xp
									l___n___0 := l_off___0
									from
									until
										js.loop_done
									loop
										l_tmp___31 := l___dst___0
										l___dst___0 := l___dst___0 + 1
										l_tmp___31.item := (0).to_natural_32
										l___n___0 := l___n___0 - 1
										if not l___n___0.to_boolean then
											js.break
										end
									end
								end
								js.break
							end
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									gmp_inst.gmpn_copyi (l_xp + l_off___0, l_up, l_un)
									js.break
								end
								js.break
							end
							if (builtin_expect ((l_pn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___35 := (l_aaf.new ((l_pn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___35 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_pn.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_dummyp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___35)
							tdiv_qr_inst.gmpn_tdiv_qr (l_tp, l_dummyp, (0).to_integer_32, l_xp, l_xn, l_pp, l_pn)
							l_tn := (l_xn - l_pn) + 1
							l_tn := l_tn - (l_tp[(l_tn - 1)] = {NATURAL_32} 0).to_integer
							l_n_digits_computed := gmpn_get_str (l_tstr, l_base, l_tp, l_tn)
							l_exp_in_base := (l_n_digits_computed.to_natural_32 + l_e___0).to_integer_32
						end
						if l_n_digits_computed > l_n_digits then
							if (l_tstr[l_n_digits.to_integer_32]).to_integer_32 * 2 >= l_base then
								l_n_digits_computed := l_n_digits
								l_i___0 := l_n_digits - {NATURAL_32} 1
								from
								until
									js.loop_done
								loop
									l_tstr[l_i___0.to_integer_32] := ((l_tstr[l_i___0.to_integer_32]).to_integer_32 + 1).to_natural_8
									l_x___2 := (l_tstr[l_i___0.to_integer_32]).to_natural_32
									if l_x___2 /= l_base.to_natural_32 then
										js.break
									end
									if not js.loop_jumped then
										l_n_digits_computed := l_n_digits_computed - 1
										if l_i___0 = {NATURAL_32} 0 then
											l_tstr[0] := (1).to_natural_8
											l_n_digits_computed := (1).to_natural_32
											l_exp_in_base := l_exp_in_base + 1
											js.break
										end
									end
									if not js.loop_jumped then
										l_i___0 := l_i___0 - 1
									end
								end
							end
						end
						if l_n_digits > l_n_digits_computed then
							l_n_digits := l_n_digits_computed
						end
						from
						until
							js.loop_done
						loop
							if l_n_digits /= {NATURAL_32} 0 then
								if (l_tstr[(l_n_digits - {NATURAL_32} 1).to_integer_32]).to_integer_32 /= 0 then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_n_digits := l_n_digits - 1
							end
						end
						l_dp := l_dbuf + (a_u.item.mp_size < 0).to_integer
						l_i := (0).to_integer_32
						from
						until
							not (l_i.to_natural_32 < l_n_digits.to_natural_32)
						loop
							l_dp[l_i] := l_num_to_text[(l_tstr[l_i]).to_integer_32]
							l_i := l_i + 1
						end
						l_dp[l_n_digits.to_integer_32] := (0).to_integer_8
						a_exp.item := l_exp_in_base
						if a_u.item.mp_size < 0 then
							l_dbuf[0] := (('-').code).to_integer_8
							l_n_digits := l_n_digits + 1
						end
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
				when 3 then -- done:
						if l_alloc_size /= {NATURAL_32} 0 then
							from
							until
								js.loop_done
							loop
								if l_alloc_size /= l_n_digits + {NATURAL_32} 1 then
									l_dbuf := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_dbuf), l_alloc_size * {PLATFORM}.Integer_8_bytes.to_natural_32, (l_n_digits + {NATURAL_32} 1) * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
								end
								js.break
							end
						end
						Result := l_dbuf
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpn_get_str (a_str: CE_POINTER [NATURAL_8]; a_base: INTEGER_32; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32): NATURAL_32
		local
			l_powtab_mem: CE_POINTER [NATURAL_32]
			l_powtab_mem_ptr: CE_POINTER [NATURAL_32]
			l_big_base: CE_ARRAY [NATURAL_32]
			l_digits_in_base: NATURAL_32
			l_powtab: CE_ARRAY [PD_POWERS]
			l_pi: INTEGER_32
			l_n: INTEGER_32
			l_p: CE_POINTER [NATURAL_32]
			l_t: CE_POINTER [NATURAL_32]
			l_out_len: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_n1: NATURAL_32
			l_n0: NATURAL_32
			l_bits_per_digit: INTEGER_32
			l_cnt: INTEGER_32
			l_bit_pos: INTEGER_32
			l_i: INTEGER_32
			l_s: CE_POINTER [NATURAL_8]
			l_bits: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_n_pows: INTEGER_32
			l_xn: INTEGER_32
			l_pn: INTEGER_32
			l_exptab: CE_ARRAY [INTEGER_32]
			l_bexp: INTEGER_32
			l_cy: NATURAL_32
			l_shift: INTEGER_32
			js: JUMP_STATE
		do
			create l_powtab_mem.make
			create l_powtab_mem_ptr.make
			create l_big_base.make (<<1>>)
			create l_powtab.make (<<32>>)
			create l_p.make
			create l_t.make
			create l___tmp_marker.make (<<1>>)
			create l_s.make
			create l_tmp___0.make
			create l_tmp___1.make
			create l_tmp___2.make
			create l_exptab.make (<<32>>)

			if a_un = 0 then
				a_str[0] := (0).to_natural_8
				Result := (1).to_natural_32
				js.return
			end
			if not js.return_called and then (((a_base).bit_and ((a_base - 1))) = 0) then
				l_bits_per_digit := (mp_bases_inst.gmpn_bases[a_base].big_base).to_integer_32
				l_s := a_str
				l_n1 := a_up[(a_un - 1)]
				from
				until
					js.loop_done
				loop
					l_cnt := builtin_clzl (l_n1)
					js.break
				end
				l_bits := {NATURAL_32} 32 * a_un.to_natural_32 - l_cnt.to_natural_32
				l_cnt := (l_bits \\ l_bits_per_digit.to_natural_32).to_integer_32
				if l_cnt /= 0 then
					l_bits := l_bits + (l_bits_per_digit - l_cnt).to_natural_32
				end
				l_bit_pos := (l_bits - (a_un - 1).to_natural_32 * {NATURAL_32} 32).to_integer_32
				l_i := a_un - 1
				from
				until
					js.loop_done
				loop
					l_bit_pos := l_bit_pos - l_bits_per_digit
					from
					until
						not (l_bit_pos >= 0)
					loop
						l_tmp___0 := l_s
						l_s := l_s + 1
						l_tmp___0.item := ((((l_n1).bit_shift_right (l_bit_pos))).bit_and ((((1).bit_shift_left (l_bits_per_digit)) - 1).to_natural_32)).to_natural_8
						l_bit_pos := l_bit_pos - l_bits_per_digit
					end
					l_i := l_i - 1
					if l_i < 0 then
						js.break
					end
					if not js.loop_jumped then
						l_n0 := (((l_n1).bit_shift_left (-l_bit_pos))).bit_and ((((1).bit_shift_left (l_bits_per_digit)) - 1).to_natural_32)
						l_n1 := a_up[l_i]
						l_bit_pos := l_bit_pos + (32)
						l_tmp___1 := l_s
						l_s := l_s + 1
						l_tmp___1.item := ((l_n0).bit_or (((l_n1).bit_shift_right (l_bit_pos)))).to_natural_8
					end
				end
				Result := (l_s.distance (a_str)).to_natural_32
				js.return
			end
			if not js.return_called then
				if 22 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_un >= 22) then
						l_tmp___2 := mpn_sb_get_str (a_str, (0).to_natural_32, a_up, a_un, a_base)
						Result := (l_tmp___2.distance (a_str)).to_natural_32
						js.return
					end
				else
					l_tmp___2 := mpn_sb_get_str (a_str, (0).to_natural_32, a_up, a_un, a_base)
					Result := (l_tmp___2.distance (a_str)).to_natural_32
					js.return
				end
			end
			if not js.return_called then
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_powtab_mem := create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 64).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))
				l_powtab_mem_ptr := l_powtab_mem
				l_big_base.item := mp_bases_inst.gmpn_bases[a_base].big_base
				l_digits_in_base := (mp_bases_inst.gmpn_bases[a_base].chars_per_limb).to_natural_32
				l_n_pows := (0).to_integer_32
				l_xn := ((1).to_double + (a_un.to_double * (mp_bases_inst.gmpn_bases[a_base].chars_per_bit_exactly * (32).to_double)) / (mp_bases_inst.gmpn_bases[a_base].chars_per_limb).to_double).truncated_to_integer
				l_pn := l_xn
				from
				until
					l_pn = 1
				loop
					l_exptab[l_n_pows] := l_pn
					l_n_pows := l_n_pows + 1
					l_pn := ((l_pn + 1)).bit_shift_right (1)
				end
				l_exptab[l_n_pows] := (1).to_integer_32
				l_powtab[0].p := l_big_base
				l_powtab[0].n := (1).to_integer_32
				l_powtab[0].digits_in_base := l_digits_in_base
				l_powtab[0].base := a_base
				l_powtab[0].shift := (0).to_integer_32
				l_powtab[1].p := l_powtab_mem_ptr
				l_powtab_mem_ptr := l_powtab_mem_ptr + (2)
				l_powtab[1].p[0] := l_big_base.item
				l_powtab[1].n := (1).to_integer_32
				l_powtab[1].digits_in_base := l_digits_in_base
				l_powtab[1].base := a_base
				l_powtab[1].shift := (0).to_integer_32
				l_n := (1).to_integer_32
				l_p := l_big_base
				l_bexp := (1).to_integer_32
				l_shift := (0).to_integer_32
				l_pi := 2
				from
				until
					not (not js.loop_done and then (l_pi.to_integer_32 < l_n_pows))
				loop
					l_t := l_powtab_mem_ptr
					l_powtab_mem_ptr := l_powtab_mem_ptr + (2 * l_n + 2)
					from
					until
						js.loop_done
					loop
						if not ((l_powtab_mem_ptr.c_pointer.to_integer_32).to_natural_32 < ((l_powtab_mem + (a_un + 64)).c_pointer.to_integer_32).to_natural_32) then
							assert_inst.gmp_assert_fail (ce_string ("get_str.c"), 474, ce_string ("powtab_mem_ptr < powtab_mem + ((un) + 2 * 32)"))
						end
						js.break
					end
					sqr_inst.gmpn_sqr (l_t, l_p, l_n)
					l_digits_in_base := l_digits_in_base * ({NATURAL_32} 2)
					l_n := l_n * (2)
					l_n := l_n - (l_t[(l_n - 1)] = {NATURAL_32} 0).to_integer
					l_bexp := l_bexp * (2)
					if l_bexp + 1 < l_exptab[l_n_pows - l_pi.to_integer_32] then
						l_digits_in_base := l_digits_in_base + (mp_bases_inst.gmpn_bases[a_base].chars_per_limb).to_natural_32
						l_cy := gmp_inst.gmpn_mul_1 (l_t, l_t, l_n, l_big_base.item)
						l_t[l_n] := l_cy
						l_n := l_n + (l_cy /= {NATURAL_32} 0).to_integer
						l_bexp := l_bexp + 1
					end
					l_shift := l_shift * (2)
					from
					until
						l_t[0] /= {NATURAL_32} 0
					loop
						l_t := l_t + 1
						l_n := l_n - 1
						l_shift := l_shift + 1
					end
					l_p := l_t
					l_powtab[l_pi].p := l_p
					l_powtab[l_pi].n := l_n
					l_powtab[l_pi].digits_in_base := l_digits_in_base
					l_powtab[l_pi].base := a_base
					l_powtab[l_pi].shift := l_shift
					l_pi := l_pi + 1
				end
				l_pi := 1
				from
				until
					not (l_pi.to_integer_32 < l_n_pows)
				loop
					l_t := l_powtab[l_pi].p
					l_n := l_powtab[l_pi].n
					l_cy := gmp_inst.gmpn_mul_1 (l_t, l_t, l_n, l_big_base.item)
					l_t[l_n] := l_cy
					l_n := l_n + (l_cy /= {NATURAL_32} 0).to_integer
					if l_t[0] = {NATURAL_32} 0 then
						l_powtab[l_pi].p := l_t + 1
						l_n := l_n - 1
						l_powtab[l_pi].shift := (l_powtab[l_pi].shift) + 1
					end
					l_powtab[l_pi].n := l_n
					l_powtab[l_pi].digits_in_base := l_powtab[l_pi].digits_in_base + (mp_bases_inst.gmpn_bases[a_base].chars_per_limb).to_natural_32
					l_pi := l_pi + 1
				end
				l_out_len := ((mpn_dc_get_str (a_str, (0).to_natural_32, a_up, a_un, ((l_powtab - 1) + l_pi), (create {CE_POINTER [NATURAL_32]}.make_cast ((tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32)))))).distance (a_str)).to_natural_32
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				Result := l_out_len
			end
		end

	gmpq_get_str (a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32; a_q: CE_POINTER [PD_MPQ_STRUCT]): CE_POINTER [INTEGER_8]
		local
			l_str: CE_POINTER [INTEGER_8]
			l_str_alloc: NATURAL_32
			l_len: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___2: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_str.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_str_alloc := (0).to_natural_32
					if l_str.is_void then
						if a_q.item.mp_num.mp_size >= 0 then
							l_tmp := a_q.item.mp_num.mp_size
						else
							l_tmp := -a_q.item.mp_num.mp_size
						end
						if a_base >= 0 then
							l_tmp___0 := a_base
						else
							l_tmp___0 := -a_base
						end
						l_str_alloc := (((l_tmp + a_q.item.mp_den.mp_size) * 32).to_double * mp_bases_inst.gmpn_bases[l_tmp___0].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 5
						l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_str_alloc]))))
					end
					gmpz_get_str (l_str, a_base, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_num"))).do_nothing
					l_len := strlen (l_str)
					if a_q.item.mp_den.mp_size /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if a_q.item.mp_den.mp_d[0] /= {NATURAL_32} 1 then
							l_pos := -1 + 3 -- goto _L
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 4
				when 3 then -- else: | _L:
						l_tmp___2 := l_len
						l_len := l_len + 1
						l_str[l_tmp___2.to_integer_32] := (('/').code).to_integer_8
						gmpz_get_str (l_str + l_len.to_integer_32, a_base, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (a_q.c_pointer + (create {PD_MPQ_STRUCT}.make).offset_of ("mp_den"))).do_nothing
						l_len := l_len + (strlen ((l_str + l_len.to_integer_32)))
				when 4 then
					if l_str_alloc /= {NATURAL_32} 0 then
						from
						until
							js.loop_done
						loop
							if l_str_alloc /= l_len + {NATURAL_32} 1 then
								l_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_str), l_str_alloc * {PLATFORM}.Integer_8_bytes.to_natural_32, (l_len + {NATURAL_32} 1) * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
							end
							js.break
						end
					end
					Result := l_str
				when 5 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_get_str (a_res_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32; a_x___2: CE_POINTER [PD_MPZ_STRUCT]): CE_POINTER [INTEGER_8]
		local
			l_res_str: CE_POINTER [INTEGER_8]
			l_base: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l_x_size: INTEGER_32
			l_str: CE_POINTER [INTEGER_8]
			l_return_str: CE_POINTER [INTEGER_8]
			l_str_size: NATURAL_32
			l_alloc_size: NATURAL_32
			l_num_to_text: CE_POINTER [INTEGER_8]
			l_i: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l___lb_base: INTEGER_32
			l___cnt: INTEGER_32
			l___totbits: NATURAL_32
			l_tmp: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: INTEGER_32
			l_tmp___3: CE_POINTER [INTEGER_8]
			l_tmp___7: CE_POINTER [ANY]
			l_actual_size: NATURAL_32
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_res_str.make
			create l_xp.make
			create l_str.make
			create l_return_str.make
			create l_num_to_text.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___3.make
			create l_tmp___7.make

			l_res_str := a_res_str
			l_base := a_base
			l_x_size := (a_x___2.item.mp_size).to_integer_32
			l_alloc_size := (0).to_natural_32
			if l_base >= 0 then
				l_num_to_text := ce_string ("0123456789abcdefghijklmnopqrstuvwxyz")
				if l_base = 0 then
					l_base := 10
				elseif l_base > 36 then
					l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz")
					if l_base > 62 then
						Result := (create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer))
						js.return
					end
				end
			else
				l_base := -l_base
				l_num_to_text := ce_string ("0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ")
			end
			if not js.return_called then
				if l_res_str.is_void then
					from
					until
						js.loop_done
					loop
						if l_x_size >= 0 then
							l_tmp___1 := l_x_size
						else
							l_tmp___1 := -l_x_size
						end
						if l_tmp___1 = 0 then
							l_alloc_size := (1).to_natural_32
						else
							from
							until
								js.loop_done
							loop
								if l_x_size >= 0 then
									l_tmp := l_x_size
								else
									l_tmp := -l_x_size
								end
								l___cnt := builtin_clzl (a_x___2.item.mp_d[(l_tmp - 1)])
								js.break
							end
							if l_x_size >= 0 then
								l_tmp___0 := l_x_size
							else
								l_tmp___0 := -l_x_size
							end
							l___totbits := l_tmp___0.to_natural_32 * {NATURAL_32} 32 - l___cnt.to_natural_32
							if ((l_base).bit_and ((l_base - 1))) = 0 then
								l___lb_base := (mp_bases_inst.gmpn_bases[l_base].big_base).to_integer_32
								l_alloc_size := ((l___totbits + l___lb_base.to_natural_32) - {NATURAL_32} 1) // l___lb_base.to_natural_32
							else
								l_alloc_size := (l___totbits.to_real_64 * mp_bases_inst.gmpn_bases[l_base].chars_per_bit_exactly).truncated_to_integer_64.to_natural_32 + {NATURAL_32} 1
							end
						end
						js.break
					end
					l_alloc_size := l_alloc_size + (1 + (l_x_size < 0).to_integer).to_natural_32
					l_res_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([l_alloc_size]))))
				end
				l_return_str := l_res_str
				if l_x_size < 0 then
					l_tmp___3 := l_res_str
					l_res_str := l_res_str + 1
					l_tmp___3[0] := (('-').code).to_integer_8
					l_x_size := -l_x_size
				end
				l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
				l_xp := a_x___2.item.mp_d
				if ((l_base).bit_and ((l_base - 1))) /= 0 then
					if (builtin_expect (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
						l_tmp___7 := (l_aaf.new (((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					else
						l_tmp___7 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((l_x_size + 1).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
					end
					l_xp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
					from
					until
						js.loop_done
					loop
						from
						until
							js.loop_done
						loop
							gmp_inst.gmpn_copyi (l_xp, a_x___2.item.mp_d, l_x_size)
							js.break
						end
						js.break
					end
				end
				l_str_size := gmpn_get_str (create {CE_POINTER [NATURAL_8]}.make_cast (l_res_str), l_base, l_xp, l_x_size)
				l_str := l_res_str
				if (l_res_str[0]).to_integer_32 = 0 then
					if l_str_size /= {NATURAL_32} 1 then
						l_str_size := l_str_size - 1
						l_str := l_str + 1
					end
				end
				l_i := 0
				from
				until
					not (l_i.to_natural_32 < l_str_size)
				loop
					l_res_str[l_i] := l_num_to_text[(l_str[l_i]).to_integer_32]
					l_i := l_i + 1
				end
				l_res_str[l_str_size.to_integer_32] := (0).to_integer_8
				from
				until
					js.loop_done
				loop
					if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
						tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
					end
					js.break
				end
				if l_alloc_size /= {NATURAL_32} 0 then
					l_actual_size := (l_str_size + {NATURAL_32} 1) + (l_res_str.distance (l_return_str)).to_natural_32
					from
					until
						js.loop_done
					loop
						if l_alloc_size /= l_actual_size then
							l_return_str := create {CE_POINTER [INTEGER_8]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (l_return_str), l_alloc_size * {PLATFORM}.Integer_8_bytes.to_natural_32, l_actual_size * {PLATFORM}.Integer_8_bytes.to_natural_32]))))
						end
						js.break
					end
				end
				Result := l_return_str
			end
		end

	mpn_dc_get_str (a_str: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_powtab: CE_POINTER [PD_POWERS]; a_tmp: CE_POINTER [NATURAL_32]): CE_POINTER [NATURAL_8]
		local
			l_str: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_tmp___0: CE_POINTER [NATURAL_8]
			l_pwp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_rp: CE_POINTER [NATURAL_32]
			l_pwn: INTEGER_32
			l_qn: INTEGER_32
			l_sn: INTEGER_32
			l_pos: INTEGER_32
		do
			create l_str.make
			create l_tmp___0.make
			create l_pwp.make
			create l_qp.make
			create l_rp.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_str := a_str
					l_len := a_len
					if 13 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
						l_pos := -1 + 12 -- skip if block
					end
				when 1 then -- if:
						if not (a_un >= 13) then
							l_pos := -1 + 10 -- skip if block
						end
				when 2 then -- if:
						l_pwp := a_powtab.item.p
						l_pwn := a_powtab.item.n
						l_sn := a_powtab.item.shift
						if not (a_un < l_pwn + l_sn) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_str := mpn_dc_get_str (l_str, l_len, a_up, a_un, a_powtab - 1, a_tmp)
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 5 then -- else:
						if a_un /= l_pwn + l_sn then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						if (gmp_inst.gmpn_cmp ((a_up + l_sn), l_pwp, a_un - l_sn)) < 0 then
							l_str := mpn_dc_get_str (l_str, l_len, a_up, a_un, a_powtab - 1, a_tmp)
						else
							l_pos := -1 + 8 -- goto _L
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else: | _L:
						l_qp := a_tmp
						l_rp := a_up
						tdiv_qr_inst.gmpn_tdiv_qr (l_qp, l_rp + l_sn, 0, (a_up + l_sn), a_un - l_sn, l_pwp, l_pwn)
						l_qn := (a_un - l_sn) - l_pwn
						l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
						if l_len /= {NATURAL_32} 0 then
							l_len := l_len - (a_powtab.item.digits_in_base)
						end
						l_str := mpn_dc_get_str (l_str, l_len, l_qp, l_qn, a_powtab - 1, a_tmp + l_qn)
						l_str := mpn_dc_get_str (l_str, a_powtab.item.digits_in_base, l_rp, l_pwn + l_sn, a_powtab - 1, a_tmp)
				when 9 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___0
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 13
				when 12 then -- else: | _L___0:
						if a_un /= 0 then
							l_str := mpn_sb_get_str (l_str, l_len, a_up, a_un, a_powtab.item.base)
						else
							from
							until
								l_len = {NATURAL_32} 0
							loop
								l_tmp___0 := l_str
								l_str := l_str + 1
								l_tmp___0.item := (0).to_natural_8
								l_len := l_len - 1
							end
						end
				when 13 then
					Result := l_str
				when 14 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	mpn_pow_1_highpart___0 (a_rp: CE_POINTER [NATURAL_32]; a_ignp: CE_POINTER [INTEGER_32]; a_base: NATURAL_32; a_exp: NATURAL_32; a_prec: INTEGER_32; a_tp: CE_POINTER [NATURAL_32]): INTEGER_32
		local
			l_rp: CE_POINTER [NATURAL_32]
			l_tp: CE_POINTER [NATURAL_32]
			l_ign: INTEGER_32
			l_off: INTEGER_32
			l_passed_rp: CE_POINTER [NATURAL_32]
			l_rn: INTEGER_32
			l_cnt: INTEGER_32
			l_i: INTEGER_32
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_rp.make
			create l_tp.make
			create l_passed_rp.make
			create l___mp_ptr_swap__tmp.make

			l_rp := a_rp
			l_tp := a_tp
			l_passed_rp := l_rp
			if a_exp = {NATURAL_32} 0 then
				l_rp[0] := (1).to_natural_32
				a_ignp.item := (0).to_integer_32
				Result := (1).to_integer_32
				js.return
			end
			if not js.return_called then
				l_rp[0] := a_base
				l_rn := (1).to_integer_32
				l_off := (0).to_integer_32
				l_ign := (0).to_integer_32
				from
				until
					js.loop_done
				loop
					l_cnt := builtin_clzl (a_exp)
					js.break
				end
				l_i := (32 - l_cnt) - 2
				from
				until
					not (not js.loop_done and then (l_i >= 0))
				loop
					sqr_inst.gmpn_sqr (l_tp, (l_rp + l_off), l_rn)
					l_rn := 2 * l_rn
					l_rn := l_rn - (l_tp[(l_rn - 1)] = {NATURAL_32} 0).to_integer
					l_ign := (l_ign).bit_shift_left ((1))
					l_off := (0).to_integer_32
					if l_rn > a_prec then
						l_ign := l_ign + (l_rn - a_prec)
						l_off := l_rn - a_prec
						l_rn := a_prec
					end
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp := l_rp
						l_rp := l_tp
						l_tp := l___mp_ptr_swap__tmp
						js.break
					end
					if ((((a_exp).bit_shift_right (l_i))).bit_and ({NATURAL_32} 1)) /= {NATURAL_32} 0 then
						l_cy := gmp_inst.gmpn_mul_1 (l_rp, (l_rp + l_off), l_rn, a_base)
						l_rp[l_rn] := l_cy
						l_rn := l_rn + (l_cy /= {NATURAL_32} 0).to_integer
						l_off := (0).to_integer_32
					end
					l_i := l_i - 1
				end
				if l_rn > a_prec then
					l_ign := l_ign + (l_rn - a_prec)
					l_rp := l_rp + (l_rn - a_prec)
					l_rn := a_prec
				end
				if not l_passed_rp.is_equal (l_rp + l_off) then
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_passed_rp, (l_rp + l_off), l_rn)
						js.break
					end
				end
				a_ignp.item := l_ign
				Result := l_rn
			end
		end

	mpn_sb_get_str (a_str: CE_POINTER [NATURAL_8]; a_len: NATURAL_32; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_base: INTEGER_32): CE_POINTER [NATURAL_8]
		local
			l_base: CE_ARRAY [INTEGER_32]
			l_str: CE_POINTER [NATURAL_8]
			l_len: NATURAL_32
			l_un: INTEGER_32
			l_rl: NATURAL_32
			l_ul: NATURAL_32
			l_s: CE_POINTER [NATURAL_8]
			l_l: NATURAL_32
			l_buf: CE_ARRAY [NATURAL_8]
			l_rp: CE_ARRAY [NATURAL_32]
			l_i: INTEGER_32
			l_frac: CE_ARRAY [NATURAL_32]
			l_digit: CE_ARRAY [NATURAL_32]
			l_tmp: CE_POINTER [NATURAL_8]
			l___q: NATURAL_32
			l___r: NATURAL_32
			l_chars_per_limb: NATURAL_32
			l_big_base: NATURAL_32
			l_big_base_inverted: NATURAL_32
			l_normalization_steps: NATURAL_32
			l_i___0: INTEGER_32
			l_frac___0: CE_ARRAY [NATURAL_32]
			l_digit___0: CE_ARRAY [NATURAL_32]
			l_tmp___1: CE_POINTER [NATURAL_8]
			l___q___0: NATURAL_32
			l___r___0: NATURAL_32
			l_tmp___2: CE_POINTER [NATURAL_8]
			l_tmp___3: CE_POINTER [NATURAL_8]
			l_tmp___4: CE_POINTER [NATURAL_8]
			js: JUMP_STATE
		do
			create l_base.make (<<1>>)
			create l_str.make
			create l_s.make
			create l_buf.make (<<448>>)
			create l_rp.make (<<22>>)
			create l_frac.make (<<1>>)
			create l_digit.make (<<1>>)
			create l_tmp.make
			create l_frac___0.make (<<1>>)
			create l_digit___0.make (<<1>>)
			create l_tmp___1.make
			create l_tmp___2.make
			create l_tmp___3.make
			create l_tmp___4.make

			l_base.item := a_base
			l_str := a_str
			l_len := a_len
			l_un := a_un
			if l_base.item = 10 then
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_rp + 1, a_up, l_un)
						js.break
					end
					js.break
				end
				l_s := l_buf + 448
				from
				until
					not (not js.loop_done and then (l_un > 1))
				loop
					gmp_impl_inst.gmpn_preinv_divrem_1 (l_rp, (1).to_integer_32, (l_rp + 1), l_un, (1_000_000_000).to_natural_32, (316_718_722).to_natural_32, 2).do_nothing
					l_un := l_un - (l_rp[l_un] = {NATURAL_32} 0).to_integer
					l_frac.item := l_rp[0] + {NATURAL_32} 1
					l_s := l_s - (9)
					l_i := 9
					from
					until
						js.loop_done
					loop
						asm103 (l_frac, l_digit)
						l_tmp := l_s
						l_s := l_s + 1
						l_tmp.item := (l_digit.item).to_natural_8
						l_i := l_i - 1
						if not l_i.to_boolean then
							js.break
						end
					end
					l_s := l_s - (9)
				end
				l_ul := l_rp[1]
				from
				until
					not (not js.loop_done and then (l_ul /= {NATURAL_32} 0))
				loop
					from
					until
						js.loop_done
					loop
						l___q := l_ul // {NATURAL_32} 10
						l___r := l_ul \\ {NATURAL_32} 10
						l_ul := l___q
						l_rl := l___r
						js.break
					end
					l_s := l_s - 1
					l_s.item := l_rl.to_natural_8
				end
			else
				l_chars_per_limb := (mp_bases_inst.gmpn_bases[l_base.item].chars_per_limb).to_natural_32
				l_big_base := mp_bases_inst.gmpn_bases[l_base.item].big_base
				l_big_base_inverted := mp_bases_inst.gmpn_bases[l_base.item].big_base_inverted
				from
				until
					js.loop_done
				loop
					l_normalization_steps := (builtin_clzl (l_big_base)).to_natural_32
					js.break
				end
				from
				until
					js.loop_done
				loop
					from
					until
						js.loop_done
					loop
						gmp_inst.gmpn_copyi (l_rp + 1, a_up, l_un)
						js.break
					end
					js.break
				end
				l_s := l_buf + 448
				from
				until
					not (not js.loop_done and then (l_un > 1))
				loop
					gmp_impl_inst.gmpn_preinv_divrem_1 (l_rp, (1).to_integer_32, (l_rp + 1), l_un, l_big_base, l_big_base_inverted, l_normalization_steps.to_integer_32).do_nothing
					l_un := l_un - (l_rp[l_un] = {NATURAL_32} 0).to_integer
					l_frac___0.item := l_rp[0] + {NATURAL_32} 1
					l_s := l_s - l_chars_per_limb.to_integer_32
					l_i___0 := l_chars_per_limb.to_integer_32
					from
					until
						js.loop_done
					loop
						asm104 (l_frac___0, l_digit___0, l_base)
						l_tmp___1 := l_s
						l_s := l_s + 1
						l_tmp___1.item := (l_digit___0.item).to_natural_8
						l_i___0 := l_i___0 - 1
						if not l_i___0.to_boolean then
							js.break
						end
					end
					l_s := l_s - l_chars_per_limb.to_integer_32
				end
				l_ul := l_rp[1]
				from
				until
					not (not js.loop_done and then (l_ul /= {NATURAL_32} 0))
				loop
					from
					until
						js.loop_done
					loop
						l___q___0 := l_ul // (l_base.item).to_natural_32
						l___r___0 := l_ul \\ (l_base.item).to_natural_32
						l_ul := l___q___0
						l_rl := l___r___0
						js.break
					end
					l_s := l_s - 1
					l_s.item := l_rl.to_natural_8
				end
			end
			l_l := ((l_buf + 448).distance (l_s)).to_natural_32
			from
			until
				not (l_l < l_len)
			loop
				l_tmp___2 := l_str
				l_str := l_str + 1
				l_tmp___2.item := (0).to_natural_8
				l_len := l_len - 1
			end
			from
			until
				l_l = {NATURAL_32} 0
			loop
				l_tmp___3 := l_str
				l_str := l_str + 1
				l_tmp___4 := l_s
				l_s := l_s + 1
				l_tmp___3.item := l_tmp___4.item
				l_l := l_l - 1
			end
			Result := l_str
		end

end
