class
	P_IMPORT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_import (a_z: CE_POINTER [PD_MPZ_STRUCT]; a_count: NATURAL_32; a_order: INTEGER_32; a_size: NATURAL_32; a_endian: INTEGER_32; a_nail: NATURAL_32; a_data: CE_POINTER [ANY])
		local
			l_endian: INTEGER_32
			l_zsize: INTEGER_32
			l_zp: CE_POINTER [NATURAL_32]
			l_align: NATURAL_32
			l___dst: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___src: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___size: INTEGER_32
			l___i: INTEGER_32
			l___dst___0: CE_POINTER [NATURAL_32]
			l___size___0: INTEGER_32
			l___src___0: CE_POINTER [NATURAL_32]
			l___i___0: INTEGER_32
			l_limb: NATURAL_32
			l_byte: NATURAL_32
			l_wbitsmask: NATURAL_32
			l_i: NATURAL_32
			l_j: NATURAL_32
			l_numb: NATURAL_32
			l_wbytes: NATURAL_32
			l_woffset: INTEGER_32
			l_dp: CE_POINTER [NATURAL_8]
			l_lbits: INTEGER_32
			l_wbits: INTEGER_32
			l_tmp___0: INTEGER_32
			l_tmp___1: NATURAL_32
			l_tmp___2: NATURAL_32
			l_tmp___3: NATURAL_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_tmp___6: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_zp.make
			create l___dst.make (<<1>>)
			create l___src.make (<<1>>)
			create l___dst___0.make
			create l___src___0.make
			create l_dp.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_tmp___6.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_endian := a_endian
					l_zsize := (((a_count * ({NATURAL_32} 8 * a_size - a_nail) + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
					if (builtin_expect ((l_zsize > (a_z.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
						realloc_inst.gmpz_realloc (a_z, l_zsize).do_nothing
					end
					l_zp := a_z.item.mp_d
					if l_endian = 0 then
						l_endian := -1
					end
					if a_nail /= {NATURAL_32} 0 then
						l_pos := -1 + 4 -- skip if block
					end
				when 1 then -- if:
						l_align := ((create {CE_POINTER [INTEGER_8]}.make_cast (a_data)).distance ((create {CE_POINTER [INTEGER_8]}.make_shared (default_pointer)))).to_natural_32 \\ {PLATFORM}.Natural_32_bytes.to_natural_32
						if a_order = -1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = -1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											js.loop_done
										loop
											from
											until
												js.loop_done
											loop
												gmp_inst.gmpn_copyi (l_zp, create {CE_POINTER [NATURAL_32]}.make_cast (a_data), a_count.to_integer_32)
												js.break
											end
											js.break
										end
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 2 then
						if a_order = -1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = 1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											js.loop_done
										loop
											l___dst.item := l_zp
											l___src.item := create {CE_POINTER [NATURAL_32]}.make_cast (a_data)
											l___size := a_count.to_integer_32
											l___i := (0).to_integer_32
											from
											until
												not (not js.loop_done and then (l___i < l___size))
											loop
												from
												until
													js.loop_done
												loop
													asm17 (l___dst, l___src)
													js.break
												end
												l___dst.item := l___dst.item + 1
												l___src.item := l___src.item + 1
												l___i := l___i + 1
											end
											js.break
										end
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 3 then
						if a_order = 1 then
							if a_size = {PLATFORM}.Natural_32_bytes.to_natural_32 then
								if l_endian = -1 then
									if l_align = {NATURAL_32} 0 then
										from
										until
											js.loop_done
										loop
											l___dst___0 := l_zp
											l___size___0 := a_count.to_integer_32
											l___src___0 := (create {CE_POINTER [NATURAL_32]}.make_cast (a_data) + l___size___0) - 1
											l___i___0 := (0).to_integer_32
											from
											until
												not (l___i___0 < l___size___0)
											loop
												l___dst___0.item := l___src___0.item
												l___dst___0 := l___dst___0 + 1
												l___src___0 := l___src___0 - 1
												l___i___0 := l___i___0 + 1
											end
											js.break
										end
										l_pos := -1 + 5 -- goto done
									end
								end
							end
						end
				when 4 then
					l_numb := a_size * {NATURAL_32} 8 - a_nail
					l_wbytes := l_numb // {NATURAL_32} 8
					l_wbits := (l_numb \\ {NATURAL_32} 8).to_integer_32
					l_wbitsmask := (({NATURAL_32} 1).bit_shift_left (l_wbits)) - {NATURAL_32} 1
					l_woffset := ((l_numb + {NATURAL_32} 7) // {NATURAL_32} 8).to_integer_32
					if l_endian >= 0 then
						l_tmp___0 := l_woffset
					else
						l_tmp___0 := -l_woffset
					end
					if a_order < 0 then
						l_tmp___1 := a_size.to_natural_32
					else
						l_tmp___1 := (-a_size.to_integer_32).to_natural_32
					end
					l_woffset := (l_tmp___0.to_natural_32 + l_tmp___1).to_integer_32
					if a_order >= 0 then
						l_tmp___2 := (a_count - {NATURAL_32} 1) * a_size
					else
						l_tmp___2 := (0).to_natural_32
					end
					if l_endian >= 0 then
						l_tmp___3 := a_size - {NATURAL_32} 1
					else
						l_tmp___3 := (0).to_natural_32
					end
					l_dp := (create {CE_POINTER [NATURAL_8]}.make_cast (a_data) + l_tmp___2.to_integer_32) + l_tmp___3.to_integer_32
					l_limb := (0).to_natural_32
					l_lbits := 0
					l_i := (0).to_natural_32
					from
					until
						not (not js.loop_done and then (l_i < a_count))
					loop
						l_j := (0).to_natural_32
						from
						until
							not (not js.loop_done and then (l_j < l_wbytes))
						loop
							l_byte := (l_dp.item).to_natural_32
							l_dp := l_dp - l_endian
							from
							until
								js.loop_done
							loop
								l_limb := (l_limb).bit_or (((l_byte).bit_shift_left (l_lbits)))
								l_lbits := l_lbits + (8)
								if l_lbits >= 32 then
									l_tmp___4 := l_zp
									l_zp := l_zp + 1
									l_tmp___4.item := (l_limb).bit_and ({NATURAL_32} 4_294_967_295)
									l_lbits := l_lbits - (32)
									l_limb := (l_byte).bit_shift_right ((8 - l_lbits))
								end
								js.break
							end
							l_j := l_j + 1
						end
						if l_wbits /= 0 then
							l_byte := ((l_dp.item).to_natural_32).bit_and (l_wbitsmask)
							l_dp := l_dp - l_endian
							from
							until
								js.loop_done
							loop
								l_limb := (l_limb).bit_or (((l_byte).bit_shift_left (l_lbits)))
								l_lbits := l_lbits + l_wbits
								if l_lbits >= 32 then
									l_tmp___5 := l_zp
									l_zp := l_zp + 1
									l_tmp___5.item := (l_limb).bit_and ({NATURAL_32} 4_294_967_295)
									l_lbits := l_lbits - (32)
									l_limb := (l_byte).bit_shift_right ((l_wbits - l_lbits))
								end
								js.break
							end
						end
						l_dp := l_dp + l_woffset
						l_i := l_i + 1
					end
					if l_lbits /= 0 then
						l_tmp___6 := l_zp
						l_zp := l_zp + 1
						l_tmp___6.item := l_limb
					end
				when 5 then -- done:
					l_zp := a_z.item.mp_d
					from
					until
						js.loop_done
					loop
						from
						until
							not (not js.loop_done and then (l_zsize > 0))
						loop
							if l_zp[(l_zsize - 1)] /= {NATURAL_32} 0 then
								js.break
							end
							if not js.loop_jumped then
								l_zsize := l_zsize - 1
							end
						end
						js.break
					end
					a_z.item.mp_size := l_zsize.to_integer_32
				when 6 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
