class
	P_INITS

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_inits (a_args: TUPLE [a_x___2: CE_POINTER [PD_MPF_STRUCT]])
		local
			l_x___2: CE_POINTER [PD_MPF_STRUCT]
			l_ap: CE_VA_LIST
		do
			create l_x___2.make
			create l_ap.make_shared (default_pointer)

			l_x___2 := a_args.a_x___2
			l_ap := create {CE_VA_LIST}.make (a_args, 2)
			from
			until
				l_x___2.is_void
			loop
				init_inst.gmpf_init (l_x___2)
				l_x___2 := (create {CE_POINTER [PD_MPF_STRUCT]}.make_cast (l_ap.pointer_item))
			end
		end

	gmpq_inits (a_args: TUPLE [a_x___2: CE_POINTER [PD_MPQ_STRUCT]])
		local
			l_x___2: CE_POINTER [PD_MPQ_STRUCT]
			l_ap: CE_VA_LIST
		do
			create l_x___2.make
			create l_ap.make_shared (default_pointer)

			l_x___2 := a_args.a_x___2
			l_ap := create {CE_VA_LIST}.make (a_args, 2)
			from
			until
				l_x___2.is_void
			loop
				init_inst.gmpq_init (l_x___2)
				l_x___2 := (create {CE_POINTER [PD_MPQ_STRUCT]}.make_cast (l_ap.pointer_item))
			end
		end

	gmpz_inits (a_args: TUPLE [a_x___2: CE_POINTER [PD_MPZ_STRUCT]])
		local
			l_x___2: CE_POINTER [PD_MPZ_STRUCT]
			l_ap: CE_VA_LIST
		do
			create l_x___2.make
			create l_ap.make_shared (default_pointer)

			l_x___2 := a_args.a_x___2
			l_ap := create {CE_VA_LIST}.make (a_args, 2)
			from
			until
				l_x___2.is_void
			loop
				init_inst.gmpz_init (l_x___2)
				l_x___2 := (create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_ap.pointer_item))
			end
		end

end
