class
	P_INVERT

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_invert (a_ip: CE_POINTER [NATURAL_32]; a_dp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_dp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_ip: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_scratch: CE_POINTER [NATURAL_32]
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_i: INTEGER_32
			l_xp: CE_POINTER [NATURAL_32]
			l___d: CE_POINTER [NATURAL_32]
			l___s: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___4: CE_POINTER [NATURAL_32]
			l_tmp___5: CE_POINTER [NATURAL_32]
			l_inv: PD_GMP_PI1_T
			l_v: CE_ARRAY [NATURAL_32]
			l_p: NATURAL_32
			l_t1: CE_ARRAY [NATURAL_32]
			l_t0: CE_ARRAY [NATURAL_32]
			l_mask: NATURAL_32
			l_e: NATURAL_32
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_n.make (<<1>>)
			create l_dp.make (<<1>>)
			create l_ip.make (<<1>>)
			create l_scratch.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make
			create l_xp.make
			create l___d.make
			create l___s.make
			create l_tmp___4.make
			create l_tmp___5.make
			create l_inv.make
			create l_v.make (<<1>>)
			create l_t1.make (<<1>>)
			create l_t0.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_n.item := a_n
					l_dp.item := a_dp
					l_ip.item := a_ip
					l_scratch := a_scratch
					if l_n.item /= 1 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							l_ip.item.item := gmp_impl_inst.gmpn_invert_limb (l_dp.item.item)
							js.break
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 8
				when 3 then -- else:
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						if l_scratch.is_void then
							if (builtin_expect (((3 * l_n.item + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___2 := (l_aaf.new (((3 * l_n.item + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((3 * l_n.item + 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l_scratch := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
						end
						if 61 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if l_n.item >= 61 then
							l_e := invertappr_inst.gmpn_ni_invertappr (l_ip.item, l_dp.item, l_n.item, l_scratch)
							if l_e.to_boolean then
								mul_n_inst.gmpn_mul_n (l_scratch, l_ip.item, l_dp.item, l_n.item)
								gmp_inst.gmpn_add_n (l_scratch + l_n.item, (l_scratch + l_n.item), l_dp.item, l_n.item).do_nothing
								if not (gmp_inst.gmpn_add (l_scratch, l_scratch, 2 * l_n.item, l_dp.item, l_n.item)).to_boolean then
									from
									until
										js.loop_done
									loop
										asm220 (l___ptr_dummy, l_ip)
										js.break
									end
								end
							end
						else
							l_pos := -1 + 6 -- goto _L
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L:
						l_xp := l_scratch
						l_i := l_n.item - 1
						from
						until
							not (l_i >= 0)
						loop
							l_xp[l_i] := {NATURAL_32} 4_294_967_295
							l_i := l_i - 1
						end
						from
						until
							js.loop_done
						loop
							l___d := l_xp + l_n.item
							l___s := l_dp.item
							l___n := l_n.item
							from
							until
								js.loop_done
							loop
								l_tmp___4 := l___d
								l___d := l___d + 1
								l_tmp___5 := l___s
								l___s := l___s + 1
								l_tmp___4.item := (((l_tmp___5.item).bit_not).bit_and ({NATURAL_32} 4_294_967_295))
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
							js.break
						end
						if l_n.item = 2 then
							gmp_inst.gmpn_divrem_2 (l_ip.item, (0).to_integer_32, l_xp, (4).to_integer_32, l_dp.item).do_nothing
						else
							from
							until
								js.loop_done
							loop
								from
								until
									js.loop_done
								loop
									l_v.item := gmp_impl_inst.gmpn_invert_limb (l_dp.item[(l_n.item - 1)])
									js.break
								end
								l_p := (l_dp.item[(l_n.item - 1)] * l_v.item)
								l_p := l_p + (l_dp.item[(l_n.item - 2)])
								if l_p < l_dp.item[(l_n.item - 2)] then
									l_v.item := l_v.item - 1
									l_mask := (-(l_p >= l_dp.item[(l_n.item - 1)]).to_integer).to_integer.to_natural_32
									l_p := l_p - (l_dp.item[(l_n.item - 1)])
									l_v.item := l_v.item + l_mask
									l_p := l_p - ((l_mask).bit_and (l_dp.item[(l_n.item - 1)]))
								end
								asm221 (l_t0, l_t1, l_dp, l_n, l_v)
								l_p := l_p + (l_t1.item)
								if l_p < l_t1.item then
									l_v.item := l_v.item - 1
									if (builtin_expect ((l_p >= l_dp.item[(l_n.item - 1)]).to_integer, 0)).to_boolean then
										if l_p > l_dp.item[(l_n.item - 1)] then
											l_v.item := l_v.item - 1
										elseif l_t0.item >= l_dp.item[(l_n.item - 2)] then
											l_v.item := l_v.item - 1
										end
									end
								end
								l_inv.inv32 := l_v.item
								js.break
							end
							sbpi1_div_q_inst.gmpn_sbpi1_div_q (l_ip.item, l_xp, 2 * l_n.item, l_dp.item, l_n.item, l_inv.inv32).do_nothing
						end
				when 7 then
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
				when 8 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	gmpz_invert (a_inverse: CE_POINTER [PD_MPZ_STRUCT]; a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_n: CE_POINTER [PD_MPZ_STRUCT]): INTEGER_32
		local
			l_gcd: CE_ARRAY [PD_MPZ_STRUCT]
			l_tmp: CE_ARRAY [PD_MPZ_STRUCT]
			l_xsize: INTEGER_32
			l_nsize: INTEGER_32
			l_size: INTEGER_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___0: INTEGER_32
			l___x: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___4: CE_POINTER [ANY]
			l___x___0: CE_POINTER [PD_MPZ_STRUCT]
			l_tmp___9: CE_POINTER [ANY]
			js: JUMP_STATE
			l_pos: INTEGER_32
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_gcd.make (<<1>>)
			create l_tmp.make (<<1>>)
			create l___tmp_marker.make (<<1>>)
			create l___x.make
			create l_tmp___4.make
			create l___x___0.make
			create l_tmp___9.make

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_xsize := (a_x___2.item.mp_size).to_integer_32
					l_nsize := (a_n.item.mp_size).to_integer_32
					if l_xsize >= 0 then
						l_xsize := l_xsize
					else
						l_xsize := -l_xsize
					end
					if l_nsize >= 0 then
						l_nsize := l_nsize
					else
						l_nsize := -l_nsize
					end
					if l_xsize > l_nsize then
						l_tmp___0 := l_xsize
					else
						l_tmp___0 := l_nsize
					end
					l_size := l_tmp___0 + 1
					if l_xsize = 0 then
						Result := 0
						js.return
					elseif l_nsize = 1 then
						if a_n.item.mp_d[0] = {NATURAL_32} 1 then
							Result := 0
							js.return
						end
					end
					if js.return_called then
						l_pos := -1 + 6 -- skip if block
					end
				when 1 then -- if:
						l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
						from
						until
							js.loop_done
						loop
							l___x := l_gcd
							l___x.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___4 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___4 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l___x.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___4)
							js.break
						end
						from
						until
							js.loop_done
						loop
							l___x___0 := l_tmp
							l___x___0.item.mp_alloc := l_size.to_integer_32
							if (builtin_expect ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
								l_tmp___9 := (l_aaf.new ((l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							else
								l_tmp___9 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (l_size.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
							end
							l___x___0.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___9)
							js.break
						end
						gcdext_inst.gmpz_gcdext (l_gcd, l_tmp, create {CE_POINTER [PD_MPZ_STRUCT]}.make_shared (default_pointer), a_x___2, a_n)
						if l_gcd[0].mp_size = 1 then
							l_pos := -1 + 4 -- skip if block
						end
				when 2 then -- if:
						l_pos := -1 + 5 -- goto _L
				when 3 then -- if block done, skip else block:
						l_pos := -1 + 6
				when 4 then -- else:
						if l_gcd[0].mp_d[0] = {NATURAL_32} 1 then
							l_pos := -1 + 6 -- skip if block
						end
				when 5 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
								tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
							end
							js.break
						end
						Result := 0
						js.return
				when 6 then -- if done | if done
						if not js.return_called then
							if l_tmp[0].mp_size < 0 then
								if a_n.item.mp_size < 0 then
									aors_inst.gmpz_sub (a_inverse, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
								else
									aors_inst.gmpz_add (a_inverse, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp), a_n)
								end
							else
								set_inst.gmpz_set (a_inverse, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_tmp))
							end
							from
							until
								js.loop_done
							loop
								if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
									tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
								end
								js.break
							end
							Result := 1
						end
				when 7 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
