class
	P_ISET_STR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpf_init_set_str (a_r: CE_POINTER [PD_MPF_STRUCT]; a_s: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		local
			l_prec: INTEGER_32
		do
			l_prec := set_dfl_prec_inst.gmp_default_fp_limb_precision
			a_r.item.mp_size := 0
			a_r.item.mp_exp := (0).to_integer_32
			a_r.item.mp_prec := l_prec.to_integer_32
			a_r.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([((l_prec + 1) * 4).to_natural_32]))))
			Result := (set_str_inst.gmpf_set_str (a_r, a_s, a_base))
		end

	gmpz_init_set_str (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_str: CE_POINTER [INTEGER_8]; a_base: INTEGER_32): INTEGER_32
		do
			a_x___2.item.mp_alloc := 1
			a_x___2.item.mp_d := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_allocate_func.pointer_item ([(4).to_natural_32]))))
			a_x___2.item.mp_size := 0
			Result := (set_str_inst.gmpz_set_str (a_x___2, a_str, a_base))
		end

end
