class
	P_JACBASE

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_jacobi_base (a_a: NATURAL_32; a_b: NATURAL_32; a_result_bit1: INTEGER_32): INTEGER_32
		local
			l_a: NATURAL_32
			l_b: NATURAL_32
			l_result_bit1: INTEGER_32
			l_twos: NATURAL_32
			l___mp_limb_t_swap__tmp: NATURAL_32
			l_twos___0: NATURAL_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_a := a_a
					l_b := a_b
					l_result_bit1 := a_result_bit1
					if l_a = {NATURAL_32} 0 then
						Result := 0
						js.return
					end
					if js.return_called then
						l_pos := -1 + 10 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							l_twos := (builtin_ctzl (l_a)).to_natural_32
							js.break
						end
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos).bit_shift_left (1)).to_integer_32).bit_and (((((l_b).bit_shift_right (1))).bit_xor (l_b)).to_integer_32)))
						l_a := (l_a).bit_shift_right (l_twos.to_integer_32)
						if l_a = {NATURAL_32} 1 then
							l_pos := -1 + 11 -- goto done
						end
				when 2 then
						if js.loop_done then
							l_pos := -1 + 10 -- skip loop
						end
				when 3 then -- loop body:
						l_result_bit1 := (l_result_bit1).bit_xor (((l_a).bit_and (l_b)).to_integer_32)
						from
						until
							js.loop_done
						loop
							l___mp_limb_t_swap__tmp := l_a
							l_a := l_b
							l_b := l___mp_limb_t_swap__tmp
							js.break
						end
				when 4 then -- loop condition:
						if js.loop_done then
							l_pos := -1 + 9 -- skip loop
						end
				when 5 then -- loop body:
						l_a := l_a - l_b
						if l_a = {NATURAL_32} 0 then
							Result := 0
							js.return
						end
						if js.return_called then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if:
						from
						until
							js.loop_done
						loop
							l_twos___0 := (builtin_ctzl (l_a)).to_natural_32
							js.break
						end
						l_result_bit1 := (l_result_bit1).bit_xor (((((l_twos___0).bit_shift_left (1)).to_integer_32).bit_and (((((l_b).bit_shift_right (1))).bit_xor (l_b)).to_integer_32)))
						l_a := (l_a).bit_shift_right (l_twos___0.to_integer_32)
						if l_a = {NATURAL_32} 1 then
							l_pos := -1 + 11 -- goto done
						end
				when 7 then
						if not (l_a >= l_b) then
							js.break
						end
				when 8 then -- if done
						l_pos := -1 + 4 -- back to loop condition
				when 9 then -- loop done
						l_pos := -1 + 2 -- back to loop condition
				when 10 then -- loop done | if done
						if js.return_called then
							l_pos := -1 + 12 -- skip if block
						end
				when 11 then -- if: | done:
							Result := (1 - ((l_result_bit1).bit_and (2)))
				when 12 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
