class
	P_MOD_1_1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_mod_1_1p (a_ap: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_b: NATURAL_32; a_bmodb: CE_POINTER [NATURAL_32]): NATURAL_32
		local
			l_n: CE_ARRAY [INTEGER_32]
			l_ap: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rh: CE_ARRAY [NATURAL_32]
			l_rl: CE_ARRAY [NATURAL_32]
			l_bi: CE_ARRAY [NATURAL_32]
			l_q: NATURAL_32
			l_ph: CE_ARRAY [NATURAL_32]
			l_pl: CE_ARRAY [NATURAL_32]
			l_r: NATURAL_32
			l_B1modb: CE_ARRAY [NATURAL_32]
			l_B2modb: CE_ARRAY [NATURAL_32]
			l_i: CE_ARRAY [INTEGER_32]
			l_cnt: CE_ARRAY [INTEGER_32]
			l_mask: NATURAL_32
			l__qh: CE_ARRAY [NATURAL_32]
			l__ql: CE_ARRAY [NATURAL_32]
			l__r: NATURAL_32
			js: JUMP_STATE
		do
			create l_n.make (<<1>>)
			create l_ap.make (<<1>>)
			create l_rh.make (<<1>>)
			create l_rl.make (<<1>>)
			create l_bi.make (<<1>>)
			create l_ph.make (<<1>>)
			create l_pl.make (<<1>>)
			create l_B1modb.make (<<1>>)
			create l_B2modb.make (<<1>>)
			create l_i.make (<<1>>)
			create l_cnt.make (<<1>>)
			create l__qh.make (<<1>>)
			create l__ql.make (<<1>>)

			l_n.item := a_n
			l_ap.item := a_ap
			l_B1modb.item := a_bmodb[2]
			l_B2modb.item := a_bmodb[3]
			asm38 (l_pl, l_ph, l_ap, l_n, l_B1modb)
			asm39 (l_rh, l_rl, l_ph, l_pl, l_ap, l_n)
			l_i.item := l_n.item - 3
			from
			until
				not (l_i.item >= 0)
			loop
				asm40 (l_pl, l_ph, l_rl, l_B1modb)
				asm41 (l_ph, l_pl, l_ap, l_i)
				asm42 (l_rl, l_rh, l_B2modb)
				asm43 (l_rh, l_rl, l_ph, l_pl)
				l_i.item := l_i.item - 1
			end
			l_bi.item := a_bmodb[0]
			l_cnt.item := (a_bmodb[1]).to_integer_32
			if (builtin_expect ((l_cnt.item /= 0).to_integer, 1)).to_boolean then
				l_rh.item := (((l_rh.item).bit_shift_left (l_cnt.item))).bit_or (((l_rl.item).bit_shift_right ((32 - l_cnt.item))))
			end
			l_mask := (-((l_rh.item >= a_b).to_integer.to_natural_32).to_integer_32).to_natural_32
			l_rh.item := l_rh.item - ((l_mask).bit_and (a_b))
			from
			until
				js.loop_done
			loop
				asm44 (l__ql, l__qh, l_rh, l_bi)
				asm45 (l__qh, l__ql, l_rh, l_rl, l_cnt)
				l__r := ((l_rl.item).bit_shift_left (l_cnt.item)) - l__qh.item * a_b
				if l__r > l__ql.item then
					l__r := l__r + a_b
					l__qh.item := l__qh.item - 1
				end
				if (builtin_expect ((l__r >= a_b).to_integer, 0)).to_boolean then
					l__r := l__r - a_b
					l__qh.item := l__qh.item + 1
				end
				l_r := l__r
				l_q := l__qh.item
				js.break
			end
			Result := ((l_r).bit_shift_right (l_cnt.item))
		end

	gmpn_mod_1_1p_cps (a_cps: CE_POINTER [NATURAL_32]; a_b: NATURAL_32)
		local
			l_b: NATURAL_32
			l_bi: CE_ARRAY [NATURAL_32]
			l_B1modb: CE_ARRAY [NATURAL_32]
			l_B2modb: NATURAL_32
			l_cnt: INTEGER_32
			l__qh: CE_ARRAY [NATURAL_32]
			l__ql: CE_ARRAY [NATURAL_32]
			l__r: NATURAL_32
			js: JUMP_STATE
		do
			create l_bi.make (<<1>>)
			create l_B1modb.make (<<1>>)
			create l__qh.make (<<1>>)
			create l__ql.make (<<1>>)

			l_b := a_b
			from
			until
				js.loop_done
			loop
				l_cnt := builtin_clzl (l_b)
				js.break
			end
			l_b := (l_b).bit_shift_left (l_cnt)
			from
			until
				js.loop_done
			loop
				l_bi.item := gmp_impl_inst.gmpn_invert_limb (l_b)
				js.break
			end
			if (builtin_expect ((l_cnt = 0).to_integer, 0)).to_boolean then
				l_B1modb.item := (-l_b.to_integer_32).to_natural_32
			else
				l_B1modb.item := (-l_b.to_integer_32).to_natural_32 * ((((l_bi.item).bit_shift_right ((32 - l_cnt)))).bit_or ((({NATURAL_32} 1).bit_shift_left (l_cnt))))
			end
			from
			until
				js.loop_done
			loop
				asm37 (l__ql, l__qh, l_B1modb, l_bi)
				l__qh.item := l__qh.item + (l_B1modb.item + {NATURAL_32} 1)
				l__r := (-(l__qh.item).to_integer_32).to_natural_32 * l_b
				if l__r > l__ql.item then
					l__r := l__r + l_b
				end
				l_B2modb := l__r
				js.break
			end
			a_cps[0] := l_bi.item
			a_cps[1] := l_cnt.to_natural_32
			a_cps[2] := (l_B1modb.item).bit_shift_right (l_cnt)
			a_cps[3] := (l_B2modb).bit_shift_right (l_cnt)
		end

end
