class
	P_MULMOD_BNM1

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_bc_mulmod_bnm1 (a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_rp.make (<<1>>)
			create l_cy.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp
			mul_n_inst.gmpn_mul_n (a_tp, a_ap, a_bp, a_rn)
			l_cy.item := gmp_inst.gmpn_add_n (l_rp.item, a_tp, (a_tp + a_rn), a_rn)
			from
			until
				js.loop_done
			loop
				asm222 (l___ptr_dummy, l_rp, l_cy)
				js.break
			end
		end

	gmpn_mulmod_bnm1 (a_rp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_bp: CE_POINTER [NATURAL_32]; a_bn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_tp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_cy___0: CE_ARRAY [NATURAL_32]
			l_hi: NATURAL_32
			l_am1: CE_POINTER [NATURAL_32]
			l_bm1: CE_POINTER [NATURAL_32]
			l_anm: INTEGER_32
			l_bnm: INTEGER_32
			l_so: CE_POINTER [NATURAL_32]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_k: INTEGER_32
			l_ap1: CE_POINTER [NATURAL_32]
			l_bp1: CE_POINTER [NATURAL_32]
			l_anp: INTEGER_32
			l_bnp: INTEGER_32
			l___ptr_dummy___2: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___3: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_mask: INTEGER_32
			l___ptr_dummy___4: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___5: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___6: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_tp.make (<<1>>)
			create l_rp.make (<<1>>)
			create l_cy.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)
			create l_n.make (<<1>>)
			create l_cy___0.make (<<1>>)
			create l_am1.make
			create l_bm1.make
			create l_so.make
			create l___ptr_dummy___0.make (<<1>>)
			create l___ptr_dummy___1.make (<<1>>)
			create l_ap1.make
			create l_bp1.make
			create l___ptr_dummy___2.make (<<1>>)
			create l___ptr_dummy___3.make (<<1>>)
			create l___ptr_dummy___4.make (<<1>>)
			create l___ptr_dummy___5.make (<<1>>)
			create l___ptr_dummy___6.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_tp.item := a_tp
					l_rp.item := a_rp
					if ((a_rn).bit_and (1)) = 0 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 6 -- goto _L___0
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if 13 = -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_rn >= 13 then
							l_n.item := (a_rn).bit_shift_right (1)
							if (builtin_expect ((a_an > l_n.item).to_integer, 1)).to_boolean then
								l_am1 := l_tp.item
								l_cy___0.item := gmp_inst.gmpn_add (l_tp.item, a_ap, l_n.item, a_ap + l_n.item, a_an - l_n.item)
								from
								until
									js.loop_done
								loop
									asm224 (l___ptr_dummy___0, l_tp, l_cy___0)
									js.break
								end
								l_anm := l_n.item
								if (builtin_expect ((a_bn > l_n.item).to_integer, 1)).to_boolean then
									l_bm1 := (l_tp.item + l_n.item)
									l_cy___0.item := gmp_inst.gmpn_add (l_tp.item + l_n.item, a_bp, l_n.item, a_bp + l_n.item, a_bn - l_n.item)
									from
									until
										js.loop_done
									loop
										asm225 (l___ptr_dummy___1, l_tp, l_n, l_cy___0)
										js.break
									end
									l_bnm := l_n.item
									l_so := l_tp.item + 2 * l_n.item
								else
									l_so := l_tp.item + l_n.item
									l_bm1 := a_bp
									l_bnm := a_bn
								end
							else
								l_so := l_tp.item
								l_am1 := a_ap
								l_anm := a_an
								l_bm1 := a_bp
								l_bnm := a_bn
							end
							gmpn_mulmod_bnm1 (l_rp.item, l_n.item, l_am1, l_anm, l_bm1, l_bnm, l_so)
							if (builtin_expect ((a_an > l_n.item).to_integer, 1)).to_boolean then
								l_ap1 := ((l_tp.item + 2 * l_n.item) + 2)
								l_cy___0.item := gmp_inst.gmpn_sub ((l_tp.item + 2 * l_n.item) + 2, a_ap, l_n.item, a_ap + l_n.item, a_an - l_n.item);
								((l_tp.item + 2 * l_n.item) + 2)[l_n.item] := (0).to_natural_32
								from
								until
									js.loop_done
								loop
									asm226 (l___ptr_dummy___2, l_tp, l_n, l_cy___0)
									js.break
								end
								l_anp := ((l_n.item).to_natural_32 + l_ap1[l_n.item]).to_integer_32
							else
								l_ap1 := a_ap
								l_anp := a_an
							end
							if (builtin_expect ((a_bn > l_n.item).to_integer, 1)).to_boolean then
								l_bp1 := ((((l_tp.item + 2 * l_n.item) + 2) + l_n.item) + 1)
								l_cy___0.item := gmp_inst.gmpn_sub ((((l_tp.item + 2 * l_n.item) + 2) + l_n.item) + 1, a_bp, l_n.item, a_bp + l_n.item, a_bn - l_n.item);
								((l_tp.item + 2 * l_n.item) + 2)[(2 * l_n.item + 1)] := (0).to_natural_32
								from
								until
									js.loop_done
								loop
									asm227 (l___ptr_dummy___3, l_tp, l_n, l_cy___0)
									js.break
								end
								l_bnp := ((l_n.item).to_natural_32 + l_bp1[l_n.item]).to_integer_32
							else
								l_bp1 := a_bp
								l_bnp := a_bn
							end
							if 565 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
								if l_n.item >= 565 then
									l_k := mul_fft_inst.gmpn_fft_best_k (l_n.item, 0)
									l_mask := ((1).bit_shift_left (l_k)) - 1
									from
									until
										not (((l_n.item).bit_and (l_mask.to_integer_32)).to_boolean)
									loop
										l_k := l_k - 1
										l_mask := (l_mask).bit_shift_right ((1))
									end
								else
									l_k := 0
								end
							else
								l_k := 0
							end
							if l_k >= 4 then
								l_tp.item[l_n.item] := mul_fft_inst.gmpn_mul_fft (l_tp.item, l_n.item, l_ap1, l_anp, l_bp1, l_bnp, l_k)
							elseif (builtin_expect ((l_bp1.is_equal (a_bp)).to_integer, 0)).to_boolean then
								mul_inst.gmpn_mul (l_tp.item, l_ap1, l_anp, l_bp1, l_bnp).do_nothing
								l_anp := (l_anp + l_bnp) - l_n.item
								l_anp := l_anp - (l_anp > l_n.item).to_integer
								l_cy___0.item := gmp_inst.gmpn_sub (l_tp.item, l_tp.item, l_n.item, (l_tp.item + l_n.item), l_anp)
								l_tp.item[l_n.item] := (0).to_natural_32
								from
								until
									js.loop_done
								loop
									asm228 (l___ptr_dummy___4, l_tp, l_cy___0)
									js.break
								end
							else
								mpn_bc_mulmod_bnp1 (l_tp.item, l_ap1, l_bp1, l_n.item, l_tp.item)
							end
							l_cy___0.item := gmp_impl_inst.gmpn_add_nc (l_rp.item, l_rp.item, l_tp.item, l_n.item, l_tp.item[l_n.item])
							l_cy___0.item := l_cy___0.item + ((l_rp.item[0]).bit_and ({NATURAL_32} 1))
							gmp_inst.gmpn_rshift (l_rp.item, l_rp.item, l_n.item, {NATURAL_32} 1).do_nothing
							l_hi := (((l_cy___0.item).bit_shift_left (31))).bit_and ({NATURAL_32} 4_294_967_295)
							l_cy___0.item := (l_cy___0.item).bit_shift_right ((1))
							l_rp.item[(l_n.item - 1)] := (l_rp.item[(l_n.item - 1)]).bit_or (l_hi)
							from
							until
								js.loop_done
							loop
								asm229 (l___ptr_dummy___5, l_rp, l_cy___0)
								js.break
							end
							if (builtin_expect ((a_an + a_bn < a_rn).to_integer, 0)).to_boolean then
								l_cy___0.item := gmp_inst.gmpn_sub_n (l_rp.item + l_n.item, l_rp.item, l_tp.item, (a_an + a_bn) - l_n.item)
								l_cy___0.item := l_tp.item[l_n.item] + (gmp_impl_inst.gmpn_sub_nc (((l_tp.item + a_an) + a_bn) - l_n.item, (((l_rp.item + a_an) + a_bn) - l_n.item), (((l_tp.item + a_an) + a_bn) - l_n.item), a_rn - (a_an + a_bn), l_cy___0.item))
								l_cy___0.item := gmp_inst.gmpn_sub_1 (l_rp.item, l_rp.item, a_an + a_bn, l_cy___0.item)
							else
								l_cy___0.item := l_tp.item[l_n.item] + (gmp_inst.gmpn_sub_n (l_rp.item + l_n.item, l_rp.item, l_tp.item, l_n.item))
								from
								until
									js.loop_done
								loop
									asm230 (l___ptr_dummy___6, l_rp, l_cy___0)
									js.break
								end
							end
						else
							l_pos := -1 + 6 -- goto _L___0
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else: | _L___0:
						if (builtin_expect ((a_bn < a_rn).to_integer, 0)).to_boolean then
							if (builtin_expect ((a_an + a_bn <= a_rn).to_integer, 0)).to_boolean then
								mul_inst.gmpn_mul (l_rp.item, a_ap, a_an, a_bp, a_bn).do_nothing
							else
								mul_inst.gmpn_mul (l_tp.item, a_ap, a_an, a_bp, a_bn).do_nothing
								l_cy.item := gmp_inst.gmpn_add (l_rp.item, l_tp.item, a_rn, (l_tp.item + a_rn), (a_an + a_bn) - a_rn)
								from
								until
									js.loop_done
								loop
									asm231 (l___ptr_dummy, l_rp, l_cy)
									js.break
								end
							end
						else
							gmpn_bc_mulmod_bnm1 (l_rp.item, a_ap, a_bp, a_rn, l_tp.item)
						end
				when 7 then -- if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gmpn_mulmod_bnm1_next_size (a_n: INTEGER_32): INTEGER_32
		local
			l_nh: INTEGER_32
			js: JUMP_STATE
		do
			if 13 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
				if not (a_n >= 13) then
					Result := a_n
					js.return
				end
			else
				Result := a_n
				js.return
			end
			if not js.return_called then
				if 49 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_n >= 49) then
						Result := (((a_n + 1)).bit_and (-2))
						js.return
					end
				else
					Result := (((a_n + 1)).bit_and (-2))
					js.return
				end
			end
			if not js.return_called then
				if 97 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (a_n >= 97) then
						Result := (((a_n + 3)).bit_and (-4))
						js.return
					end
				else
					Result := (((a_n + 3)).bit_and (-4))
					js.return
				end
			end
			if not js.return_called then
				l_nh := ((a_n + 1)).bit_shift_right (1)
				if 565 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if not (l_nh >= 565) then
						Result := (((a_n + 7)).bit_and (-8))
						js.return
					end
				else
					Result := (((a_n + 7)).bit_and (-8))
					js.return
				end
			end
			if not js.return_called then
				Result := (2 * (mul_fft_inst.gmpn_fft_next_size (l_nh, (mul_fft_inst.gmpn_fft_best_k (l_nh, 0)))))
			end
		end

	mpn_bc_mulmod_bnp1 (a_rp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_bp: CE_POINTER [NATURAL_32]; a_rn: INTEGER_32; a_tp: CE_POINTER [NATURAL_32])
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_cy: CE_ARRAY [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_rp.make (<<1>>)
			create l_cy.make (<<1>>)
			create l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp
			mul_n_inst.gmpn_mul_n (a_tp, a_ap, a_bp, a_rn + 1)
			l_cy.item := a_tp[2 * a_rn] + (gmp_inst.gmpn_sub_n (l_rp.item, a_tp, (a_tp + a_rn), a_rn))
			l_rp.item[a_rn] := (0).to_natural_32
			from
			until
				js.loop_done
			loop
				asm223 (l___ptr_dummy, l_rp, l_cy)
				js.break
			end
		end

end
