class
	P_RAND

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_randinit (a_args: TUPLE [a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_alg: NATURAL_32])
		local
			l_ap: CE_VA_LIST
			l_pos: INTEGER_32
		do
			create l_ap.make_shared (default_pointer)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_ap := create {CE_VA_LIST}.make (a_args, 3)
					inspect a_args.a_alg.to_integer_32 -- switch 1 head
					when 0 then l_pos := -1 + 1
					else l_pos := -1 + 2
					end
				when 1 then -- switch 1, case 0
					if not (randlc2s_inst.gmp_randinit_lc_2exp_size (a_args.a_rstate, (l_ap.natural_32_item))).to_boolean then
						errno_inst.gmp_errno := (errno_inst.gmp_errno).bit_or ((8))
					end
					l_pos := -1 + 3 -- switch 1; break
				when 2 then -- switch 1, default:
					errno_inst.gmp_errno := (errno_inst.gmp_errno).bit_or ((1))
					l_pos := -1 + 3 -- switch 1; break
				when 3 then -- switch 1, done:
				when 4 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
