class
	P_REALLOC

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_realloc (a_m: CE_POINTER [PD_MPZ_STRUCT]; a_new_alloc: INTEGER_32): CE_POINTER [ANY]
		local
			l_new_alloc: INTEGER_32
			l_mp: CE_POINTER [NATURAL_32]
			l_tmp___2: INTEGER_32
		do
			create l_mp.make

			l_new_alloc := a_new_alloc
			if l_new_alloc > 1 then
				l_new_alloc := l_new_alloc
			else
				l_new_alloc := (1).to_integer_32
			end
			if {PLATFORM}.Integer_32_bytes.to_natural_32 = {PLATFORM}.Integer_32_bytes.to_natural_32 then
				if (builtin_expect ((l_new_alloc.to_natural_32 > {NATURAL_32} 134_217_727).to_integer, 0)).to_boolean then
					Io.error.put_string ("gmp: overflow in mpz type%N")
					abort
				end
			elseif (builtin_expect ((l_new_alloc > (-((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1)).to_integer_32).to_integer, 0)).to_boolean then
				Io.error.put_string ("gmp: overflow in mpz type%N")
				abort
			end
			l_mp := create {CE_POINTER [NATURAL_32]}.make_cast ((create {CE_POINTER [ANY]}.make_cast (memory_inst.gmp_reallocate_func.pointer_item ([create {CE_POINTER [ANY]}.make_cast (a_m.item.mp_d), (a_m.item.mp_alloc).to_natural_32 * {PLATFORM}.Natural_32_bytes.to_natural_32, (l_new_alloc.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32]))))
			a_m.item.mp_d := l_mp
			a_m.item.mp_alloc := l_new_alloc.to_integer_32
			if a_m.item.mp_size >= 0 then
				l_tmp___2 := a_m.item.mp_size
			else
				l_tmp___2 := -a_m.item.mp_size
			end
			if l_tmp___2.to_integer_32 > l_new_alloc then
				a_m.item.mp_size := 0
			end
			Result := (create {CE_POINTER [ANY]}.make_cast (l_mp))
		end

end
