class
	P_REDC_1_SEC

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_redc_1_sec (a_rp: CE_POINTER [NATURAL_32]; a_up: CE_POINTER [NATURAL_32]; a_mp: CE_POINTER [NATURAL_32]; a_n: INTEGER_32; a_invm: NATURAL_32)
		local
			l_up: CE_POINTER [NATURAL_32]
			l_j: INTEGER_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_up.make

			l_up := a_up
			l_j := a_n - 1
			from
			until
				not (not js.loop_done and then (l_j >= 0))
			loop
				l_cy := gmp_inst.gmpn_addmul_1 (l_up, a_mp, a_n, (l_up[0] * a_invm).bit_and ({NATURAL_32} 4_294_967_295))
				l_up[0] := l_cy
				l_up := l_up + 1
				l_j := l_j - 1
			end
			l_cy := gmp_inst.gmpn_add_n (a_rp, l_up, (l_up - a_n), a_n)
			subcnd_n_inst.gmpn_subcnd_n (a_rp, a_rp, a_mp, a_n, l_cy).do_nothing
		end

end
