class
	P_REMOVE

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_remove (a_wp: CE_POINTER [NATURAL_32]; a_wn: CE_POINTER [INTEGER_32]; a_up: CE_POINTER [NATURAL_32]; a_un: INTEGER_32; a_vp: CE_POINTER [NATURAL_32]; a_vn: INTEGER_32; a_cap: NATURAL_32): NATURAL_32
		local
			l_pwpsp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_pwpsn: CE_ARRAY [INTEGER_32]
			l_npowers: INTEGER_32
			l_tp: CE_POINTER [NATURAL_32]
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_pp: CE_POINTER [NATURAL_32]
			l_qp2: CE_POINTER [NATURAL_32]
			l_scratch_out: CE_POINTER [NATURAL_32]
			l_pn: INTEGER_32
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_i: INTEGER_32
			l_pwr: NATURAL_32
			l___tmp_marker: CE_ARRAY [CE_POINTER [PD_TMP_REENTRANT_T]]
			l_tmp___2: CE_POINTER [ANY]
			l_tmp___7: CE_POINTER [ANY]
			l_tmp___12: CE_POINTER [ANY]
			l_tmp___17: CE_POINTER [ANY]
			l_tmp___25: CE_POINTER [ANY]
			l___mp_ptr_swap__tmp: CE_POINTER [NATURAL_32]
			l___mp_ptr_swap__tmp___0: CE_POINTER [NATURAL_32]
			js: JUMP_STATE
			l_aaf: CE_ALLOCA_FACTORY
		do
			create l_pwpsp.make (<<32>>)
			create l_pwpsn.make (<<32>>)
			create l_tp.make
			create l_qp.make
			create l_np.make
			create l_pp.make
			create l_qp2.make
			create l_scratch_out.make
			create l___tmp_marker.make (<<1>>)
			create l_tmp___2.make
			create l_tmp___7.make
			create l_tmp___12.make
			create l_tmp___17.make
			create l_tmp___25.make
			create l___mp_ptr_swap__tmp.make
			create l___mp_ptr_swap__tmp___0.make

			l___tmp_marker.item := create {CE_POINTER [PD_TMP_REENTRANT_T]}.make_shared (default_pointer)
			if (builtin_expect ((((a_un + a_vn) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___2 := (l_aaf.new ((((a_un + a_vn) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___2 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (((a_un + a_vn) // 2).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_tp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___2)
			if (builtin_expect ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___7 := (l_aaf.new ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___7 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___7)
			if (builtin_expect ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___12 := (l_aaf.new ((a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___12 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, (a_un.to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_qp2 := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___12)
			if (builtin_expect (((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___17 := (l_aaf.new (((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___17 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((a_un + 32).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_np := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___17)
			l_pp := a_vp
			l_pn := a_vn
			if (builtin_expect (((bdiv_qr_inst.gmpn_bdiv_qr_itch (a_un, (a_un).bit_shift_right (1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32 < {NATURAL_32} 65_536).to_integer, 1)).to_boolean then
				l_tmp___25 := (l_aaf.new (((bdiv_qr_inst.gmpn_bdiv_qr_itch (a_un, (a_un).bit_shift_right (1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			else
				l_tmp___25 := (tal_reent_inst.gmp_tmp_reentrant_alloc (l___tmp_marker, ((bdiv_qr_inst.gmpn_bdiv_qr_itch (a_un, (a_un).bit_shift_right (1))).to_natural_32 * ({PLATFORM}.Natural_32_bytes.to_natural_32).to_natural_32).to_natural_32))
			end
			l_scratch_out := create {CE_POINTER [NATURAL_32]}.make_cast (l_tmp___25)
			from
			until
				js.loop_done
			loop
				from
				until
					js.loop_done
				loop
					gmp_inst.gmpn_copyi (l_qp, a_up, a_un)
					js.break
				end
				js.break
			end
			l_qn := a_un
			l_npowers := (0).to_integer_32
			from
			until
				not (not js.loop_done and then (l_qn >= l_pn))
			loop
				bdiv_qr_inst.gmpn_bdiv_qr (l_qp2, l_tp, l_qp, l_qn, l_pp, l_pn, l_scratch_out).do_nothing
				if not (gmp_impl_inst.mpn_zero_p (l_tp, l_pn)).to_boolean then
					js.break
				end
				if not js.loop_jumped then
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp := l_qp
						l_qp := l_qp2
						l_qp2 := l___mp_ptr_swap__tmp
						js.break
					end
					l_qn := l_qn - l_pn
					l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
					l_pwpsp[l_npowers] := l_pp
					l_pwpsn[l_npowers] := l_pn
					l_npowers := l_npowers + 1
					if (({NATURAL_32} 2).bit_shift_left (l_npowers)) - {NATURAL_32} 1 > a_cap then
						js.break
					end
				end
				if not js.loop_jumped then
					l_nn := 2 * l_pn - 1
					if l_nn > l_qn then
						js.break
					end
				end
				if not js.loop_jumped then
					sqr_inst.gmpn_sqr (l_np, l_pp, l_pn)
					l_nn := l_nn + (l_np[l_nn] /= {NATURAL_32} 0).to_integer
					l_pp := l_np
					l_pn := l_nn
					l_np := l_np + l_nn
				end
			end
			l_pwr := (({NATURAL_32} 1).bit_shift_left (l_npowers)) - {NATURAL_32} 1
			l_i := l_npowers - 1
			from
			until
				not (not js.loop_done and then (l_i >= 0))
			loop
				l_pp := l_pwpsp[l_i]
				l_pn := l_pwpsn[l_i]
				if l_qn < l_pn then
					js.continue
				end
				if not js.loop_jumped and then (l_pwr + (({NATURAL_32} 1).bit_shift_left (l_i)) > a_cap) then
					js.continue
				end
				if not js.loop_jumped then
					bdiv_qr_inst.gmpn_bdiv_qr (l_qp2, l_tp, l_qp, l_qn, l_pp, l_pn, l_scratch_out).do_nothing
					if not (gmp_impl_inst.mpn_zero_p (l_tp, l_pn)).to_boolean then
						js.continue
					end
				end
				if not js.loop_jumped then
					from
					until
						js.loop_done
					loop
						l___mp_ptr_swap__tmp___0 := l_qp
						l_qp := l_qp2
						l_qp2 := l___mp_ptr_swap__tmp___0
						js.break
					end
					l_qn := l_qn - l_pn
					l_qn := l_qn + (l_qp[l_qn] /= {NATURAL_32} 0).to_integer
					l_pwr := l_pwr + (({NATURAL_32} 1).bit_shift_left (l_i))
				end
				if js.loop_increment then
					l_i := l_i - 1
				end
			end
			from
			until
				js.loop_done
			loop
				from
				until
					js.loop_done
				loop
					gmp_inst.gmpn_copyi (a_wp, l_qp, l_qn)
					js.break
				end
				js.break
			end
			a_wn.item := l_qn
			from
			until
				js.loop_done
			loop
				if (builtin_expect ((not (l___tmp_marker.item).is_void).to_integer, 0)).to_boolean then
					tal_reent_inst.gmp_tmp_reentrant_free (l___tmp_marker.item)
				end
				js.break
			end
			Result := l_pwr
		end

	gmpz_remove (a_dest: CE_POINTER [PD_MPZ_STRUCT]; a_src: CE_POINTER [PD_MPZ_STRUCT]; a_f: CE_POINTER [PD_MPZ_STRUCT]): NATURAL_32
		local
			l_fpow: CE_ARRAY [CE_ARRAY [PD_MPZ_STRUCT]]
			l_x___2: CE_ARRAY [PD_MPZ_STRUCT]
			l_rem: CE_ARRAY [PD_MPZ_STRUCT]
			l_pwr: NATURAL_32
			l_p: INTEGER_32
			l_s0: NATURAL_32
			js: JUMP_STATE
		do
			create l_fpow.make (<<32, 1>>)
			create l_x___2.make (<<1>>)
			create l_rem.make (<<1>>)

			if (cmp_ui_inst.gmpz_cmp_ui (a_f, {NATURAL_32} 1)) <= 0 then
				errno_inst.gmp_divide_by_zero
			end
			if a_src.item.mp_size = 0 then
				if not a_src.is_equal (a_dest) then
					set_inst.gmpz_set (a_dest, a_src)
				end
				Result := {NATURAL_32} 0
				js.return
			end
			if not js.return_called then
				if (cmp_ui_inst.gmpz_cmp_ui (a_f, {NATURAL_32} 2)) = 0 then
					l_s0 := scan1_inst.gmpz_scan1 (a_src, (0).to_natural_32)
					cfdiv_q_2exp_inst.gmpz_fdiv_q_2exp (a_dest, a_src, l_s0)
					Result := l_s0
					js.return
				end
			end
			if not js.return_called then
				init_inst.gmpz_init (l_rem)
				init_inst.gmpz_init (l_x___2)
				l_pwr := (0).to_natural_32
				init_inst.gmpz_init (l_fpow[0])
				set_inst.gmpz_set (l_fpow[0], a_f)
				set_inst.gmpz_set (a_dest, a_src)
				l_p := 0
				from
				until
					js.loop_done
				loop
					tdiv_qr_inst.gmpz_tdiv_qr (l_x___2, l_rem, a_dest, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
					if l_rem[0].mp_size /= 0 then
						js.break
					end
					if not js.loop_jumped then
						init_inst.gmpz_init (l_fpow[l_p + 1])
						mul_inst.gmpz_mul (l_fpow[l_p + 1], create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])), create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
						set_inst.gmpz_set (a_dest, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2))
						l_p := l_p + 1
					end
				end
				l_pwr := (((1).bit_shift_left (l_p)) - 1).to_natural_32
				clear_inst.gmpz_clear (l_fpow[l_p])
				from
				until
					js.loop_done
				loop
					l_p := l_p - 1
					if not (l_p >= 0) then
						js.break
					end
					if not js.loop_jumped then
						tdiv_qr_inst.gmpz_tdiv_qr (l_x___2, l_rem, a_dest, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast ((l_fpow[l_p])))
						if l_rem[0].mp_size = 0 then
							l_pwr := l_pwr + ((1).bit_shift_left (l_p)).to_natural_32
							set_inst.gmpz_set (a_dest, create {CE_POINTER [PD_MPZ_STRUCT]}.make_cast (l_x___2))
						end
						clear_inst.gmpz_clear (l_fpow[l_p])
					end
				end
				clear_inst.gmpz_clear (l_x___2)
				clear_inst.gmpz_clear (l_rem)
				Result := l_pwr
			end
		end

end
