class
	P_RRANDOMB

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_rrandomb (a_rp: CE_POINTER [NATURAL_32]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_rp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_bi: CE_ARRAY [NATURAL_32]
			l_ranm: CE_ARRAY [NATURAL_32]
			l_cap_chunksize: NATURAL_32
			l_chunksize: NATURAL_32
			l_i: INTEGER_32
			l___rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___rstate___0: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___rstate___1: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_rp.make (<<1>>)
			create l_bi.make (<<1>>)
			create l_ranm.make (<<1>>)
			create l___rstate.make
			create l___rstate___0.make
			create l___rstate___1.make
			create l___ptr_dummy.make (<<1>>)

			l_rp.item := a_rp
			l_i := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32 - {NATURAL_32} 1).to_integer_32
			l_rp.item[l_i] := ({NATURAL_32} 4_294_967_295).bit_shift_right ((({NATURAL_32} 32 - a_nbits \\ {NATURAL_32} 32) \\ {NATURAL_32} 32).to_integer_32)
			l_i := l_i - 1
			from
			until
				not (l_i >= 0)
			loop
				l_rp.item[l_i] := {NATURAL_32} 4_294_967_295
				l_i := l_i - 1
			end
			from
			until
				js.loop_done
			loop
				l___rstate := a_rstate;
				((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate, l_ranm, {NATURAL_32} 32])
				js.break
			end
			l_cap_chunksize := (a_nbits // (l_ranm.item \\ {NATURAL_32} 4 + {NATURAL_32} 1)).to_natural_32
			l_cap_chunksize := l_cap_chunksize + (l_cap_chunksize = {NATURAL_32} 0).to_integer.to_natural_32
			l_bi.item := a_nbits
			from
			until
				js.loop_done
			loop
				from
				until
					js.loop_done
				loop
					l___rstate___0 := a_rstate;
					((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate___0.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate___0, l_ranm, {NATURAL_32} 32])
					js.break
				end
				l_chunksize := ({NATURAL_32} 1 + l_ranm.item \\ l_cap_chunksize.to_natural_32).to_natural_32
				if l_bi.item < l_chunksize.to_natural_32 then
					l_bi.item := (0).to_natural_32
				else
					l_bi.item := l_bi.item - l_chunksize.to_natural_32
				end
				if l_bi.item = {NATURAL_32} 0 then
					js.break
				end
				if not js.loop_jumped then
					l_rp.item[(l_bi.item // {NATURAL_32} 32).to_integer_32] := (l_rp.item[(l_bi.item // {NATURAL_32} 32).to_integer_32]).bit_xor ((({NATURAL_32} 1).bit_shift_left ((l_bi.item \\ {NATURAL_32} 32).to_integer_32)))
					from
					until
						js.loop_done
					loop
						l___rstate___1 := a_rstate;
						((create {CE_POINTER [PD_GMP_RANDFNPTR_T]}.make_cast (l___rstate___1.item.mp_algdata.mp_lc)).item.randget_fn).call ([l___rstate___1, l_ranm, {NATURAL_32} 32])
						js.break
					end
					l_chunksize := ({NATURAL_32} 1 + l_ranm.item \\ l_cap_chunksize.to_natural_32).to_natural_32
					if l_bi.item < l_chunksize.to_natural_32 then
						l_bi.item := (0).to_natural_32
					else
						l_bi.item := l_bi.item - l_chunksize.to_natural_32
					end
					from
					until
						js.loop_done
					loop
						asm25 (l___ptr_dummy, l_rp, l_bi)
						js.break
					end
					if l_bi.item = {NATURAL_32} 0 then
						js.break
					end
				end
			end
		end

	gmpz_rrandomb (a_x___2: CE_POINTER [PD_MPZ_STRUCT]; a_rstate: CE_POINTER [PD_GMP_RANDSTATE_STRUCT]; a_nbits: NATURAL_32)
		local
			l_nl: INTEGER_32
		do
			l_nl := (((a_nbits + {NATURAL_32} 32) - {NATURAL_32} 1) // {NATURAL_32} 32).to_integer_32
			if a_nbits /= {NATURAL_32} 0 then
				if (builtin_expect ((l_nl > (a_x___2.item.mp_alloc).to_integer_32).to_integer, 0)).to_boolean then
					realloc_inst.gmpz_realloc (a_x___2, l_nl).do_nothing
				end
				gmp_rrandomb (a_x___2.item.mp_d, a_rstate, a_nbits)
			end
			a_x___2.item.mp_size := l_nl.to_integer_32
		end

end
