class
	P_SBPI1_BDIV_QR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_sbpi1_bdiv_qr (a_qp: CE_POINTER [NATURAL_32]; a_np: CE_POINTER [NATURAL_32]; a_nn: INTEGER_32; a_dp: CE_POINTER [NATURAL_32]; a_dn: INTEGER_32; a_dinv: NATURAL_32): NATURAL_32
		local
			l_qp: CE_POINTER [NATURAL_32]
			l_np: CE_POINTER [NATURAL_32]
			l_nn: INTEGER_32
			l_qn: INTEGER_32
			l_i: INTEGER_32
			l_rh: NATURAL_32
			l_ql: NATURAL_32
			l_q: NATURAL_32
			l_q___0: NATURAL_32
			l_cy: NATURAL_32
			js: JUMP_STATE
		do
			create l_qp.make
			create l_np.make

			l_qp := a_qp
			l_np := a_np
			l_nn := a_nn
			l_qn := l_nn - a_dn
			l_rh := (0).to_natural_32
			l_ql := (1).to_natural_32
			from
			until
				not (not js.loop_done and then (l_qn > a_dn))
			loop
				l_i := (0).to_integer_32
				from
				until
					not (l_i < a_dn)
				loop
					l_q := a_dinv * l_np[l_i]
					l_qp[l_i] := (l_q).bit_not
					l_np[l_i] := gmp_inst.gmpn_addmul_1 (l_np + l_i, a_dp, a_dn, l_q)
					l_i := l_i + 1
				end
				l_rh := l_rh + (gmp_inst.gmpn_add (l_np + a_dn, (l_np + a_dn), l_qn, l_np, a_dn))
				l_ql := gmp_inst.gmpn_add_1 (l_qp, l_qp, a_dn, l_ql)
				l_qp := l_qp + a_dn
				l_qn := l_qn - a_dn
				l_np := l_np + a_dn
				l_nn := l_nn - a_dn
			end
			l_i := (0).to_integer_32
			from
			until
				not (l_i < l_qn)
			loop
				l_q___0 := a_dinv * l_np[l_i]
				l_qp[l_i] := (l_q___0).bit_not
				l_np[l_i] := gmp_inst.gmpn_addmul_1 (l_np + l_i, a_dp, a_dn, l_q___0)
				l_i := l_i + 1
			end
			l_rh := l_rh + (gmp_inst.gmpn_add_n (l_np + a_dn, (l_np + a_dn), l_np, l_qn))
			l_ql := gmp_inst.gmpn_add_1 (l_qp, l_qp, l_qn, l_ql)
			if (builtin_expect ((l_ql > {NATURAL_32} 0).to_integer, 0)).to_boolean then
				Result := (0).to_natural_32
			else
				l_cy := gmp_inst.gmpn_sub_n (l_np + l_qn, (l_np + l_qn), a_dp, a_dn)
				Result := (l_cy - l_rh)
			end
		end

end
