class
	P_SNPRINTF

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmp_snprintf (a_args: TUPLE [a_buf: CE_POINTER [INTEGER_8]; a_size: NATURAL_32; a_fmt: CE_POINTER [INTEGER_8]]): INTEGER_32
		local
			l_d: CE_ARRAY [PD_GMP_SNPRINTF_T]
			l_ap: CE_VA_LIST
			l_ret: INTEGER_32
		do
			create l_d.make (<<1>>)
			create l_ap.make_shared (default_pointer)

			l_ap := create {CE_VA_LIST}.make (a_args, 4)
			l_d.item.buf := a_args.a_buf
			l_d.item.size := a_args.a_size
			l_ret := doprnt_inst.gmp_doprnt (snprntffuns_inst.gmp_snprintf_funs, create {CE_POINTER [ANY]}.make_cast (l_d), a_args.a_fmt, l_ap.twin)
			Result := l_ret
		end

end
