class
	P_TOOM2_SQR

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpn_toom2_sqr (a_pp: CE_POINTER [NATURAL_32]; a_ap: CE_POINTER [NATURAL_32]; a_an: INTEGER_32; a_scratch: CE_POINTER [NATURAL_32])
		local
			l_pp: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l_n: CE_ARRAY [INTEGER_32]
			l_s: INTEGER_32
			l_cy: CE_ARRAY [NATURAL_32]
			l_cy2: CE_ARRAY [NATURAL_32]
			l_asm1: CE_POINTER [NATURAL_32]
			l___dst: CE_POINTER [NATURAL_32]
			l___n: INTEGER_32
			l_tmp___0: CE_POINTER [NATURAL_32]
			l___ptr_dummy: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___0: CE_ARRAY [CE_POINTER [NATURAL_32]]
			l___ptr_dummy___1: CE_ARRAY [CE_POINTER [NATURAL_32]]
			js: JUMP_STATE
		do
			create l_pp.make (<<1>>)
			create l_n.make (<<1>>)
			create l_cy.make (<<1>>)
			create l_cy2.make (<<1>>)
			create l_asm1.make
			create l___dst.make
			create l_tmp___0.make
			create l___ptr_dummy.make (<<1>>)
			create l___ptr_dummy___0.make (<<1>>)
			create l___ptr_dummy___1.make (<<1>>)

			l_pp.item := a_pp
			l_s := (a_an).bit_shift_right (1)
			l_n.item := a_an - l_s
			l_asm1 := l_pp.item
			if l_s = l_n.item then
				if (gmp_inst.gmpn_cmp (a_ap, a_ap + l_n.item, l_n.item)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n.item, a_ap, l_n.item).do_nothing
				else
					gmp_inst.gmpn_sub_n (l_asm1, a_ap, a_ap + l_n.item, l_n.item).do_nothing
				end
			elseif (gmp_impl_inst.mpn_zero_p (a_ap + l_s, l_n.item - l_s)).to_boolean then
				if (gmp_inst.gmpn_cmp (a_ap, a_ap + l_n.item, l_s)) < 0 then
					gmp_inst.gmpn_sub_n (l_asm1, a_ap + l_n.item, a_ap, l_s).do_nothing
					from
					until
						js.loop_done
					loop
						if l_n.item - l_s /= 0 then
							l___dst := l_asm1 + l_s
							l___n := l_n.item - l_s
							from
							until
								js.loop_done
							loop
								l_tmp___0 := l___dst
								l___dst := l___dst + 1
								l_tmp___0.item := (0).to_natural_32
								l___n := l___n - 1
								if not l___n.to_boolean then
									js.break
								end
							end
						end
						js.break
					end
				else
					gmp_inst.gmpn_sub (l_asm1, a_ap, l_n.item, a_ap + l_n.item, l_s).do_nothing
				end
			else
				gmp_inst.gmpn_sub (l_asm1, a_ap, l_n.item, a_ap + l_n.item, l_s).do_nothing
			end
			from
			until
				js.loop_done
			loop
				if 30 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 30 then
						gmpn_toom2_sqr (a_scratch, l_asm1, l_n.item, a_scratch + 2 * l_n.item)
					else
						gmp_impl_inst.gmpn_sqr_basecase (a_scratch, l_asm1, l_n.item)
					end
				else
					gmp_impl_inst.gmpn_sqr_basecase (a_scratch, l_asm1, l_n.item)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 30 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_s >= 30 then
						gmpn_toom2_sqr (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s, a_scratch + 2 * l_n.item)
					else
						gmp_impl_inst.gmpn_sqr_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s)
					end
				else
					gmp_impl_inst.gmpn_sqr_basecase (l_pp.item + 2 * l_n.item, a_ap + l_n.item, l_s)
				end
				js.break
			end
			from
			until
				js.loop_done
			loop
				if 30 /= -((({NATURAL_32} 4_294_967_295).bit_xor ((({NATURAL_32} 4_294_967_295).bit_shift_right (1)))).to_integer_32 + 1) then
					if l_n.item >= 30 then
						gmpn_toom2_sqr (l_pp.item, a_ap, l_n.item, a_scratch + 2 * l_n.item)
					else
						gmp_impl_inst.gmpn_sqr_basecase (l_pp.item, a_ap, l_n.item)
					end
				else
					gmp_impl_inst.gmpn_sqr_basecase (l_pp.item, a_ap, l_n.item)
				end
				js.break
			end
			l_cy.item := gmp_inst.gmpn_add_n (l_pp.item + 2 * l_n.item, (l_pp.item + l_n.item), (l_pp.item + 2 * l_n.item), l_n.item)
			l_cy2.item := l_cy.item + (gmp_inst.gmpn_add_n (l_pp.item + l_n.item, (l_pp.item + 2 * l_n.item), l_pp.item, l_n.item))
			l_cy.item := l_cy.item + (gmp_inst.gmpn_add (l_pp.item + 2 * l_n.item, (l_pp.item + 2 * l_n.item), l_n.item, ((l_pp.item + 2 * l_n.item) + l_n.item), (l_s + l_s) - l_n.item))
			l_cy.item := l_cy.item - (gmp_inst.gmpn_sub_n (l_pp.item + l_n.item, (l_pp.item + l_n.item), a_scratch, 2 * l_n.item))
			from
			until
				js.loop_done
			loop
				asm140 (l___ptr_dummy, l_pp, l_n, l_cy2)
				js.break
			end
			if (builtin_expect ((l_cy.item <= {NATURAL_32} 2).to_integer, 1)).to_boolean then
				from
				until
					js.loop_done
				loop
					asm141 (l___ptr_dummy___0, l_pp, l_n, l_cy)
					js.break
				end
			else
				from
				until
					js.loop_done
				loop
					asm142 (l___ptr_dummy___1, l_pp, l_n)
					js.break
				end
			end
		end

end
