class
	P_UI_POW_UI

inherit
	LIBGMP_DATA
	S_GCC_BUILTIN
	S_STDIO
	S_STDLIB
	S_SIGNAL
	S_STRING
	S_CTYPE
	S_LANGINFO
	S_LIBIO
	S_OBSTACK

feature {ANY} -- routines

	gmpz_ui_pow_ui (a_r: CE_POINTER [PD_MPZ_STRUCT]; a_b: NATURAL_32; a_e: NATURAL_32)
		local
			l_b: CE_ARRAY [NATURAL_32]
		do
			create l_b.make (<<1>>)

			l_b.item := a_b
			n_pow_ui_inst.gmpz_n_pow_ui (a_r, l_b, (l_b.item /= {NATURAL_32} 0).to_integer, a_e)
		end

end
