class
	P_EXPONENTIALINV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_cdf_exponential_Pinv (a_P___2: REAL_64; a_mu: REAL_64): REAL_64
		local
			l_x: REAL_64
		do
			l_x := -a_mu * (log1p (-a_P___2))
			Result := l_x
		end

	gsl_cdf_exponential_Qinv (a_Q___1: REAL_64; a_mu: REAL_64): REAL_64
		local
			l_x: REAL_64
		do
			l_x := -a_mu * (log (a_Q___1))
			Result := l_x
		end

end
