class
	P_FILE_SOURCE

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_matrix_char_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_char_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_char_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_char_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_char_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_char_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_char_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_char_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_char_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_char_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_CHAR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_char_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_char_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_complex_float_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_complex_float_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_complex_float_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_complex_float_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_complex_float_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_complex_float_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_complex_float_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_complex_float_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_complex_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_complex_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_complex_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_complex_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_complex_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_complex_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_complex_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_complex_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_complex_long_double_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_complex_long_double_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_complex_long_double_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_complex_long_double_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_complex_long_double_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_complex_long_double_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_complex_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_complex_long_double_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_complex_long_double_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_float_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_float_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_float_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_float_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_float_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_float_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_float_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_float_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_float_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_int_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_int_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_int_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_int_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_int_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_int_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_int_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_int_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_int_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_int_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_INT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_int_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_int_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_long_double_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_long_double_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_long_double_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_long_double_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_long_double_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_long_double_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_long_double_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_long_double_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_long_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_long_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_long_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_long_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_long_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_long_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_long_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_LONG]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_long_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_long_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_short_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_short_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_short_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_short_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_short_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_short_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_short_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_short_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_short_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_short_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_SHORT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_short_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_short_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uchar_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_uchar_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_uchar_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uchar_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_uchar_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_uchar_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uchar_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_uchar_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_uchar_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uchar_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UCHAR]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_uchar_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_uchar_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uint_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_uint_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_uint_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uint_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_uint_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_uint_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uint_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_uint_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_uint_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_uint_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_UINT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_uint_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_uint_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ulong_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_ulong_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_ulong_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ulong_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_ulong_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_ulong_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ulong_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_ulong_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_ulong_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ulong_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_ULONG]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_ulong_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_ulong_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ushort_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_ushort_raw_fprintf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32, a_format)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_ushort_raw_fprintf (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32, a_format)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ushort_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_ushort_raw_fread (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_ushort_raw_fread (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ushort_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fprintf_source_inst.gsl_block_ushort_raw_fscanf (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fprintf_source_inst.gsl_block_ushort_raw_fscanf (a_stream, a_m___4.item.data + (l_i * l_tda).to_integer_32, l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_matrix_ushort_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_m___4: CE_POINTER [PD_GSL_MATRIX_USHORT]): INTEGER_32
		local
			l_status: INTEGER_32
			l_size1: NATURAL_32
			l_size2: NATURAL_32
			l_tda: NATURAL_32
			l_i: NATURAL_32
			js: JUMP_STATE
		do
			l_status := 0
			l_size1 := a_m___4.item.size1
			l_size2 := a_m___4.item.size2
			l_tda := a_m___4.item.tda
			if l_tda = l_size2 then
				l_status := fwrite_source_inst.gsl_block_ushort_raw_fwrite (a_stream, a_m___4.item.data, l_size1 * l_size2, (1).to_natural_32)
			else
				l_i := (0).to_natural_32
				from
				until
					not (not js.loop_done and then (l_i < l_size1))
				loop
					l_status := fwrite_source_inst.gsl_block_ushort_raw_fwrite (a_stream, (a_m___4.item.data + (l_i * l_tda).to_integer_32), l_size2, (1).to_natural_32)
					if l_status.to_boolean then
						js.break
					end
					if not js.loop_jumped then
						l_i := l_i + 1
					end
				end
			end
			Result := l_status
		end

	gsl_vector_char_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_char_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_char_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_char_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_char_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_char_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_char_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_char_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_complex_float_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_complex_float_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_complex_float_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_complex_float_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_complex_float_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_complex_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_complex_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_complex_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_complex_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_complex_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_complex_long_double_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_complex_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_complex_long_double_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_complex_long_double_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_complex_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_COMPLEX_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_complex_long_double_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_float_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_float_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_float_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_float_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_float_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_float_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_float_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_FLOAT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_float_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_int_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_INT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_int_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_int_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_int_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_int_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_int_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_int_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_INT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_int_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_long_double_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_long_double_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_long_double_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_long_double_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_long_double_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_long_double_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_long_double_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG_DOUBLE]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_long_double_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_long_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_long_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_long_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_long_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_long_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_long_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_long_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_LONG]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_long_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_short_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_short_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_short_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_short_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_short_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_short_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_short_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_SHORT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_short_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_uchar_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_uchar_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_uchar_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_uchar_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_uchar_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_uchar_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_uchar_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UCHAR]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_uchar_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_uint_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_uint_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_uint_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_uint_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_uint_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_uint_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_uint_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_UINT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_uint_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_ulong_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_ulong_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_ulong_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_ulong_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_ulong_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_ulong_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_ulong_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_ULONG]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_ulong_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_ushort_fprintf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]; a_format: CE_POINTER [INTEGER_8]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_ushort_raw_fprintf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride, a_format))
			Result := l_status
		end

	gsl_vector_ushort_fread (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_ushort_raw_fread (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_ushort_fscanf (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fprintf_source_inst.gsl_block_ushort_raw_fscanf (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

	gsl_vector_ushort_fwrite (a_stream: CE_POINTER [SD_IO_FILE]; a_v: CE_POINTER [PD_GSL_VECTOR_USHORT]): INTEGER_32
		local
			l_status: INTEGER_32
		do
			l_status := (fwrite_source_inst.gsl_block_ushort_raw_fwrite (a_stream, a_v.item.data, a_v.item.size, a_v.item.stride))
			Result := l_status
		end

end
