class
	P_FP_GNUX86

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_ieee_set_mode (a_precision: INTEGER_32; a_rounding: INTEGER_32; a_exception_mask: INTEGER_32): INTEGER_32
		local
			l_mode: CE_ARRAY [NATURAL_16]
			l_mode_sse: CE_ARRAY [NATURAL_32]
			l_pos: INTEGER_32
		do
			create l_mode.make (<<1>>)
			create l_mode_sse.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_mode.item := (0).to_natural_16
					inspect a_precision -- switch 1 head
					when 1 then l_pos := -1 + 1
					when 2 then l_pos := -1 + 2
					when 3 then l_pos := -1 + 3
					else l_pos := -1 + 4
					end
				when 1 then -- switch 1, case 1
					l_mode.item := ((l_mode.item).to_integer_32).to_natural_16
					l_pos := -1 + 5 -- switch 1; break
				when 2 then -- switch 1, case 2
					l_mode.item := (((l_mode.item).to_integer_32).bit_or (512)).to_natural_16
					l_pos := -1 + 5 -- switch 1; break
				when 3 then -- switch 1, case 3
					l_mode.item := (((l_mode.item).to_integer_32).bit_or (768)).to_natural_16
					l_pos := -1 + 5 -- switch 1; break
				when 4 then -- switch 1, default:
					l_mode.item := (((l_mode.item).to_integer_32).bit_or (768)).to_natural_16
				when 5 then -- switch 1, done:
					inspect a_rounding -- switch 2 head
					when 1 then l_pos := -1 + 6
					when 2 then l_pos := -1 + 7
					when 3 then l_pos := -1 + 8
					when 4 then l_pos := -1 + 9
					else l_pos := -1 + 10
					end
				when 6 then -- switch 2, case 1
					l_mode.item := ((l_mode.item).to_integer_32).to_natural_16
					l_pos := -1 + 11 -- switch 2; break
				when 7 then -- switch 2, case 2
					l_mode.item := (((l_mode.item).to_integer_32).bit_or (1_024)).to_natural_16
					l_pos := -1 + 11 -- switch 2; break
				when 8 then -- switch 2, case 3
					l_mode.item := (((l_mode.item).to_integer_32).bit_or (2_048)).to_natural_16
					l_pos := -1 + 11 -- switch 2; break
				when 9 then -- switch 2, case 4
					l_mode.item := (((l_mode.item).to_integer_32).bit_or (3_072)).to_natural_16
					l_pos := -1 + 11 -- switch 2; break
				when 10 then -- switch 2, default:
					l_mode.item := ((l_mode.item).to_integer_32).to_natural_16
				when 11 then -- switch 2, done:
					if ((a_exception_mask).bit_and (1)).to_boolean then
						l_mode.item := (((l_mode.item).to_integer_32).bit_or (1)).to_natural_16
					end
					if ((a_exception_mask).bit_and (2)).to_boolean then
						l_mode.item := (((l_mode.item).to_integer_32).bit_or (2)).to_natural_16
					end
					if ((a_exception_mask).bit_and (4)).to_boolean then
						l_mode.item := (((l_mode.item).to_integer_32).bit_or (4)).to_natural_16
					end
					if ((a_exception_mask).bit_and (8)).to_boolean then
						l_mode.item := (((l_mode.item).to_integer_32).bit_or (8)).to_natural_16
					end
					if ((a_exception_mask).bit_and (16)).to_boolean then
						l_mode.item := (((l_mode.item).to_integer_32).bit_or (16)).to_natural_16
					end
					if ((a_exception_mask).bit_and (32)).to_boolean then
						l_mode.item := (((l_mode.item).to_integer_32).bit_and (-33)).to_natural_16
					else
						l_mode.item := (((l_mode.item).to_integer_32).bit_or (32)).to_natural_16
					end
					asm1 (l_mode)
					l_mode_sse.item := {NATURAL_32} 0
					l_mode_sse.item := (l_mode_sse.item).bit_or ((((((l_mode.item).to_integer_32).bit_and (63))).bit_shift_left (7)).to_natural_32)
					l_mode_sse.item := (l_mode_sse.item).bit_or ((((((l_mode.item).to_integer_32).bit_and (3_072))).bit_shift_left (3)).to_natural_32)
					asm2 (l_mode_sse)
					Result := 0
				when 12 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
