class
	P_GSL_GSL_VECTOR_CHAR

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	gsl_vector_char_const_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_i: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (a_v.item.data + (a_i * a_v.item.stride).to_integer_32)
		end

	gsl_vector_char_get (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_i: NATURAL_32): INTEGER_8
		do
			Result := (a_v.item.data[(a_i * a_v.item.stride).to_integer_32])
		end

	gsl_vector_char_ptr (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_i: NATURAL_32): CE_POINTER [INTEGER_8]
		do
			Result := (a_v.item.data + (a_i * a_v.item.stride).to_integer_32)
		end

	gsl_vector_char_set (a_v: CE_POINTER [PD_GSL_VECTOR_CHAR]; a_i: NATURAL_32; a_x: INTEGER_8)
		do
			a_v.item.data[(a_i * a_v.item.stride).to_integer_32] := a_x
		end

end
