class
	P_LEGENDRE_CON

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	conicalP_0_V (a_t: REAL_64; a_f: REAL_64; a_tau: REAL_64; a_sgn: REAL_64; a_V0: CE_POINTER [REAL_64]; a_V1: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_C: CE_ARRAY [REAL_64]
			l_T: CE_ARRAY [REAL_64]
			l_H: CE_ARRAY [REAL_64]
			l_V: CE_ARRAY [REAL_64]
			l_i: INTEGER_32
		do
			create l_C.make (<<8>>)
			create l_T.make (<<8>>)
			create l_H.make (<<8>>)
			create l_V.make (<<12>>)

			l_T[0] := 1.0
			l_H[0] := 1.0
			l_V[0] := 1.0
			l_i := 1
			from
			until
				not (l_i <= 7)
			loop
				l_T[l_i] := l_T[l_i - 1] * a_t
				l_H[l_i] := l_H[l_i - 1] * (a_t * a_f)
				l_i := l_i + 1
			end
			l_i := 1
			from
			until
				not (l_i <= 11)
			loop
				l_V[l_i] := l_V[l_i - 1] * a_tau
				l_i := l_i + 1
			end
			l_C[0] := 1.0
			l_C[1] := (l_H[1] - 1.0) / (8.0 * l_T[1])
			l_C[2] := (((9.0 * l_H[2] + 6.0 * l_H[1]) - 15.0) - (a_sgn * 8.0) * l_T[2]) / (128.0 * l_T[2])
			l_C[3] := (5.0 * ((((15.0 * l_H[3] + 27.0 * l_H[2]) + 21.0 * l_H[1]) - 63.0) - (a_sgn * l_T[2]) * (16.0 * l_H[1] + 24.0))) / (1024.0 * l_T[3])
			l_C[4] := (7.0 * ((((((525.0 * l_H[4] + 1500.0 * l_H[3]) + 2430.0 * l_H[2]) + 1980.0 * l_H[1]) - 6435.0) + 192.0 * l_T[4]) - (a_sgn * l_T[2]) * ((720.0 * l_H[2] + 1600.0 * l_H[1]) + 2160.0))) / (32768.0 * l_T[4])
			l_C[5] := (21.0 * (((((((2835.0 * l_H[5] + 11025.0 * l_H[4]) + 24750.0 * l_H[3]) + 38610.0 * l_H[2]) + 32175.0 * l_H[1]) - 109395.0) + l_T[4] * (1984.0 * l_H[1] + 4032.0)) - (a_sgn * l_T[2]) * (((4800.0 * l_H[3] + 15120.0 * l_H[2]) + 26400.0 * l_H[1]) + 34320.0))) / (262144.0 * l_T[5])
			l_C[6] := (11.0 * ((((((((218295.0 * l_H[6] + 1071630.0 * l_H[5]) + 3009825.0 * l_H[4]) + 6142500.0 * l_H[3]) + 9398025.0 * l_H[2]) + 7936110.0 * l_H[1]) - 27776385.0) + l_T[4] * ((254016.0 * l_H[2] + 749952.0 * l_H[1]) + 1100736.0)) - (a_sgn * l_T[2]) * (((((441000.0 * l_H[4] + 1814400.0 * l_H[3]) + 4127760.0 * l_H[2]) + 6552000.0 * l_H[1]) + 8353800.0) + 31232.0 * l_T[4]))) / (4194304.0 * l_T[6])
			a_V0.item := ((l_C[0] + ((-4.0 * l_C[3]) / l_T[1] + l_C[4]) / l_V[4]) + ((-192.0 * l_C[5]) / l_T[3] + (144.0 * l_C[6]) / l_T[2]) / l_V[8]) + a_sgn * ((-l_C[2] / l_V[2] + (((-24.0 * l_C[4]) / l_T[2] + (12.0 * l_C[5]) / l_T[1]) - l_C[6]) / l_V[6]) + ((-1920.0 * l_C[6]) / l_T[4]) / l_V[10])
			a_V1.item := ((l_C[1] / l_V[1] + (8.0 * (l_C[3] / l_T[2] - l_C[4] / l_T[1]) + l_C[5]) / l_V[5]) + ((384.0 * l_C[5]) / l_T[4] - (768.0 * l_C[6]) / l_T[3]) / l_V[9]) + a_sgn * ((((2.0 * l_C[2]) / l_T[1] - l_C[3]) / l_V[3] + (((48.0 * l_C[4]) / l_T[3] - (72.0 * l_C[5]) / l_T[2]) + (18.0 * l_C[6]) / l_T[1]) / l_V[7]) + ((3840.0 * l_C[6]) / l_T[5]) / l_V[11])
			Result := 0
		end

	conicalP_1_V (a_t: REAL_64; a_f: REAL_64; a_tau: REAL_64; a_sgn: REAL_64; a_V0: CE_POINTER [REAL_64]; a_V1: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_Cm1: REAL_64
			l_C: CE_ARRAY [REAL_64]
			l_T: CE_ARRAY [REAL_64]
			l_H: CE_ARRAY [REAL_64]
			l_V: CE_ARRAY [REAL_64]
			l_i: INTEGER_32
		do
			create l_C.make (<<8>>)
			create l_T.make (<<8>>)
			create l_H.make (<<8>>)
			create l_V.make (<<12>>)

			l_T[0] := 1.0
			l_H[0] := 1.0
			l_V[0] := 1.0
			l_i := 1
			from
			until
				not (l_i <= 7)
			loop
				l_T[l_i] := l_T[l_i - 1] * a_t
				l_H[l_i] := l_H[l_i - 1] * (a_t * a_f)
				l_i := l_i + 1
			end
			l_i := 1
			from
			until
				not (l_i <= 11)
			loop
				l_V[l_i] := l_V[l_i - 1] * a_tau
				l_i := l_i + 1
			end
			l_Cm1 := -1.0
			l_C[0] := (3.0 * (1.0 - l_H[1])) / (8.0 * l_T[1])
			l_C[1] := (((-15.0 * l_H[2] + 6.0 * l_H[1]) + 9.0) + (a_sgn * 8.0) * l_T[2]) / (128.0 * l_T[2])
			l_C[2] := (3.0 * ((((-35.0 * l_H[3] - 15.0 * l_H[2]) + 15.0 * l_H[1]) + 35.0) + (a_sgn * l_T[2]) * (32.0 * l_H[1] + 8.0))) / (1024.0 * l_T[3])
			l_C[3] := ((((((-4725.0 * l_H[4] - 6300.0 * l_H[3]) - 3150.0 * l_H[2]) + 3780.0 * l_H[1]) + 10395.0) - 1216.0 * l_T[4]) + (a_sgn * l_T[2]) * ((6000.0 * l_H[2] + 5760.0 * l_H[1]) + 1680.0)) / (32768.0 * l_T[4])
			l_C[4] := (7.0 * (((((((-10395.0 * l_H[5] - 23625.0 * l_H[4]) - 28350.0 * l_H[3]) - 14850.0 * l_H[2]) + 19305.0 * l_H[1]) + 57915.0) - l_T[4] * (6336.0 * l_H[1] + 6080.0)) + (a_sgn * l_T[2]) * (((16800.0 * l_H[3] + 30000.0 * l_H[2]) + 25920.0 * l_H[1]) + 7920.0))) / (262144.0 * l_T[5])
			l_C[5] := ((((((((-2837835.0 * l_H[6] - 9168390.0 * l_H[5]) - 16372125.0 * l_H[4]) - (18_918_900).to_double * l_H[3]) - 10135125.0 * l_H[2]) + 13783770.0 * l_H[1]) + 43648605.0) - l_T[4] * ((3044160.0 * l_H[2] + 5588352.0 * l_H[1]) + 4213440.0)) + (a_sgn * l_T[2]) * (((((5556600.0 * l_H[4] + 14817600.0 * l_H[3]) + 20790000.0 * l_H[2]) + 17297280.0 * l_H[1]) + 5405400.0) + 323072.0 * l_T[4])) / (4194304.0 * l_T[6])
			l_C[6] := 0.0
			a_V0.item := ((l_C[0] + ((-4.0 * l_C[3]) / l_T[1] + l_C[4]) / l_V[4]) + ((-192.0 * l_C[5]) / l_T[3] + (144.0 * l_C[6]) / l_T[2]) / l_V[8]) + a_sgn * (-l_C[2] / l_V[2] + (((-24.0 * l_C[4]) / l_T[2] + (12.0 * l_C[5]) / l_T[1]) - l_C[6]) / l_V[6])
			a_V1.item := ((l_C[1] / l_V[1] + (8.0 * (l_C[3] / l_T[2] - l_C[4] / l_T[1]) + l_C[5]) / l_V[5]) + ((384.0 * l_C[5]) / l_T[4] - (768.0 * l_C[6]) / l_T[3]) / l_V[9]) + a_sgn * ((l_Cm1 * l_V[1] + ((2.0 * l_C[2]) / l_T[1] - l_C[3]) / l_V[3]) + (((48.0 * l_C[4]) / l_T[3] - (72.0 * l_C[5]) / l_T[2]) + (18.0 * l_C[6]) / l_T[1]) / l_V[7])
			Result := 0
		end

	conicalP_hyperg_large_x (a_mu: REAL_64; a_tau: REAL_64; a_y: REAL_64; a_reF: CE_POINTER [REAL_64]; a_imF: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_kmax___0: INTEGER_32
			l_re_a: REAL_64
			l_re_b: REAL_64
			l_re_c: REAL_64
			l_im_a: REAL_64
			l_im_b: REAL_64
			l_im_c: REAL_64
			l_re_sum: REAL_64
			l_im_sum: REAL_64
			l_re_term: REAL_64
			l_im_term: REAL_64
			l_k: INTEGER_32
			l_re_ak: REAL_64
			l_re_bk: REAL_64
			l_re_ck: REAL_64
			l_im_ak: REAL_64
			l_im_bk: REAL_64
			l_im_ck: REAL_64
			l_den: REAL_64
			l_re_multiplier: REAL_64
			l_im_multiplier: REAL_64
			l_re_tmp: REAL_64
			l_im_tmp: REAL_64
			l_asum: REAL_64
			l_tmp: REAL_64
			js: JUMP_STATE
		do
			l_kmax___0 := 1_000
			l_re_a := 0.25 - 0.5 * a_mu
			l_re_b := 0.75 - 0.5 * a_mu
			l_re_c := 1.0
			l_im_a := -0.5 * a_tau
			l_im_b := -0.5 * a_tau
			l_im_c := -a_tau
			l_re_sum := 1.0
			l_im_sum := 0.0
			l_re_term := 1.0
			l_im_term := 0.0
			l_k := 1
			from
			until
				not (not js.loop_done and then (l_k <= l_kmax___0))
			loop
				l_re_ak := (l_re_a + l_k.to_double) - 1.0
				l_re_bk := (l_re_b + l_k.to_double) - 1.0
				l_re_ck := (l_re_c + l_k.to_double) - 1.0
				l_im_ak := l_im_a
				l_im_bk := l_im_b
				l_im_ck := l_im_c
				l_den := l_re_ck * l_re_ck + l_im_ck * l_im_ck
				l_re_multiplier := ((l_re_ak * l_re_bk - l_im_ak * l_im_bk) * l_re_ck + l_im_ck * (l_im_ak * l_re_bk + l_re_ak * l_im_bk)) / l_den
				l_im_multiplier := ((l_im_ak * l_re_bk + l_re_ak * l_im_bk) * l_re_ck - l_im_ck * (l_re_ak * l_re_bk - l_im_ak * l_im_bk)) / l_den
				l_re_tmp := l_re_multiplier * l_re_term - l_im_multiplier * l_im_term
				l_im_tmp := l_im_multiplier * l_re_term + l_re_multiplier * l_im_term
				l_tmp := fabs (l_re_sum)
				l_asum := l_tmp + (fabs (l_im_sum))
				l_re_term := (a_y / l_k.to_double) * l_re_tmp
				l_im_term := (a_y / l_k.to_double) * l_im_tmp
				if (fabs (l_re_term / l_asum)) < 2.2204460492503131e-16 then
					if (fabs (l_im_term / l_asum)) < 2.2204460492503131e-16 then
						js.break
					end
				end
				if not js.loop_jumped then
					l_re_sum := l_re_sum + l_re_term
					l_im_sum := l_im_sum + l_im_term
					l_k := l_k + 1
				end
			end
			a_reF.item := l_re_sum
			a_imF.item := l_im_sum
			if l_k = l_kmax___0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("legendre_con.c"), 473, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	conicalP_negmu_xgt1_CF1 (a_mu: REAL_64; a_ell: INTEGER_32; a_tau: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_maxk: INTEGER_32
			l_gamma___0: REAL_64
			l_pre: REAL_64
			l_tmp: REAL_64
			l_tk: REAL_64
			l_sum: REAL_64
			l_rhok: REAL_64
			l_k: INTEGER_32
			l_tlk: REAL_64
			l_l1k: REAL_64
			l_ak: REAL_64
			l_tmp___2: REAL_64
			js: JUMP_STATE
		do
			l_maxk := 20_000
			l_gamma___0 := 1.0 - 1.0 / (a_x * a_x)
			l_tmp := sqrt (a_x - 1.0)
			l_pre := (l_tmp * (sqrt (a_x + 1.0))) / (a_x * (2.0 * ((a_ell.to_double + a_mu) + 1.0)))
			l_tk := 1.0
			l_sum := 1.0
			l_rhok := 0.0
			l_k := 1
			from
			until
				not (not js.loop_done and then (l_k < l_maxk))
			loop
				l_tlk := 2.0 * ((a_ell.to_double + a_mu) + l_k.to_double)
				l_l1k := (((a_ell.to_double + a_mu) - 0.5) + 1.0) + l_k.to_double
				l_ak := (-(a_tau * a_tau + l_l1k * l_l1k) / (l_tlk * (l_tlk + 2.0))) * l_gamma___0
				l_rhok := (-l_ak * (1.0 + l_rhok)) / (1.0 + l_ak * (1.0 + l_rhok))
				l_tk := l_tk * l_rhok
				l_sum := l_sum + l_tk
				if (fabs (l_tk / l_sum)) < 2.2204460492503131e-16 then
					js.break
				end
				if not js.loop_jumped then
					l_k := l_k + 1
				end
			end
			a_result.item.val := l_pre * l_sum
			a_result.item.err := fabs (l_pre * l_tk)
			l_tmp___2 := sqrt (l_k.to_double)
			a_result.item.err := a_result.item.err + (((2.0 * 2.2204460492503131e-16) * (l_tmp___2 + 1.0)) * (fabs (l_pre * l_sum)))
			if l_k >= l_maxk then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("error"), ce_string ("legendre_con.c"), 147, 11)
					Result := 11
					js.return
					if not js.return_called then
						js.break
					end
				end
			else
				Result := 0
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	conicalP_negmu_xlt1_CF1 (a_mu: REAL_64; a_ell: INTEGER_32; a_tau: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_RECUR_BIG: REAL_64
			l_maxiter: INTEGER_32
			l_n: INTEGER_32
			l_xi: REAL_64
			l_tmp: REAL_64
			l_Anm2: REAL_64
			l_Bnm2: REAL_64
			l_Anm1: REAL_64
			l_Bnm1: REAL_64
			l_a1___4: REAL_64
			l_b1___0: REAL_64
			l_An: REAL_64
			l_Bn: REAL_64
			l_an2: REAL_64
			l_bn2: REAL_64
			l_fn: REAL_64
			l_old_fn: REAL_64
			l_del: REAL_64
			l_tmp___4: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_RECUR_BIG := 1.3407807929942596e+154
					l_maxiter := 5_000
					l_n := 1
					l_tmp := sqrt (1.0 - a_x)
					l_xi := a_x / (l_tmp * (sqrt (1.0 + a_x)))
					l_Anm2 := 1.0
					l_Bnm2 := 0.0
					l_Anm1 := 0.0
					l_Bnm1 := 1.0
					l_a1___4 := 1.0
					l_b1___0 := (2.0 * ((a_mu + a_ell.to_double) + 1.0)) * l_xi
					l_An := l_b1___0 * l_Anm1 + l_a1___4 * l_Anm2
					l_Bn := l_b1___0 * l_Bnm1 + l_a1___4 * l_Bnm2
					l_fn := l_An / l_Bn
				when 1 then -- loop condition:
					if not (not js.loop_done and then (l_n < l_maxiter)) then
						l_pos := -1 + 8 -- skip loop
					end
				when 2 then -- loop body:
						l_n := l_n + 1
						l_Anm2 := l_Anm1
						l_Bnm2 := l_Bnm1
						l_Anm1 := l_An
						l_Bnm1 := l_Bn
						l_an2 := a_tau * a_tau + (((a_mu - 0.5) + a_ell.to_double) + l_n.to_double) * (((a_mu - 0.5) + a_ell.to_double) + l_n.to_double)
						l_bn2 := (2.0 * ((a_ell.to_double + a_mu) + l_n.to_double)) * l_xi
						l_An := l_bn2 * l_Anm1 + l_an2 * l_Anm2
						l_Bn := l_bn2 * l_Bnm1 + l_an2 * l_Bnm2
						if not ((fabs (l_An)) > l_RECUR_BIG) then
							l_pos := -1 + 5 -- skip if block
						end
				when 3 then -- if:
						l_pos := -1 + 6 -- goto _L
				when 4 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 5 then -- else:
						if not ((fabs (l_Bn)) > l_RECUR_BIG) then
							l_pos := -1 + 7 -- skip if block
						end
				when 6 then -- if: | _L:
						l_An := l_An / l_RECUR_BIG
						l_Bn := l_Bn / l_RECUR_BIG
						l_Anm1 := l_Anm1 / l_RECUR_BIG
						l_Bnm1 := l_Bnm1 / l_RECUR_BIG
						l_Anm2 := l_Anm2 / l_RECUR_BIG
						l_Bnm2 := l_Bnm2 / l_RECUR_BIG
				when 7 then -- if done
						l_old_fn := l_fn
						l_fn := l_An / l_Bn
						l_del := l_old_fn / l_fn
						if (fabs (l_del - 1.0)) < 2.0 * 2.2204460492503131e-16 then
							js.break
						end
						l_pos := -1 + 1 -- back to loop condition
				when 8 then -- loop done
					a_result.item.val := l_fn
					l_tmp___4 := sqrt (l_n.to_double)
					a_result.item.err := ((4.0 * 2.2204460492503131e-16) * (l_tmp___4 + 1.0)) * (fabs (l_fn))
					if l_n >= l_maxiter then
						from
						until
							js.loop_done
						loop
							error_inst.gsl_error (ce_string ("error"), ce_string ("legendre_con.c"), 108, 11)
							Result := 11
							js.return
							if not js.return_called then
								js.break
							end
						end
					else
						Result := 0
						js.return
					end
					if not js.return_called then
						Result := 0
					end
				when 9 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	conicalP_xlt1_hyperg_A (a_mu: REAL_64; a_tau: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_x2___1: REAL_64
			l_err_amp: REAL_64
			l_pre_val: REAL_64
			l_pre_err: REAL_64
			l_tmp___3: REAL_64
			l_ln_g1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_ln_g2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_arg_g1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_arg_g2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_F1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_F2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_pre1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_pre2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_t1_val: REAL_64
			l_t1_err: REAL_64
			l_t2_val: REAL_64
			l_t2_err: REAL_64
			l_stat_F1: INTEGER_32
			l_stat_F2: INTEGER_32
			l_status: INTEGER_32
			l_tmp___7: INTEGER_32
			l_tmp___8: INTEGER_32
			l_tmp___11: REAL_64
			l_tmp___13: REAL_64
		do
			create l_ln_g1.make (<<1>>)
			create l_ln_g2.make (<<1>>)
			create l_arg_g1.make (<<1>>)
			create l_arg_g2.make (<<1>>)
			create l_F1.make (<<1>>)
			create l_F2.make (<<1>>)
			create l_pre1.make (<<1>>)
			create l_pre2.make (<<1>>)

			l_x2___1 := a_x * a_x
			l_err_amp := 1.0 + 1.0 / (2.2204460492503131e-16 + (fabs (1.0 - (fabs (a_x)))))
			l_pre_val := 1.77245385090551602729816748334 / (pow (0.5 * (sqrt ((1).to_double - l_x2___1)), a_mu))
			l_tmp___3 := fabs (a_mu)
			l_pre_err := ((l_err_amp * 2.2204460492503131e-16) * (l_tmp___3 + 1.0)) * (fabs (l_pre_val))
			l_stat_F1 := (hyperg_2f1_inst.gsl_sf_hyperg_2F1_conj_e (0.25 - 0.5 * a_mu, 0.5 * a_tau, 0.5, l_x2___1, l_F1))
			l_stat_F2 := (hyperg_2f1_inst.gsl_sf_hyperg_2F1_conj_e (0.75 - 0.5 * a_mu, 0.5 * a_tau, 1.5, l_x2___1, l_F2))
			if l_stat_F1 /= 0 then
				l_tmp___8 := l_stat_F1
			else
				if l_stat_F2 /= 0 then
					l_tmp___7 := l_stat_F2
				else
					l_tmp___7 := 0
				end
				l_tmp___8 := l_tmp___7
			end
			l_status := l_tmp___8
			gamma_inst.gsl_sf_lngamma_complex_e (0.75 - 0.5 * a_mu, -0.5 * a_tau, l_ln_g1, l_arg_g1).do_nothing
			gamma_inst.gsl_sf_lngamma_complex_e (0.25 - 0.5 * a_mu, -0.5 * a_tau, l_ln_g2, l_arg_g2).do_nothing
			exp_inst.gsl_sf_exp_err_e (-2.0 * l_ln_g1.item.val, 2.0 * l_ln_g1.item.err, l_pre1).do_nothing
			exp_inst.gsl_sf_exp_err_e (-2.0 * l_ln_g2.item.val, 2.0 * l_ln_g2.item.err, l_pre2).do_nothing
			l_pre2.item.val := l_pre2.item.val * (-2.0 * a_x)
			l_pre2.item.err := l_pre2.item.err * (2.0 * (fabs (a_x)))
			l_pre2.item.err := l_pre2.item.err + (2.2204460492503131e-16 * (fabs (l_pre2.item.val)))
			l_t1_val := l_pre1.item.val * l_F1.item.val
			l_tmp___11 := fabs (l_pre1.item.val)
			l_t1_err := l_tmp___11 * l_F1.item.err + l_pre1.item.err * (fabs (l_F1.item.val))
			l_t2_val := l_pre2.item.val * l_F2.item.val
			l_tmp___13 := fabs (l_pre2.item.val)
			l_t2_err := l_tmp___13 * l_F2.item.err + l_pre2.item.err * (fabs (l_F2.item.val))
			a_result.item.val := l_pre_val * (l_t1_val + l_t2_val)
			a_result.item.err := l_pre_val * (l_t1_err + l_t2_err)
			a_result.item.err := a_result.item.err + (l_pre_err * (fabs (l_t1_val + l_t2_val)))
			a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
			Result := l_status
		end

	gsl_sf_conicalP_0 (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_conicalP_0_e (a_lambda, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_conicalP_0_e(lambda, x, &result)"), ce_string ("legendre_con.c"), 1_348, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_conicalP_0_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_K: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_th: REAL_64
			l_s: REAL_64
			l_xi: REAL_64
			l_c___1: REAL_64
			l_t: REAL_64
			l_tmp___8: INTEGER_32
			l_tmp___9: INTEGER_32
			l_P___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lm: CE_ARRAY [REAL_64]
			l_stat_P: INTEGER_32
			l_stat_e: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_V0: CE_ARRAY [REAL_64]
			l_V1: CE_ARRAY [REAL_64]
			l_th___0: REAL_64
			l_sth: REAL_64
			l_I0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_I1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_I0: INTEGER_32
			l_stat_I1: INTEGER_32
			l_stat_I: INTEGER_32
			l_tmp___19: INTEGER_32
			l_tmp___20: INTEGER_32
			l_stat_V: INTEGER_32
			l_bessterm: REAL_64
			l_besserr: REAL_64
			l_tmp___22: REAL_64
			l_arg1: REAL_64
			l_sqts: REAL_64
			l_stat_e___0: INTEGER_32
			l_tmp___27: INTEGER_32
			l_tmp___28: INTEGER_32
			l_tmp___29: INTEGER_32
			l_sh: REAL_64
			l_tmp___30: REAL_64
			l_xi___0: REAL_64
			l_J0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_J1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_J0: INTEGER_32
			l_stat_J1: INTEGER_32
			l_stat_J: INTEGER_32
			l_tmp___35: INTEGER_32
			l_tmp___36: INTEGER_32
			l_stat_V___0: INTEGER_32
			l_bessterm___0: REAL_64
			l_besserr___0: REAL_64
			l_tmp___38: REAL_64
			l_pre_val: REAL_64
			l_pre_err: REAL_64
			l_tmp___44: INTEGER_32
			l_tmp___45: INTEGER_32
			l_tmp___46: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_K.make (<<1>>)
			create l_P___2.make (<<1>>)
			create l_lm.make (<<1>>)
			create l_V0.make (<<1>>)
			create l_V1.make (<<1>>)
			create l_I0.make (<<1>>)
			create l_I1.make (<<1>>)
			create l_J0.make (<<1>>)
			create l_J1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_con.c"), 771, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else:
						if a_x /= 1.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						a_result.item.val := 1.0
						a_result.item.err := 0.0
						Result := 0
						js.return
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if a_lambda /= 0.0 then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_x < 1.0 then
							l_th := (acos (a_x))
							l_s := (sin (0.5 * l_th))
							l_stat_K := ellint_inst.gsl_sf_ellint_Kcomp_e (l_s, (0).to_natural_32, l_K)
							a_result.item.val := (2.0 / 3.14159265358979323846) * l_K.item.val
							a_result.item.err := (2.0 / 3.14159265358979323846) * l_K.item.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_K
							js.return
						else
							l_xi := (acosh (a_x))
							l_c___1 := (cosh (0.5 * l_xi))
							l_t := (tanh (0.5 * l_xi))
							l_stat_K := ellint_inst.gsl_sf_ellint_Kcomp_e (l_t, (0).to_natural_32, l_K)
							a_result.item.val := ((2.0 / 3.14159265358979323846) / l_c___1) * l_K.item.val
							a_result.item.err := ((2.0 / 3.14159265358979323846) / l_c___1) * l_K.item.err
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_K
							js.return
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_lambda < 1000.0 then
							l_tmp___8 := conicalP_xlt1_hyperg_A (0.0, a_lambda, a_x, a_result)
							Result := l_tmp___8
							js.return
						else
							l_pos := -1 + 12 -- goto _L___4
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else: | _L___4:
						if not (a_x < 0.1) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_lambda < 17.0 then
							l_tmp___8 := conicalP_xlt1_hyperg_A (0.0, a_lambda, a_x, a_result)
							Result := l_tmp___8
							js.return
						else
							l_pos := -1 + 15 -- goto _L___3
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else: | _L___3:
						if not (a_x < 0.2) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if a_lambda < 5.0 then
							l_tmp___8 := conicalP_xlt1_hyperg_A (0.0, a_lambda, a_x, a_result)
							Result := l_tmp___8
							js.return
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else: | _L___2:
						if not (a_x <= 0.2) then
							l_pos := -1 + 21 -- skip if block
						end
				when 19 then -- if:
						if a_lambda < 17.0 then
							l_tmp___9 := hyperg_2f1_inst.gsl_sf_hyperg_2F1_conj_e (0.5, a_lambda, 1.0, (1.0 - a_x) / (2).to_double, a_result)
							Result := l_tmp___9
							js.return
						else
							l_pos := -1 + 21 -- goto _L___1
						end
				when 20 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 21 then -- else: | _L___1:
						if not (a_x <= 1.5) then
							l_pos := -1 + 24 -- skip if block
						end
				when 22 then -- if:
						if a_lambda < 20.0 then
							l_tmp___9 := hyperg_2f1_inst.gsl_sf_hyperg_2F1_conj_e (0.5, a_lambda, 1.0, (1.0 - a_x) / (2).to_double, a_result)
							Result := l_tmp___9
							js.return
						else
							l_pos := -1 + 24 -- goto _L___0
						end
				when 23 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else: | _L___0:
						if not (1.5 < a_x) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if a_x > 20.0 then
							l_tmp___46 := a_x
						else
							l_tmp___46 := 20.0
						end
						if a_lambda < l_tmp___46 then
							l_stat_P := (gsl_sf_conicalP_large_x_e (0.0, a_lambda, a_x, l_P___2, l_lm))
							l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_lm.item, (2.0 * 2.2204460492503131e-16) * (fabs (l_lm.item)), l_P___2.item.val, l_P___2.item.err, a_result))
							if l_stat_e /= 0 then
								l_tmp___14 := l_stat_e
							else
								if l_stat_P /= 0 then
									l_tmp___13 := l_stat_P
								else
									l_tmp___13 := 0
								end
								l_tmp___14 := l_tmp___13
							end
							Result := l_tmp___14
							js.return
						else
							l_pos := -1 + 27 -- goto _L
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L:
						if a_x < 1.0 then
							l_th___0 := (acos (a_x))
							l_sth := (sqrt (1.0 - a_x * a_x))
							l_stat_I0 := (bessel_i0_inst.gsl_sf_bessel_I0_scaled_e2 (l_th___0 * a_lambda, l_I0))
							l_stat_I1 := (bessel_i1_inst.gsl_sf_bessel_I1_scaled_e2 (l_th___0 * a_lambda, l_I1))
							if l_stat_I0 /= 0 then
								l_tmp___20 := l_stat_I0
							else
								if l_stat_I1 /= 0 then
									l_tmp___19 := l_stat_I1
								else
									l_tmp___19 := 0
								end
								l_tmp___20 := l_tmp___19
							end
							l_stat_I := l_tmp___20
							l_stat_V := (conicalP_0_V (l_th___0, a_x / l_sth, a_lambda, -1.0, l_V0, l_V1))
							l_bessterm := l_V0.item * l_I0.item.val + l_V1.item * l_I1.item.val
							l_tmp___22 := fabs (l_V0.item)
							l_besserr := l_tmp___22 * l_I0.item.err + (fabs (l_V1.item)) * l_I1.item.err
							l_arg1 := l_th___0 * a_lambda
							l_sqts := (sqrt (l_th___0 / l_sth))
							l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (l_arg1, (4.0 * 2.2204460492503131e-16) * (fabs (l_arg1)), l_sqts * l_bessterm, l_sqts * l_besserr, a_result))
							if l_stat_e___0 /= 0 then
								l_tmp___29 := l_stat_e___0
							else
								if l_stat_V /= 0 then
									l_tmp___28 := l_stat_V
								else
									if l_stat_I /= 0 then
										l_tmp___27 := l_stat_I
									else
										l_tmp___27 := 0
									end
									l_tmp___28 := l_tmp___27
								end
								l_tmp___29 := l_tmp___28
							end
							Result := l_tmp___29
							js.return
						else
							l_tmp___30 := sqrt (a_x - 1.0)
							l_sh := l_tmp___30 * (sqrt (a_x + 1.0))
							l_xi___0 := (log (a_x + l_sh))
							l_stat_J0 := (bessel_j0_inst.gsl_sf_bessel_J0_e2 (l_xi___0 * a_lambda, l_J0))
							l_stat_J1 := (bessel_j1_inst.gsl_sf_bessel_J1_e (l_xi___0 * a_lambda, l_J1))
							if l_stat_J0 /= 0 then
								l_tmp___36 := l_stat_J0
							else
								if l_stat_J1 /= 0 then
									l_tmp___35 := l_stat_J1
								else
									l_tmp___35 := 0
								end
								l_tmp___36 := l_tmp___35
							end
							l_stat_J := l_tmp___36
							l_stat_V___0 := (conicalP_0_V (l_xi___0, a_x / l_sh, a_lambda, 1.0, l_V0, l_V1))
							l_bessterm___0 := l_V0.item * l_J0.item.val + l_V1.item * l_J1.item.val
							l_tmp___38 := fabs (l_V0.item)
							l_besserr___0 := l_tmp___38 * l_J0.item.err + (fabs (l_V1.item)) * l_J1.item.err
							l_pre_val := (sqrt (l_xi___0 / l_sh))
							l_pre_err := 2.0 * (fabs (l_pre_val))
							a_result.item.val := l_pre_val * l_bessterm___0
							a_result.item.err := l_pre_val * l_besserr___0
							a_result.item.err := a_result.item.err + (l_pre_err * (fabs (l_bessterm___0)))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if l_stat_V___0 /= 0 then
								l_tmp___45 := l_stat_V___0
							else
								if l_stat_J /= 0 then
									l_tmp___44 := l_stat_J
								else
									l_tmp___44 := 0
								end
								l_tmp___45 := l_tmp___44
							end
							Result := l_tmp___45
							js.return
						end
				when 28 then -- if done | if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_conicalP_1 (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_conicalP_1_e (a_lambda, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_conicalP_1_e(lambda, x, &result)"), ce_string ("legendre_con.c"), 1_353, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_conicalP_1_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_K: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_E: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_K: INTEGER_32
			l_stat_E: INTEGER_32
			l_err_amp: REAL_64
			l_th: REAL_64
			l_s: REAL_64
			l_c2___0: REAL_64
			l_sth: REAL_64
			l_pre: REAL_64
			l_tmp___10: INTEGER_32
			l_tmp___11: INTEGER_32
			l_err_amp___0: REAL_64
			l_xi: REAL_64
			l_c___1: REAL_64
			l_t: REAL_64
			l_sxi: REAL_64
			l_pre___0: REAL_64
			l_tmp___21: INTEGER_32
			l_tmp___22: INTEGER_32
			l_tmp___23: INTEGER_32
			l_arg: REAL_64
			l_sgn: REAL_64
			l_tmp___25: INTEGER_32
			l_pre___1: REAL_64
			l_F___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_F: INTEGER_32
			l_P___2: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lm: CE_ARRAY [REAL_64]
			l_stat_P: INTEGER_32
			l_stat_e2: INTEGER_32
			l_tmp___33: INTEGER_32
			l_tmp___34: INTEGER_32
			l_V0: CE_ARRAY [REAL_64]
			l_V1: CE_ARRAY [REAL_64]
			l_sqrt_1mx: REAL_64
			l_sqrt_1px: REAL_64
			l_th___0: REAL_64
			l_sth___0: REAL_64
			l_I0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_I1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_I0: INTEGER_32
			l_stat_I1: INTEGER_32
			l_stat_I: INTEGER_32
			l_tmp___40: INTEGER_32
			l_tmp___41: INTEGER_32
			l_stat_V: INTEGER_32
			l_bessterm: REAL_64
			l_besserr: REAL_64
			l_tmp___43: REAL_64
			l_tmp___44: REAL_64
			l_tmp___45: REAL_64
			l_arg1: REAL_64
			l_sqts: REAL_64
			l_stat_e___0: INTEGER_32
			l_tmp___50: INTEGER_32
			l_tmp___51: INTEGER_32
			l_tmp___52: INTEGER_32
			l_sqrt_xm1: REAL_64
			l_sqrt_xp1: REAL_64
			l_sh: REAL_64
			l_xi___0: REAL_64
			l_xi_lam: REAL_64
			l_J0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_J1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_J0: INTEGER_32
			l_stat_J1: INTEGER_32
			l_stat_J: INTEGER_32
			l_tmp___58: INTEGER_32
			l_tmp___59: INTEGER_32
			l_stat_V___0: INTEGER_32
			l_bessterm___0: REAL_64
			l_besserr___0: REAL_64
			l_tmp___61: REAL_64
			l_tmp___62: REAL_64
			l_tmp___63: REAL_64
			l_tmp___64: REAL_64
			l_tmp___65: REAL_64
			l_pre___2: REAL_64
			l_tmp___69: INTEGER_32
			l_tmp___70: INTEGER_32
			l_tmp___71: REAL_64
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_K.make (<<1>>)
			create l_E.make (<<1>>)
			create l_F___0.make (<<1>>)
			create l_P___2.make (<<1>>)
			create l_lm.make (<<1>>)
			create l_V0.make (<<1>>)
			create l_V1.make (<<1>>)
			create l_I0.make (<<1>>)
			create l_I1.make (<<1>>)
			create l_J0.make (<<1>>)
			create l_J1.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_con.c"), 872, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 3 then -- else:
						if a_lambda /= 0.0 then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if:
						if a_x = 1.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif a_x < 1.0 then
							if 1.0 - a_x < 1.4901161193847656e-08 then
								l_err_amp := (gsl_gsl_minmax_inst.GSL_MAX_DBL (1.0, 1.0 / (2.2204460492503131e-16 + (fabs (1.0 - a_x)))))
								a_result.item.val := ((0.25 / 1.41421356237309504880) * (sqrt (1.0 - a_x))) * (1.0 + (5.0 / 16.0) * (1.0 - a_x))
								a_result.item.err := ((l_err_amp * 3.0) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
								Result := 0
								js.return
							else
								l_th := (acos (a_x))
								l_s := (sin (0.5 * l_th))
								l_c2___0 := 1.0 - l_s * l_s
								l_sth := (sin (l_th))
								l_pre := 2.0 / (3.14159265358979323846 * l_sth)
								l_stat_K := ellint_inst.gsl_sf_ellint_Kcomp_e (l_s, (0).to_natural_32, l_K)
								l_stat_E := ellint_inst.gsl_sf_ellint_Ecomp_e (l_s, (0).to_natural_32, l_E)
								a_result.item.val := l_pre * (l_E.item.val - l_c2___0 * l_K.item.val)
								a_result.item.err := l_pre * (l_E.item.err + (fabs (l_c2___0)) * l_K.item.err)
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
								if l_stat_K /= 0 then
									l_tmp___11 := l_stat_K
								else
									if l_stat_E /= 0 then
										l_tmp___10 := l_stat_E
									else
										l_tmp___10 := 0
									end
									l_tmp___11 := l_tmp___10
								end
								Result := l_tmp___11
								js.return
							end
						elseif a_x - 1.0 < 1.4901161193847656e-08 then
							l_err_amp___0 := (gsl_gsl_minmax_inst.GSL_MAX_DBL (1.0, 1.0 / (2.2204460492503131e-16 + (fabs (1.0 - a_x)))))
							a_result.item.val := ((-0.25 / 1.41421356237309504880) * (sqrt (a_x - 1.0))) * (1.0 - (5.0 / 16.0) * (a_x - 1.0))
							a_result.item.err := ((l_err_amp___0 * 3.0) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
							Result := 0
							js.return
						else
							l_xi := (acosh (a_x))
							l_c___1 := (cosh (0.5 * l_xi))
							l_t := (tanh (0.5 * l_xi))
							l_sxi := (sinh (l_xi))
							l_pre___0 := (2.0 / (3.14159265358979323846 * l_sxi)) * l_c___1
							l_stat_K := ellint_inst.gsl_sf_ellint_Kcomp_e (l_t, (0).to_natural_32, l_K)
							l_stat_E := ellint_inst.gsl_sf_ellint_Ecomp_e (l_t, (0).to_natural_32, l_E)
							a_result.item.val := l_pre___0 * (l_E.item.val - l_K.item.val)
							a_result.item.err := l_pre___0 * (l_E.item.err + l_K.item.err)
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if l_stat_K /= 0 then
								l_tmp___22 := l_stat_K
							else
								if l_stat_E /= 0 then
									l_tmp___21 := l_stat_E
								else
									l_tmp___21 := 0
								end
								l_tmp___22 := l_tmp___21
							end
							Result := l_tmp___22
							js.return
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 6 then -- else:
						if not (a_x <= 0.0) then
							l_pos := -1 + 9 -- skip if block
						end
				when 7 then -- if:
						if a_lambda < 1000.0 then
							l_tmp___23 := conicalP_xlt1_hyperg_A (1.0, a_lambda, a_x, a_result)
							Result := l_tmp___23
							js.return
						else
							l_pos := -1 + 9 -- goto _L___5
						end
				when 8 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 9 then -- else: | _L___5:
						if not (a_x < 0.1) then
							l_pos := -1 + 12 -- skip if block
						end
				when 10 then -- if:
						if a_lambda < 17.0 then
							l_tmp___23 := conicalP_xlt1_hyperg_A (1.0, a_lambda, a_x, a_result)
							Result := l_tmp___23
							js.return
						else
							l_pos := -1 + 12 -- goto _L___4
						end
				when 11 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 12 then -- else: | _L___4:
						if not (a_x < 0.2) then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if a_lambda < 5.0 then
							l_tmp___23 := conicalP_xlt1_hyperg_A (1.0, a_lambda, a_x, a_result)
							Result := l_tmp___23
							js.return
						else
							l_pos := -1 + 15 -- goto _L___3
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 15 then -- else: | _L___3:
						if not (a_x <= 0.2) then
							l_pos := -1 + 18 -- skip if block
						end
				when 16 then -- if:
						if a_lambda < 17.0 then
							l_pos := -1 + 20 -- goto _L___0
						else
							l_pos := -1 + 18 -- goto _L___2
						end
				when 17 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 18 then -- else: | _L___2:
						if not (a_x < 1.5) then
							l_pos := -1 + 24 -- skip if block
						end
				when 19 then -- if:
						if not (a_lambda < 20.0) then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___0:
						l_arg := (fabs (a_x * a_x - 1.0))
						if 1.0 - a_x >= 0.0 then
							l_tmp___25 := 1
						else
							l_tmp___25 := -1
						end
						l_sgn := l_tmp___25.to_double
						l_pre___1 := ((0.5 * (a_lambda * a_lambda + 0.25)) * l_sgn) * (sqrt (l_arg))
						l_stat_F := (hyperg_2f1_inst.gsl_sf_hyperg_2F1_conj_e (1.5, a_lambda, 2.0, (1.0 - a_x) / (2).to_double, l_F___0))
						a_result.item.val := l_pre___1 * l_F___0.item.val
						a_result.item.err := (fabs (l_pre___1)) * l_F___0.item.err
						a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
						Result := l_stat_F
						js.return
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___1
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 28
				when 24 then -- else: | _L___1:
						if not (1.5 <= a_x) then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if a_x > 20.0 then
							l_tmp___71 := a_x
						else
							l_tmp___71 := 20.0
						end
						if a_lambda < l_tmp___71 then
							l_stat_P := (gsl_sf_conicalP_large_x_e (1.0, a_lambda, a_x, l_P___2, l_lm))
							l_stat_e2 := (exp_inst.gsl_sf_exp_mult_err_e (l_lm.item, (2.0 * 2.2204460492503131e-16) * (fabs (l_lm.item)), l_P___2.item.val, l_P___2.item.err, a_result))
							if l_stat_e2 /= 0 then
								l_tmp___34 := l_stat_e2
							else
								if l_stat_P /= 0 then
									l_tmp___33 := l_stat_P
								else
									l_tmp___33 := 0
								end
								l_tmp___34 := l_tmp___33
							end
							Result := l_tmp___34
							js.return
						else
							l_pos := -1 + 27 -- goto _L
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 28
				when 27 then -- else: | _L:
						if a_x < 1.0 then
							l_sqrt_1mx := (sqrt (1.0 - a_x))
							l_sqrt_1px := (sqrt (1.0 + a_x))
							l_th___0 := (acos (a_x))
							l_sth___0 := l_sqrt_1mx * l_sqrt_1px
							l_stat_I0 := (bessel_i0_inst.gsl_sf_bessel_I0_scaled_e2 (l_th___0 * a_lambda, l_I0))
							l_stat_I1 := (bessel_i1_inst.gsl_sf_bessel_I1_scaled_e2 (l_th___0 * a_lambda, l_I1))
							if l_stat_I0 /= 0 then
								l_tmp___41 := l_stat_I0
							else
								if l_stat_I1 /= 0 then
									l_tmp___40 := l_stat_I1
								else
									l_tmp___40 := 0
								end
								l_tmp___41 := l_tmp___40
							end
							l_stat_I := l_tmp___41
							l_stat_V := (conicalP_1_V (l_th___0, a_x / l_sth___0, a_lambda, -1.0, l_V0, l_V1))
							l_bessterm := l_V0.item * l_I0.item.val + l_V1.item * l_I1.item.val
							l_tmp___43 := fabs (l_V0.item)
							l_tmp___44 := fabs (l_V1.item)
							l_tmp___45 := fabs (l_V0.item * l_I0.item.val)
							l_besserr := ((l_tmp___43 * l_I0.item.err + l_tmp___44 * l_I1.item.err) + (2.0 * 2.2204460492503131e-16) * l_tmp___45) + (2.0 * 2.2204460492503131e-16) * (fabs (l_V1.item * l_I1.item.val))
							l_arg1 := l_th___0 * a_lambda
							l_sqts := (sqrt (l_th___0 / l_sth___0))
							l_stat_e___0 := (exp_inst.gsl_sf_exp_mult_err_e (l_arg1, (2.0 * 2.2204460492503131e-16) * (fabs (l_arg1)), l_sqts * l_bessterm, l_sqts * l_besserr, a_result))
							a_result.item.err := a_result.item.err * (1.0 / l_sqrt_1mx)
							if l_stat_e___0 /= 0 then
								l_tmp___52 := l_stat_e___0
							else
								if l_stat_V /= 0 then
									l_tmp___51 := l_stat_V
								else
									if l_stat_I /= 0 then
										l_tmp___50 := l_stat_I
									else
										l_tmp___50 := 0
									end
									l_tmp___51 := l_tmp___50
								end
								l_tmp___52 := l_tmp___51
							end
							Result := l_tmp___52
							js.return
						else
							l_sqrt_xm1 := (sqrt (a_x - 1.0))
							l_sqrt_xp1 := (sqrt (a_x + 1.0))
							l_sh := l_sqrt_xm1 * l_sqrt_xp1
							l_xi___0 := (log (a_x + l_sh))
							l_xi_lam := l_xi___0 * a_lambda
							l_stat_J0 := (bessel_j0_inst.gsl_sf_bessel_J0_e2 (l_xi_lam, l_J0))
							l_stat_J1 := (bessel_j1_inst.gsl_sf_bessel_J1_e (l_xi_lam, l_J1))
							if l_stat_J0 /= 0 then
								l_tmp___59 := l_stat_J0
							else
								if l_stat_J1 /= 0 then
									l_tmp___58 := l_stat_J1
								else
									l_tmp___58 := 0
								end
								l_tmp___59 := l_tmp___58
							end
							l_stat_J := l_tmp___59
							l_stat_V___0 := (conicalP_1_V (l_xi___0, a_x / l_sh, a_lambda, 1.0, l_V0, l_V1))
							l_bessterm___0 := l_V0.item * l_J0.item.val + l_V1.item * l_J1.item.val
							l_tmp___61 := fabs (l_V0.item)
							l_tmp___62 := fabs (l_V1.item)
							l_tmp___63 := fabs (l_V0.item * l_J0.item.val)
							l_tmp___64 := fabs (l_V1.item * l_J1.item.val)
							l_tmp___65 := fabs ((l_xi_lam * l_V0.item) * l_J1.item.val)
							l_besserr___0 := ((((l_tmp___61 * l_J0.item.err + l_tmp___62 * l_J1.item.err) + ((512.0 * 2.0) * 2.2204460492503131e-16) * l_tmp___63) + ((512.0 * 2.0) * 2.2204460492503131e-16) * l_tmp___64) + 2.2204460492503131e-16 * l_tmp___65) + 2.2204460492503131e-16 * (fabs ((l_xi_lam * l_V1.item) * l_J0.item.val))
							l_pre___2 := (sqrt (l_xi___0 / l_sh))
							a_result.item.val := l_pre___2 * l_bessterm___0
							a_result.item.err := ((l_pre___2 * l_besserr___0) * l_sqrt_xp1) / l_sqrt_xm1
							a_result.item.err := a_result.item.err + ((4.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if l_stat_V___0 /= 0 then
								l_tmp___70 := l_stat_V___0
							else
								if l_stat_J /= 0 then
									l_tmp___69 := l_stat_J
								else
									l_tmp___69 := 0
								end
								l_tmp___70 := l_tmp___69
							end
							Result := l_tmp___70
							js.return
						end
				when 28 then -- if done | if done | if done | if done | if done | if done | if done
						if not js.return_called then
							Result := 0
						end
				when 29 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_conicalP_cyl_reg (a_m___4: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_conicalP_cyl_reg_e (a_m___4, a_lambda, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_conicalP_cyl_reg_e(m, lambda, x, &result)"), ce_string ("legendre_con.c"), 1_373, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_conicalP_cyl_reg_e (a_m___4: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c___1: REAL_64
			l_r_Pkm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Pk: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_stat_P: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_Pkm1: REAL_64
			l_Pk: REAL_64
			l_Pkp1: REAL_64
			l_k: INTEGER_32
			l_d: REAL_64
			l_xi: REAL_64
			l_tmp___10: REAL_64
			l_rat: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_P0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_CF1: INTEGER_32
			l_stat_P0: INTEGER_32
			l_Pkp1___0: REAL_64
			l_Pk___0: REAL_64
			l_Pkm1___0: REAL_64
			l_k___0: INTEGER_32
			l_d___0: REAL_64
			l_tmp___15: REAL_64
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_xi___0: REAL_64
			l_rat___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_CF1___0: INTEGER_32
			l_stat_P___0: INTEGER_32
			l_Pkp1___1: REAL_64
			l_Pk___1: REAL_64
			l_Pkm1___1: REAL_64
			l_k___1: INTEGER_32
			l_d___1: REAL_64
			l_P1___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___23: REAL_64
			l_P0___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___27: REAL_64
			l_tmp___30: REAL_64
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r_Pkm1.make (<<1>>)
			create l_r_Pk.make (<<1>>)
			create l_rat.make (<<1>>)
			create l_P0.make (<<1>>)
			create l_rat___0.make (<<1>>)
			create l_P1___0.make (<<1>>)
			create l_P0___0.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_m___4 < -1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_con.c"), 1_233, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_m___4 = -1 then
							Result := (gsl_sf_conicalP_1_e (a_lambda, a_x, a_result))
							js.return
						elseif a_m___4 = 0 then
							Result := (gsl_sf_conicalP_0_e (a_lambda, a_x, a_result))
							js.return
						elseif a_x = 1.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif a_x < 0.0 then
							l_c___1 := 1.0 / (sqrt (1.0 - a_x * a_x))
							l_stat_0 := (gsl_sf_conicalP_1_e (a_lambda, a_x, l_r_Pkm1))
							l_stat_1 := (gsl_sf_conicalP_0_e (a_lambda, a_x, l_r_Pk))
							if l_stat_0 /= 0 then
								l_tmp___7 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___6 := l_stat_1
								else
									l_tmp___6 := 0
								end
								l_tmp___7 := l_tmp___6
							end
							l_stat_P := l_tmp___7
							l_Pkm1 := l_r_Pkm1.item.val
							l_Pk := l_r_Pk.item.val
							l_k := 0
							from
							until
								not (l_k < a_m___4)
							loop
								l_d := (l_k.to_double + 0.5) * (l_k.to_double + 0.5) + a_lambda * a_lambda
								l_Pkp1 := (l_Pkm1 - (((2.0 * l_k.to_double) * l_c___1) * a_x) * l_Pk) / l_d
								l_Pkm1 := l_Pk
								l_Pk := l_Pkp1
								l_k := l_k + 1
							end
							a_result.item.val := l_Pk
							a_result.item.err := ((a_m___4.to_double + 2.0) * 2.2204460492503131e-16) * (fabs (l_Pk))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							Result := l_stat_P
							js.return
						elseif a_x < 1.0 then
							l_tmp___10 := sqrt (1.0 - a_x)
							l_xi := a_x / (l_tmp___10 * (sqrt (1.0 + a_x)))
							l_stat_CF1 := (conicalP_negmu_xlt1_CF1 (0.0, a_m___4, a_lambda, a_x, l_rat))
							l_stat_P0 := (gsl_sf_conicalP_0_e (a_lambda, a_x, l_P0))
							l_Pkp1___0 := l_rat.item.val * 1.4916681462400413e-154
							l_Pk___0 := 1.4916681462400413e-154
							l_k___0 := a_m___4
							from
							until
								not (l_k___0 > 0)
							loop
								l_d___0 := (l_k___0.to_double + 0.5) * (l_k___0.to_double + 0.5) + a_lambda * a_lambda
								l_Pkm1___0 := ((2.0 * l_k___0.to_double) * l_xi) * l_Pk___0 + l_d___0 * l_Pkp1___0
								l_Pkp1___0 := l_Pk___0
								l_Pk___0 := l_Pkm1___0
								l_k___0 := l_k___0 - 1
							end
							a_result.item.val := (1.4916681462400413e-154 * l_P0.item.val) / l_Pk___0
							a_result.item.err := ((2.0 * 1.4916681462400413e-154) * l_P0.item.err) / (fabs (l_Pk___0))
							l_tmp___15 := fabs (l_rat.item.err / l_rat.item.val)
							a_result.item.err := a_result.item.err + (((2.0 * l_tmp___15) * (a_m___4.to_double + 1.0)) * (fabs (a_result.item.val)))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if l_stat_P0 /= 0 then
								l_tmp___19 := l_stat_P0
							else
								if l_stat_CF1 /= 0 then
									l_tmp___18 := l_stat_CF1
								else
									l_tmp___18 := 0
								end
								l_tmp___19 := l_tmp___18
							end
							Result := l_tmp___19
							js.return
						elseif a_x = 1.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_xi___0 := a_x / (sqrt ((a_x - 1.0) * (a_x + 1.0)))
							l_stat_CF1___0 := (conicalP_negmu_xgt1_CF1 (0.0, a_m___4, a_lambda, a_x, l_rat___0))
							l_Pkp1___1 := l_rat___0.item.val * 1.4916681462400413e-154
							l_Pk___1 := 1.4916681462400413e-154
							l_k___1 := a_m___4
							from
							until
								not (l_k___1 > -1)
							loop
								l_d___1 := (l_k___1.to_double + 0.5) * (l_k___1.to_double + 0.5) + a_lambda * a_lambda
								l_Pkm1___1 := ((2.0 * l_k___1.to_double) * l_xi___0) * l_Pk___1 - l_d___1 * l_Pkp1___1
								l_Pkp1___1 := l_Pk___1
								l_Pk___1 := l_Pkm1___1
								l_k___1 := l_k___1 - 1
							end
							l_tmp___30 := fabs (l_Pk___1)
							if l_tmp___30 > (fabs (l_Pkp1___1)) then
								l_stat_P___0 := gsl_sf_conicalP_1_e (a_lambda, a_x, l_P1___0)
								a_result.item.val := (1.4916681462400413e-154 * l_P1___0.item.val) / l_Pk___1
								a_result.item.err := ((2.0 * 1.4916681462400413e-154) * l_P1___0.item.err) / (fabs (l_Pk___1))
								l_tmp___23 := fabs (l_rat___0.item.err / l_rat___0.item.val)
								a_result.item.err := a_result.item.err + (((2.0 * l_tmp___23) * (a_m___4.to_double + 2.0)) * (fabs (a_result.item.val)))
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							else
								l_stat_P___0 := gsl_sf_conicalP_0_e (a_lambda, a_x, l_P0___0)
								a_result.item.val := (1.4916681462400413e-154 * l_P0___0.item.val) / l_Pkp1___1
								a_result.item.err := ((2.0 * 1.4916681462400413e-154) * l_P0___0.item.err) / (fabs (l_Pkp1___1))
								l_tmp___27 := fabs (l_rat___0.item.err / l_rat___0.item.val)
								a_result.item.err := a_result.item.err + (((2.0 * l_tmp___27) * (a_m___4.to_double + 2.0)) * (fabs (a_result.item.val)))
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							end
							if l_stat_P___0 /= 0 then
								l_tmp___33 := l_stat_P___0
							else
								if l_stat_CF1___0 /= 0 then
									l_tmp___32 := l_stat_CF1___0
								else
									l_tmp___32 := 0
								end
								l_tmp___33 := l_tmp___32
							end
							Result := l_tmp___33
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_conicalP_half (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_conicalP_half_e (a_lambda, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_conicalP_half_e(lambda, x, &result)"), ce_string ("legendre_con.c"), 1_358, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_conicalP_half_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_err_amp: REAL_64
			l_ac: REAL_64
			l_den: REAL_64
			l_tmp___4: REAL_64
			l_err_amp___0: REAL_64
			l_sq_term: REAL_64
			l_tmp___12: REAL_64
			l_ln_term: REAL_64
			l_den___0: REAL_64
			l_carg_val: REAL_64
			l_carg_err: REAL_64
			l_cos_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_cos: INTEGER_32
			js: JUMP_STATE
		do
			create l_cos_result.make (<<1>>)

			if a_x <= -1.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_con.c"), 1_017, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 1.0 then
				l_err_amp := 1.0 + 1.0 / (2.2204460492503131e-16 + (fabs (1.0 - (fabs (a_x)))))
				l_ac := (acos (a_x))
				l_tmp___4 := sqrt (1.0 - a_x)
				l_den := (sqrt (l_tmp___4 * (sqrt (1.0 + a_x))))
				a_result.item.val := (0.797884560802865355879892 / l_den) * (cosh (l_ac * a_lambda))
				a_result.item.err := ((l_err_amp * 3.0) * 2.2204460492503131e-16) * (fabs (a_result.item.val))
				a_result.item.err := a_result.item.err * ((fabs (l_ac * a_lambda)) + 1.0)
				Result := 0
				js.return
			elseif a_x = 1.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			else
				l_err_amp___0 := 1.0 + 1.0 / (2.2204460492503131e-16 + (fabs (1.0 - (fabs (a_x)))))
				l_tmp___12 := sqrt (a_x - 1.0)
				l_sq_term := l_tmp___12 * (sqrt (a_x + 1.0))
				l_ln_term := (log (a_x + l_sq_term))
				l_den___0 := (sqrt (l_sq_term))
				l_carg_val := a_lambda * l_ln_term
				l_carg_err := (2.0 * 2.2204460492503131e-16) * (fabs (l_carg_val))
				l_stat_cos := (trig_inst.gsl_sf_cos_err_e (l_carg_val, l_carg_err, l_cos_result))
				a_result.item.val := (0.797884560802865355879892 / l_den___0) * l_cos_result.item.val
				a_result.item.err := ((l_err_amp___0 * 0.797884560802865355879892) / l_den___0) * l_cos_result.item.err
				a_result.item.err := a_result.item.err + ((4.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				Result := l_stat_cos
				js.return
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_conicalP_large_x_e (a_mu: REAL_64; a_tau: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_ln_multiplier: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_y: REAL_64
			l_tmp: REAL_64
			l_reF: CE_ARRAY [REAL_64]
			l_imF: CE_ARRAY [REAL_64]
			l_stat_F: INTEGER_32
			l_lgr_num: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lgth_num: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lgr_den: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lgth_den: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_gn: INTEGER_32
			l_stat_gd: INTEGER_32
			l_angle: REAL_64
			l_lnx: REAL_64
			l_lnxp1: REAL_64
			l_lnxm1: REAL_64
			l_lnpre_const: REAL_64
			l_lnpre_comm: REAL_64
			l_lnpre_err: REAL_64
			l_tmp___7: REAL_64
			l_tmp___8: REAL_64
			l_tmp___9: REAL_64
			l_cos_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_cos: INTEGER_32
			l_status: INTEGER_32
			l_tmp___13: INTEGER_32
			l_tmp___14: INTEGER_32
			l_tmp___15: INTEGER_32
			l_tmp___16: INTEGER_32
			l_lnFf_val: REAL_64
			l_lnFf_err: REAL_64
			l_lnnoc_val: REAL_64
			l_lnnoc_err: REAL_64
			l_stat_e: INTEGER_32
		do
			create l_reF.make (<<1>>)
			create l_imF.make (<<1>>)
			create l_lgr_num.make (<<1>>)
			create l_lgth_num.make (<<1>>)
			create l_lgr_den.make (<<1>>)
			create l_lgth_den.make (<<1>>)
			create l_cos_result.make (<<1>>)

			if a_x < 0.5 * 1.3407807929942596e+154 then
				l_tmp := 1.0 / (a_x * a_x)
			else
				l_tmp := 0.0
			end
			l_y := l_tmp
			l_stat_F := (conicalP_hyperg_large_x (a_mu, a_tau, l_y, l_reF, l_imF))
			l_stat_gn := (gamma_inst.gsl_sf_lngamma_complex_e (0.0, a_tau, l_lgr_num, l_lgth_num))
			l_stat_gd := (gamma_inst.gsl_sf_lngamma_complex_e (0.5 - a_mu, a_tau, l_lgr_den, l_lgth_den))
			l_angle := (l_lgth_num.item.val - l_lgth_den.item.val) + (atan2 (l_imF.item, l_reF.item))
			l_lnx := (log (a_x))
			l_lnxp1 := (log (a_x + 1.0))
			l_lnxm1 := (log (a_x - 1.0))
			l_lnpre_const := 0.5 * 0.69314718055994530942 - 0.5 * 1.14472988584940017414342735135
			l_lnpre_comm := (a_mu - 0.5) * l_lnx - (0.5 * a_mu) * (l_lnxp1 + l_lnxm1)
			l_tmp___7 := fabs ((a_mu - 0.5) * l_lnx)
			l_tmp___8 := fabs (0.5 * a_mu)
			l_tmp___9 := fabs (l_lnxp1)
			l_lnpre_err := (2.2204460492503131e-16 * (0.5 * 0.69314718055994530942 + 0.5 * 1.14472988584940017414342735135) + 2.2204460492503131e-16 * l_tmp___7) + (2.2204460492503131e-16 * l_tmp___8) * (l_tmp___9 + (fabs (l_lnxm1)))
			l_stat_cos := (trig_inst.gsl_sf_cos_e (l_angle + a_tau * ((log (a_x)) + 0.69314718055994530942), l_cos_result))
			if l_stat_cos /= 0 then
				l_tmp___16 := l_stat_cos
			else
				if l_stat_gd /= 0 then
					l_tmp___15 := l_stat_gd
				else
					if l_stat_gn /= 0 then
						l_tmp___14 := l_stat_gn
					else
						if l_stat_F /= 0 then
							l_tmp___13 := l_stat_F
						else
							l_tmp___13 := 0
						end
						l_tmp___14 := l_tmp___13
					end
					l_tmp___15 := l_tmp___14
				end
				l_tmp___16 := l_tmp___15
			end
			l_status := l_tmp___16
			if l_cos_result.item.val = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := l_status
			else
				l_lnFf_val := (0.5 * (log (l_reF.item * l_reF.item + l_imF.item * l_imF.item)) + l_lgr_num.item.val) - l_lgr_den.item.val
				l_lnFf_err := (l_lgr_num.item.err + l_lgr_den.item.err) + 2.2204460492503131e-16 * (fabs (l_lnFf_val))
				l_lnnoc_val := (l_lnpre_const + l_lnpre_comm) + l_lnFf_val
				l_lnnoc_err := (l_lnpre_err + l_lnFf_err) + 2.2204460492503131e-16 * (fabs (l_lnnoc_val))
				l_stat_e := (exp_inst.gsl_sf_exp_mult_err_e (l_lnnoc_val, l_lnnoc_err, l_cos_result.item.val, l_cos_result.item.err, a_result))
				if l_stat_e = 0 then
					a_ln_multiplier.item := 0.0
				else
					a_result.item.val := l_cos_result.item.val
					a_result.item.err := l_cos_result.item.err
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
					a_ln_multiplier.item := l_lnnoc_val
				end
				Result := l_status
			end
		end

	gsl_sf_conicalP_mhalf (a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_conicalP_mhalf_e (a_lambda, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_conicalP_mhalf_e(lambda, x, &result)"), ce_string ("legendre_con.c"), 1_363, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_conicalP_mhalf_e (a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_ac: REAL_64
			l_den: REAL_64
			l_tmp___2: REAL_64
			l_arg: REAL_64
			l_err_amp: REAL_64
			l_tmp___9: REAL_64
			l_sq_term: REAL_64
			l_tmp___13: REAL_64
			l_ln_term: REAL_64
			l_den___0: REAL_64
			l_arg_val: REAL_64
			l_arg_err: REAL_64
			l_sin_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_sin: INTEGER_32
			js: JUMP_STATE
		do
			create l_sin_result.make (<<1>>)

			if a_x <= -1.0 then
				from
				until
					js.loop_done
				loop
					a_result.item.val := (builtin_nanf (ce_string (""))).to_double
					a_result.item.err := (builtin_nanf (ce_string (""))).to_double
					from
					until
						js.loop_done
					loop
						error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_con.c"), 1_060, 1)
						Result := 1
						js.return
						if not js.return_called then
							js.break
						end
					end
					if not js.return_called then
						js.break
					end
				end
			elseif a_x < 1.0 then
				l_ac := (acos (a_x))
				l_tmp___2 := sqrt (1.0 - a_x)
				l_den := (sqrt (l_tmp___2 * (sqrt (1.0 + a_x))))
				l_arg := l_ac * a_lambda
				l_err_amp := 1.0 + 1.0 / (2.2204460492503131e-16 + (fabs (1.0 - (fabs (a_x)))))
				if (fabs (l_arg)) < 1.4901161193847656e-08 then
					a_result.item.val := (0.797884560802865355879892 / l_den) * l_ac
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
					a_result.item.err := a_result.item.err * l_err_amp
				else
					a_result.item.val := (0.797884560802865355879892 / (l_den * a_lambda)) * (sinh (l_arg))
					l_tmp___9 := fabs (l_arg)
					a_result.item.err := (2.2204460492503131e-16 * (l_tmp___9 + 1.0)) * (fabs (a_result.item.val))
					a_result.item.err := a_result.item.err * l_err_amp
					a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
				end
				Result := 0
				js.return
			elseif a_x = 1.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				Result := 0
				js.return
			else
				l_tmp___13 := sqrt (a_x - 1.0)
				l_sq_term := l_tmp___13 * (sqrt (a_x + 1.0))
				l_ln_term := (log (a_x + l_sq_term))
				l_den___0 := (sqrt (l_sq_term))
				l_arg_val := a_lambda * l_ln_term
				l_arg_err := (2.0 * 2.2204460492503131e-16) * (fabs (l_arg_val))
				if l_arg_val < 1.4901161193847656e-08 then
					a_result.item.val := (0.797884560802865355879892 / l_den___0) * l_ln_term
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val))
					Result := 0
					js.return
				else
					l_stat_sin := (trig_inst.gsl_sf_sin_err_e (l_arg_val, l_arg_err, l_sin_result))
					a_result.item.val := (0.797884560802865355879892 / (l_den___0 * a_lambda)) * l_sin_result.item.val
					a_result.item.err := (0.797884560802865355879892 / (fabs (l_den___0 * a_lambda))) * l_sin_result.item.err
					a_result.item.err := a_result.item.err + ((3.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
					Result := l_stat_sin
					js.return
				end
			end
			if not js.return_called then
				Result := 0
			end
		end

	gsl_sf_conicalP_sph_reg (a_l: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64): REAL_64
		local
			l_result: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_status: INTEGER_32
			js: JUMP_STATE
		do
			create l_result.make (<<1>>)

			l_status := (gsl_sf_conicalP_sph_reg_e (a_l, a_lambda, a_x, l_result))
			if l_status /= 0 then
				from
				until
					js.loop_done
				loop
					error_inst.gsl_error (ce_string ("gsl_sf_conicalP_sph_reg_e(l, lambda, x, &result)"), ce_string ("legendre_con.c"), 1_368, l_status)
					Result := (l_result.item.val)
					js.return
					if not js.return_called then
						js.break
					end
				end
			end
			if not js.return_called then
				Result := (l_result.item.val)
			end
		end

	gsl_sf_conicalP_sph_reg_e (a_l: INTEGER_32; a_lambda: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]): INTEGER_32
		local
			l_c___1: REAL_64
			l_r_Pellm1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_r_Pell: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_0: INTEGER_32
			l_stat_1: INTEGER_32
			l_stat_P: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_Pellm1: REAL_64
			l_Pell: REAL_64
			l_Pellp1: REAL_64
			l_ell: INTEGER_32
			l_d: REAL_64
			l_xi: REAL_64
			l_tmp___10: REAL_64
			l_rat: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_Phf: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_CF1: INTEGER_32
			l_stat_Phf: INTEGER_32
			l_Pellp1___0: REAL_64
			l_Pell___0: REAL_64
			l_Pellm1___0: REAL_64
			l_ell___0: INTEGER_32
			l_d___0: REAL_64
			l_tmp___15: REAL_64
			l_tmp___18: INTEGER_32
			l_tmp___19: INTEGER_32
			l_xi___0: REAL_64
			l_rat___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_CF1___0: INTEGER_32
			l_stat_P___0: INTEGER_32
			l_Pellp1___1: REAL_64
			l_Pell___1: REAL_64
			l_Pellm1___1: REAL_64
			l_ell___1: INTEGER_32
			l_d___1: REAL_64
			l_Phf___0: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___23: REAL_64
			l_Pmhf: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_tmp___27: REAL_64
			l_tmp___30: REAL_64
			l_tmp___32: INTEGER_32
			l_tmp___33: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			create l_r_Pellm1.make (<<1>>)
			create l_r_Pell.make (<<1>>)
			create l_rat.make (<<1>>)
			create l_Phf.make (<<1>>)
			create l_rat___0.make (<<1>>)
			create l_Phf___0.make (<<1>>)
			create l_Pmhf.make (<<1>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					if not (a_x <= -1.0) then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						l_pos := -1 + 4 -- goto _L
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 3 then -- else:
						if not (a_l < -1) then
							l_pos := -1 + 6 -- skip if block
						end
				when 4 then -- if: | _L:
						from
						until
							js.loop_done
						loop
							a_result.item.val := (builtin_nanf (ce_string (""))).to_double
							a_result.item.err := (builtin_nanf (ce_string (""))).to_double
							from
							until
								js.loop_done
							loop
								error_inst.gsl_error (ce_string ("domain error"), ce_string ("legendre_con.c"), 1_117, 1)
								Result := 1
								js.return
								if not js.return_called then
									js.break
								end
							end
							if not js.return_called then
								js.break
							end
						end
				when 5 then -- if block done, skip else block:
						l_pos := -1 + 7
				when 6 then -- else:
						if a_l = -1 then
							Result := (gsl_sf_conicalP_half_e (a_lambda, a_x, a_result))
							js.return
						elseif a_l = 0 then
							Result := (gsl_sf_conicalP_mhalf_e (a_lambda, a_x, a_result))
							js.return
						elseif a_x = 1.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						elseif a_x < 0.0 then
							l_c___1 := 1.0 / (sqrt (1.0 - a_x * a_x))
							l_stat_0 := (gsl_sf_conicalP_half_e (a_lambda, a_x, l_r_Pellm1))
							l_stat_1 := (gsl_sf_conicalP_mhalf_e (a_lambda, a_x, l_r_Pell))
							if l_stat_0 /= 0 then
								l_tmp___7 := l_stat_0
							else
								if l_stat_1 /= 0 then
									l_tmp___6 := l_stat_1
								else
									l_tmp___6 := 0
								end
								l_tmp___7 := l_tmp___6
							end
							l_stat_P := l_tmp___7
							l_Pellm1 := l_r_Pellm1.item.val
							l_Pell := l_r_Pell.item.val
							l_ell := 0
							from
							until
								not (l_ell < a_l)
							loop
								l_d := (l_ell.to_double + 1.0) * (l_ell.to_double + 1.0) + a_lambda * a_lambda
								l_Pellp1 := (l_Pellm1 - (((2.0 * l_ell.to_double + 1.0) * l_c___1) * a_x) * l_Pell) / l_d
								l_Pellm1 := l_Pell
								l_Pell := l_Pellp1
								l_ell := l_ell + 1
							end
							a_result.item.val := l_Pell
							a_result.item.err := ((0.5 * a_l.to_double + 1.0) * 2.2204460492503131e-16) * (fabs (l_Pell))
							a_result.item.err := a_result.item.err + ((2.2204460492503131e-16 * a_l.to_double) * (fabs (a_result.item.val)))
							Result := l_stat_P
							js.return
						elseif a_x < 1.0 then
							l_tmp___10 := sqrt (1.0 - a_x)
							l_xi := a_x / (l_tmp___10 * (sqrt (1.0 + a_x)))
							l_stat_CF1 := (conicalP_negmu_xlt1_CF1 (0.5, a_l, a_lambda, a_x, l_rat))
							l_stat_Phf := (gsl_sf_conicalP_half_e (a_lambda, a_x, l_Phf))
							l_Pellp1___0 := l_rat.item.val * 1.4916681462400413e-154
							l_Pell___0 := 1.4916681462400413e-154
							l_ell___0 := a_l
							from
							until
								not (l_ell___0 >= 0)
							loop
								l_d___0 := (l_ell___0.to_double + 1.0) * (l_ell___0.to_double + 1.0) + a_lambda * a_lambda
								l_Pellm1___0 := ((2.0 * l_ell___0.to_double + 1.0) * l_xi) * l_Pell___0 + l_d___0 * l_Pellp1___0
								l_Pellp1___0 := l_Pell___0
								l_Pell___0 := l_Pellm1___0
								l_ell___0 := l_ell___0 - 1
							end
							a_result.item.val := (1.4916681462400413e-154 * l_Phf.item.val) / l_Pell___0
							a_result.item.err := (1.4916681462400413e-154 * l_Phf.item.err) / (fabs (l_Pell___0))
							l_tmp___15 := fabs (l_rat.item.err / l_rat.item.val)
							a_result.item.err := a_result.item.err + ((l_tmp___15 * (a_l.to_double + 1.0)) * (fabs (a_result.item.val)))
							a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							if l_stat_Phf /= 0 then
								l_tmp___19 := l_stat_Phf
							else
								if l_stat_CF1 /= 0 then
									l_tmp___18 := l_stat_CF1
								else
									l_tmp___18 := 0
								end
								l_tmp___19 := l_tmp___18
							end
							Result := l_tmp___19
							js.return
						elseif a_x = 1.0 then
							a_result.item.val := 0.0
							a_result.item.err := 0.0
							Result := 0
							js.return
						else
							l_xi___0 := a_x / (sqrt ((a_x - 1.0) * (a_x + 1.0)))
							l_stat_CF1___0 := (conicalP_negmu_xgt1_CF1 (0.5, a_l, a_lambda, a_x, l_rat___0))
							l_Pellp1___1 := l_rat___0.item.val * 1.4916681462400413e-154
							l_Pell___1 := 1.4916681462400413e-154
							l_ell___1 := a_l
							from
							until
								not (l_ell___1 >= 0)
							loop
								l_d___1 := (l_ell___1.to_double + 1.0) * (l_ell___1.to_double + 1.0) + a_lambda * a_lambda
								l_Pellm1___1 := ((2.0 * l_ell___1.to_double + 1.0) * l_xi___0) * l_Pell___1 - l_d___1 * l_Pellp1___1
								l_Pellp1___1 := l_Pell___1
								l_Pell___1 := l_Pellm1___1
								l_ell___1 := l_ell___1 - 1
							end
							l_tmp___30 := fabs (l_Pell___1)
							if l_tmp___30 > (fabs (l_Pellp1___1)) then
								l_stat_P___0 := gsl_sf_conicalP_half_e (a_lambda, a_x, l_Phf___0)
								a_result.item.val := (1.4916681462400413e-154 * l_Phf___0.item.val) / l_Pell___1
								a_result.item.err := ((2.0 * 1.4916681462400413e-154) * l_Phf___0.item.err) / (fabs (l_Pell___1))
								l_tmp___23 := fabs (l_rat___0.item.err / l_rat___0.item.val)
								a_result.item.err := a_result.item.err + (((2.0 * l_tmp___23) * (a_l.to_double + 1.0)) * (fabs (a_result.item.val)))
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							else
								l_stat_P___0 := gsl_sf_conicalP_mhalf_e (a_lambda, a_x, l_Pmhf)
								a_result.item.val := (1.4916681462400413e-154 * l_Pmhf.item.val) / l_Pellp1___1
								a_result.item.err := ((2.0 * 1.4916681462400413e-154) * l_Pmhf.item.err) / (fabs (l_Pellp1___1))
								l_tmp___27 := fabs (l_rat___0.item.err / l_rat___0.item.val)
								a_result.item.err := a_result.item.err + (((2.0 * l_tmp___27) * (a_l.to_double + 1.0)) * (fabs (a_result.item.val)))
								a_result.item.err := a_result.item.err + ((2.0 * 2.2204460492503131e-16) * (fabs (a_result.item.val)))
							end
							if l_stat_P___0 /= 0 then
								l_tmp___33 := l_stat_P___0
							else
								if l_stat_CF1___0 /= 0 then
									l_tmp___32 := l_stat_CF1___0
								else
									l_tmp___32 := 0
								end
								l_tmp___33 := l_tmp___32
							end
							Result := l_tmp___33
							js.return
						end
				when 7 then -- if done
						if not js.return_called then
							Result := 0
						end
				when 8 then
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

	gsl_sf_conicalP_xgt1_neg_mu_largetau_e (a_mu: REAL_64; a_tau: REAL_64; a_x: REAL_64; a_acosh_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_ln_multiplier: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_xi: REAL_64
			l_ln_xi_pre: REAL_64
			l_ln_pre: REAL_64
			l_sumA: REAL_64
			l_sumB: REAL_64
			l_sum: REAL_64
			l_arg: REAL_64
			l_J_mup1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_J_mu: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_J_mum1: REAL_64
			l_lnshxi: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_stat_e: INTEGER_32
		do
			create l_J_mup1.make (<<1>>)
			create l_J_mu.make (<<1>>)
			create l_lnshxi.make (<<1>>)

			l_xi := a_acosh_x
			if l_xi < 1.2207031250000000e-04 then
				l_ln_xi_pre := (-l_xi * l_xi) / 6.0
			else
				trig_inst.gsl_sf_lnsinh_e (l_xi, l_lnshxi).do_nothing
				l_ln_xi_pre := (log (l_xi)) - l_lnshxi.item.val
			end
			l_ln_pre := 0.5 * l_ln_xi_pre - a_mu * (log (a_tau))
			l_arg := a_tau * l_xi
			bessel_jnu_inst.gsl_sf_bessel_Jnu_e (a_mu + 1.0, l_arg, l_J_mup1).do_nothing
			bessel_jnu_inst.gsl_sf_bessel_Jnu_e (a_mu, l_arg, l_J_mu).do_nothing
			l_J_mum1 := -l_J_mup1.item.val + ((2.0 * a_mu) / l_arg) * l_J_mu.item.val
			l_sumA := 1.0 - (olver_A1_xi (-a_mu, l_xi, a_x)) / (a_tau * a_tau)
			l_sumB := olver_B0_xi (-a_mu, l_xi)
			l_sum := l_J_mu.item.val * l_sumA - ((l_xi / a_tau) * l_J_mum1) * l_sumB
			if l_sum = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				a_ln_multiplier.item := 0.0
				Result := 0
			else
				l_stat_e := (exp_inst.gsl_sf_exp_mult_e (l_ln_pre, l_sum, a_result))
				if l_stat_e /= 0 then
					a_result.item.val := l_sum
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_sum))
					a_ln_multiplier.item := l_ln_pre
				else
					a_ln_multiplier.item := 0.0
				end
				Result := 0
			end
		end

	gsl_sf_conicalP_xlt1_large_neg_mu_e (a_mu: REAL_64; a_tau: REAL_64; a_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_ln_multiplier: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_beta: REAL_64
			l_beta2: REAL_64
			l_S: REAL_64
			l_p: REAL_64
			l_lg_mup1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_lg_stat: INTEGER_32
			l_ln_pre_1: REAL_64
			l_tmp___2: REAL_64
			l_ln_pre_2: REAL_64
			l_ln_pre_3: REAL_64
			l_ln_pre: REAL_64
			l_sum: REAL_64
			l_tmp___6: REAL_64
			l_stat_e: INTEGER_32
		do
			create l_lg_mup1.make (<<1>>)

			l_beta := a_tau / a_mu
			l_beta2 := l_beta * l_beta
			l_S := l_beta * (acos ((1.0 - l_beta2) / (1.0 + l_beta2)))
			l_p := a_x / (sqrt (l_beta2 * (1.0 - a_x * a_x) + 1.0))
			l_lg_stat := (gamma_inst.gsl_sf_lngamma_e (a_mu + 1.0, l_lg_mup1))
			l_tmp___2 := log (1.0 + l_beta2)
			l_ln_pre_1 := (0.5 * a_mu) * ((l_S - l_tmp___2) + (log ((1.0 - l_p) / (1.0 + l_p)))) - l_lg_mup1.item.val
			l_ln_pre_2 := -0.25 * (log (1.0 + l_beta2 * (1.0 - a_x)))
			l_ln_pre_3 := -a_tau * (atan (l_p * l_beta))
			l_ln_pre := (l_ln_pre_1 + l_ln_pre_2) + l_ln_pre_3
			l_tmp___6 := olver_U1 (l_beta2, l_p)
			l_sum := (1.0 - l_tmp___6 / a_mu) + (olver_U2 (l_beta2, l_p)) / (a_mu * a_mu)
			if l_sum = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				a_ln_multiplier.item := 0.0
				Result := 0
			else
				l_stat_e := (exp_inst.gsl_sf_exp_mult_e (l_ln_pre, l_sum, a_result))
				if l_stat_e /= 0 then
					a_result.item.val := l_sum
					a_result.item.err := (2.0 * 2.2204460492503131e-16) * (fabs (l_sum))
					a_ln_multiplier.item := l_ln_pre
				else
					a_ln_multiplier.item := 0.0
				end
				Result := l_lg_stat
			end
		end

	gsl_sf_conicalP_xlt1_neg_mu_largetau_e (a_mu: REAL_64; a_tau: REAL_64; a_x: REAL_64; a_acos_x: REAL_64; a_result: CE_POINTER [PD_GSL_SF_RESULT_STRUCT]; a_ln_multiplier: CE_POINTER [REAL_64]): INTEGER_32
		local
			l_theta: REAL_64
			l_ln_th_pre: REAL_64
			l_ln_pre: REAL_64
			l_sumA: REAL_64
			l_sumB: REAL_64
			l_sum: REAL_64
			l_sumerr: REAL_64
			l_arg: REAL_64
			l_I_mup1: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_I_mu: CE_ARRAY [PD_GSL_SF_RESULT_STRUCT]
			l_I_mum1: REAL_64
			l_stat_e: INTEGER_32
		do
			create l_I_mup1.make (<<1>>)
			create l_I_mu.make (<<1>>)

			l_theta := a_acos_x
			if l_theta < 1.2207031250000000e-04 then
				l_ln_th_pre := (l_theta * l_theta) / 6.0
			else
				l_ln_th_pre := log (l_theta / (sin (l_theta)))
			end
			l_ln_pre := 0.5 * l_ln_th_pre - a_mu * (log (a_tau))
			l_arg := a_tau * l_theta
			bessel_inu_inst.gsl_sf_bessel_Inu_e (a_mu + 1.0, l_arg, l_I_mup1).do_nothing
			bessel_inu_inst.gsl_sf_bessel_Inu_e (a_mu, l_arg, l_I_mu).do_nothing
			l_I_mum1 := l_I_mup1.item.val + ((2.0 * a_mu) / l_arg) * l_I_mu.item.val
			l_sumA := 1.0 - (olver_A1_th (-a_mu, l_theta, a_x)) / (a_tau * a_tau)
			l_sumB := olver_B0_th (-a_mu, l_theta)
			l_sum := l_I_mu.item.val * l_sumA - ((l_theta / a_tau) * l_I_mum1) * l_sumB
			l_sumerr := fabs (l_I_mu.item.err * l_sumA)
			l_sumerr := l_sumerr + (fabs (((l_I_mup1.item.err * l_theta) / a_tau) * l_sumB))
			l_sumerr := l_sumerr + (fabs ((((((l_I_mu.item.err * l_theta) / a_tau) * l_sumB) * 2.0) * a_mu) / l_arg))
			if l_sum = 0.0 then
				a_result.item.val := 0.0
				a_result.item.err := 0.0
				a_ln_multiplier.item := 0.0
				Result := 0
			else
				l_stat_e := (exp_inst.gsl_sf_exp_mult_e (l_ln_pre, l_sum, a_result))
				if l_stat_e /= 0 then
					a_result.item.val := l_sum
					a_result.item.err := l_sumerr
					a_result.item.err := a_result.item.err + (2.2204460492503131e-16 * (fabs (l_sum)))
					a_ln_multiplier.item := l_ln_pre
				else
					a_ln_multiplier.item := 0.0
				end
				Result := 0
			end
		end

	olver_A1_th (a_mu: REAL_64; a_theta: REAL_64; a_x: REAL_64): REAL_64
		local
			l_B: REAL_64
			l_psi: REAL_64
			l_y: REAL_64
			l_s: REAL_64
		do
			l_B := (olver_B0_th (a_mu, a_theta))
			if (fabs (a_x - 1.0)) < 1.2207031250000000e-04 then
				l_y := 1.0 - a_x
				l_s := -1.0 / 3.0 + l_y * (2.0 / 15.0 - l_y * (61.0 / 945.0 - (452.0 / 14175.0) * l_y))
				l_psi := (((4.0 * a_mu) * a_mu - 1.0) / 16.0) * l_s
			else
				l_psi := (((4.0 * a_mu) * a_mu - 1.0) / 16.0) * (1.0 / (a_x * a_x - 1.0) + 1.0 / (a_theta * a_theta))
			end
			Result := ((((((-0.5 * a_theta) * a_theta) * l_B) * l_B + (a_mu + 0.5) * l_B) - l_psi) + (a_mu / 6.0) * (0.25 - a_mu * a_mu))
		end

	olver_A1_xi (a_mu: REAL_64; a_xi: REAL_64; a_x: REAL_64): REAL_64
		local
			l_B: REAL_64
			l_psi: REAL_64
			l_y: REAL_64
			l_s: REAL_64
		do
			l_B := (olver_B0_xi (a_mu, a_xi))
			if (fabs (a_x - 1.0)) < 1.2207031250000000e-04 then
				l_y := a_x - 1.0
				l_s := -1.0 / 3.0 + l_y * (2.0 / 15.0 - l_y * (61.0 / 945.0 - (452.0 / 14175.0) * l_y))
				l_psi := (((4.0 * a_mu) * a_mu - 1.0) / 16.0) * l_s
			else
				l_psi := (((4.0 * a_mu) * a_mu - 1.0) / 16.0) * (1.0 / (a_x * a_x - 1.0) - 1.0 / (a_xi * a_xi))
			end
			Result := ((((((0.5 * a_xi) * a_xi) * l_B) * l_B + (a_mu + 0.5) * l_B) - l_psi) + (a_mu / 6.0) * (0.25 - a_mu * a_mu))
		end

	olver_B0_th (a_mu: REAL_64; a_theta: REAL_64): REAL_64
		do
			Result := ((-(1.0 - (4.0 * a_mu) * a_mu) / (8.0 * a_theta)) * (1.0 / (tan (a_theta)) - 1.0 / a_theta))
		end

	olver_B0_xi (a_mu: REAL_64; a_xi: REAL_64): REAL_64
		do
			Result := (((1.0 - (4.0 * a_mu) * a_mu) / (8.0 * a_xi)) * (1.0 / (tanh (a_xi)) - 1.0 / a_xi))
		end

	olver_U1 (a_beta2: REAL_64; a_p: REAL_64): REAL_64
		do
			Result := (((a_p - 1.0) / (24.0 * (1.0 + a_beta2))) * (3.0 + a_beta2 * (2.0 + (5.0 * a_p) * (1.0 + a_p))))
		end

	olver_U2 (a_beta2: REAL_64; a_p: REAL_64): REAL_64
		local
			l_beta4: REAL_64
			l_p2: REAL_64
			l_poly1: REAL_64
			l_poly2: REAL_64
			l_poly3: REAL_64
		do
			l_beta4 := a_beta2 * a_beta2
			l_p2 := a_p * a_p
			l_poly1 := (4.0 * l_beta4 + 84.0 * a_beta2) - 63.0
			l_poly2 := (16.0 * l_beta4 + 90.0 * a_beta2) - 81.0
			l_poly3 := (a_beta2 * l_p2) * (((97.0 * a_beta2 - 432.0) + (77.0 * a_p) * (a_beta2 - 6.0)) - ((385.0 * a_beta2) * l_p2) * (1.0 + a_p))
			Result := (((1.0 - a_p) / (1152.0 * (1.0 + a_beta2))) * ((l_poly1 + l_poly2) + l_poly3))
		end

end
