class
	P_PTSORT

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	sort_results (a_workspace: CE_POINTER [PD_GSL_INTEGRATION_WORKSPACE])
		local
			l_i: NATURAL_32
			l_elist: CE_POINTER [REAL_64]
			l_order: CE_POINTER [NATURAL_32]
			l_nint: NATURAL_32
			l_i1: NATURAL_32
			l_e1: REAL_64
			l_i_max: NATURAL_32
			l_j: NATURAL_32
			l_i2: NATURAL_32
			l_e2: REAL_64
			js: JUMP_STATE
		do
			create l_elist.make
			create l_order.make

			l_elist := a_workspace.item.elist
			l_order := a_workspace.item.order
			l_nint := a_workspace.item.size
			l_i := (0).to_natural_32
			from
			until
				not (not js.loop_done and then (l_i < l_nint))
			loop
				l_i1 := l_order[l_i.to_integer_32]
				l_e1 := l_elist[l_i1.to_integer_32]
				l_i_max := l_i1
				l_j := l_i + {NATURAL_32} 1
				from
				until
					not (l_j < l_nint)
				loop
					l_i2 := l_order[l_j.to_integer_32]
					l_e2 := l_elist[l_i2.to_integer_32]
					if l_e2 >= l_e1 then
						l_i_max := l_i2
						l_e1 := l_e2
					end
					l_j := l_j + 1
				end
				if l_i_max /= l_i1 then
					l_order[l_i.to_integer_32] := l_order[l_i_max.to_integer_32]
					l_order[l_i_max.to_integer_32] := l_i1
				end
				l_i := l_i + 1
			end
			a_workspace.item.i := l_order[0]
		end

end
