class
	P_STRMV

inherit
	LIBGSL_DATA
	S_GCC_BUILTIN
	S_LIBIO
	S_STDIO
	S_STDLIB
	S_MATH
	S_STRING
	S_ASSERT

feature {ANY} -- routines

	cblas_strmv (a_order: NATURAL_32; a_Uplo: NATURAL_32; a_TransA: NATURAL_32; a_Diag: NATURAL_32; a_N: INTEGER_32; a_A___0: CE_POINTER [REAL_32]; a_lda: INTEGER_32; a_X: CE_POINTER [REAL_32]; a_incX: INTEGER_32)
		local
			l_i: INTEGER_32
			l_j: INTEGER_32
			l_nonunit: INTEGER_32
			l_Trans: INTEGER_32
			l_tmp: NATURAL_32
			l_ix: INTEGER_32
			l_tmp___0: INTEGER_32
			l_temp: REAL_32
			l_j_min: INTEGER_32
			l_j_max: INTEGER_32
			l_jx: INTEGER_32
			l_tmp___1: INTEGER_32
			l_ix___0: INTEGER_32
			l_tmp___2: INTEGER_32
			l_temp___0: REAL_32
			l_j_min___0: INTEGER_32
			l_j_max___0: INTEGER_32
			l_jx___0: INTEGER_32
			l_tmp___3: INTEGER_32
			l_tmp___4: INTEGER_32
			l_ix___1: INTEGER_32
			l_tmp___5: INTEGER_32
			l_temp___1: REAL_32
			l_j_min___1: INTEGER_32
			l_j_max___1: INTEGER_32
			l_jx___1: INTEGER_32
			l_tmp___6: INTEGER_32
			l_tmp___7: INTEGER_32
			l_ix___2: INTEGER_32
			l_tmp___8: INTEGER_32
			l_temp___2: REAL_32
			l_j_min___2: INTEGER_32
			l_j_max___2: INTEGER_32
			l_jx___2: INTEGER_32
			l_tmp___9: INTEGER_32
			js: JUMP_STATE
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_nonunit := (a_Diag = {NATURAL_32} 131).to_integer
					if a_TransA /= {NATURAL_32} 113 then
						l_tmp := a_TransA
					else
						l_tmp := {NATURAL_32} 112
					end
					l_Trans := l_tmp.to_integer_32
					if a_order /= {NATURAL_32} 101 then
						l_pos := -1 + 3 -- skip if block
					end
				when 1 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 6 -- goto _L___12
							else
								l_pos := -1 + 3 -- goto _L___16
							end
						else
							l_pos := -1 + 3 -- goto _L___16
						end
				when 2 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 3 then -- else: | _L___16:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 12 -- skip if block
						end
				when 4 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 10 -- skip if block
						end
				when 5 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 8 -- skip if block
						end
				when 6 then -- if: | _L___12:
						if a_incX > 0 then
							l_tmp___0 := 0
						else
							l_tmp___0 := (a_N - 1) * -a_incX
						end
						l_ix := l_tmp___0
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < a_N))
						loop
							l_temp := (0.0).truncated_to_real
							l_j_min := l_i + 1
							l_j_max := a_N
							if a_incX > 0 then
								l_tmp___1 := 0
							else
								l_tmp___1 := (a_N - 1) * -a_incX
							end
							l_jx := l_tmp___1 + l_j_min * a_incX
							l_j := l_j_min
							from
							until
								not (l_j < l_j_max)
							loop
								l_temp := l_temp + (a_X[l_jx] * a_A___0[(a_lda * l_i + l_j)])
								l_jx := l_jx + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								a_X[l_ix] := l_temp + a_X[l_ix] * a_A___0[(a_lda * l_i + l_i)]
							else
								a_X[l_ix] := a_X[l_ix] + l_temp
							end
							l_ix := l_ix + a_incX
							l_i := l_i + 1
						end
				when 7 then -- if block done, skip else block:
						l_pos := -1 + 9
				when 8 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 9 then -- if done | if block done, skip else block:
						l_pos := -1 + 11
				when 10 then -- else:
						l_pos := -1 + 12 -- goto _L___14
				when 11 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 12 then -- else: | _L___14:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if l_Trans = 111 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 18 -- goto _L___7
							else
								l_pos := -1 + 15 -- goto _L___11
							end
						else
							l_pos := -1 + 15 -- goto _L___11
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 15 then -- else: | _L___11:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if l_Trans /= 112 then
							l_pos := -1 + 22 -- skip if block
						end
				when 17 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 20 -- skip if block
						end
				when 18 then -- if: | _L___7:
						if a_incX > 0 then
							l_tmp___2 := 0
						else
							l_tmp___2 := (a_N - 1) * -a_incX
						end
						l_ix___0 := l_tmp___2 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							js.loop_done
						loop
							if l_i > 0 then
								l_tmp___4 := l_i
								l_i := l_i - 1
								if not l_tmp___4.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_temp___0 := (0.0).truncated_to_real
								l_j_min___0 := 0
								l_j_max___0 := l_i
								if a_incX > 0 then
									l_tmp___3 := 0
								else
									l_tmp___3 := (a_N - 1) * -a_incX
								end
								l_jx___0 := l_tmp___3 + l_j_min___0 * a_incX
								l_j := l_j_min___0
								from
								until
									not (l_j < l_j_max___0)
								loop
									l_temp___0 := l_temp___0 + (a_X[l_jx___0] * a_A___0[(a_lda * l_i + l_j)])
									l_jx___0 := l_jx___0 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									a_X[l_ix___0] := l_temp___0 + a_X[l_ix___0] * a_A___0[(a_lda * l_i + l_i)]
								else
									a_X[l_ix___0] := a_X[l_ix___0] + l_temp___0
								end
								l_ix___0 := l_ix___0 - a_incX
							end
						end
				when 19 then -- if block done, skip else block:
						l_pos := -1 + 21
				when 20 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 21 then -- if done | if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_pos := -1 + 24 -- goto _L___9
				when 23 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 24 then -- else: | _L___9:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 27 -- skip if block
						end
				when 25 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 121 then
								l_pos := -1 + 30 -- goto _L___2
							else
								l_pos := -1 + 27 -- goto _L___6
							end
						else
							l_pos := -1 + 27 -- goto _L___6
						end
				when 26 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 27 then -- else: | _L___6:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 36 -- skip if block
						end
				when 28 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 34 -- skip if block
						end
				when 29 then -- if:
						if a_Uplo /= {NATURAL_32} 122 then
							l_pos := -1 + 32 -- skip if block
						end
				when 30 then -- if: | _L___2:
						if a_incX > 0 then
							l_tmp___5 := 0
						else
							l_tmp___5 := (a_N - 1) * -a_incX
						end
						l_ix___1 := l_tmp___5 + (a_N - 1) * a_incX
						l_i := a_N
						from
						until
							js.loop_done
						loop
							if l_i > 0 then
								l_tmp___7 := l_i
								l_i := l_i - 1
								if not l_tmp___7.to_boolean then
									js.break
								end
							else
								js.break
							end
							if not js.loop_jumped then
								l_temp___1 := (0.0).truncated_to_real
								l_j_min___1 := 0
								l_j_max___1 := l_i
								if a_incX > 0 then
									l_tmp___6 := 0
								else
									l_tmp___6 := (a_N - 1) * -a_incX
								end
								l_jx___1 := l_tmp___6 + l_j_min___1 * a_incX
								l_j := l_j_min___1
								from
								until
									not (l_j < l_j_max___1)
								loop
									l_temp___1 := l_temp___1 + (a_X[l_jx___1] * a_A___0[(a_lda * l_j + l_i)])
									l_jx___1 := l_jx___1 + a_incX
									l_j := l_j + 1
								end
								if l_nonunit.to_boolean then
									a_X[l_ix___1] := l_temp___1 + a_X[l_ix___1] * a_A___0[(a_lda * l_i + l_i)]
								else
									a_X[l_ix___1] := a_X[l_ix___1] + l_temp___1
								end
								l_ix___1 := l_ix___1 - a_incX
							end
						end
				when 31 then -- if block done, skip else block:
						l_pos := -1 + 33
				when 32 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 33 then -- if done | if block done, skip else block:
						l_pos := -1 + 35
				when 34 then -- else:
						l_pos := -1 + 36 -- goto _L___4
				when 35 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 36 then -- else: | _L___4:
						if a_order /= {NATURAL_32} 101 then
							l_pos := -1 + 39 -- skip if block
						end
				when 37 then -- if:
						if l_Trans = 112 then
							if a_Uplo = {NATURAL_32} 122 then
								l_pos := -1 + 42 -- goto _L
							else
								l_pos := -1 + 39 -- goto _L___1
							end
						else
							l_pos := -1 + 39 -- goto _L___1
						end
				when 38 then -- if block done, skip else block:
						l_pos := -1 + 49
				when 39 then -- else: | _L___1:
						if a_order /= {NATURAL_32} 102 then
							l_pos := -1 + 48 -- skip if block
						end
				when 40 then -- if:
						if l_Trans /= 111 then
							l_pos := -1 + 46 -- skip if block
						end
				when 41 then -- if:
						if a_Uplo /= {NATURAL_32} 121 then
							l_pos := -1 + 44 -- skip if block
						end
				when 42 then -- if: | _L:
						if a_incX > 0 then
							l_tmp___8 := 0
						else
							l_tmp___8 := (a_N - 1) * -a_incX
						end
						l_ix___2 := l_tmp___8
						l_i := 0
						from
						until
							not (not js.loop_done and then (l_i < a_N))
						loop
							l_temp___2 := (0.0).truncated_to_real
							l_j_min___2 := l_i + 1
							l_j_max___2 := a_N
							if a_incX > 0 then
								l_tmp___9 := 0
							else
								l_tmp___9 := (a_N - 1) * -a_incX
							end
							l_jx___2 := l_tmp___9 + (l_i + 1) * a_incX
							l_j := l_j_min___2
							from
							until
								not (l_j < l_j_max___2)
							loop
								l_temp___2 := l_temp___2 + (a_X[l_jx___2] * a_A___0[(a_lda * l_j + l_i)])
								l_jx___2 := l_jx___2 + a_incX
								l_j := l_j + 1
							end
							if l_nonunit.to_boolean then
								a_X[l_ix___2] := l_temp___2 + a_X[l_ix___2] * a_A___0[(a_lda * l_i + l_i)]
							else
								a_X[l_ix___2] := a_X[l_ix___2] + l_temp___2
							end
							l_ix___2 := l_ix___2 + a_incX
							l_i := l_i + 1
						end
				when 43 then -- if block done, skip else block:
						l_pos := -1 + 45
				when 44 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmv_r.h"), ce_string ("unrecognized operation")])
				when 45 then -- if done | if block done, skip else block:
						l_pos := -1 + 47
				when 46 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmv_r.h"), ce_string ("unrecognized operation")])
				when 47 then -- if done | if block done, skip else block:
						l_pos := -1 + 49
				when 48 then -- else:
						xerbla_inst.cblas_xerbla ([0, ce_string ("source_trmv_r.h"), ce_string ("unrecognized operation")])
				when 49 then -- if done | if done | if done | if done | if done | if done | if done
						l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
			end

end
